
indexing
	
	description: "Object that can generate colors for an %
		%element of a reticle view according to its account type"
	author: "David Hollenberg"
	date: "October 1, 2006"

class ACCOUNT_TYPE_COLOR_GENERATOR
inherit
	RETICLE_VIEW_ELEMENT_COLOR_GENERATOR

create
	make

feature  -- Access

	border_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Foreground color for border (usually a
			-- rectangle) of `an_element'
		do
			Result := standard_color (an_element)
		end
	
	label_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Foreground color for label
		do
			Result := standard_color (an_element)
		end
	
feature {NONE} -- Implementation

	standard_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Standard color for `an_element', based on
			-- locked in X and locked in Y status
		local
			is_com, is_mep, is_other: BOOLEAN
		do
			is_com := an_element.is_commercial_project
			is_mep := an_element.is_mep_project
			is_other := an_element.is_other_project
			if not an_element.is_selectable then
				Result := palette.unselectable_color
			elseif is_com then
				Result := palette.commercial_project_color
			elseif is_mep then
				Result := palette.mep_project_color
			elseif is_other then
				Result := palette.other_project_color
			else
				Result := palette.non_project_color
			end
		end
	
end
