
indexing

	date: "Tue Apr 24 10:30:09 2007"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application NFE, database user DHOLLEN"
	database_tables: 
		"ACCT_SUB_TYPES (MOSIS.ACCT_SUB_TYPES)"
			-- Included columns
			-- 	ACCT_SUB_TYPE
			-- 	ACCT_TYPE
			-- 	DESCR
			-- 	DOCUMENT_ACCESS_GRACE_DAYS
			-- 	INDA_REQUIRED
			-- 	PAYMENT_GRACE_DAYS
			-- 	WATERMARK_DOCUMENTS
			-- Excluded columns
			-- 	(none)

class ACCT_SUB_TYPES_RAW

inherit

	DB_IDENTIFIED_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_acct_type: STRING; the_acct_sub_type: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_acct_type_exists: the_acct_type /= Void
			the_acct_sub_type_exists: the_acct_sub_type /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			acct_type := the_acct_type
			acct_sub_type := the_acct_sub_type
			is_null_acct_type := False
			is_null_acct_sub_type := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 7

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  acct_sub_type, acct_type, descr, document_access_grace_days,%N  inda_required, payment_grace_days, watermark_documents"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "acct_sub_types asubt"

	join_condition: STRING = ""

	table_name: STRING = "acct_sub_types"

	key_where_clause: STRING = "acct_type = :1 and acct_sub_type = :2"

feature -- Values

	acct_sub_type: STRING
			-- DB: VARCHAR2(20) not null

	acct_type: STRING
			-- DB: VARCHAR2(20) not null

	descr: STRING
			-- DB: VARCHAR2(80)

	document_access_grace_days: INTEGER
			-- DB: NUMBER(4,0) not null

	inda_required: BOOLEAN
			-- DB: CHAR(1) not null

	payment_grace_days: INTEGER
			-- DB: NUMBER(4,0) not null

	watermark_documents: BOOLEAN
			-- DB: CHAR(1) not null

feature -- Nullness for null allowed columns

	is_null_descr: BOOLEAN

feature -- Nullness for non-null columns

	is_null_acct_sub_type: BOOLEAN
	is_null_acct_type: BOOLEAN
	is_null_document_access_grace_days: BOOLEAN
	is_null_inda_required: BOOLEAN
	is_null_payment_grace_days: BOOLEAN
	is_null_watermark_documents: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (acct_sub_type, r.acct_sub_type)
				and equal (acct_type, r.acct_type)
			Result := Result
				and is_null_acct_sub_type = r.is_null_acct_sub_type
				and is_null_acct_type = r.is_null_acct_type
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and document_access_grace_days = r.document_access_grace_days
				and inda_required = r.inda_required
				and payment_grace_days = r.payment_grace_days
				and watermark_documents = r.watermark_documents
			Result := Result
				and equal (descr, r.descr)
			Result := Result
				and is_null_descr = r.is_null_descr
				and is_null_document_access_grace_days = r.is_null_document_access_grace_days
				and is_null_inda_required = r.is_null_inda_required
				and is_null_payment_grace_days = r.is_null_payment_grace_days
				and is_null_watermark_documents = r.is_null_watermark_documents
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 20)
			q.select_string (2, 20)
			q.select_string (3, 80)
			q.select_integer (4)
			q.select_boolean (5)
			q.select_integer (6)
			q.select_boolean (7)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			document_access_grace_days := q.integer_value (4)
			inda_required := q.boolean_value (5)
			payment_grace_days := q.integer_value (6)
			watermark_documents := q.boolean_value (7)
		end

	fill_in_references (q: SQL_QUERY)
		do
			acct_sub_type := q.string_value (1)
			acct_type := q.string_value (2)
			descr := q.string_value (3)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, acct_sub_type)
			q.get_string_value (2, acct_type)
			q.get_string_value (3, descr)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_acct_sub_type := q.is_null (1)
			is_null_acct_type := q.is_null (2)
			is_null_descr := q.is_null (3)
			is_null_document_access_grace_days := q.is_null (4)
			is_null_inda_required := q.is_null (5)
			is_null_payment_grace_days := q.is_null (6)
			is_null_watermark_documents := q.is_null (7)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_acct_type := True
			is_null_acct_sub_type := True
			create acct_type.make (0)
			create acct_sub_type.make (0)
		end

	set_null_nonkey
		do
			is_null_descr := True
			is_null_document_access_grace_days := True
			is_null_inda_required := True
			is_null_payment_grace_days := True
			is_null_watermark_documents := True
			create descr.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, acct_type, False)
			q.bind_num_to_string (2, acct_sub_type, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and document_access_grace_days = q.integer_value (4)
				and inda_required = q.boolean_value (5)
				and payment_grace_days = q.integer_value (6)
				and watermark_documents = q.boolean_value (7)
			q.get_string_value (1, s)
			Result := Result and equal (acct_sub_type, s)
			q.get_string_value (2, s)
			Result := Result and equal (acct_type, s)
			q.get_string_value (3, s)
			Result := Result and equal (descr, s)
			Result := Result
				and is_null_acct_sub_type = q.is_null (1)
				and is_null_acct_type = q.is_null (2)
				and is_null_descr = q.is_null (3)
				and is_null_document_access_grace_days = q.is_null (4)
				and is_null_inda_required = q.is_null (5)
				and is_null_payment_grace_days = q.is_null (6)
				and is_null_watermark_documents = q.is_null (7)
		end

end
