deferred class ACTION_ITEM

inherit
	ANY
	MISC_UTILITIES_ACCESS
		export 
			{NONE} all 
		end;

feature

	done: BOOLEAN
		-- action is a one-shot

	exception_cause: STRING
		-- why we failed (try_it only)

	do_it is
		-- just do it (but just once)
	require not done
	deferred
	ensure done
	end;

	try_it is
		-- give it a shot; allow for failure (via exception)
	require not done
	local in_retry: BOOLEAN
	do if in_retry
	    then done := false
		 exception_cause := mu.exception_explanation
	    else do_it
	   end
	ensure done_xor_excuse: done = (exception_cause = Void)
	rescue
	   in_retry := true; retry;
	end;

	descr: STRING is
		-- short, pithy description of the action
	deferred
	end;

end -- ACTION_ITEM
