
indexing
	
	description: "Action that adds die for reticle view element to a list"
	author: "David Hollenberg"
	date: "November 30, 2006"

class ADD_DIE_ACTION
inherit
	VIEW_ELEMENT_ACTION

feature -- Properties

	die_list: LIST [RETICLE_DIE]
			-- List to which to add dies

feature -- Modification

	set_die_list (a_list: like die_list)
			-- Set `die_list' to `a_list'
		require
			a_list_not_void: a_list /= Void
		do
			die_list := a_list
		ensure
			die_list_set: die_list = a_list
		end

feature -- Operations

	apply (an_element: RETICLE_VIEW_ELEMENT)
			-- Apply action to `an_element'
		local
			l_die: RETICLE_DIE
		do
			if an_element.is_die then
				l_die ?= an_element.model_element
				check
					l_die_not_void: l_die /= Void
				end
				die_list.extend (l_die)
			end
		end

end
