
indexing
	
	description: "Action that adds projects to list if not already present"
	author: "David Hollenberg"
	date: "November 30, 2006"

class ADD_PROJECT_ACTION
inherit
	VIEW_ELEMENT_ACTION

feature -- Properties

	list: LIST [PACKING_PROJECTS_MROW]
			-- List to which to add projects

feature -- Modification

	set_list (a_list: like list)
			-- Set `list' to `a_list'
		require
			a_list_not_void: a_list /= Void
		do
			list := a_list
			create projects_table.make (a_list.count)
		ensure
			list_set: list = a_list
		end

feature -- Operations

	apply (an_element: RETICLE_VIEW_ELEMENT)
			-- Apply action to `an_element'
		local
			p: PACKING_PROJECTS_MROW
		do
			p := an_element.project
			projects_table.search (p)
			if not projects_table.found then
				projects_table.put (1, p)
				list.extend (an_element.project)
			end
		end

feature {NONE} -- Implementation

	projects_table: HASH_TABLE [INTEGER, PACKING_PROJECTS_MROW]
			-- Table which records projects that have already
			-- been added to list

end
