
indexing
	
	description: "Action that adds die for reticle view element to a list %
		%if it is not already in the list"
	author: "David Hollenberg"
	date: "November 30, 2006"

class ADD_UNIQUE_DIE_ACTION
inherit
	VIEW_ELEMENT_ACTION

feature -- Properties

	die_list: LIST [PACKING_DIES_MROW]
			-- List to which to add dies

feature -- Modification

	set_die_list (a_list: like die_list)
			-- Set `die_list' to `a_list'
		require
			a_list_not_void: a_list /= Void
		do
			die_list := a_list
			die_list.compare_references
		ensure
			die_list_set: die_list = a_list
		end

feature -- Operations

	apply (an_element: RETICLE_VIEW_ELEMENT)
			-- Apply action to `an_element'
		local
			l_die: PACKING_DIES_MROW
		do
			l_die := an_element.model_element.die
			if not die_list.has (l_die) then
				die_list.extend (l_die)
			end
		end

end
