class ADDRESSES_ROW

inherit

	ADDRESSES_RAW

	ESSENCE_OF_ADDRESS

create

	make_template, make_null

feature -- deferred ESSENCE_OF_ADDRESS features that are not found
	--  directly in ADDRESSES_RAW

	line_a: STRING is
	do  create Result.make(80);
	    if not is_null_appellation
	     then Result.append(appellation); Result.extend(' ');
	    end;
	    Result.append(first_name);
	    su.append_with_separator(Result, su.space, mid_name);
	    su.append_with_separator(Result, su.space, last_name);
	    su.append_with_separator(Result, su.space, suffix);
	end;

	line_b: STRING is
	do  Result := full_name		-- of the organization
	end;

	line_c: STRING is
	local  b: DB_BIND_I;
	do  if not is_null_div_no
	     then create b.make(div_no)
		  Result := connection.safe_selected_string(
						"full_name", "divisions",
						"div_no = :1", b)
	    end;
	end;

	phone_info: STRING is
	local b: DB_BIND_ICC;
	do  create b.make(contact_no, phone_loc_is_work, phone_usage_is_person);
	    Result := connection.safe_selected_string(
				"phone_text", "phone_texts",
				phone_filter, b);
	    if su.is_empty(Result)
	     then b.make(contact_no, phone_loc_is_work, phone_usage_is_vmail);
		  Result := connection.safe_selected_string(
				"phone_text", "phone_texts",
				phone_filter, b);
	    end;
	end;

	phone_filter: STRING is
		-- we only go after work numbers
	"contact_no = :1 and phone_loc = :2 and phone_usage = :3"

feature	-- new full label

	full_label: STRING is
	local b: DB_BIND_IC
	do  create b.make(contact_no, address_type)
	    Result := connection.selected_string
			("address_labels.contact_address_label(:1, :2, 0, 0)",
			 "dual", Void, b)
	end;

end -- class ADDRESSES_ROW
