
indexing
	
	description: "Object that can generate colors for an %
		%element of a reticle view according to all validity errors %
		%and warnings found for it, in Cut mode"
	author: "David Hollenberg"
	date: "December 8, 2006"

class ALL_CUT_VALIDITY_COLOR_GENERATOR
inherit
	RETICLE_VIEW_ELEMENT_COLOR_GENERATOR

create
	make

feature -- Access

	border_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Foreground color for border (usually a
			-- rectangle) of `an_element'
		do
			Result := standard_color (an_element)
		end
	
	label_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Foreground color for label
		do
			Result := standard_color (an_element)
		end
	
feature {NONE} -- Implementation

	standard_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Standard color for `an_element'
		do
			if not an_element.is_selectable then
				Result := palette.unselectable_color
			elseif an_element.is_cut_cut_die_invalid then
				Result := palette.invalid_isolated_cut_die_color
			elseif an_element.has_wrong_lot_for_cut_pattern then
				Result := palette.wrong_lot_color
			elseif an_element.is_cut_cut_die_too_big then
				Result := palette.cut_die_too_big_color
			elseif an_element.shares_cut_die_with_others then
				Result := palette.shared_cut_die_color
			elseif an_element.has_non_default_cut_die_size then
				Result := palette.non_default_cut_die_size_color
			elseif an_element.is_extra_cut then
				Result := palette.extra_cut_color
			else
				Result := palette.no_validity_issues_color
			end
		end
	
end
