
indexing
	
	description: "Object that can generate colors for an %
		%element of a reticle view according to all validity errors %
		%and warnings found for it, in Pack mode"
	author: "David Hollenberg"
	date: "December 8, 2006"

class ALL_PACK_VALIDITY_COLOR_GENERATOR
inherit
	RETICLE_VIEW_ELEMENT_COLOR_GENERATOR
	SCRIBES_INCLUDABLE

create
	make

feature -- Access

	border_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Foreground color for border (usually a
			-- rectangle) of `an_element'
		do
			Result := standard_color (an_element)
		end
	
	label_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Foreground color for label
		do
			Result := standard_color (an_element)
		end
	
feature {NONE} -- Implementation

	standard_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Standard color for `an_element'
		do
			if not an_element.is_selectable then
				Result := palette.unselectable_color
			elseif not an_element.intersects_any_field then
				Result := palette.outside_all_fields_color
			elseif an_element.partially_outside_fields and (scribes_included or an_element.is_non_scribe) then
				Result := palette.overlaps_field_edge_color
			elseif an_element.is_overlapping_another_object then
				Result := palette.overlaps_another_object_color
			elseif an_element.is_below_minimum_size then
				Result := palette.below_minimum_size_color
			elseif an_element.is_wafer_etest_id_missing then
				Result := palette.needs_lot_assignment_color
			elseif an_element.is_unlocked_or_unassigned_cust_project then
				Result := palette.unlocked_or_unassigned_color
			elseif an_element.is_too_close_to_another_object then
				Result := palette.too_close_to_object_color
			elseif an_element.is_too_close_to_field_edge and (scribes_included or an_element.is_non_scribe) then
				Result := palette.too_close_to_edge_color
			elseif an_element.is_scribe_cut_die_too_big then
				Result := palette.cut_die_too_big_color
			elseif an_element.is_unisolated_in_scribe_cut_die then
				Result := palette.not_isolated_in_cut_die_color
			elseif an_element.is_uncentered_in_cut_die then
				Result := palette.not_centered_in_cut_die_color
			elseif an_element.is_floating_scribe then
				Result := palette.floating_scribe_color
			elseif an_element.is_misaligned_scribe then
				Result := palette.misaligned_scribe_color
			elseif an_element.is_small_scribe_or_filler and (scribes_included or an_element.is_non_scribe) then
				Result := palette.small_but_legal_color
			else
				Result := palette.no_validity_issues_color
			end
		end
	
end
