
indexing

	date: "Tue Apr 24 10:30:09 2007"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user DHOLLEN"
	database_tables: 
		"APPLICATION_COLORS (MOSIS.APPLICATION_COLORS)"
			-- Included columns
			-- 	APPLICATION
			-- 	BLUE_VALUE
			-- 	COLOR_NAME
			-- 	COLOR_ROLE
			-- 	GREEN_VALUE
			-- 	RED_VALUE
			-- Excluded columns
			-- 	(none)

class APPLICATION_COLORS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_application: STRING; the_color_role: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_application_exists: the_application /= Void
			the_color_role_exists: the_color_role /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			application := the_application
			color_role := the_color_role
			is_null_application := False
			is_null_color_role := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 6

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  application, blue_value, color_name, color_role, green_value, red_value"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "application_colors appc"

	join_condition: STRING = ""

	table_name: STRING = "application_colors"

	key_where_clause: STRING = "application = :1 and color_role = :2"

feature -- Values

	application: STRING
			-- DB: VARCHAR2(50) not null

	blue_value: DOUBLE
			-- DB: NUMBER(*,*)

	color_name: STRING
			-- DB: VARCHAR2(30)

	color_role: STRING
			-- DB: VARCHAR2(30) not null

	green_value: DOUBLE
			-- DB: NUMBER(*,*)

	red_value: DOUBLE
			-- DB: NUMBER(*,*)

feature -- Nullness for null allowed columns

	is_null_blue_value: BOOLEAN
	is_null_color_name: BOOLEAN
	is_null_green_value: BOOLEAN
	is_null_red_value: BOOLEAN

feature -- Nullness for non-null columns

	is_null_application: BOOLEAN
	is_null_color_role: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (application, r.application)
				and equal (color_role, r.color_role)
			Result := Result
				and is_null_application = r.is_null_application
				and is_null_color_role = r.is_null_color_role
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and blue_value = r.blue_value
				and green_value = r.green_value
				and red_value = r.red_value
			Result := Result
				and equal (color_name, r.color_name)
			Result := Result
				and is_null_blue_value = r.is_null_blue_value
				and is_null_color_name = r.is_null_color_name
				and is_null_green_value = r.is_null_green_value
				and is_null_red_value = r.is_null_red_value
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 50)
			q.select_double (2)
			q.select_string (3, 30)
			q.select_string (4, 30)
			q.select_double (5)
			q.select_double (6)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			blue_value := q.double_value (2)
			green_value := q.double_value (5)
			red_value := q.double_value (6)
		end

	fill_in_references (q: SQL_QUERY)
		do
			application := q.string_value (1)
			color_name := q.string_value (3)
			color_role := q.string_value (4)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, application)
			q.get_string_value (3, color_name)
			q.get_string_value (4, color_role)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_application := q.is_null (1)
			is_null_blue_value := q.is_null (2)
			is_null_color_name := q.is_null (3)
			is_null_color_role := q.is_null (4)
			is_null_green_value := q.is_null (5)
			is_null_red_value := q.is_null (6)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_application := True
			is_null_color_role := True
			create application.make (0)
			create color_role.make (0)
		end

	set_null_nonkey
		do
			is_null_blue_value := True
			is_null_color_name := True
			is_null_green_value := True
			is_null_red_value := True
			create color_name.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, application, False)
			q.bind_num_to_string (2, color_role, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and blue_value = q.double_value (2)
				and green_value = q.double_value (5)
				and red_value = q.double_value (6)
			q.get_string_value (1, s)
			Result := Result and equal (application, s)
			q.get_string_value (3, s)
			Result := Result and equal (color_name, s)
			q.get_string_value (4, s)
			Result := Result and equal (color_role, s)
			Result := Result
				and is_null_application = q.is_null (1)
				and is_null_blue_value = q.is_null (2)
				and is_null_color_name = q.is_null (3)
				and is_null_color_role = q.is_null (4)
				and is_null_green_value = q.is_null (5)
				and is_null_red_value = q.is_null (6)
		end

end
