
indexing
	
	description: "An event of possible interest that occurs during an application"
	author: "David Hollenberg"
	date: "March 12, 2003"

deferred class APPLICATION_EVENT
inherit
	ANY
	PUBLICATION_MANAGER_ACCESS
		export
			{NONE} all
		end

feature -- Operations

	publish
			-- Publish occurrence of event
		require
			is_valid: is_valid
		do
			pubman.publish (Current)
		end

	subscribe (action: PROCEDURE [ANY, TUPLE [like Current]])
			-- Call `action' when event is published
		do
			pubman.subscribe (Current, action)
		end

	unsubscribe (action: PROCEDURE [ANY, TUPLE [like Current]])
			-- Do not call `action' any longer when event is 
			-- published
		do
			pubman.unsubscribe (Current, action)
		end

feature -- Properties

	is_valid: BOOLEAN
			-- Is event in a valid state to be published?
		deferred
		end

end
