
indexing

	date: "Tue Apr 24 10:30:09 2007"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application NFE, database user DHOLLEN"
	database_tables: 
		"APPLICATION_EVENTS (MOSIS.APPLICATION_EVENTS)"
			-- Included columns
			-- 	APPLICATION
			-- 	CHAR_VALUE
			-- 	DATE_VALUE
			-- 	DESCR
			-- 	EVENT_NAME
			-- 	NUMERIC_VALUE
			-- Excluded columns
			-- 	(none)

class APPLICATION_EVENTS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_application: STRING; the_event_name: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_application_exists: the_application /= Void
			the_event_name_exists: the_event_name /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			application := the_application
			event_name := the_event_name
			is_null_application := False
			is_null_event_name := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 6

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  application, char_value, date_value, descr, event_name, numeric_value"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "application_events ae"

	join_condition: STRING = ""

	table_name: STRING = "application_events"

	key_where_clause: STRING = "application = :1 and event_name = :2"

feature -- Values

	application: STRING
			-- DB: VARCHAR2(50) not null

	char_value: STRING
			-- DB: VARCHAR2(255)

	date_value: DB_DATE
			-- DB: DATE

	descr: STRING
			-- DB: VARCHAR2(255)

	event_name: STRING
			-- DB: VARCHAR2(30) not null

	numeric_value: DOUBLE
			-- DB: NUMBER(*,*)

feature -- Nullness for null allowed columns

	is_null_char_value: BOOLEAN
	is_null_date_value: BOOLEAN
	is_null_descr: BOOLEAN
	is_null_numeric_value: BOOLEAN

feature -- Nullness for non-null columns

	is_null_application: BOOLEAN
	is_null_event_name: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (application, r.application)
				and equal (event_name, r.event_name)
			Result := Result
				and is_null_application = r.is_null_application
				and is_null_event_name = r.is_null_event_name
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and numeric_value = r.numeric_value
			Result := Result
				and equal (char_value, r.char_value)
				and equal (date_value, r.date_value)
				and equal (descr, r.descr)
			Result := Result
				and is_null_char_value = r.is_null_char_value
				and is_null_date_value = r.is_null_date_value
				and is_null_descr = r.is_null_descr
				and is_null_numeric_value = r.is_null_numeric_value
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 50)
			q.select_string (2, 255)
			q.select_date (3)
			q.select_string (4, 255)
			q.select_string (5, 30)
			q.select_double (6)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			numeric_value := q.double_value (6)
		end

	fill_in_references (q: SQL_QUERY)
		do
			application := q.string_value (1)
			char_value := q.string_value (2)
			date_value := q.date_value (3)
			descr := q.string_value (4)
			event_name := q.string_value (5)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, application)
			q.get_string_value (2, char_value)
			q.get_date_value (3, date_value)
			q.get_string_value (4, descr)
			q.get_string_value (5, event_name)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_application := q.is_null (1)
			is_null_char_value := q.is_null (2)
			is_null_date_value := q.is_null (3)
			is_null_descr := q.is_null (4)
			is_null_event_name := q.is_null (5)
			is_null_numeric_value := q.is_null (6)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_application := True
			is_null_event_name := True
			create application.make (0)
			create event_name.make (0)
		end

	set_null_nonkey
		do
			is_null_char_value := True
			is_null_date_value := True
			is_null_descr := True
			is_null_numeric_value := True
			create char_value.make (0)
			create {ORACLE_DATE} date_value.set_null
			create descr.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, application, False)
			q.bind_num_to_string (2, event_name, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
			d: DB_DATE
		do
			s := temp_string
			d := temp_date
			Result := True
			Result := Result
				and numeric_value = q.double_value (6)
			q.get_string_value (1, s)
			Result := Result and equal (application, s)
			q.get_string_value (2, s)
			Result := Result and equal (char_value, s)
			q.get_date_value (3, d)
			Result := Result and equal (date_value, d)
			q.get_string_value (4, s)
			Result := Result and equal (descr, s)
			q.get_string_value (5, s)
			Result := Result and equal (event_name, s)
			Result := Result
				and is_null_application = q.is_null (1)
				and is_null_char_value = q.is_null (2)
				and is_null_date_value = q.is_null (3)
				and is_null_descr = q.is_null (4)
				and is_null_event_name = q.is_null (5)
				and is_null_numeric_value = q.is_null (6)
		end

end
