class APPLICATION_PARAMETERS_ROW

inherit

	APPLICATION_PARAMETERS_RAW
	ROW_COUNT_CHECK_ACCESS
		export
			{NONE} all
		end

create

	make_template, make_null, make_by_key

feature -- Collections

	parameter_value (app, parameter: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current] is
			-- Rows for application parameter
			-- for `app' with name `parameter'
		require
			application_exists: app /= Void
			parameter_exists: parameter /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_SS
		do
			create b.make (app, parameter)
			Result := all_rows_filtered (conn, "application = :1 and parameter_name = :2", b)
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

end -- APPLICATION_PARAMETERS_ROW
