
indexing
	
	description: "A run closing step operation that assigns cut patterns %
		%to packaging lots"
	author: "David Hollenberg"
	date: "February 28, 2007"

class ASSIGN_CUT_PATTERNS_OP
inherit
	RC_PRIMITIVE_STEP_OP
	RC_APPLICABLE_STEP
	NO_USER_INTERFACE
	NO_EXTERNAL_STATE

create
	make

feature -- Properties

	input_data_items: LIST [STRING]
			-- Data items required before step can be executed
		do
			Result := array_as_list (<<
					data_item.Assigned_wafer_processes,
					data_item.Assigned_die_ids,
					data_item.Initial_packaging_lots,
					data_item.Cut_patterns
				 >>)
		end

feature {NONE} -- Implementation

	do_step
			-- Execute step
		do
			if question ("Have you run the SQL script%N%N     @assign_run_cut_pattern_lots " + session.run_id + "%N%Nto assign cut patterns to packaging lots?") then
			else
				abort
			end
			cache.uncache_cut_patterns
			call_completion_actions
		end

	undo_step
			-- Undo execution of step
		local
			cut_patterns: LIST [RUN_CUT_PATTERNS_MROW]
			lock_op: ROW_LOCK_OP
		do
			cache.uncache_cut_patterns
			cut_patterns := cache.cut_pattern_mrows
			create lock_op
			lock_op.lock_list_nowait (cut_patterns)
			cut_patterns.do_all (agent {RUN_CUT_PATTERNS_MROW}.set_null_packaging_lot_no)
			call_completion_actions
		end

	set_state
			-- Set `state'
		do
			state := Void
		end

end
