
indexing
	
	description: "Action that assign wafer etest ID to reticle view %
		%element (which must be a customer project)"
	author: "David Hollenberg"
	date: "December 18, 2006"

class ASSIGN_LOT_ACTION
inherit
	VIEW_ELEMENT_ACTION

feature -- Properties

	wafer_etest_row: WAFER_ETEST_NAMES_ROW
			-- Row for wafer etest name to assign to projects

feature -- Modification

	set_wafer_etest_row (a_row: like wafer_etest_row)
			-- Set `wafer_etest_row' to `a_row'
		do
			wafer_etest_row := a_row
		ensure
			wafer_etest_row_set: wafer_etest_row = a_row
		end

feature -- Operations

	apply (an_element: RETICLE_VIEW_ELEMENT)
			-- Apply action to `an_element'
		local
			l_die: PACKING_DIES_MROW
			old_name, new_name: STRING
		do
			if an_element.any_copies_selected then
				l_die := an_element.die
				old_name := l_die.wafer_etest_name
				if wafer_etest_row /= Void then
					new_name := wafer_etest_row.wafer_etest_name
					l_die.set_wafer_etest_name (new_name)
				else
					new_name := ""
					l_die.set_null_wafer_etest_name
				end
				an_element.add_to_changed_region
				an_element.add_change (create {ASSIGNED_LOT_CHANGE}.make (an_element, old_name, new_name))
			end
		end

end
