deferred class AUTO_DB_DELETABLE_ROW_LIST [reference G -> DB_DELETABLE_ROW]
	-- maintain a list of rows fetched from the database by our
	-- very own special query (deferred)
	-- but only fetch them upon first reference.
	-- inherit this class and rename all three features to more
	--  appropriate names

feature -- the visible list of rows

	the_list: DB_DELETABLE_ROW_LIST[G] is
		-- the visible list
	do  if the_hidden_list = Void
	     then	-- time to initialize
		create the_hidden_list.make_by_query(fetch_the_list);
	    end;
	    Result := the_hidden_list
	ensure Result /= Void
	end;

feature {NONE} -- the real list; Void until first reference

	the_hidden_list: DB_DELETABLE_ROW_LIST[G];
		-- the real list if non-Void;
		-- to reset for a refetch, do the_hidden_list := Void

feature {NONE} -- deferred implementation: our query

	fetch_the_list: DB_IDENTIFIED_QUERY[G] is
		-- ready to execute query to fetch our rows;
		-- Void bypasses the query and creates an empty list
	deferred
	end;

end -- AUTO_DB_DELETABLE_ROW_LIST
