
indexing
	
	description: "Database row on whose behalf a batch job needs to %
		%be run."
	author: "David Hollenberg";
	date: "January 29, 2004"

deferred class BATCH_JOB_REQUESTOR
inherit
	CONST_BATCH_JOB_REQUESTOR
	STRING_UTILITIES_ACCESS
		export
			{NONE} all
		end

feature -- Modification
	
	set_status_created is
		local
			status_values: JOB_STATUS_VALUES
		do
			set_job_status (status_values.Created)
			set_null_job_info
		end

	set_status_pending is
		local
			status_values: JOB_STATUS_VALUES
		do
			set_job_status (status_values.Pending)
			set_null_job_info
		end

	set_status_executing is
		local
			status_values: JOB_STATUS_VALUES
		do
			set_job_status (status_values.Executing)
			set_null_job_info
		end

	set_null_job_info is
		do
			set_null_date_job_started
			set_null_date_job_ended
			set_null_error_explanation
		end

	set_date_job_started (d: DB_DATE) is
		do
			is_known_job_interval := False
		end

	set_date_job_ended (d: DB_DATE) is
		do
			is_known_job_interval := False
		end

	set_error_explanation (s: STRING) is
		do
			truncated_error := su.nicely_truncated_string (s, maxlen_error_explanation)
		end

	set_job_status (s: STRING) is
			-- Set `job_status' to `s'
		deferred
		end

	set_batch_job_no (n: INTEGER) is
			-- Set batch job number to `n'
		deferred
		end

	set_null_date_job_started is
			-- Set date batch job started to null
		deferred
		end

	set_null_batch_job_no is
			-- Set batch job number to null
		deferred
		end

	set_null_date_job_ended is
			-- Set date batch job ended to null
		deferred
		end

	set_null_error_explanation is
			-- Set error explanation to null
		deferred
		end

feature {NONE} -- Implementation

	truncated_error: STRING
			-- Error explanation truncated to fit max
			-- length of column

end
