
indexing

	date: "Tue Apr 24 10:30:09 2007"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user DHOLLEN"
	database_tables: 
		"BATCH_JOBS (MOSIS.BATCH_JOBS)"
			-- Included columns
			-- 	BATCH_JOB_NO
			-- 	BATCH_JOB_QUEUE
			-- 	BATCH_JOB_STATE
			-- 	BATCH_JOB_TYPE
			-- 	CHILD_PROCESS_ID
			-- 	DATE_CHILD_STARTED
			-- 	DATE_STATE_CHANGED
			-- 	DATE_SUBMITTED
			-- 	ERROR_EXPLANATION
			-- 	ERROR_FILENAME
			-- 	EXECUTION_HOST
			-- 	EXIT_CODE
			-- 	INPUT_FILENAME
			-- 	JOB_NAME
			-- 	JOB_SET_NAME
			-- 	NOTIFY_ON_FAILURE
			-- 	OUTPUT_FILENAME
			-- 	PRIORITY
			-- 	PROCESS_NAME
			-- 	PROCESS_START_COUNT
			-- 	PROGRAM_ARGUMENTS
			-- 	PROGRAM_FILENAME
			-- 	RESTARTABLE
			-- 	SIGNAL_NUMBER
			-- Excluded columns
			-- 	(none)

class BATCH_JOBS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_batch_job_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			batch_job_no := the_batch_job_no
			is_null_batch_job_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 24

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  batch_job_no, batch_job_queue, batch_job_state, batch_job_type,%N  child_process_id, date_child_started, date_state_changed, date_submitted,%N  error_explanation, error_filename, execution_host, exit_code,%N  input_filename, job_name, job_set_name, notify_on_failure,%N  output_filename, priority, process_name, process_start_count,%N  program_arguments, program_filename, restartable, signal_number"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "batch_jobs bj"

	join_condition: STRING = ""

	table_name: STRING = "batch_jobs"

	key_where_clause: STRING = "batch_job_no = :1"

feature -- Values

	batch_job_no: INTEGER
			-- DB: NUMBER(9,0) not null

	batch_job_queue: STRING
			-- DB: VARCHAR2(30) not null

	batch_job_state: STRING
			-- DB: VARCHAR2(20) not null

	batch_job_type: STRING
			-- DB: VARCHAR2(20) not null

	child_process_id: INTEGER
			-- DB: NUMBER(5,0)

	date_child_started: DB_DATE
			-- DB: DATE

	date_state_changed: DB_DATE
			-- DB: DATE not null

	date_submitted: DB_DATE
			-- DB: DATE not null

	error_explanation: STRING
			-- DB: VARCHAR2(2000)

	error_filename: STRING
			-- DB: VARCHAR2(255)

	execution_host: STRING
			-- DB: VARCHAR2(20)

	exit_code: INTEGER
			-- DB: NUMBER(3,0)

	input_filename: STRING
			-- DB: VARCHAR2(255)

	job_name: STRING
			-- DB: VARCHAR2(30) not null

	job_set_name: STRING
			-- DB: VARCHAR2(30) not null

	notify_on_failure: BOOLEAN
			-- DB: CHAR(1) not null

	output_filename: STRING
			-- DB: VARCHAR2(255)

	priority: INTEGER
			-- DB: NUMBER(3,0) not null

	process_name: STRING
			-- DB: VARCHAR2(30)

	process_start_count: INTEGER
			-- DB: NUMBER(3,0)

	program_arguments: STRING
			-- DB: VARCHAR2(2000)

	program_filename: STRING
			-- DB: VARCHAR2(255) not null

	restartable: BOOLEAN
			-- DB: CHAR(1) not null

	signal_number: INTEGER
			-- DB: NUMBER(2,0)

feature -- Nullness for null allowed columns

	is_null_child_process_id: BOOLEAN
	is_null_date_child_started: BOOLEAN
	is_null_error_explanation: BOOLEAN
	is_null_error_filename: BOOLEAN
	is_null_execution_host: BOOLEAN
	is_null_exit_code: BOOLEAN
	is_null_input_filename: BOOLEAN
	is_null_output_filename: BOOLEAN
	is_null_process_name: BOOLEAN
	is_null_process_start_count: BOOLEAN
	is_null_program_arguments: BOOLEAN
	is_null_signal_number: BOOLEAN

feature -- Nullness for non-null columns

	is_null_batch_job_no: BOOLEAN
	is_null_batch_job_queue: BOOLEAN
	is_null_batch_job_state: BOOLEAN
	is_null_batch_job_type: BOOLEAN
	is_null_date_state_changed: BOOLEAN
	is_null_date_submitted: BOOLEAN
	is_null_job_name: BOOLEAN
	is_null_job_set_name: BOOLEAN
	is_null_notify_on_failure: BOOLEAN
	is_null_priority: BOOLEAN
	is_null_program_filename: BOOLEAN
	is_null_restartable: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and batch_job_no = r.batch_job_no
			Result := Result
				and is_null_batch_job_no = r.is_null_batch_job_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and child_process_id = r.child_process_id
				and exit_code = r.exit_code
				and notify_on_failure = r.notify_on_failure
				and priority = r.priority
				and process_start_count = r.process_start_count
				and restartable = r.restartable
				and signal_number = r.signal_number
			Result := Result
				and equal (batch_job_queue, r.batch_job_queue)
				and equal (batch_job_state, r.batch_job_state)
				and equal (batch_job_type, r.batch_job_type)
				and equal (date_child_started, r.date_child_started)
				and equal (date_state_changed, r.date_state_changed)
				and equal (date_submitted, r.date_submitted)
				and equal (error_explanation, r.error_explanation)
				and equal (error_filename, r.error_filename)
				and equal (execution_host, r.execution_host)
				and equal (input_filename, r.input_filename)
				and equal (job_name, r.job_name)
				and equal (job_set_name, r.job_set_name)
				and equal (output_filename, r.output_filename)
				and equal (process_name, r.process_name)
				and equal (program_arguments, r.program_arguments)
				and equal (program_filename, r.program_filename)
			Result := Result
				and is_null_batch_job_queue = r.is_null_batch_job_queue
				and is_null_batch_job_state = r.is_null_batch_job_state
				and is_null_batch_job_type = r.is_null_batch_job_type
				and is_null_child_process_id = r.is_null_child_process_id
				and is_null_date_child_started = r.is_null_date_child_started
				and is_null_date_state_changed = r.is_null_date_state_changed
				and is_null_date_submitted = r.is_null_date_submitted
				and is_null_error_explanation = r.is_null_error_explanation
				and is_null_error_filename = r.is_null_error_filename
				and is_null_execution_host = r.is_null_execution_host
				and is_null_exit_code = r.is_null_exit_code
				and is_null_input_filename = r.is_null_input_filename
				and is_null_job_name = r.is_null_job_name
				and is_null_job_set_name = r.is_null_job_set_name
				and is_null_notify_on_failure = r.is_null_notify_on_failure
				and is_null_output_filename = r.is_null_output_filename
				and is_null_priority = r.is_null_priority
				and is_null_process_name = r.is_null_process_name
				and is_null_process_start_count = r.is_null_process_start_count
				and is_null_program_arguments = r.is_null_program_arguments
				and is_null_program_filename = r.is_null_program_filename
				and is_null_restartable = r.is_null_restartable
				and is_null_signal_number = r.is_null_signal_number
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_integer (1)
			q.select_string (2, 30)
			q.select_string (3, 20)
			q.select_string (4, 20)
			q.select_integer (5)
			q.select_date (6)
			q.select_date (7)
			q.select_date (8)
			q.select_string (9, 2000)
			q.select_string (10, 255)
			q.select_string (11, 20)
			q.select_integer (12)
			q.select_string (13, 255)
			q.select_string (14, 30)
			q.select_string (15, 30)
			q.select_boolean (16)
			q.select_string (17, 255)
			q.select_integer (18)
			q.select_string (19, 30)
			q.select_integer (20)
			q.select_string (21, 2000)
			q.select_string (22, 255)
			q.select_boolean (23)
			q.select_integer (24)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			batch_job_no := q.integer_value (1)
			child_process_id := q.integer_value (5)
			exit_code := q.integer_value (12)
			notify_on_failure := q.boolean_value (16)
			priority := q.integer_value (18)
			process_start_count := q.integer_value (20)
			restartable := q.boolean_value (23)
			signal_number := q.integer_value (24)
		end

	fill_in_references (q: SQL_QUERY)
		do
			batch_job_queue := q.string_value (2)
			batch_job_state := q.string_value (3)
			batch_job_type := q.string_value (4)
			date_child_started := q.date_value (6)
			date_state_changed := q.date_value (7)
			date_submitted := q.date_value (8)
			error_explanation := q.string_value (9)
			error_filename := q.string_value (10)
			execution_host := q.string_value (11)
			input_filename := q.string_value (13)
			job_name := q.string_value (14)
			job_set_name := q.string_value (15)
			output_filename := q.string_value (17)
			process_name := q.string_value (19)
			program_arguments := q.string_value (21)
			program_filename := q.string_value (22)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (2, batch_job_queue)
			q.get_string_value (3, batch_job_state)
			q.get_string_value (4, batch_job_type)
			q.get_date_value (6, date_child_started)
			q.get_date_value (7, date_state_changed)
			q.get_date_value (8, date_submitted)
			q.get_string_value (9, error_explanation)
			q.get_string_value (10, error_filename)
			q.get_string_value (11, execution_host)
			q.get_string_value (13, input_filename)
			q.get_string_value (14, job_name)
			q.get_string_value (15, job_set_name)
			q.get_string_value (17, output_filename)
			q.get_string_value (19, process_name)
			q.get_string_value (21, program_arguments)
			q.get_string_value (22, program_filename)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_batch_job_no := q.is_null (1)
			is_null_batch_job_queue := q.is_null (2)
			is_null_batch_job_state := q.is_null (3)
			is_null_batch_job_type := q.is_null (4)
			is_null_child_process_id := q.is_null (5)
			is_null_date_child_started := q.is_null (6)
			is_null_date_state_changed := q.is_null (7)
			is_null_date_submitted := q.is_null (8)
			is_null_error_explanation := q.is_null (9)
			is_null_error_filename := q.is_null (10)
			is_null_execution_host := q.is_null (11)
			is_null_exit_code := q.is_null (12)
			is_null_input_filename := q.is_null (13)
			is_null_job_name := q.is_null (14)
			is_null_job_set_name := q.is_null (15)
			is_null_notify_on_failure := q.is_null (16)
			is_null_output_filename := q.is_null (17)
			is_null_priority := q.is_null (18)
			is_null_process_name := q.is_null (19)
			is_null_process_start_count := q.is_null (20)
			is_null_program_arguments := q.is_null (21)
			is_null_program_filename := q.is_null (22)
			is_null_restartable := q.is_null (23)
			is_null_signal_number := q.is_null (24)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_batch_job_no := True
		end

	set_null_nonkey
		do
			is_null_batch_job_queue := True
			is_null_batch_job_state := True
			is_null_batch_job_type := True
			is_null_child_process_id := True
			is_null_date_child_started := True
			is_null_date_state_changed := True
			is_null_date_submitted := True
			is_null_error_explanation := True
			is_null_error_filename := True
			is_null_execution_host := True
			is_null_exit_code := True
			is_null_input_filename := True
			is_null_job_name := True
			is_null_job_set_name := True
			is_null_notify_on_failure := True
			is_null_output_filename := True
			is_null_priority := True
			is_null_process_name := True
			is_null_process_start_count := True
			is_null_program_arguments := True
			is_null_program_filename := True
			is_null_restartable := True
			is_null_signal_number := True
			create batch_job_queue.make (0)
			create batch_job_state.make (0)
			create batch_job_type.make (0)
			create {ORACLE_DATE} date_child_started.set_null
			create {ORACLE_DATE} date_state_changed.set_null
			create {ORACLE_DATE} date_submitted.set_null
			create error_explanation.make (0)
			create error_filename.make (0)
			create execution_host.make (0)
			create input_filename.make (0)
			create job_name.make (0)
			create job_set_name.make (0)
			create output_filename.make (0)
			create process_name.make (0)
			create program_arguments.make (0)
			create program_filename.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_integer (1, batch_job_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
			d: DB_DATE
		do
			s := temp_string
			d := temp_date
			Result := True
			Result := Result
				and batch_job_no = q.integer_value (1)
				and child_process_id = q.integer_value (5)
				and exit_code = q.integer_value (12)
				and notify_on_failure = q.boolean_value (16)
				and priority = q.integer_value (18)
				and process_start_count = q.integer_value (20)
				and restartable = q.boolean_value (23)
				and signal_number = q.integer_value (24)
			q.get_string_value (2, s)
			Result := Result and equal (batch_job_queue, s)
			q.get_string_value (3, s)
			Result := Result and equal (batch_job_state, s)
			q.get_string_value (4, s)
			Result := Result and equal (batch_job_type, s)
			q.get_date_value (6, d)
			Result := Result and equal (date_child_started, d)
			q.get_date_value (7, d)
			Result := Result and equal (date_state_changed, d)
			q.get_date_value (8, d)
			Result := Result and equal (date_submitted, d)
			q.get_string_value (9, s)
			Result := Result and equal (error_explanation, s)
			q.get_string_value (10, s)
			Result := Result and equal (error_filename, s)
			q.get_string_value (11, s)
			Result := Result and equal (execution_host, s)
			q.get_string_value (13, s)
			Result := Result and equal (input_filename, s)
			q.get_string_value (14, s)
			Result := Result and equal (job_name, s)
			q.get_string_value (15, s)
			Result := Result and equal (job_set_name, s)
			q.get_string_value (17, s)
			Result := Result and equal (output_filename, s)
			q.get_string_value (19, s)
			Result := Result and equal (process_name, s)
			q.get_string_value (21, s)
			Result := Result and equal (program_arguments, s)
			q.get_string_value (22, s)
			Result := Result and equal (program_filename, s)
			Result := Result
				and is_null_batch_job_no = q.is_null (1)
				and is_null_batch_job_queue = q.is_null (2)
				and is_null_batch_job_state = q.is_null (3)
				and is_null_batch_job_type = q.is_null (4)
				and is_null_child_process_id = q.is_null (5)
				and is_null_date_child_started = q.is_null (6)
				and is_null_date_state_changed = q.is_null (7)
				and is_null_date_submitted = q.is_null (8)
				and is_null_error_explanation = q.is_null (9)
				and is_null_error_filename = q.is_null (10)
				and is_null_execution_host = q.is_null (11)
				and is_null_exit_code = q.is_null (12)
				and is_null_input_filename = q.is_null (13)
				and is_null_job_name = q.is_null (14)
				and is_null_job_set_name = q.is_null (15)
				and is_null_notify_on_failure = q.is_null (16)
				and is_null_output_filename = q.is_null (17)
				and is_null_priority = q.is_null (18)
				and is_null_process_name = q.is_null (19)
				and is_null_process_start_count = q.is_null (20)
				and is_null_program_arguments = q.is_null (21)
				and is_null_program_filename = q.is_null (22)
				and is_null_restartable = q.is_null (23)
				and is_null_signal_number = q.is_null (24)
		end

end
