
indexing
	
	description: "Window to allow printing of bonding diagrams for %
		%a specific run"
	author: "David Hollenberg"
	date: "March 10, 2005"

class BOND_DIAGRAM_PRINT_WINDOW

inherit
	RC_RUN_PRINT_WINDOW
		
create
	make

feature {NONE} -- Implementation

	add_extra_select_menu_items (select_menu: EV_MENU)
		do
		end

	populate_maps
			-- Populate list of maps that can be printed
		local
			fg: RC_FILE_GENERATOR
			row: IC_PACKAGINGS_ROW
			unassigned_packagings: LIST [IC_PACKAGINGS_ROW]
		do
			maps.wipe_out
			missing_map_count := 0
			cache.uncache_packaging_lots
			create row.make_template
			unassigned_packagings := row.rows_needing_diagram_for_pkg_lot (session.run_id, 0, True, session.connection, expected_count.At_least_zero)
			fg := file_generator
			cache.packaging_lot_rows.do_all (agent add_bond_map)
			if not unassigned_packagings.is_empty then
				add_unassigned_bond_map
			end
			set_missing_files_status
		end

	add_bond_map (lot: RUN_PACKAGING_LOTS_ROW)
			-- Add bonding diagram set for `lot' to `maps'
			-- if file exists
		require
			lot_not_void: lot /= Void
		do
			if not lot.ic_packagings_needing_bonding.is_empty then
				add_map (lot.symbolic_bond_diagrams_map_name, session.file_generator.bond_diagrams_map_ps_file (lot, lot.packager_short_id, lot.wafer_etest_id))
			end
		end

	add_unassigned_bond_map
			-- Add bonding diagram set for packagings not assigned
			-- to any packaging lot, if file exists
		do
			add_map ("Bonding Diagrams not Assigned to a Packaging Lot", session.file_generator.bond_diagrams_map_ps_file (Void, "", ""))
		end

	job_name: STRING
			-- Name to use for print job
		do
			Result := session.run_id + "_bond_diagrams"
		end
	
end
