
indexing
	
	description: "Data source that has a bonding diagram"
	author: "David Hollenberg"
	date: "April 20, 2005"

class BOND_DIAGRAM_SOURCE

inherit
	DATA_SOURCEABLE
		
create
	make

feature {NONE} -- Creation

	make (ipw: IC_PACKAGING_AND_WO)
		require
			ipw_not_void: ipw /= Void
		do
			packaging := ipw
		end


feature -- Properties

	data_source: DATA_SOURCE
		do
			if cached_data_source = Void then
				set_cached_data_source
			end
			Result := cached_data_source
		end

feature {NONE} -- Implementation

	packaging: IC_PACKAGING_AND_WO
			-- Packaging for which diagram can be generated

	cached_data_source: DATA_SOURCE

	set_cached_data_source
		local
			gen: BONDING_DIAGRAM_GENERATOR
			diagram: BONDING_DIAGRAM
			projector: DRW_POSTSCRIPT_PROJECTOR
		do
			create gen.make (packaging.ic_packagings_row.connection)
			diagram := gen.vendor_bonding_diagram (packaging.ic_packagings_row, packaging.production_id)
			diagram.set_drawing_rotatable (False)
			diagram.generate_document
			create projector
			projector.project (diagram.last_document)
			create {DATA_SOURCE_STRING} cached_data_source.make (projector.postscript_result)
		end

end
