
indexing
	
	description: "[
		Facilities for dealing with Yes and No strings as
		boolean values.
		]"
	author: "David Hollenberg"
	date: "May 16, 2003"

deferred class BOOLEAN_STRINGS
inherit
	ANY
		undefine
			default_create
		end

feature -- Properties

	boolean_to_string (b: BOOLEAN): STRING
			-- `b' converted to corresponding string
		do
			if b then
				Result := Yes
			else
				Result := No
			end
		ensure
			result_exists: Result /= Void
			result_yes_or_no: is_valid_boolean_string (Result)
		end

	as_boolean (s: STRING): BOOLEAN
			-- `s' converted to a boolean
		require
			string_exists: s /= Void
			string_yes_or_no: is_valid_boolean_string (s)
		do
			Result := s.is_equal (Yes)
		end

	is_valid_boolean_string (s: STRING): BOOLEAN
			-- Does `s' represent a valid boolean?
		require
			string_exists: s /= Void
		do
			Result := s.is_equal (Yes) or s.is_equal (No)
		end

	Yes: STRING = "Yes"
			-- String representing True

	No: STRING = "No"
			-- String representing False

end
