
indexing
	
	description: "Action that builds list of edges of model %
		%elements and their properties"
	author: "David Hollenberg"
	date: "January 17, 2007"

class BUILD_EDGE_LIST_ACTION
inherit
	SCRIBE_EDGE_ACTION

feature -- Operations

	apply (an_element: RETICLE_VIEW_ELEMENT)
			-- Apply action to `an_element'
		local
			fields: LIST [RETICLE_FIELD]
		do
			if an_element.intersects_any_field then
				fields := an_element.intersecting_fields
				from
					fields.start
				until
					fields.after
				loop
					add_edges (an_element, edges_for_field (fields.item))
					fields.forth
				end
			end
		end

feature {NONE} -- Implementation

	add_edges (an_element: RETICLE_VIEW_ELEMENT a_field_edges: FIELD_ELEMENT_EDGES)
			-- Add edges for `an_element' to `a_field_edges'
		local
			field: like a_field_edges
			left, right, bottom, top: DOUBLE
		do
			field := a_field_edges
			left := grid.rounded_edge (an_element.left_x)
			right := grid.rounded_edge (an_element.right_x)
			bottom := grid.rounded_edge (an_element.bottom_y)
			top := grid.rounded_edge (an_element.top_y)
			
			if not an_element.is_horizontal_scribe then
				add_edge (an_element, left, bottom, top, field.left_limit, field.right_limit, field.vertical_edges)
				add_edge (an_element, right, bottom, top, field.left_limit, field.right_limit, field.vertical_edges)
			end
			
			if not an_element.is_vertical_scribe then
				add_edge (an_element, bottom, left, right, field.bottom_limit, field.top_limit, field.horizontal_edges)
				add_edge (an_element, top,left, right, field.bottom_limit, field.top_limit, field.horizontal_edges)
			end
		end

	add_edge (an_element: RETICLE_VIEW_ELEMENT a_position, a_low_end, a_high_end, a_low_limit, a_high_limit: DOUBLE a_list: LIST [MODEL_ELEMENT_EDGE])
			-- Add new edge to `a_list' if `a_position' is between
			-- `a_low_limit' and `a_high_limit'
		local
			edge: MODEL_ELEMENT_EDGE
		do
			if a_position >= a_low_limit and a_position <= a_high_limit then
				create edge
				edge.set_ends (a_low_end, a_high_end)
				edge.set_position (a_position)
				edge.set_is_meetable (an_element.is_meetable)
				a_list.extend (edge)
			end
		end

end
