
indexing
	
	description: "A run closing step operation that builds an order for %
		%fabrication for a dedicated run"
	author: "David Hollenberg"
	date: "March 29, 2004"

class BUILD_FAB_RUN_ORDER_OP
inherit
	RC_PRIMITIVE_STEP_OP
	HAS_USER_INTERFACE
	NO_EXTERNAL_STATE

create
	make

feature -- Properties

	input_data_items: LIST [STRING]
			-- Data items required before step can be executed
		do
			Result := array_as_list (<<
				data_item.Production_job
				 >>)
		end

	is_applicable: BOOLEAN
			-- Is step applicable to run for session?
		do
			Result := cache.is_dedicated_run
		end

feature {NONE} -- Implementation

	do_step
		local
			ifc: FAB_RUN_ORDER_IFC
		do
			ifc := factory.fab_run_order_interface (session.run_id, session.title_with_run_id ("Build Fab Run Order"))
			ifc.set_session (session)
			ifc.success_actions.extend (agent call_completion_actions)
			ifc.abort_actions.append (abort_actions)
			ifc.build
		end

	undo_step
			-- Undo execution of step
		do
			-- Don't try to remove any previously built order
			call_completion_actions
		end

	set_state
			-- Set `state'
		do
			state := Void
		end

end
