
indexing
	
	description: "Object whose case can be set"
	author: "David Hollenberg"
	date: "December 15, 2004"

deferred class CASE_SETTABLE

feature -- Properties

	is_uppercase_only: BOOLEAN
			-- Must all entered text be converted to uppercase?

	is_lowercase_only: BOOLEAN
			-- Must all entered text be converted to lowercase?

	is_mixed_case: BOOLEAN is
			-- Should entered text be allowed to contain both
			-- uppercase and lowercase characters?
		do
			Result := not is_uppercase_only and not is_lowercase_only
		end

feature -- Modification
	
	enable_uppercase_only is
		do
			is_uppercase_only := True
			is_lowercase_only := False
		end

	enable_lowercase_only is
		do
			is_lowercase_only := True
			is_uppercase_only := False
		end

	enable_mixed_case is
		do
			is_lowercase_only := False
			is_uppercase_only := False
		end

invariant
	not_upper_and_lower: not (is_uppercase_only and is_lowercase_only)
end
