class CATS_AREA_MEASUREMENT

inherit
	CATS_STATEMENT

create
	make

feature	-- compilation

	compile_prolog is
	do
	end;

	compile_statement(cop: CATS_OPERATION): CATS_OPERATION is
		-- cop is the putative final producer of our data
	local tmp: CATS_OP_FILE;
	do  if cop.modifies_primary or cop.primary.is_modified
				    or cop.primary.is_hierarchical
	     then  -- we need to fracture cop to a temp to measure
		  tmp := my_env.fracture_to_temp(cop);
		  Result := my_env.new_operation(tmp)
	     else Result := cop
	    end;
	    Result.set_final_comment("==> AREA   # xxxxxxxxx." + mebes_ext);
	    Result.set_command(cmd_is_area);
	end;

feature	-- creation

	make(src: CATS_EXPRESSION; plyr: STRING; res: DOUBLE) is
	require have_src: src /= Void
	do  source := src;
	    layer_level_name := plyr
	    resolution := res
	    statement_name := su.string_of_2("density for ", plyr);
	end;

end -- CATS_AREA_MEASUREMENT
