class CATS_CIFLIB_STEP
	-- step to run ciflib to produce a .clib file

inherit
	CATS_SCRIPT_STEP

	CATS_FILE_CONSUMER	-- (for the clay file)
create
	make

feature	-- the mandatory attributes of each step

	step_type: STRING is "CIFLIB"
		-- the (fixed) name of this type of step

	command_line: STRING is "ciflib"	-- is obsolete
				-- "readfile"	-- is not ready for prime time

	input1: STRING
		-- the first input file (by name) is the clay file
		-- (when using readfile, it is the second input!!)

	input2: STRING
		-- the second input file (by name) is the cif file
		-- (when using readfile, it is the first input!!)

	write_input_to_script(sfil: LARGE_PLAIN_TEXT_FILE) is
		-- script for readfile: just the three file names
	do  add_a_line(sfil, input1, Void);	-- clay 
	    add_a_line(sfil, input2, Void);	-- cif  
	    add_a_line(sfil, output, Void);	-- clib
	end;

feature	-- cats_file_consumer stuff

	my_step: CATS_CIFLIB_STEP is
		-- I am my own step
	do  Result := Current
	end;

	resolution_reqd: DOUBLE is
	do	-- (0 = unknown / indefinite)
	end;

feature {NONE} -- creation

	make(clay, cif, clib: STRING) is
		-- the three file names, fully spelled out
	do  input1 := clay;
	    input2 := cif;
	    output := clib;
	    output_is_temp := true
	end;

end -- CATS_CIFLIB_STEP
