class CATS_EXPR_BOOL

	-- a CATS_EXPRESSION that is a Boolean operation on two
	-- input CATS_EXPRESSIONs

inherit
	CATS_EXPR_OP[CATS_EXPRESSION]
	redefine is_equal, complexity, holds, register_all_exprs2, replace
	end;

create
	make3

feature	-- compilation

	function: STRING

	compile_prolog(env: CATS_COMPILATION_ENVIRONMENT) is
		-- whatever needs to be done before op1 is compiled
	do
	end;

	can_merge_into_op(cop: CATS_OPERATION): BOOLEAN is
		-- can I add myself into cop?
	do  Result := not cop.modifies_primary
	end;

	compile_op2(env:CATS_COMPILATION_ENVIRONMENT;
			cop:CATS_OPERATION) is
		-- compile function and operand2 into cop
	local cop2: CATS_OPERATION; cin2: CATS_OP_FILE
	do  cop2 := operand2.compile(env);
	    if cop2.modifies_primary
	     then cin2 := env.fracture_to_temp(cop2)
	     else cin2 := cop2.primary
	    end;
	    cop.set_function(function, cin2)
	end;

feature	-- complexity

	is_equal(other: like Current): BOOLEAN is
		-- really have other: ANY
	do  Result := same_type(other) and then
			(equal(function, other.function) and
			 equal(operand1, other.operand1) and
			 equal(operand2, other.operand2)
			)
	end;

	complexity: INTEGER is
	do  Result := operand1.complexity + 1 + operand2.complexity
	end;

feature	-- cats_expr_holder stuff

	holds(ce: CATS_EXPRESSION): BOOLEAN is
		-- Note: we are a holder for _each_ of our operands
	do  Result := operand1.is_equal(ce) or
		      operand2.is_equal(ce)
	end;

	register_all_exprs2(ce_opt: CATS_EXPR_OPTIMIZER; stmt_no: INTEGER) is
	do  ce_opt.add_holder(operand1, Current);	-- register
	    ce_opt.add_holder(operand2, Current);	-- me (twice)
	    operand1.register_all_exprs(ce_opt, stmt_no); -- and recurse
	    operand2.register_all_exprs(ce_opt, stmt_no)  -- (twice)
	end;

	replace(olde, newe: CATS_EXPRESSION) is
		-- try each operand in turn
	do  if operand1.is_equal(olde)
	     then operand1 := newe
	    end;
	    if operand2.is_equal(olde)
	     then operand2 := newe
	    end;
	end;

feature {NONE} -- creation
	-- except for the function name, there is nothing specific to the
	-- four functions, so we use a different make routine and avoid
	-- needing 4 descendent classes

	make3(func: STRING; op1, op2: CATS_EXPRESSION) is
	require is_valid_Boolean_op(func)
	do  function := func;
	    operand1 := op1;
	    operand2 := op2
	end;

end -- CATS_EXPR_BOOL
