class CATS_EXPR_BORDERED
	-- a change of the border attribute for the evaluation of op1

inherit
	CATS_EXPR_OP[STRING]

create
	make	-- in CATS_EXPR_OP

feature	--

	function: STRING is "BORDERED"

	prior_border: STRING
		-- for save and restore

	compile_prolog(env: CATS_COMPILATION_ENVIRONMENT) is
	local ot: CATS_OPERATION;
	do  -- adjust the border for all generated operations
	    ot := env.operation_template;
	    prior_border := ot.border
	    ot.set_border(operand2)
	end;

	can_merge_into_op(cop: CATS_OPERATION): BOOLEAN is
	do  Result := cop.tag = Void
	end;

	compile_op2(env: CATS_COMPILATION_ENVIRONMENT;
			cop: CATS_OPERATION) is
	local ot: CATS_OPERATION;
	do  -- tag cop
	    cop.set_tag(su.string_of_3(function, su.space, operand2));
	    -- restore the template
	    ot := env.operation_template;
	    ot.set_border(prior_border)
	end;

end -- CATS_EXPR_BORDERED
