class CATS_EXPR_LEAF
	-- a CATS_EXPRESSION that is an input layer (or pseudo-layer).
	-- All we have here in the expression is a layer name.
	-- Details regarding that layer depend upon the Cats
	-- compilation environment

inherit
	CATS_EXPRESSION

create
	make

convert		
	make ({STRING})		-- let a layer name become a LEAF

feature	-- data

	layer: STRING

feature	-- equality, display and complexity

	is_equal(other: like Current): BOOLEAN is
		-- really have other: ANY
	do  Result := same_type(other) and then
			equal(layer, other.layer)
	end;

	out: STRING is
	do  Result := layer.twin
	end;

	complexity: INTEGER is
	do  Result := 1
	end;

feature	-- compilation

	compile(env: CATS_COMPILATION_ENVIRONMENT): CATS_OPERATION is
		-- produce a new OPERATION containing just the input
	local inp: CATS_OP_FILE
	do  inp := env.input_for_layer(layer);
	    Result := env.new_operation(inp)
	end;

feature	-- hash_code

	hash_code: INTEGER is
	do  Result := layer.hash_code
	end;

feature	-- cats_expr_holder stuff

	holds(ce: CATS_EXPRESSION): BOOLEAN is 
	do  -- Result := false
	end;

	register_all_exprs2(ce_opt: CATS_EXPR_OPTIMIZER; stmt_no: INTEGER) is
	do  -- nada
	end;

	replace(olde, newe: CATS_EXPRESSION) is
	do  -- not callable
	end;

feature {NONE} -- creation

	make(lyr: STRING) is
	require have_layer: su.not_empty(lyr)
	do  layer := lyr
	end;

end -- CATS_EXPR_LEAF
