class CATS_EXPR_ONLY
	-- a restriction of the leaf input to L(ayout) or O(verhead)

inherit
	CATS_EXPR_OP[CHARACTER]

create
	make	-- in CATS_EXPR_OP

feature	--

	function: STRING is "ONLY"

	saved_template: CATS_OP_FILE
		-- for save and restore

	compile_prolog(env: CATS_COMPILATION_ENVIRONMENT) is
	do  -- adjust the input templates for all generated leaves
	    if env.second_leaf_input_template = Void
	     then raise_cats_error("CATS_EXPR_ONLY needs two inputs!")
	    elseif operand2 = 'L'
	     then saved_template := env.second_leaf_input_template;
		  env.set_leaf_input_templates
			(env.leaf_input_template, Void)
	    elseif operand2 = 'O'
	     then saved_template := env.leaf_input_template;
		  env.set_leaf_input_templates
			(env.second_leaf_input_template, Void)
	     else raise_cats_error("CATS_EXPR_ONLY has unknown operand2!")
	    end
	end;

	can_merge_into_op(cop: CATS_OPERATION): BOOLEAN is
	do  Result := true
	end;

	compile_op2(env: CATS_COMPILATION_ENVIRONMENT;
			cop: CATS_OPERATION) is
	do  -- just restore the two inputs; leave COP alone
	    if operand2 = 'L'
	     then env.set_leaf_input_templates
			(env.leaf_input_template, saved_template)
	     else env.set_leaf_input_templates
			(saved_template, env.leaf_input_template)
	    end
	end;

end -- CATS_EXPR_ONLY
