class CATS_EXPR_RULED
	-- a change of the sizing "rule" for the evaluation of op1

inherit
	CATS_EXPR_OP[STRING]

create
	make	-- in CATS_EXPR_OP

feature	--

	function: STRING is "RULED"

	prior_rule: STRING
		-- for save and restore

	compile_prolog(env: CATS_COMPILATION_ENVIRONMENT) is
	local ot: CATS_OPERATION;
	do  -- adjust the rule for all generated operations
	    ot := env.operation_template;
	    prior_rule := ot.rule
	    ot.set_rule(operand2)
	end;

	can_merge_into_op(cop: CATS_OPERATION): BOOLEAN is
	do  Result := cop.tag = Void
	end;

	compile_op2(env: CATS_COMPILATION_ENVIRONMENT;
			cop: CATS_OPERATION) is
	local ot: CATS_OPERATION;
	do  -- tag cop
	    cop.set_tag(su.string_of_3(function, su.space, operand2));
	    -- restore the template
	    ot := env.operation_template;
	    ot.set_rule(prior_rule)
	end;

end -- CATS_EXPR_RULED
