class CATS_EXPR_SCALED
	-- a scaling operation on an input CATS_EXPRESSIONS

inherit
	CATS_EXPR_OP[DOUBLE]

create
	make	-- in CATS_EXPR_OP

feature	-- 

	function: STRING is "SCALED"

	prior_resolution: DOUBLE
		-- save it here from prolog to compile_op2

	compile_prolog(env: CATS_COMPILATION_ENVIRONMENT) is
		-- whatever needs to be done before op1 is compiled
	local ot: CATS_OPERATION
	do  -- adjust resolution for all generated temps
	    ot := env.operation_template
	    prior_resolution := ot.resolution
	    ot.set_resolution(prior_resolution / operand2)
	end;

	can_merge_into_op(cop: CATS_OPERATION): BOOLEAN is
		-- can I add myself into cop?
		-- almost always, yes
	do  Result := cop.tag = Void
	end;

	compile_op2(env:CATS_COMPILATION_ENVIRONMENT;
			cop:CATS_OPERATION) is
		-- compile function and op2 into cop
	local op1: CATS_OP_FILE; ot: CATS_OPERATION
	do  -- scale the input(s)
	    op1 := cop.primary;
	    op1.set_scale(op1.scale * operand2);
	    op1 := cop.secondary;
	    if op1 /= Void
	     then op1.set_scale(op1.scale * operand2)
	    end;
	    -- compensate the grow if it was inside the scale
	    cop.set_grow(cop.grow * operand2);
	    -- restore resolution here and in template
	    -- (the resolution when cop was created is wrong for cop)
	    ot := env.operation_template;
	    ot.set_resolution(prior_resolution);
	    cop.set_resolution(prior_resolution)
	end;

end -- CATS_EXPR_SCALED
