class CATS_EXPR_SIZED
	-- a sizing operation on an input CATS_EXPRESSIONS

inherit
	CATS_EXPR_OP[DOUBLE]
		redefine	op2_out
		end;

create
	make	-- in CATS_EXPR_OP

feature	-- 

	function: STRING is "SIZED"

	op2_out: STRING is
	do  Result := fd4.formatted(operand2)
	end;

	compile_prolog(env: CATS_COMPILATION_ENVIRONMENT) is
		-- whatever needs to be done before op1 is compiled
	do  mop := env.operation_template	-- save for below
	end;

	can_merge_into_op(cop: CATS_OPERATION): BOOLEAN is
		-- can I add myself into cop?
	do  Result := parameters_are_unchanged(cop) and
		      can_set_grow(cop)
	end;

	compile_op2(env:CATS_COMPILATION_ENVIRONMENT;
			cop:CATS_OPERATION) is
		-- compile function and op2 into cop
	local p: CATS_OP_FILE
	do  p := cop.primary;
	    if (not cop.modifies_primary) and p.sizing = 0 and p.scale = 1
	     then -- modify p.sizing
		  p.set_sizing(operand2 * p.input_scale_factor)
	    elseif cop.reverse	-- modify cop.grow
	     then cop.set_grow(-(operand2 * cop.output_scale_factor))
	     else cop.set_grow(  operand2 * cop.output_scale_factor)
	    end;
	end;

feature {NONE} -- details

	mop: CATS_OPERATION	-- (saved for parameters_are_unchanged)

	parameters_are_unchanged(cop: CATS_OPERATION): BOOLEAN is
		-- are the parameters that affect sizing the same in cop
		-- as they are in mop (which is our correct environment)?
	do  Result := equal(mop.rule, cop.rule) and
		      equal(mop.border, cop.border)
		  --  and mop.twosided = cop.twosided
	end;

	can_set_grow(cop: CATS_OPERATION): BOOLEAN is
		-- can we push our sizing into cop.grow?
	do  Result := (cop.grow = 0) and cop.tag = Void
	end;

end -- CATS_EXPR_SIZED

