class CATS_EXPR_SOLID
	-- a CATS_EXPRESSION that is either completely blank (all field)
	--  or completely filled (all feature) source

inherit
	CATS_EXPRESSION

create
	make_blank,
	make_fill

feature	-- which one is it

	is_filled: BOOLEAN

feature	-- equality, display and complexity

	is_equal(other: like Current): BOOLEAN is
		-- really have other: ANY
	do  Result := same_type(other) and then
			equal(is_filled, other.is_filled)
	end;

	out: STRING is
	do  if is_filled	-- use the CATS select names
	     then Result := "FILL"
	     else Result := "BLANK"
	    end
	end;

	complexity: INTEGER is
	do  Result := 1
	end;

feature	-- compilation

	compile(env: CATS_COMPILATION_ENVIRONMENT): CATS_OPERATION is
		-- produce an operation to create our solid patch
	local leaf: CATS_EXPR_LEAF
		combo: CATS_EXPRESSION
	do  leaf := env.techn.throwaway_layer.layer_name;
	    if is_filled
	     then combo := leaf #xor# leaf	-- features everywhere
	     else combo := leaf #minus# leaf	-- no features at all
	    end;
	    Result := combo.compile(env)	-- and compile him in my stead
	end;

feature	-- hash_code

	hash_code: INTEGER is
	do  Result := out.hash_code
	end;

feature	-- cats_expr_holder stuff

	holds(ce: CATS_EXPRESSION): BOOLEAN is 
	do  -- Result := false
	end;

	register_all_exprs2(ce_opt: CATS_EXPR_OPTIMIZER; stmt_no: INTEGER) is
	do  -- nada
	end;

	replace(olde, newe: CATS_EXPRESSION) is
	do  -- not callable
	end;

feature {NONE} -- creation

	make_blank is
	do  is_filled := false
	end;

	make_fill is
	do  is_filled := true
	end;

end -- CATS_EXPR_LEAF
