class CATS_EXPRESSION_SUPPORT
	-- stuff needed by clients of CATS_STATEMENT and/or
	-- CATS_EXPRESSION to aid in the creation of said statements
	-- and expressions.

inherit
	STRING_UTILITIES_ACCESS

feature	-- blank and fill leaves

	emptiness: CATS_EXPR_SOLID is
	once create Result.make_blank
	end;

	fullness: CATS_EXPR_SOLID is
	once create Result.make_fill
	end;

feature	-- cats statement creation

	clevel(src: CATS_EXPRESSION; lvl: STRING; res: DOUBLE):
				CATS_LEVEL_FRACTURE is
	do  create Result.make(src, lvl, res)
	end;

	ctemp(src: CATS_EXPRESSION; plyr: STRING; res: DOUBLE):
				CATS_TEMP_FRACTURE is
		-- plyr is a pseudo-layer that is henceforth
		-- available as leaf (lyr) operand
		-- use res = 0 to have it calculated
	do  create Result.make(src, plyr, res)
	end;

	carea(src: CATS_EXPRESSION; plyr: STRING; res: DOUBLE): 
				CATS_AREA_MEASUREMENT is
		-- measure the area / density of src
	do  create Result.make(src, plyr, res)
	end;

	cextent(layer: STRING; res: DOUBLE):
				CATS_EXTENT_MEASUREMENT is
		-- measure the extent of the layer
	do  create Result.make(layer, res)
	end;

feature	-- selector creators

	rectilinear: STRING is "rectilinear"

	norectilinear: STRING is "norectilinear"

	maxhw(lo, hi: DOUBLE): STRING is
		-- maxhw <range of values for max of h and w>
	do  Result := su.string_of_4
			("maxhw ", lo.out, " ", hi.out)
	end;

end -- CATS_EXPRESSION_SUPPORT
