deferred class CATS_FILE_CONSUMER
	-- a consumer of the output of a CATS_SCRIPT_STEP

feature	-- attributes of a script_step output consumer

	my_producer: CATS_SCRIPT_STEP
		-- the step whose output I am consuming;
		-- if Void, the input is not a script step output

	my_step: CATS_SCRIPT_STEP is
		-- the step in which I am consuming the file
		-- (never Void, except in CATS_OP_FILE template)
	deferred
	end;

	resolution_reqd: DOUBLE is
		-- the resolution that I need from this file
		-- (0 = unknown / indefinite)
	deferred
	end;

	processed: BOOLEAN is
		-- has my consumption of the file been processed yet?
	deferred
	end;

feature	-- update

	set_my_producer(stp: CATS_SCRIPT_STEP) is
		-- cross link me and my producer
	require stp /= Void
	do  my_producer := stp
	    stp.add_consumer(Current)
	ensure my_producer = stp
	end;

end -- CATS_FILE_CONSUMER
