class CATS_READGDS_STEP
	-- step to run readfile to produce a .clib file from a .gds file

inherit
	CATS_SCRIPT_STEP

create
	make

feature	-- the mandatory attributes of each step

	step_type: STRING is "READGDS"
		-- the (fixed) name of this type of step

	command_line: STRING is "readfile"

	input1: STRING
		-- the first input file is the gds file

	input2: STRING
		-- the second input file is not used (remains Void)

	write_input_to_script(sfil: LARGE_PLAIN_TEXT_FILE) is
		-- script for readfile: just the two file names
	do  add_a_line(sfil, input1, Void);	-- gds file
	    add_a_line(sfil, output, Void);	-- clib file
	end;

feature {NONE} -- creation

	make(gds, clib: STRING) is
		-- the two file names, fully spelled out
	do  input1 := gds
	    output := clib;
	    output_is_temp := true
	end;

end -- CATS_READGDS_STEP
