class CATS_TEMP_FRACTURE
	-- fracture to an explicit temporary flat file, which can
	-- then be a leaf in later expressions 
inherit
	CATS_STATEMENT

create
	make

feature	-- compilation

	compile_prolog is
	do
	end;

	compile_statement(cop: CATS_OPERATION): CATS_OPERATION is
		-- cop is the final producer of our data
	local fnam: STRING 
	do  fnam := my_env.explicit_temp_name
				(su.empty_value(mebes_ext,
						layer_level_name));
	    cop.set_output_explicit(fnam, layer_level_name);
	    cop.set_command(cmd_is_do);
	    Result := cop
	end;

feature	-- creation

	make(src: CATS_EXPRESSION; plyr: STRING; res: DOUBLE) is
	require have_src: src /= Void
	do  source := src;
	    layer_level_name := plyr;
	    resolution := res	-- use 0 to have it calculated
	    statement_name := su.string_of_2("fracturing (temp) ", plyr);
	end;

end -- CATS_TEMP_FRACTURE
