class CATS_WRITEMEBES_STEP
	-- step to run writefile to produce a mebes file from a .cflt file

inherit
	CATS_SCRIPT_STEP

	CATS_FILE_CONSUMER

create
	make

feature	-- the mandatory attributes of each step

	step_type: STRING is "WRITEMEBES"
		-- the (fixed) name of this type of step

	command_line: STRING is "writefile"

	input1: STRING
		-- the first input file is the .cflt

	input2: STRING
		-- the second input file is not used (remains Void)

	write_input_to_script(sfil: LARGE_PLAIN_TEXT_FILE) is
		-- script for writefile: just the two file names
	do  add_a_line(sfil, input1, Void);	-- .cflt file
	    add_a_line(sfil, output, Void);	-- mebes file
	end;

feature	-- cats_file_consumer stuff

	my_step: CATS_WRITEMEBES_STEP is
		-- I am my own step
	do  Result := Current
	end;

	resolution_reqd: DOUBLE is
	do	-- (0 = unknown / indefinite)
	end;

feature {NONE} -- creation

	make(cflt, mbs: STRING) is
		-- the two file names, fully spelled out
	do  input1 := cflt;
	    output := mbs;
	    output_is_temp := false;	-- usually mebes is to be saved
	end;

end -- CATS_WRITEMEBES_STEP
