
indexing
	
	description: "Action to take for elements that are test vehicles %
		%during validity checking"
	author: "David Hollenberg"
	date: "October 1, 2006"

class CHECK_TEST_VEHICLE_ACTION
inherit
	VIEW_ELEMENT_ACTION

feature -- Properties

	rotated_0_count: INTEGER
			-- Number of test vehicles rotated 0 degrees clockwise
	
	rotated_90_count: INTEGER
			-- Number of test vehicles rotated 90 degrees clockwise
	
	rotated_180_count: INTEGER
			-- Number of test vehicles rotated 180 degrees clockwise
	
	rotated_270_count: INTEGER
			-- Number of test vehicles rotated 270 degrees clockwise
	
feature -- Operations

	initialize
		do
			rotated_0_count := 0
			rotated_90_count := 0
			rotated_180_count := 0
			rotated_270_count := 0
		end

	apply (an_element: RETICLE_VIEW_ELEMENT)
			-- Apply action to `an_element'
		do
			if not an_element.is_processed and an_element.intersects_any_field then
				an_element.set_processed
				inspect an_element.rotation
				when 0 then
					rotated_0_count := rotated_0_count + 1
				when 90 then
					rotated_90_count := rotated_90_count + 1
				when 180 then
					rotated_180_count := rotated_180_count + 1
				when 270 then
					rotated_270_count := rotated_270_count + 1
				end
			end
		end

end
