class CHECKSUM_PAIR

inherit
	DOUBLE_MATH
	redefine out
	end;

create
	make

feature	-- pair of numbers comprising a checksum

	checksum: DOUBLE

	byte_count: DOUBLE

	-- NOTE: two checksum_pairs can be compared with standard equal

feature	-- validation

	is_valid_checksum_value(d: DOUBLE): BOOLEAN is
		-- valid iff >= 0 and integral
	do  Result := (d >= 0) and (d = floor(d))
	end;

feature -- status

	is_zero: BOOLEAN is
	do  Result := checksum = 0 and byte_count = 0
	end;

feature -- creation (or re-use)

	make(csum, bcnt: DOUBLE) is
	require valid_checksum:   is_valid_checksum_value(csum);
		valid_byte_count: is_valid_checksum_value(bcnt)
	do  checksum   := csum;
	    byte_count := bcnt
	ensure checksum = csum and byte_count = bcnt
	end;

feature -- default depiction

	out: STRING is
	do  create Result.make(24);
	    Result.append_double(checksum);
	    Result.extend(',');
	    Result.extend(' ');
	    Result.append_double(byte_count);
	end;

end -- CHECKSUM_PAIR
