class	CIF_FILE_OPTIONS
	-- common stuff for the cif_file_reader and cif_file_writer

feature -- constants

	one_centimicron: DOUBLE is 0.00000001
		-- 10 ^ -8 meters, the standard cif unit

feature -- options

	symbol_name_command: STRING
		-- cif user command to hold symbol symbolic names

	set_symbol_name_command(n: INTEGER) is
		-- cif user command to name each symbol
		-- (zero or negative value turns off naming)
	do  if n <= 0
	     then symbol_name_command := Void
	     else symbol_name_command := n.out
	    end
	end;

	port_name_command: STRING
		-- cif user command to specify ports
		-- syntax is
		--  <port_name_command> <word> <point> <layer>;
		--  where word is the port name, point is its center, and
		--	layer is its layer name

	set_port_name_command(n: INTEGER) is
		-- cif user command to name each port
		-- (zero or negative value turns off naming)
	do  if n <= 0
	     then port_name_command := Void
	     else port_name_command := n.out
	    end
	end;

end -- CIF_FILE_OPTIONS
