
indexing
	
	description: "Object that can generate colors for an %
		%element of a reticle view according to whether the element %
		%has an edge that is too close to the corresponding edge of %
		%its associated field"
	author: "David Hollenberg"
	date: "December 8, 2006"

class CLOSE_TO_EDGE_COLOR_GENERATOR
inherit
	SCRIBES_INCLUDABLE_COLOR_GENERATOR

create
	make

feature -- Access

	border_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Foreground color for border (usually a
			-- rectangle) of `an_element'
		do
			Result := standard_color (an_element)
		end
	
	label_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Foreground color for label
		do
			Result := standard_color (an_element)
		end
	
feature {NONE} -- Implementation

	standard_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Standard color for `an_element'
		do
			if not an_element.is_selectable then
				Result := palette.unselectable_color
			elseif an_element.is_too_close_to_field_edge and (scribes_included or an_element.is_non_scribe) then
				Result := palette.too_close_to_edge_color
			else
				Result := palette.no_validity_issues_color
			end
		end
	
end
