
indexing
	
	description: "Action that computes whether element is fixed or locked %
		%in X and/or Y"
	author: "David Hollenberg"
	date: "October 31, 2006"

class COMPUTE_FIXED_AND_LOCKED_ACTION
inherit
	VIEW_ELEMENT_ACTION

feature -- Properties

	has_fixed_element: BOOLEAN
			-- Are any of the elements examined so far fixed in
			-- X or Y?

	has_locked_element: BOOLEAN
			-- Are any of the elements examined so far locked in
			-- X or Y?

feature -- Operations

	initialize
		do
			has_fixed_element := False
			has_locked_element := False
		end

	apply (an_element: RETICLE_VIEW_ELEMENT)
			-- Apply action to `an_element'
		do
			if (an_element.is_fixed_in_x and an_element.is_movable_in_x) or (an_element.is_fixed_in_y and an_element.is_movable_in_y) then
				has_fixed_element := True
			end
			if (an_element.is_locked_in_x and not an_element.is_stationary_in_x) or (an_element.is_locked_in_y and not an_element.is_stationary_in_y) then
				has_locked_element := True
			end
		end

end
