
indexing

	date: "Tue Apr 24 10:30:09 2007"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application NFE, database user DHOLLEN"
	database_tables: 
		"CONTACTS (MOSIS.CONTACTS)"
			-- Included columns
			-- 	COMMENTS
			-- 	CONTACT_NO
			-- 	DIV_NO
			-- 	FIRST_NAME
			-- 	LAST_NAME
			-- 	MID_NAME
			-- 	NET_ADDRESS
			-- 	ORG_NO
			-- 	PREFERRED_NAME
			-- 	PREFIX (appellation)
			-- 	PRONUNCIATION
			-- 	SUFFIX
			-- 	TITLE
			-- Excluded columns
			-- 	(none)

class CONTACTS_RAW

inherit

	DB_IDENTIFIED_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_contact_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			contact_no := the_contact_no
			is_null_contact_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 13

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  comments, contact_no, div_no, first_name, last_name, mid_name,%N  net_address, org_no, preferred_name, prefix, pronunciation, suffix, title"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "contacts con"

	join_condition: STRING = ""

	table_name: STRING = "contacts"

	key_where_clause: STRING = "contact_no = :1"

feature -- Values

	comments: STRING
			-- DB: VARCHAR2(255)

	contact_no: INTEGER
			-- DB: NUMBER(6,0) not null

	div_no: INTEGER
			-- DB: NUMBER(6,0)

	first_name: STRING
			-- DB: VARCHAR2(30)

	last_name: STRING
			-- DB: VARCHAR2(30)

	mid_name: STRING
			-- DB: VARCHAR2(30)

	net_address: STRING
			-- DB: VARCHAR2(300)

	org_no: INTEGER
			-- DB: NUMBER(6,0) not null

	preferred_name: STRING
			-- DB: VARCHAR2(30)

	appellation: STRING
			-- DB: prefix VARCHAR2(15)

	pronunciation: STRING
			-- DB: VARCHAR2(50)

	suffix: STRING
			-- DB: VARCHAR2(15)

	title: STRING
			-- DB: VARCHAR2(38)

feature -- Nullness for null allowed columns

	is_null_comments: BOOLEAN
	is_null_div_no: BOOLEAN
	is_null_first_name: BOOLEAN
	is_null_last_name: BOOLEAN
	is_null_mid_name: BOOLEAN
	is_null_net_address: BOOLEAN
	is_null_preferred_name: BOOLEAN
	is_null_appellation: BOOLEAN
	is_null_pronunciation: BOOLEAN
	is_null_suffix: BOOLEAN
	is_null_title: BOOLEAN

feature -- Nullness for non-null columns

	is_null_contact_no: BOOLEAN
	is_null_org_no: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and contact_no = r.contact_no
			Result := Result
				and is_null_contact_no = r.is_null_contact_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and div_no = r.div_no
				and org_no = r.org_no
			Result := Result
				and equal (comments, r.comments)
				and equal (first_name, r.first_name)
				and equal (last_name, r.last_name)
				and equal (mid_name, r.mid_name)
				and equal (net_address, r.net_address)
				and equal (preferred_name, r.preferred_name)
				and equal (appellation, r.appellation)
				and equal (pronunciation, r.pronunciation)
				and equal (suffix, r.suffix)
				and equal (title, r.title)
			Result := Result
				and is_null_comments = r.is_null_comments
				and is_null_div_no = r.is_null_div_no
				and is_null_first_name = r.is_null_first_name
				and is_null_last_name = r.is_null_last_name
				and is_null_mid_name = r.is_null_mid_name
				and is_null_net_address = r.is_null_net_address
				and is_null_org_no = r.is_null_org_no
				and is_null_preferred_name = r.is_null_preferred_name
				and is_null_appellation = r.is_null_appellation
				and is_null_pronunciation = r.is_null_pronunciation
				and is_null_suffix = r.is_null_suffix
				and is_null_title = r.is_null_title
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 255)
			q.select_integer (2)
			q.select_integer (3)
			q.select_string (4, 30)
			q.select_string (5, 30)
			q.select_string (6, 30)
			q.select_string (7, 300)
			q.select_integer (8)
			q.select_string (9, 30)
			q.select_string (10, 15)
			q.select_string (11, 50)
			q.select_string (12, 15)
			q.select_string (13, 38)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			contact_no := q.integer_value (2)
			div_no := q.integer_value (3)
			org_no := q.integer_value (8)
		end

	fill_in_references (q: SQL_QUERY)
		do
			comments := q.string_value (1)
			first_name := q.string_value (4)
			last_name := q.string_value (5)
			mid_name := q.string_value (6)
			net_address := q.string_value (7)
			preferred_name := q.string_value (9)
			appellation := q.string_value (10)
			pronunciation := q.string_value (11)
			suffix := q.string_value (12)
			title := q.string_value (13)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, comments)
			q.get_string_value (4, first_name)
			q.get_string_value (5, last_name)
			q.get_string_value (6, mid_name)
			q.get_string_value (7, net_address)
			q.get_string_value (9, preferred_name)
			q.get_string_value (10, appellation)
			q.get_string_value (11, pronunciation)
			q.get_string_value (12, suffix)
			q.get_string_value (13, title)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_comments := q.is_null (1)
			is_null_contact_no := q.is_null (2)
			is_null_div_no := q.is_null (3)
			is_null_first_name := q.is_null (4)
			is_null_last_name := q.is_null (5)
			is_null_mid_name := q.is_null (6)
			is_null_net_address := q.is_null (7)
			is_null_org_no := q.is_null (8)
			is_null_preferred_name := q.is_null (9)
			is_null_appellation := q.is_null (10)
			is_null_pronunciation := q.is_null (11)
			is_null_suffix := q.is_null (12)
			is_null_title := q.is_null (13)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_contact_no := True
		end

	set_null_nonkey
		do
			is_null_comments := True
			is_null_div_no := True
			is_null_first_name := True
			is_null_last_name := True
			is_null_mid_name := True
			is_null_net_address := True
			is_null_org_no := True
			is_null_preferred_name := True
			is_null_appellation := True
			is_null_pronunciation := True
			is_null_suffix := True
			is_null_title := True
			create comments.make (0)
			create first_name.make (0)
			create last_name.make (0)
			create mid_name.make (0)
			create net_address.make (0)
			create preferred_name.make (0)
			create appellation.make (0)
			create pronunciation.make (0)
			create suffix.make (0)
			create title.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_integer (1, contact_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and contact_no = q.integer_value (2)
				and div_no = q.integer_value (3)
				and org_no = q.integer_value (8)
			q.get_string_value (1, s)
			Result := Result and equal (comments, s)
			q.get_string_value (4, s)
			Result := Result and equal (first_name, s)
			q.get_string_value (5, s)
			Result := Result and equal (last_name, s)
			q.get_string_value (6, s)
			Result := Result and equal (mid_name, s)
			q.get_string_value (7, s)
			Result := Result and equal (net_address, s)
			q.get_string_value (9, s)
			Result := Result and equal (preferred_name, s)
			q.get_string_value (10, s)
			Result := Result and equal (appellation, s)
			q.get_string_value (11, s)
			Result := Result and equal (pronunciation, s)
			q.get_string_value (12, s)
			Result := Result and equal (suffix, s)
			q.get_string_value (13, s)
			Result := Result and equal (title, s)
			Result := Result
				and is_null_comments = q.is_null (1)
				and is_null_contact_no = q.is_null (2)
				and is_null_div_no = q.is_null (3)
				and is_null_first_name = q.is_null (4)
				and is_null_last_name = q.is_null (5)
				and is_null_mid_name = q.is_null (6)
				and is_null_net_address = q.is_null (7)
				and is_null_org_no = q.is_null (8)
				and is_null_preferred_name = q.is_null (9)
				and is_null_appellation = q.is_null (10)
				and is_null_pronunciation = q.is_null (11)
				and is_null_suffix = q.is_null (12)
				and is_null_title = q.is_null (13)
		end

end
