deferred class CONTENT_TYPE_CACHE
	-- class to fetch or select my content_types_row
	-- based on my content_type_id, and hang on to it

inherit
	ANY
	DB_QUERY_OPTIONS
	export {NONE} all end;

feature	-- the deferred stuff we need to function

	connection: DB_CONNECTION
	deferred
	end;

	content_type_id: STRING
	deferred
	end;

feature	-- fetch and select routines

	content_type: CONTENT_TYPES_ROW
		-- the content_types row for my content_type_id
	do  if cached_content_type = Void or else
	       (not equal(cached_content_type.content_type_id, 
						content_type_id))
	     then create cached_content_type.make_by_key(
				connection, old_row, content_type_id)
	    end
	    Result := cached_content_type
	end;

	select_content_type(ctyps: LIST[CONTENT_TYPES_ROW])
		-- pick my row out of a master list (clear entry if not found)
	do  cached_content_type := Void
	    if ctyps /= Void then
		from  ctyps.start
		until ctyps.after or cached_content_type /= Void
		loop  if equal (ctyps.item.content_type_id,
						content_type_id)
			then cached_content_type := ctyps.item
		      end;
		      ctyps.forth
		end
	    end
	end;

feature {NONE} -- cached row

	cached_content_type: CONTENT_TYPES_ROW

end -- CONTENT_TYPE_CACHE
