class CONTENT_TYPES_ROW

inherit
	CONTENT_TYPES_RAW

	FILE_UTILITIES_ACCESS

create

	make_template, make_null, make_by_key

feature	-- pick a row based on a file name

	content_type_for_filename (conn: DB_CONNECTION; fname: STRING): like Current is
		-- find (longest) match on tail of fname vs filename_suffix
		-- matching is case-independent
		-- Void if no match
		--  (if UNKNOWN is in the table, there will always be a match)
	require connection_exists: conn /= Void
		file_name_exists: fname /= Void
	local b: DB_BIND_S; lst: LIST[like Current]
	do  create b.make (fu.file_name_part (fname))
	    lst := all_rows_filtered_ordered
				(conn,
				 "lower(:1) like '%%'||lower(filename_suffix)", b,
				 "nvl(length(filename_suffix),0)")
	    if not lst.is_empty then
		Result := lst.last
	    end
	end;

end -- CONTENT_TYPES_ROW
