
indexing
	
	description: "Action that converts view element that is locked in X %
		%and/or Y to be fixed in that dimension instead"
	author: "David Hollenberg"
	date: "October 5, 2006"

class CONVERT_LOCKED_TO_FIXED_ACTION
inherit
	VIEW_ELEMENT_ACTION

feature -- Operations

	apply (an_element: RETICLE_VIEW_ELEMENT)
			-- Apply action to `an_element'
		local
			changed: BOOLEAN
			chg_fixed_x, chg_fixed_y, chg_locked_x, chg_locked_y: BOOLEAN
		do
			changed := False
			if an_element.is_locked_in_x and not an_element.is_stationary_in_x then
				an_element.unlock_in_x
				an_element.fix_in_x
				chg_fixed_x := an_element.is_fixed_in_x_changed
				chg_locked_x := an_element.is_movable_in_x_changed
				changed := changed or chg_fixed_x or chg_locked_x
			end
			if an_element.is_locked_in_y and not an_element.is_stationary_in_y then
				an_element.unlock_in_y
				an_element.fix_in_y
				chg_fixed_y := an_element.is_fixed_in_y_changed
				chg_locked_y := an_element.is_movable_in_y_changed
				changed := changed or chg_fixed_y or chg_locked_y
			end
			if changed then
				an_element.add_to_changed_region
				an_element.add_change (create {CONVERT_LOCKED_TO_FIXED_CHANGE}.make (an_element, chg_fixed_x, chg_fixed_y, chg_locked_x, chg_locked_y))
			end
		end

end
