
indexing
	
	description: "A run closing step operation that creates file(s) %
		%to be sent to mask shop, usually by zip or tar and gzip"
	author: "David Hollenberg"
	date: "May 26, 2004"

class CREATE_MASK_SHOP_FILES_OP
inherit
	RC_PRIMITIVE_STEP_OP
	RC_APPLICABLE_STEP
	NO_USER_INTERFACE
	NO_EXTERNAL_STATE

create
	make

feature -- Properties

	input_data_items: LIST [STRING]
			-- Data items required before step can be executed
		do
			Result := array_as_list (<<
					data_item.Assembled_run
				 >>)
		end

feature {NONE} -- Implementation

	do_step
			-- Execute step
		local
			style: PATTERN_FILE_RENAMING_STYLE_VALUES
			renaming_style, msg: STRING
		do
			renaming_style := cache.pattern_file_renaming_style
			msg := "For many runs, the files we need to send to the mask shop (job file, MEBES files or GDS files)%Nmust be packaged into a single file (usually a .zip or .tar.gz file).  Have you created this file?" + "%N%N" + "Answer %"Yes%" if not applicable to this run."
			if renaming_style.is_equal (style.Ami_part_nos) then
				msg.append ("%N%NIMPORTANT: Be sure to send renamed pattern files " + ami_pattern_file_root + ".*")
			elseif renaming_style.is_empty then
				-- Don't add reminder about renamed files
			else
				handle_hard_error ("unknown pattern file renaming style " + renaming_style)
			end
			
			if question (msg) then
			else
				abort
			end
			call_completion_actions
		end

	undo_step
			-- Undo execution of step
		do
			call_completion_actions
		end

	set_state
			-- Set `state'
		do
			state := Void
		end

	ami_pattern_file_root: STRING
			-- Root pattern file name when AMI part number
			-- style renaming is used
		local
			row: PATTERN_FILES_ROW
		do
			create row.make_template
			Result := row.final_rows_for_run (session.run_id, connection, expected_count.At_least_one).first.renamed_pattern_filename.substring (1, 9)
		end

end
