
indexing
	
	description: "A run closing step operation that creates a %
		%job file used to merge individual pattern files into %
		%one pattern file per mask level/field combination"
	author: "David Hollenberg"
	date: "July 15, 2004"

class CREATE_MERGE_JOB_FILE_OP
inherit
	CREATE_JOB_FILE_OP
		redefine
			job_deck
		end

create
	make

feature -- Properties

	input_data_items: LIST [STRING]
			-- Data items required before step can be executed
		do
			Result := array_as_list (<<
				data_item.Mask_techn,
				data_item.Wafer_techn,
				data_item.Wafer_part_id,
				data_item.Assigned_die_ids,
				data_item.Test_vehicle_fab_instances
				 >>)
		end

feature {NONE} -- Implementation

	is_applicable: BOOLEAN
			-- Is step applicable to run for session?
		do
			Result := cache.run_needs_merge
		end

	job_file: RC_FILE
			-- Job file to be written
		do
			Result := file_generator.merge_job_file
		end

	create_job_deck
			-- Create `job_deck' with appropriate type of job deck
		do
			create {MERGE_JOB_FILE} job_deck
		end

	set_job_titles_and_orientations
			-- Set any need titles and title orientations in
			-- `job_deck'
		do
		end

	set_job_canned_lines
			-- Set any needed prolog or epilog canned lines in
			-- `job_deck'
		do
		end

	add_merged_chips
			-- Add chips that refer to merged pattern files
		do
		end

	set_chip_locations (row: DIE_ATTRIBUTES_ROW)
			-- Set `chip_locations' for `row'
		do
			chip_locations := cache.all_mask_locations_for_die (row)
			if chip_locations.is_empty then
				handle_hard_error ("no locations on mask for die id " + row.die_id)
			end
		end

	reverse_tone (polarity: STRING): BOOLEAN
			-- Should mask level with `polarity' be written
			-- in reverse tone?
		do
			Result := False
		end

	job_deck: MERGE_JOB_FILE
			-- Job deck to be created

end
