
indexing
	
	description: "Change that creates or deletes an element that is a die"
	author: "David Hollenberg"
	date: "January 25, 2007"

deferred class CREATION_OR_DELETION_CHANGE
inherit
	RETICLE_SIMPLE_CHANGE
		redefine
			parent
		end

feature -- Properties

	parent: RETICLE_CREATION_OR_DELETION_CHANGE
			-- Change that includes this simple change

feature -- Operations

	create_element
			-- Create element
		local
			l_model_element: RETICLE_DIE
		do
			set_die_and_location
			l_model_element ?= model_element
			check
				l_model_element_not_void: l_model_element /= Void
			end
			if not model.copies_table_has (l_model_element) then
				die.set_die_locations (create {ARRAYED_LIST [PACKING_DIE_LOCATIONS_MROW]}.make (0))
				model.current_version.add_new_die (die)
			end
			die.add_existing_die_location (die_location)
			model.add_existing_element (l_model_element)
			view.set_all_copies_list (element)
			element.unmark
			view.elements.extend (element)
		end

	partially_delete_element
			-- Partially delete element (not all copies deleted)
		do
			set_die_and_location
			element.remove_from_all_copies
			die.remove_die_location (die_location)
			element.mark
		end

	fully_delete_element
			-- Fully delete element (all copies deleted)
		do
			set_die_and_location
			parent.add_fully_deleted_die (die)
			parent.add_fully_deleted_element (element)
			element.mark
		end

feature {NONE} -- Implementation

	set_die_and_location
			-- Set `die' and `die_location'
		local
			m: like model_element
		do
			m := model_element
			die := m.die
			die_location := m.die_location
		end

	die: PACKING_DIES_MROW
	
	die_location: PACKING_DIE_LOCATIONS_MROW
end
