
indexing
	
	description: "Change that sets width for subsequently created %
		%horizontal or vertical scribes"
	author: "David Hollenberg"
	date: "January 25, 2007"

class CURRENT_SCRIBE_WIDTHS_CHANGE
inherit
	RETICLE_SIMPLE_CHANGE
		rename
			make as simple_make
		export
			{NONE} simple_make
		end

create
	make

feature {NONE} -- Creation

	make (a_view: RETICLE_VIEW an_old_horizontal_width, an_old_vertical_width, a_new_horizontal_width, a_new_vertical_width, a_default_width: DOUBLE a_packing: RC_PACKING)
		do
			current_view := a_view
			old_horizontal_width := an_old_horizontal_width
			old_vertical_width := an_old_vertical_width
			new_horizontal_width := a_new_horizontal_width
			new_vertical_width := a_new_vertical_width
			default_width := a_default_width
			packing := a_packing
		end

feature -- Properties

	current_view: RETICLE_VIEW
			-- View to which change was made

	old_horizontal_width: DOUBLE
			-- Horizontal scribe width before change

	old_vertical_width: DOUBLE
			-- Vertical scribe width before change

	new_horizontal_width: DOUBLE
			-- Horizontal scribe width after change

	new_vertical_width: DOUBLE
			-- Vertical scribe width after change

	default_width: DOUBLE
			-- Default scribe width

	packing: RC_PACKING
			-- Packing (where scribe widths are saved
			-- if they change)

feature -- Operations

	undo
			-- Undo change
		do
			current_view.set_custom_horizontal_scribe_width (old_horizontal_width)
			current_view.set_custom_vertical_scribe_width (old_vertical_width)
			packing.save_new_scribe_widths (new_horizontal_width, new_vertical_width, old_horizontal_width, old_vertical_width, default_width)
		end

	redo
			-- Redo change
		do
			current_view.set_custom_horizontal_scribe_width (new_horizontal_width)
			current_view.set_custom_vertical_scribe_width (new_vertical_width)
			packing.save_new_scribe_widths (old_horizontal_width, old_vertical_width, new_horizontal_width, new_vertical_width, default_width)
		end

end
