
indexing

	date: "Tue Dec 18 11:35:30 2007"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application NFE, database user ALLMOSIS"
	database_tables: 
		"CUST_ACCT_PASSWORDS (MOSIS.CUST_ACCT_PASSWORDS)"
			-- Included columns
			-- 	CUST_ACCT_NO
			-- 	DATE_PASSWORD_EXPIRES
			-- 	PASSWORD
			-- 	PASSWORD_TYPE
			-- Excluded columns
			-- 	(none)

class CUST_ACCT_PASSWORDS_RAW

inherit

	DB_IDENTIFIED_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_cust_acct_no: INTEGER; the_password_type: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_password_type_exists: the_password_type /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			cust_acct_no := the_cust_acct_no
			password_type := the_password_type
			is_null_cust_acct_no := False
			is_null_password_type := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 4

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  cust_acct_no, date_password_expires, password, password_type"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "cust_acct_passwords capw"

	join_condition: STRING = ""

	table_name: STRING = "cust_acct_passwords"

	key_where_clause: STRING = "cust_acct_no = :1 and password_type = :2"

feature -- Values

	cust_acct_no: INTEGER
			-- DB: NUMBER(6,0) not null

	date_password_expires: DB_DATE
			-- DB: DATE

	password: STRING
			-- DB: VARCHAR2(50)

	password_type: STRING
			-- DB: VARCHAR2(15) not null

feature -- Nullness for null allowed columns

	is_null_date_password_expires: BOOLEAN
	is_null_password: BOOLEAN

feature -- Nullness for non-null columns

	is_null_cust_acct_no: BOOLEAN
	is_null_password_type: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and cust_acct_no = r.cust_acct_no
			Result := Result
				and equal (password_type, r.password_type)
			Result := Result
				and is_null_cust_acct_no = r.is_null_cust_acct_no
				and is_null_password_type = r.is_null_password_type
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (date_password_expires, r.date_password_expires)
				and equal (password, r.password)
			Result := Result
				and is_null_date_password_expires = r.is_null_date_password_expires
				and is_null_password = r.is_null_password
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_integer (1)
			q.select_date (2)
			q.select_string (3, 50)
			q.select_string (4, 15)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			cust_acct_no := q.integer_value (1)
		end

	fill_in_references (q: SQL_QUERY)
		do
			date_password_expires := q.date_value (2)
			password := q.string_value (3)
			password_type := q.string_value (4)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_date_value (2, date_password_expires)
			q.get_string_value (3, password)
			q.get_string_value (4, password_type)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_cust_acct_no := q.is_null (1)
			is_null_date_password_expires := q.is_null (2)
			is_null_password := q.is_null (3)
			is_null_password_type := q.is_null (4)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_cust_acct_no := True
			is_null_password_type := True
			create password_type.make (0)
		end

	set_null_nonkey
		do
			is_null_date_password_expires := True
			is_null_password := True
			create {ORACLE_DATE} date_password_expires.set_null
			create password.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_integer (1, cust_acct_no, False)
			q.bind_num_to_string (2, password_type, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
			d: DB_DATE
		do
			s := temp_string
			d := temp_date
			Result := True
			Result := Result
				and cust_acct_no = q.integer_value (1)
			q.get_date_value (2, d)
			Result := Result and equal (date_password_expires, d)
			q.get_string_value (3, s)
			Result := Result and equal (password, s)
			q.get_string_value (4, s)
			Result := Result and equal (password_type, s)
			Result := Result
				and is_null_cust_acct_no = q.is_null (1)
				and is_null_date_password_expires = q.is_null (2)
				and is_null_password = q.is_null (3)
				and is_null_password_type = q.is_null (4)
		end

end
