
indexing

	date: "Tue Dec 18 11:35:30 2007"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application NFE, database user ALLMOSIS"
	database_tables: 
		"CUST_ACCTS (MOSIS.CUST_ACCTS)"
			-- Included columns
			-- 	ACCT_PRICING_CLASS
			-- 	ACCT_SPONSOR_ID
			-- 	ACCT_SUB_TYPE
			-- 	ACCT_TYPE
			-- 	COMMENTS
			-- 	COUNTRY
			-- 	CUST_ACCT_NO
			-- 	DATE_ACCT_CREATED
			-- 	DATE_ACCT_DELINQUENT
			-- 	DATE_ACCT_EXPIRES
			-- 	DATE_ACCT_ON_HOLD
			-- 	DATE_LAST_DOC_ACCESS_MSG_SENT
			-- 	DATE_LAST_PASSWORD_MSG_SENT
			-- 	DATE_REACTIVATED
			-- 	DISCOUNT_FRACTION
			-- 	DIV_NO
			-- 	DOCUMENT_ACCESS_GRACE_DAYS
			-- 	IC_PREP_FRACTION
			-- 	IS_TRF_OK
			-- 	ORG_NO
			-- 	PAYMENT_GRACE_DAYS
			-- 	REDIRECTED_CUST_ACCT_NO
			-- 	TERMS_PAYMENT_DAYS
			-- 	WATERMARK_DOCUMENTS
			-- Excluded columns
			-- 	DATE_LAST_NOTIFY_MSG_SENT

class CUST_ACCTS_RAW

inherit

	DB_IDENTIFIED_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_cust_acct_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			cust_acct_no := the_cust_acct_no
			is_null_cust_acct_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 24

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  acct_pricing_class, acct_sponsor_id, acct_sub_type, acct_type, comments,%N  country, cust_acct_no, date_acct_created, date_acct_delinquent,%N  date_acct_expires, date_acct_on_hold, date_last_doc_access_msg_sent,%N  date_last_password_msg_sent, date_reactivated, discount_fraction, div_no,%N  document_access_grace_days, ic_prep_fraction, is_trf_ok, org_no,%N  payment_grace_days, redirected_cust_acct_no, terms_payment_days,%N  watermark_documents"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "cust_accts ca"

	join_condition: STRING = ""

	table_name: STRING = "cust_accts"

	key_where_clause: STRING = "cust_acct_no = :1"

feature -- Values

	acct_pricing_class: STRING
			-- DB: VARCHAR2(10) not null

	acct_sponsor_id: STRING
			-- DB: VARCHAR2(20)

	acct_sub_type: STRING
			-- DB: VARCHAR2(20)

	acct_type: STRING
			-- DB: VARCHAR2(20) not null

	comments: STRING
			-- DB: VARCHAR2(2500)

	country: STRING
			-- DB: VARCHAR2(38) not null

	cust_acct_no: INTEGER
			-- DB: NUMBER(6,0) not null

	date_acct_created: DB_DATE
			-- DB: DATE not null

	date_acct_delinquent: DB_DATE
			-- DB: DATE

	date_acct_expires: DB_DATE
			-- DB: DATE

	date_acct_on_hold: DB_DATE
			-- DB: DATE

	date_last_doc_access_msg_sent: DB_DATE
			-- DB: DATE

	date_last_password_msg_sent: DB_DATE
			-- DB: DATE

	date_reactivated: DB_DATE
			-- DB: DATE

	discount_fraction: DOUBLE
			-- DB: NUMBER(*,*) not null

	div_no: INTEGER
			-- DB: NUMBER(6,0)

	document_access_grace_days: INTEGER
			-- DB: NUMBER(4,0)

	ic_prep_fraction: DOUBLE
			-- DB: NUMBER(*,*)

	is_trf_ok: BOOLEAN
			-- DB: CHAR(1) not null

	org_no: INTEGER
			-- DB: NUMBER(6,0) not null

	payment_grace_days: INTEGER
			-- DB: NUMBER(4,0)

	redirected_cust_acct_no: INTEGER
			-- DB: NUMBER(6,0)

	terms_payment_days: INTEGER
			-- DB: NUMBER(4,0) not null

	watermark_documents: BOOLEAN
			-- DB: CHAR(1)

feature -- Nullness for null allowed columns

	is_null_acct_sponsor_id: BOOLEAN
	is_null_acct_sub_type: BOOLEAN
	is_null_comments: BOOLEAN
	is_null_date_acct_delinquent: BOOLEAN
	is_null_date_acct_expires: BOOLEAN
	is_null_date_acct_on_hold: BOOLEAN
	is_null_date_last_doc_access_msg_sent: BOOLEAN
	is_null_date_last_password_msg_sent: BOOLEAN
	is_null_date_reactivated: BOOLEAN
	is_null_div_no: BOOLEAN
	is_null_document_access_grace_days: BOOLEAN
	is_null_ic_prep_fraction: BOOLEAN
	is_null_payment_grace_days: BOOLEAN
	is_null_redirected_cust_acct_no: BOOLEAN
	is_null_watermark_documents: BOOLEAN

feature -- Nullness for non-null columns

	is_null_acct_pricing_class: BOOLEAN
	is_null_acct_type: BOOLEAN
	is_null_country: BOOLEAN
	is_null_cust_acct_no: BOOLEAN
	is_null_date_acct_created: BOOLEAN
	is_null_discount_fraction: BOOLEAN
	is_null_is_trf_ok: BOOLEAN
	is_null_org_no: BOOLEAN
	is_null_terms_payment_days: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and cust_acct_no = r.cust_acct_no
			Result := Result
				and is_null_cust_acct_no = r.is_null_cust_acct_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and discount_fraction = r.discount_fraction
				and div_no = r.div_no
				and document_access_grace_days = r.document_access_grace_days
				and ic_prep_fraction = r.ic_prep_fraction
				and is_trf_ok = r.is_trf_ok
				and org_no = r.org_no
				and payment_grace_days = r.payment_grace_days
				and redirected_cust_acct_no = r.redirected_cust_acct_no
				and terms_payment_days = r.terms_payment_days
				and watermark_documents = r.watermark_documents
			Result := Result
				and equal (acct_pricing_class, r.acct_pricing_class)
				and equal (acct_sponsor_id, r.acct_sponsor_id)
				and equal (acct_sub_type, r.acct_sub_type)
				and equal (acct_type, r.acct_type)
				and equal (comments, r.comments)
				and equal (country, r.country)
				and equal (date_acct_created, r.date_acct_created)
				and equal (date_acct_delinquent, r.date_acct_delinquent)
				and equal (date_acct_expires, r.date_acct_expires)
				and equal (date_acct_on_hold, r.date_acct_on_hold)
				and equal (date_last_doc_access_msg_sent, r.date_last_doc_access_msg_sent)
				and equal (date_last_password_msg_sent, r.date_last_password_msg_sent)
				and equal (date_reactivated, r.date_reactivated)
			Result := Result
				and is_null_acct_pricing_class = r.is_null_acct_pricing_class
				and is_null_acct_sponsor_id = r.is_null_acct_sponsor_id
				and is_null_acct_sub_type = r.is_null_acct_sub_type
				and is_null_acct_type = r.is_null_acct_type
				and is_null_comments = r.is_null_comments
				and is_null_country = r.is_null_country
				and is_null_date_acct_created = r.is_null_date_acct_created
				and is_null_date_acct_delinquent = r.is_null_date_acct_delinquent
				and is_null_date_acct_expires = r.is_null_date_acct_expires
				and is_null_date_acct_on_hold = r.is_null_date_acct_on_hold
				and is_null_date_last_doc_access_msg_sent = r.is_null_date_last_doc_access_msg_sent
				and is_null_date_last_password_msg_sent = r.is_null_date_last_password_msg_sent
				and is_null_date_reactivated = r.is_null_date_reactivated
				and is_null_discount_fraction = r.is_null_discount_fraction
				and is_null_div_no = r.is_null_div_no
				and is_null_document_access_grace_days = r.is_null_document_access_grace_days
				and is_null_ic_prep_fraction = r.is_null_ic_prep_fraction
				and is_null_is_trf_ok = r.is_null_is_trf_ok
				and is_null_org_no = r.is_null_org_no
				and is_null_payment_grace_days = r.is_null_payment_grace_days
				and is_null_redirected_cust_acct_no = r.is_null_redirected_cust_acct_no
				and is_null_terms_payment_days = r.is_null_terms_payment_days
				and is_null_watermark_documents = r.is_null_watermark_documents
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 10)
			q.select_string (2, 20)
			q.select_string (3, 20)
			q.select_string (4, 20)
			q.select_string (5, 2500)
			q.select_string (6, 38)
			q.select_integer (7)
			q.select_date (8)
			q.select_date (9)
			q.select_date (10)
			q.select_date (11)
			q.select_date (12)
			q.select_date (13)
			q.select_date (14)
			q.select_double (15)
			q.select_integer (16)
			q.select_integer (17)
			q.select_double (18)
			q.select_boolean (19)
			q.select_integer (20)
			q.select_integer (21)
			q.select_integer (22)
			q.select_integer (23)
			q.select_boolean (24)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			cust_acct_no := q.integer_value (7)
			discount_fraction := q.double_value (15)
			div_no := q.integer_value (16)
			document_access_grace_days := q.integer_value (17)
			ic_prep_fraction := q.double_value (18)
			is_trf_ok := q.boolean_value (19)
			org_no := q.integer_value (20)
			payment_grace_days := q.integer_value (21)
			redirected_cust_acct_no := q.integer_value (22)
			terms_payment_days := q.integer_value (23)
			watermark_documents := q.boolean_value (24)
		end

	fill_in_references (q: SQL_QUERY)
		do
			acct_pricing_class := q.string_value (1)
			acct_sponsor_id := q.string_value (2)
			acct_sub_type := q.string_value (3)
			acct_type := q.string_value (4)
			comments := q.string_value (5)
			country := q.string_value (6)
			date_acct_created := q.date_value (8)
			date_acct_delinquent := q.date_value (9)
			date_acct_expires := q.date_value (10)
			date_acct_on_hold := q.date_value (11)
			date_last_doc_access_msg_sent := q.date_value (12)
			date_last_password_msg_sent := q.date_value (13)
			date_reactivated := q.date_value (14)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, acct_pricing_class)
			q.get_string_value (2, acct_sponsor_id)
			q.get_string_value (3, acct_sub_type)
			q.get_string_value (4, acct_type)
			q.get_string_value (5, comments)
			q.get_string_value (6, country)
			q.get_date_value (8, date_acct_created)
			q.get_date_value (9, date_acct_delinquent)
			q.get_date_value (10, date_acct_expires)
			q.get_date_value (11, date_acct_on_hold)
			q.get_date_value (12, date_last_doc_access_msg_sent)
			q.get_date_value (13, date_last_password_msg_sent)
			q.get_date_value (14, date_reactivated)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_acct_pricing_class := q.is_null (1)
			is_null_acct_sponsor_id := q.is_null (2)
			is_null_acct_sub_type := q.is_null (3)
			is_null_acct_type := q.is_null (4)
			is_null_comments := q.is_null (5)
			is_null_country := q.is_null (6)
			is_null_cust_acct_no := q.is_null (7)
			is_null_date_acct_created := q.is_null (8)
			is_null_date_acct_delinquent := q.is_null (9)
			is_null_date_acct_expires := q.is_null (10)
			is_null_date_acct_on_hold := q.is_null (11)
			is_null_date_last_doc_access_msg_sent := q.is_null (12)
			is_null_date_last_password_msg_sent := q.is_null (13)
			is_null_date_reactivated := q.is_null (14)
			is_null_discount_fraction := q.is_null (15)
			is_null_div_no := q.is_null (16)
			is_null_document_access_grace_days := q.is_null (17)
			is_null_ic_prep_fraction := q.is_null (18)
			is_null_is_trf_ok := q.is_null (19)
			is_null_org_no := q.is_null (20)
			is_null_payment_grace_days := q.is_null (21)
			is_null_redirected_cust_acct_no := q.is_null (22)
			is_null_terms_payment_days := q.is_null (23)
			is_null_watermark_documents := q.is_null (24)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_cust_acct_no := True
		end

	set_null_nonkey
		do
			is_null_acct_pricing_class := True
			is_null_acct_sponsor_id := True
			is_null_acct_sub_type := True
			is_null_acct_type := True
			is_null_comments := True
			is_null_country := True
			is_null_date_acct_created := True
			is_null_date_acct_delinquent := True
			is_null_date_acct_expires := True
			is_null_date_acct_on_hold := True
			is_null_date_last_doc_access_msg_sent := True
			is_null_date_last_password_msg_sent := True
			is_null_date_reactivated := True
			is_null_discount_fraction := True
			is_null_div_no := True
			is_null_document_access_grace_days := True
			is_null_ic_prep_fraction := True
			is_null_is_trf_ok := True
			is_null_org_no := True
			is_null_payment_grace_days := True
			is_null_redirected_cust_acct_no := True
			is_null_terms_payment_days := True
			is_null_watermark_documents := True
			create acct_pricing_class.make (0)
			create acct_sponsor_id.make (0)
			create acct_sub_type.make (0)
			create acct_type.make (0)
			create comments.make (0)
			create country.make (0)
			create {ORACLE_DATE} date_acct_created.set_null
			create {ORACLE_DATE} date_acct_delinquent.set_null
			create {ORACLE_DATE} date_acct_expires.set_null
			create {ORACLE_DATE} date_acct_on_hold.set_null
			create {ORACLE_DATE} date_last_doc_access_msg_sent.set_null
			create {ORACLE_DATE} date_last_password_msg_sent.set_null
			create {ORACLE_DATE} date_reactivated.set_null
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_integer (1, cust_acct_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
			d: DB_DATE
		do
			s := temp_string
			d := temp_date
			Result := True
			Result := Result
				and cust_acct_no = q.integer_value (7)
				and discount_fraction = q.double_value (15)
				and div_no = q.integer_value (16)
				and document_access_grace_days = q.integer_value (17)
				and ic_prep_fraction = q.double_value (18)
				and is_trf_ok = q.boolean_value (19)
				and org_no = q.integer_value (20)
				and payment_grace_days = q.integer_value (21)
				and redirected_cust_acct_no = q.integer_value (22)
				and terms_payment_days = q.integer_value (23)
				and watermark_documents = q.boolean_value (24)
			q.get_string_value (1, s)
			Result := Result and equal (acct_pricing_class, s)
			q.get_string_value (2, s)
			Result := Result and equal (acct_sponsor_id, s)
			q.get_string_value (3, s)
			Result := Result and equal (acct_sub_type, s)
			q.get_string_value (4, s)
			Result := Result and equal (acct_type, s)
			q.get_string_value (5, s)
			Result := Result and equal (comments, s)
			q.get_string_value (6, s)
			Result := Result and equal (country, s)
			q.get_date_value (8, d)
			Result := Result and equal (date_acct_created, d)
			q.get_date_value (9, d)
			Result := Result and equal (date_acct_delinquent, d)
			q.get_date_value (10, d)
			Result := Result and equal (date_acct_expires, d)
			q.get_date_value (11, d)
			Result := Result and equal (date_acct_on_hold, d)
			q.get_date_value (12, d)
			Result := Result and equal (date_last_doc_access_msg_sent, d)
			q.get_date_value (13, d)
			Result := Result and equal (date_last_password_msg_sent, d)
			q.get_date_value (14, d)
			Result := Result and equal (date_reactivated, d)
			Result := Result
				and is_null_acct_pricing_class = q.is_null (1)
				and is_null_acct_sponsor_id = q.is_null (2)
				and is_null_acct_sub_type = q.is_null (3)
				and is_null_acct_type = q.is_null (4)
				and is_null_comments = q.is_null (5)
				and is_null_country = q.is_null (6)
				and is_null_cust_acct_no = q.is_null (7)
				and is_null_date_acct_created = q.is_null (8)
				and is_null_date_acct_delinquent = q.is_null (9)
				and is_null_date_acct_expires = q.is_null (10)
				and is_null_date_acct_on_hold = q.is_null (11)
				and is_null_date_last_doc_access_msg_sent = q.is_null (12)
				and is_null_date_last_password_msg_sent = q.is_null (13)
				and is_null_date_reactivated = q.is_null (14)
				and is_null_discount_fraction = q.is_null (15)
				and is_null_div_no = q.is_null (16)
				and is_null_document_access_grace_days = q.is_null (17)
				and is_null_ic_prep_fraction = q.is_null (18)
				and is_null_is_trf_ok = q.is_null (19)
				and is_null_org_no = q.is_null (20)
				and is_null_payment_grace_days = q.is_null (21)
				and is_null_redirected_cust_acct_no = q.is_null (22)
				and is_null_terms_payment_days = q.is_null (23)
				and is_null_watermark_documents = q.is_null (24)
		end

end
