
indexing

	date: "Tue Apr 24 10:30:10 2007"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user DHOLLEN"
	database_tables: 
		"CUST_CHARGE_BREAKDOWNS (MOSIS.CUST_CHARGE_BREAKDOWNS)"
			-- Included columns
			-- 	AMOUNT_CHARGED
			-- 	M_ADJUSTMENT_NO
			-- 	M_COST_CATEGORY_ID
			-- 	M_CUST_CHARGE_NO
			-- Excluded columns
			-- 	(none)

class CUST_CHARGE_BREAKDOWNS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_m_cust_charge_no: INTEGER; the_m_adjustment_no: INTEGER; the_m_cost_category_id: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_m_cost_category_id_exists: the_m_cost_category_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			m_cust_charge_no := the_m_cust_charge_no
			m_adjustment_no := the_m_adjustment_no
			m_cost_category_id := the_m_cost_category_id
			is_null_m_cust_charge_no := False
			is_null_m_adjustment_no := False
			is_null_m_cost_category_id := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 4

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  amount_charged, m_adjustment_no, m_cost_category_id, m_cust_charge_no"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "cust_charge_breakdowns ccb"

	join_condition: STRING = ""

	table_name: STRING = "cust_charge_breakdowns"

	key_where_clause: STRING = "m_cust_charge_no = :1 and m_adjustment_no = :2 and m_cost_category_id = :3"

feature -- Values

	amount_charged: DOUBLE
			-- DB: NUMBER(14,5) not null

	m_adjustment_no: INTEGER
			-- DB: NUMBER(2,0) not null

	m_cost_category_id: STRING
			-- DB: VARCHAR2(10) not null

	m_cust_charge_no: INTEGER
			-- DB: NUMBER(6,0) not null

feature -- Nullness for non-null columns

	is_null_amount_charged: BOOLEAN
	is_null_m_adjustment_no: BOOLEAN
	is_null_m_cost_category_id: BOOLEAN
	is_null_m_cust_charge_no: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and m_adjustment_no = r.m_adjustment_no
				and m_cust_charge_no = r.m_cust_charge_no
			Result := Result
				and equal (m_cost_category_id, r.m_cost_category_id)
			Result := Result
				and is_null_m_adjustment_no = r.is_null_m_adjustment_no
				and is_null_m_cost_category_id = r.is_null_m_cost_category_id
				and is_null_m_cust_charge_no = r.is_null_m_cust_charge_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and amount_charged = r.amount_charged
			Result := Result
				and is_null_amount_charged = r.is_null_amount_charged
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_double (1)
			q.select_integer (2)
			q.select_string (3, 10)
			q.select_integer (4)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			amount_charged := q.double_value (1)
			m_adjustment_no := q.integer_value (2)
			m_cust_charge_no := q.integer_value (4)
		end

	fill_in_references (q: SQL_QUERY)
		do
			m_cost_category_id := q.string_value (3)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (3, m_cost_category_id)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_amount_charged := q.is_null (1)
			is_null_m_adjustment_no := q.is_null (2)
			is_null_m_cost_category_id := q.is_null (3)
			is_null_m_cust_charge_no := q.is_null (4)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_m_cust_charge_no := True
			is_null_m_adjustment_no := True
			is_null_m_cost_category_id := True
			create m_cost_category_id.make (0)
		end

	set_null_nonkey
		do
			is_null_amount_charged := True
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_integer (1, m_cust_charge_no, False)
			q.bind_num_to_integer (2, m_adjustment_no, False)
			q.bind_num_to_string (3, m_cost_category_id, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and amount_charged = q.double_value (1)
				and m_adjustment_no = q.integer_value (2)
				and m_cust_charge_no = q.integer_value (4)
			q.get_string_value (3, s)
			Result := Result and equal (m_cost_category_id, s)
			Result := Result
				and is_null_amount_charged = q.is_null (1)
				and is_null_m_adjustment_no = q.is_null (2)
				and is_null_m_cost_category_id = q.is_null (3)
				and is_null_m_cust_charge_no = q.is_null (4)
		end

end
