
indexing

	date: "Mon Sep 29 10:54:29 2008"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user ALLMOSIS"
	database_tables: 
		"CUST_CHARGES (MOSIS.CUST_CHARGES)"
			-- Included columns
			-- 	AMOUNT_TAX
			-- 	AMOUNT_TOTAL_NO_TAX
			-- 	DATE_ENTERED
			-- 	DISTRIBUTION_RANK
			-- 	EDU_UNITS
			-- 	IS_UNIT_CHARGE
			-- 	MFA_NO
			-- 	M_ADJUSTMENT_NO
			-- 	M_CUST_CHARGE_NO
			-- 	M_FUNDING_ALLOC_NO
			-- 	M_FUNDING_AUTH_NO
			-- 	M_JOB_NO
			-- 	PROCESS_CHARGE
			-- 	REASON
			-- 	UNCOLLECTABLE
			-- Excluded columns
			-- 	(none)

class CUST_CHARGES_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_m_cust_charge_no: INTEGER; the_m_adjustment_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			m_cust_charge_no := the_m_cust_charge_no
			m_adjustment_no := the_m_adjustment_no
			is_null_m_cust_charge_no := False
			is_null_m_adjustment_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 15

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  amount_tax, amount_total_no_tax, date_entered, distribution_rank,%N  edu_units, is_unit_charge, mfa_no, m_adjustment_no, m_cust_charge_no,%N  m_funding_alloc_no, m_funding_auth_no, m_job_no, process_charge, reason,%N  uncollectable"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "cust_charges cc"

	join_condition: STRING = ""

	table_name: STRING = "cust_charges"

	key_where_clause: STRING = "m_cust_charge_no = :1 and m_adjustment_no = :2"

feature -- Values

	amount_tax: DOUBLE
			-- DB: NUMBER(11,5) not null

	amount_total_no_tax: DOUBLE
			-- DB: NUMBER(9,2) not null

	date_entered: DB_DATE
			-- DB: DATE not null

	distribution_rank: INTEGER
			-- DB: NUMBER(2,0) not null

	edu_units: INTEGER
			-- DB: NUMBER(4,0) not null

	is_unit_charge: BOOLEAN
			-- DB: CHAR(1) not null

	mfa_no: INTEGER
			-- DB: NUMBER(6,0)

	m_adjustment_no: INTEGER
			-- DB: NUMBER(2,0) not null

	m_cust_charge_no: INTEGER
			-- DB: NUMBER(6,0) not null

	m_funding_alloc_no: INTEGER
			-- DB: NUMBER(6,0) not null

	m_funding_auth_no: INTEGER
			-- DB: NUMBER(6,0) not null

	m_job_no: INTEGER
			-- DB: NUMBER(6,0) not null

	process_charge: BOOLEAN
			-- DB: CHAR(1) not null

	reason: STRING
			-- DB: VARCHAR2(80)

	uncollectable: BOOLEAN
			-- DB: CHAR(1) not null

feature -- Nullness for null allowed columns

	is_null_mfa_no: BOOLEAN
	is_null_reason: BOOLEAN

feature -- Nullness for non-null columns

	is_null_amount_tax: BOOLEAN
	is_null_amount_total_no_tax: BOOLEAN
	is_null_date_entered: BOOLEAN
	is_null_distribution_rank: BOOLEAN
	is_null_edu_units: BOOLEAN
	is_null_is_unit_charge: BOOLEAN
	is_null_m_adjustment_no: BOOLEAN
	is_null_m_cust_charge_no: BOOLEAN
	is_null_m_funding_alloc_no: BOOLEAN
	is_null_m_funding_auth_no: BOOLEAN
	is_null_m_job_no: BOOLEAN
	is_null_process_charge: BOOLEAN
	is_null_uncollectable: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and m_adjustment_no = r.m_adjustment_no
				and m_cust_charge_no = r.m_cust_charge_no
			Result := Result
				and is_null_m_adjustment_no = r.is_null_m_adjustment_no
				and is_null_m_cust_charge_no = r.is_null_m_cust_charge_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and amount_tax = r.amount_tax
				and amount_total_no_tax = r.amount_total_no_tax
				and distribution_rank = r.distribution_rank
				and edu_units = r.edu_units
				and is_unit_charge = r.is_unit_charge
				and mfa_no = r.mfa_no
				and m_funding_alloc_no = r.m_funding_alloc_no
				and m_funding_auth_no = r.m_funding_auth_no
				and m_job_no = r.m_job_no
				and process_charge = r.process_charge
				and uncollectable = r.uncollectable
			Result := Result
				and equal (date_entered, r.date_entered)
				and equal (reason, r.reason)
			Result := Result
				and is_null_amount_tax = r.is_null_amount_tax
				and is_null_amount_total_no_tax = r.is_null_amount_total_no_tax
				and is_null_date_entered = r.is_null_date_entered
				and is_null_distribution_rank = r.is_null_distribution_rank
				and is_null_edu_units = r.is_null_edu_units
				and is_null_is_unit_charge = r.is_null_is_unit_charge
				and is_null_mfa_no = r.is_null_mfa_no
				and is_null_m_funding_alloc_no = r.is_null_m_funding_alloc_no
				and is_null_m_funding_auth_no = r.is_null_m_funding_auth_no
				and is_null_m_job_no = r.is_null_m_job_no
				and is_null_process_charge = r.is_null_process_charge
				and is_null_reason = r.is_null_reason
				and is_null_uncollectable = r.is_null_uncollectable
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_double (1)
			q.select_double (2)
			q.select_date (3)
			q.select_integer (4)
			q.select_integer (5)
			q.select_boolean (6)
			q.select_integer (7)
			q.select_integer (8)
			q.select_integer (9)
			q.select_integer (10)
			q.select_integer (11)
			q.select_integer (12)
			q.select_boolean (13)
			q.select_string (14, 80)
			q.select_boolean (15)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			amount_tax := q.double_value (1)
			amount_total_no_tax := q.double_value (2)
			distribution_rank := q.integer_value (4)
			edu_units := q.integer_value (5)
			is_unit_charge := q.boolean_value (6)
			mfa_no := q.integer_value (7)
			m_adjustment_no := q.integer_value (8)
			m_cust_charge_no := q.integer_value (9)
			m_funding_alloc_no := q.integer_value (10)
			m_funding_auth_no := q.integer_value (11)
			m_job_no := q.integer_value (12)
			process_charge := q.boolean_value (13)
			uncollectable := q.boolean_value (15)
		end

	fill_in_references (q: SQL_QUERY)
		do
			date_entered := q.date_value (3)
			reason := q.string_value (14)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_date_value (3, date_entered)
			q.get_string_value (14, reason)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_amount_tax := q.is_null (1)
			is_null_amount_total_no_tax := q.is_null (2)
			is_null_date_entered := q.is_null (3)
			is_null_distribution_rank := q.is_null (4)
			is_null_edu_units := q.is_null (5)
			is_null_is_unit_charge := q.is_null (6)
			is_null_mfa_no := q.is_null (7)
			is_null_m_adjustment_no := q.is_null (8)
			is_null_m_cust_charge_no := q.is_null (9)
			is_null_m_funding_alloc_no := q.is_null (10)
			is_null_m_funding_auth_no := q.is_null (11)
			is_null_m_job_no := q.is_null (12)
			is_null_process_charge := q.is_null (13)
			is_null_reason := q.is_null (14)
			is_null_uncollectable := q.is_null (15)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_m_cust_charge_no := True
			is_null_m_adjustment_no := True
		end

	set_null_nonkey
		do
			is_null_amount_tax := True
			is_null_amount_total_no_tax := True
			is_null_date_entered := True
			is_null_distribution_rank := True
			is_null_edu_units := True
			is_null_is_unit_charge := True
			is_null_mfa_no := True
			is_null_m_funding_alloc_no := True
			is_null_m_funding_auth_no := True
			is_null_m_job_no := True
			is_null_process_charge := True
			is_null_reason := True
			is_null_uncollectable := True
			create {ORACLE_DATE} date_entered.set_null
			create reason.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_integer (1, m_cust_charge_no, False)
			q.bind_num_to_integer (2, m_adjustment_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
			d: DB_DATE
		do
			s := temp_string
			d := temp_date
			Result := True
			Result := Result
				and amount_tax = q.double_value (1)
				and amount_total_no_tax = q.double_value (2)
				and distribution_rank = q.integer_value (4)
				and edu_units = q.integer_value (5)
				and is_unit_charge = q.boolean_value (6)
				and mfa_no = q.integer_value (7)
				and m_adjustment_no = q.integer_value (8)
				and m_cust_charge_no = q.integer_value (9)
				and m_funding_alloc_no = q.integer_value (10)
				and m_funding_auth_no = q.integer_value (11)
				and m_job_no = q.integer_value (12)
				and process_charge = q.boolean_value (13)
				and uncollectable = q.boolean_value (15)
			q.get_date_value (3, d)
			Result := Result and equal (date_entered, d)
			q.get_string_value (14, s)
			Result := Result and equal (reason, s)
			Result := Result
				and is_null_amount_tax = q.is_null (1)
				and is_null_amount_total_no_tax = q.is_null (2)
				and is_null_date_entered = q.is_null (3)
				and is_null_distribution_rank = q.is_null (4)
				and is_null_edu_units = q.is_null (5)
				and is_null_is_unit_charge = q.is_null (6)
				and is_null_mfa_no = q.is_null (7)
				and is_null_m_adjustment_no = q.is_null (8)
				and is_null_m_cust_charge_no = q.is_null (9)
				and is_null_m_funding_alloc_no = q.is_null (10)
				and is_null_m_funding_auth_no = q.is_null (11)
				and is_null_m_job_no = q.is_null (12)
				and is_null_process_charge = q.is_null (13)
				and is_null_reason = q.is_null (14)
				and is_null_uncollectable = q.is_null (15)
		end

end
