class CUST_IC_DESIGN_PADS_ROW

inherit
	CUST_IC_DESIGN_PADS_RAW

	ROW_COUNT_CHECK_ACCESS

	MORE_DOUBLE_MATH

create
	make_template, make_null, make_by_key

feature -- Properties

	size_min: DOUBLE is
		-- shorter of x and y
	do  Result := size_x.min (size_y)
	end;

	size_max: DOUBLE is
		-- longer of x and y
	do  Result := size_x.max (size_y)
	end;

	infix "|-|"(other: CUST_IC_DESIGN_PADS_ROW): DOUBLE is
		-- center to center distance between two pads
	require exists: other /= Void
	do  Result := radius(center_x - other.center_x, center_y - other.center_y)
	end;

	rows_for_design_no (dno: INTEGER conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current] is
			-- All rows for design number `dno'
		require
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_I
		do
			create b.make (dno)
			Result := all_rows_filtered (conn, "design_no = :1", b)
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end
end -- CUST_IC_DESIGN_PADS_ROW
