
indexing

	author: "Generated"
	date: "Fri Feb 27 14:00:36 PST 2004"

class CUST_IC_DESIGNS_MROW
inherit
	CUST_IC_DESIGNS_MRAW
	undefine delete		-- inherit from MULTI_LINE_TEXT_ROW
	redefine post
	end;

	CUST_IC_DESIGNS_ROW
		undefine
			initialize_new, initialize_new_by_key
		redefine
			anchored_cidf_row
		end

	MULTI_LINE_TEXT_ROW[CUST_IC_DESIGN_DESCRS_MROW]
	rename the_text as description,
	       set_the_text as set_description
	end;

	DB_UTILITIES
	export	{ANY}	su
		{NONE}	all
	end;

create
	make_template, make_null, make_by_key

feature -- database coordination

	post is
		-- automatic update of date_modified before posting
	do if is_registered and not is_deleted
	    then set_date_modified(connection.transaction_date)
	   end;
	   precursor;
	end;

feature -- Modification

	freeze is
			-- If `Current' is not frozen, mark it frozen
		do
			if not design_frozen then
				set_design_frozen (True)
			end
		end

	unfreeze is
			-- If `Current' is frozen and does not have
			-- multiple fab instances, mark it unfrozen
		do
			if design_frozen then
				if not has_multiple_fab_instances then
					set_design_frozen (False)
				end
			end
		end

feature	-- cust_ic_design_measurements

	set_measurement_value(iname: STRING; val: DOUBLE)
		-- modify existing or add a new one
	local foo: CUST_IC_DESIGN_MEASUREMENTS_MROW
	do  foo := a_measurement(iname);
	    if foo = Void then
		create foo.make_null(connection)
		foo.set_design_no(design_no);
		foo.set_item_name(iname);
		cached_measurements.extend(foo)
	    end;
	    foo.set_numeric_value(val)
	end;

	remove_measurement(iname: STRING)
		-- remove a measurement (nop if doesn't exist)
	local foo: CUST_IC_DESIGN_MEASUREMENTS_MROW
	do  foo := a_measurement(iname);
	    if foo /= Void then
		foo.delete;
		cached_measurements.remove	-- foo is current!!
	    end
	end;

feature {NONE} -- effectors for description (MULTI_LINE_TEXT_ROW)

	anchored_cidf_row: CUST_IC_DESIGN_FILES_MROW
	do
	end;

	create_numbered_row: CUST_IC_DESIGN_DESCRS_MROW is
	do  create Result.make_null(connection);
	    Result.set_design_no(design_no)
	end;

	numbered_rows_filter: STRING is "design_no = :1";

	numbered_rows_binder: DB_BIND_I is
	do  create Result.make(design_no);
	end;

end
