
class CUST_QUOTE_LINE_ITEMS_ROW

inherit

	CUST_QUOTE_LINE_ITEMS_RAW

	DB_QUERY_OPTIONS
	    export
		{NONE} all
	    end

	MOSIS_PRICE
	    rename
		price_identification_no as m_cust_quote_no,
		line_no as cust_quote_line_no,
		descr as full_cust_quote_id
	    export
		 {NONE} is_standard_price, pricing_schedule
	    undefine
		cust_quote_line_no,
		quantity_quoted,
		assumed_area
	    end

create

	make_template, make_null, make_by_key

feature -- attributes from parent

	date_effective: DB_DATE is
	    do
		Result := parent.date_effective
	    end

	date_expires: DB_DATE is
	    do
		Result := parent.date_expires
	    end

	is_null_date_expires: BOOLEAN is
	    do
		Result := parent.is_null_date_expires
	    end

	full_cust_quote_id: STRING is
		-- cust_quote_id of my quote
	    do
		Result := parent.full_cust_quote_id
	    end;

feature	-- my part

	my_part: M_PARTS_ROW is
	do  if my_cached_part = Void
	     then create my_cached_part.make_by_key(connection,old_row,m_part_no)
	    end;
	    Result := my_cached_part
	end;

feature {CUST_QUOTES_ROW}

	set_my_parent(dad: CUST_QUOTES_ROW) is
		-- always trust dad
	do  my_parent := dad
	end;

feature {NONE} -- 

	my_parent: CUST_QUOTES_ROW

	parent: CUST_QUOTES_ROW is
	    require
		valid: m_cust_quote_no > 0
	    do
		if my_parent = Void then
		    create my_parent.make_by_key(connection,old_row,m_cust_quote_no)
		end
		Result := my_parent
	    end

	my_cached_part: M_PARTS_ROW

feature {NONE} -- for MOSIS_PRICE

	is_quoted_price: BOOLEAN is
	    do
		Result := True
	    end

	edu_units: INTEGER is
	    do
	    end

end -- class CUST_QUOTE_LINE_ITEMS_ROW
