
indexing

	author: "Generated"
	date: "Sat Feb 21 09:30:28 PST 2004"

class CUST_WOS_MROW
inherit
	CUST_WOS_MRAW

	CUST_WOS_ROW
		undefine
			initialize_new,
			initialize_new_by_key
		redefine
			anchored_line_item
		end
	ROW_BUSY_CHECK_ACCESS
	
create
	make_template, make_null, make_by_key

feature {NONE}

	anchored_line_item: CUST_WO_LINE_ITEMS_MROW is
		-- for anchoring; always Void
	do
	end;

feature	-- 

	is_post_needed: BOOLEAN is
		-- do we need to post before we can use a db package?
		-- (i.e, am I or any of my line items registered?)
	local lis: like line_items;
	do  from  lis := line_items;
		  lis.start;
		  Result := is_registered;
	    until lis.after or Result
	    loop  Result := lis.item.is_registered
		  lis.forth
	    end
	end;

feature -- Properties

	locked_work_orders_for_run (run: STRING conn: DB_CONNECTION opt: DB_LOCK_BUSY_OPTION range: ITEM_COUNT_RANGE): LIST [like Current] is
			-- All work orders for run `run', with rows already
			-- locked
		require
			run_exists: run /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			busy_action_exists: opt /= Void
			range_exists: range /= Void
		local
			b: DB_BIND_S
		do
			create b.make (run)
			Result := all_rows_filtered_locked (conn, "m_fab_no in (select m_fab_no from ic_fab_instances where run_id = :1)", b, opt)
			check_list_busy
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

	locked_test_vehicle_work_orders_for_run (run: STRING conn: DB_CONNECTION opt: DB_LOCK_BUSY_OPTION range: ITEM_COUNT_RANGE): LIST [like Current] is
			-- All work orders for test vehicles on run `run', 
			-- with rows already locked
		require
			run_exists: run /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			busy_action_exists: opt /= Void
			range_exists: range /= Void
		local
			b: DB_BIND_SS
			ic_fab_instance_type: IC_FAB_INSTANCE_TYPE_VALUES
		do
			create b.make (run, ic_fab_instance_type.Test_vehicle)
			Result := all_rows_filtered_locked (conn, "m_fab_no in (select m_fab_no from ic_fab_instances where run_id = :1 and ic_fab_instance_type = :2)", b, opt)
			check_list_busy
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end


end
