
indexing
	
	description: "Change that creates or deletes an element that is a cut"
	author: "David Hollenberg"
	date: "January 25, 2007"

deferred class CUT_CREATION_OR_DELETION_CHANGE
inherit
	RETICLE_SIMPLE_CHANGE
		redefine
			parent
		end

feature -- Properties

	parent: RETICLE_CUT_CREATION_OR_DELETION_CHANGE
			-- Change that includes this simple change

feature -- Operations

	create_element
			-- Create element
		local
			l_model_element: RETICLE_CUT
		do
			set_cut_location
			l_model_element ?= model_element
			check
				l_model_element_not_void: l_model_element /= Void
			end
			model.add_new_cut (cut_location, parent.cut_pattern)
			element.unmark
			view.elements.extend (element)
		end

	delete_element
			-- Delete element
		do
			set_cut_location
			parent.add_deleted_cut (cut_location)
			parent.add_deleted_element (element)
			element.mark
		end

feature {NONE} -- Implementation

	set_cut_location
			-- Set `cut_location'
		do
			cut_location := model_element.cut_location
		end

	cut_location: PACKING_CUT_LOCATIONS_MROW

end
