
indexing
	
	description: "Utilities for cut pattern map generation"
	author: "David Hollenberg"
	date: "March 10, 2005"

deferred class CUT_MAP_UTILITIES

feature -- Implementation

	cache: RUN_CACHE
		deferred
		ensure
			result_not_void: Result /= Void
		end

	file_generator: RC_FILE_GENERATOR
		deferred
		ensure
			result_not_void: Result /= Void
		end

	fetch_cut_pattern_data
			-- Fetch some needed data from cache
		do
			cache.uncache_cut_patterns
			cache.uncache_packaging_lots
			cache.uncache_wafer_lots
		end

	postscript_file_for_lot (lot: RUN_PACKAGING_LOTS_ROW): RC_FILE
			-- PostScript file to write for `lot'
		do
			Result := file_generator.cut_patterns_map_ps_file (lot, lot_short_org (lot), lot_etest_id (lot))
		end

	pdf_file_for_lot (lot: RUN_PACKAGING_LOTS_ROW): RC_FILE
			-- PDF file to write for `lot'
		do
			Result := file_generator.cut_patterns_map_pdf_file (lot, lot_short_org (lot), lot_etest_id (lot))
		end

	lot_short_org (lot: RUN_PACKAGING_LOTS_ROW): STRING
			-- Organization short id for `lot'
		do
			if lot /= Void then
				Result := lot.packager_short_id
			else
				Result := ""
			end
		ensure
			result_exists: Result /= Void
		end

	lot_etest_id (lot: RUN_PACKAGING_LOTS_ROW): STRING
			-- Wafer etest id for `lot'
		do
			if lot /= Void then
				Result := lot.wafer_etest_id
			else
				Result := ""
			end
		ensure
			result_exists: Result /= Void
		end

end
