
indexing
	
	description: "Change that changes one or more properties of an %
		%existing cut pattern"
	author: "David Hollenberg"
	date: "January 25, 2007"

class CUT_PATTERN_PROPERTY_CHANGE
inherit
	RETICLE_SIMPLE_CHANGE
		rename
			make as simple_make
		export
			{NONE} simple_make
		end

create
	make

feature {NONE} -- Creation

	make (a_view: RETICLE_VIEW an_old_etest_name: STRING an_old_quant: INTEGER an_old_has_quant: BOOLEAN a_new_etest_name: STRING a_new_quant: INTEGER a_new_has_quant: BOOLEAN)
		do
			current_view := a_view
			old_etest_name := an_old_etest_name
			old_wafer_quantity := an_old_quant
			old_has_wafer_quantity := an_old_has_quant
			new_etest_name := a_new_etest_name
			new_wafer_quantity := a_new_quant
			new_has_wafer_quantity := a_new_has_quant
		end

feature -- Properties

	current_view: RETICLE_VIEW
			-- View to which change was made

	old_etest_name: STRING
			-- Cut pattern wafer etest name before change

	old_wafer_quantity: INTEGER
			-- Cut pattern wafer quantity before change

	old_has_wafer_quantity: BOOLEAN
			-- Cut pattern existence of wafer quantity before 
			-- change

	new_etest_name: STRING
			-- Cut pattern wafer etest name after change

	new_wafer_quantity: INTEGER
			-- Cut pattern wafer quantity after change

	new_has_wafer_quantity: BOOLEAN
			-- Cut pattern existence of wafer quantity after
			-- change

feature -- Operations

	undo
			-- Undo change
		do
			current_view.current_cut_pattern.set_wafer_etest_name (old_etest_name)
			current_view.current_cut_pattern.set_quantity_wafers_needed (old_wafer_quantity, old_has_wafer_quantity)
		end

	redo
			-- Redo change
		do
			current_view.current_cut_pattern.set_wafer_etest_name (new_etest_name)
			current_view.current_cut_pattern.set_quantity_wafers_needed (new_wafer_quantity, new_has_wafer_quantity)
		end

end
