
indexing
	
	description: "Change that changes the status of a cut pattern from %
		%Completed to Under Construction"
	author: "David Hollenberg"
	date: "January 25, 2007"

class CUT_PATTERN_STATUS_CHANGE
inherit
	RETICLE_SIMPLE_CHANGE
		rename
			make as simple_make
		export
			{NONE} simple_make
		end

create
	make

feature {NONE} -- Creation

	make (a_view: RETICLE_VIEW an_old_completed, a_new_completed: BOOLEAN)
		do
			current_view := a_view
			old_completed := an_old_completed
			new_completed := a_new_completed
		end

feature -- Properties

	current_view: RETICLE_VIEW
			-- View to which change was made

	old_completed: BOOLEAN
			-- Cut pattern "is completed" status before change

	new_completed: BOOLEAN
			-- Cut pattern "is completed" status after change

feature -- Operations

	undo
			-- Undo change
		do
			current_view.current_cut_pattern.set_is_completed (old_completed)
		end

	redo
			-- Redo change
		do
			current_view.current_cut_pattern.set_is_completed (new_completed)
		end

end
