
indexing
	
	author: "David Hollenberg"
	date: "November 20, 1998"
	description: "A consumer of data from some arbitrary source, %
		%which is only a data consumer and not a data transform."

deferred class DATA_CONSUMER_ONLY

inherit
	DATA_CONSUMER

feature -- Properties

	other_ok: BOOLEAN = True
			-- Have all calls made to `consume' or `consume_eof'
			-- since initialization or reset succeeded
			-- for the consumer of my output, if any?
			-- Always true since no output

	other_errors: LIST [STRING]
			-- Errors that occurred for the consumer of my output
			-- (if any) in a call to `consume' or `consume_eof'.
			-- Always Void since no output
		do
			Result := Void
		end

	other_warnings: LIST [STRING]
			-- Warnings that occurred for the
			-- consumer of my output during calls to
			-- `consume' and `consume_eof'.
			-- Always Void since no output
		do
			Result := Void
		end

	all_ok: BOOLEAN
			-- Have all calls made to `consume' or `consume_eof'
			-- since initialization or reset succeeded
			-- for this consumer and all its output consumers?
		do
			Result := local_ok
		end

	all_errors: LIST [STRING]
			-- Errors that occurred for this consumer and all
			-- its output consumers in a call to `consume' or
			-- `consume_eof'.
			-- Void unless `all_ok' is false
		do
			Result := local_errors
		end

	all_warnings: LIST [STRING]
			-- Warnings that occurred for this
			-- consumer and all its output consumers
			-- during calls to `consume' and `consume_eof',
			-- or Void if none
		do
			Result := local_warnings
		end

invariant
	other_ok: other_ok
	no_other_errors: other_errors = Void
	no_other_warnings: other_warnings = Void
	all_ok_local: all_ok = local_ok
	all_errors_local: all_errors = local_errors
	all_warnings_local: all_warnings = local_warnings

end
