
indexing
	
	author: "Joel Goldberg"
	date: "Feb 13, 2006"
	description: "A consumer of data that writes it to an opened file"

class DATA_CONSUMER_OPEN_FILE

inherit
	DATA_CONSUMER_ONLY
		redefine
			initialize, reset
		end
	UNIX_OS_ACCESS
		export
			{NONE} all
		end

create
	make

feature {NONE} -- Creation

	make (f: LARGE_FILE)
			-- f is the bucket, starting wherever we are
		require
			exists: f /= Void
			writeable: f.is_open_write
		do
			file := f
			starting_position := file.position
			reset
		end

feature	-- status

	in_initial_state: BOOLEAN
		-- Is `Current' in its initial state?
		-- FIX_ME: I don't think this position stuff will work
		--	for pipes !!
	do  Result := file.position = starting_position
	end

feature -- Operations

	consume (the_data: STRING)
			-- Consume some more data in `the_data'.
			-- Just write it to `file'
		do
			file.put_string (the_data)
			current_position := file.position
		end

	consume_eof
			-- Consume an "end of file" indication.
		do
		end

	initialize
			-- mark new starting position for this phase
		do
			starting_position := file.position
			precursor
		end

	reset
			-- Reset `Current' to its initial state so
			-- that it may be reused
		do
			precursor
		--	if not in_initial_state then
		--		file.go(starting_position)
		--	end
		end

feature -- Properties

	file: LARGE_FILE
			-- File to which to write consumed data

	starting_position: INTEGER_64
			-- position where we started to write
			-- for this op (for reset)

	Default_name: STRING = "File"
			-- Default name of `Current'

	always_ok: BOOLEAN = True
			-- Is this consumer always OK? (Answer: yes)

	current_position: INTEGER_64

end
