
indexing
	
	description: "Interface to get info for database login"
	author: "David Hollenberg"
	date: "September 23, 2002"

deferred class DATABASE_LOGIN_IFC

inherit
	ABSTRACT_INTERFACE
		
feature {NONE} -- Creation

	make_interface (init_user, conn_str: STRING)
			-- Create interface for database login with
			-- initial username `init_user' (changeable)
			-- and connect string `conn_str'
		require
			init_user_exists: init_user /= Void
			connect_string_exists: conn_str /= Void
		do
			initial_connect_string := conn_str
			initial_user := init_user
			create accept_actions
			create decline_actions
		end

feature -- Properties

	accept_actions: ACTION_SEQUENCE [TUPLE [STRING, STRING, STRING]]
			-- Actions to be performed when user accepts current
			-- operation.  The current values of username,
			-- password and connect string will be passed in

	decline_actions: CLOSED_ACTION_SEQUENCE
			-- Actions to be performed when user declines to
			-- proceed with current operation

	initial_connect_string: STRING
			-- Initial value for connect string

	initial_user: STRING
			-- Initial value for username

invariant
	accept_actions_exist: accept_actions /= Void
	decline_actions_exist: decline_actions /= Void
	initial_user_exists: initial_user /= Void
	connect_string_exists: initial_connect_string /= Void
end
