
indexing
	
	description: "Dates sent column in a multi column list"
	author: "David Hollenberg"
	date: "June 1, 2005"

class DATES_SENT_COLUMN [G -> HAS_DATES_SENT]
inherit
	MULTI_COLUMN_LIST_COLUMN [G]
	STRING_UTILITIES_ACCESS
		export
			{NONE} all
		end

create
	default_create

feature -- Properties

	title: STRING = "Dates Sent"
			-- Title for column

	alignment: EV_TEXT_ALIGNMENT
			-- Alignment for values in column
		do
			create Result.make_with_left_alignment
		end

	value (r: G): STRING
			-- Value in column for `r'
		local
			list: LIST [DB_DATE]
			strings: ARRAYED_LIST [STRING]
		do
			if r.has_dates_sent then
				create Result.make (20)
				from
					list := r.dates_sent
					create strings.make (list.count)
					list.start
				until
					list.after
				loop
					strings.extend (list.item.to_date_string)
					list.forth
				end
				Result := su.joined_by (strings, "   ")
			else
				Result := ""
			end
		end

	comparator: DATES_SENT_COMPARATOR [G]
		do
			create Result
		end

end
