
indexing
	
	description: "Comparator for dates sent in a multi column list"
	author: "David Hollenberg"
	date: "June 1, 2005"

class DATES_SENT_COMPARATOR [G -> HAS_DATES_SENT]
inherit
	KL_COMPARATOR [G]

feature -- Status report

	less_than (u, v: G): BOOLEAN
			-- Is `u' considered less than `v'?
		local
			list1, list2: LIST [DB_DATE]
			d1, d2: DB_DATE
			done: BOOLEAN
		do
			if u.has_dates_sent and v.has_dates_sent then
				list1 := u.dates_sent
				list2 := v.dates_sent
				from
					done := False
					list1.start
					list2.start
				until
					list1.after or list2.after or done
				loop
					d1 := list1.item
					d2 := list2.item
					if d1 < d2 then
						Result := True
						done := True
					elseif d1 > d2 then
						Result := False
						done := True
					else
						list1.forth
						list2.forth
						Result := list1.after and not list2.after
					end
				end
			elseif v.has_dates_sent then
				Result := True
			else
				Result := False
			end
		end

end
