class DB_DELETABLE_ROW_LIST [reference G -> DB_DELETABLE_ROW]
	-- DB_LOCKABLE_ROW_LIST with support for deletion

inherit
	DB_LOCKABLE_ROW_LIST[G]

create
	make,
	make_by_query

create {DB_DELETABLE_ROW_LIST}
	make_filled

feature -- status

	are_deleted: INTEGER is
		-- how many of the rows are deleted
		-- NOTE: if we always use delete_row or delete_all,
		--  then are_deleted == 0 since deleted entries are 
		--  also removed from the list.
	do  from  start
	    until after
	    loop  if item.is_deleted then Result := Result + 1 end;
		  forth
	    end;
	ensure 0 <= Result and Result <= count
	end;

feature -- modification

	delete_row is
		-- delete the current (cursor) row from database and list
	require not off;
	do  item.delete
	    remove
	end;

	delete_all is
		-- delete all the rows from the database and empty the list
	do  from  start
	    until after
	    loop  item.delete
		  forth
	    end
	    wipe_out;
	ensure is_empty
	end;

end -- DB_DELETABLE_ROW_LIST
