class DB_IDENTIFIED_ROW_LIST [reference G -> DB_IDENTIFIED_ROW]

inherit
	DB_ROW_LIST[G]

create
	make,
	make_by_query

create {DB_IDENTIFIED_ROW_LIST}
	make_filled

feature -- status counts (number of rows in given state)

	are_changed: INTEGER is
		-- how many of the rows are changed
	do  from  start
	    until after
	    loop  if item.is_changed then Result := Result + 1 end;
		  forth
	    end;
	ensure 0 <= Result and Result <= count
	end;

	are_registered: INTEGER is
		-- how many of the rows are registered
	do  from  start
	    until after
	    loop  if item.is_registered then Result := Result + 1 end;
		  forth
	    end;
	ensure 0 <= Result and Result <= count
	end;

	are_new: INTEGER is
		-- how many of the rows are new
	do  from  start
	    until after
	    loop  if item.is_new then Result := Result + 1 end;
		  forth
	    end;
	ensure 0 <= Result and Result <= count
	end;

	are_old: INTEGER is
		-- how many of the rows are old
	do  from  start
	    until after
	    loop  if item.is_old then Result := Result + 1 end;
		  forth
	    end;
	ensure 0 <= Result and Result <= count
	end;

end -- DB_IDENTIFIED_ROW_LIST
