class DB_LOCKABLE_ROW_LIST [reference G -> DB_LOCKABLE_ROW]
	-- DB_IDENTIFIED_ROW_LIST with support for locking

inherit
	DB_IDENTIFIED_ROW_LIST[G]

create
	make,
	make_by_query

create {DB_LOCKABLE_ROW_LIST}
	make_filled

feature -- status

	are_locked: INTEGER is
		-- how many of the rows are locked
	do  from  start
	    until after
	    loop  if item.is_locked then Result := Result + 1 end;
		  forth
	    end;
	ensure 0 <= Result and Result <= count
	end;

feature -- modification

	lock_all_with_wait(wait: BOOLEAN) is
		-- lock_with_wait(wait) all the rows
	do  from  start
	    until after
	    loop  if wait
		   then item.lock_wait
		   else item.lock_nowait
		  end
		  forth
	    end
	end;

end -- DB_LOCKABLE_ROW_LIST
