class DB_OPTIONS_LIST [reference G -> DB_ESSENCE_OF_OPTION]

inherit

	DB_ROW_LIST[G]

	MOSIS_TECH_VALUES
	undefine copy, is_equal
	end;

create

	make, make_by_query

create {DB_OPTIONS_LIST}

	make_filled

feature

	has_name(nam: STRING): BOOLEAN is
	do
	     from  start
	     until after or Result
	     loop
		  Result := equal(item.option_name, nam)
		  forth;
	     end;
	end;

	has_id(id: STRING): BOOLEAN is
	do
	     from  start
	     until after or Result
	     loop
		  Result := equal(item.option_id, id)
		  forth;
	     end;
	end;

	has_category(category: STRING): BOOLEAN is
	do
	     from  start
	     until after or Result
	     loop
		  Result := equal(item.option_category, category)
		  forth;
	     end;
	end;

	option_by_name(nam: STRING): G is
	do
	     from  start
	     until after or Result /= Void
	     loop
		  if item.option_name.is_equal(nam) then Result := item;
		  end;
		  forth;
	     end;
	end;

	option_by_id(id: STRING): G is
	do
	     from  start
	     until after or Result /= Void
	     loop
		  if item.option_id.is_equal(id) then Result := item;
		  end;
		  forth;
	     end;
	end;

	option_by_category(category: STRING): G is
	do
	     from  start
	     until after or Result /= Void
	     loop
		  if item.option_category.is_equal(category) then Result := item;
		  end;
		  forth;
	     end;
	end;

	is_epi: BOOLEAN is
	do
		Result := has_id(option_id_is_epi);
	end;

	is_non_epi: BOOLEAN is
	do
		Result := has_id(option_id_is_bulk);
	end;

	epi_option: String is
	do
		if is_epi then
		   check not_both_epi_and_non_epi: not is_non_epi; end;
		   Result := option_id_is_epi
		elseif is_non_epi then
		   Result := option_id_is_bulk
		end;
	end;



end -- DB_OPTIONS_LIST