class DB_ROW_LIST [reference G -> DB_ROW]
	-- a list of related rows fetched from the database 
	--  (usually by a single query)

inherit
	ARRAYED_LIST[G]

create
	make,		-- in ARRAYED_LIST
	make_by_query
create {DB_ROW_LIST}
	make_filled

feature -- attributes (taken from the first row; all should match)

	connection: DB_CONNECTION is
	do  if not is_empty
	     then Result := first.connection
	    end
	end;

	transaction_number: INTEGER is
	do  if not is_empty
	     then Result := first.transaction_number
	    end
	end;

feature {NONE} -- creation

	make_by_query(q: DB_ROWS_QUERY[G]) is
	local  r: LIST[G];
	do  if q = Void
	     then make(0)
	     else q.get_all_rows;
		  r := q.row_list;
		  make(r.count);
		  append(r)
		  q.release
	    end;
	end;

end -- DB_ROW_LIST
