
indexing
	
	description: "Handler for published events in Delta"
	author: "David Hollenberg"
	date: "March 27, 2003"

class DELTA_EVENT_HANDLER
inherit
	ANY
	STRING_UTILITIES_ACCESS
		export
			{NONE} all
		end
	NUMBER_UTILITIES_ACCESS
		export
			{NONE} all
		end
	RC_ENVIRONMENT_ACCESS
		export
			{NONE} all
		end

create
	make

feature {NONE} -- Creation

	make (sess_man: RC_SESSION_MANAGER)
			-- Create with session manager `sess_man'
		require
			session_manager_exists: sess_man /= Void
		do
			session_manager := sess_man
		end

feature -- Operations

	subscribe_to_events
			-- Subscribe to events of interest to Delta
		do
			(create {UNSUBSCRIBED_EVENT_EVENT}).subscribe (
				agent handle_unsubscribed_event)
			(create {DATABASE_LOGIN_TRY_EVENT}).subscribe (
				agent handle_database_login_try)
			(create {DATABASE_LOGIN_OK_EVENT}).subscribe (
				agent handle_database_login_ok)
			(create {DATABASE_LOGIN_FAILED_EVENT}).subscribe (
				agent handle_database_login_failed)
			(create {ACCEPT_EVENT}).subscribe (agent handle_accept)
			(create {DECLINE_EVENT}).subscribe (agent handle_decline)
			(create {SELECTED_CHOICE_EVENT}).subscribe (agent handle_selected_choice)
			(create {FILE_OPEN_TRY_EVENT}).subscribe (agent handle_file_open_try)
			(create {FILE_OPEN_OK_EVENT}).subscribe (agent handle_file_open_ok)
			(create {FILE_OPEN_FAILED_EVENT}).subscribe (agent handle_file_open_failed)
			(create {FILE_CLOSE_EVENT}).subscribe (agent handle_file_close)
			(create {FILE_DELETE_TRY_EVENT}).subscribe (agent handle_file_delete_try)
			(create {FILE_DELETE_OK_EVENT}).subscribe (agent handle_file_delete_ok)
			(create {FILE_DELETE_FAILED_EVENT}).subscribe (agent handle_file_delete_failed)
			(create {FILE_RETRIEVE_OK_EVENT}).subscribe (agent handle_file_retrieve_ok)
			(create {FILE_RETRIEVE_FAILED_EVENT}).subscribe (agent handle_file_retrieve_failed)
			(create {FILE_GROUP_CHANGE_OK_EVENT}).subscribe (agent handle_file_group_change_ok)
			(create {FILE_GROUP_CHANGE_FAILED_EVENT}).subscribe (agent handle_file_group_change_failed)
			(create {DIR_CREATE_TRY_EVENT}).subscribe (agent handle_dir_create_try)
			(create {DIR_CREATE_OK_EVENT}).subscribe (agent handle_dir_create_ok)
			(create {DIR_CREATE_FAILED_EVENT}).subscribe (agent handle_dir_create_failed)
			(create {DIR_DELETE_TRY_EVENT}).subscribe (agent handle_dir_delete_try)
			(create {DIR_DELETE_OK_EVENT}).subscribe (agent handle_dir_delete_ok)
			(create {DIR_DELETE_FAILED_EVENT}).subscribe (agent handle_dir_delete_failed)
			(create {DIR_OPEN_OK_EVENT}).subscribe (agent handle_dir_open_ok)
			(create {DIR_OPEN_FAILED_EVENT}).subscribe (agent handle_dir_open_failed)
			(create {DIR_CLOSE_EVENT}).subscribe (agent handle_dir_close)
			(create {SYMLINK_CREATE_OK_EVENT}).subscribe (agent handle_symlink_create_ok)
			(create {SYMLINK_CREATE_FAILED_EVENT}).subscribe (agent handle_symlink_create_failed)
			(create {LINK_DELETE_OK_EVENT}).subscribe (agent handle_link_delete_ok)
			(create {LINK_DELETE_FAILED_EVENT}).subscribe (agent handle_link_delete_failed)
			(create {LOCK_TRY_EVENT}).subscribe (agent handle_lock_try)
			(create {LOCK_OK_EVENT}).subscribe (agent handle_lock_ok)
			(create {LOCK_FAILED_EVENT}).subscribe (agent handle_lock_failed)
			(create {UNLOCK_OK_EVENT}).subscribe (agent handle_unlock_ok)
			(create {INPUT_VALUE_EVENT}).subscribe (agent handle_input_value)
			(create {LABELED_INPUT_VALUE_EVENT}).subscribe (agent handle_labeled_input_value)
			(create {RUN_CREATED_EVENT}).subscribe (agent handle_run_created)
			(create {RUN_DELETED_EVENT}).subscribe (agent handle_run_deleted)
			(create {RUN_START_CLOSE_EVENT}).subscribe (agent handle_run_start_close)
			(create {RUN_END_CLOSE_EVENT}).subscribe (agent handle_run_end_close)
			(create {ROLE_SET_OK_EVENT}).subscribe (agent handle_role_set_ok)
			(create {ROLE_SET_FAILED_EVENT}).subscribe (agent handle_role_set_failed)
			(create {CONDITION_EVENT}).subscribe (agent handle_condition)
			(create {ABORT_EVENT}).subscribe (agent handle_abort)
			(create {RETRY_EVENT}).subscribe (agent handle_retry)
			(create {IGNORE_EVENT}).subscribe (agent handle_ignore)
			(create {CONTINUE_EVENT}).subscribe (agent handle_continue)
			(create {BOOLEAN_ANSWER_EVENT}).subscribe (agent handle_boolean_answer)
			(create {NOTIFY_EVENT}).subscribe (agent handle_notify)
			(create {ROWS_INSERTED_EVENT}).subscribe (agent handle_rows_inserted)
			(create {ROWS_UPDATED_EVENT}).subscribe (agent handle_rows_updated)
			(create {ROWS_DELETED_EVENT}).subscribe (agent handle_rows_deleted)
			(create {ROW_LOCK_OK_EVENT}).subscribe (agent handle_row_lock_ok)
			(create {ROW_LOCK_FAILED_EVENT}).subscribe (agent handle_row_lock_failed)
			(create {OPERATOR_OK_EVENT}).subscribe (agent handle_operator_ok)
			(create {OPERATOR_INVALID_EVENT}).subscribe (agent handle_operator_invalid)
			(create {BONDING_GENERATION_STARTED_EVENT}).subscribe (agent handle_bonding_generation_started)
			(create {BONDING_GENERATION_ENDED_EVENT}).subscribe (agent handle_bonding_generation_ended)
			(create {LOCK_OUT_STARTED_EVENT}).subscribe (agent handle_lockout_started)
			(create {LOCK_OUT_ENDED_EVENT}).subscribe (agent handle_lockout_ended)
			(create {POST_EVENT}).subscribe (agent handle_post)
			(create {COMMIT_EVENT}).subscribe (agent handle_commit)
			(create {ROLLBACK_EVENT}).subscribe (agent handle_rollback)
			(create {RC_STEP_DO_STARTED_EVENT}).subscribe (agent handle_step_do_started)
			(create {RC_STEP_UNDO_STARTED_EVENT}).subscribe (agent handle_step_undo_started)
			(create {RC_STEP_DO_ENDED_EVENT}).subscribe (agent handle_step_do_ended)
			(create {RC_STEP_UNDO_ENDED_EVENT}).subscribe (agent handle_step_undo_ended)
			(create {RC_STEP_REENTERED_EVENT}).subscribe (agent handle_step_reentered)
			(create {RC_STEP_DO_ABORTED_EVENT}).subscribe (agent handle_step_do_aborted)
			(create {RC_STEP_UNDO_ABORTED_EVENT}).subscribe (agent handle_step_undo_aborted)
			(create {RUN_CLERK_CHANGE_EVENT}).subscribe (agent handle_run_clerk_change)
			(create {DESIGN_ENGINEER_CHANGE_EVENT}).subscribe (agent handle_design_engineer_change)
			(create {TEST_ENGINEER_CHANGE_EVENT}).subscribe (agent handle_test_engineer_change)
			(create {RUN_CLOSER_CHANGE_EVENT}).subscribe (agent handle_run_closer_change)
			(create {FILE_ROOT_CHANGE_EVENT}).subscribe (agent handle_file_root_change)
			(create {RUN_TYPE_CHANGE_EVENT}).subscribe (agent handle_run_type_change)
			(create {OVERHEAD_RUN_ID_CHANGE_EVENT}).subscribe (agent handle_overhead_run_id_change)
			(create {EDUCATIONAL_STATUS_CHANGE_EVENT}).subscribe (agent handle_educational_status_change)
			(create {TAXI_STATUS_CHANGE_EVENT}).subscribe (agent handle_taxi_status_change)
			(create {WAFER_TECHN_CHANGE_EVENT}).subscribe (agent handle_wafer_techn_change)
			(create {MASK_TECHN_CHANGE_EVENT}).subscribe (agent handle_mask_techn_change)
			(create {DESIGNATED_DT_CHANGE_EVENT}).subscribe (agent handle_designated_dt_change)
			(create {FIELD_SET_CHANGE_EVENT}).subscribe (agent handle_field_set_change)
			(create {STEP_PATTERN_CHANGE_EVENT}).subscribe (agent handle_step_pattern_change)
			(create {CLOSE_DATE_CHANGE_EVENT}).subscribe (agent handle_close_date_change)
			(create {SCHED_RUN_NO_CHANGE_EVENT}).subscribe (agent handle_sched_run_no_change)
			(create {OTHER_BORDER_CHANGE_EVENT}).subscribe (agent handle_other_border_change)
			(create {OVERHEAD_STYLE_CHANGE_EVENT}).subscribe (agent handle_overhead_style_change)
			(create {VENDOR_PART_SEQUENCE_CHANGE_EVENT}).subscribe (agent handle_vendor_part_sequence_change)
			(create {WAFER_PART_ID_SRC_CHANGE_EVENT}).subscribe (agent handle_wafer_part_id_src_change)
			(create {WAFER_PART_ID_CHANGE_EVENT}).subscribe (agent handle_wafer_part_id_change)
			(create {MASK_PART_ID_CHANGE_EVENT}).subscribe (agent handle_mask_part_id_change)
			(create {FATAL_EXCEPTION_EVENT}).subscribe (agent handle_fatal_exception)
			(create {RUN_GRABBED_EVENT}).subscribe (agent handle_run_grabbed)
			(create {RUN_GRAB_FAILED_EVENT}).subscribe (agent handle_run_grab_failed)
			(create {RUN_RELEASED_EVENT}).subscribe (agent handle_run_released)
			(create {RUN_RELEASE_FAILED_EVENT}).subscribe (agent handle_run_release_failed)
			(create {GDS_MERGES_DONE_EVENT}).subscribe (agent handle_gds_merges_done)
			(create {GDS_MERGE_FAILED_EVENT}).subscribe (agent handle_gds_merge_failed)
			(create {GDS_MERGE_SUBMITTED_EVENT}).subscribe (agent handle_gds_merge_submitted)
			(create {GDS_MERGE_RELEASED_EVENT}).subscribe (agent handle_gds_merge_released)
			(create {GDS_MERGE_CHANGED_EVENT}).subscribe (agent handle_gds_merge_changed)
			(create {GDS_MERGE_RESET_EVENT}).subscribe (agent handle_gds_merge_reset)
			(create {DIE_FRACTURES_DONE_EVENT}).subscribe (agent handle_die_fractures_done)
			(create {DIE_FRACTURE_FAILED_EVENT}).subscribe (agent handle_die_fracture_failed)
			(create {DIE_FRACTURE_SUBMITTED_EVENT}).subscribe (agent handle_die_fracture_submitted)
			(create {DIE_FRACTURE_RELEASED_EVENT}).subscribe (agent handle_die_fracture_released)
			(create {DIE_FRACTURE_CHANGED_EVENT}).subscribe (agent handle_die_fracture_changed)
			(create {DIE_FRACTURE_RESET_EVENT}).subscribe (agent handle_die_fracture_reset)
			(create {LEVEL_MERGES_DONE_EVENT}).subscribe (agent handle_level_merges_done)
			(create {LEVEL_MERGE_FAILED_EVENT}).subscribe (agent handle_level_merge_failed)
			(create {LEVEL_MERGE_SUBMITTED_EVENT}).subscribe (agent handle_level_merge_submitted)
			(create {LEVEL_MERGE_RELEASED_EVENT}).subscribe (agent handle_level_merge_released)
			(create {LEVEL_MERGE_CHANGED_EVENT}).subscribe (agent handle_level_merge_changed)
			(create {LEVEL_MERGE_RESET_EVENT}).subscribe (agent handle_level_merge_reset)
			(create {LEVEL_FILLS_DONE_EVENT}).subscribe (agent handle_level_fills_done)
			(create {LEVEL_FILL_FAILED_EVENT}).subscribe (agent handle_level_fill_failed)
			(create {LEVEL_FILL_SUBMITTED_EVENT}).subscribe (agent handle_level_fill_submitted)
			(create {LEVEL_FILL_RELEASED_EVENT}).subscribe (agent handle_level_fill_released)
			(create {LEVEL_FILL_CHANGED_EVENT}).subscribe (agent handle_level_fill_changed)
			(create {LEVEL_FILL_RESET_EVENT}).subscribe (agent handle_level_fill_reset)
			(create {FILL_SELECTOR_DONE_EVENT}).subscribe (agent handle_fill_selector_done)
			(create {FILL_SELECTOR_FAILED_EVENT}).subscribe (agent handle_fill_selector_failed)
			(create {FILL_SELECTOR_SUBMITTED_EVENT}).subscribe (agent handle_fill_selector_submitted)
			(create {FILL_SELECTOR_RELEASED_EVENT}).subscribe (agent handle_fill_selector_released)
			(create {FILL_SELECTOR_CHANGED_EVENT}).subscribe (agent handle_fill_selector_changed)
			(create {FILL_SELECTOR_RESET_EVENT}).subscribe (agent handle_fill_selector_reset)
			(create {CHARGE_ADJUSTMENT_EVENT}).subscribe (agent handle_charge_adjustment)
			(create {UNUSED_OPTIONS_EVENT}).subscribe (agent handle_unused_options)
			(create {UNRESOLVED_ACCT_ISSUE_EVENT}).subscribe (agent handle_unresolved_account_issue)
			(create {UNRESOLVED_PROJ_ISSUE_EVENT}).subscribe (agent handle_unresolved_project_issue)
			(create {PHASE_CHANGE_EVENT}).subscribe (agent handle_phase_change)
			(create {LEVEL_DENSITY_EVENT}).subscribe (agent handle_level_density)
			(create {PROBING_FILES_EVENT}).subscribe (agent handle_probing_files)
			(create {TEST_VEHICLES_EVENT}).subscribe (agent handle_test_vehicles)
			(create {SCMOS_CONVERSION_REQUIRED_EVENT}).subscribe (agent handle_scmos_conversion_required)
			(create {GDS_MERGE_RESULTS_EVENT}).subscribe (agent handle_gds_merge_results)
			(create {FOUNDRY_ECCN_GENERATED_EVENT}).subscribe (agent handle_foundry_eccn_generated)
			(create {INTERNAL_REQUEST_SUBMITTED_EVENT}).subscribe (agent handle_internal_request_submitted)
			(create {RUN_POSTED_EVENT}).subscribe (agent handle_run_posted)
			(create {RUN_RTM_EVENT}).subscribe (agent handle_run_rtm)
			(create {DED_MASK_INVOICE_EVENT}).subscribe (agent handle_ded_mask_invoice)
			(create {PACKING_VERSION_CREATED_EVENT}).subscribe (agent handle_packing_version_created)
			(create {PACKING_VERSION_SELECTED_EVENT}).subscribe (agent handle_packing_version_selected)
			(create {PACKING_OUTPUT_EVENT}).subscribe (agent handle_packing_output)
		end

	handle_unsubscribed_event (event: UNSUBSCRIBED_EVENT_EVENT)
		do
			log_internal_error ("no subscribers for event " + event.event.generating_type)
		end

	handle_database_login_try (event: DATABASE_LOGIN_TRY_EVENT)
		do
			log_operation ("Trying database login for user " + event.user_name + ", database " + event.connect_string)
		end

	handle_database_login_ok (event: DATABASE_LOGIN_OK_EVENT)
		do
			log_operation ("Database login succeeded for user " + event.user_name + ", database " + event.connect_string)
		end

	handle_database_login_failed (event: DATABASE_LOGIN_FAILED_EVENT)
		do
			log_operation ("Database login failed for user " + event.user_name + ", database " + event.connect_string)
		end

	handle_accept (event: ACCEPT_EVENT)
		do
			log_operation ("User clicked " + event.label + " in " + event.title)
		end

	handle_decline (event: DECLINE_EVENT)
		do
			log_operation ("User clicked " + event.label + " in " + event.title)
		end

	handle_abort (event: ABORT_EVENT)
		do
			log_operation ("User clicked " + event.label + " in " + event.title)
		end

	handle_retry (event: RETRY_EVENT)
		do
			log_operation ("User clicked " + event.label + " in " + event.title)
		end

	handle_ignore (event: IGNORE_EVENT)
		do
			log_operation ("User clicked " + event.label + " in " + event.title)
		end

	handle_continue (event: CONTINUE_EVENT)
		do
			log_operation ("User clicked " + event.label + " in " + event.title)
		end

	handle_boolean_answer (event: BOOLEAN_ANSWER_EVENT)
		do
			log_operation ("User clicked " + event.label + " in " + event.title)
		end

	handle_notify (event: NOTIFY_EVENT)
		do
			log_operation ("User clicked " + event.label + " in " + event.title)
		end

	handle_selected_choice (event: SELECTED_CHOICE_EVENT)
		do
			log_operation ("User selected " + su.double_quoted (event.value))
		end

	handle_input_value (event: INPUT_VALUE_EVENT)
		do
			log_operation ("Input value is " + su.double_quoted (event.value))
		end

	handle_labeled_input_value (event: LABELED_INPUT_VALUE_EVENT)
		do
			log_operation ("Selected label is " + su.double_quoted (event.label))
			log_operation ("Selected value is " + su.double_quoted (event.value))
		end

	handle_file_open_try (event: FILE_OPEN_TRY_EVENT)
		do
		end

	handle_file_open_ok (event: FILE_OPEN_OK_EVENT)
		do
			log_operation ("Opened file for " + event.mode + ": " + event.file_name)
		end

	handle_file_open_failed (event: FILE_OPEN_FAILED_EVENT)
		do
			log_operation ("Failed to open file for " + event.mode + ": " + event.file_name + " (" + event.reason + ")")
		end

	handle_file_close (event: FILE_CLOSE_EVENT)
		do
			log_operation ("Closed file " + event.file_name)
		end

	handle_file_delete_try (event: FILE_DELETE_TRY_EVENT)
		do
		end

	handle_file_delete_ok (event: FILE_DELETE_OK_EVENT)
		do
			log_operation ("Deleted file " + event.file_name)
		end

	handle_file_delete_failed (event: FILE_DELETE_FAILED_EVENT)
		do
			log_operation ("Failed to delete file " + event.file_name)
		end

	handle_file_retrieve_ok (event: FILE_RETRIEVE_OK_EVENT)
		do
			log_operation ("Retrieved object structure saved in file " + event.file_name)
		end

	handle_file_retrieve_failed (event: FILE_RETRIEVE_FAILED_EVENT)
		do
			log_operation ("Failed to retrieve object structure saved in file " + event.file_name)
		end

	handle_file_group_change_ok (event: FILE_GROUP_CHANGE_OK_EVENT)
		do
			log_operation ("Changed group of " + event.file_name + " to " + event.group_name)
		end

	handle_file_group_change_failed (event: FILE_GROUP_CHANGE_FAILED_EVENT)
		do
			log_operation ("Failed to change group of " + event.file_name + " to " + event.group_name)
		end

	handle_dir_create_try (event: DIR_CREATE_TRY_EVENT)
		do
		end

	handle_dir_create_ok (event: DIR_CREATE_OK_EVENT)
		do
			log_operation ("Created directory " + event.directory_name)
		end

	handle_dir_create_failed (event: DIR_CREATE_FAILED_EVENT)
		do
			log_operation ("Failed to create directory " + event.directory_name)
		end

	handle_dir_delete_try (event: DIR_DELETE_TRY_EVENT)
		do
		end

	handle_dir_delete_ok (event: DIR_DELETE_OK_EVENT)
		do
			log_operation ("Removed directory " + event.directory_name)
		end

	handle_dir_delete_failed (event: DIR_DELETE_FAILED_EVENT)
		do
			log_operation ("Failed to remove directory " + event.directory_name)
		end

	handle_dir_open_ok (event: DIR_OPEN_OK_EVENT)
		do
			log_operation ("Opened directory " + event.directory_name)
		end

	handle_dir_open_failed (event: DIR_OPEN_FAILED_EVENT)
		do
			log_operation ("Failed to open directory " + event.directory_name)
		end

	handle_dir_close (event: DIR_CLOSE_EVENT)
		do
			log_operation ("Closed directory " + event.directory_name)
		end

	handle_symlink_create_ok (event: SYMLINK_CREATE_OK_EVENT)
		do
			log_operation ("Created symbolic link " + event.new_path_name + " to " + event.old_path_name)
		end

	handle_symlink_create_failed (event: SYMLINK_CREATE_FAILED_EVENT)
		do
			log_operation ("Failed to create symbolic link from " + event.new_path_name + " to " + event.old_path_name)
		end

	handle_link_delete_ok (event: LINK_DELETE_OK_EVENT)
		do
			log_operation ("Removed link " + event.path_name)
		end

	handle_link_delete_failed (event: LINK_DELETE_FAILED_EVENT)
		do
			log_operation ("Failed to remove link " + event.path_name)
		end

	handle_lock_try (event: LOCK_TRY_EVENT)
		do
		end

	handle_lock_ok (event: LOCK_OK_EVENT)
		local
			lock: LOCK
			mode: STRING
		do
			lock := event.lock
			if lock.is_exclusive then
				mode := "exclusive"
			else
				mode := "shared"
			end
			log_operation ("Got " + mode + " lock on file " + event.lock.lock_name)
		end

	handle_lock_failed (event: LOCK_FAILED_EVENT)
		local
			lock: LOCK
			mode: STRING
		do
			lock := event.lock
			if lock.is_exclusive then
				mode := "exclusive"
			else
				mode := "shared"
			end
			log_operation ("Failed to get " + mode + " lock on file " + event.lock.lock_name)
		end

	handle_unlock_ok (event: UNLOCK_OK_EVENT)
		do
			log_operation ("Unlocked file " + event.lock.lock_name)
		end

	handle_role_set_ok (event: ROLE_SET_OK_EVENT)
		do
			log_operation ("Role set to " + event.role)
		end

	handle_role_set_failed (event: ROLE_SET_FAILED_EVENT)
		do
			log_operation ("Cannot set role to " + event.role)
		end

	handle_run_created (event: RUN_CREATED_EVENT)
		do
			log_operation ("Created run " + event.run_id)
		end

	handle_run_deleted (event: RUN_DELETED_EVENT)
		do
			log_operation ("Deleted run " + event.run_id)
		end

	handle_run_start_close (event: RUN_START_CLOSE_EVENT)
		do
			log_operation ("Started run closing session for " + event.run_id)
		end

	handle_run_end_close (event: RUN_END_CLOSE_EVENT)
		do
			log_operation ("Terminated run closing session for " + event.run_id)
		end

	handle_rows_inserted (event: ROWS_INSERTED_EVENT)
		do
			log_operation ("Inserted " + event.count.out + " rows into " + event.table)
		end

	handle_rows_updated (event: ROWS_UPDATED_EVENT)
		do
			log_operation ("Updated "  + event.count.out + " rows in " + event.table)
		end

	handle_rows_deleted (event: ROWS_DELETED_EVENT)
		do
			log_operation ("Deleted "  + event.count.out + " rows from " + event.table)
		end

	handle_row_lock_ok (event: ROW_LOCK_OK_EVENT)
		local
			row: DB_LOCKABLE_ROW
		do
			row := event.row
			log_operation ("Locked " + row_identification (row))
		end

	handle_row_lock_failed (event: ROW_LOCK_FAILED_EVENT)
		local
			row: DB_LOCKABLE_ROW
		do
			row := event.row
			if row.is_locked_but_changed then
				log_operation ("Locked row but it changed since fetch - " + row_identification (row))
			elseif row.is_busy then
				log_operation ("Failed to lock row (busy) - " + row_identification (row))
			elseif row.is_gone then
				log_operation ("Failed to lock row (gone) - " + row_identification (row))
			end
		end

	handle_operator_ok (event: OPERATOR_OK_EVENT)
		do
			log_operation ("User " + event.user_name + " is valid operator")
		end

	handle_operator_invalid (event: OPERATOR_INVALID_EVENT)
		do
			log_operation ("User " + event.user_name + " is not a valid operator")
		end

	handle_bonding_generation_started (event: BONDING_GENERATION_STARTED_EVENT)
		do
			log_operation ("Bonding diagram generation started")
		end

	handle_bonding_generation_ended (event: BONDING_GENERATION_ENDED_EVENT)
		do
			log_operation ("Bonding diagram generation ended")
		end

	handle_lockout_started (event: LOCK_OUT_STARTED_EVENT)
		do
			log_operation ("Run closing lockout started")
		end

	handle_lockout_ended (event: LOCK_OUT_ENDED_EVENT)
		do
			log_operation ("Run closing lockout ended")
		end

	handle_post (event: POST_EVENT)
		do
			log_operation ("Transaction posted")
		end

	handle_commit (event: COMMIT_EVENT)
		do
			log_operation ("Transaction committed")
		end

	handle_rollback (event: ROLLBACK_EVENT)
		do
			log_operation ("Transaction rolled back")
		end

	handle_step_do_started (event: RC_STEP_DO_STARTED_EVENT)
		do
			set_current_step_name (event.step.step_name)
			log_operation ("Started " + event.step.description + applicable_note (event.is_applicable))
		end

	handle_step_undo_started (event: RC_STEP_UNDO_STARTED_EVENT)
		local
			undo_type: STRING
		do
			set_current_step_name (event.step.step_name)
			undo_type := undo_type_text (event.save_state)
			log_operation ("Started " + undo_type + " undo of " + event.step.description + applicable_note (event.is_applicable))
		end

	handle_step_do_ended (event: RC_STEP_DO_ENDED_EVENT)
		do
			set_current_step_name (Void)
			log_operation ("Finished " + event.step.description + applicable_note (event.is_applicable))
		end

	handle_step_undo_ended (event: RC_STEP_UNDO_ENDED_EVENT)
		local
			undo_type: STRING
		do
			set_current_step_name (Void)
			undo_type := undo_type_text (event.save_state)
			log_operation ("Finished " + undo_type + " undo of " + event.step.description + applicable_note (event.is_applicable))
		end

	handle_step_reentered (event: RC_STEP_REENTERED_EVENT)
		do
			set_current_step_name (Void)
			log_operation ("Re-entered " + event.step.description)
		end

	handle_step_do_aborted (event: RC_STEP_DO_ABORTED_EVENT)
		do
			set_current_step_name (Void)
			log_operation ("Aborted " + event.step.description)
		end

	handle_step_undo_aborted (event: RC_STEP_UNDO_ABORTED_EVENT)
		do
			set_current_step_name (Void)
			log_operation ("Aborted undo of " + event.step.description)
		end

	handle_run_clerk_change (event: RUN_CLERK_CHANGE_EVENT)
		do
			log_set_operation ("Run clerk", event.run_clerk)
		end

	handle_design_engineer_change (event: DESIGN_ENGINEER_CHANGE_EVENT)
		do
			log_set_operation ("Design engineer", event.design_engineer)
		end

	handle_test_engineer_change (event: TEST_ENGINEER_CHANGE_EVENT)
		do
			log_set_operation ("Test engineer", event.test_engineer)
		end

	handle_run_closer_change (event: RUN_CLOSER_CHANGE_EVENT)
		do
			log_set_operation ("Run closer", event.run_closer)
		end

	handle_file_root_change (event: FILE_ROOT_CHANGE_EVENT)
		do
			log_set_operation ("Final MEBES file root", event.root)
		end

	handle_run_type_change (event: RUN_TYPE_CHANGE_EVENT)
		do
			log_set_operation ("Run type", event.run_type)
		end

	handle_overhead_run_id_change (event: OVERHEAD_RUN_ID_CHANGE_EVENT)
		do
			log_set_operation ("Overhead run id", event.overhead_run_id)
		end

	handle_educational_status_change (event: EDUCATIONAL_STATUS_CHANGE_EVENT)
		do
			log_set_operation ("Educational run", event.is_educational)
		end

	handle_taxi_status_change (event: TAXI_STATUS_CHANGE_EVENT)
		do
			log_set_operation ("Taxi run", event.is_taxi)
		end

	handle_wafer_techn_change (event: WAFER_TECHN_CHANGE_EVENT)
		do
			log_set_operation ("Wafer techn", event.wafer_techn)
		end

	handle_mask_techn_change (event: MASK_TECHN_CHANGE_EVENT)
		do
			log_set_operation ("Mask techn", event.mask_techn)
		end

	handle_designated_dt_change (event: DESIGNATED_DT_CHANGE_EVENT)
		do
			log_set_operation ("Designated design techn", event.designated_design_techn)
		end

	handle_field_set_change (event: FIELD_SET_CHANGE_EVENT)
		do
			log_set_operation ("Field set name", event.field_set)
		end

	handle_step_pattern_change (event: STEP_PATTERN_CHANGE_EVENT)
		do
			log_set_operation ("Field step pattern", event.field_step_pattern)
		end

	handle_close_date_change (event: CLOSE_DATE_CHANGE_EVENT)
		do
			log_set_operation ("Run close date", event.close_date)
		end

	handle_sched_run_no_change (event: SCHED_RUN_NO_CHANGE_EVENT)
		do
			log_set_operation ("Scheduled run number", event.sched_run_no)
		end

	handle_other_border_change (event: OTHER_BORDER_CHANGE_EVENT)
		do
			log_set_operation ("Other border", event.other_border)
		end

	handle_overhead_style_change (event: OVERHEAD_STYLE_CHANGE_EVENT)
		do
			log_set_operation ("Overhead style", event.overhead_style)
		end

	handle_vendor_part_sequence_change (event: VENDOR_PART_SEQUENCE_CHANGE_EVENT)
		do
			log_set_operation ("Vendor part sequence", event.vendor_part_sequence)
		end

	handle_wafer_part_id_src_change (event: WAFER_PART_ID_SRC_CHANGE_EVENT)
		do
			log_set_operation ("Wafer part id source", event.wafer_part_id_source)
		end

	handle_wafer_part_id_change (event: WAFER_PART_ID_CHANGE_EVENT)
		do
			log_set_operation ("Wafer part id", event.wafer_part_id)
		end

	handle_mask_part_id_change (event: MASK_PART_ID_CHANGE_EVENT)
		do
			log_set_operation ("Mask part id", event.mask_part_id)
		end

	handle_fatal_exception (event: FATAL_EXCEPTION_EVENT)
		do
			log_operation ("Application raised fatal exception")
		end

	handle_run_grabbed (event: RUN_GRABBED_EVENT)
		do
			log_operation ("Grabbed run " + event.run_id)
		end

	handle_run_grab_failed (event: RUN_GRAB_FAILED_EVENT)
		do
			log_operation ("Failed to grab run " + event.run_id)
		end

	handle_run_released (event: RUN_RELEASED_EVENT)
		do
			log_operation ("Released run " + event.run_id)
		end

	handle_run_release_failed (event: RUN_RELEASE_FAILED_EVENT)
		do
			log_operation ("Failed to release run " + event.run_id)
		end

	handle_gds_merges_done (event: GDS_MERGES_DONE_EVENT)
		local
			run: STRING
		do
			log_operation ("All GDS merges completed")
			run := session.id_value
			send_email_to_user ("merged GDS files created", "All jobs to create merged GDS files for run " + run + " have completed.")
		end

	handle_gds_merge_submitted (event: GDS_MERGE_SUBMITTED_EVENT)
		local
			first: GDS_MERGE_JOB
			die_ids, fld_names: STRING
		do
			first := event.rows.first
			if first.is_die_merge then
				die_ids := die_ids_string (event.rows)
				log_operation ("GDS merge jobs submitted for dies " + die_ids)
			else
				fld_names := field_names_string (event.rows)
				log_operation ("GDS merge jobs submitted for fields " + fld_names)
			end
		end

	handle_gds_merge_released (event: GDS_MERGE_RELEASED_EVENT)
		local
			first: GDS_MERGE_JOB
			die_ids, fld_names: STRING
		do
			first := event.rows.first
			if first.is_die_merge then
				die_ids := die_ids_string (event.rows)
				log_operation ("GDS merge jobs released for dies " + die_ids)
			else
				fld_names := field_names_string (event.rows)
				log_operation ("GDS merge jobs released for fields " + fld_names)
			end
		end

	handle_gds_merge_changed (event: GDS_MERGE_CHANGED_EVENT)
		local
			rows: LIST [GDS_MERGE_JOB]
			row: GDS_MERGE_JOB
		do
			rows := event.rows
			from
				rows.start
			until
				rows.after
			loop
				row := rows.item
				if row.is_die_merge then
					log_operation ("GDS merge status for die " + row.die_id + " changed to " + row.job_status)
				else
					log_operation ("GDS merge status for field " + row.field_name + " changed to " + row.job_status)
				end
				rows.forth
			end
		end

	handle_gds_merge_reset (event: GDS_MERGE_RESET_EVENT)
		local
			first: GDS_MERGE_JOB
			die_ids, fld_names: STRING
		do
			
			first := event.rows.first
			if first.is_die_merge then
				die_ids := die_ids_string (event.rows)
				log_operation ("GDS merge jobs reset for dies " + die_ids)
			else
				fld_names := field_names_string (event.rows)
				log_operation ("GDS merge jobs reset for field " + fld_names)
			end
		end

	handle_gds_merge_failed (event: GDS_MERGE_FAILED_EVENT)
		local
			run, entity: STRING
			first: GDS_MERGE_JOB
			failed_ids, aborted_ids, body: STRING
		do
			run := session.id_value
			if not event.failed_rows.is_empty then
				first := event.failed_rows.first
			else
				first := event.aborted_rows.first
			end
			if first.is_die_merge then
				failed_ids := die_ids_string (event.failed_rows)
				aborted_ids := die_ids_string (event.aborted_rows)
				entity := "die IDs"
			else
				failed_ids := field_names_string (event.failed_rows)
				aborted_ids := field_names_string (event.aborted_rows)
				entity := "fields"
			end
			body := ""
			if not failed_ids.is_empty then
				log_operation ("GDS merge jobs failed for " + entity + " " + failed_ids)
				body.append (run + " GDS merge jobs failed for " + entity + ":%N%N   " + failed_ids + "%N")
			end
			if not aborted_ids.is_empty then
				log_operation ("GDS merge jobs aborted for " + entity + " " + aborted_ids)
				if not body.is_empty then
					body.extend ('%N')
				end
				body.append (run + " GDS merge jobs aborted for " + entity + ":%N%N   " + aborted_ids + "%N")
			end
			body.extend ('%N')
			body.append ("No further notifications will be sent until you Unmonitor run and%Nthen Monitor it again.%N")
			
			send_email_to_user ("GDS merge job(s) failed", body)
		end

	handle_die_fractures_done (event: DIE_FRACTURES_DONE_EVENT)
		local
			run: STRING
		do
			log_operation ("All die fractures completed")
			run := session.id_value
			send_email_to_user ("die fractures done", "All die fractures for run " + run + " have completed.")
		end

	handle_die_fracture_submitted (event: DIE_FRACTURE_SUBMITTED_EVENT)
		local
			die_ids: STRING
		do
			die_ids := die_ids_string (event.dies)
			log_operation ("Fracture jobs submitted for dies " + die_ids)
		end

	handle_die_fracture_released (event: DIE_FRACTURE_RELEASED_EVENT)
		local
			die_ids: STRING
		do
			die_ids := die_ids_string (event.dies)
			log_operation ("Fracture jobs released for dies " + die_ids)
		end

	handle_die_fracture_changed (event: DIE_FRACTURE_CHANGED_EVENT)
		local
			dies: LIST [DIE_JOB]
			die: DIE_JOB
		do
			dies := event.dies
			from
				dies.start
			until
				dies.after
			loop
				die := dies.item
				log_operation ("Die fracture status for " + die.die_id + " changed to " + die.job_status)
				dies.forth
			end
		end

	handle_die_fracture_reset (event: DIE_FRACTURE_RESET_EVENT)
		local
			die_ids: STRING
		do
			die_ids := die_ids_string (event.dies)
			log_operation ("Die fractures reset for dies " + die_ids)
		end

	handle_die_fracture_failed (event: DIE_FRACTURE_FAILED_EVENT)
		local
			run: STRING
			failed_ids, aborted_ids, body: STRING
		do
			run := session.id_value
			failed_ids := die_ids_string (event.failed_dies)
			aborted_ids := die_ids_string (event.aborted_dies)
			body := ""
			if not failed_ids.is_empty then
				log_operation ("Fractures failed for die ids " + failed_ids)
				body.append (run + " fractures failed for die ids:%N%N   " + failed_ids + "%N")
			end
			if not aborted_ids.is_empty then
				log_operation ("Fractures aborted for die ids " + aborted_ids)
				if not body.is_empty then
					body.extend ('%N')
				end
				body.append (run + " fractures aborted for die ids:%N%N   " + aborted_ids + "%N")
			end
			body.extend ('%N')
			body.append ("No further notifications will be sent until you Unmonitor run and%Nthen Monitor it again.%N")
			
			send_email_to_user ("die fracture(s) failed", body)
		end

	handle_level_merges_done (event: LEVEL_MERGES_DONE_EVENT)
		do
			handle_levels_done ("merge")
		end

	handle_level_merge_submitted (event: LEVEL_MERGE_SUBMITTED_EVENT)
		local
			level_ids: STRING
		do
			level_ids := level_ids_string (event.levels)
			log_operation ("Merge jobs submitted for levels " + level_ids)
		end

	handle_level_merge_released (event: LEVEL_MERGE_RELEASED_EVENT)
		local
			level_ids: STRING
		do
			level_ids := level_ids_string (event.levels)
			log_operation ("Merge jobs released for levels " + level_ids)
		end

	handle_level_merge_changed (event: LEVEL_MERGE_CHANGED_EVENT)
		do
			handle_levels_changed (event.levels, "merge")
		end

	handle_level_merge_reset (event: LEVEL_MERGE_RESET_EVENT)
		local
			level_ids: STRING
		do
			level_ids := level_ids_string (event.levels)
			log_operation ("Level merges reset for levels " + level_ids)
		end

	handle_level_merge_failed (event: LEVEL_MERGE_FAILED_EVENT)
		do
			handle_levels_failed (event.failed_levels, event.aborted_levels, "merge")
		end

	handle_level_fills_done (event: LEVEL_FILLS_DONE_EVENT)
		do
			handle_levels_done ("fill")
		end

	handle_level_fill_submitted (event: LEVEL_FILL_SUBMITTED_EVENT)
		local
			level_ids: STRING
		do
			level_ids := level_ids_string (event.levels)
			log_operation ("Fill jobs submitted for levels " + level_ids)
		end

	handle_level_fill_released (event: LEVEL_FILL_RELEASED_EVENT)
		local
			level_ids: STRING
		do
			level_ids := level_ids_string (event.levels)
			log_operation ("Fill jobs released for levels " + level_ids)
		end

	handle_level_fill_changed (event: LEVEL_FILL_CHANGED_EVENT)
		do
			handle_levels_changed (event.levels, "fill")
		end

	handle_level_fill_reset (event: LEVEL_FILL_RESET_EVENT)
		local
			level_ids: STRING
		do
			level_ids := level_ids_string (event.levels)
			log_operation ("Level fills reset for levels " + level_ids)
		end

	handle_level_fill_failed (event: LEVEL_FILL_FAILED_EVENT)
		do
			handle_levels_failed (event.failed_levels, event.aborted_levels, "fill")
		end

	handle_levels_done (type: STRING)
		local
			run: STRING
		do
			log_operation ("All level " + type + "s completed")
			run := session.id_value
			send_email_to_user ("level " + type + " jobs done", "All level " + type + " jobs for run " + run + " have completed.")
		end

	handle_levels_changed (levels: LIST [LEVEL_JOB] type: STRING)
		local
			level: LEVEL_JOB
		do
			from
				levels.start
			until
				levels.after
			loop
				level := levels.item
				log_operation ("Level " + type + " status for " + level.level_identifier + " changed to " + level.job_status)
				levels.forth
			end
		end

	handle_levels_failed (failed_levels, aborted_levels: LIST [LEVEL_JOB] type: STRING)
		local
			run, cap_type: STRING
			failed_ids, aborted_ids, body: STRING
		do
			run := session.id_value
			create cap_type.make (type.count)
			su.append_capitalized (cap_type, type)
			failed_ids := level_ids_string (failed_levels)
			aborted_ids := level_ids_string (aborted_levels)
			body := ""
			if not failed_ids.is_empty then
				log_operation (cap_type + " jobs failed for level ids " + failed_ids)
				body.append (run + " " + type + " jobs failed for level ids:%N%N   " + failed_ids + "%N")
			end
			if not aborted_ids.is_empty then
				log_operation (cap_type + " jobs aborted for level ids " + aborted_ids)
				if not body.is_empty then
					body.extend ('%N')
				end
				body.append (run + " " + type + " jobs aborted for level ids:%N%N   " + aborted_ids + "%N")
			end
			body.extend ('%N')
			body.append ("No further notifications will be sent until you Unmonitor run and%Nthen Monitor it again.%N")
			
			send_email_to_user ("level " + type + " job(s) failed", body)
		end

	handle_fill_selector_done (event: FILL_SELECTOR_DONE_EVENT)
		local
			run: STRING
		do
			log_operation ("Creation of fill selector file completed")
			run := session.id_value
			send_email_to_user ("fill selector job done", "Creation of fill area selector file for run " + run + " has completed.%NReady to add fill to merged pattern files.")
		end

	handle_fill_selector_submitted (event: FILL_SELECTOR_SUBMITTED_EVENT)
		do
			log_operation ("Fill selector job submitted")
		end

	handle_fill_selector_released (event: FILL_SELECTOR_RELEASED_EVENT)
		do
			log_operation ("Fill selector job released")
		end

	handle_fill_selector_changed (event: FILL_SELECTOR_CHANGED_EVENT)
		do
			log_operation ("Fill selector job status changed to " + event.jobs.first.job_status)
		end

	handle_fill_selector_reset (event: FILL_SELECTOR_RESET_EVENT)
		do
			log_operation ("Fill selector job reset")
		end

	handle_fill_selector_failed (event: FILL_SELECTOR_FAILED_EVENT)
		local
			run, text: STRING
			body: STRING
		do
			run := session.id_value
			body := ""
			if not event.failed_jobs.is_empty then
				text := run + " Fill selector file creation job failed"
				log_operation (text)
				body.append (text)
			end
			if not event.aborted_jobs.is_empty then
				text := run + " fill selector file creation job aborted"
				log_operation (text)
				if not body.is_empty then
					body.extend ('%N')
				end
				body.append (text)
			end
			body.extend ('%N')
			body.append ("No further notifications will be sent until you Unmonitor run and%Nthen Monitor it again.%N")
			
			send_email_to_user ("fill selector job failed", body)
		end

	handle_charge_adjustment (event: CHARGE_ADJUSTMENT_EVENT)
		local
			verb: STRING
		do
			if event.reverse then
				verb := "reversed"
			else
				verb := "restored"
			end
			log_operation ("Charges " + verb + " for " + event.count.out + " line items")
			log_operation ("Total amount of adjustment was " + nu.money_formatted_number (event.amount))
		end

	handle_unused_options (event: UNUSED_OPTIONS_EVENT)
		do
			send_email_to_list (rc_env.unused_options_to_list, event.subject, event.message)
		end

	handle_unresolved_account_issue (event: UNRESOLVED_ACCT_ISSUE_EVENT)
		do
			send_email_to_list (rc_env.unresolved_issue_to_list, event.subject, event.message)
		end

	handle_unresolved_project_issue (event: UNRESOLVED_PROJ_ISSUE_EVENT)
		do
			send_email_to_user (event.subject, event.message)
		end

	handle_phase_change (event: PHASE_CHANGE_EVENT)
		do
			log_set_operation ("Last completed phase", event.phase)
		end

	handle_level_density (event: LEVEL_DENSITY_EVENT)
		do
			send_email_to_list (rc_env.level_density_to_list, event.subject, event.message)
		end

	handle_probing_files (event: PROBING_FILES_EVENT)
		do
			send_email_to_list (rc_env.probing_files_to_list, event.subject, event.message)
		end

	handle_test_vehicles (event: TEST_VEHICLES_EVENT)
		do
			send_email_to_list (rc_env.test_vehicles_to_list, event.subject, event.message)
		end

	handle_scmos_conversion_required (event: SCMOS_CONVERSION_REQUIRED_EVENT)
		do
			send_email_to_list_with_reply_to (rc_env.scmos_conversion_to_list, event.subject, event.message, rc_env.user_email_address)
		end

	handle_gds_merge_results (event: GDS_MERGE_RESULTS_EVENT)
		do
			send_email_to_list (rc_env.gds_merge_to_list, event.subject, event.message)
		end

	handle_foundry_eccn_generated (event: FOUNDRY_ECCN_GENERATED_EVENT)
		do
			send_email_to_list (rc_env.export_control_to_list, event.subject, event.message)
		end

	handle_internal_request_submitted (event: INTERNAL_REQUEST_SUBMITTED_EVENT)
		do
			log_operation (event.request.internal_request_type + " front end internal request submitted for " + event.design_no.out + " (die " + event.die_id + ")")
		end

	handle_run_posted (event: RUN_POSTED_EVENT)
		do
			send_email_to_list (rc_env.run_posted_to_list, event.subject, event.message)
		end

	handle_run_rtm (event: RUN_RTM_EVENT)
		do
			send_email_to_list (rc_env.run_rtm_to_list, event.subject, event.message)
		end

	handle_ded_mask_invoice (event: DED_MASK_INVOICE_EVENT)
		do
			send_email_to_list (rc_env.mask_invoice_to_list, event.subject, event.message)
		end

	handle_packing_version_created (event: PACKING_VERSION_CREATED_EVENT)
		local
		do
			log_operation ("Created " + event.version.version_title + " of packing " + event.version.packing_id)
		end

	handle_packing_version_selected (event: PACKING_VERSION_SELECTED_EVENT)
		do
			log_operation ("Switched to " + event.version.version_title + " of packing " + event.version.packing_id)
		end

	handle_packing_output (event: PACKING_OUTPUT_EVENT)
		do
			log_operation (event.message)
		end

	handle_condition (event: CONDITION_EVENT)
		local
			cond: APPLICATION_CONDITION
		do
			cond := event.condition
			log_error (event.message)
			if session.preferences.is_unattended_mode_enabled then
		
				send_email_to_user ("run closing stopped", event.message)
			end
		end

feature {NONE} -- Implementation

	session_manager: RC_SESSION_MANAGER
			-- Session manager for access to current session

	log_operation (s: STRING)
		require
			string_exists: s /= Void
		local
			sess: RC_SESSION
		do
			sess := session
			if sess /= Void then
				sess.log_operation (s)
			end
		end

	log_set_operation (what, value: STRING)
		require
			what_exists: what /= Void
			value_exists: value /= Void
		do
			log_operation (what + " set to " + su.double_quoted (value))
		end

	log_error (s: STRING)
		require
			string_exists: s /= Void
		local
			sess: RC_SESSION
		do
			sess := session
			if sess /= Void then
				sess.log_error (s)
			end
		end

	log_internal_error (s: STRING)
		require
			string_exists: s /= Void
		do
			log_error ("Internal error: " + s)
		end

	send_email_to_user (subj, body: STRING)
			-- Send e-mail message to user running program
		require
			subject_exists: subj /= Void
			body_exists: body /= Void
		local
			sess: RC_SESSION
		do
			sess := session
			if sess /= Void then
				sess.send_email_to_user (subj, body)
			end
		end

	send_email_to_list (addr, subj, body: STRING)
			-- Send e-mail message to `addr' with subject `subj'
			-- and `body'
		require
			address_exists: addr /= Void
			address_nonempty: not addr.is_empty
			subject_exists: subj /= Void
			body_exists: body /= Void
		local
			sess: RC_SESSION
		do
			sess := session
			if sess /= Void then
				sess.send_email_to_list (addr, subj, body, Void)
			end
		end

	send_email_to_list_with_reply_to (addr, subj, body, repl_to: STRING)
			-- Send e-mail message to `addr' with subject `subj'
			-- and `body' and `repl_to' as reply-to field
		require
			address_exists: addr /= Void
			address_nonempty: not addr.is_empty
			subject_exists: subj /= Void
			repl_to_exists: repl_to /= Void
			body_exists: body /= Void
		local
			sess: RC_SESSION
		do
			sess := session
			if sess /= Void then
				sess.send_email_to_list (addr, subj, body, repl_to)
			end
		end

	set_current_step_name (s: STRING)
		local
			sess: RC_SESSION
		do
			sess := session
			if sess /= Void then
				sess.set_current_step_name (s)
			end
		end

	session: RC_SESSION
			-- Current session
		do
			Result := session_manager.current_session
		end

	row_identification (row: DB_IDENTIFIED_ROW): STRING
		local
			table: STRING
		do
			table := row.table_name.as_upper
			Result := "table " + table + ", rowid " + row.connection.rowid_extended_format_text (row.rowid) + " (" + row.rowid.out + ")"
		end

	undo_type_text (save_state: BOOLEAN): STRING
			-- Description of type of step undo
		do
			if save_state then
				Result := "soft"
			else
				Result := "hard"
			end
		end

	applicable_note (applicable: BOOLEAN): STRING
		do
			if applicable then
				Result := ""
			else
				Result := " (not applicable)"
			end
		end

	die_ids_string (dies: LIST [HAS_DIE_ID]): STRING
		local
			list: ARRAYED_LIST [STRING]
		do
			create list.make (dies.count)
			from
				dies.start
			until
				dies.after
			loop
				list.extend (dies.item.die_id)
				dies.forth
			end
			Result := su.joined_by (list, " ")
		end

	level_ids_string (levels: LIST [LEVEL_JOB]): STRING
		local
			list: ARRAYED_LIST [STRING]
		do
			create list.make (levels.count)
			from
				levels.start
			until
				levels.after
			loop
				list.extend (levels.item.level_identifier)
				levels.forth
			end
			Result := su.joined_by (list, " ")
		end

	field_names_string (rows: LIST [HAS_FIELD_NAME]): STRING
		local
			list: ARRAYED_LIST [STRING]
		do
			create list.make (rows.count)
			from
				rows.start
			until
				rows.after
			loop
				list.extend (rows.item.field_name)
				rows.forth
			end
			Result := su.joined_by (list, " ")
		end

invariant
	session_manager_exists: session_manager /= Void
end
