
indexing
	
	description: "Latest released version of Delta run closing system"
	author: "David Hollenberg"
	date: "January 10, 2004"

class DELTA_LATEST_VERSION
inherit
	DELTA_VERSION
		redefine
			default_create
		end
	RC_ENVIRONMENT_ACCESS
		export
			{NONE} all
		redefine
			default_create
		end
	FILE_UTILITIES_ACCESS
		export
			{NONE} all
		redefine
			default_create
		end
	UNIX_OS_ACCESS
		export
			{NONE} all
		redefine
			default_create
		end

feature {NONE} -- Creation

	default_create
		do
			refresh
		end

feature -- Properties

	number: STRING
			-- Number identifying this version
	
	release_date: STRING
			-- Date this version was released
	
feature -- Modification

	refresh
			-- Refresh information about version
		local
			fname: STRING
			f: LARGE_PLAIN_TEXT_FILE
		do
			fname := rc_env.delta_version_file
			f := fu.opened_for_read (fname)
			if f /= Void then
				f.read_line
				if not f.end_of_file then
					number := f.last_string.twin
				else
					number := Not_available
				end
				f.read_line
				if not f.end_of_file then
					release_date := f.last_string.twin
				else
					release_date := Not_available
				end
				f.close
			else
				number := Not_available
				release_date := Not_available
			end
			refresh_time := unix_os.current_time_in_seconds
		end

feature {NONE} -- Implementation

	Not_available: STRING = "(Not available)"

invariant
	number_not_void: number /= Void
	release_date_not_void: release_date /= Void
end
