
indexing

	date: "Thu Jul  3 10:30:26 2008"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DESIGN_TECHN, database user GOLDBERG"
	database_tables: 
		"DESIGN_TECHN_ID_LAYERS (MOSIS.DESIGN_TECHN_ID_LAYERS)"
			-- Included columns
			-- 	DESIGN_TECHN_ID
			-- 	INTERNAL_LAYER
			-- 	IS_MBB_LAYER
			-- 	LAYER_NAME
			-- 	LAYER_ORDER
			-- 	LAYER_ROLE
			-- 	MEBES_EXTENSION
			-- Excluded columns
			-- 	(none)

class DESIGN_TECHN_ID_LAYERS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_design_techn_id: STRING; the_layer_name: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_design_techn_id_exists: the_design_techn_id /= Void
			the_layer_name_exists: the_layer_name /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			design_techn_id := the_design_techn_id
			layer_name := the_layer_name
			is_null_design_techn_id := False
			is_null_layer_name := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 7

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  design_techn_id, internal_layer, is_mbb_layer, layer_name, layer_order,%N  layer_role, mebes_extension"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "design_techn_id_layers dtil"

	join_condition: STRING = ""

	table_name: STRING = "design_techn_id_layers"

	key_where_clause: STRING = "design_techn_id = :1 and layer_name = :2"

feature -- Values

	design_techn_id: STRING
			-- DB: VARCHAR2(50) not null

	internal_layer: BOOLEAN
			-- DB: CHAR(1) not null

	is_mbb_layer: BOOLEAN
			-- DB: CHAR(1) not null

	layer_name: STRING
			-- DB: VARCHAR2(255) not null

	layer_order: INTEGER
			-- DB: NUMBER(6,0) not null

	layer_role: STRING
			-- DB: VARCHAR2(5) not null

	mebes_extension: STRING
			-- DB: CHAR(2)

feature -- Nullness for null allowed columns

	is_null_mebes_extension: BOOLEAN

feature -- Nullness for non-null columns

	is_null_design_techn_id: BOOLEAN
	is_null_internal_layer: BOOLEAN
	is_null_is_mbb_layer: BOOLEAN
	is_null_layer_name: BOOLEAN
	is_null_layer_order: BOOLEAN
	is_null_layer_role: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (design_techn_id, r.design_techn_id)
				and equal (layer_name, r.layer_name)
			Result := Result
				and is_null_design_techn_id = r.is_null_design_techn_id
				and is_null_layer_name = r.is_null_layer_name
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and internal_layer = r.internal_layer
				and is_mbb_layer = r.is_mbb_layer
				and layer_order = r.layer_order
			Result := Result
				and equal (layer_role, r.layer_role)
				and equal (mebes_extension, r.mebes_extension)
			Result := Result
				and is_null_internal_layer = r.is_null_internal_layer
				and is_null_is_mbb_layer = r.is_null_is_mbb_layer
				and is_null_layer_order = r.is_null_layer_order
				and is_null_layer_role = r.is_null_layer_role
				and is_null_mebes_extension = r.is_null_mebes_extension
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 50)
			q.select_boolean (2)
			q.select_boolean (3)
			q.select_string (4, 255)
			q.select_integer (5)
			q.select_string (6, 5)
			q.select_string (7, 2)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			internal_layer := q.boolean_value (2)
			is_mbb_layer := q.boolean_value (3)
			layer_order := q.integer_value (5)
		end

	fill_in_references (q: SQL_QUERY)
		do
			design_techn_id := q.string_value (1)
			layer_name := q.string_value (4)
			layer_role := q.string_value (6)
			mebes_extension := q.string_value (7)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, design_techn_id)
			q.get_string_value (4, layer_name)
			q.get_string_value (6, layer_role)
			q.get_string_value (7, mebes_extension)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_design_techn_id := q.is_null (1)
			is_null_internal_layer := q.is_null (2)
			is_null_is_mbb_layer := q.is_null (3)
			is_null_layer_name := q.is_null (4)
			is_null_layer_order := q.is_null (5)
			is_null_layer_role := q.is_null (6)
			is_null_mebes_extension := q.is_null (7)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_design_techn_id := True
			is_null_layer_name := True
			create design_techn_id.make (0)
			create layer_name.make (0)
		end

	set_null_nonkey
		do
			is_null_internal_layer := True
			is_null_is_mbb_layer := True
			is_null_layer_order := True
			is_null_layer_role := True
			is_null_mebes_extension := True
			create layer_role.make (0)
			create mebes_extension.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, design_techn_id, False)
			q.bind_num_to_string (2, layer_name, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and internal_layer = q.boolean_value (2)
				and is_mbb_layer = q.boolean_value (3)
				and layer_order = q.integer_value (5)
			q.get_string_value (1, s)
			Result := Result and equal (design_techn_id, s)
			q.get_string_value (4, s)
			Result := Result and equal (layer_name, s)
			q.get_string_value (6, s)
			Result := Result and equal (layer_role, s)
			q.get_string_value (7, s)
			Result := Result and equal (mebes_extension, s)
			Result := Result
				and is_null_design_techn_id = q.is_null (1)
				and is_null_internal_layer = q.is_null (2)
				and is_null_is_mbb_layer = q.is_null (3)
				and is_null_layer_name = q.is_null (4)
				and is_null_layer_order = q.is_null (5)
				and is_null_layer_role = q.is_null (6)
				and is_null_mebes_extension = q.is_null (7)
		end

end
