class DESIGN_TECHN_ID_LAYERS_ROW

inherit
	DESIGN_TECHN_ID_LAYERS_RAW

	DB_QUERY_OPTIONS
		export {NONE} all
		end;

create
	make_template, make_null, make_by_key

feature	-- the layer_role and its attributes

	is_glass_layer: BOOLEAN is
	do  if not is_null_layer_role then
		Result := roles_row.is_glass_layer
	    end
	end;

	is_pads_layer: BOOLEAN is
	do  if not is_null_layer_role then
		Result := roles_row.is_pads_layer
	    end
	end;

	is_mems_layer: BOOLEAN is
	do  if not is_null_layer_role then
		Result := roles_row.is_mems_layer
	    end
	end;

	check_min_size: BOOLEAN is
	do  if not is_null_layer_role then
		Result := roles_row.check_min_size
	    end
	end;

	check_max_size: BOOLEAN is
	do  if not is_null_layer_role then
		Result := roles_row.check_max_size
	    end
	end;

	is_non_mask_layer: BOOLEAN is
	do  if not is_null_layer_role then
		Result := roles_row.is_non_mask_layer
	    end
	end;

	is_metal_layer: BOOLEAN is
	do  if not is_null_layer_role then
		Result := roles_row.is_metal_layer
	    end
	end;

	is_label_background: BOOLEAN is
	do  if not is_null_layer_role then
		Result := roles_row.is_label_background
	    end
	end;

	is_corner_chamfer: BOOLEAN is
	do  if not is_null_layer_role then
		Result := roles_row.is_corner_chamfer
	    end
	end;

	bond_layer_priority: INTEGER is
	do  if not is_null_layer_role then
		Result := roles_row.bond_layer_priority
	    end
	end;

	is_null_bond_layer_priority: BOOLEAN is
	do  Result := is_null_layer_role or else
			roles_row.is_null_bond_layer_priority
	end;

	is_of_bond_priority(pri: INTEGER): BOOLEAN is
	do  Result := (not is_null_bond_layer_priority) and then
			bond_layer_priority = pri
	end;

	roles_row: LAYER_ROLES_ROW is
	require have_role: not is_null_layer_role
	do  if cached_roles = Void then
		create cached_roles.make_by_key 
				(connection, old_row, layer_role)
	    end;
	    Result := cached_roles
	end;

	select_roles_row(rlst: LIST[LAYER_ROLES_ROW]) is
		-- pick my cached_roles out of the list provided
	require have_list: rlst /= Void
	do  from  rlst.start; cached_roles := Void
	    until rlst.after or cached_roles /= Void
	    loop  if equal(rlst.item.layer_role, layer_role) then
			cached_roles := rlst.item
		  end;
		  rlst.forth
	    end
	end;

feature	{NONE} -- cache

	cached_roles: LAYER_ROLES_ROW

end -- DESIGN_TECHN_ID_LAYERS_ROW
