class DESIGN_TECHNS_ROW

inherit
	DESIGN_TECHNS_RAW

	DB_QUERY_OPTIONS

	STRING_UTILITIES_ACCESS

create
	make_template, make_null, make_detached, make_by_key,
	make_by_dtid_and_lambda

feature	-- bring out all the attributes of my design_techn_id

	is_scalable: BOOLEAN
	do  Result := dtid.is_scalable
	end;

	org_no: INTEGER
	do  Result := dtid.org_no
	end;

	design_type: STRING
	do  Result := dtid.design_type
	end;

	layer_map_url: STRING
	do  Result := dtid.layer_map_url
	end;

	descr: STRING
	do  Result := dtid.descr
	end;

feature	-- presentation string for design_techn 

	design_techn_handle: STRING
		-- handle used by the front end
	do  if is_scalable then
		Result := su.string_of_3(design_techn_id, ", lambda = ",
					 design_lambda)
	    else
		Result := design_techn_id
	    end
	end;

feature	-- my design_techn_id

	dtid: DESIGN_TECHN_IDS_ROW
		-- my design_techn_ids row
	do  if cached_dtid = Void then
		create cached_dtid.make_by_key(connection, old_row, design_techn_id)
	    end;
	    Result := cached_dtid
	end;

feature {NONE} -- cached data

	cached_dtid: DESIGN_TECHN_IDS_ROW

feature	{NONE} -- alternate creation

	make_by_dtid_and_lambda(conn: DB_CONNECTION; opt: DB_QUERY_OPTION;
				a_dtid, a_lamb: STRING)
		-- find using design_techn_id and design_lambda
	require	have_dtid: a_dtid /= Void
		have_lambda: a_lamb /= Void
		lambda_OK: a_lamb.is_empty or a_lamb.is_double
	local b: DB_BIND_SS
	do  create b.make(a_dtid, a_lamb)
	    make_by_alternate_key(conn, opt, dtid_lambda_filter, b)
	end;

	dtid_lambda_filter: STRING =
	"design_techn_id = :1 and nvl(design_lambda, 0) = nvl(:2, 0)"

end -- DESIGN_TECHNS_ROW
