
indexing

	author: "Generated"
	date: "Thu Jun 12 14:26:02 PDT 2003"

class DIE_ATTRIBUTES_ROW
inherit
	ABSTRACT_DIE
	DIE_ATTRIBUTES_RAW
	ROW_COUNT_CHECK_ACCESS
	ITEM_COUNT_RANGES_ACCESS
		export
			{NONE} all
		end
	CONDITION_UTILITIES
		export
			{NONE} all
		end

create
	make_template, make_null

feature -- Properties

	dies_for_run (run: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current] is
			-- All dies for run `run', ordered by die id
		require
			run_exists: run /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		do
			Result := all_rows_filtered_ordered (conn, "run_id = '" + run + "'", Void, "die_id")
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

	non_null_wafer_design_techn: like wafer_design_techn is
			-- Value of `wafer_design_techn', with error 
			-- check for nullness
		do
			check_not_null ("wafer_design_techn", is_null_wafer_design_techn, Current)
			Result := wafer_design_techn
		end

	fab_instance: IC_FAB_INSTANCES_ROW is
		require
			is_project: is_project
		do
			if cached_fab_instance = Void then
				fetch_fab_instance
			end
			Result := cached_fab_instance
		end
	
	design_no: INTEGER is
		do
			Result := fab_instance.design_no
		end
	
	scribe_orientation: STRING is
		do
			handle_hard_error ("scribe_orientation not available in DIE_ATTRIBUTES row")
		end

feature {NONE} -- Implementation

	fetch_fab_instance
		local
			row: like fab_instance
		do
			create row.make_template
			cached_fab_instance := row.row_for_run_and_die (run_id, die_id, connection, expected_count.Exactly_one)
		end

	cached_fab_instance: like fab_instance
			-- Fab instance, cached in memory

end
