
indexing
	
	description: "An operation that closes a directory"
	author: "David Hollenberg"
	date: "May 8, 2003"

class DIR_CLOSE_OP
inherit
	OPERATION
		rename
			try_operation as try_close
		end

create
	default_create

feature -- Operations

	close (d: LARGE_DIRECTORY)
			-- Close `d'
		require
			dir_exists: d /= Void
			dir_not_closed: not d.is_closed
		do
			directory := d
			execute
		end

feature {NONE} -- Implementation

	directory: LARGE_DIRECTORY
			-- Directory to try to close

	try_close
			-- Try directory close
		do
			directory.close
			publish_close_event
		end

	publish_close_event
		local
			close_event: DIR_CLOSE_EVENT
		do
			create close_event
			close_event.set_directory_name (directory.name)
			close_event.publish
		end

end
