indexing
	description:
		"A drawing circle."
	author: "Barden E. Smith"
	date:	"August 13, 2004"

class
	DRW_CIRCLE

inherit
	DRW_SHAPE

	DRW_FILLABLE
		undefine
			out
		end

	DRW_COORDINATE
		undefine
			is_equal,
			out
		end

create
	make

feature {NONE} -- Creation

	make (a_r, a_x, a_y: DOUBLE) is
			-- Assign parameters.
		do
			set (a_x, a_y)
			set_radius (a_r)
		ensure
			radius_assigned: r = a_r
			x_assigned: x = a_x
			y_assigned: y = a_y
		end

	
feature -- Access

	r: DOUBLE
			-- radius along x-axis.

feature -- Element change

	set_radius (a_r: DOUBLE) is
			-- Assign size of the circle.
		do
			r := a_r
		ensure
			radius_assigned: r = a_r
		end


feature -- Size estimating

	bounding_box: DRW_BASIC_RECTANGLE is
		do
			Result := box_transformed (create {DRW_BASIC_RECTANGLE}.make (2.0 * r, 2.0 * r, x, y))
		end

feature {DRW_PROJECTOR} -- plotting routine

	project (plotter: DRW_FIGURE_DRAWING_ROUTINES) is
		do
			if is_drawable then
				plotter.draw_figure_circle (Current)
			end
		end

end -- class DRW_CIRCLE
