indexing
	description:
		"A drawing command to close a path back to its begining."
	author: "Barden E. Smith"
	date:	"August 13, 2004"

class
	DRW_CLOSE

inherit
	ANY
		redefine
			default_create
		end
	DRW_COMMAND
		export
			{DRW_CLOSE} theta_radians, x, y
			{NONE} all
		redefine
			default_create
		end


create
	default_create,
	make_absolute

feature {NONE} -- Creation

	default_create is
			-- Assign parameters.
		do
			set_code ({DRW_COMMAND_TYPE}.drw_pathseg_closepath)
		end

	make_absolute is
			-- Stylistic difference only (svg_path)
		do
			default_create
			is_absolute := True
		end

	
feature -- Display

	svg_path: STRING is
		do
			if is_relative then
				Result := "z"
			else
				Result := "Z"
			end
		end

feature {DRW_PATH} -- Size estimating

	expand_bounding_box (context: DRW_PATH) is
			-- Expands the bonding_box info in `context' include command points
		do
			context.current_point.set_point (context.initial_point)
		end

feature {NONE} -- Implementation

	key_values: TUPLE [DOUBLE] is
		do
			Result := [0.0]
		end

end -- class DRW_CLOSE
