indexing
	description:
		"A drawing command."
	author: "Barden E. Smith"
	date:	"August 13, 2004"


deferred class
	DRW_COMMAND

inherit
	ANY
	DRW_COORDINATE
		export
			{ANY} set, set_point, transform_by, x, y
			{DRW_COMMAND} theta_radians
			{NONE} all
		undefine
			is_equal, out
		end


feature -- Access

	type_code: INTEGER


	is_absolute: BOOLEAN

	is_relative: BOOLEAN is
		do
			Result := not is_absolute
		end

	is_smooth: BOOLEAN

feature {NONE} -- Implementation

	set_code (code: INTEGER) is
			-- Assign `code' to `type_code'.
		do
			type_code := code
		ensure
			type_code_set: type_code = code
		end


	key_values: TUPLE is
		deferred
		end

feature -- Display

	svg_path: STRING is
		deferred
		ensure
			result_not_void: Result /= Void
		end

feature {DRW_PATH} -- Size estimating

	expand_bounding_box (context: DRW_PATH) is
			-- Expands the bonding_box info in `context' include command points
		require
			have_context: context /= Void
			have_initial: context.initial_point /= Void
			have_current: context.current_point /= Void
		deferred
		end

feature {DRW_COMMAND_PROCESSOR} -- Drawing commands

	execute_command (p: DRW_COMMAND_PROCESSOR) is
		require
			has_projector: p /= Void
			has_processor: p.has_processor
		do
			p.processor.i_th (type_code).call (key_values)
		end

end -- class DRW_COMMAND
