indexing
	description:
		"A drawing command processor."
	author: "Barden E. Smith"
	date:	"October 19, 2004"


deferred class
	DRW_COMMAND_PROCESSOR

feature {NONE} -- Initialization

	make_processor is
		do
			create processor.make_from_array (<<
				Agent close (1),
				Agent drawto (2, ?, ?),
				Agent drawto (3, ?, ?),
				Agent drawto (4, ?, ?),
				Agent drawto (5, ?, ?),
				Agent curveto3 (6, ?, ?, ?, ?, ?, ?),
				Agent curveto3 (7, ?, ?, ?, ?, ?, ?),
				Agent curveto2 (8, ?, ?, ?, ?),
				Agent curveto2 (9, ?, ?, ?, ?),
				Agent arcto (10, ?, ?, ?, ?, ?, ?, ?),
				Agent arcto (11, ?, ?, ?, ?, ?, ?, ?),
				Agent drawto (12, ?, ?),
				Agent drawto (13, ?, ?),
				Agent drawto (14, ?, ?),
				Agent drawto (15, ?, ?),
				Agent curveto3 (16, ?, ?, ?, ?, ?, ?),
				Agent curveto3 (17, ?, ?, ?, ?, ?, ?),
				Agent curveto2 (18, ?, ?, ?, ?),
				Agent curveto2 (19, ?, ?, ?, ?)
				>>)
		end

	arcto (code: INTEGER x, y, rrx, rry, rot: DOUBLE  fa, fs: BOOLEAN) is
		require
			positive_rad: rrx >= 0 and rry >= 0
		deferred
		end

	close (code: INTEGER) is
		deferred
		end

	curveto2 (code: INTEGER x, y, x1, y1: DOUBLE) is
		deferred
		end

	curveto3 (code: INTEGER x, y, x1, y1, x2 ,y2: DOUBLE) is
		deferred
		end

	drawto (code: INTEGER x, y: DOUBLE) is
		deferred
		end

feature {DRW_COMMAND, DRW_COMMAND_PROCESSOR} -- Path Processor

	processor: ARRAYED_LIST [PROCEDURE [DRW_COMMAND_PROCESSOR, TUPLE]]

	has_processor: BOOLEAN is
		do
			Result := processor /= Void
		end

end -- class DRW_COMMAND_PROCESSOR
