indexing
	description:
		"Abstract class for drawing of figures."
	author: "Barden E. Smith"
	date:	"August 13, 2004"


deferred class
	DRW_FIGURE_DRAWING_ROUTINES

feature -- Figure drawing

	start_page (view: DRW_BASIC_RECTANGLE page_label:STRING) is
		deferred
		end

	finish_page is
		deferred
		end

	alter_current_transform (m: DRW_MATRIX) is
			-- Update the current transform using `m'
		require
			m_not_void: m /= Void
		deferred
		end

	restore_previous_transform is
		deferred
		end

	draw_figure_circle (circle: DRW_CIRCLE) is
			-- Draw standard representation of `circle' to canvas.
		require
			circle_not_void: circle /= Void
		deferred
		end

	draw_figure_ellipse (ellipse: DRW_ELLIPSE) is
			-- Draw standard representation of `ellipse' to canvas.
		require
			ellipse_not_void: ellipse /= Void
		deferred
		end

	draw_figure_line (line: DRW_LINE) is
			-- Draw a standard representation of `line' to the canvas.
		require
			line_not_void: line /= Void
		deferred
		end

--	draw_figure_image (image: DRW_IMAGE) is
			-- Draw standard representation of `image' to canvas.
--		require
--			image_not_void: image /= Void
--		deferred
--		end

	draw_figure_polygon (polygon: DRW_POLYGON) is
			-- Draw standard representation of `polygon' to canvas.
		require
			polygon_not_void: polygon /= Void
		deferred
		end

	draw_figure_polyline (lines: DRW_POLYLINE) is
			-- Draw standard representation of `lines' to canvas.
		require
			lines_not_void: lines /= Void
		deferred
		end

	draw_figure_rectangle (rectangle: DRW_RECTANGLE) is
			-- Draw standard representation of `rectangle' to canvas.
		require
			rectangle_not_void: rectangle /= Void
		deferred
		end

	draw_figure_soft_rectangle (rectangle: DRW_SOFT_RECTANGLE) is
			-- Draw standard representation of `rectangle' to canvas.
		require
			rectangle_not_void: rectangle /= Void
		deferred
		end

	draw_figure_path (path: DRW_PATH) is
			-- Draw standard representation of `path' to canvas.
		require
			path_not_void: path /= Void
		deferred
		end

	draw_figure_text (text_figure: DRW_TEXT) is
			-- Draw standard representation of `text_figure' to canvas.
		require
			text_figure_not_void: text_figure /= Void
		deferred
		end

end -- class DRW_FIGURE_DRAWING_ROUTINES
