indexing
	description:
		"For shapes that can be filled."
	author: "Barden E. Smith"
	date:	"August 13, 2004"

deferred class
	DRW_FILLABLE

feature -- Shape attributes

	fill: DRW_COLOR

	stroke: DRW_COLOR is
		deferred
		end

	has_stroke: BOOLEAN is
		deferred
		end

	is_stroked: BOOLEAN is
		deferred
		end

	is_drawable: BOOLEAN is
			-- true if stroked or filled
		do
			Result := is_stroked or has_fill
		end

feature {DRW_COMMAND_PROCESSOR} -- Implementation and projection

	stroke_line_cap: INTEGER is
		deferred
		end

	stroke_line_join: INTEGER is
		deferred
		end

feature -- Status

	has_fill: BOOLEAN is
		do
			Result := fill /= Void
		end

feature -- Modification

	set_fill (f_color: DRW_COLOR) is
		-- sets the fill color to `f_color'
		do
			fill := f_color
		end

end -- class DRW_FILLABLE
