indexing
	description:
		"A group of drawing figures."
	author: "Barden E. Smith"
	date:	"August 13, 2004"

class
	DRW_GROUP

inherit
	DRW_FIGURE
		undefine
			copy, is_equal
		end

	DRW_TRANSFORMABLE_GROUP
		rename
			make_array as make
		redefine
			bounding_box,
			project
		end

	DRW_VIEW_BOX
		undefine
			copy, default_create, is_equal
		end

create
	make,
	make_from_list

create {DRW_GROUP}
	make_filled

feature -- Creation

	make_from_list (l: LIST [DRW_FIGURE]) is
		require
			l_not_void: l /= Void
		do
			make (l.count)
			from
				l.start
			until
				l.after
			loop
				add_figure (l.item)
				l.forth
			end
		end

feature -- Size estimating

	bounding_box: DRW_BASIC_RECTANGLE is
				-- Void if no pages or view_box
		do
			if has_view_box then
				Result := view_box.twin
			else
				Result := precursor
			end
		end


feature {DRW_PROJECTOR} -- plotting routine

	project (plotter: DRW_FIGURE_DRAWING_ROUTINES) is
		local
			m: DRW_MATRIX
		do
			if has_view_box then
				m := transform
				if m = Void then
					transform := matrix_map (untransformed_bounding_box)
				else
					transform := transform. and_then (matrix_map (box_transformed (untransformed_bounding_box)))
				end
				precursor (plotter)
				transform := m
			else
				precursor (plotter)
			end
		end

end -- class DRW_GROUP
