indexing
	description:
		"A drawing line."
	author: "Barden E. Smith"
	date:	"August 13, 2004"

class
	DRW_LINE

inherit
	DRW_LINE_SEGMENT
	DRW_SHAPE

create
	make,
	make_by_coordinates

feature -- Shape attributes

	is_drawable: BOOLEAN is
			-- true if stroked
		do
			Result := is_stroked
		end

feature -- Size estimating

	bounding_box: DRW_BASIC_RECTANGLE is
		local
			c0, c1: DRW_COORDINATE
		do
			create c0.set (x1, y1)
			create c1.set (x2, y2)
			create Result.make_by_coordinates (coordinate_transformed (c0), coordinate_transformed (c1))
		end


feature {DRW_PROJECTOR} -- plotting routine

	project (plotter: DRW_FIGURE_DRAWING_ROUTINES) is
		do
			if is_drawable then
				plotter.draw_figure_line (current)
			end
		end

end -- class DRW_LINE
