indexing
	description:
		"A drawing transformation matrix."
	author: "Barden E. Smith"
	date:	"August 13, 2004"


class
	DRW_MATRIX
		-- linear transformation of a pair of (DOUBLE) numbers

inherit
	MATRIX
		rename
			make_translation as make_translation_point
		export
			{NONE} is_mirrored_in_x
		end

create
	make_magnification,
	make_translation,
	make_translation_xy,
	make_arbitrary,
	make_rotation,
	make_rotation_degrees,
	make_rotation_degrees_xy,
	make_from_matrix,
	make_identity

feature -- Canonical representation

	translation_coordinate: DRW_COORDINATE is
		do
			create Result.set (tx, ty)
		end

feature {NONE} -- Creation

	make_translation (p: DRW_COORDINATE) is
		require
			not_void: p /= Void
		do
			make_translation_xy (p.x, p.y)
		end

end -- class DRW_MATRIX
