indexing
	description:
		"Attributes of a sheet of paper or document size."
	author: "Barden E. Smith"
	date:	"September 10, 2004"

deferred class
	DRW_PAPER_SIZE

feature -- Size attributes

	paper_height: DOUBLE is
			-- Height in convenient user units
		deferred
		end

	paper_width: DOUBLE is
			-- Width in convenient user units
		deferred
		end

	height: DOUBLE is
			-- Viewable height in user units
		do
			Result := paper_height - (top_margin + bottom_margin)
		end

	width: DOUBLE is
			-- Viewable width in user units
		do
			Result := paper_width - (left_margin + right_margin)
		end

	unit_label: STRING is
			-- Label of convenient user unit (standard abbreviation)
		deferred
		end

feature -- Conversion

	as_pts (l: DOUBLE): DOUBLE is
			-- converts length in paper units to typesetter points (pts) 
			--  using exactly 72 points per inch.
		deferred
		end

	height_pts: DOUBLE is
		do
			Result := as_pts (height)
		end

	width_pts: DOUBLE is
		do
			Result := as_pts (width)
		end

feature -- Margins

	bottom_margin: DOUBLE is
			-- in user units
		deferred
		end

	left_margin: DOUBLE is
			-- in user units
		deferred
		end

	right_margin: DOUBLE is
			-- in user units
		deferred
		end

	top_margin: DOUBLE is
			-- in user units
		deferred
		end

end -- class DRW_PAPER_SIZE
