indexing
	description:
		"A drawing path."
	author: "Barden E. Smith"
	date:	"August 13, 2004"

class
	DRW_PATH

inherit
	DRW_SHAPE
		undefine
			copy,
			is_equal
		end

	ARRAYED_LIST[DRW_COMMAND]
		rename
			make_from_array as make_from_command_array,
			fill as fill_list
		export
			{ANY} extend, after, count, forth, is_empty, item, i_th, start, wipe_out, readable, off, valid_index, index, prunable, extendible
			{DRW_PATH} all
		end

	DRW_FILLABLE
		undefine
			copy,
			is_equal
		end

create
	make,
	make_from_command_array

create {DRW_PATH}
	make_filled


feature -- Modification

	add_command (c: like item) is
		do
			extend (c)
		end


feature -- Display

	svg_path: STRING is
		do
			create Result.make(0)
			from
				start
			until
				after
			loop
				Result.append (item.svg_path)
			end
		ensure
			result_not_void: Result /= Void
		end

feature -- Size estimating

	bounding_box: DRW_BASIC_RECTANGLE is
			-- Void if empty
		local
			f: DRW_COMMAND
		do
			from
				start
				if not after then
					create initial_point.set (item.x, item.y)
					create current_point.set (item.x, item.y)
					create expanding_box.make (0, 0, item.x, item.y)
				end
			until
				after
			loop
				f := item
				f.expand_bounding_box (Current)
				forth
			end
			Result := box_transformed (expanding_box)
		end

feature {DRW_COMMAND, DRW_PATH} -- Size contribution

	initial_point: DRW_COORDINATE

	current_point: DRW_COORDINATE

	control_reflection: DRW_COORDINATE

	expanding_box: DRW_BASIC_RECTANGLE

feature {NONE} -- plotting routine

	project (plotter: DRW_FIGURE_DRAWING_ROUTINES) is
		do
			if is_drawable then
				plotter.draw_figure_path (current)
			end
		end

end -- class DRW_PATH
