indexing
	description:
		"Abstract class for drawing projector with routine."
	author: "Barden E. Smith"
	date:	"September 13, 2004"


deferred class
	DRW_PROJECTOR_ROUTINES

inherit
	DRW_FIGURE_DRAWING_ROUTINES


feature -- Basic operation

	project (d: DRW_DOCUMENT) is
		do
			establish_document (d)
			initialize_projection
			document.project (Current)
			finish_projection
		end


feature -- State

	is_projecting: BOOLEAN


feature {NONE} -- Implementation

	document: DRW_DOCUMENT

	establish_document (d: DRW_DOCUMENT) is
		require
			document_not_void: d /= Void
		deferred
		end

	initialize_projection is
			-- redefined if additional step are needed
		do
			is_projecting := True
		ensure
			projecting: is_projecting
		end
			
	finish_projection is
			-- redefined if additional step are needed
		do
			is_projecting := False
		ensure
			not_projecting: not is_projecting
		end


end -- class DRW_PROJECTOR_ROUTINES
