indexing
	description:
		"Rectangular figures."
	author: "Barden E. Smith"
	date:	"August 13, 2004"

class
	DRW_RECTANGLE

inherit
	DRW_BASIC_RECTANGLE

	DRW_SHAPE
		undefine
			out
		end

	DRW_FILLABLE
		undefine
			out
		end

create
	make,
	make_by_coordinates,
	make_from_rectangle



feature -- Transformation			


	as_transformed_points (xform: DRW_MATRIX): SIMPLE_LIST_OF_POINTS is
			-- return points as transformed by local transform and
			-- then by `xform'
		require
			xform_not_void: xform /= Void
		local
			m: DRW_MATRIX
		do
			create Result.make (4)
			if is_transformed then
				m := transform.and_then (xform)
			else
				m := xform
			end
			Result.extend (m.transform_xy (left, bottom))
			Result.extend (m.transform_xy (right, bottom))
			Result.extend (m.transform_xy (right, top))
			Result.extend (m.transform_xy (left, top))
		ensure
			result_exists: Result /= Void
		end


feature -- Size estimating

	bounding_box: DRW_BASIC_RECTANGLE is
		local
			lx, ly, ux, uy: DOUBLE
			p: POINT
		do
			if is_transformed then
				p := transform.transform_xy (left, bottom)
				lx := p.x
				ux := lx
				ly := p.y
				uy := ly
				p := transform.transform_xy (right, bottom)
				lx := lx.min(p.x)
				ux := ux.max(p.x)
				ly := ly.min(p.y)
				uy := uy.max(p.y)
				p := transform.transform_xy (right, top)
				lx := lx.min(p.x)
				ux := ux.max(p.x)
				ly := ly.min(p.y)
				uy := uy.max(p.y)
				p := transform.transform_xy (left, top)
				lx := lx.min(p.x)
				ux := ux.max(p.x)
				ly := ly.min(p.y)
				uy := uy.max(p.y)
				create Result.make (ux - lx, uy - ly, (lx + ux) / 2.0, (ly + uy) / 2.0)
			else
				create Result.make (width, height, x, y)
			end
		end


feature {DRW_PROJECTOR} -- plotting routine

	project (plotter: DRW_FIGURE_DRAWING_ROUTINES) is
		do
			if is_drawable then
				plotter.draw_figure_rectangle (current)
			end
		end

end -- class DRW_RECTANGLE
