indexing
	description:
		"A group of drawing transformable figures."
	author: "Barden E. Smith"
	date:	"September 13, 2004"

class
	DRW_TRANSFORMABLE_GROUP

inherit
	ARRAYED_LIST [DRW_FIGURE]
		rename
			make as make_array
		end

	DRW_TRANSFORMABLE
		undefine
			copy, is_equal
		end

create

create {DRW_TRANSFORMABLE_GROUP}
	make_filled

feature -- Modification

	add_figure (f: like item) is
		do
			extend (f)
		end


feature -- Size estimating

	bounding_box: DRW_BASIC_RECTANGLE is
				-- Void if empty
		do
			Result := untransformed_bounding_box
			if Result /= Void then
				Result := box_transformed (Result)
			end
		end

	untransformed_bounding_box: DRW_BASIC_RECTANGLE is
				-- Void if empty
		local
			b, b1: DRW_BASIC_RECTANGLE
			f: DRW_FIGURE
			i: INTEGER
		do
			from
				i := 1
			until
				i > count
			loop
				f := i_th (i)
				if b = Void then
					b := f.bounding_box
				else
					b1 := f.bounding_box
					if b1 /= Void then
						b.merge (b1)
					end
				end
				i := i + 1
			end
			Result := b
		end


feature {DRW_PROJECTOR} -- plotting routine

	project (plotter: DRW_FIGURE_DRAWING_ROUTINES) is
		do
			if is_transformed then
				plotter.alter_current_transform (transform)
			end
			from
				start
			until
				after
			loop
				item.project (plotter)
				forth
			end
			if is_transformed then
				plotter.restore_previous_transform
			end
		end

end -- class DRW_TRANSFORMABLE_GROUP
