
indexing
	
	description: "Object that can handle a condition and whose handling %
		%can be changed dynamically by setting an action"
	author: "David Hollenberg"
	date: "May 11, 2006"

class DYNAMIC_CONDITION_HANDLER
inherit
	CONDITION_HANDLER

create
	make_with_action

feature {NONE} -- Creation

	make_with_action (a: like action)
			-- Create handler with action `a'
		do
			action := a
		end

feature -- Properties

	action: PROCEDURE [ANY, TUPLE [APPLICATION_CONDITION]]
			-- Action to be performed to handle condition

feature -- Modification

	set_action (a: like action)
		do
			action := a
		ensure
			action_set: action = a
		end

feature -- Operations

	handle (cond: APPLICATION_CONDITION)
			-- Handle condition `cond'
		do
			action.call ([cond])
		end

end
