
indexing
	
	author: "David Hollenberg"
	date:	"December 2, 1995"
	description: "Constants for Eiffel datatype codes"
		
class EIFFEL_DATATYPE_CODES

feature -- Codes for Eiffel datatypes
	
	integer_eiffel_type: INTEGER = 1
	
	real_eiffel_type: INTEGER = 2
	
	double_eiffel_type: INTEGER = 3
	
	character_eiffel_type: INTEGER = 4
	
	boolean_eiffel_type: INTEGER = 5
	
	date_eiffel_type: INTEGER = 6
	
	rowid_eiffel_type: INTEGER = 7
	
	string_eiffel_type: INTEGER = 8
	
	raw_eiffel_type: INTEGER = 9
	
feature -- Translation to datatype names
	
	name_for_eiffel_type (code: INTEGER): STRING
			-- New string with Eiffel type name corresponding
			-- to `code'
		do
			inspect code
			when integer_eiffel_type then
				Result := "INTEGER"
			when real_eiffel_type then
				Result := "REAL"
			when double_eiffel_type then
				Result := "DOUBLE"
			when character_eiffel_type then
				Result := "CHARACTER"
			when boolean_eiffel_type then
				Result := "BOOLEAN"
			when date_eiffel_type then
				Result := "DB_DATE"
			when rowid_eiffel_type then
				Result := "DB_ROWID"
			when string_eiffel_type then
				Result := "STRING"
			when raw_eiffel_type then
				Result := "raw STRING"
			else
				Result := "unknown"
			end
		end
	
feature -- Validity
	
	is_valid_eiffel_datatype (code: INTEGER): BOOLEAN
			-- Is `code' a valid Eiffel datatype code?
		do
			Result := True
			inspect code
			when integer_eiffel_type then
			when real_eiffel_type then
			when double_eiffel_type then
			when character_eiffel_type then
			when boolean_eiffel_type then
			when date_eiffel_type then
			when rowid_eiffel_type then
			when string_eiffel_type then
			when raw_eiffel_type then
			else
				Result := False
			end
		end
	
end
