
indexing
	
	description: "Counts of horizontal and vertical elemenets with a particular width"
	author: "David Hollenberg"

class ELEMENT_WIDTH_RECORD

create
	make

feature {NONE} -- Creation

	make (a_width: DOUBLE)
			-- Create for element width `a_width'
		do
			width := a_width
		ensure
			width_set: width = a_width
		end

feature -- Properties

	width: DOUBLE
			-- Width of element

	horizontal_count: INTEGER
			-- Number of horizontal elements with this
			-- width

	vertical_count: INTEGER
			-- Number of vertical elements with this
			-- width

	count_summary: STRING
			-- Summary of counts in `Current'
		do
			create Result.make (30)
			if horizontal_count > 0 then
				Result.append_integer (horizontal_count)
				Result.extend (' ')
				Result.append ("horizontal")
			end
			if vertical_count > 0 then
				if not Result.is_empty then
					Result.append (", ")
				end
				Result.append_integer (vertical_count)
				Result.extend (' ')
				Result.append ("vertical")
			end
		end

feature -- Modification

	increment_horizontal_count
			-- Add one to `horizontal_count'
		do
			horizontal_count := horizontal_count + 1
		end

	increment_vertical_count
			-- Add one to `vertical_count'
		do
			vertical_count := vertical_count + 1
		end

end
