deferred class ESSENCE_OF_ADDRESS
		-- all the stuff that is common to
		--  ADDRESSES, FUNDING_AUTH_ADDRESSES,
		--  and M_SHIPMENT_ADDRESSES

inherit
	STRING_UTILITIES_ACCESS

	MOSIS_ADDR_VALUES

feature -- the common attributes

	address_type: CHARACTER is deferred end;

  --	address_format: CHARACTER is deferred end;

	line_a: STRING is deferred end;

	line_b: STRING is deferred end;

	line_c: STRING is deferred end;

	line_1: STRING is deferred end;

	line_2: STRING is deferred end;

	line_3: STRING is deferred end;

	city: STRING is deferred end;

	state: STRING is deferred end;

	country: STRING is deferred end;

	is_null_country: BOOLEAN is deferred end;

	zip: STRING is deferred end;

	zip_plus_4: STRING is deferred end;

	province: STRING is deferred end;

	postal_code: STRING is deferred end;

	phone_info: STRING is deferred end;

feature

	is_billing_address: BOOLEAN is
	do  Result := address_type = addr_is_billing
	end;

	is_shipping_address: BOOLEAN is
	do  Result := address_type = addr_is_shipping
	end;

	is_mailing_address: BOOLEAN is
	do  Result := address_type = addr_is_mailing
	end;

	is_domestic: BOOLEAN is
	local cv: COUNTRY_VALUES
	do  Result := is_null_country or else equal(country, cv.united_states)
	end;

	is_foreign: BOOLEAN is
	do  Result := not is_domestic
	end;

	zip_no: INTEGER is
	do  if zip.is_integer
	     then Result := zip.to_integer
	    end
	end;

	full_label: STRING is
		-- put together a full mailing label
	deferred
		-- each descendant now does this via
		-- a function in the address_labels package
	end;

end -- ESSENCE_OF_ADDRESS
