
indexing
	
	description: "A run closing step operation that generates %
		%posts fabrication status of a run"
	author: "David Hollenberg"
	date: "June 6, 2005"

deferred class FAB_POSTING_OP
inherit
	RC_PRIMITIVE_STEP_OP
		redefine
			run_one_report
		end
	UNIX_OS_ACCESS
		export
			{NONE} all
		undefine
			default_create
		end
	STAT_CONSTANTS
		export
			{NONE} all
		undefine
			default_create
		end

feature {NONE} -- Implementation

	execute_run_status_report
			-- Execute report to generate status of run
		do
			run_one_report (environment.run_status_report, "p_run_id=" + session.run_id, run_status_report_output_file)
		end

	execute_all_runs_status_report
			-- Execute report to generate overview page
			-- linking to individual run status pages
		do
			run_one_report (environment.all_runs_status_report, "", all_runs_status_report_output_file)
		end

	run_one_report (module, parms, dest: STRING)
			-- Run ReportWriter report `module' with `parms'
			-- and put output in `dest'
		local
			old_mask, new_mask: INTEGER
		do
			new_mask := (S_irusr | S_iwusr | S_irgrp | S_iwgrp | S_iroth).bit_not
			old_mask := unix_os.set_file_creation_mask (new_mask)
			precursor (module, parms, dest)
			new_mask := unix_os.set_file_creation_mask (old_mask)
		rescue
			new_mask := unix_os.set_file_creation_mask (old_mask)
		end

	run_status_report_output_file: STRING
			-- Output file from running the run status report
		do
			Result := cache.status_directory + session.lower_run_id + "_sts.html"
		ensure
			result_exists: Result /= Void
		end

	all_runs_status_report_output_file: STRING
			-- Output file from running report that links
			-- to status for all runs
		do
			Result := cache.admin_application_parameter_string ("ANY", "REPORTS", "$MWEB") + "Customer/run-status.html"
		ensure
			result_exists: Result /= Void
		end

end
