
indexing
	
	description: "Interface to report a fatal error in application"
	author: "David Hollenberg"
	date: "November 11, 2003"

deferred class FATAL_ERROR_IFC

inherit
	ABSTRACT_INTERFACE
		
feature {NONE} -- Creation

	make_interface (a_text: STRING)
			-- Create interface for reporting fatal error
			-- described by `a_text'
		require
			a_text_exists: a_text /= Void
		do
			text := a_text
			create notify_actions
			create exit_actions
		end

feature -- Properties

	notify_actions: CLOSED_ACTION_SEQUENCE
			-- Actions to be performed when user chooses
			-- Notify option

	exit_actions: CLOSED_ACTION_SEQUENCE
			-- Actions to be performed when user chooses
			-- Exit option

	text: STRING
			-- Text describing error

invariant
	notify_actions_exist: notify_actions /= Void
	exit_actions_exist: exit_actions /= Void
	text_exists: text /= Void
end
