
indexing
	
	author: "David Hollenberg"
	date: "May 3, 2002"
	description: "A file descriptor which is to be closed in %
		%spawned process"

class FD_CLOSE

inherit
	PROCESS_FD
		redefine
			is_close
		end

create
	make

feature {NONE} -- Creation

	make (fd: INTEGER)
			-- Create `Current' for file descriptor `fd'
		require
			valid_descriptor: valid_file_descriptor (fd)
		do
			number := fd
		ensure
			number_set: number = fd
		end

feature -- Properties

	is_close: BOOLEAN = True
			-- Should file descriptor be closed in spawned process?

feature -- Operations

	prepare_for_fork
			-- Do any preparation needed prior to a fork
			-- to setup this file descriptor in spawned
			-- process
		do
			source_descriptor := unix_os.Invalid_file_descriptor
		end

	setup_for_parent
			-- Take any actions needed to setup this file
			-- descriptor in parent process after a fork
		do
		end

	setup_for_child (fd_set: PROCESS_FD_SET)
			-- Take any actions needed to setup this file
			-- descriptor in child process after a fork,
			-- where `fd_set' is the entire set of file
			-- descriptors to be setup
		do
			unix_os.close_file_descriptor (number)
		end

end

