
indexing

	date: "Tue Aug 26 16:01:27 2008"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user DHOLLEN"
	database_tables: 
		"FIELD_LOCATIONS (MOSIS.FIELD_LOCATIONS)"
			-- Included columns
			-- 	COPY_NO
			-- 	FIELD_NAME
			-- 	FIELD_SET_NAME
			-- 	LOCATION_X
			-- 	LOCATION_Y
			-- Excluded columns
			-- 	(none)

class FIELD_LOCATIONS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_field_set_name: STRING; the_field_name: STRING; the_copy_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_field_set_name_exists: the_field_set_name /= Void
			the_field_name_exists: the_field_name /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			field_set_name := the_field_set_name
			field_name := the_field_name
			copy_no := the_copy_no
			is_null_field_set_name := False
			is_null_field_name := False
			is_null_copy_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 5

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  copy_no, field_name, field_set_name, location_x, location_y"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "field_locations fl"

	join_condition: STRING = ""

	table_name: STRING = "field_locations"

	key_where_clause: STRING = "field_set_name = :1 and field_name = :2 and copy_no = :3"

feature -- Values

	copy_no: INTEGER
			-- DB: NUMBER(3,0) not null

	field_name: STRING
			-- DB: VARCHAR2(20) not null

	field_set_name: STRING
			-- DB: VARCHAR2(30) not null

	location_x: DOUBLE
			-- DB: NUMBER(12,6)

	location_y: DOUBLE
			-- DB: NUMBER(12,6)

feature -- Nullness for null allowed columns

	is_null_location_x: BOOLEAN
	is_null_location_y: BOOLEAN

feature -- Nullness for non-null columns

	is_null_copy_no: BOOLEAN
	is_null_field_name: BOOLEAN
	is_null_field_set_name: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and copy_no = r.copy_no
			Result := Result
				and equal (field_name, r.field_name)
				and equal (field_set_name, r.field_set_name)
			Result := Result
				and is_null_copy_no = r.is_null_copy_no
				and is_null_field_name = r.is_null_field_name
				and is_null_field_set_name = r.is_null_field_set_name
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and location_x = r.location_x
				and location_y = r.location_y
			Result := Result
				and is_null_location_x = r.is_null_location_x
				and is_null_location_y = r.is_null_location_y
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_integer (1)
			q.select_string (2, 20)
			q.select_string (3, 30)
			q.select_double (4)
			q.select_double (5)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			copy_no := q.integer_value (1)
			location_x := q.double_value (4)
			location_y := q.double_value (5)
		end

	fill_in_references (q: SQL_QUERY)
		do
			field_name := q.string_value (2)
			field_set_name := q.string_value (3)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (2, field_name)
			q.get_string_value (3, field_set_name)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_copy_no := q.is_null (1)
			is_null_field_name := q.is_null (2)
			is_null_field_set_name := q.is_null (3)
			is_null_location_x := q.is_null (4)
			is_null_location_y := q.is_null (5)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_field_set_name := True
			is_null_field_name := True
			is_null_copy_no := True
			create field_set_name.make (0)
			create field_name.make (0)
		end

	set_null_nonkey
		do
			is_null_location_x := True
			is_null_location_y := True
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, field_set_name, False)
			q.bind_num_to_string (2, field_name, False)
			q.bind_num_to_integer (3, copy_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and copy_no = q.integer_value (1)
				and location_x = q.double_value (4)
				and location_y = q.double_value (5)
			q.get_string_value (2, s)
			Result := Result and equal (field_name, s)
			q.get_string_value (3, s)
			Result := Result and equal (field_set_name, s)
			Result := Result
				and is_null_copy_no = q.is_null (1)
				and is_null_field_name = q.is_null (2)
				and is_null_field_set_name = q.is_null (3)
				and is_null_location_x = q.is_null (4)
				and is_null_location_y = q.is_null (5)
		end

end
