
indexing

	author: "Generated"
	date: "Wed Feb 11 15:00:22 PST 2004"

class FIELD_LOCATIONS_ROW
inherit
	FIELD_LOCATIONS_RAW
	ROW_COUNT_CHECK_ACCESS
	NULL_VALUE_CHECK_ACCESS
create
	make_template, make_null, make_by_key

feature -- Properties

	locations_for_field_set (name: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current] is
			-- All locations for field set `name', ordered by
			-- field name and then copy number within field name
		require
			name_exists: name /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_S
		do
			create b.make (name)
			Result := all_rows_filtered_ordered (conn, "field_set_name = :1", b, "field_name, copy_no")
			check_row_count (Result, range)
		end

	custom_locations_for_run (run: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current] is
			-- All locations for field sets whose litho size
			-- is a custom one for `run'
		require
			run_exists: run /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_S
		do
			create b.make (run)
			Result := all_rows_filtered (conn, "[
				field_set_name in    
				   (select field_set_name from field_sets fs, litho_sizes ls
				    where fs.litho_size_id = ls.litho_size_id and ls.run_id = :1)
				]", b)
			check_row_count (Result, range)
		end

	center: CONST_POINT is
			-- Location of center of field in microns, relative
			-- to lower left corner of mask
		do
			create Result.make_xy (non_null_location_x, non_null_location_y)
		ensure
			result_exists: Result /= Void
		end

	non_null_location_x: like location_x is
			-- Value of `location_x', with error check for nullness
		do
			check_not_null ("location_x", is_null_location_x, Current)
			Result := location_x
		end

	non_null_location_y: like location_y is
			-- Value of `location_y', with error check for nullness
		do
			check_not_null ("location_y", is_null_location_y, Current)
			Result := location_y
		end

end
