
indexing
	
	description: "Interface to set (and possibly create) field set for a run"
	author: "David Hollenberg"
	date: "August 26, 2008"

deferred class FIELD_SET_IFC

inherit
	ABSTRACT_INTERFACE
	RC_SESSIONABLE
		
feature {NONE} -- Creation

	make_interface
			-- Create interface
		do
			create success_actions
			create abort_actions
		end

feature -- Properties

	success_actions: CLOSED_ACTION_SEQUENCE
			-- Actions to be performed after field set selected

	abort_actions: CLOSED_ACTION_SEQUENCE
			-- Actions to be performed when selection of field set
			-- is aborted prematurely

	state: STRING
			-- State saved by soft undo, if not Void

	field_set_name: STRING
			-- Name of field set selected when step done

feature -- Modification

	set_state (s: STRING)
			-- Set `state' to `s'
		do
			state := s
		end

end
