
indexing
	
	author: "Joel Goldberg (reworked by David Hollenberg)"
	date: "January 18, 2000"
	description: "Entity that can be copied to a file or data_consumer"

deferred class FILABLE

feature -- Operations

	copy_to_file (f: LARGE_FILE)
			-- Copy `Current' to file `f'
		require
			file_exists: f /= Void
			file_writable: f.is_open_write
		local dcon: DATA_CONSUMER_OPEN_FILE
		do
			create dcon.make(f)
			dcon.initialize
			copy_to_consumer(dcon)
		end

	copy_to_consumer(dcon: DATA_CONSUMER)
			-- Copy 'Current" to consumer dcon
		require
			exists: dcon /= Void
		deferred
		end

	close
			-- Close data source and release all resources
		deferred
		end
	
end
