
indexing
	
	description: "[
		Logical group of files that are related because they
		have similar functions (e.g., files representing
		bonding diagrams).
		]"
	author: "David Hollenberg"
	date: "September 16, 2002"

deferred class FILE_CATEGORY
inherit
	FILE_UTILITIES_ACCESS
feature
	name: STRING
			-- Name of category
		deferred
		ensure
			result_exists: result /= Void
		end

	can_compute_file_pathnames: BOOLEAN
			-- May category be used to compute file pathnames?
		deferred
		end

	can_compute_dir_pathnames: BOOLEAN
			-- May category be used to compute directory pathnames?
		deferred
		end

	sub_directory_name: STRING
			-- Name of sub-directory in which files
			-- are placed
		deferred
		ensure
			result_exists: result /= Void
		end

	group_name: STRING
			-- Name of group under which directory
			-- and files in directory should be
			-- created
		deferred
		ensure
			result_exists: result /= Void
		end

	directory_permission_string: STRING
			-- Permissions to assign to directory
		deferred
		ensure
			result_exists: result /= Void
			valid_result: fu.is_valid_permission_string (Result)
		end

	file_permission_string: STRING
			-- Permissions to assign to files in directory
		deferred
		ensure
			result_exists: result /= Void
			valid_result: fu.is_valid_permission_string (Result)
		end

	directory_pathname: STRING
			-- Full pathname of directory for category
		require
			can_compute_dir_pathnames: can_compute_dir_pathnames
		deferred
		ensure
			result_exists: result /= Void
		end

	file_pathname (fname: STRING): STRING
			-- Full pathname of file named `fname'
			-- that is in `Current'
		require
			can_compute_file_pathnames: can_compute_file_pathnames
			name_exists: fname /= Void
		deferred
		ensure
			result_exists: result /= Void
		end

end
