
indexing
	
	description: "An operation that closes a file"
	author: "David Hollenberg"
	date: "March 12, 2003"

class FILE_CLOSE_OP
inherit
	OPERATION
		rename
			try_operation as try_close
		end

create
	default_create

feature -- Operations

	close (f: LARGE_FILE)
			-- Close `f'
		require
			file_exists: f /= Void
			file_not_closed: not f.is_closed
		do
			file := f
			execute
		end

feature {NONE} -- Implementation

	file: LARGE_FILE
			-- File to try to close

	try_close
			-- Try file close
		do
			file.close
			publish_close_event
		end

	publish_close_event
		local
			close_event: FILE_CLOSE_EVENT
		do
			create close_event
			close_event.set_file_name (file.name)
			close_event.publish
		end

end
