
class FILE_HARD_LINK_ACTION

inherit
	FILE_ACTION_ITEM

	STRING_UTILITIES_ACCESS
		export
			{NONE} all
		end

	UNIX_OS_ACCESS
		export
			{NONE} all
		end

create
	make

feature {NONE} -- Creation

	make (the_old_name, the_new_name: STRING) is
		require 
			old_name_exists: the_old_name /= Void
			new_name_exists: the_new_name /= Void
		do  
			make_fil (the_old_name);
	    		new_name := the_new_name;
		end;

feature

	new_name: STRING		
			-- New name

	do_it is
		do  
			if fil.exists then 
				unix_os.make_hard_link (fil.name, new_name) 
			end;
	    		done := True;
		end;

	descr: STRING is
		do  
			Result := su.string_of_4("Hard link ", fil.name, " to ", new_name);
		end;

end -- FILE_HARD_LINK_ACTION
