deferred class FILE_ROLE_CACHE
	-- class to fetch or select my file_roles_row
	-- based on my file_role, and hang on to it

inherit
	ANY
	DB_QUERY_OPTIONS
	export {NONE} all end;

feature	-- the deferred stuff we need to function

	connection: DB_CONNECTION
	deferred
	end;

	file_role: STRING
	deferred
	end;

feature	-- fetch and select routines

	file_role_row: FILE_ROLES_ROW
		-- the file_roles row for my file_role
	do  if cached_file_role = Void or else
	       (not equal(cached_file_role.file_role, 
						file_role))
	     then create cached_file_role.make_by_key(
				connection, old_row, file_role)
	    end
	    Result := cached_file_role
	end;

	select_file_role(frols: LIST[FILE_ROLES_ROW])
		-- pick my row out of a master list (clear entry if not found)
	do  cached_file_role := Void
	    if frols /= Void then
		from  frols.start
		until frols.after or cached_file_role /= Void
		loop  if equal (frols.item.file_role, file_role)
			then cached_file_role := frols.item
		      end;
		      frols.forth
		end
	    end
	end;

feature {NONE} -- cached row

	cached_file_role: FILE_ROLES_ROW

end -- FILE_ROLE_CACHE
