
indexing

	date: "Tue Apr 24 10:30:12 2007"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user DHOLLEN"
	database_tables: 
		"FILL_PATTERNS (MOSIS.FILL_PATTERNS)"
			-- Included columns
			-- 	CELL_MERGE_SIZING
			-- 	CELL_REMOVE_SIZING
			-- 	CELL_SELECTION_GDS_LAYER
			-- 	CELL_SIZE
			-- 	FILE_NAME
			-- 	FILL_PATTERN_ID
			-- 	SCALE_FACTOR
			-- 	TOP_STRUCTURE
			-- Excluded columns
			-- 	(none)

class FILL_PATTERNS_RAW

inherit

	DB_IDENTIFIED_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_fill_pattern_id: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_fill_pattern_id_exists: the_fill_pattern_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			fill_pattern_id := the_fill_pattern_id
			is_null_fill_pattern_id := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 8

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  cell_merge_sizing, cell_remove_sizing, cell_selection_gds_layer,%N  cell_size, file_name, fill_pattern_id, scale_factor, top_structure"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "fill_patterns fp"

	join_condition: STRING = ""

	table_name: STRING = "fill_patterns"

	key_where_clause: STRING = "fill_pattern_id = :1"

feature -- Values

	cell_merge_sizing: DOUBLE
			-- DB: NUMBER(*,*) not null

	cell_remove_sizing: DOUBLE
			-- DB: NUMBER(*,*) not null

	cell_selection_gds_layer: INTEGER
			-- DB: NUMBER(3,0) not null

	cell_size: DOUBLE
			-- DB: NUMBER(*,*) not null

	file_name: STRING
			-- DB: VARCHAR2(255) not null

	fill_pattern_id: STRING
			-- DB: VARCHAR2(20) not null

	scale_factor: DOUBLE
			-- DB: NUMBER(*,*) not null

	top_structure: STRING
			-- DB: VARCHAR2(255) not null

feature -- Nullness for non-null columns

	is_null_cell_merge_sizing: BOOLEAN
	is_null_cell_remove_sizing: BOOLEAN
	is_null_cell_selection_gds_layer: BOOLEAN
	is_null_cell_size: BOOLEAN
	is_null_file_name: BOOLEAN
	is_null_fill_pattern_id: BOOLEAN
	is_null_scale_factor: BOOLEAN
	is_null_top_structure: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (fill_pattern_id, r.fill_pattern_id)
			Result := Result
				and is_null_fill_pattern_id = r.is_null_fill_pattern_id
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and cell_merge_sizing = r.cell_merge_sizing
				and cell_remove_sizing = r.cell_remove_sizing
				and cell_selection_gds_layer = r.cell_selection_gds_layer
				and cell_size = r.cell_size
				and scale_factor = r.scale_factor
			Result := Result
				and equal (file_name, r.file_name)
				and equal (top_structure, r.top_structure)
			Result := Result
				and is_null_cell_merge_sizing = r.is_null_cell_merge_sizing
				and is_null_cell_remove_sizing = r.is_null_cell_remove_sizing
				and is_null_cell_selection_gds_layer = r.is_null_cell_selection_gds_layer
				and is_null_cell_size = r.is_null_cell_size
				and is_null_file_name = r.is_null_file_name
				and is_null_scale_factor = r.is_null_scale_factor
				and is_null_top_structure = r.is_null_top_structure
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_double (1)
			q.select_double (2)
			q.select_integer (3)
			q.select_double (4)
			q.select_string (5, 255)
			q.select_string (6, 20)
			q.select_double (7)
			q.select_string (8, 255)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			cell_merge_sizing := q.double_value (1)
			cell_remove_sizing := q.double_value (2)
			cell_selection_gds_layer := q.integer_value (3)
			cell_size := q.double_value (4)
			scale_factor := q.double_value (7)
		end

	fill_in_references (q: SQL_QUERY)
		do
			file_name := q.string_value (5)
			fill_pattern_id := q.string_value (6)
			top_structure := q.string_value (8)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (5, file_name)
			q.get_string_value (6, fill_pattern_id)
			q.get_string_value (8, top_structure)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_cell_merge_sizing := q.is_null (1)
			is_null_cell_remove_sizing := q.is_null (2)
			is_null_cell_selection_gds_layer := q.is_null (3)
			is_null_cell_size := q.is_null (4)
			is_null_file_name := q.is_null (5)
			is_null_fill_pattern_id := q.is_null (6)
			is_null_scale_factor := q.is_null (7)
			is_null_top_structure := q.is_null (8)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_fill_pattern_id := True
			create fill_pattern_id.make (0)
		end

	set_null_nonkey
		do
			is_null_cell_merge_sizing := True
			is_null_cell_remove_sizing := True
			is_null_cell_selection_gds_layer := True
			is_null_cell_size := True
			is_null_file_name := True
			is_null_scale_factor := True
			is_null_top_structure := True
			create file_name.make (0)
			create top_structure.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, fill_pattern_id, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and cell_merge_sizing = q.double_value (1)
				and cell_remove_sizing = q.double_value (2)
				and cell_selection_gds_layer = q.integer_value (3)
				and cell_size = q.double_value (4)
				and scale_factor = q.double_value (7)
			q.get_string_value (5, s)
			Result := Result and equal (file_name, s)
			q.get_string_value (6, s)
			Result := Result and equal (fill_pattern_id, s)
			q.get_string_value (8, s)
			Result := Result and equal (top_structure, s)
			Result := Result
				and is_null_cell_merge_sizing = q.is_null (1)
				and is_null_cell_remove_sizing = q.is_null (2)
				and is_null_cell_selection_gds_layer = q.is_null (3)
				and is_null_cell_size = q.is_null (4)
				and is_null_file_name = q.is_null (5)
				and is_null_fill_pattern_id = q.is_null (6)
				and is_null_scale_factor = q.is_null (7)
				and is_null_top_structure = q.is_null (8)
		end

end
