
indexing

	date: "Tue Apr 24 10:30:12 2007"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user DHOLLEN"
	database_tables: 
		"FILL_ROLES (MOSIS.FILL_ROLES)"
			-- Included columns
			-- 	DENSITY_MEASUREMENT_REQUIRED
			-- 	DESCR
			-- 	EXCLUSION_LAYER
			-- 	FILLED_LAYER
			-- 	FILL_ROLE
			-- Excluded columns
			-- 	(none)

class FILL_ROLES_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_fill_role: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_fill_role_exists: the_fill_role /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			fill_role := the_fill_role
			is_null_fill_role := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 5

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  density_measurement_required, descr, exclusion_layer, filled_layer,%N  fill_role"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "fill_roles fr"

	join_condition: STRING = ""

	table_name: STRING = "fill_roles"

	key_where_clause: STRING = "fill_role = :1"

feature -- Values

	density_measurement_required: BOOLEAN
			-- DB: CHAR(1) not null

	descr: STRING
			-- DB: VARCHAR2(50)

	exclusion_layer: BOOLEAN
			-- DB: CHAR(1) not null

	filled_layer: BOOLEAN
			-- DB: CHAR(1) not null

	fill_role: STRING
			-- DB: VARCHAR2(10) not null

feature -- Nullness for null allowed columns

	is_null_descr: BOOLEAN

feature -- Nullness for non-null columns

	is_null_density_measurement_required: BOOLEAN
	is_null_exclusion_layer: BOOLEAN
	is_null_filled_layer: BOOLEAN
	is_null_fill_role: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (fill_role, r.fill_role)
			Result := Result
				and is_null_fill_role = r.is_null_fill_role
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and density_measurement_required = r.density_measurement_required
				and exclusion_layer = r.exclusion_layer
				and filled_layer = r.filled_layer
			Result := Result
				and equal (descr, r.descr)
			Result := Result
				and is_null_density_measurement_required = r.is_null_density_measurement_required
				and is_null_descr = r.is_null_descr
				and is_null_exclusion_layer = r.is_null_exclusion_layer
				and is_null_filled_layer = r.is_null_filled_layer
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_boolean (1)
			q.select_string (2, 50)
			q.select_boolean (3)
			q.select_boolean (4)
			q.select_string (5, 10)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			density_measurement_required := q.boolean_value (1)
			exclusion_layer := q.boolean_value (3)
			filled_layer := q.boolean_value (4)
		end

	fill_in_references (q: SQL_QUERY)
		do
			descr := q.string_value (2)
			fill_role := q.string_value (5)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (2, descr)
			q.get_string_value (5, fill_role)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_density_measurement_required := q.is_null (1)
			is_null_descr := q.is_null (2)
			is_null_exclusion_layer := q.is_null (3)
			is_null_filled_layer := q.is_null (4)
			is_null_fill_role := q.is_null (5)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_fill_role := True
			create fill_role.make (0)
		end

	set_null_nonkey
		do
			is_null_density_measurement_required := True
			is_null_descr := True
			is_null_exclusion_layer := True
			is_null_filled_layer := True
			create descr.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, fill_role, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and density_measurement_required = q.boolean_value (1)
				and exclusion_layer = q.boolean_value (3)
				and filled_layer = q.boolean_value (4)
			q.get_string_value (2, s)
			Result := Result and equal (descr, s)
			q.get_string_value (5, s)
			Result := Result and equal (fill_role, s)
			Result := Result
				and is_null_density_measurement_required = q.is_null (1)
				and is_null_descr = q.is_null (2)
				and is_null_exclusion_layer = q.is_null (3)
				and is_null_filled_layer = q.is_null (4)
				and is_null_fill_role = q.is_null (5)
		end

end
