
indexing
	
	description: "Change that fixed an object in X and Y dimensions"
	author: "David Hollenberg"
	date: "January 25, 2007"

class FIX_IN_X_AND_Y_CHANGE
inherit
	RETICLE_SIMPLE_CHANGE
		rename
			make as simple_make
		export
			{NONE} simple_make
		end

create
	make

feature {NONE} -- Creation

	make (an_element: RETICLE_VIEW_ELEMENT an_x_changed, a_y_changed: BOOLEAN)
		do
			simple_make (an_element)
			fixed_in_x_changed := an_x_changed
			fixed_in_y_changed := a_y_changed
		end

feature -- Properties

	fixed_in_x_changed: BOOLEAN
			-- Did fixed in X change?

	fixed_in_y_changed: BOOLEAN
			-- Did fixed in Y change?

feature -- Operations

	undo
			-- Undo change
		do
			if fixed_in_x_changed then
				element.unfix_in_x
			end
			if fixed_in_y_changed then
				element.unfix_in_y
			end
		end

	redo
			-- Redo change
		do
			if fixed_in_x_changed then
				element.fix_in_x
			end
			if fixed_in_y_changed then
				element.fix_in_y
			end
		end

end
