
indexing
	
	description: "Object that can generate colors for an %
		%element of a reticle view according to fixed in X and Y status"
	author: "David Hollenberg"
	date: "October 1, 2006"

class FIXED_STATUS_COLOR_GENERATOR
inherit
	RETICLE_VIEW_ELEMENT_COLOR_GENERATOR

create
	make

feature  -- Access

	border_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Foreground color for border (usually a
			-- rectangle) of `an_element'
		do
			Result := standard_color (an_element)
		end
	
	label_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Foreground color for label
		do
			Result := standard_color (an_element)
		end
	
feature {NONE} -- Implementation

	standard_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Standard color for `an_element', based on
			-- fixed in X and fixed in Y status
		local
			fixed_x, fixed_y: BOOLEAN
		do
			fixed_x := an_element.is_fixed_in_x
			fixed_y := an_element.is_fixed_in_y
			if not an_element.is_selectable then
				Result := palette.unselectable_color
			elseif fixed_x and fixed_y then
				Result := palette.fixed_in_x_and_y_color
			elseif fixed_x then
				Result := palette.fixed_in_x_only_color
			elseif fixed_y then
				Result := palette.fixed_in_y_only_color
			else
				Result := palette.not_fixed_in_x_or_y_color
			end
		end
	
end
