
indexing
	
	description: "Window to allow invocation of front end to send %
		%a message to some or all customer projects on a run"
	author: "David Hollenberg"
	date: "May 31, 2005"

deferred class FRONT_END_MESSAGE_WINDOW

inherit
	INTERNAL_FE_REQUEST_WINDOW
		

feature {NONE} -- Implementation

	fetch_cust_wos
			-- Fetch customer work orders for projects that
			-- may need notifications sent
		local
			cwo: CUST_WOS_ROW
		do
			create cwo.make_template
			cust_wos := cwo.cust_work_orders_for_production (session.run_id, connection, expected_count.At_least_zero)
		end

	set_visible_columns
			-- Set visible columns in `projects'
		local
			cols: ARRAYED_LIST [MULTI_COLUMN_LIST_COLUMN [ORDER_MULTI_COLUMN_LIST_ROW]]
		do
			create cols.make (10)
			cols.extend (create {RUN_ID_COLUMN [ORDER_MULTI_COLUMN_LIST_ROW]})
			cols.extend (create {DIE_ID_COLUMN [ORDER_MULTI_COLUMN_LIST_ROW]})
			cols.extend (create {DESIGN_NO_COLUMN [ORDER_MULTI_COLUMN_LIST_ROW]})
			cols.extend (create {ACCOUNT_STRING_COLUMN [ORDER_MULTI_COLUMN_LIST_ROW]})
			cols.extend (create {DATES_SENT_COLUMN [ORDER_MULTI_COLUMN_LIST_ROW]})
			projects.set_visible_columns (cols)
		end
			
	check_rows_valid
			-- Check that all selected rows are for work
			-- orders that are not still being paid for by MOSIS
		local
			mosis_paying_list: LIST [ORDER_MULTI_COLUMN_LIST_ROW]
			die_ids: STRING
			n: INTEGER
		do
			mosis_paying_list := selected_rows.twin
			mosis_paying_list.wipe_out
			selected_rows.do_if (agent mosis_paying_list.extend, agent {ORDER_MULTI_COLUMN_LIST_ROW}.is_mosis_still_paying)
			if not mosis_paying_list.is_empty then
				n := mosis_paying_list.count
				create die_ids.make (3 * n)
				mosis_paying_list.do_all (agent add_die_id (?, die_ids))
				inform ("Projects with the following die IDs cannot be notified because%NMOSIS is still paying the bill:%N%N" + die_ids + "%N%NPlease deselect these projects first.")
				operation.abort
			end
		end

	add_die_id (row: ORDER_MULTI_COLUMN_LIST_ROW s: STRING)
			-- Append die id for `row' to `s'
		do
			s.append (row.die_id)
			s.extend (' ')
		end

end
