
indexing

	date: "Thu Feb 26 08:25:14 2009"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application NFE, database user ALLMOSIS"
	database_tables: 
		"FUNDING_ALLOCS (MOSIS.FUNDING_ALLOCS)",
			-- Included columns
			-- 	CUST_ACCT_NO
			-- 	PRICING_SCHEDULE
			-- Excluded columns
			-- 	AMOUNT_AVAILABLE
			-- 	DATE_EFFECTIVE
			-- 	DATE_EXPIRES
			-- 	M_FUNDING_ALLOC_NO
			-- 	UNLIMITED
		"FUNDING_AUTHS (MOSIS.FUNDING_AUTHS)",
			-- Included columns
			-- 	AMOUNT_AUTHORIZED
			-- 	AUTH_ID
			-- 	CHARGES_TAXABLE
			-- 	COMMENTS
			-- 	CUST_ACCT_NO_REPORTING
			-- 	DATE_DOCUMENT
			-- 	DATE_EFFECTIVE
			-- 	DATE_EXPIRES
			-- 	DATE_FAX_RECD
			-- 	DATE_HARDCOPY_RECD
			-- 	DATE_VERBAL_RECD
			-- 	DIV_NO
			-- 	EDU_UNITS_AUTHORIZED
			-- 	OBJECT_CODE
			-- 	ORG_NO
			-- 	PO_TYPE
			-- 	RELEASE_REQUIRED
			-- 	SALES_TAX_ID
			-- 	SUB_TYPE
			-- 	UNLIMITED
			-- 	USC_ACCT_NO
			-- Excluded columns
			-- 	AMOUNT_SOLD
			-- 	AMOUNT_UNAVAILABLE
			-- 	EDU_UNITS_UNAVAILABLE
			-- 	M_FUNDING_AUTH_NO
		"FUNDING_DISTRIBUTIONS (MOSIS.FUNDING_DISTRIBUTIONS)"
			-- Included columns
			-- 	DISTRIBUTION_RANK
			-- 	M_FUNDING_ALLOC_NO
			-- 	M_FUNDING_AUTH_NO
			-- 	WEIGHTING_FACTOR
			-- Excluded columns
			-- 	AMOUNT_LIMIT
			-- 	AMOUNT_UNAVAILABLE

class FUNDING_TRIPLE_RAW

inherit

	DB_ANONYMOUS_ROW

create

	make_template, make_null, make_detached

feature -- Properties

	real_column_count: INTEGER = 27

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  cust_acct_no, pricing_schedule, amount_authorized, auth_id,%N  charges_taxable, comments, cust_acct_no_reporting, date_document,%N  fau.date_effective, fau.date_expires, date_fax_recd, date_hardcopy_recd,%N  date_verbal_recd, div_no, edu_units_authorized, object_code, org_no,%N  po_type, release_required, sales_tax_id, sub_type, fau.unlimited,%N  usc_acct_no, distribution_rank, fds.m_funding_alloc_no,%N  fds.m_funding_auth_no, weighting_factor"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "funding_allocs fal, funding_auths fau, funding_distributions fds"

	join_condition: STRING = "fds.m_funding_alloc_no = fal.m_funding_alloc_no and fds.m_funding_auth_no = fau.m_funding_auth_no"

	table_count: INTEGER = 3

	group_by: STRING = ""

feature -- Values

	cust_acct_no: INTEGER
			-- DB: NUMBER(5,0) not null

	pricing_schedule: STRING
			-- DB: VARCHAR2(10) not null

	amount_authorized: DOUBLE
			-- DB: NUMBER(10,2) not null

	auth_id: STRING
			-- DB: VARCHAR2(20) not null

	charges_taxable: BOOLEAN
			-- DB: CHAR(1) not null

	comments: STRING
			-- DB: VARCHAR2(255)

	cust_acct_no_reporting: INTEGER
			-- DB: NUMBER(6,0) not null

	date_document: DB_DATE
			-- DB: DATE not null

	date_effective: DB_DATE
			-- DB: DATE not null

	date_expires: DB_DATE
			-- DB: DATE

	date_fax_recd: DB_DATE
			-- DB: DATE

	date_hardcopy_recd: DB_DATE
			-- DB: DATE

	date_verbal_recd: DB_DATE
			-- DB: DATE

	div_no: INTEGER
			-- DB: NUMBER(6,0)

	edu_units_authorized: INTEGER
			-- DB: NUMBER(4,0) not null

	object_code: STRING
			-- DB: CHAR(5)

	org_no: INTEGER
			-- DB: NUMBER(6,0) not null

	po_type: STRING
			-- DB: VARCHAR2(15)

	release_required: BOOLEAN
			-- DB: CHAR(1) not null

	sales_tax_id: STRING
			-- DB: VARCHAR2(15)

	sub_type: STRING
			-- DB: VARCHAR2(7) not null

	unlimited: BOOLEAN
			-- DB: CHAR(1) not null

	usc_acct_no: STRING
			-- DB: NUMBER(10,0)
			-- Eiffel type specified explicitly

	distribution_rank: INTEGER
			-- DB: NUMBER(2,0) not null

	m_funding_alloc_no: INTEGER
			-- DB: NUMBER(6,0) not null

	m_funding_auth_no: INTEGER
			-- DB: NUMBER(6,0) not null

	weighting_factor: DOUBLE
			-- DB: NUMBER(*,*) not null

feature -- Nullness for null allowed columns

	is_null_comments: BOOLEAN
	is_null_date_expires: BOOLEAN
	is_null_date_fax_recd: BOOLEAN
	is_null_date_hardcopy_recd: BOOLEAN
	is_null_date_verbal_recd: BOOLEAN
	is_null_div_no: BOOLEAN
	is_null_object_code: BOOLEAN
	is_null_po_type: BOOLEAN
	is_null_sales_tax_id: BOOLEAN
	is_null_usc_acct_no: BOOLEAN

feature -- Nullness for non-null columns

	is_null_cust_acct_no: BOOLEAN
	is_null_pricing_schedule: BOOLEAN
	is_null_amount_authorized: BOOLEAN
	is_null_auth_id: BOOLEAN
	is_null_charges_taxable: BOOLEAN
	is_null_cust_acct_no_reporting: BOOLEAN
	is_null_date_document: BOOLEAN
	is_null_date_effective: BOOLEAN
	is_null_edu_units_authorized: BOOLEAN
	is_null_org_no: BOOLEAN
	is_null_release_required: BOOLEAN
	is_null_sub_type: BOOLEAN
	is_null_unlimited: BOOLEAN
	is_null_distribution_rank: BOOLEAN
	is_null_m_funding_alloc_no: BOOLEAN
	is_null_m_funding_auth_no: BOOLEAN
	is_null_weighting_factor: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and distribution_rank = r.distribution_rank
				and m_funding_alloc_no = r.m_funding_alloc_no
				and m_funding_auth_no = r.m_funding_auth_no
			Result := Result
				and is_null_distribution_rank = r.is_null_distribution_rank
				and is_null_m_funding_alloc_no = r.is_null_m_funding_alloc_no
				and is_null_m_funding_auth_no = r.is_null_m_funding_auth_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and cust_acct_no = r.cust_acct_no
				and amount_authorized = r.amount_authorized
				and charges_taxable = r.charges_taxable
				and cust_acct_no_reporting = r.cust_acct_no_reporting
				and div_no = r.div_no
				and edu_units_authorized = r.edu_units_authorized
				and org_no = r.org_no
				and release_required = r.release_required
				and unlimited = r.unlimited
				and weighting_factor = r.weighting_factor
			Result := Result
				and equal (pricing_schedule, r.pricing_schedule)
				and equal (auth_id, r.auth_id)
				and equal (comments, r.comments)
				and equal (date_document, r.date_document)
				and equal (date_effective, r.date_effective)
				and equal (date_expires, r.date_expires)
				and equal (date_fax_recd, r.date_fax_recd)
				and equal (date_hardcopy_recd, r.date_hardcopy_recd)
				and equal (date_verbal_recd, r.date_verbal_recd)
				and equal (object_code, r.object_code)
				and equal (po_type, r.po_type)
				and equal (sales_tax_id, r.sales_tax_id)
				and equal (sub_type, r.sub_type)
				and equal (usc_acct_no, r.usc_acct_no)
			Result := Result
				and is_null_cust_acct_no = r.is_null_cust_acct_no
				and is_null_pricing_schedule = r.is_null_pricing_schedule
				and is_null_amount_authorized = r.is_null_amount_authorized
				and is_null_auth_id = r.is_null_auth_id
				and is_null_charges_taxable = r.is_null_charges_taxable
				and is_null_comments = r.is_null_comments
				and is_null_cust_acct_no_reporting = r.is_null_cust_acct_no_reporting
				and is_null_date_document = r.is_null_date_document
				and is_null_date_effective = r.is_null_date_effective
				and is_null_date_expires = r.is_null_date_expires
				and is_null_date_fax_recd = r.is_null_date_fax_recd
				and is_null_date_hardcopy_recd = r.is_null_date_hardcopy_recd
				and is_null_date_verbal_recd = r.is_null_date_verbal_recd
				and is_null_div_no = r.is_null_div_no
				and is_null_edu_units_authorized = r.is_null_edu_units_authorized
				and is_null_object_code = r.is_null_object_code
				and is_null_org_no = r.is_null_org_no
				and is_null_po_type = r.is_null_po_type
				and is_null_release_required = r.is_null_release_required
				and is_null_sales_tax_id = r.is_null_sales_tax_id
				and is_null_sub_type = r.is_null_sub_type
				and is_null_unlimited = r.is_null_unlimited
				and is_null_usc_acct_no = r.is_null_usc_acct_no
				and is_null_weighting_factor = r.is_null_weighting_factor
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_integer (1)
			q.select_string (2, 10)
			q.select_double (3)
			q.select_string (4, 20)
			q.select_boolean (5)
			q.select_string (6, 255)
			q.select_integer (7)
			q.select_date (8)
			q.select_date (9)
			q.select_date (10)
			q.select_date (11)
			q.select_date (12)
			q.select_date (13)
			q.select_integer (14)
			q.select_integer (15)
			q.select_string (16, 5)
			q.select_integer (17)
			q.select_string (18, 15)
			q.select_boolean (19)
			q.select_string (20, 15)
			q.select_string (21, 7)
			q.select_boolean (22)
			q.select_string (23, 22)
			q.select_integer (24)
			q.select_integer (25)
			q.select_integer (26)
			q.select_double (27)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			cust_acct_no := q.integer_value (1)
			amount_authorized := q.double_value (3)
			charges_taxable := q.boolean_value (5)
			cust_acct_no_reporting := q.integer_value (7)
			div_no := q.integer_value (14)
			edu_units_authorized := q.integer_value (15)
			org_no := q.integer_value (17)
			release_required := q.boolean_value (19)
			unlimited := q.boolean_value (22)
			distribution_rank := q.integer_value (24)
			m_funding_alloc_no := q.integer_value (25)
			m_funding_auth_no := q.integer_value (26)
			weighting_factor := q.double_value (27)
		end

	fill_in_references (q: SQL_QUERY)
		do
			pricing_schedule := q.string_value (2)
			auth_id := q.string_value (4)
			comments := q.string_value (6)
			date_document := q.date_value (8)
			date_effective := q.date_value (9)
			date_expires := q.date_value (10)
			date_fax_recd := q.date_value (11)
			date_hardcopy_recd := q.date_value (12)
			date_verbal_recd := q.date_value (13)
			object_code := q.string_value (16)
			po_type := q.string_value (18)
			sales_tax_id := q.string_value (20)
			sub_type := q.string_value (21)
			usc_acct_no := q.string_value (23)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (2, pricing_schedule)
			q.get_string_value (4, auth_id)
			q.get_string_value (6, comments)
			q.get_date_value (8, date_document)
			q.get_date_value (9, date_effective)
			q.get_date_value (10, date_expires)
			q.get_date_value (11, date_fax_recd)
			q.get_date_value (12, date_hardcopy_recd)
			q.get_date_value (13, date_verbal_recd)
			q.get_string_value (16, object_code)
			q.get_string_value (18, po_type)
			q.get_string_value (20, sales_tax_id)
			q.get_string_value (21, sub_type)
			q.get_string_value (23, usc_acct_no)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_cust_acct_no := q.is_null (1)
			is_null_pricing_schedule := q.is_null (2)
			is_null_amount_authorized := q.is_null (3)
			is_null_auth_id := q.is_null (4)
			is_null_charges_taxable := q.is_null (5)
			is_null_comments := q.is_null (6)
			is_null_cust_acct_no_reporting := q.is_null (7)
			is_null_date_document := q.is_null (8)
			is_null_date_effective := q.is_null (9)
			is_null_date_expires := q.is_null (10)
			is_null_date_fax_recd := q.is_null (11)
			is_null_date_hardcopy_recd := q.is_null (12)
			is_null_date_verbal_recd := q.is_null (13)
			is_null_div_no := q.is_null (14)
			is_null_edu_units_authorized := q.is_null (15)
			is_null_object_code := q.is_null (16)
			is_null_org_no := q.is_null (17)
			is_null_po_type := q.is_null (18)
			is_null_release_required := q.is_null (19)
			is_null_sales_tax_id := q.is_null (20)
			is_null_sub_type := q.is_null (21)
			is_null_unlimited := q.is_null (22)
			is_null_usc_acct_no := q.is_null (23)
			is_null_distribution_rank := q.is_null (24)
			is_null_m_funding_alloc_no := q.is_null (25)
			is_null_m_funding_auth_no := q.is_null (26)
			is_null_weighting_factor := q.is_null (27)
		end

feature {NONE} -- Initialization

	set_null
		do
			is_null_cust_acct_no := True
			is_null_pricing_schedule := True
			is_null_amount_authorized := True
			is_null_auth_id := True
			is_null_charges_taxable := True
			is_null_comments := True
			is_null_cust_acct_no_reporting := True
			is_null_date_document := True
			is_null_date_effective := True
			is_null_date_expires := True
			is_null_date_fax_recd := True
			is_null_date_hardcopy_recd := True
			is_null_date_verbal_recd := True
			is_null_div_no := True
			is_null_edu_units_authorized := True
			is_null_object_code := True
			is_null_org_no := True
			is_null_po_type := True
			is_null_release_required := True
			is_null_sales_tax_id := True
			is_null_sub_type := True
			is_null_unlimited := True
			is_null_usc_acct_no := True
			is_null_distribution_rank := True
			is_null_m_funding_alloc_no := True
			is_null_m_funding_auth_no := True
			is_null_weighting_factor := True
			create pricing_schedule.make (0)
			create auth_id.make (0)
			create comments.make (0)
			create {ORACLE_DATE} date_document.set_null
			create {ORACLE_DATE} date_effective.set_null
			create {ORACLE_DATE} date_expires.set_null
			create {ORACLE_DATE} date_fax_recd.set_null
			create {ORACLE_DATE} date_hardcopy_recd.set_null
			create {ORACLE_DATE} date_verbal_recd.set_null
			create object_code.make (0)
			create po_type.make (0)
			create sales_tax_id.make (0)
			create sub_type.make (0)
			create usc_acct_no.make (0)
		end

end
