
indexing
	
	description: "Multi-column list row for a die and%
		%associated GDS merge batch job"
	author: "David Hollenberg"
	date: "October 9, 2008"

class GDS_MERGE_DIE_JOB
inherit	
	GDS_MERGE_JOB
		rename
			make as gds_merge_make
		end
	HAS_DESIGN_NUMBER
		rename
			design_number as design_no,
			has_design_number as has_design_no
		undefine
			copy, is_equal, default_create
		end
	HAS_DIE_TYPE
		undefine
			copy, is_equal, default_create
		end
	HAS_NAME
		undefine
			copy, is_equal, default_create
		end

create 
	make

create {GDS_MERGE_DIE_JOB}
	make_filled

feature {NONE} -- Creation

	make (gds_row: RUN_GDS_FILES_MROW ifi: IC_FAB_INSTANCES_EROW)
		require
			gds_row_not_void: gds_row /= Void
			ifif_not_void: ifi /= Void
		do
			gds_merge_make (gds_row)
			set_fab_instance (ifi)
			enable_visible
		ensure
			is_visible: is_visible
		end

feature -- Properties

	fab_instance: IC_FAB_INSTANCES_EROW
			-- Information about the fab instance, including
			-- extra information from other tables

	die_type: STRING
			-- Die type
		local
			ifi_type: IC_FAB_INSTANCE_TYPE_VALUES
			di_type: DIE_TYPE_VALUES
			type: STRING
		do
			type := fab_instance.ic_fab_instance_type
			if type.is_equal (ifi_type.Customer_fab) then
				Result := di_type.Cust_die
			elseif type.is_equal (ifi_type.Test_vehicle) then
				Result := di_type.Test_vehicle
			else
				handle_hard_error ("unknown ic_fab_instance_type " + type)
			end
		end

	has_field_name: BOOLEAN = False
			-- Does `Current' have a associated field name?

	has_design_no: BOOLEAN = True
			-- Is there an associated design number?

	design_no: INTEGER
			-- Design number
		do
			Result := fab_instance.design_no
		end

	name: STRING
			-- Identifying name
		do
			Result := fab_instance.design_name
		end

	job_name (a_run_id: STRING): STRING
			-- Name of job for `a_run_id'
		do
			Result := a_run_id + gds_merge_job_base + run_gds_files_row.die_id
		end

feature -- Modification

	set_fab_instance (f: IC_FAB_INSTANCES_EROW)
			-- Set `fab_instance' to `f'
		do
			fab_instance := f
		ensure
			fab_instance_set: fab_instance = f
		end

feature {NONE} -- Implementation

	new_filled_list (n: INTEGER): like Current
			-- New list with `n' elements.
		do
			create Result.make_filled (n)
		end
		
end
