class GDS_PAIR
		-- just a pair of integers for a gds layer
		-- (or a layer and a null datatype to mean all datatypes)

inherit
	VIRTUAL_GDS_PAIR

create

	make, make_null, make_integer

feature	-- the gds layer and datatype as attributes

	layer, datatype: INTEGER
	is_null_datatype: BOOLEAN

feature	-- creation

	make(l, dt: INTEGER) is
	require	valid_layer: is_valid_layer(l);
		valid_datatype: is_valid_datatype(dt)
	do  layer := l;
	    datatype := dt
	    is_null_datatype := false
	ensure matches: layer = l and datatype = dt
	end;

	make_null(l: INTEGER) is
	require	valid_layer: is_valid_layer(l);
	do  layer := l;
	    is_null_datatype := true
	ensure matches: layer = l and is_null_datatype
	end;

	make_integer(i: INTEGER) is
		-- fake a gds pair from a single integer
	require valid_integer: 0 <= i and i < 65536
	do  make(i \\ 256, i // 256)
	ensure i = as_integer
	end;

end -- GDS_PAIR