class GDSXDESIGN_TECHN_ID_LAYERS_ROW

inherit
	GDSXDESIGN_TECHN_ID_LAYERS_RAW
		undefine	out
		end;

	VIRTUAL_GDS_PAIR
		rename	layer	as gds_layer,
			datatype as gds_datatype,
			is_null_datatype as is_null_gds_datatype
		end;
	ROW_COUNT_CHECK_ACCESS
		undefine
			out
		end

create
	make_template, make_null

feature	-- Collections

	rows_for_design_techn (dt: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current] is
			-- All rows design techn ID `dt'
		require
			dt_exists: dt /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_S
		do
			create b.make (dt)
			Result := all_rows_filtered_ordered (conn, "design_techn_id = :1", b, "layer_name, gds_datatype, gds_layer")
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end


feature	-- out

	-- Note that the out that we inherit from VIRTUAL_GDS_PAIR
	--  publishes just the gds value, ignoring the dtid and
	--  layer name.

end -- GDSXDESIGN_TECHN_ID_LAYERS_ROW
