
indexing
	
	description: "A run closing step operation that creates one layout %
		%overhead file for die that needs one"
	author: "David Hollenberg"
	date: "July 9, 2005"

class GEN_DIE_OVERHEAD_FILES_OP
inherit
	GEN_GEOMETRY_FILES_OP

create
	make

feature -- Properties

	input_data_items: LIST [STRING]
			-- Data items required before step can be executed
		do
			Result := array_as_list (<<
					data_item.Mask_techn,
					data_item.Effective_other_border,
					data_item.Effective_overhead_styles,
					data_item.Assigned_die_ids,
					data_item.Test_vehicle_fab_instances,
					data_item.Overhead_run_id,
					data_item.Converted_scmos_layout
				 >>)
		end

feature {NONE} -- Implementation

	dies_needing_file (dies: LIST [like anchored_die]): LIST [like anchored_die]
			-- Dies in `dies' for which geometry file needs
			-- to be generated
		do
			create {ARRAYED_LIST [like anchored_die]} Result.make (dies.count)
			dies.do_if (agent Result.extend, agent {like anchored_die}.needs_overhead_file)
		end

	has_valid_type (r: like anchored_die): BOOLEAN
			-- Does `r' have a valid type for the
			-- particular file generation operation to be
			-- performed?
		do
			Result := r.needs_overhead_file
		end

	generated_file_name (r: like anchored_die): STRING
			-- Name of geometry file to be generated for `r'
		do
			Result := file_generator.die_overhead_layout_file (r.die_id).file_pathname
		end

	generate_file (gen: MOSIS_OVERHEAD_GENERATOR r: like anchored_die dcf: DATA_CONSUMER_CHECKED_FILE)
			-- Generate die overhead layout file for `r' into `dcf'
			-- using `gen' to do the work
		do
			gen.overhead_to_cif (r, dcf)
		end

	delete_generated_file (r: like anchored_die)
			-- Delete die overhead layout file for `r',
			-- if it exists
		do
			file_generator.die_overhead_layout_file (r.die_id).delete_if_exists
		end

	progress_window_title: STRING = "Die Overhead File Generation"
			-- Title for progress window (without run id)

	file_description: STRING = "die overhead CIF file"
			-- Description of type of files being generated,
			-- for error messages

end
