
indexing
	
	description: "A run closing step operation that creates one layout %
		%file for each filler"
	author: "David Hollenberg"
	date: "July 9, 2005"

class GEN_FILLER_FILES_OP
inherit
	GEN_GEOMETRY_FILES_OP

create
	make

feature -- Properties

	input_data_items: LIST [STRING]
			-- Data items required before step can be executed
		do
			Result := array_as_list (<<
				data_item.Mask_techn,
				data_item.Assigned_die_ids,
				data_item.Converted_scmos_layout
			 >>)
		end

feature {NONE} -- Implementation

	dies_needing_file (dies: LIST [like anchored_die]): LIST [like anchored_die]
			-- Dies in `dies' for which geometry file needs
			-- to be generated
		do
			create {ARRAYED_LIST [like anchored_die]} Result.make (dies.count)
			dies.do_if (agent Result.extend, agent {like anchored_die}.is_filler)
		end

	has_valid_type (r: like anchored_die): BOOLEAN
			-- Does `r' have a valid type for the
			-- particular file generation operation to be
			-- performed?
		do
			Result := r.is_filler
		end

	generated_file_name (r: like anchored_die): STRING
			-- Name of geometry file to be generated for `r'
		do
			Result := file_generator.die_filler_layout_file (r.die_id).file_pathname
		end

	generate_file (gen: MOSIS_OVERHEAD_GENERATOR r: like anchored_die dcf: DATA_CONSUMER_CHECKED_FILE)
			-- Generate filler layout file for `r' into `dcf'
			-- using `gen' to do the work
		do
			gen.filler_to_cif (r, dcf)
		end

	delete_generated_file (r: like anchored_die)
			-- Delete scribe layout file for `r', if it exists
		do
			file_generator.die_filler_layout_file (r.die_id).delete_if_exists
		end

	progress_window_title: STRING = "Filler Generation"
			-- Title for progress window (without run id)

	file_description: STRING = "filler CIF file"
			-- Description of type of files being generated,
			-- for error messages

end
