
indexing
	
	description: "A run closing step operation that generates %
		%public status information about the run"
	author: "David Hollenberg"
	date: "May 26, 2004"

class GEN_PUBLIC_STATUS_OP
inherit
	FAB_POSTING_OP
	NO_USER_INTERFACE
	CREATES_EXTERNAL_STATE

create
	make

feature -- Properties

	input_data_items: LIST [STRING]
			-- Data items required before step can be executed
		do
			Result := array_as_list (<<
					data_item.Fab_posted_event
				 >>)
		end

feature {NONE} -- Implementation

	is_applicable: BOOLEAN
			-- Is step applicable to run for session?
		do
			Result := not cache.is_development_run
		end

	do_step
			-- Execute step
		do
			execute_run_status_report
			process_pending_abort
			execute_all_runs_status_report
			call_completion_actions
		end

	undo_step
			-- Undo execution of step
		local
			step_name: PRIMITIVE_STEP_NAME_VALUES
			event_name: EVENT_NAME_VALUES
		do
			if not steps.there_exists (agent {RC_PRIMITIVE_STEP}.has_step_name (step_name.Post_run)) then
				session.commit_actions.extend (agent inform ("Undoing this step (" + step.step_name + ") does not re-run reports visible on%Nthe public web site to generate versions without this run.%NYou must undo the step that inserts the " + event_name.Fab_posted + " event to remove%Nthis run from status reports on the public web site."))
			end
			call_completion_actions
		end

	set_state
			-- Set `state'
		do
			state := Void
		end

end
