
indexing
	
	description: "A run closing step operation that generates PostScript %
		%and PDF files for a single map of the wafer or a field of view"
	author: "David Hollenberg"
	date: "January 21, 2005"

deferred class GEN_SINGLE_MAP_OP
inherit
	GEN_MAP_OP

feature {NONE} -- Implementation

	generate_maps
			-- Generate PostScript and PDF files for map(s)
		do
			create_map
			generate_postscript_file (map, postscript_file.file_pathname)
			convert_postscript_to_pdf (postscript_file.file_pathname, pdf_file.file_pathname)
		end

	create_map
			-- Create `map'
		deferred
		end

	delete_maps
			-- Delete map files
		do
			postscript_file.delete_if_exists
			pdf_file.delete_if_exists
		end

	postscript_file: RC_FILE
			-- PostScript file to write
		deferred
		ensure
			result_exists: Result /= Void
		end

	pdf_file: RC_FILE
			-- PDF file to write
		deferred
		ensure
			result_exists: Result /= Void
		end

end
