
indexing
	
	description: "A run closing step operation that generates PostScript %
		%and PDF files that show the fields of view stepped across %
		%the wafer"
	author: "David Hollenberg"
	date: "January 20, 2005"

class GEN_STEP_PATTERN_MAP_OP
inherit
	GEN_SINGLE_MAP_OP
		redefine
			input_data_items,
			drawing_rotatable,
			is_applicable
		end

create
	make

feature -- Properties

	input_data_items: LIST [STRING]
			-- Data items required before step can be executed
		do
			Result := array_as_list (<<
				data_item.Field_set,
				data_item.Field_step_pattern
				>>)
		end

	is_applicable: BOOLEAN
			-- Is step applicable?
		do
			Result := cache.is_reticle_packing_target
		end

feature {NONE} -- Implementation

	create_map
			-- Create `map'
		do
			map := map_generator.step_pattern_map
		end

	drawing_rotatable: BOOLEAN = False
			-- May drawing be rotated to make it appear
			-- larger on the paper, if appropriate?

	postscript_file: RC_FILE
			-- PostScript file to write
		do
			Result := file_generator.step_pattern_map_ps_file
		end

	pdf_file: RC_FILE
			-- PDF file to write
		do
			Result := file_generator.step_pattern_map_pdf_file
		end

end
