
indexing

	date: "Fri Jan 23 15:56:10 2009"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user GOLDBERG"
	database_tables: 
		"GEOMETRIES (MOSIS.GEOMETRIES)"
			-- Included columns
			-- 	DESCRIPTION
			-- 	DESIGN_TECHN
			-- 	EXTERNAL_FILES
			-- 	EXTERNAL_TO_PAYLOAD
			-- 	GEOMETRY_FILENAME
			-- 	GEOMETRY_FORMAT
			-- 	GEOMETRY_ID
			-- 	REQUIRED
			-- 	SIZE_X
			-- 	SIZE_Y
			-- 	TOP_STRUCTURE_NAME
			-- 	WAFER_TECHN
			-- Excluded columns
			-- 	(none)

class GEOMETRIES_RAW

inherit

	DB_IDENTIFIED_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_geometry_id: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_geometry_id_exists: the_geometry_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			geometry_id := the_geometry_id
			is_null_geometry_id := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 12

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  description, design_techn, external_files, external_to_payload,%N  geometry_filename, geometry_format, geometry_id, required, size_x,%N  size_y, top_structure_name, wafer_techn"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "geometries g"

	join_condition: STRING = ""

	table_name: STRING = "geometries"

	key_where_clause: STRING = "geometry_id = :1"

feature -- Values

	description: STRING
			-- DB: VARCHAR2(255)

	design_techn: STRING
			-- DB: VARCHAR2(50)

	external_files: BOOLEAN
			-- DB: CHAR(1) not null

	external_to_payload: BOOLEAN
			-- DB: CHAR(1) not null

	geometry_filename: STRING
			-- DB: VARCHAR2(50)

	geometry_format: STRING
			-- DB: VARCHAR2(8)

	geometry_id: STRING
			-- DB: VARCHAR2(50) not null

	required: BOOLEAN
			-- DB: CHAR(1) not null

	size_x: DOUBLE
			-- DB: NUMBER(*,*)

	size_y: DOUBLE
			-- DB: NUMBER(*,*)

	top_structure_name: STRING
			-- DB: VARCHAR2(255)

	wafer_techn: STRING
			-- DB: VARCHAR2(50) not null

feature -- Nullness for null allowed columns

	is_null_description: BOOLEAN
	is_null_design_techn: BOOLEAN
	is_null_geometry_filename: BOOLEAN
	is_null_geometry_format: BOOLEAN
	is_null_size_x: BOOLEAN
	is_null_size_y: BOOLEAN
	is_null_top_structure_name: BOOLEAN

feature -- Nullness for non-null columns

	is_null_external_files: BOOLEAN
	is_null_external_to_payload: BOOLEAN
	is_null_geometry_id: BOOLEAN
	is_null_required: BOOLEAN
	is_null_wafer_techn: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (geometry_id, r.geometry_id)
			Result := Result
				and is_null_geometry_id = r.is_null_geometry_id
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and external_files = r.external_files
				and external_to_payload = r.external_to_payload
				and required = r.required
				and size_x = r.size_x
				and size_y = r.size_y
			Result := Result
				and equal (description, r.description)
				and equal (design_techn, r.design_techn)
				and equal (geometry_filename, r.geometry_filename)
				and equal (geometry_format, r.geometry_format)
				and equal (top_structure_name, r.top_structure_name)
				and equal (wafer_techn, r.wafer_techn)
			Result := Result
				and is_null_description = r.is_null_description
				and is_null_design_techn = r.is_null_design_techn
				and is_null_external_files = r.is_null_external_files
				and is_null_external_to_payload = r.is_null_external_to_payload
				and is_null_geometry_filename = r.is_null_geometry_filename
				and is_null_geometry_format = r.is_null_geometry_format
				and is_null_required = r.is_null_required
				and is_null_size_x = r.is_null_size_x
				and is_null_size_y = r.is_null_size_y
				and is_null_top_structure_name = r.is_null_top_structure_name
				and is_null_wafer_techn = r.is_null_wafer_techn
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 255)
			q.select_string (2, 50)
			q.select_boolean (3)
			q.select_boolean (4)
			q.select_string (5, 50)
			q.select_string (6, 8)
			q.select_string (7, 50)
			q.select_boolean (8)
			q.select_double (9)
			q.select_double (10)
			q.select_string (11, 255)
			q.select_string (12, 50)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			external_files := q.boolean_value (3)
			external_to_payload := q.boolean_value (4)
			required := q.boolean_value (8)
			size_x := q.double_value (9)
			size_y := q.double_value (10)
		end

	fill_in_references (q: SQL_QUERY)
		do
			description := q.string_value (1)
			design_techn := q.string_value (2)
			geometry_filename := q.string_value (5)
			geometry_format := q.string_value (6)
			geometry_id := q.string_value (7)
			top_structure_name := q.string_value (11)
			wafer_techn := q.string_value (12)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, description)
			q.get_string_value (2, design_techn)
			q.get_string_value (5, geometry_filename)
			q.get_string_value (6, geometry_format)
			q.get_string_value (7, geometry_id)
			q.get_string_value (11, top_structure_name)
			q.get_string_value (12, wafer_techn)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_description := q.is_null (1)
			is_null_design_techn := q.is_null (2)
			is_null_external_files := q.is_null (3)
			is_null_external_to_payload := q.is_null (4)
			is_null_geometry_filename := q.is_null (5)
			is_null_geometry_format := q.is_null (6)
			is_null_geometry_id := q.is_null (7)
			is_null_required := q.is_null (8)
			is_null_size_x := q.is_null (9)
			is_null_size_y := q.is_null (10)
			is_null_top_structure_name := q.is_null (11)
			is_null_wafer_techn := q.is_null (12)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_geometry_id := True
			create geometry_id.make (0)
		end

	set_null_nonkey
		do
			is_null_description := True
			is_null_design_techn := True
			is_null_external_files := True
			is_null_external_to_payload := True
			is_null_geometry_filename := True
			is_null_geometry_format := True
			is_null_required := True
			is_null_size_x := True
			is_null_size_y := True
			is_null_top_structure_name := True
			is_null_wafer_techn := True
			create description.make (0)
			create design_techn.make (0)
			create geometry_filename.make (0)
			create geometry_format.make (0)
			create top_structure_name.make (0)
			create wafer_techn.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, geometry_id, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and external_files = q.boolean_value (3)
				and external_to_payload = q.boolean_value (4)
				and required = q.boolean_value (8)
				and size_x = q.double_value (9)
				and size_y = q.double_value (10)
			q.get_string_value (1, s)
			Result := Result and equal (description, s)
			q.get_string_value (2, s)
			Result := Result and equal (design_techn, s)
			q.get_string_value (5, s)
			Result := Result and equal (geometry_filename, s)
			q.get_string_value (6, s)
			Result := Result and equal (geometry_format, s)
			q.get_string_value (7, s)
			Result := Result and equal (geometry_id, s)
			q.get_string_value (11, s)
			Result := Result and equal (top_structure_name, s)
			q.get_string_value (12, s)
			Result := Result and equal (wafer_techn, s)
			Result := Result
				and is_null_description = q.is_null (1)
				and is_null_design_techn = q.is_null (2)
				and is_null_external_files = q.is_null (3)
				and is_null_external_to_payload = q.is_null (4)
				and is_null_geometry_filename = q.is_null (5)
				and is_null_geometry_format = q.is_null (6)
				and is_null_geometry_id = q.is_null (7)
				and is_null_required = q.is_null (8)
				and is_null_size_x = q.is_null (9)
				and is_null_size_y = q.is_null (10)
				and is_null_top_structure_name = q.is_null (11)
				and is_null_wafer_techn = q.is_null (12)
		end

end
