
indexing
	
	description: "Object that can handle an informational message and get confirmation that user wants to proceed in a graphical environment"
	author: "David Hollenberg"
	date: "March 20, 2003"

class GUI_CONFIRMATION_HANDLER
inherit
	GRAPHICAL_CONDITION_HANDLER
		redefine
			is_notify_allowed
		end

create
	make

feature -- Properties

	is_notify_allowed (cond: APPLICATION_CONDITION): BOOLEAN
			-- Should handler allow user to notify others
			-- of `cond'?
		do
			Result := False
		end

feature {NONE} -- Implementation

	show_dialog (w: EV_WINDOW msg_text: STRING notify: BOOLEAN)
			-- Display modal relative to `w' a dialog for
			-- a warning (can be ignored) with error
			-- message `msg_text'
		local
			ok_button, cancel_button: EV_BUTTON
		do
			create {EV_CONFIRMATION_DIALOG} dialog.make_with_text (msg_text)
			dialog.set_background_color (user_interface.background_color)
			title := "Confirmation"
			dialog.set_title (title)
			dialog.set_buttons_and_actions (<< ev_ok, ev_cancel >>, << agent handle_continue, agent handle_abort >>)
			ok_button := dialog.button (ev_ok)
			cancel_button := dialog.button (ev_cancel)
			dialog.set_default_push_button (ok_button)
			dialog.set_default_cancel_button (cancel_button)
			-- dialog.show_actions.extend (agent ok_button.center_pointer)
			dialog.show_modal_to_window (w)
		end

end
