
indexing
	
	description: "Object that can handle a hard error in a graphical environment, with a retry option"
	author: "David Hollenberg"
	date: "March 20, 2003"

class GUI_HARD_RETRY_ERROR_HANDLER
inherit
	GRAPHICAL_CONDITION_HANDLER

create
	make

feature {NONE} -- Implementation

	show_dialog (w: EV_WINDOW msg_text: STRING notify: BOOLEAN)
			-- Display modal relative to `w' an error
			-- dialog for a hard error (cannot be ignored)
			-- which can be retried, with error message
			-- `msg_text'
		local
			retry_button, abort_button: EV_BUTTON
		do
			create {EV_ERROR_DIALOG} dialog.make_with_text (msg_text)
			dialog.set_background_color (user_interface.background_color)
			title := "Hard Error"
			dialog.set_title (title)
			if notify then
				dialog.set_buttons_and_actions (<< ev_retry, ev_abort, Notify_button_text >>, << agent handle_retry, agent handle_abort, agent handle_notify >>)
			else
				dialog.set_buttons_and_actions (<< ev_retry, ev_abort >>, << agent handle_retry, agent handle_abort >>)
			end
			retry_button := dialog.button (ev_retry)
			abort_button := dialog.button (ev_abort)
			dialog.set_default_push_button (retry_button)
			dialog.set_default_cancel_button (abort_button)
			-- dialog.show_actions.extend (agent retry_button.center_pointer)
			dialog.show_modal_to_window (w)
		end

end
