
indexing
	
	description: "Object that can handle an informational message in a graphical environment"
	author: "David Hollenberg"
	date: "March 20, 2003"

class GUI_INFORMATION_HANDLER
inherit
	GRAPHICAL_CONDITION_HANDLER
		redefine
			is_notify_allowed
		end

create
	make

feature -- Properties

	is_notify_allowed (cond: APPLICATION_CONDITION): BOOLEAN
			-- Should handler allow user to notify others
			-- of `cond'?
		do
			Result := False
		end

feature {NONE} -- Implementation

	show_dialog (w: EV_WINDOW msg_text: STRING notify: BOOLEAN)
			-- Display modal relative to `w' a dialog for
			-- an informational message with message
			-- `msg_text'
		local
			ok_button: EV_BUTTON
		do
			create {EV_INFORMATION_DIALOG} dialog.make_with_text (msg_text)
			dialog.set_background_color (user_interface.background_color)
			title := "Information"
			dialog.set_title (title)
			dialog.set_buttons_and_actions (<< ev_ok >>, << agent handle_continue >>)
			ok_button := dialog.button (ev_ok)
			dialog.set_default_push_button (ok_button)
			-- dialog.show_actions.extend (agent ok_button.center_pointer)
			dialog.show_modal_to_window (w)
		end

end
