
indexing
	
	description: "Object that can handle a question get boolean answer from user"
	author: "David Hollenberg"
	date: "March 20, 2003"

class GUI_QUESTION_HANDLER
inherit
	GRAPHICAL_CONDITION_HANDLER
		redefine
			is_notify_allowed
		end

create
	make

feature -- Properties

	is_notify_allowed (cond: APPLICATION_CONDITION): BOOLEAN
			-- Should handler allow user to notify others
			-- of `cond'?
		do
			Result := False
		end

feature {NONE} -- Implementation

	show_dialog (w: EV_WINDOW msg_text: STRING notify: BOOLEAN)
			-- Display modal relative to `w' a dialog for
			-- a question with text `msg_text'
		local
			yes_button, no_button, cancel_button: EV_BUTTON
		do
			create {EV_QUESTION_DIALOG} dialog.make_with_text (msg_text)
			dialog.set_background_color (user_interface.background_color)
			title := "Question"
			dialog.set_title (title)
			dialog.set_buttons_and_actions (<< ev_yes, ev_no, ev_cancel >>, << agent handle_yes, agent handle_no, agent handle_abort >>)
			yes_button := dialog.button (ev_yes)
			no_button := dialog.button (ev_no)
			cancel_button := dialog.button (ev_cancel)
			dialog.set_default_push_button (yes_button)
			dialog.set_default_cancel_button (cancel_button)
			-- dialog.show_actions.extend (agent yes_button.center_pointer)
			dialog.show_modal_to_window (w)
		end

end
