
indexing
	
	description: "Object that can handle a warning in a graphical environment, with a retry option"
	author: "David Hollenberg"
	date: "March 20, 2003"

class GUI_RETRY_WARNING_HANDLER
inherit
	GRAPHICAL_CONDITION_HANDLER
		redefine
			dialog
		end

create
	make

feature {NONE} -- Implementation

	show_dialog (w: EV_WINDOW msg_text: STRING notify: BOOLEAN)
			-- Display modal relative to `w' a dialog for
			-- a warning (can be ignored) with error
			-- message `msg_text'
		local
			retry_button, abort_button: EV_BUTTON
			font: EV_FONT
		do
			create {FONTABLE_WARNING_DIALOG} dialog.make_with_text (msg_text)
			dialog.set_background_color (user_interface.background_color)
			title := "Warning"
			dialog.set_title (title)
			if needs_column_alignment then
				create font.make_with_values (gui.Family_screen,
					gui.Weight_regular, gui.Shape_regular, 14)
				font.preferred_families.extend ("Courier")
				dialog.set_text_font (font)
			end
			if notify then
				dialog.set_buttons_and_actions (<< ev_ok, ev_retry, ev_cancel, Notify_button_text >>, << agent handle_ignore, agent handle_retry, agent handle_abort, agent handle_notify >>)
			else
				dialog.set_buttons_and_actions (<< ev_ok, ev_retry, ev_cancel >>, << agent handle_ignore, agent handle_retry, agent handle_abort >>)
			end
			retry_button := dialog.button (ev_retry)
			abort_button := dialog.button (ev_cancel)
			dialog.set_default_push_button (retry_button)
			dialog.set_default_cancel_button (abort_button)
			-- dialog.show_actions.extend (agent retry_button.center_pointer)
			dialog.show_modal_to_window (w)
		end

	dialog: FONTABLE_WARNING_DIALOG
			-- Dialog used to report message

end
