
indexing
	
	description: "Object that can handle a soft error in a graphical environment"
	author: "David Hollenberg"
	date: "March 20, 2003"

class GUI_SOFT_ERROR_HANDLER
inherit
	GRAPHICAL_CONDITION_HANDLER

create
	make

feature {NONE} -- Implementation

	show_dialog (w: EV_WINDOW msg_text: STRING notify: BOOLEAN)
			-- Display modal relative to `w' an error
			-- dialog for a soft error (can be ignored)
			-- with error message `msg_text'
		local
			abort_button, ignore_button: EV_BUTTON
		do
			create {EV_ERROR_DIALOG} dialog.make_with_text (msg_text)
			dialog.set_background_color (user_interface.background_color)
			title := "Soft Error"
			dialog.set_title (title)
			if notify then
				dialog.set_buttons_and_actions (<< ev_abort, ev_ignore, Notify_button_text >>, << agent handle_abort, agent handle_ignore, agent handle_notify >>)
			else
				dialog.set_buttons_and_actions (<< ev_abort, ev_ignore >>, << agent handle_abort, agent handle_ignore >>)
			end
			ignore_button := dialog.button (ev_ignore)
			abort_button := dialog.button (ev_abort)
			dialog.set_default_push_button (abort_button)
			dialog.set_default_cancel_button (abort_button)
			-- dialog.show_actions.extend (agent abort_button.center_pointer)
			dialog.show_modal_to_window (w)
		end

end
