class HASHED_CONFIGURATION_VARS
		-- CONFIGURATION_VARS kept in a hash table

inherit
	CONFIGURATION_VARS
	undefine is_equal, copy
	end;

	HASH_TABLE[STRING, STRING]
	rename  
		has as hash_table_has,
		item as hash_table_item
	export {HASHED_CONFIGURATION_VARS} all
	end;

	DICTIONARY		-- picks up item from hash_table
	undefine is_equal, copy
	end;

	STRING_UTILITIES_ACCESS
	undefine is_equal, copy
	end;

create
	make

feature -- initialization (done post-creation)

	initialize_from_args(args: ARRAY[STRING]) is
		-- set up the vars from the command line args
	do  
	    original_args := args;
	    configure_from_args(args);
	end;

feature -- Access

	has (key: STRING): BOOLEAN is
			-- Is there an entry for `key'?
		do
			Result := hash_table_has (key)
		end;

	item (key: STRING): STRING is
			-- Value associated with `key' or Void if none
		do
			Result := hash_table_item (key)
		end;

feature -- copy of the args actually used

	original_args: ARRAY[STRING]

feature -- variable installation (effector for CONFIGURATION_VARS)

	set_configuration_variable(key, val: STRING) is
	do  force(val, key)
	end;

end -- HASHED_CONFIGURATION_VARS
