
indexing
	
	description: "Action to be spread elements horizontally"
	author: "David Hollenberg"
	date: "November 16, 2006"

class HORIZONTAL_SPREAD_ACTION
inherit
	SPREAD_ACTION

feature {NONE} -- Implementation

	compute_center (an_element: RETICLE_VIEW_ELEMENT)
			-- Compute `new_center' for `an_element'.
		local
			n: INTEGER_64
			size_x, diff, diff_y: DOUBLE
		do
			size_x := an_element.model_element.size_x
			diff := largest_dimension - size_x
			diff_y := largest_dimension / 2.0
			n := grid.rounded_edge_units (diff)
			if n \\ 2 /= 0 then
				diff_y := diff_y + grid.edge_resolution / 2
			end
			new_center.make_xy (next_point.x + size_x / 2, next_point.y + diff_y)
			next_point.make_xy (grid.rounded_edge (next_point.x + size_x + spacing), next_point.y)
		end

end
