
indexing

	date: "Thu Feb  5 11:48:48 2009"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user DHOLLEN"
	database_tables: 
		"IBM_MAP_DATA (MOSIS.IBM_MAP_DATA)"
			-- Included columns
			-- 	CENTER_X
			-- 	CENTER_Y
			-- 	EXTERNAL_NAME
			-- 	ID
			-- 	MASK_SITE_NO
			-- 	RUN_ID
			-- 	SITE_NO
			-- 	SIZE_X
			-- 	SIZE_Y
			-- Excluded columns
			-- 	(none)

class IBM_MAP_DATA_RAW

inherit

	DB_IDENTIFIED_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_run_id: STRING; the_site_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_run_id_exists: the_run_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			run_id := the_run_id
			site_no := the_site_no
			is_null_run_id := False
			is_null_site_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 9

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  center_x, center_y, external_name, id, mask_site_no, run_id, site_no,%N  size_x, size_y"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "ibm_map_data imd"

	join_condition: STRING = ""

	table_name: STRING = "ibm_map_data"

	key_where_clause: STRING = "run_id = :1 and site_no = :2"

feature -- Values

	center_x: DOUBLE
			-- DB: NUMBER(9,3)

	center_y: DOUBLE
			-- DB: NUMBER(9,3)

	external_name: STRING
			-- DB: VARCHAR2(24)

	id: STRING
			-- DB: VARCHAR2(12)

	mask_site_no: INTEGER
			-- DB: NUMBER(4,0)

	run_id: STRING
			-- DB: CHAR(4) not null

	site_no: INTEGER
			-- DB: NUMBER(3,0) not null

	size_x: DOUBLE
			-- DB: NUMBER(9,3)

	size_y: DOUBLE
			-- DB: NUMBER(9,3)

feature -- Nullness for null allowed columns

	is_null_center_x: BOOLEAN
	is_null_center_y: BOOLEAN
	is_null_external_name: BOOLEAN
	is_null_id: BOOLEAN
	is_null_mask_site_no: BOOLEAN
	is_null_size_x: BOOLEAN
	is_null_size_y: BOOLEAN

feature -- Nullness for non-null columns

	is_null_run_id: BOOLEAN
	is_null_site_no: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and site_no = r.site_no
			Result := Result
				and equal (run_id, r.run_id)
			Result := Result
				and is_null_run_id = r.is_null_run_id
				and is_null_site_no = r.is_null_site_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and center_x = r.center_x
				and center_y = r.center_y
				and mask_site_no = r.mask_site_no
				and size_x = r.size_x
				and size_y = r.size_y
			Result := Result
				and equal (external_name, r.external_name)
				and equal (id, r.id)
			Result := Result
				and is_null_center_x = r.is_null_center_x
				and is_null_center_y = r.is_null_center_y
				and is_null_external_name = r.is_null_external_name
				and is_null_id = r.is_null_id
				and is_null_mask_site_no = r.is_null_mask_site_no
				and is_null_size_x = r.is_null_size_x
				and is_null_size_y = r.is_null_size_y
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_double (1)
			q.select_double (2)
			q.select_string (3, 24)
			q.select_string (4, 12)
			q.select_integer (5)
			q.select_string (6, 4)
			q.select_integer (7)
			q.select_double (8)
			q.select_double (9)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			center_x := q.double_value (1)
			center_y := q.double_value (2)
			mask_site_no := q.integer_value (5)
			site_no := q.integer_value (7)
			size_x := q.double_value (8)
			size_y := q.double_value (9)
		end

	fill_in_references (q: SQL_QUERY)
		do
			external_name := q.string_value (3)
			id := q.string_value (4)
			run_id := q.string_value (6)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (3, external_name)
			q.get_string_value (4, id)
			q.get_string_value (6, run_id)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_center_x := q.is_null (1)
			is_null_center_y := q.is_null (2)
			is_null_external_name := q.is_null (3)
			is_null_id := q.is_null (4)
			is_null_mask_site_no := q.is_null (5)
			is_null_run_id := q.is_null (6)
			is_null_site_no := q.is_null (7)
			is_null_size_x := q.is_null (8)
			is_null_size_y := q.is_null (9)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_run_id := True
			is_null_site_no := True
			create run_id.make (0)
		end

	set_null_nonkey
		do
			is_null_center_x := True
			is_null_center_y := True
			is_null_external_name := True
			is_null_id := True
			is_null_mask_site_no := True
			is_null_size_x := True
			is_null_size_y := True
			create external_name.make (0)
			create id.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, run_id, False)
			q.bind_num_to_integer (2, site_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and center_x = q.double_value (1)
				and center_y = q.double_value (2)
				and mask_site_no = q.integer_value (5)
				and site_no = q.integer_value (7)
				and size_x = q.double_value (8)
				and size_y = q.double_value (9)
			q.get_string_value (3, s)
			Result := Result and equal (external_name, s)
			q.get_string_value (4, s)
			Result := Result and equal (id, s)
			q.get_string_value (6, s)
			Result := Result and equal (run_id, s)
			Result := Result
				and is_null_center_x = q.is_null (1)
				and is_null_center_y = q.is_null (2)
				and is_null_external_name = q.is_null (3)
				and is_null_id = q.is_null (4)
				and is_null_mask_site_no = q.is_null (5)
				and is_null_run_id = q.is_null (6)
				and is_null_site_no = q.is_null (7)
				and is_null_size_x = q.is_null (8)
				and is_null_size_y = q.is_null (9)
		end

end
