
class IBM_MAP_DATA_ROW
inherit
	IBM_MAP_DATA_RAW
	ROW_COUNT_CHECK_ACCESS

create
	make_template, make_null, make_by_key

feature -- Collections

	map_data_for_run (run: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): DYNAMIC_LIST [like Current] is
			-- All map data rows for run `run', ordered
			-- by site number
		require
			run_exists: run /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_S
		do
			create b.make (run)
			Result := all_rows_filtered_ordered (conn, "run_id = :1", b, "site_no")
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

	map_data_for_run_die_locations (run: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): DYNAMIC_LIST [like Current] is
			-- All map data rows for run `run' that are
			-- foreign keys into DIE_LOCATIONS
		require
			run_exists: run /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_S
		do
			create b.make (run)
			Result := all_rows_filtered (conn, "[
				run_id = :1 and (run_id, mask_site_no) in 
				(select run_id, mask_site_no from die_locations
				 where run_id = :1)
				]",
				b)
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

end
