class IC_FAB_INSTANCEXWAFER_VENDORS_ROW

inherit
	IC_FAB_INSTANCEXWAFER_VENDORS_RAW
	ROW_COUNT_CHECK_ACCESS
		export
			{NONE} all
		end

create
	make_template, make_null

feature -- Collections

	rows_for_fab_no (mfn: INTEGER conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current] is
			-- Wafer vendor constraints for fab no `mfn',
			-- order by constraint code
		require
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_I
		do
			create b.make (mfn)
			Result := all_rows_filtered_ordered (conn, "m_fab_no = :1", b, "wafer_vendor_constraint_code")
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

end -- IC_FAB_INSTANCEXWAFER_VENDORS_ROW
