
indexing
	
	description: "IC_packagings row and one of its associated cust_wos rows"
	author: "David Hollenberg"
	date: "March 13, 2006"

class IC_PACKAGING_AND_WO

create
	make

feature {NONE} -- Creation

	make (icp: IC_PACKAGINGS_ROW cwo: CUST_WOS_ROW)
		require
			ic_not_void: icp /= Void
			cwo_not_void: cwo /= Void
		do
			ic_packagings_row := icp
			cust_wos_row := cwo
			set_unique_id
		end

feature -- Properties

	ic_packagings_row: IC_PACKAGINGS_ROW
			-- Row from ic_packagings table

	cust_wos_row: CUST_WOS_ROW
			-- One associated row from cust_wos table
			-- (association is via m_fab_no)

	ic_packaging_no: INTEGER
			-- IC packaging number of IC packagings row
		do
			Result := ic_packagings_row.ic_packaging_no
		end

	m_fab_no: INTEGER
			-- Fab number
		do
			Result := ic_packagings_row.m_fab_no
		end

	package_id: STRING
			-- Package ID
		do
			Result := ic_packagings_row.package_id
		end

	is_null_package_id: BOOLEAN
			-- Is `package_id' null?
		do
			Result := ic_packagings_row.is_null_package_id
		end

	bonding_id: STRING
			-- Bonding ID
		do
			Result := ic_packagings_row.bonding_id
		end

	production_id: STRING
			-- Production ID of associated cust work order
		do
			Result := cust_wos_row.production_id
		end

	fab_no_prod_id: STRING
			-- MOSIS fab number and production ID of `Current',
			-- separated by a null character
		do
			Result := m_fab_no.out + "%U" + production_id
		end

	unique_id: STRING
			-- Unique identifier for row

feature {NONE} -- Implementation

	set_unique_id
		do
			unique_id := ic_packaging_no.out + "%U" + production_id
		end

end
