
indexing

	author: "Generated"
	date: "Fri Feb 27 10:32:55 PST 2004"

class IC_PACKAGINGS_MROW
inherit
	IC_PACKAGINGS_MRAW
		redefine delete
		end;

	IC_PACKAGINGS_ROW
		undefine
			initialize_new,
			initialize_new_by_key
		redefine
			anchored_cid_file
		end
	ROW_COUNT_CHECK_ACCESS
	ROW_BUSY_CHECK_ACCESS

create
	make_template, make_null, make_by_key

feature {NONE} -- associated cust_ic_design_files stuff

	anchored_cid_file: CUST_IC_DESIGN_FILES_MROW is
	do
	end;

feature	-- modifications

	set_package_requested_none is
	do  set_package_requested(package_is_none)
	end;

	set_package_requested_default is
	do  set_package_requested(package_is_default)
	end;

	delete_the_wiring is
		-- discard the wiring (and its approval)
	local wires: like my_mwiring
	do  wires := my_mwiring;
	    if not wires.is_empty
	     then wires.do_all(agent {IC_PACKAGING_WIRES_MROW}.delete)
		  wires.wipe_out;
		  set_null_date_diagram_approved;
		  set_null_diagram_approved_by;
		  set_null_is_custom_wiring
	    end;
	end;

	disconnect_the_cid_files is
		-- disconnect any cust_ic_design_files from me
		-- (and make them undeliverable)
	local cfils: like cid_files; it: like anchored_cid_file
	do  cfils := cid_files;		-- (should be none or 1)
	    from  cfils.start
	    until cfils.after
	    loop  it := cfils.item;
		  it.set_null_ic_packaging_no;
		  it.set_deliverable(false);
		  cfils.forth
	    end;
	    cfils.wipe_out
	end;

	delete is
		-- redefinition from DB_DELETABLE_ROW
	local rereg: BOOLEAN
	do  rereg := is_registered and 
		     (have_a_wiring or not cid_files.is_empty)
	    disconnect_the_cid_files;	-- do BEFORE delete_the_wiring
	    delete_the_wiring;		-- do BEFORE row delete
	    precursor;
	    if rereg then reregister_last end;
	end;

feature -- Properties

	locked_test_vehicle_packagings_for_run (run: STRING conn: DB_CONNECTION opt: DB_LOCK_BUSY_OPTION range: ITEM_COUNT_RANGE): LIST [like Current] is
			-- All IC packagings for test vehicles on run `run', 
			-- with rows already locked
		require
			run_exists: run /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			busy_action_exists: opt /= Void
			range_exists: range /= Void
		local
			b: DB_BIND_SS
			ic_fab_instance_type: IC_FAB_INSTANCE_TYPE_VALUES
		do
			create b.make (run, ic_fab_instance_type.Test_vehicle)
			Result := all_rows_filtered_locked (conn, "m_fab_no in (select m_fab_no from ic_fab_instances where run_id = :1 and ic_fab_instance_type = :2)", b, opt)
			check_list_busy
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

end
