
indexing

	date: "Wed Apr  9 10:34:59 2008"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application NFE, database user ALLMOSIS"
	database_tables: 
		"INCOMING_COMMUNICATIONS (MOSIS.INCOMING_COMMUNICATIONS)"
			-- Included columns
			-- 	COMMUNICATION_MEDIUM
			-- 	HEADER_DATE
			-- 	HEADER_FROM
			-- 	HEADER_MESSAGE_ID
			-- 	HEADER_REPLY_TO
			-- 	HEADER_SENDER
			-- 	HEADER_SUBJECT
			-- 	HEADER_TO
			-- 	M_COMMUNICATION_NO
			-- 	SECURITY_TYPE
			-- 	STORAGE_FILENAME
			-- 	STORAGE_SEGMENT_LENGTH
			-- 	STORAGE_SEGMENT_OFFSET
			-- Excluded columns
			-- 	(none)

class INCOMING_COMMUNICATIONS_RAW

inherit

	DB_DELETABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_m_communication_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			m_communication_no := the_m_communication_no
			is_null_m_communication_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 13

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  communication_medium, header_date, header_from, header_message_id,%N  header_reply_to, header_sender, header_subject, header_to,%N  m_communication_no, security_type, storage_filename,%N  storage_segment_length, storage_segment_offset"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "incoming_communications ic"

	join_condition: STRING = ""

	table_name: STRING = "incoming_communications"

	key_where_clause: STRING = "m_communication_no = :1"

feature -- Values

	communication_medium: STRING
			-- DB: VARCHAR2(10) not null

	header_date: STRING
			-- DB: VARCHAR2(255)

	header_from: STRING
			-- DB: VARCHAR2(255)

	header_message_id: STRING
			-- DB: VARCHAR2(255)

	header_reply_to: STRING
			-- DB: VARCHAR2(255)

	header_sender: STRING
			-- DB: VARCHAR2(255)

	header_subject: STRING
			-- DB: VARCHAR2(255)

	header_to: STRING
			-- DB: VARCHAR2(255)

	m_communication_no: INTEGER
			-- DB: NUMBER(9,0) not null

	security_type: STRING
			-- DB: VARCHAR2(10)

	storage_filename: STRING
			-- DB: VARCHAR2(255)

	storage_segment_length: INTEGER
			-- DB: NUMBER(9,0)

	storage_segment_offset: INTEGER
			-- DB: NUMBER(9,0)

feature -- Maximum database lengths for character columns

	maxlen_communication_medium: INTEGER = 10
	maxlen_header_date: INTEGER = 255
	maxlen_header_from: INTEGER = 255
	maxlen_header_message_id: INTEGER = 255
	maxlen_header_reply_to: INTEGER = 255
	maxlen_header_sender: INTEGER = 255
	maxlen_header_subject: INTEGER = 255
	maxlen_header_to: INTEGER = 255
	maxlen_security_type: INTEGER = 10
	maxlen_storage_filename: INTEGER = 255

feature -- Precisions for number columns

	precision_m_communication_no: INTEGER = 9
	precision_storage_segment_length: INTEGER = 9
	precision_storage_segment_offset: INTEGER = 9

feature -- Scales for number columns

	scale_m_communication_no: INTEGER = 0
	scale_storage_segment_length: INTEGER = 0
	scale_storage_segment_offset: INTEGER = 0

feature -- Nullness for null allowed columns

	is_null_header_date: BOOLEAN
	is_null_header_from: BOOLEAN
	is_null_header_message_id: BOOLEAN
	is_null_header_reply_to: BOOLEAN
	is_null_header_sender: BOOLEAN
	is_null_header_subject: BOOLEAN
	is_null_header_to: BOOLEAN
	is_null_security_type: BOOLEAN
	is_null_storage_filename: BOOLEAN
	is_null_storage_segment_length: BOOLEAN
	is_null_storage_segment_offset: BOOLEAN

feature -- Nullness for non-null columns

	is_null_communication_medium: BOOLEAN
	is_null_m_communication_no: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and m_communication_no = r.m_communication_no
			Result := Result
				and is_null_m_communication_no = r.is_null_m_communication_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and storage_segment_length = r.storage_segment_length
				and storage_segment_offset = r.storage_segment_offset
			Result := Result
				and equal (communication_medium, r.communication_medium)
				and equal (header_date, r.header_date)
				and equal (header_from, r.header_from)
				and equal (header_message_id, r.header_message_id)
				and equal (header_reply_to, r.header_reply_to)
				and equal (header_sender, r.header_sender)
				and equal (header_subject, r.header_subject)
				and equal (header_to, r.header_to)
				and equal (security_type, r.security_type)
				and equal (storage_filename, r.storage_filename)
			Result := Result
				and is_null_communication_medium = r.is_null_communication_medium
				and is_null_header_date = r.is_null_header_date
				and is_null_header_from = r.is_null_header_from
				and is_null_header_message_id = r.is_null_header_message_id
				and is_null_header_reply_to = r.is_null_header_reply_to
				and is_null_header_sender = r.is_null_header_sender
				and is_null_header_subject = r.is_null_header_subject
				and is_null_header_to = r.is_null_header_to
				and is_null_security_type = r.is_null_security_type
				and is_null_storage_filename = r.is_null_storage_filename
				and is_null_storage_segment_length = r.is_null_storage_segment_length
				and is_null_storage_segment_offset = r.is_null_storage_segment_offset
		end

feature -- Modification

	set_communication_medium (s: STRING)
		do
			change_field (True, True)
			communication_medium := s
			if s = Void then
				create communication_medium.make (0)
			end
			is_null_communication_medium := s = Void or else s.count = 0
		end

	set_header_date (s: STRING)
		do
			change_field (True, True)
			header_date := s
			if s = Void then
				create header_date.make (0)
			end
			is_null_header_date := s = Void or else s.count = 0
		end

	set_header_from (s: STRING)
		do
			change_field (True, True)
			header_from := s
			if s = Void then
				create header_from.make (0)
			end
			is_null_header_from := s = Void or else s.count = 0
		end

	set_header_message_id (s: STRING)
		do
			change_field (True, True)
			header_message_id := s
			if s = Void then
				create header_message_id.make (0)
			end
			is_null_header_message_id := s = Void or else s.count = 0
		end

	set_header_reply_to (s: STRING)
		do
			change_field (True, True)
			header_reply_to := s
			if s = Void then
				create header_reply_to.make (0)
			end
			is_null_header_reply_to := s = Void or else s.count = 0
		end

	set_header_sender (s: STRING)
		do
			change_field (True, True)
			header_sender := s
			if s = Void then
				create header_sender.make (0)
			end
			is_null_header_sender := s = Void or else s.count = 0
		end

	set_header_subject (s: STRING)
		do
			change_field (True, True)
			header_subject := s
			if s = Void then
				create header_subject.make (0)
			end
			is_null_header_subject := s = Void or else s.count = 0
		end

	set_header_to (s: STRING)
		do
			change_field (True, True)
			header_to := s
			if s = Void then
				create header_to.make (0)
			end
			is_null_header_to := s = Void or else s.count = 0
		end

	set_m_communication_no (k: INTEGER)
		do
			change_key_field
			m_communication_no := k
			is_null_m_communication_no := False
		end

	set_security_type (s: STRING)
		do
			change_field (True, True)
			security_type := s
			if s = Void then
				create security_type.make (0)
			end
			is_null_security_type := s = Void or else s.count = 0
		end

	set_storage_filename (s: STRING)
		do
			change_field (True, True)
			storage_filename := s
			if s = Void then
				create storage_filename.make (0)
			end
			is_null_storage_filename := s = Void or else s.count = 0
		end

	set_storage_segment_length (k: INTEGER)
		do
			change_field (True, True)
			storage_segment_length := k
			is_null_storage_segment_length := False
		end

	set_storage_segment_offset (k: INTEGER)
		do
			change_field (True, True)
			storage_segment_offset := k
			is_null_storage_segment_offset := False
		end

feature -- Modification to null

	set_null_header_date
		do
			set_header_date (Void)
		end

	set_null_header_from
		do
			set_header_from (Void)
		end

	set_null_header_message_id
		do
			set_header_message_id (Void)
		end

	set_null_header_reply_to
		do
			set_header_reply_to (Void)
		end

	set_null_header_sender
		do
			set_header_sender (Void)
		end

	set_null_header_subject
		do
			set_header_subject (Void)
		end

	set_null_header_to
		do
			set_header_to (Void)
		end

	set_null_security_type
		do
			set_security_type (Void)
		end

	set_null_storage_filename
		do
			set_storage_filename (Void)
		end

	set_null_storage_segment_length
		do
			change_field (True, True)
			storage_segment_length := 0
			is_null_storage_segment_length := True
		end

	set_null_storage_segment_offset
		do
			change_field (True, True)
			storage_segment_offset := 0
			is_null_storage_segment_offset := True
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 10)
			q.select_string (2, 255)
			q.select_string (3, 255)
			q.select_string (4, 255)
			q.select_string (5, 255)
			q.select_string (6, 255)
			q.select_string (7, 255)
			q.select_string (8, 255)
			q.select_integer (9)
			q.select_string (10, 10)
			q.select_string (11, 255)
			q.select_integer (12)
			q.select_integer (13)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			m_communication_no := q.integer_value (9)
			storage_segment_length := q.integer_value (12)
			storage_segment_offset := q.integer_value (13)
		end

	fill_in_references (q: SQL_QUERY)
		do
			communication_medium := q.string_value (1)
			header_date := q.string_value (2)
			header_from := q.string_value (3)
			header_message_id := q.string_value (4)
			header_reply_to := q.string_value (5)
			header_sender := q.string_value (6)
			header_subject := q.string_value (7)
			header_to := q.string_value (8)
			security_type := q.string_value (10)
			storage_filename := q.string_value (11)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, communication_medium)
			q.get_string_value (2, header_date)
			q.get_string_value (3, header_from)
			q.get_string_value (4, header_message_id)
			q.get_string_value (5, header_reply_to)
			q.get_string_value (6, header_sender)
			q.get_string_value (7, header_subject)
			q.get_string_value (8, header_to)
			q.get_string_value (10, security_type)
			q.get_string_value (11, storage_filename)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_communication_medium := q.is_null (1)
			is_null_header_date := q.is_null (2)
			is_null_header_from := q.is_null (3)
			is_null_header_message_id := q.is_null (4)
			is_null_header_reply_to := q.is_null (5)
			is_null_header_sender := q.is_null (6)
			is_null_header_subject := q.is_null (7)
			is_null_header_to := q.is_null (8)
			is_null_m_communication_no := q.is_null (9)
			is_null_security_type := q.is_null (10)
			is_null_storage_filename := q.is_null (11)
			is_null_storage_segment_length := q.is_null (12)
			is_null_storage_segment_offset := q.is_null (13)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_m_communication_no := True
		end

	set_null_nonkey
		do
			is_null_communication_medium := True
			is_null_header_date := True
			is_null_header_from := True
			is_null_header_message_id := True
			is_null_header_reply_to := True
			is_null_header_sender := True
			is_null_header_subject := True
			is_null_header_to := True
			is_null_security_type := True
			is_null_storage_filename := True
			is_null_storage_segment_length := True
			is_null_storage_segment_offset := True
			create communication_medium.make (0)
			create header_date.make (0)
			create header_from.make (0)
			create header_message_id.make (0)
			create header_reply_to.make (0)
			create header_sender.make (0)
			create header_subject.make (0)
			create header_to.make (0)
			create security_type.make (0)
			create storage_filename.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_integer (1, m_communication_no, False)
		end

	bind (s: SQL_STATEMENT)
		do
			s.bind_num_to_string (1, communication_medium, is_null_communication_medium)
			s.bind_num_to_string (2, header_date, is_null_header_date)
			s.bind_num_to_string (3, header_from, is_null_header_from)
			s.bind_num_to_string (4, header_message_id, is_null_header_message_id)
			s.bind_num_to_string (5, header_reply_to, is_null_header_reply_to)
			s.bind_num_to_string (6, header_sender, is_null_header_sender)
			s.bind_num_to_string (7, header_subject, is_null_header_subject)
			s.bind_num_to_string (8, header_to, is_null_header_to)
			s.bind_num_to_integer (9, m_communication_no, is_null_m_communication_no)
			s.bind_num_to_string (10, security_type, is_null_security_type)
			s.bind_num_to_string (11, storage_filename, is_null_storage_filename)
			s.bind_num_to_integer (12, storage_segment_length, is_null_storage_segment_length)
			s.bind_num_to_integer (13, storage_segment_offset, is_null_storage_segment_offset)
		end

	bind_list_for_insert: STRING = "  :1, :2, :3, :4, :5, :6, :7, :8, :9, :10, :11, :12, :13"

	bind_list_for_update: STRING = "  communication_medium = :1, header_date = :2, header_from = :3,%N  header_message_id = :4, header_reply_to = :5, header_sender = :6,%N  header_subject = :7, header_to = :8, m_communication_no = :9,%N  security_type = :10, storage_filename = :11,%N  storage_segment_length = :12, storage_segment_offset = :13"

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and m_communication_no = q.integer_value (9)
				and storage_segment_length = q.integer_value (12)
				and storage_segment_offset = q.integer_value (13)
			q.get_string_value (1, s)
			Result := Result and equal (communication_medium, s)
			q.get_string_value (2, s)
			Result := Result and equal (header_date, s)
			q.get_string_value (3, s)
			Result := Result and equal (header_from, s)
			q.get_string_value (4, s)
			Result := Result and equal (header_message_id, s)
			q.get_string_value (5, s)
			Result := Result and equal (header_reply_to, s)
			q.get_string_value (6, s)
			Result := Result and equal (header_sender, s)
			q.get_string_value (7, s)
			Result := Result and equal (header_subject, s)
			q.get_string_value (8, s)
			Result := Result and equal (header_to, s)
			q.get_string_value (10, s)
			Result := Result and equal (security_type, s)
			q.get_string_value (11, s)
			Result := Result and equal (storage_filename, s)
			Result := Result
				and is_null_communication_medium = q.is_null (1)
				and is_null_header_date = q.is_null (2)
				and is_null_header_from = q.is_null (3)
				and is_null_header_message_id = q.is_null (4)
				and is_null_header_reply_to = q.is_null (5)
				and is_null_header_sender = q.is_null (6)
				and is_null_header_subject = q.is_null (7)
				and is_null_header_to = q.is_null (8)
				and is_null_m_communication_no = q.is_null (9)
				and is_null_security_type = q.is_null (10)
				and is_null_storage_filename = q.is_null (11)
				and is_null_storage_segment_length = q.is_null (12)
				and is_null_storage_segment_offset = q.is_null (13)
		end

end
