
indexing
	
	description: "A run closing step operation that allows the %
		%run closer to invoke the front end to process internal %
		%front end requests for a set of projects identified by %
		%order number"
	author: "David Hollenberg"
	date: "June 7, 2005"

deferred class INTERNAL_FE_REQUEST_OP
inherit
	RC_PRIMITIVE_STEP_OP
	HAS_USER_INTERFACE
	NO_EXTERNAL_STATE
		-- Actually creates external state but files are
		-- not deleted when step is undone, since they
		-- represent messages that have already been sent

feature {NONE} -- Implementation

	do_step
		local
			ifc: INTERNAL_FE_REQUEST_IFC
		do
			ifc := internal_request_interface
			ifc.set_session (session)
			ifc.success_actions.extend (agent call_completion_actions)
			ifc.abort_actions.append (abort_actions)
			ifc.build
		end

	undo_step
			-- Undo execution of step
		do
			call_completion_actions
		end

	set_state
			-- Set `state'
		do
			state := Void
		end

	internal_request_interface: INTERNAL_FE_REQUEST_IFC
		deferred
		ensure
			result_not_void: Result /= Void
		end

end
