
indexing

	date: "Tue Apr 24 10:30:13 2007"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application NFE, database user DHOLLEN"
	database_tables: 
		"INTERNAL_FE_REQUESTS (MOSIS.INTERNAL_FE_REQUESTS)"
			-- Included columns
			-- 	DATE_REQUESTED
			-- 	FILE_ROLE
			-- 	INTERNAL_REQUEST_NO
			-- 	INTERNAL_REQUEST_TYPE
			-- 	IS_PRODUCTION_SPECIFIC
			-- 	M_ORDER_NO
			-- 	SOURCE_FILENAME
			-- 	TEXT_VALUE
			-- Excluded columns
			-- 	(none)

class INTERNAL_FE_REQUESTS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_internal_request_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			internal_request_no := the_internal_request_no
			is_null_internal_request_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 8

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  date_requested, file_role, internal_request_no, internal_request_type,%N  is_production_specific, m_order_no, source_filename, text_value"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "internal_fe_requests ifr"

	join_condition: STRING = ""

	table_name: STRING = "internal_fe_requests"

	key_where_clause: STRING = "internal_request_no = :1"

feature -- Values

	date_requested: DB_DATE
			-- DB: DATE not null

	file_role: STRING
			-- DB: VARCHAR2(20)

	internal_request_no: INTEGER
			-- DB: NUMBER(6,0) not null

	internal_request_type: STRING
			-- DB: VARCHAR2(24) not null

	is_production_specific: BOOLEAN
			-- DB: CHAR(1) not null

	m_order_no: INTEGER
			-- DB: NUMBER(6,0) not null

	source_filename: STRING
			-- DB: VARCHAR2(200)

	text_value: STRING
			-- DB: VARCHAR2(200)

feature -- Maximum database lengths for character columns

	maxlen_file_role: INTEGER = 20
	maxlen_internal_request_type: INTEGER = 24
	maxlen_source_filename: INTEGER = 200
	maxlen_text_value: INTEGER = 200

feature -- Precisions for number columns

	precision_internal_request_no: INTEGER = 6
	precision_m_order_no: INTEGER = 6

feature -- Scales for number columns

	scale_internal_request_no: INTEGER = 0
	scale_m_order_no: INTEGER = 0

feature -- Nullness for null allowed columns

	is_null_file_role: BOOLEAN
	is_null_source_filename: BOOLEAN
	is_null_text_value: BOOLEAN

feature -- Nullness for non-null columns

	is_null_date_requested: BOOLEAN
	is_null_internal_request_no: BOOLEAN
	is_null_internal_request_type: BOOLEAN
	is_null_is_production_specific: BOOLEAN
	is_null_m_order_no: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and internal_request_no = r.internal_request_no
			Result := Result
				and is_null_internal_request_no = r.is_null_internal_request_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and is_production_specific = r.is_production_specific
				and m_order_no = r.m_order_no
			Result := Result
				and equal (date_requested, r.date_requested)
				and equal (file_role, r.file_role)
				and equal (internal_request_type, r.internal_request_type)
				and equal (source_filename, r.source_filename)
				and equal (text_value, r.text_value)
			Result := Result
				and is_null_date_requested = r.is_null_date_requested
				and is_null_file_role = r.is_null_file_role
				and is_null_internal_request_type = r.is_null_internal_request_type
				and is_null_is_production_specific = r.is_null_is_production_specific
				and is_null_m_order_no = r.is_null_m_order_no
				and is_null_source_filename = r.is_null_source_filename
				and is_null_text_value = r.is_null_text_value
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_date (1)
			q.select_string (2, 20)
			q.select_integer (3)
			q.select_string (4, 24)
			q.select_boolean (5)
			q.select_integer (6)
			q.select_string (7, 200)
			q.select_string (8, 200)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			internal_request_no := q.integer_value (3)
			is_production_specific := q.boolean_value (5)
			m_order_no := q.integer_value (6)
		end

	fill_in_references (q: SQL_QUERY)
		do
			date_requested := q.date_value (1)
			file_role := q.string_value (2)
			internal_request_type := q.string_value (4)
			source_filename := q.string_value (7)
			text_value := q.string_value (8)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_date_value (1, date_requested)
			q.get_string_value (2, file_role)
			q.get_string_value (4, internal_request_type)
			q.get_string_value (7, source_filename)
			q.get_string_value (8, text_value)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_date_requested := q.is_null (1)
			is_null_file_role := q.is_null (2)
			is_null_internal_request_no := q.is_null (3)
			is_null_internal_request_type := q.is_null (4)
			is_null_is_production_specific := q.is_null (5)
			is_null_m_order_no := q.is_null (6)
			is_null_source_filename := q.is_null (7)
			is_null_text_value := q.is_null (8)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_internal_request_no := True
		end

	set_null_nonkey
		do
			is_null_date_requested := True
			is_null_file_role := True
			is_null_internal_request_type := True
			is_null_is_production_specific := True
			is_null_m_order_no := True
			is_null_source_filename := True
			is_null_text_value := True
			create {ORACLE_DATE} date_requested.set_null
			create file_role.make (0)
			create internal_request_type.make (0)
			create source_filename.make (0)
			create text_value.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_integer (1, internal_request_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
			d: DB_DATE
		do
			s := temp_string
			d := temp_date
			Result := True
			Result := Result
				and internal_request_no = q.integer_value (3)
				and is_production_specific = q.boolean_value (5)
				and m_order_no = q.integer_value (6)
			q.get_date_value (1, d)
			Result := Result and equal (date_requested, d)
			q.get_string_value (2, s)
			Result := Result and equal (file_role, s)
			q.get_string_value (4, s)
			Result := Result and equal (internal_request_type, s)
			q.get_string_value (7, s)
			Result := Result and equal (source_filename, s)
			q.get_string_value (8, s)
			Result := Result and equal (text_value, s)
			Result := Result
				and is_null_date_requested = q.is_null (1)
				and is_null_file_role = q.is_null (2)
				and is_null_internal_request_no = q.is_null (3)
				and is_null_internal_request_type = q.is_null (4)
				and is_null_is_production_specific = q.is_null (5)
				and is_null_m_order_no = q.is_null (6)
				and is_null_source_filename = q.is_null (7)
				and is_null_text_value = q.is_null (8)
		end

end
