class INTERNAL_FE_REQUESTS_ROW

inherit
	INTERNAL_FE_REQUESTS_RAW
	ROW_COUNT_CHECK_ACCESS
		export
			{NONE} all
		end
	DB_QUERY_OPTIONS
		export	{NONE} all
		end

create

	make_template, make_null, make_by_key

feature -- my internal_request_types row and its attributes

	internal_request_action: STRING is
	do  Result := internal_request.internal_request_action
	end;

	reply_mode: STRING is
	do  Result := internal_request.reply_mode
	end;

	message_application: STRING is
	do  Result := internal_request.message_application
	end;

	subject_message_id: STRING is
	do  Result := internal_request.subject_message_id
	end;

	body_message_id: STRING is
	do  Result := internal_request.body_message_id
	end;

	include_status: BOOLEAN is
	do  Result := internal_request.include_status
	end;

	internal_request: INTERNAL_REQUEST_TYPES_ROW is
	do  if cached_internal_request = Void
	     then create cached_internal_request.make_by_key
				(connection, old_row, internal_request_type)
	    end;
	    Result := cached_internal_request
	end;

feature	-- my file_roles row and its attributes

	role_order: INTEGER is
	require have_a_role: not is_null_file_role
	do  Result := file_role_row.role_order
	end;

	role_text: STRING is
	require have_a_role: not is_null_file_role
	do  Result := file_role_row.role_text
	end;

	is_layout: BOOLEAN is
	require have_a_role: not is_null_file_role
	do  Result := file_role_row.is_layout
	end;

	file_role_row: FILE_ROLES_ROW is
	do  if is_null_file_role then
		cached_file_role := Void
	    elseif cached_file_role = Void then
		create cached_file_role.make_by_key
				(connection, old_row, file_role)
	    end;
	    Result := cached_file_role
	end;

feature {NONE} -- cached data

	cached_internal_request: INTERNAL_REQUEST_TYPES_ROW

	cached_file_role: FILE_ROLES_ROW

feature -- Collections

	rows_for_production_and_type (prod_id, req_type: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current] is
			-- Internal requests for production ID `prod_id'
			-- with internal request type `req_type'
		require
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_SS
		do
			create b.make (prod_id, req_type)
			Result := all_rows_filtered (conn, "internal_request_type = :2 and m_order_no in (select m_order_no from cust_wos where production_id = :1)", b)
			check_row_count (Result, range)
		end

end
