
indexing

	date: "Tue Apr 24 10:30:13 2007"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application NFE, database user DHOLLEN"
	database_tables: 
		"INTERNAL_REQUEST_TYPES (MOSIS.INTERNAL_REQUEST_TYPES)"
			-- Included columns
			-- 	BODY_MESSAGE_ID
			-- 	DESCR
			-- 	INCLUDE_STATUS
			-- 	INTERNAL_REQUEST_ACTION
			-- 	INTERNAL_REQUEST_TYPE
			-- 	MESSAGE_APPLICATION
			-- 	REPLY_MODE
			-- 	SUBJECT_MESSAGE_ID
			-- Excluded columns
			-- 	(none)

class INTERNAL_REQUEST_TYPES_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_internal_request_type: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_internal_request_type_exists: the_internal_request_type /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			internal_request_type := the_internal_request_type
			is_null_internal_request_type := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 8

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  body_message_id, descr, include_status, internal_request_action,%N  internal_request_type, message_application, reply_mode,%N  subject_message_id"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "internal_request_types ireqt"

	join_condition: STRING = ""

	table_name: STRING = "internal_request_types"

	key_where_clause: STRING = "internal_request_type = :1"

feature -- Values

	body_message_id: STRING
			-- DB: VARCHAR2(20) not null

	descr: STRING
			-- DB: VARCHAR2(255)

	include_status: BOOLEAN
			-- DB: CHAR(1) not null

	internal_request_action: STRING
			-- DB: VARCHAR2(24)

	internal_request_type: STRING
			-- DB: VARCHAR2(24) not null

	message_application: STRING
			-- DB: VARCHAR2(50) not null

	reply_mode: STRING
			-- DB: VARCHAR2(15) not null

	subject_message_id: STRING
			-- DB: VARCHAR2(20) not null

feature -- Maximum database lengths for character columns

	maxlen_body_message_id: INTEGER = 20
	maxlen_descr: INTEGER = 255
	maxlen_internal_request_action: INTEGER = 24
	maxlen_internal_request_type: INTEGER = 24
	maxlen_message_application: INTEGER = 50
	maxlen_reply_mode: INTEGER = 15
	maxlen_subject_message_id: INTEGER = 20

feature -- Nullness for null allowed columns

	is_null_descr: BOOLEAN
	is_null_internal_request_action: BOOLEAN

feature -- Nullness for non-null columns

	is_null_body_message_id: BOOLEAN
	is_null_include_status: BOOLEAN
	is_null_internal_request_type: BOOLEAN
	is_null_message_application: BOOLEAN
	is_null_reply_mode: BOOLEAN
	is_null_subject_message_id: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (internal_request_type, r.internal_request_type)
			Result := Result
				and is_null_internal_request_type = r.is_null_internal_request_type
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and include_status = r.include_status
			Result := Result
				and equal (body_message_id, r.body_message_id)
				and equal (descr, r.descr)
				and equal (internal_request_action, r.internal_request_action)
				and equal (message_application, r.message_application)
				and equal (reply_mode, r.reply_mode)
				and equal (subject_message_id, r.subject_message_id)
			Result := Result
				and is_null_body_message_id = r.is_null_body_message_id
				and is_null_descr = r.is_null_descr
				and is_null_include_status = r.is_null_include_status
				and is_null_internal_request_action = r.is_null_internal_request_action
				and is_null_message_application = r.is_null_message_application
				and is_null_reply_mode = r.is_null_reply_mode
				and is_null_subject_message_id = r.is_null_subject_message_id
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 20)
			q.select_string (2, 255)
			q.select_boolean (3)
			q.select_string (4, 24)
			q.select_string (5, 24)
			q.select_string (6, 50)
			q.select_string (7, 15)
			q.select_string (8, 20)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			include_status := q.boolean_value (3)
		end

	fill_in_references (q: SQL_QUERY)
		do
			body_message_id := q.string_value (1)
			descr := q.string_value (2)
			internal_request_action := q.string_value (4)
			internal_request_type := q.string_value (5)
			message_application := q.string_value (6)
			reply_mode := q.string_value (7)
			subject_message_id := q.string_value (8)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, body_message_id)
			q.get_string_value (2, descr)
			q.get_string_value (4, internal_request_action)
			q.get_string_value (5, internal_request_type)
			q.get_string_value (6, message_application)
			q.get_string_value (7, reply_mode)
			q.get_string_value (8, subject_message_id)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_body_message_id := q.is_null (1)
			is_null_descr := q.is_null (2)
			is_null_include_status := q.is_null (3)
			is_null_internal_request_action := q.is_null (4)
			is_null_internal_request_type := q.is_null (5)
			is_null_message_application := q.is_null (6)
			is_null_reply_mode := q.is_null (7)
			is_null_subject_message_id := q.is_null (8)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_internal_request_type := True
			create internal_request_type.make (0)
		end

	set_null_nonkey
		do
			is_null_body_message_id := True
			is_null_descr := True
			is_null_include_status := True
			is_null_internal_request_action := True
			is_null_message_application := True
			is_null_reply_mode := True
			is_null_subject_message_id := True
			create body_message_id.make (0)
			create descr.make (0)
			create internal_request_action.make (0)
			create message_application.make (0)
			create reply_mode.make (0)
			create subject_message_id.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, internal_request_type, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and include_status = q.boolean_value (3)
			q.get_string_value (1, s)
			Result := Result and equal (body_message_id, s)
			q.get_string_value (2, s)
			Result := Result and equal (descr, s)
			q.get_string_value (4, s)
			Result := Result and equal (internal_request_action, s)
			q.get_string_value (5, s)
			Result := Result and equal (internal_request_type, s)
			q.get_string_value (6, s)
			Result := Result and equal (message_application, s)
			q.get_string_value (7, s)
			Result := Result and equal (reply_mode, s)
			q.get_string_value (8, s)
			Result := Result and equal (subject_message_id, s)
			Result := Result
				and is_null_body_message_id = q.is_null (1)
				and is_null_descr = q.is_null (2)
				and is_null_include_status = q.is_null (3)
				and is_null_internal_request_action = q.is_null (4)
				and is_null_internal_request_type = q.is_null (5)
				and is_null_message_application = q.is_null (6)
				and is_null_reply_mode = q.is_null (7)
				and is_null_subject_message_id = q.is_null (8)
		end

end
