
indexing
	
	description: "Object that generates a %"filled%" indication for %
		%elements of a reticle view according to their isolation status"
	author: "David Hollenberg"
	date: "November 29, 2006"

class ISOLATION_FILL_GENERATOR
inherit
	RETICLE_VIEW_ELEMENT_FILL_GENERATOR

create
	make

feature  -- Access

	is_interior_filled (an_element: RETICLE_VIEW_ELEMENT): BOOLEAN
			-- Should interior of `an_element' be filled when
			-- it is displayed?
		do
			Result := an_element.is_selectable and an_element.is_isolated_in_any_cut_pattern
		end
	
	interior_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Foreground color for interior of
			-- `an_element', if it is filled
		do
			if an_element.is_isolated_in_current_cut_pattern then
				Result := palette.isolated_in_curr_pattern_fill_color
			else
				Result := palette.isolated_in_other_pattern_fill_color
			end
		end
	
end
