
indexing
	
	description: "Chip in a job file"
	author: "David Hollenberg"
	date: "July 21, 2004"

class JOB_FILE_CHIP

create
	default_create

feature -- Properties

	comment: STRING
			-- Text of comment to be included in job file before
			-- CHIP command, if not Void

	number: INTEGER
			-- Identifying number assigned to chip

	levels: LIST [JOB_FILE_CHIP_LEVEL]
			-- Levels on which chip is to be written and
			-- how it is to be written, sorted by spot size
			-- and level number

	locations: LIST [CONST_POINT]
			-- Locations where chip should be written
			-- (in microns, relative to lower left corner
			-- of mask), sorted by Y and X

feature -- Modification

	set_comment (s: STRING)
			-- Set `comment' to `s'
		do
			comment := s
		ensure
			value_set: comment = s
		end

	set_number (n: INTEGER)
			-- Set `number' to `n'
		do
			number := n
		ensure
			value_set: number = n
		end

	set_levels (list: like levels)
			-- Set `levels' to `list'
		do
			levels := list
		ensure
			value_set: levels = list
		end

	set_locations (list: like locations)
			-- Set `locations' to `list'
		do
			locations := list
		ensure
			value_set: locations = list
		end

end
