deferred class LAYER
	-- generic layer for LAYOUT
	-- layers should be cached to save space

feature -- logical layer name

	layer_name: STRING is
	deferred
	end;

feature -- cif and gds name(s) for this layer

	have_cif_name: BOOLEAN is
		-- have I any cif names at all?
	deferred
	end;

	is_my_cif_name(c: STRING): BOOLEAN is
		-- is c (one of) my cif name(s)
	deferred
	end;

	a_cif_name: STRING is
		-- (some one of) my cif name(s)
	require have_cif_name
	deferred
	end;

	have_gds_name: BOOLEAN is
		-- do I have (any) gds names at all?
	deferred
	end;

	is_my_gds_name(layer, datatype: INTEGER): BOOLEAN is
		-- is (layer, datatype) one of my gds names?
	deferred
	end;

	a_gds_layer: INTEGER is
		-- with a_gds_datatype, (one of my) gds names
	require have_gds_name
	deferred
	ensure is_my_gds_name(Result, a_gds_datatype)
	end;

	a_gds_datatype: INTEGER is
		-- with a_gds_layer, (one of my) gds names
	require have_gds_name
	deferred
	ensure is_my_gds_name(a_gds_layer, Result)
	end;

end -- LAYER
