deferred class LAYER_ERROR_TESTER

inherit

	STRING_UTILITIES_ACCESS

feature	-- deferred stuff for factor access

	connection: DB_CONNECTION is
	deferred
	end;

	layer_error_id: STRING is
	deferred
	end;

feature	-- factor list

	factors: LIST[LAYER_ERROR_FACTORS_ROW] is
	local r: LAYER_ERROR_FACTORS_ROW; b: DB_BIND_S;
	do  if cached_factors = Void
	     then create r.make_template;
		  create b.make(layer_error_id);
		  cached_factors := r.all_rows_filtered
					(connection,
					 "layer_error_id = :1", b)
	    end;
	    Result := cached_factors
	end;

feature {NONE} -- factor list cache

	cached_factors: LIST[LAYER_ERROR_FACTORS_ROW]

feature -- the test

	is_kosher(lyrs: LIST[ABSTRACT_LAYER]): BOOLEAN is
		-- does this layer list pass our test?
		-- YES: he's a good boy (does NOT have this layer_error)
		-- NO: bad boy (HAS this layer error)
	require lyrs /= Void
	local  fctrs: like factors;  fctr: LAYER_ERROR_FACTORS_ROW;
	do  fctrs := factors;  
	    if lyrs.is_empty
	     then -- special treatment for empty layer list
		  -- because we don't know yet when factors are involved
		  Result := not fctrs.is_empty
	     else -- normal treatment; run full test
		  from  fctrs.start
		  until fctrs.after or Result
		  loop  fctr := fctrs.item;
			-- a true result requires that (at least) one factor
			--  NOT be true
			Result := has(lyrs, fctr.layer_name) /= fctr.present
			fctrs.forth
		  end
	    end;
	end;

	has(lyrs: LIST[ABSTRACT_LAYER]; ly: STRING): BOOLEAN is
		-- is ly found in lyrs (exact name match)
	require lyrs /= Void; su.not_empty(ly);
	do  from  lyrs.start
	    until lyrs.after or Result
	    loop  Result := equal(ly, lyrs.item.layer_name);
		  lyrs.forth
	    end
	end;
	
end -- LAYER_ERROR_TESTER
