deferred class LAYOUT

inherit
	ANY
		undefine
			out
		end

	GEOMETRY_SUPPORT
	export {NONE} all
	undefine out
	end;

	STRING_UTILITIES_ACCESS
	export {NONE} all
	undefine out
	end;

feature

	is_unlayered: BOOLEAN is
		-- is this unlayered ("monochromatic") layout?
	deferred
	end;

	traverse(c: LAYOUT_CONSUMER; m: MATRIX) is
		-- "walk" this layout, passing interesting parts to 
		--  the designated consumer
	deferred
	end;

	have_bounding_box: BOOLEAN is
		-- do I currently have a computed bounding box
	deferred
	end;

	bounding_box: CONST_RECTANGLE is
		-- a Void box means the item is non-existent
		-- (there is no LAYOUT in this LAYOUT object)
	deferred
	end;

	to_string(ind: STRING): STRING is
		-- (potentially very long) string depicting this layout
		-- ind is the per-level line indentation to use
	require ind /= Void
	local  foo: LC_PRETTY_PRINT
	do  create foo.make(ind);
	    traverse(foo, identity);
	    Result := foo.text
	end;

feature	-- new layout

	nicely_fitting_in(box: CONST_RECTANGLE): LAYOUT is
		-- scale (up or down) and move me so that I just fit into box
		-- (fill the box in the tighter dimension and center in
		--  the other dimension)
	require have_box: box /= Void;
		have_space: not box.is_empty
	local bb: CONST_RECTANGLE;
	do  bb := bounding_box;
	    if bb /= Void
	     then create {LAYOUT_RELOCATION}
			Result.make(Current, bb.moved_into(box))
	     else Result := Void	-- I have no layout
	    end
	end;
		
feature	-- self-modification

	change_layers(remapping: HASH_TABLE[STRING, STRING];
			notifier: PROCEDURE[ANY, TUPLE[LAYOUT, STRING]])
		-- remapping defines the layers to be remapped (the keys)
		--   and the new layer for each (the values)
		-- notifier is called once for each item that is remapped,
		--   with the second argument being the NEW layer name
	require	have_map: remapping /= Void
	deferred
	end;

end -- LAYOUT
