deferred class LAYOUT_CONSUMER
	-- generic consumer of a layout traversal

feature	-- consumers for the terminal nodes

	do_rectangle(r: LAYOUT_RECTANGLE; at: MATRIX) is
	deferred
	end;

	do_polygon(p: LAYOUT_POLYGON; at: MATRIX) is
	deferred
	end;

	do_path(w: LAYOUT_PATH; at: MATRIX) is
	deferred
	end;

	do_port(p: LAYOUT_PORT; at: MATRIX) is
	deferred
	end;

	do_text(t: LAYOUT_TEXT; at: MATRIX)
	deferred
	end;

feature -- consumer for the interesting non-terminals
	-- NOTE: to continue the traversal in depth, the consumer must 
	--	explicitly traverse the contained layout (body)

	do_layer(l: STRING; body: LAYOUT; at: MATRIX) is
	deferred
	end;

	do_named(n: STRING; body: LAYOUT; at: MATRIX) is
	deferred
	end;

	do_reference(r: LAYOUT_REFERENCE; at: MATRIX) is
		-- NOTE: DO NOT continue traversal with r.traverse!!
		--  (recursion loop!!)
		-- The referenced item is r.name and, if obtained,
		-- the referenced layout is r.body
		-- The complete transformation called for is
		-- (((r.name/r.body "at" r.strans_plus)
		--	"arrayed by" r.copies_in_X/Y and r.step_in_X/Y)
		--	"at" at)
	deferred
	end;

feature -- abort the traversal (for whatever reason)

	terminate_traversal: BOOLEAN is
	deferred
	end;

end -- LAYOUT_CONSUMER
