class LAYOUT_IO_OPTIONS
	-- various options pertaining to layout IO, 
	--  gathered in one common place
	-- together with set routines for them

create
	make

feature -- constants

	one_centimicron: DOUBLE is 0.00000001
		-- 10 ^ -8 meters, the standard cif unit

	one_nanometer: DOUBLE = 0.000000001
		-- 10 ^ -9 meters, the most common gds database unit

	default_aref_expansion_limit: INTEGER is 400;
		-- default value if not specified

feature	-- the options

	symbol_name_command: INTEGER;
		-- usually 0 (none) or 9
	port_name_command: INTEGER;
		-- usually 0 (none) or 94
	output_write_scale: DOUBLE
		-- default is 1
	te_gds2_arrays: BOOLEAN
		-- default is true (strict Calma interpretation)
	aref_expansion_limit: INTEGER
		-- default is default_aref_expansion_limit
	input_library_unit: DOUBLE
		-- if non-zero, the required unit_size for an input library
		-- default is 1 nm (not 1 centimicron!) for cif,
		-- default is actual database unit of file for gds
	init_unknown_layers: SIMPLE_LAYER_SET
		-- list going in; default is Void (none)
	allow_named_calls: BOOLEAN
		-- should cif reader allow named calls (cif 2.7 feature)
	expand_root_structure: BOOLEAN
		-- should cif writer expand root structure?
	filtering_techn: LAYER_SET[LAYER]
		-- if set, writers skip over unknown layers
	traversed_layers: LIST[STRING]
		-- if set, writers skip all layers not in this list
	preserve_gds_text: BOOLEAN
		-- if true, preserve TEXT in gds files
	boxes_are_layout: BOOLEAN
		-- if true, treat a gds BOX as a gds BOUNDARY
		-- (and its BOXTYPE as a DATATYPE)
		-- (technically, they aren't, but not everyone is aware)

feature	-- the set routines

	set_symbol_name_command(a_val: INTEGER)
	do  symbol_name_command := a_val
	end;

	set_port_name_command(a_val: INTEGER)
	do  port_name_command := a_val
	end;

	set_output_write_scale(a_val: DOUBLE)
	do  output_write_scale := a_val
	end;

	set_te_gds2_arrays(a_val: BOOLEAN)
	do  te_gds2_arrays := a_val
	end;

	set_aref_expansion_limit(a_val: INTEGER)
	do  aref_expansion_limit := a_val
	end;

	set_input_library_unit(a_val: DOUBLE)
	do  input_library_unit := a_val
	end;

	set_init_unknown_layers(a_val: SIMPLE_LAYER_SET)
	do  init_unknown_layers := a_val
	end;

	set_allow_named_calls(a_val: BOOLEAN)
	do  allow_named_calls := a_val
	end;

	set_expand_root_structure(a_val: BOOLEAN)
	do  expand_root_structure := a_val
	end;

	set_filtering_techn(a_val: LAYER_SET[LAYER])
	do  filtering_techn := a_val
	end;

	set_traversed_layers(a_val: LIST[STRING])
	do  traversed_layers := a_val
	end;

	set_preserve_gds_text(a_val: BOOLEAN)
	do  preserve_gds_text := a_val
	end;

	set_boxes_are_layout(a_val: BOOLEAN)
	do  boxes_are_layout := a_val
	end;

feature	{NONE} -- 

	make
	do  -- 
	    set_output_write_scale(1)
	    set_te_gds2_arrays(true)
	    set_aref_expansion_limit(default_aref_expansion_limit)
	end;

end -- LAYOUT_IO_OPTIONS
