class LAYOUT_NAMING
		-- a piece of named layout

inherit
	LAYOUT

create
	make

feature -- attributes

	body: LAYOUT

	name: STRING

feature -- the deferred LAYOUT features

	out: STRING is
	do  Result := su.string_of_2("Named: ", name);
	end;

	is_unlayered: BOOLEAN is
		-- is this unlayered ("monochromatic") layout?
	do  Result := body.is_unlayered
	end;

	traverse(c: LAYOUT_CONSUMER; m: MATRIX) is
		-- "walk" this layout, passing interesting parts to 
		--  the designated consumer
	do  c.do_named(name, body, m)
	end;

	have_bounding_box: BOOLEAN
	do  Result := body.have_bounding_box
	end;

	bounding_box: CONST_RECTANGLE
	do  Result := body.bounding_box
	end;

	change_layers(remapping: HASH_TABLE[STRING, STRING];
			notifier: PROCEDURE[ANY, TUPLE[LAYOUT, STRING]])
		-- pass-through here
	do  body.change_layers(remapping, notifier)
	end;

feature {NONE} -- creation

	make(b: LAYOUT; nam: STRING) is
	require b /= Void and su.not_empty(nam)
	do  body := b;  name := nam
	end;

end -- LAYOUT_NAMING

