class LAYOUT_POLYGON

inherit
	POLYGON
	rename bounding_box as poly_bounding_box
	redefine extend_xy
	end;

	HASHABLE_LAYOUT

	CACHED_BOUNDING_BOX
	rename calculate_bb as poly_bounding_box
	end;

create
	make,
	make_copy,
	make_transformed

feature	-- conversion to a layout_rectangle

	to_layout_rectangle: LAYOUT_RECTANGLE is
		-- identical to to_rectangle except for type
	require is_rectangular
	do  create Result.make_by_corners(i_th_x(1), i_th_y(1),
				     i_th_x(3), i_th_y(3))
	end;

feature -- the deferred LAYOUT features

	is_unlayered: BOOLEAN is true;
		-- is this unlayered ("monochromatic") layout?

	traverse(c: LAYOUT_CONSUMER; m: MATRIX) is
	do  c.do_polygon(Current, m)
	end;

	change_layers(remapping: HASH_TABLE[STRING, STRING];
			notifier: PROCEDURE[ANY, TUPLE[LAYOUT, STRING]])
		-- no operation here
	do  
	end;

feature	-- the deferred HASHABLE feature

	hash_code: INTEGER
	do  Result := area.hash_code
	end;

feature	-- the redefined extend_xy

	extend_xy(x, y: DOUBLE)
		-- also must clear the cached_bb
	do  precursor(x, y);
	    cached_bb := Void
	end;

end -- LAYOUT_POLYGON
