class LAYOUT_RECTANGLE
		-- layout element that is a rectangle

inherit
	CONST_RECTANGLE
	select is_equal
	end;

	HASHABLE_LAYOUT
	rename is_equal as general_is_equal
	end;

create -- (straight out of CONST_RECTANGLE)

	make_copy,
	make_corners, make_by_corners,
	make_size_and_center, make_by_size_and_center

feature -- the deferred LAYOUT features

	is_unlayered: BOOLEAN is true
		-- is this unlayered ("monochromatic") layout?

	traverse(c: LAYOUT_CONSUMER; m: MATRIX) is
		-- "walk" this layout, passing interesting parts to 
		--  the designated consumer
	do  c.do_rectangle(Current, m);
	end;

	have_bounding_box: BOOLEAN = true

	bounding_box: CONST_RECTANGLE
		-- I am my own bounding box
	do  Result := Current
	end;

	change_layers(remapping: HASH_TABLE[STRING, STRING];
			notifier: PROCEDURE[ANY, TUPLE[LAYOUT, STRING]])
		-- no operation here
	do  
	end;

feature	-- the deferred HASHABLE feature

	hash_code: INTEGER 
	do  Result := area.hash_code
	end;

end -- LAYOUT_RECTANGLE
