class LAYOUT_RELOCATION
	-- layout that has been moved by a matrix

inherit
	LAYOUT

	CACHED_BOUNDING_BOX

create
	make,
	make_translation,
	make_translation_xy

feature	-- constituents

	body: LAYOUT

	mat: MATRIX

feature -- the deferred LAYOUT features

	out: STRING is
	do  Result := su.string_of_2("At: ", mat.out)
	end;

	is_unlayered: BOOLEAN is
		-- is this unlayered ("monochromatic") layout?
	do  Result := body.is_unlayered
	end;

	traverse(c: LAYOUT_CONSUMER; m: MATRIX) is
		-- "walk" this layout (we have no consumer)
	do  body.traverse(c, mat.and_then(m))
		-- when he's done, we's done
	end;

	calculate_bb: CONST_RECTANGLE is
		-- calculate my bounding box
	local his_bb: CONST_RECTANGLE; p: POLYGON
	do  his_bb := body.bounding_box;
	    if his_bb = Void
	     then		-- if he don't have one, neither do I
	    elseif mat.is_Manhattan
	     then Result := his_bb.at(mat)
	     else create p.make_transformed(his_bb.to_polygon, mat);
		  Result := p.bounding_box
	    end;
	end;

	change_layers(remapping: HASH_TABLE[STRING, STRING];
			notifier: PROCEDURE[ANY, TUPLE[LAYOUT, STRING]])
		-- pass-through here
	do  body.change_layers(remapping, notifier)
	end;

feature {NONE} -- creation

	make(b: LAYOUT; at: MATRIX) is
	require have_args: b /= Void and at /= Void
	do  mat := at;
	    body := b;
	end;

	make_translation(b: LAYOUT; at: POINT) is
	require have_args: b /= Void and at /= Void
	do  create mat.make_translation(at);
	    body := b
	end;

	make_translation_xy(b: LAYOUT; x,y: DOUBLE) is
	require have_args: b /= Void
	do  create mat.make_translation_xy(x, y);
	    body := b
	end;

end -- LAYOUT_RELOCATION
