class LAYOUT_TEXT
	-- non-layout element to preserve the GDS text feature
	-- (when desired) in a LAYOUT object.

inherit
	LAYOUT

create
	make

feature	-- attributes of a TEXT element

	presentation: INTEGER
		-- a combo item containing the font #, 
		-- the vertical presentation (alignment) and
		-- the horizontal presentation

	ends: PATH_OPTIONS
		-- optional PATHTYPE

	width: DOUBLE
		-- optional WIDTH

	text: STRING
		-- the STRING text itself

feature -- creation (or re-use)

	make(a_pres: INTEGER; an_ends: PATH_OPTIONS; a_width: DOUBLE;
		a_text: STRING)
		-- just save them all
	do  presentation := a_pres;
	    ends := an_ends;
	    width := a_width;
	    text := a_text
	end;

feature	-- deferred features of LAYOUT

	is_unlayered: BOOLEAN = true;
		-- is this unlayered ("monochromatic") layout?

	traverse(c: LAYOUT_CONSUMER; m: MATRIX)
		-- "walk" this layout, passing interesting parts to 
		--  the designated consumer
	do  c.do_text(Current, m)
	end;

	have_bounding_box: BOOLEAN = false
		-- TEXT is NOT layout

	bounding_box: CONST_RECTANGLE is
		-- (there is no LAYOUT in this LAYOUT object)
	do
	end;

	change_layers(remapping: HASH_TABLE[STRING, STRING];
			notifier: PROCEDURE[ANY, TUPLE[LAYOUT, STRING]])
		-- remapping defines the layers to be remapped (the keys)
		--   and the new layer for each (the values)
		-- notifier is called once for each item that is remapped,
		--   with the second argument being the NEW layer name
	do
	end;

	out: STRING
	do  Result := "%'%'" + text + "%'%'"
	end;

end -- LAYOUT_TEXT
