class LAYOUT_TO_CIF
	-- write layout (in)to a cif file
	-- layout is assumed to be in microns!!

inherit
	LIBRARY_SUPPORT

	FILE_UTILITIES_ACCESS

	LAYOUT_IO_OPTIONS_ACCESS

feature -- result holders (not examined by us)

	the_messages: RESPONSE_COLLECTOR
		-- error and warning messages

	the_unknown_layers: SIMPLE_LAYER_SET
		-- unknown layers (in case one needs to pass them on)

feature	-- the workers

	layout_to_cif(	bdy: LAYOUT;
			dt: LAYER_SET[LAYER];
			dcf: DATA_CONSUMER) is
		-- write layout as a single symbol into the argument 
		-- dt is its technology (used to look up cif names)
		-- dcf must be initialized beforehand and completed afterward
	require have_body: bdy /= Void;
		have_dt: dt /= Void;
		have_dcf: dcf /= Void
	local llib: LAYOUT_LIBRARY; cfil: CIF_FILE_WRITER; ows: DOUBLE;
	do  -- create a trivial library
	    create llib.make(name_for_all, one_micron);
	    llib.set_technology(dt);
	    llib.add_structure(structure(name_for_all, bdy));
	    llib.set_root_structure(name_for_all);
	    -- create and set up a cif writer
	    create cfil.make(dcf);
	    ows := lioopt.output_write_scale
	    lioopt.set_output_write_scale(1000)	-- microns to nanometers
	    -- write bdy to dcf via llib and cfil
	    cfil.put_library(llib);
	    -- save responses for client
	    if the_messages = Void
	     then the_messages := cfil.the_messages
	     else the_messages.append(cfil.the_messages)
	    end;
	    the_unknown_layers := cfil.unknown_layers
	    lioopt.set_output_write_scale(ows)	-- restore
	end;

	layout_to_cif_file(bdy: LAYOUT;
			   dt: LAYER_SET[LAYER];
			   fnam: STRING) is
		-- as above, but open and close output file named fnam
	require have_fnam: fnam /= Void and then not fnam.is_empty
	local dcf: DATA_CONSUMER_FILE;
	do  create dcf.make(fu.shell_tilde_expanded(fnam));
	    dcf.initialize;
	    layout_to_cif(bdy, dt, dcf);
	    dcf.consume_eof
	end;

	name_for_all: STRING is "TOP"

end -- LAYOUT_TO_CIF
