class LC_LOCAL_LAYERS
	-- collect a list of all the layers present locally in this layout
	-- (references are NOT followed)

inherit
	LAYOUT_CONSUMER

	LC_IGNORE_TERMINALS

	LC_PURSUE_NAMING

create
	make

feature	-- the resulting list

	layers_found: LIST[STRING]

feature	-- our worker bee

	do_layer(l: STRING; body: LAYOUT; at: MATRIX)
		-- add l to the list if we have any body
	do  if body = Void or layers_found.has(l) then	
		-- nada
	    elseif body.bounding_box /= Void then
		layers_found.extend(l)
	    end
	end;

feature	-- other pieces of a layout_consumer

	do_reference(r: LAYOUT_REFERENCE; at: MATRIX)
		-- don't do references
	do
	end;

	terminate_traversal: BOOLEAN = false

feature {NONE} -- creation

	make
	do  create {ARRAYED_LIST[STRING]} layers_found.make(50);
	    layers_found.compare_objects
	end;

end -- LC_LOCAL_LAYERS
