class LC_MARK_REFERENCES
		-- mark references for one structure
		--  (the one being traversed)
		-- (at least, we do not traverse substructures)

inherit
	LC_IGNORE_TERMINALS
		-- we care not about actual layout

	LC_PURSUE_NAMING
		-- we care not about names

	LC_IGNORE_LAYERINGS
		-- since references are never inside layerings

	LIBRARY_SUPPORT

create
	make

feature	-- our hash table of referenced_structures

	stru_list: HASH_TABLE[BOOLEAN, STRING]

feature -- our worker bee

	do_reference(r: LAYOUT_REFERENCE; at: MATRIX) is
	do  stru_list.force(true, r.structure_name)
	end;

	terminate_traversal: BOOLEAN is false

feature -- creation (or re-use)

	make(rl: like stru_list) is
	require rl /= Void
	do  stru_list := rl
	end

end -- LC_MARK_REFERENCES

