deferred class LC_OUTPUT_TERMINAL
		-- for those who are writing out some LAYOUT

inherit
	LC_PURSUE_LAYERING
		-- gives us current_layer: LAYER

	LC_PURSUE_NAMING
		-- gives us current_name: STRING

	LC_TERMINAL_SELECTOR
		-- lets us suppress some terminals by type

  --	LC_PURSUE_REFERENCE
  --	we leave do_references deferred

feature	-- consumers for the terminal nodes
	-- transform them and call the real consumers

	do_rectangle(r: LAYOUT_RECTANGLE; at: MATRIX) is
	local p: POLYGON;
	do  if ignore_rectangles
	     then
	    elseif at.is_identity
	     then output_rectangle(r)
	    elseif at.is_Manhattan
	     then output_rectangle(r.at(at))
	     else create p.make_transformed(r.to_polygon, at);
		  output_polygon(p)
	    end;
	end;

	do_polygon(p: LAYOUT_POLYGON; at: MATRIX) is
	local p2: POLYGON
	do  if ignore_polygons
	     then
	    elseif at.is_identity
	     then output_polygon(p)
	     else create p2.make_transformed(p, at);
		  output_polygon(p2)
	    end;
	end;

	do_path(w: LAYOUT_PATH; at: MATRIX) is
	local w2: PATH
	do  if ignore_paths
	     then
	    elseif at.is_identity
	     then output_path(w)
	     else create w2.make_transformed(w, at);
		  output_path(w2)
	    end
	end;

	do_port(p: LAYOUT_PORT; at: MATRIX) is
	local p2: CONST_RECTANGLE; mag: DOUBLE
	do  if ignore_ports
	     then
	    elseif at.is_identity
	     then output_port(p)
	    elseif at.is_Manhattan
	     then output_port(p.at(at))
	    -- the remaining options are marginal, at best
	    elseif at.is_gds_legal
	     then -- just magnify and translate
		  mag := at.magnification;
		  create p2.make_by_size_and_center(
			p.size_x * mag, p.size_y * mag,
			p.center_x + at.tx, p.center_y + at.ty);
		  output_port(p2)
	     else -- BSOM
		  output_port(p)
	    end
	end;

	do_text(t: LAYOUT_TEXT; at: MATRIX)
	do  if not ignore_text then
		output_text(t, at)
	    end
	end;

feature -- the real worker bees

	output_rectangle(r: CONST_RECTANGLE) is
	deferred
	end;

	output_polygon(p: POLYGON) is
	deferred
	end;

	output_path(w: PATH) is
	deferred
	end;

	output_port(p: CONST_RECTANGLE) is
	deferred
	end;

	output_text(t: LAYOUT_TEXT; at: MATRIX)
		-- this one is NOT deferred; redefine to effect
	do  -- nothing
	end;

end -- LC_OUTPUT_TERMINAL
