class LC_RENAME_REFERENCES
		-- rename references for one structure
		--  (the one being traversed)
		-- (at least, we do not traverse substructures)

inherit
	LC_IGNORE_TERMINALS
		-- we care not about actual layout

	LC_PURSUE_NAMING
		-- we care not about names

	LC_IGNORE_LAYERINGS
		-- since references are never inside layerings

	LIBRARY_SUPPORT

create
	make

feature	-- our list of old (key) and new (item) names (from creation)

	translation_table: HASH_TABLE[STRING, STRING]

feature -- our worker bee

	do_reference(r: LAYOUT_REFERENCE; at: MATRIX) is
		-- NOTE: leave r.body alone, in any case
	local nam: STRING;
	do  nam := r.structure_name;
	    translation_table.search(nam)
	    if translation_table.found
	     then r.rename_structure(translation_table.found_item);
		  if notifier /= Void then
			notifier.call([r, nam])
		  end
	    end;
	end;

	terminate_traversal: BOOLEAN is false

feature	-- our notifier

	notifier: PROCEDURE[ANY, TUPLE[LAYOUT, STRING]]

	set_notifier(a_notifier: like notifier)
	do  notifier := a_notifier
	end;

feature -- creation (or re-use)

	make(xlat: like translation_table) is
	require xlat /= Void
	do  translation_table := xlat
	end

end -- LC_RENAME_REFERENCES

