
indexing
	
	description: "Pair of lists"
	author: "David Hollenberg"

class LIST_PAIR [G]

create
	make

feature {NONE} -- Creation

	make (m, n: INTEGER)
			-- Create with initial capacity `m' for
			-- `list1' and `n' for `list2'
		do
			create {ARRAYED_LIST [G]} list1.make (m)
			create {ARRAYED_LIST [G]} list2.make (n)
		end


feature -- Properties

	list1: LIST [G]
			-- First list

	list2: LIST [G]
			-- Second list

	both_lists_empty: BOOLEAN
			-- Are both `list1' and `list2' empty?
		do
			Result := list1.is_empty and list2.is_empty
		end

	both_lists_non_empty: BOOLEAN
			-- Are both `list1' and `list2' non-empty?
		do
			Result := not list1.is_empty and not list2.is_empty
		end

	exactly_one_list_empty: BOOLEAN
			-- Is one of `list1' and `list2' empty and
			-- the other non-empty?
		do
			Result := not both_lists_empty and not both_lists_non_empty
		end

end
