
indexing
	
	description: "Object that can compose text for a lock error"
	author: "David Hollenberg"
	date: "October 30, 2003"

class LOCK_ERROR_COMPOSER
inherit
	TEXT_COMPOSER [LOCK_ERROR]

feature -- Properties

	text (err: LOCK_ERROR): STRING
			-- Text composed for `err'
		local
			mode, aux_data: STRING
			lock: LOCK
		do
			lock := err.lock
			if lock.is_exclusive then
				mode := "exclusive"
			else
				mode := "shared"
			end
			Result := "Cannot get " + mode + " lock on " + lock.lock_name + "%N" + "Lock held by process id " + lock.conflicting_lock_process_id.out
			aux_data := lock.auxiliary_data
			aux_data.right_adjust
			if not aux_data.is_empty then
				Result.extend ('%N')
				Result.append ("Auxiliary data: ")
				Result.append (aux_data)
			end
		end

end
