
indexing
	
	description: "Change that locked an object in Y dimension"
	author: "David Hollenberg"
	date: "January 25, 2007"

class LOCK_IN_Y_CHANGE
inherit
	RETICLE_SIMPLE_CHANGE
		rename
			make as simple_make
		export
			{NONE} simple_make
		end

create
	make

feature {NONE} -- Creation

	make (an_element: RETICLE_VIEW_ELEMENT a_fixed_x_changed, a_fixed_y_changed, a_locked_y_changed: BOOLEAN)
		do
			simple_make (an_element)
			fixed_in_x_changed := a_fixed_x_changed
			fixed_in_y_changed := a_fixed_y_changed
			locked_in_y_changed := a_locked_y_changed
		end

feature -- Properties

	fixed_in_x_changed: BOOLEAN
			-- Did fixed in X change?

	fixed_in_y_changed: BOOLEAN
			-- Did fixed in Y change?

	locked_in_y_changed: BOOLEAN
			-- Did locked in Y change?

feature -- Operations

	undo
			-- Undo change
		do
			if locked_in_y_changed then
				element.unlock_in_y
			end
			if fixed_in_x_changed then
				element.fix_in_x
			end
			if fixed_in_y_changed then
				element.fix_in_y
			end
		end

	redo
			-- Redo change
		do
			if fixed_in_x_changed then
				element.unfix_in_x
			end
			if fixed_in_y_changed then
				element.unfix_in_y
			end
			if locked_in_y_changed then
				element.lock_in_y
			end
		end

end
