
indexing
	
	description: "A run closing step operation that locks production %
		%charges for this production"
	author: "David Hollenberg"
	date: "March 6, 2008"

class LOCK_PRODUCTION_CHARGES_OP
inherit
	RC_PRIMITIVE_STEP_OP
	RC_APPLICABLE_STEP
	NO_USER_INTERFACE
	NO_EXTERNAL_STATE

create
	make

feature -- Properties

	input_data_items: LIST [STRING]
			-- Data items required before step can be executed
		do
			Result := array_as_list (<<
					data_item.Production_job,
					data_item.Test_vehicle_orders,
					data_item.Fab_run_order
				>>)
		end

feature {NONE} -- Implementation


	do_step
			-- Execute of step
		do
			fetch_and_modify_production (True)
			call_completion_actions
		end

	undo_step
			-- Undo execution of step
		do
			fetch_and_modify_production (False)
			call_completion_actions
		end

	set_state
			-- Set `state'
		do
			state := Void
		end

	fetch_and_modify_production (b: BOOLEAN)
			-- Fetch productions row, lock it and set production
			-- charges locked to `b'
		local
			prod: PRODUCTIONS_MROW
		do
			prod := cache.productions_mrow
			session.lock_row (prod)
			prod.set_production_charges_locked (b)
		end

end
