
indexing
	
	description: "Object that can generate colors for an %
		%element of a reticle view according to locked in position %
		%X and Y status"
	author: "David Hollenberg"
	date: "October 1, 2006"

class LOCKED_STATUS_COLOR_GENERATOR
inherit
	RETICLE_VIEW_ELEMENT_COLOR_GENERATOR

create
	make

feature  -- Access

	border_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Foreground color for border (usually a
			-- rectangle) of `an_element'
		do
			Result := standard_color (an_element)
		end
	
	label_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Foreground color for label
		do
			Result := standard_color (an_element)
		end
	
feature {NONE} -- Implementation

	standard_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Standard color for `an_element', based on
			-- locked in X and locked in Y status
		local
			locked_x, locked_y: BOOLEAN
		do
			locked_x := an_element.is_locked_in_x
			locked_y := an_element.is_locked_in_y
			if not an_element.is_selectable then
				Result := palette.unselectable_color
			elseif locked_x and locked_y then
				Result := palette.locked_in_x_and_y_color
			elseif locked_x then
				Result := palette.locked_in_x_only_color
			elseif locked_y then
				Result := palette.locked_in_y_only_color
			else
				Result := palette.not_locked_in_x_or_y_color
			end
		end
	
end
