
indexing
	
	description: "Object that generates a %"filled%" indication for %
		%elements of a reticle view that are locked in X or Y or both"
	author: "David Hollenberg"
	date: "July 25, 2006"

class LOCKED_STATUS_FILL_GENERATOR
inherit
	RETICLE_VIEW_ELEMENT_FILL_GENERATOR

create
	make

feature  -- Access

	is_interior_filled (an_element: RETICLE_VIEW_ELEMENT): BOOLEAN
			-- Should interior of `an_element' be filled when
			-- it is displayed?
		do
			Result := an_element.is_selectable and (an_element.is_locked_in_x or an_element.is_locked_in_y)
		end
	
	interior_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Foreground color for interior of
			-- `an_element', if it is filled
		local
			locked_x, locked_y: BOOLEAN
		do
			locked_x := an_element.is_locked_in_x
			locked_y := an_element.is_locked_in_y
			if locked_x and locked_y then
				Result := palette.locked_in_x_and_y_fill_color
			elseif locked_x then
				Result := palette.locked_in_x_fill_color
			elseif locked_y then
				Result := palette.locked_in_y_fill_color
			else
				-- Shouldn't get here
				Result := palette.unselectable_color
			end
		end
	
end
