
indexing
	
	description: "Lot compatibility status column in a multi column list"
	author: "David Hollenberg"
	date: "December 19, 2006"

class LOT_COMPATIBILITY_COLUMN [G -> HAS_LOT_COMPATIBILITY]
inherit
	MULTI_COLUMN_LIST_COLUMN [G]

create
	make

feature {NONE} -- Creation

	make (a_title: STRING n: INTEGER)
			-- Create with `a_title' for lot number `n'
		do
			title := a_title
			lot_number := n
		end

feature -- Properties

	lot_number: INTEGER
			-- Lot number for column

	title: STRING
			-- Title for column

	alignment: EV_TEXT_ALIGNMENT
			-- Alignment for values in column
		do
			create Result.make_with_left_alignment
		end

	value (r: G): STRING
			-- Value in column for `r'
		do
			Result := r.lot_compatibility (lot_number)
		end

	comparator: LOT_COMPATIBILITY_COMPARATOR [G]
		do
			create Result.make (lot_number)
		end

end
