
indexing
	
	description: "Comparator for lot compatibility status"
	author: "David Hollenberg"
	date: "December 19, 2006"

class LOT_COMPATIBILITY_COMPARATOR [G -> HAS_LOT_COMPATIBILITY]
inherit
	KL_COMPARATOR [G]

create
	make

feature {NONE} -- Creation

	make (n: INTEGER)
			-- Create for lot number `n'
		do
			lot_number := n
		end

feature -- Properties

	lot_number: INTEGER
			-- Lot number to compare

feature -- Status report

	less_than (u, v: G): BOOLEAN
			-- Is `u' considered less than `v'?
		do
			if u.has_lot_compatibility (lot_number) and v.has_lot_compatibility (lot_number) then
				Result := u.lot_compatibility (lot_number) < v.lot_compatibility (lot_number)
			elseif v.has_lot_compatibility (lot_number) then
				Result := True
			else
				Result := False
			end
		end

end
