
indexing

	date: "Tue Apr 24 10:30:14 2007"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user DHOLLEN"
	database_tables: 
		"M_DEVICES (MOSIS.M_DEVICES)"
			-- Included columns
			-- 	AVAILABLE
			-- 	COMMENTS
			-- 	DEVICE_CLASS
			-- 	DEVICE_ID
			-- 	DEVICE_LOCATION
			-- 	DEVICE_MODEL_NAME
			-- 	HOST_NAME
			-- 	MEDIUM_TYPE
			-- 	M_DEVICE_NO
			-- 	OPERATING_ENVIRONMENT (device_operating_environment)
			-- 	QUEUE_NAME
			-- 	RESTRICTED_TO_HOST
			-- Excluded columns
			-- 	(none)

class M_DEVICES_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_m_device_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			m_device_no := the_m_device_no
			is_null_m_device_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 12

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  available, comments, device_class, device_id, device_location,%N  device_model_name, host_name, medium_type, m_device_no,%N  operating_environment, queue_name, restricted_to_host"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "m_devices md"

	join_condition: STRING = ""

	table_name: STRING = "m_devices"

	key_where_clause: STRING = "m_device_no = :1"

feature -- Values

	available: BOOLEAN
			-- DB: CHAR(1) not null

	comments: STRING
			-- DB: VARCHAR2(255)

	device_class: STRING
			-- DB: VARCHAR2(20) not null

	device_id: STRING
			-- DB: VARCHAR2(20) not null

	device_location: STRING
			-- DB: VARCHAR2(20)

	device_model_name: STRING
			-- DB: VARCHAR2(20)

	host_name: STRING
			-- DB: VARCHAR2(20)

	medium_type: STRING
			-- DB: VARCHAR2(15) not null

	m_device_no: INTEGER
			-- DB: NUMBER(7,0) not null

	device_operating_environment: STRING
			-- DB: operating_environment VARCHAR2(20) not null

	queue_name: STRING
			-- DB: VARCHAR2(40)

	restricted_to_host: BOOLEAN
			-- DB: CHAR(1) not null

feature -- Maximum database lengths for character columns

	maxlen_comments: INTEGER = 255
	maxlen_device_class: INTEGER = 20
	maxlen_device_id: INTEGER = 20
	maxlen_device_location: INTEGER = 20
	maxlen_device_model_name: INTEGER = 20
	maxlen_host_name: INTEGER = 20
	maxlen_medium_type: INTEGER = 15
	maxlen_device_operating_environment: INTEGER = 20
	maxlen_queue_name: INTEGER = 40

feature -- Precisions for number columns

	precision_m_device_no: INTEGER = 7

feature -- Scales for number columns

	scale_m_device_no: INTEGER = 0

feature -- Nullness for null allowed columns

	is_null_comments: BOOLEAN
	is_null_device_location: BOOLEAN
	is_null_device_model_name: BOOLEAN
	is_null_host_name: BOOLEAN
	is_null_queue_name: BOOLEAN

feature -- Nullness for non-null columns

	is_null_available: BOOLEAN
	is_null_device_class: BOOLEAN
	is_null_device_id: BOOLEAN
	is_null_medium_type: BOOLEAN
	is_null_m_device_no: BOOLEAN
	is_null_device_operating_environment: BOOLEAN
	is_null_restricted_to_host: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and m_device_no = r.m_device_no
			Result := Result
				and is_null_m_device_no = r.is_null_m_device_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and available = r.available
				and restricted_to_host = r.restricted_to_host
			Result := Result
				and equal (comments, r.comments)
				and equal (device_class, r.device_class)
				and equal (device_id, r.device_id)
				and equal (device_location, r.device_location)
				and equal (device_model_name, r.device_model_name)
				and equal (host_name, r.host_name)
				and equal (medium_type, r.medium_type)
				and equal (device_operating_environment, r.device_operating_environment)
				and equal (queue_name, r.queue_name)
			Result := Result
				and is_null_available = r.is_null_available
				and is_null_comments = r.is_null_comments
				and is_null_device_class = r.is_null_device_class
				and is_null_device_id = r.is_null_device_id
				and is_null_device_location = r.is_null_device_location
				and is_null_device_model_name = r.is_null_device_model_name
				and is_null_host_name = r.is_null_host_name
				and is_null_medium_type = r.is_null_medium_type
				and is_null_device_operating_environment = r.is_null_device_operating_environment
				and is_null_queue_name = r.is_null_queue_name
				and is_null_restricted_to_host = r.is_null_restricted_to_host
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_boolean (1)
			q.select_string (2, 255)
			q.select_string (3, 20)
			q.select_string (4, 20)
			q.select_string (5, 20)
			q.select_string (6, 20)
			q.select_string (7, 20)
			q.select_string (8, 15)
			q.select_integer (9)
			q.select_string (10, 20)
			q.select_string (11, 40)
			q.select_boolean (12)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			available := q.boolean_value (1)
			m_device_no := q.integer_value (9)
			restricted_to_host := q.boolean_value (12)
		end

	fill_in_references (q: SQL_QUERY)
		do
			comments := q.string_value (2)
			device_class := q.string_value (3)
			device_id := q.string_value (4)
			device_location := q.string_value (5)
			device_model_name := q.string_value (6)
			host_name := q.string_value (7)
			medium_type := q.string_value (8)
			device_operating_environment := q.string_value (10)
			queue_name := q.string_value (11)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (2, comments)
			q.get_string_value (3, device_class)
			q.get_string_value (4, device_id)
			q.get_string_value (5, device_location)
			q.get_string_value (6, device_model_name)
			q.get_string_value (7, host_name)
			q.get_string_value (8, medium_type)
			q.get_string_value (10, device_operating_environment)
			q.get_string_value (11, queue_name)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_available := q.is_null (1)
			is_null_comments := q.is_null (2)
			is_null_device_class := q.is_null (3)
			is_null_device_id := q.is_null (4)
			is_null_device_location := q.is_null (5)
			is_null_device_model_name := q.is_null (6)
			is_null_host_name := q.is_null (7)
			is_null_medium_type := q.is_null (8)
			is_null_m_device_no := q.is_null (9)
			is_null_device_operating_environment := q.is_null (10)
			is_null_queue_name := q.is_null (11)
			is_null_restricted_to_host := q.is_null (12)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_m_device_no := True
		end

	set_null_nonkey
		do
			is_null_available := True
			is_null_comments := True
			is_null_device_class := True
			is_null_device_id := True
			is_null_device_location := True
			is_null_device_model_name := True
			is_null_host_name := True
			is_null_medium_type := True
			is_null_device_operating_environment := True
			is_null_queue_name := True
			is_null_restricted_to_host := True
			create comments.make (0)
			create device_class.make (0)
			create device_id.make (0)
			create device_location.make (0)
			create device_model_name.make (0)
			create host_name.make (0)
			create medium_type.make (0)
			create device_operating_environment.make (0)
			create queue_name.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_integer (1, m_device_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and available = q.boolean_value (1)
				and m_device_no = q.integer_value (9)
				and restricted_to_host = q.boolean_value (12)
			q.get_string_value (2, s)
			Result := Result and equal (comments, s)
			q.get_string_value (3, s)
			Result := Result and equal (device_class, s)
			q.get_string_value (4, s)
			Result := Result and equal (device_id, s)
			q.get_string_value (5, s)
			Result := Result and equal (device_location, s)
			q.get_string_value (6, s)
			Result := Result and equal (device_model_name, s)
			q.get_string_value (7, s)
			Result := Result and equal (host_name, s)
			q.get_string_value (8, s)
			Result := Result and equal (medium_type, s)
			q.get_string_value (10, s)
			Result := Result and equal (device_operating_environment, s)
			q.get_string_value (11, s)
			Result := Result and equal (queue_name, s)
			Result := Result
				and is_null_available = q.is_null (1)
				and is_null_comments = q.is_null (2)
				and is_null_device_class = q.is_null (3)
				and is_null_device_id = q.is_null (4)
				and is_null_device_location = q.is_null (5)
				and is_null_device_model_name = q.is_null (6)
				and is_null_host_name = q.is_null (7)
				and is_null_medium_type = q.is_null (8)
				and is_null_m_device_no = q.is_null (9)
				and is_null_device_operating_environment = q.is_null (10)
				and is_null_queue_name = q.is_null (11)
				and is_null_restricted_to_host = q.is_null (12)
		end

end
