
indexing

	date: "Tue Jul 31 12:46:54 2007"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user ALLMOSIS"
	database_tables: 
		"M_OPERATORS (MOSIS.M_OPERATORS)"
			-- Included columns
			-- 	FULL_NAME
			-- 	INITIALS
			-- 	IS_CLERK
			-- 	IS_CLOSER
			-- 	IS_CUST_SUPPORT_MONITOR
			-- 	IS_CUST_SUPPORT_RESPONDER
			-- 	IS_DESIGN_ENGINEER
			-- 	IS_PREFERRED_CLERK
			-- 	IS_PREFERRED_TEST_ENGINEER
			-- 	IS_TEST_ENGINEER
			-- 	NET_ADDRESS
			-- 	USERNAME
			-- Excluded columns
			-- 	(none)

class M_OPERATORS_RAW

inherit

	DB_IDENTIFIED_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_username: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_username_exists: the_username /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			username := the_username
			is_null_username := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 12

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  full_name, initials, is_clerk, is_closer, is_cust_support_monitor,%N  is_cust_support_responder, is_design_engineer, is_preferred_clerk,%N  is_preferred_test_engineer, is_test_engineer, net_address, username"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "m_operators mopr"

	join_condition: STRING = ""

	table_name: STRING = "m_operators"

	key_where_clause: STRING = "username = :1"

feature -- Values

	full_name: STRING
			-- DB: VARCHAR2(250) not null

	initials: STRING
			-- DB: VARCHAR2(3) not null

	is_clerk: BOOLEAN
			-- DB: CHAR(1) not null

	is_closer: BOOLEAN
			-- DB: CHAR(1) not null

	is_cust_support_monitor: BOOLEAN
			-- DB: CHAR(1) not null

	is_cust_support_responder: BOOLEAN
			-- DB: CHAR(1) not null

	is_design_engineer: BOOLEAN
			-- DB: CHAR(1) not null

	is_preferred_clerk: BOOLEAN
			-- DB: CHAR(1) not null

	is_preferred_test_engineer: BOOLEAN
			-- DB: CHAR(1) not null

	is_test_engineer: BOOLEAN
			-- DB: CHAR(1) not null

	net_address: STRING
			-- DB: VARCHAR2(300)

	username: STRING
			-- DB: VARCHAR2(30) not null

feature -- Nullness for null allowed columns

	is_null_net_address: BOOLEAN

feature -- Nullness for non-null columns

	is_null_full_name: BOOLEAN
	is_null_initials: BOOLEAN
	is_null_is_clerk: BOOLEAN
	is_null_is_closer: BOOLEAN
	is_null_is_cust_support_monitor: BOOLEAN
	is_null_is_cust_support_responder: BOOLEAN
	is_null_is_design_engineer: BOOLEAN
	is_null_is_preferred_clerk: BOOLEAN
	is_null_is_preferred_test_engineer: BOOLEAN
	is_null_is_test_engineer: BOOLEAN
	is_null_username: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (username, r.username)
			Result := Result
				and is_null_username = r.is_null_username
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and is_clerk = r.is_clerk
				and is_closer = r.is_closer
				and is_cust_support_monitor = r.is_cust_support_monitor
				and is_cust_support_responder = r.is_cust_support_responder
				and is_design_engineer = r.is_design_engineer
				and is_preferred_clerk = r.is_preferred_clerk
				and is_preferred_test_engineer = r.is_preferred_test_engineer
				and is_test_engineer = r.is_test_engineer
			Result := Result
				and equal (full_name, r.full_name)
				and equal (initials, r.initials)
				and equal (net_address, r.net_address)
			Result := Result
				and is_null_full_name = r.is_null_full_name
				and is_null_initials = r.is_null_initials
				and is_null_is_clerk = r.is_null_is_clerk
				and is_null_is_closer = r.is_null_is_closer
				and is_null_is_cust_support_monitor = r.is_null_is_cust_support_monitor
				and is_null_is_cust_support_responder = r.is_null_is_cust_support_responder
				and is_null_is_design_engineer = r.is_null_is_design_engineer
				and is_null_is_preferred_clerk = r.is_null_is_preferred_clerk
				and is_null_is_preferred_test_engineer = r.is_null_is_preferred_test_engineer
				and is_null_is_test_engineer = r.is_null_is_test_engineer
				and is_null_net_address = r.is_null_net_address
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 250)
			q.select_string (2, 3)
			q.select_boolean (3)
			q.select_boolean (4)
			q.select_boolean (5)
			q.select_boolean (6)
			q.select_boolean (7)
			q.select_boolean (8)
			q.select_boolean (9)
			q.select_boolean (10)
			q.select_string (11, 300)
			q.select_string (12, 30)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			is_clerk := q.boolean_value (3)
			is_closer := q.boolean_value (4)
			is_cust_support_monitor := q.boolean_value (5)
			is_cust_support_responder := q.boolean_value (6)
			is_design_engineer := q.boolean_value (7)
			is_preferred_clerk := q.boolean_value (8)
			is_preferred_test_engineer := q.boolean_value (9)
			is_test_engineer := q.boolean_value (10)
		end

	fill_in_references (q: SQL_QUERY)
		do
			full_name := q.string_value (1)
			initials := q.string_value (2)
			net_address := q.string_value (11)
			username := q.string_value (12)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, full_name)
			q.get_string_value (2, initials)
			q.get_string_value (11, net_address)
			q.get_string_value (12, username)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_full_name := q.is_null (1)
			is_null_initials := q.is_null (2)
			is_null_is_clerk := q.is_null (3)
			is_null_is_closer := q.is_null (4)
			is_null_is_cust_support_monitor := q.is_null (5)
			is_null_is_cust_support_responder := q.is_null (6)
			is_null_is_design_engineer := q.is_null (7)
			is_null_is_preferred_clerk := q.is_null (8)
			is_null_is_preferred_test_engineer := q.is_null (9)
			is_null_is_test_engineer := q.is_null (10)
			is_null_net_address := q.is_null (11)
			is_null_username := q.is_null (12)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_username := True
			create username.make (0)
		end

	set_null_nonkey
		do
			is_null_full_name := True
			is_null_initials := True
			is_null_is_clerk := True
			is_null_is_closer := True
			is_null_is_cust_support_monitor := True
			is_null_is_cust_support_responder := True
			is_null_is_design_engineer := True
			is_null_is_preferred_clerk := True
			is_null_is_preferred_test_engineer := True
			is_null_is_test_engineer := True
			is_null_net_address := True
			create full_name.make (0)
			create initials.make (0)
			create net_address.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, username, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and is_clerk = q.boolean_value (3)
				and is_closer = q.boolean_value (4)
				and is_cust_support_monitor = q.boolean_value (5)
				and is_cust_support_responder = q.boolean_value (6)
				and is_design_engineer = q.boolean_value (7)
				and is_preferred_clerk = q.boolean_value (8)
				and is_preferred_test_engineer = q.boolean_value (9)
				and is_test_engineer = q.boolean_value (10)
			q.get_string_value (1, s)
			Result := Result and equal (full_name, s)
			q.get_string_value (2, s)
			Result := Result and equal (initials, s)
			q.get_string_value (11, s)
			Result := Result and equal (net_address, s)
			q.get_string_value (12, s)
			Result := Result and equal (username, s)
			Result := Result
				and is_null_full_name = q.is_null (1)
				and is_null_initials = q.is_null (2)
				and is_null_is_clerk = q.is_null (3)
				and is_null_is_closer = q.is_null (4)
				and is_null_is_cust_support_monitor = q.is_null (5)
				and is_null_is_cust_support_responder = q.is_null (6)
				and is_null_is_design_engineer = q.is_null (7)
				and is_null_is_preferred_clerk = q.is_null (8)
				and is_null_is_preferred_test_engineer = q.is_null (9)
				and is_null_is_test_engineer = q.is_null (10)
				and is_null_net_address = q.is_null (11)
				and is_null_username = q.is_null (12)
		end

end
