
indexing

	date: "Tue Apr 24 10:30:14 2007"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application NFE, database user DHOLLEN"
	database_tables: 
		"M_PRICES (MOSIS.M_PRICES)"
			-- Included columns
			-- 	AREA_AMOUNT
			-- 	DATE_EFFECTIVE
			-- 	DATE_EXPIRES
			-- 	EDU_UNITS
			-- 	FLAT_AMOUNT
			-- 	M_PART_NO
			-- 	M_PRICE_NO
			-- 	PRICING_SCHEDULE
			-- Excluded columns
			-- 	(none)

class M_PRICES_RAW

inherit

	DB_IDENTIFIED_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_m_price_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			m_price_no := the_m_price_no
			is_null_m_price_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 8

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  area_amount, date_effective, date_expires, edu_units, flat_amount,%N  m_part_no, m_price_no, pricing_schedule"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "m_prices pr"

	join_condition: STRING = ""

	table_name: STRING = "m_prices"

	key_where_clause: STRING = "m_price_no = :1"

feature -- Values

	area_amount: DOUBLE
			-- DB: NUMBER(9,2) not null

	date_effective: DB_DATE
			-- DB: DATE not null

	date_expires: DB_DATE
			-- DB: DATE

	edu_units: INTEGER
			-- DB: NUMBER(4,0) not null

	flat_amount: DOUBLE
			-- DB: NUMBER(9,2) not null

	m_part_no: INTEGER
			-- DB: NUMBER(6,0) not null

	m_price_no: INTEGER
			-- DB: NUMBER(6,0) not null

	pricing_schedule: STRING
			-- DB: VARCHAR2(10) not null

feature -- Nullness for null allowed columns

	is_null_date_expires: BOOLEAN

feature -- Nullness for non-null columns

	is_null_area_amount: BOOLEAN
	is_null_date_effective: BOOLEAN
	is_null_edu_units: BOOLEAN
	is_null_flat_amount: BOOLEAN
	is_null_m_part_no: BOOLEAN
	is_null_m_price_no: BOOLEAN
	is_null_pricing_schedule: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and m_price_no = r.m_price_no
			Result := Result
				and is_null_m_price_no = r.is_null_m_price_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and area_amount = r.area_amount
				and edu_units = r.edu_units
				and flat_amount = r.flat_amount
				and m_part_no = r.m_part_no
			Result := Result
				and equal (date_effective, r.date_effective)
				and equal (date_expires, r.date_expires)
				and equal (pricing_schedule, r.pricing_schedule)
			Result := Result
				and is_null_area_amount = r.is_null_area_amount
				and is_null_date_effective = r.is_null_date_effective
				and is_null_date_expires = r.is_null_date_expires
				and is_null_edu_units = r.is_null_edu_units
				and is_null_flat_amount = r.is_null_flat_amount
				and is_null_m_part_no = r.is_null_m_part_no
				and is_null_pricing_schedule = r.is_null_pricing_schedule
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_double (1)
			q.select_date (2)
			q.select_date (3)
			q.select_integer (4)
			q.select_double (5)
			q.select_integer (6)
			q.select_integer (7)
			q.select_string (8, 10)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			area_amount := q.double_value (1)
			edu_units := q.integer_value (4)
			flat_amount := q.double_value (5)
			m_part_no := q.integer_value (6)
			m_price_no := q.integer_value (7)
		end

	fill_in_references (q: SQL_QUERY)
		do
			date_effective := q.date_value (2)
			date_expires := q.date_value (3)
			pricing_schedule := q.string_value (8)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_date_value (2, date_effective)
			q.get_date_value (3, date_expires)
			q.get_string_value (8, pricing_schedule)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_area_amount := q.is_null (1)
			is_null_date_effective := q.is_null (2)
			is_null_date_expires := q.is_null (3)
			is_null_edu_units := q.is_null (4)
			is_null_flat_amount := q.is_null (5)
			is_null_m_part_no := q.is_null (6)
			is_null_m_price_no := q.is_null (7)
			is_null_pricing_schedule := q.is_null (8)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_m_price_no := True
		end

	set_null_nonkey
		do
			is_null_area_amount := True
			is_null_date_effective := True
			is_null_date_expires := True
			is_null_edu_units := True
			is_null_flat_amount := True
			is_null_m_part_no := True
			is_null_pricing_schedule := True
			create {ORACLE_DATE} date_effective.set_null
			create {ORACLE_DATE} date_expires.set_null
			create pricing_schedule.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_integer (1, m_price_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
			d: DB_DATE
		do
			s := temp_string
			d := temp_date
			Result := True
			Result := Result
				and area_amount = q.double_value (1)
				and edu_units = q.integer_value (4)
				and flat_amount = q.double_value (5)
				and m_part_no = q.integer_value (6)
				and m_price_no = q.integer_value (7)
			q.get_date_value (2, d)
			Result := Result and equal (date_effective, d)
			q.get_date_value (3, d)
			Result := Result and equal (date_expires, d)
			q.get_string_value (8, s)
			Result := Result and equal (pricing_schedule, s)
			Result := Result
				and is_null_area_amount = q.is_null (1)
				and is_null_date_effective = q.is_null (2)
				and is_null_date_expires = q.is_null (3)
				and is_null_edu_units = q.is_null (4)
				and is_null_flat_amount = q.is_null (5)
				and is_null_m_part_no = q.is_null (6)
				and is_null_m_price_no = q.is_null (7)
				and is_null_pricing_schedule = q.is_null (8)
		end

end
