
indexing

	date: "Tue Apr 24 10:30:17 2007"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application NFE, database user DHOLLEN"
	database_tables: 
		"M_REQUESTS (MOSIS.M_REQUESTS)"
			-- Included columns
			-- 	DATE_PROCESSED
			-- 	DESIGN_NO
			-- 	M_COMMUNICATION_NO
			-- 	M_FAB_NO
			-- 	REQUESTED_ID
			-- 	REQUEST_NO
			-- 	REQUEST_TYPE
			-- 	REVISION_NO
			-- 	STORAGE_FILENAME
			-- 	STORAGE_SEGMENT_LENGTH
			-- 	STORAGE_SEGMENT_OFFSET
			-- Excluded columns
			-- 	(none)

class M_REQUESTS_RAW

inherit

	DB_DELETABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_m_communication_no: INTEGER; the_request_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			m_communication_no := the_m_communication_no
			request_no := the_request_no
			is_null_m_communication_no := False
			is_null_request_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 11

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  date_processed, design_no, m_communication_no, m_fab_no, requested_id,%N  request_no, request_type, revision_no, storage_filename,%N  storage_segment_length, storage_segment_offset"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "m_requests ir"

	join_condition: STRING = ""

	table_name: STRING = "m_requests"

	key_where_clause: STRING = "m_communication_no = :1 and request_no = :2"

feature -- Values

	date_processed: DB_DATE
			-- DB: DATE

	design_no: INTEGER
			-- DB: NUMBER(6,0)

	m_communication_no: INTEGER
			-- DB: NUMBER(9,0) not null

	m_fab_no: INTEGER
			-- DB: NUMBER(6,0)

	requested_id: STRING
			-- DB: VARCHAR2(24)

	request_no: INTEGER
			-- DB: NUMBER(3,0) not null

	request_type: STRING
			-- DB: VARCHAR2(24) not null

	revision_no: INTEGER
			-- DB: NUMBER(6,0)

	storage_filename: STRING
			-- DB: VARCHAR2(255)

	storage_segment_length: INTEGER
			-- DB: NUMBER(9,0)

	storage_segment_offset: INTEGER
			-- DB: NUMBER(9,0)

feature -- Nullness for null allowed columns

	is_null_date_processed: BOOLEAN
	is_null_design_no: BOOLEAN
	is_null_m_fab_no: BOOLEAN
	is_null_requested_id: BOOLEAN
	is_null_revision_no: BOOLEAN
	is_null_storage_filename: BOOLEAN
	is_null_storage_segment_length: BOOLEAN
	is_null_storage_segment_offset: BOOLEAN

feature -- Nullness for non-null columns

	is_null_m_communication_no: BOOLEAN
	is_null_request_no: BOOLEAN
	is_null_request_type: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and m_communication_no = r.m_communication_no
				and request_no = r.request_no
			Result := Result
				and is_null_m_communication_no = r.is_null_m_communication_no
				and is_null_request_no = r.is_null_request_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and design_no = r.design_no
				and m_fab_no = r.m_fab_no
				and revision_no = r.revision_no
				and storage_segment_length = r.storage_segment_length
				and storage_segment_offset = r.storage_segment_offset
			Result := Result
				and equal (date_processed, r.date_processed)
				and equal (requested_id, r.requested_id)
				and equal (request_type, r.request_type)
				and equal (storage_filename, r.storage_filename)
			Result := Result
				and is_null_date_processed = r.is_null_date_processed
				and is_null_design_no = r.is_null_design_no
				and is_null_m_fab_no = r.is_null_m_fab_no
				and is_null_requested_id = r.is_null_requested_id
				and is_null_request_type = r.is_null_request_type
				and is_null_revision_no = r.is_null_revision_no
				and is_null_storage_filename = r.is_null_storage_filename
				and is_null_storage_segment_length = r.is_null_storage_segment_length
				and is_null_storage_segment_offset = r.is_null_storage_segment_offset
		end

feature -- Modification

	set_date_processed (d: DB_DATE)
		do
			change_field (True, True)
			date_processed := d
			if d = Void then
				create {ORACLE_DATE} date_processed.set_null
			end
			is_null_date_processed := d = Void or else d.is_null
		end

	set_design_no (k: INTEGER)
		do
			change_field (True, True)
			design_no := k
			is_null_design_no := False
		end

	set_m_communication_no (k: INTEGER)
		do
			change_key_field
			m_communication_no := k
			is_null_m_communication_no := False
		end

	set_m_fab_no (k: INTEGER)
		do
			change_field (True, True)
			m_fab_no := k
			is_null_m_fab_no := False
		end

	set_requested_id (s: STRING)
		do
			change_field (True, True)
			requested_id := s
			if s = Void then
				create requested_id.make (0)
			end
			is_null_requested_id := s = Void or else s.count = 0
		end

	set_request_no (k: INTEGER)
		do
			change_key_field
			request_no := k
			is_null_request_no := False
		end

	set_request_type (s: STRING)
		do
			change_field (True, True)
			request_type := s
			if s = Void then
				create request_type.make (0)
			end
			is_null_request_type := s = Void or else s.count = 0
		end

	set_revision_no (k: INTEGER)
		do
			change_field (True, True)
			revision_no := k
			is_null_revision_no := False
		end

	set_storage_filename (s: STRING)
		do
			change_field (True, True)
			storage_filename := s
			if s = Void then
				create storage_filename.make (0)
			end
			is_null_storage_filename := s = Void or else s.count = 0
		end

	set_storage_segment_length (k: INTEGER)
		do
			change_field (True, True)
			storage_segment_length := k
			is_null_storage_segment_length := False
		end

	set_storage_segment_offset (k: INTEGER)
		do
			change_field (True, True)
			storage_segment_offset := k
			is_null_storage_segment_offset := False
		end

feature -- Modification to null

	set_null_date_processed
		do
			set_date_processed (Void)
		end

	set_null_design_no
		do
			change_field (True, True)
			design_no := 0
			is_null_design_no := True
		end

	set_null_m_fab_no
		do
			change_field (True, True)
			m_fab_no := 0
			is_null_m_fab_no := True
		end

	set_null_requested_id
		do
			set_requested_id (Void)
		end

	set_null_revision_no
		do
			change_field (True, True)
			revision_no := 0
			is_null_revision_no := True
		end

	set_null_storage_filename
		do
			set_storage_filename (Void)
		end

	set_null_storage_segment_length
		do
			change_field (True, True)
			storage_segment_length := 0
			is_null_storage_segment_length := True
		end

	set_null_storage_segment_offset
		do
			change_field (True, True)
			storage_segment_offset := 0
			is_null_storage_segment_offset := True
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_date (1)
			q.select_integer (2)
			q.select_integer (3)
			q.select_integer (4)
			q.select_string (5, 24)
			q.select_integer (6)
			q.select_string (7, 24)
			q.select_integer (8)
			q.select_string (9, 255)
			q.select_integer (10)
			q.select_integer (11)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			design_no := q.integer_value (2)
			m_communication_no := q.integer_value (3)
			m_fab_no := q.integer_value (4)
			request_no := q.integer_value (6)
			revision_no := q.integer_value (8)
			storage_segment_length := q.integer_value (10)
			storage_segment_offset := q.integer_value (11)
		end

	fill_in_references (q: SQL_QUERY)
		do
			date_processed := q.date_value (1)
			requested_id := q.string_value (5)
			request_type := q.string_value (7)
			storage_filename := q.string_value (9)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_date_value (1, date_processed)
			q.get_string_value (5, requested_id)
			q.get_string_value (7, request_type)
			q.get_string_value (9, storage_filename)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_date_processed := q.is_null (1)
			is_null_design_no := q.is_null (2)
			is_null_m_communication_no := q.is_null (3)
			is_null_m_fab_no := q.is_null (4)
			is_null_requested_id := q.is_null (5)
			is_null_request_no := q.is_null (6)
			is_null_request_type := q.is_null (7)
			is_null_revision_no := q.is_null (8)
			is_null_storage_filename := q.is_null (9)
			is_null_storage_segment_length := q.is_null (10)
			is_null_storage_segment_offset := q.is_null (11)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_m_communication_no := True
			is_null_request_no := True
		end

	set_null_nonkey
		do
			is_null_date_processed := True
			is_null_design_no := True
			is_null_m_fab_no := True
			is_null_requested_id := True
			is_null_request_type := True
			is_null_revision_no := True
			is_null_storage_filename := True
			is_null_storage_segment_length := True
			is_null_storage_segment_offset := True
			create {ORACLE_DATE} date_processed.set_null
			create requested_id.make (0)
			create request_type.make (0)
			create storage_filename.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_integer (1, m_communication_no, False)
			q.bind_num_to_integer (2, request_no, False)
		end

	bind (s: SQL_STATEMENT)
		do
			s.bind_num_to_date (1, date_processed, is_null_date_processed)
			s.bind_num_to_integer (2, design_no, is_null_design_no)
			s.bind_num_to_integer (3, m_communication_no, is_null_m_communication_no)
			s.bind_num_to_integer (4, m_fab_no, is_null_m_fab_no)
			s.bind_num_to_string (5, requested_id, is_null_requested_id)
			s.bind_num_to_integer (6, request_no, is_null_request_no)
			s.bind_num_to_string (7, request_type, is_null_request_type)
			s.bind_num_to_integer (8, revision_no, is_null_revision_no)
			s.bind_num_to_string (9, storage_filename, is_null_storage_filename)
			s.bind_num_to_integer (10, storage_segment_length, is_null_storage_segment_length)
			s.bind_num_to_integer (11, storage_segment_offset, is_null_storage_segment_offset)
		end

	bind_list_for_insert: STRING = "  :1, :2, :3, :4, :5, :6, :7, :8, :9, :10, :11"

	bind_list_for_update: STRING = "  date_processed = :1, design_no = :2, m_communication_no = :3,%N  m_fab_no = :4, requested_id = :5, request_no = :6, request_type = :7,%N  revision_no = :8, storage_filename = :9, storage_segment_length = :10,%N  storage_segment_offset = :11"

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
			d: DB_DATE
		do
			s := temp_string
			d := temp_date
			Result := True
			Result := Result
				and design_no = q.integer_value (2)
				and m_communication_no = q.integer_value (3)
				and m_fab_no = q.integer_value (4)
				and request_no = q.integer_value (6)
				and revision_no = q.integer_value (8)
				and storage_segment_length = q.integer_value (10)
				and storage_segment_offset = q.integer_value (11)
			q.get_date_value (1, d)
			Result := Result and equal (date_processed, d)
			q.get_string_value (5, s)
			Result := Result and equal (requested_id, s)
			q.get_string_value (7, s)
			Result := Result and equal (request_type, s)
			q.get_string_value (9, s)
			Result := Result and equal (storage_filename, s)
			Result := Result
				and is_null_date_processed = q.is_null (1)
				and is_null_design_no = q.is_null (2)
				and is_null_m_communication_no = q.is_null (3)
				and is_null_m_fab_no = q.is_null (4)
				and is_null_requested_id = q.is_null (5)
				and is_null_request_no = q.is_null (6)
				and is_null_request_type = q.is_null (7)
				and is_null_revision_no = q.is_null (8)
				and is_null_storage_filename = q.is_null (9)
				and is_null_storage_segment_length = q.is_null (10)
				and is_null_storage_segment_offset = q.is_null (11)
		end

end
