class M_REQUESTS_ROW

inherit
	M_REQUESTS_RAW
		rename
			reregister_last as reregister_last_raw
		undefine
			is_equal
		end

	STORED_HUNK_OF_TEXT

	AUTO_DB_DELETABLE_ROW_LIST[NFE_M_REPLIES_MROW]
		rename
			the_list	as the_replies,
			the_hidden_list as the_hidden_replies,
			fetch_the_list  as fetch_the_replies
		undefine
			is_equal
		end

create

	make_template, make_null, make_by_key

feature

	fetch_the_replies: IDENTIFIED_QUERY[NFE_M_REPLIES_MROW] is
	local  b: DB_BIND_II; r: NFE_M_REPLIES_MROW;
	do  if is_old
	     then create b.make(m_communication_no, request_no);
		  create r.make_template;
		  create Result.make(connection, r);
		  Result.set_f_and_b(
			"m_communication_no = :1 and request_no = :2", b);
		  Result.set_order_by("reply_no")
	    end;
	end;

	make_next_reply: NFE_M_REPLIES_MROW is
		-- add another reply
	do  create Result.make_null(connection);
	    the_replies.extend(Result);
	    Result.set_m_communication_no(m_communication_no);
	    Result.set_request_no(request_no);
	    Result.set_reply_no(the_replies.count);
	end;

	reregister_last is
		-- do me and then the kids too
	local repl: like the_replies; r: NFE_M_REPLIES_MROW
	do  reregister_last_raw;
	    from  repl := the_replies; repl.start
	    until repl.after
	    loop  r := repl.item
		  if r.is_registered then r.reregister_last end
		  repl.forth
	    end
	end;

feature {M_REQUESTS_ROW} -- artifice for STORED_HUNK_OF_TEXT

	reply_no: INTEGER is 0;

feature {NONE} -- artifice for STORED_HUNK_OF_TEXT

	first_response_line: STRING is
		-- empty response for requests
	do
	end;

	header_subject: STRING is
		-- empty header_subject for requests
	do
	end;

	sent_to: STRING is
		-- empty sent_to for requests
	do
	end;

	security_type: STRING is
		-- empty security_type for requests
	do
	end;

	content_type_id: STRING is
	once  Result := glo.content_is_text
	end;

feature -- viewer support

	viewer_row: ARRAY [STRING] is
	    -- array of strings for display in the communication viewer.
	    -- viewer_row_select is either viewer_table_row or viewer_status_row.
	    -- viewer_anchor_base may be set for inclusion in anchor if needed.
	    local
		str: STRING;
		dno: INTEGER;
	    do
		if viewer_row_select = viewer_table_row then
		    create Result.make(0,4);
    
		    str := "<A HREF=%"";
		    if viewer_anchor_base /= Void then
			str.append (viewer_anchor_base)
		    end;
		    str.extend ('#')
		    str.append (my_handle)
		    str.append ("%">")
		    str.append ("Request</A>");
		    Result.put(str,0);
		    Result.put(request_type,1);
		    str := requested_id;
		    dno := design_no;
		    if dno > 0 then
			if su.is_empty (str) or else
			  ( str.is_integer and then (str.to_integer = dno) ) then
			    str := dno.out;
			else
			    str := su.string_of_4 (dno.out," ( ",str," )");
			end
		    elseif su.is_empty (str) then
			str := "&nbsp"
		    end;
		    Result.put(str,2);
		    Result.put("",3);	    -- net address?
		    Result.put(date_processed.out,4);
		elseif viewer_row_select = viewer_status_row then
		else
		end
	    end


end -- M_REQUESTS_ROW
