
indexing
	
	description: "An object that can be marked, visited and selected"
	author: "David Hollenberg"
	date: "April 16, 2003"

class MARKABLE

feature -- Properties

	is_marked: BOOLEAN
			-- Is object marked?

	is_visited: BOOLEAN
			-- Has object been visited?

	is_selected: BOOLEAN
			-- Has object been selected?

	is_explicit: BOOLEAN
			-- Has object been selected explicitly?

	is_implicit: BOOLEAN
			-- Has object been selected implicitl?
		do
			Result := not is_explicit
		end

	is_in_cycle: BOOLEAN
			-- Is object part of a cycle?

feature -- Modification

	mark
			-- Mark object
		do
			is_marked := True
		ensure
			is_marked: is_marked
		end

	unmark
			-- Unmark object
		do
			is_marked := False
		ensure
			is_unmarked: not is_marked
		end

	visit
			-- Visit object
		do
			is_visited := True
		ensure
			visited: is_visited
		end

	unvisit
			-- Unvisit object
		do
			is_visited := False
		ensure
			unvisited: not is_visited
		end

	select_explicit
			-- Select object explicitly
		do
			is_selected := True
			is_explicit := True
		ensure
			selected: is_selected
			selected_explicitly: is_explicit
		end

	select_implicit
			-- Select object implicitly
		do
			is_selected := True
			is_explicit := False
		ensure
			selected: is_selected
			selected_implicitly: not is_explicit
		end

	unselect
			-- Unselect object
		do
			is_selected := False
		ensure
			unselected: not is_selected
		end

	set_in_cycle
			-- Set `is_in_cycle' to True
		do
			is_in_cycle := True
		ensure
			in_cycle: is_in_cycle
		end

end
