
indexing

	author: "Generated"
	date: "Sat Feb 21 09:30:28 PST 2004"

class MASK_TECHN_CANNED_LINES_ROW
inherit
	MASK_TECHN_CANNED_LINES_RAW
	ROW_COUNT_CHECK_ACCESS
create
	make_by_key, make_template, make_null

feature
	
	prolog_lines (mt, mask_size: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [STRING] is
			-- All canned prolog lines for mask techn `mt'
			-- and mask size id `mask_size', order by line number
		require
			mt_exists: mt /= Void
			mask_size_exists: mask_size /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		do
			Result := canned_lines (mt, mask_size, True, conn, range)
		ensure
			result_exists: Result /= Void
		end

	epilog_lines (mt, mask_size: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [STRING] is
			-- All canned epilog lines for mask techn `mt'
			-- and mask size id `mask_size', order by line number
		require
			mt_exists: mt /= Void
			mask_size_exists: mask_size /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		do
			Result := canned_lines (mt, mask_size, False, conn, range)
		ensure
			result_exists: Result /= Void
		end

feature {NONE} -- Implementation

	canned_lines (mt, mask_size: STRING is_prolog: BOOLEAN conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [STRING] is
			-- All canned lines for mask techn `mt' and
			-- mask size id `mask_size' which match
			-- `is_prolog', order by line number
		require
			mt_exists: mt /= Void
			mask_size_exists: mask_size /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_SSB
			list: LIST [like Current]
		do
			create b.make (mt, mask_size, is_prolog)
			list := all_rows_filtered_ordered (conn, 
				"mask_techn = :1 and mask_size_id = :2 and prolog = :3",
				b, "line_no")
			check_row_count (list, range)
			create {ARRAYED_LIST [STRING]} Result.make (list.count)
			list.do_all (agent add_canned_line (Result, ?))
		ensure
			result_exists: Result /= Void
		end

	add_canned_line (list: LIST [STRING] row: MASK_TECHN_CANNED_LINES_ROW) is
			-- Add text from `row' to `list'
		require
			list_exists: list /= Void
			row_exists: row /= Void
		do
			list.extend (row.text)
		end

end
