
indexing

	author: "Generated"
	date: "Wed Jun 18 12:57:24 PDT 2003"

class MASK_TECHNS_ROW
inherit
	MASK_TECHNS_RAW
	ROW_COUNT_CHECK_ACCESS
	POLARITY_VALUES
		export
			{ANY} is_valid_polarity
			{NONE} all
		end
create
	make_template, make_null, make_by_key

feature -- Properties

	mask_techns_with_name (mt: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current] is
			-- All mask techns named `mt'
		require
			mask_techn_exists: mt /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_S
		do
			create b.make (mt)
			Result := all_rows_filtered (conn, "mask_techn = :1", b)
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

	needs_mebes_files: BOOLEAN is
			-- Do we need to generate MEBES files for this mask 
			-- techn?
		require
			ebeam_type_exists: ebeam_type /= Void
			ebeam_type_nonempty: not ebeam_type.is_empty
		local
			ebeam_type_values: EBEAM_TYPE_VALUES
		do
			Result := ebeam_type.is_equal (ebeam_type_values.Mebes)
		end

	needs_gds_files: BOOLEAN is
			-- Do we need to generate GDS files for this mask 
			-- techn?
		local
			ebeam_type_values: EBEAM_TYPE_VALUES
		do
			Result := ebeam_type.is_equal (ebeam_type_values.Aeble)
		end

	positive_resist (polarity: STRING): BOOLEAN is
			-- Does mask require positive resist to achieve
			-- `polarity'?
		require
			polarity_exists: polarity /= Void
			polarity_valid: is_valid_polarity (polarity)
		local
			mode: WRITE_MODE_VALUES
		do
			Result := write_mode.is_equal (mode.Positive_resist) or
			  (write_mode.is_equal (mode.Direct_write) and polarity.is_equal (Dark_field)) or
			  (write_mode.is_equal (mode.Reverse_write) and polarity.is_equal (Clear_field))
		end

	reverse_tone (polarity: STRING): BOOLEAN is
			-- Does mask need reverse tone to achieve `polarity'?
		require
			polarity_exists: polarity /= Void
			polarity_valid: is_valid_polarity (polarity)
		do
			if positive_resist (polarity) then
				Result := polarity.is_equal (Clear_field)
			else
				Result := polarity.is_equal (Dark_field)
			end
		end

end
