
indexing
	
	description: "Object that generates a %"filled%" indication for %
		%selectable elements of a reticle view that do not have a %
		%maximum die size"
	author: "David Hollenberg"
	date: "October 30, 2006"

class MAX_DIE_SIZE_FILL_GENERATOR
inherit
	RETICLE_VIEW_ELEMENT_FILL_GENERATOR

create
	make

feature -- Properties

	tight_packing_fit: INTEGER
			-- Maximum difference between minimum and
			-- maximum die size for die to be considered a
			-- tight fit for packing purposes

feature -- Modification

	set_tight_packing_fit (a_value: like tight_packing_fit)
			-- Set `tight_packing_fit' to `a_value'
		do
			tight_packing_fit := a_value
		ensure
			value_set: tight_packing_fit = a_value
		end

feature  -- Access

	is_interior_filled (an_element: RETICLE_VIEW_ELEMENT): BOOLEAN
			-- Should interior of `an_element' be filled when
			-- it is displayed?
		do
			Result := an_element.is_selectable and an_element.is_die and then an_element.max_die_size = Void
		end
	
	interior_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Foreground color for interior of
			-- `an_element', if it is filled
		do
			Result := palette.no_max_die_size_fill_color
		end
	
end
