
indexing
	
	description: "Object that can generate a maximum die size label %
		%for an element of a reticle view"
	author: "David Hollenberg"
	date: "October 30, 2006"

class MAX_DIE_SIZE_LABEL_GENERATOR
inherit
	RETICLE_VIEW_ELEMENT_LABEL_GENERATOR

feature  -- Access

	label (an_element: RETICLE_VIEW_ELEMENT): STRING
			-- Label for `an_element'
		local
			p: CONST_POINT
			grid: GRID
			cut_die: CONST_RECTANGLE
		do
			if an_element.is_die then
				p := an_element.max_die_size
			else
				p := Void
			end
			Result := an_element.identification
			if an_element.is_project then
				if not Result.is_empty then
					Result.extend ('%N')
				end
				p := an_element.max_die_size
				if p /= Void then
					Result.append (p.x.rounded.out + " x " + p.y.rounded.out)
				else
					Result.append ("No Max")
				end
			end
			-- Add cut die size if available
			grid := an_element.grid
			cut_die := an_element.oriented_scribe_cut_die
			if cut_die /= Void then
				Result.extend ('%N')
				Result.append (grid.formatted_number (cut_die.size_x) + " x " + grid.formatted_number (cut_die.size_y))
			end
			-- Do not add "slop" dimensions for now
			-- Result.extend ('%N')
			-- Result.append (an_element.slop_x.rounded.out + " x " + an_element.slop_y.rounded.out)
		end
	
end
