
indexing
	
	description: "Action to compute sum of selected objects widths and heights"
	author: "David Hollenberg"
	date: "December 13, 2006"

class MEASURE_SUM_ACTION
inherit
	VIEW_ELEMENT_ACTION
	GRIDABLE

feature -- Properties

	total_x: DOUBLE
			-- Sum of widths of selected objects

	total_y: DOUBLE
			-- Sum of heights of selected objects

feature -- Modification

	initialize
			-- Initialize before measure operation
		do
			total_x := 0.0
			total_y := 0.0
		end

feature -- Operations

	apply (an_element: RETICLE_VIEW_ELEMENT)
			-- Apply action to `an_element'
		do
			if an_element.participates_in_measure then
				total_x := grid.rounded_size (total_x + an_element.size_x)
				total_y := grid.rounded_size (total_y + an_element.size_y)
			end
		end

end
