class MESSAGE_HEADER
		-- a standard RFC822 message header for either
		--  reading or composing e-mail messages
		-- can also be used to hold other headers that fit an
		--  a-list model

feature  -- access
	
	message_header(nam: STRING): LIST[STRING] is
		-- access to the parsed message header
		--  (created by read_message_header)
		-- nam is a header field name (TO, SEND, SUBJECT, etc)
		--  in UPPER CASE
		-- returned is a list with one entry for each occurence of
		--  nam in the header, in original message order.
		-- the strings in the list are the unfolded field bodies
		-- returns Void if nam never appeared
	do  if header_fields /= Void then
		Result := header_fields.items(nam); end;
	end;

	message_header1(nam: STRING): STRING is
		-- just the first one (or Void if none)
	local  foo: LIST[STRING];
	do  foo := message_header(nam);
	    if foo /= Void
	     then Result := foo.first
	    end
	end;

	message_header_field_names: ARRAY[STRING] is
		-- list of all the field names that actually appeared in the
		-- message header; order is arbitrary
	do  if header_fields /= Void then
                Result := header_fields.current_keys; end;
	end;

feature {NONE} -- Implementation

	header_fields: A_LIST[STRING]

end  -- MESSAGE_HEADER
