class MIME_SIMPLEPART
	-- one simple MIME part

inherit
	MIME_PART

create
	make, make_string, make_filename

feature -- stuff

	copy_body_to_consumer(c: DATA_CONSUMER) is
	local xform: DATA_TRANSFORM; 
	do  if equal(content_encoding, encoding_is_b64)
	     then create {BASE64_ENCODER} xform.make
	    elseif equal(content_encoding, encoding_is_qp)
	     then create {QUOTED_PRINTABLE_ENCODER} xform.make
	    end;
	    if xform = Void
	     then my_body.copy_to_consumer(c)
	     else xform.set_output_consumer(c)
		  xform.initialize
		  my_body.copy_to_consumer(xform)
		  xform.consume_eof	-- FIX_ME: propagation issue ??
	    end
	end;

	close is
	do  my_body.close
	end;

feature {NONE} -- implementation

	my_body: FILABLE

feature {NONE} -- creation

	make(a_type, a_subtype: STRING; a_src: FILABLE) is
		-- part of type a_type / a_subtype
		-- body comes from a_src
		-- anything else (e.g., encoding) is owner's responsibility
	do  content_type := a_type;
	    content_subtype := a_subtype;
	    my_body := a_src
	end;

	make_string(a_type, a_subtype, body: STRING) is
		-- body IS the body
	local a_ds: DATA_SOURCE_STRING
	do  create a_ds.make(body);
	    make(a_type, a_subtype, a_ds)
	end;

	make_filename(a_type, a_subtype, fnam: STRING) is
		-- contents of file fnam IS the body
	local a_ds: DATA_SOURCE_FILE
	do  create a_ds.make_from_filename(fnam);
	    make(a_type, a_subtype, a_ds)
	end;

end -- MIME_SIMPLEPART
