class MIME_SUPPORT
	-- values and validators for MIME messages

inherit
	STRING_UTILITIES_ACCESS

feature	-- additional MIME header fields

	msg_MIME_version:	STRING is "MIME-VERSION"
	msg_content_type:	STRING is "CONTENT-TYPE"
	msg_content_transfer_encoding:
				STRING is "CONTENT-TRANSFER-ENCODING"
	msg_content_description: STRING is "CONTENT-DESCRIPTION"
	msg_content_id:		STRING is "CONTENT-ID"
	msg_content_disposition: STRING is "CONTENT-DISPOSITION"

feature	-- the (one and only) MIME version

	the_MIME_version:	STRING is "1.0"

feature	-- the common MIME types and subtypes

	mtype_is_text:		STRING is "text"
	mtext_is_plain:		STRING is "plain"
	mtext_is_HTML:		STRING is "html"
	mtype_is_image:		STRING is "image"
	mtype_is_multipart:	STRING is "multipart"
	mpart_is_mixed:		STRING is "mixed"
	mpart_is_alt:		STRING is "alternative"
	mpart_is_related:	STRING is "related"
	mtype_is_app:		STRING is "application"

feature	-- the standard encodings

	encoding_is_qp: STRING is "quoted-printable"

	encoding_is_b64: STRING is "base64"

feature	-- parameter builders

	key_is_quoted_val(key, val: STRING): STRING is
		-- key="val"
	do  Result := su.string_of_4(key, "=%"", val, "%"")
	end;

	name_is(val: STRING): STRING is
		-- name="val"
	do  Result := key_is_quoted_val("name", val)
	end;

end -- MIME_SUPPORT
