
indexing
	
	description: "Miscellaneous utilities"
	author: "David Hollenberg"
	date: "February 11, 2000"

class MISC_UTILITIES

inherit
	ANY
	STRING_UTILITIES_ACCESS
		export
			{NONE} all
		end
	EXCEPTIONS_ACCESS
		export
			{NONE} all
		end

feature -- Boolean functions

	both (a, b: BOOLEAN): BOOLEAN
			-- Are both `a' and `b' true?  This is just
			-- `a' anded with `b', but with guaranteed
			-- evaluation of both args (evaluated before
			-- routine is called)
		do
			Result := a and b
		end

	exactly_one (a, b, c: BOOLEAN): BOOLEAN
			-- Is exactly one of `a', `b' and `c' true?
		do
			Result := (a xor b xor c) and not (a and b and c)
		end

	have_exception: BOOLEAN
		-- do we have an open exception
	do  Result := exc.original_exception > 0
	end

	have_exception_explanation: BOOLEAN
			-- Do we have an exception_explanation to give?
	do  Result := have_exception
	end

	exception_explanation: STRING
			-- Name of developer exception if exception due
			-- to a developer exception.  Otherwise, the
			-- tag name and meaning of original exception
		local tnam, mning: STRING
		do
			if exc.is_developer_exception then
				Result := exc.developer_exception_name
			else	tnam := exc.original_tag_name
				mning := exc.meaning(exc.original_exception)
				if su.is_empty(tnam) then
					Result := mning
				else	Result := su.string_of_3
					(tnam, su.colon_space, mning)
				end
			end
		end
	
end
