
indexing
	
	description: "Constants for modifier keys (Ctrl, Alt, Shift) and %
		%combinations of them"
	author: "David Hollenberg"
	date: "October 24, 2006"

class MODIFIER_KEY_CONSTANTS

feature -- Properties (modifier codes must be contiguous)

	Minimum_modifier_code: INTEGER = 0

	Unmodified_code: INTEGER = 0
			-- Code for no modifiers

	Ctrl_code: INTEGER = 1
			-- Code for Ctrl modifier only

	Alt_code: INTEGER = 2
			-- Code for Alt modifier only

	Shift_code: INTEGER = 3
			-- Code for Shift modifier only

	Ctrl_alt_code: INTEGER = 4
			-- Code for Ctrl+Alt modifier

	Alt_shift_code: INTEGER = 5
			-- Code for Alt+Shift modifier

	Ctrl_shift_code: INTEGER = 6
			-- Code for Ctrl+Shift modifier

	Ctrl_alt_shift_code: INTEGER = 7
			-- Code for Ctrl+Alt+Shift modifier

	Modifier_combinations: INTEGER = 8
			-- Number of distinct combinations of modifiers

	modifier_count (alt, ctrl, shift: BOOLEAN): INTEGER
			-- Number of modifier keys pressed
		do
			if alt then
				Result := Result + 1
			end
			if ctrl then
				Result := Result + 1
			end
			if shift then
				Result := Result + 1
			end
		end

	modifier_code (alt, ctrl, shift: BOOLEAN): INTEGER
			-- Code encoding which modifier keys are pressed
		do
			if not ctrl and not alt and not shift then
				Result := Unmodified_code
			elseif ctrl and not alt and not shift then
				Result := Ctrl_code
			elseif not ctrl and alt and not shift then
				Result := Alt_code
			elseif not ctrl and not alt and shift then
				Result := Shift_code
			elseif ctrl and alt and not shift then
				Result := Ctrl_alt_code
			elseif not ctrl and alt and shift then
				Result := Alt_shift_code
			elseif ctrl and not alt and shift then
				Result := Ctrl_shift_code
			else
				Result := Ctrl_alt_shift_code
			end
		end

	description (alt, ctrl, shift: BOOLEAN): STRING
			-- Description of modifier state
		do
			create Result.make (20)
			if ctrl then
				Result.append ("Ctrl+")
			end
			if shift then
				Result.append ("Shift+")
			end
			if alt then
				Result.append ("Alt+")
			end
		end

end
