class MONEY_MATTERS
	-- we retain currency ($) amounts in eiffel DOUBLEs,
	-- with all values in dollars rounded as appropriate

feature	-- 

	trifling_amount: DOUBLE is 0.1;		-- a mere dime

	verrry_close(amt1, amt2: DOUBLE): BOOLEAN is
		-- are these guys really, really close to being the same?
	do  Result := (amt1 - amt2).abs <= trifling_amount
	end;

	really_big_bucks: DOUBLE is 20000000.0;	-- $20 mil
		-- (anything larger will screw up in to_the_penny)

feature	-- currency rounding functions

	to_the_mil(A: DOUBLE): DOUBLE is
	do  Result := to_the_whatever(A, 1000);
	end;

	to_the_cent, to_the_penny(A: DOUBLE): DOUBLE is
	do  Result := to_the_whatever(A, 100);
	end;

	to_the_nickel(A: DOUBLE): DOUBLE is
	do  Result := to_the_whatever(A, 20);
	end;

	to_the_dime(A: DOUBLE): DOUBLE is
	do  Result := to_the_whatever(A, 10);
	end;

	to_the_quarter(A: DOUBLE): DOUBLE is
	do  Result := to_the_whatever(A, 4);
	end;

	to_the_dollar(A: DOUBLE): DOUBLE is
	do  Result := A.rounded;
	end;

feature -- currency truncation functions

	truncate_to_penny(A: DOUBLE): DOUBLE is
	do  Result := truncate_to_whatever(A, 100);
	end;

feature -- currency display functions

	as_currency(A: DOUBLE): STRING is
		-- printable form as currency
	do  Result := (A * 100).rounded.out;
	    -- make sure we have at least 3 digits
	    from
	    until Result.count >= 3
	    loop  Result.precede('0')
	    end;
	    -- possibly insert 1 or 2 commas
	    if Result.count >= 10 then
		Result.insert_string(",", Result.count-7)
	    end;
	    if Result.count >= 7 then
		Result.insert_string(",", Result.count-4)
	    end;
	    -- insert decimal point or remove the cents
	    if (Result @ (Result.count-1)) = '0' and
		(Result @ Result.count) = '0' then
		Result.keep_head(Result.count - 2)
	    else
		Result.insert_string(".", Result.count-1)
	    end;
	    Result.precede('$');
	end;

feature -- sales tax rate lookup

	sales_tax: SALES_TAX_LOOKUP is
	once  create Result.make
	end;

feature {NONE} 

	to_the_whatever(A: DOUBLE; unit: DOUBLE): DOUBLE is
	do  Result := (A * unit).rounded / unit
	end;

	truncate_to_whatever(A: DOUBLE; unit: DOUBLE): DOUBLE is
	do  Result := (A * unit).truncated_to_integer / unit
	end;

end -- MONEY_MATTERS
