class MOSIS_CACT_VALUES
	-- known attribute values with semantic meaning
	-- found primarily in CACT (and CORD) section tables
	-- They are collected here for ease of use.

feature	-- cust_acct.acct_type and .acct_sponsor_id

	accttyp_is_com:		STRING = "COM"
	accttyp_is_nda:		STRING = "NDA"
	accttyp_is_res:		STRING = "RES"
	accttyp_is_class:	STRING = "CLASS"
	accttyp_is_aclas:	STRING = "ACLAS"

	sponsor_is_edu:		STRING = "EDU"
	sponsor_is_mep:		STRING = "MEP"
	sponsor_is_nsf:		STRING = "NSF"
	sponsor_is_nsa:		STRING = "NSA"
	sponsor_is_oh:		STRING = "OH"
	sponsor_is_dar:		STRING = "DAR"
	sponsor_is_qa:		STRING = "QA"
	sponsor_is_rel:		STRING = "REL"

feature -- values of funding_auths.sub_type and .po_type

	subtype_is_cust_po:	STRING = "CUST_PO"
	subtype_is_uscauth:	STRING = "USCAUTH"
	subtype_is_eduauth:	STRING = "EDUAUTH"

	po_type_is_blanket:	STRING = "BLANKET"
	po_type_is_regular:	STRING = "REGULAR"

feature	-- LEGAL_AGR_TYPEs

	la_type_is_cst:		STRING = "CST"
	la_type_is_gov:		STRING = "GOV"
	la_type_is_nda:		STRING = "NDA"
	la_type_is_invnda:	STRING = "INVNDA"

feature	-- contact_roles

	cr_is_admin_liaison:	STRING = "ADMIN_LIAS"
	cr_is_tech_liaison:	STRING = "TECH_LIAS"
	cr_is_itar_liaison:	STRING = "ITAR_LIAS"
	cr_is_itar_contact:	STRING = "ITAR_CNTCT"

feature	-- password_type values

	pwt_is_basic:		STRING = "BASIC"
	pwt_is_accounting:	STRING = "ACCOUNTING"
	pwt_is_documentation:	STRING = "DOCUMENTATION"

	pwd_is_unassigned:	STRING = "*?UN-ASSIGNED?!*"

feature -- M_FUNDING_ALLOC_NO known values
	-- (it's an integer, not a string,
	--   but the only value known a priori in code)

	the_funding_alloc_from_hell: INTEGER = -1

end
