
indexing
	description: "Standard MOSIS colors and color names"
	author: "David Hollenberg"
	date:	"September 28, 2006"

class MOSIS_EV_STOCK_COLORS
inherit
	DRW_COLOR_GENERATOR
		rename
			colors as drw_colors
		export
			{NONE} drw_colors
		redefine
			default_create
		end

feature {NONE} -- Creation

	default_create is
		local
			a_key: STRING
			an_item: DRW_COLOR
		do
			precursor
			create colors.make ((drw_colors.capacity * 1.25).truncated_to_integer)
			
			from
				drw_colors.start
			until
				drw_colors.after
			loop
				a_key := drw_colors.key_for_iteration
				an_item := drw_colors.item_for_iteration
				colors.put (as_ev_color (an_item), a_key)
				drw_colors.forth
			end
			
			-- Add any additional named colors to `colors' here

		end

feature -- Access

	color_for_name (a_color_name: STRING): EV_COLOR is
		require
			a_color_name_not_void: a_color_name /= Void
			is_known_color_name: is_known_color_name (a_color_name)
		do
			Result := colors.item (a_color_name)
		ensure
			result_not_void: Result /= Void
		end

	is_known_color_name (a_color_name: STRING): BOOLEAN is
		require
			a_color_name_not_void: a_color_name /= Void
		do
			Result := colors.has (a_color_name)
		end

feature -- Colors

	Aliceblue: EV_COLOR is 
		once
			Result := color_for_name (Aliceblue_name)
		end
	
	Antiquewhite: EV_COLOR is 
		once
			Result := color_for_name (Antiquewhite_name)
		end
	
	Aqua: EV_COLOR is 
		once
			Result := color_for_name (Aqua_name)
		end
	
	Aquamarine: EV_COLOR is 
		once
			Result := color_for_name (Aquamarine_name)
		end
	
	Azure: EV_COLOR is 
		once
			Result := color_for_name (Azure_name)
		end
	
	Beige: EV_COLOR is 
		once
			Result := color_for_name (Beige_name)
		end
	
	Bisque: EV_COLOR is 
		once
			Result := color_for_name (Bisque_name)
		end
	
	Black: EV_COLOR is 
		once
			Result := color_for_name (Black_name)
		end
	
	Blanchedalmond: EV_COLOR is 
		once
			Result := color_for_name (Blanchedalmond_name)
		end
	
	Blue: EV_COLOR is 
		once
			Result := color_for_name (Blue_name)
		end
	
	Blueviolet: EV_COLOR is 
		once
			Result := color_for_name (Blueviolet_name)
		end
	
	Brown: EV_COLOR is 
		once
			Result := color_for_name (Brown_name)
		end
	
	Burlywood: EV_COLOR is 
		once
			Result := color_for_name (Burlywood_name)
		end
	
	Cadetblue: EV_COLOR is 
		once
			Result := color_for_name (Cadetblue_name)
		end
	
	Chartreuse: EV_COLOR is 
		once
			Result := color_for_name (Chartreuse_name)
		end
	
	Chocolate: EV_COLOR is 
		once
			Result := color_for_name (Chocolate_name)
		end
	
	Coral: EV_COLOR is 
		once
			Result := color_for_name (Coral_name)
		end
	
	Cornflowerblue: EV_COLOR is 
		once
			Result := color_for_name (Cornflowerblue_name)
		end
	
	Cornsilk: EV_COLOR is 
		once
			Result := color_for_name (Cornsilk_name)
		end
	
	Crimson: EV_COLOR is 
		once
			Result := color_for_name (Crimson_name)
		end
	
	Cyan: EV_COLOR is 
		once
			Result := color_for_name (Cyan_name)
		end
	
	Darkblue: EV_COLOR is 
		once
			Result := color_for_name (Darkblue_name)
		end
	
	Darkcyan: EV_COLOR is 
		once
			Result := color_for_name (Darkcyan_name)
		end
	
	Darkgoldenrod: EV_COLOR is 
		once
			Result := color_for_name (Darkgoldenrod_name)
		end
	
	Darkgray: EV_COLOR is 
		once
			Result := color_for_name (Darkgray_name)
		end
	
	Darkgreen: EV_COLOR is 
		once
			Result := color_for_name (Darkgreen_name)
		end
	
	Darkgrey: EV_COLOR is 
		once
			Result := color_for_name (Darkgrey_name)
		end
	
	Darkkhaki: EV_COLOR is 
		once
			Result := color_for_name (Darkkhaki_name)
		end
	
	Darkmagenta: EV_COLOR is 
		once
			Result := color_for_name (Darkmagenta_name)
		end
	
	Darkolivegreen: EV_COLOR is 
		once
			Result := color_for_name (Darkolivegreen_name)
		end
	
	Darkorange: EV_COLOR is 
		once
			Result := color_for_name (Darkorange_name)
		end
	
	Darkorchid: EV_COLOR is 
		once
			Result := color_for_name (Darkorchid_name)
		end
	
	Darkred: EV_COLOR is 
		once
			Result := color_for_name (Darkred_name)
		end
	
	Darksalmon: EV_COLOR is 
		once
			Result := color_for_name (Darksalmon_name)
		end
	
	Darkseagreen: EV_COLOR is 
		once
			Result := color_for_name (Darkseagreen_name)
		end
	
	Darkslateblue: EV_COLOR is 
		once
			Result := color_for_name (Darkslateblue_name)
		end
	
	Darkslategray: EV_COLOR is 
		once
			Result := color_for_name (Darkslategray_name)
		end
	
	Darkslategrey: EV_COLOR is 
		once
			Result := color_for_name (Darkslategrey_name)
		end
	
	Darkturquoise: EV_COLOR is 
		once
			Result := color_for_name (Darkturquoise_name)
		end
	
	Darkviolet: EV_COLOR is 
		once
			Result := color_for_name (Darkviolet_name)
		end
	
	Deeppink: EV_COLOR is 
		once
			Result := color_for_name (Deeppink_name)
		end
	
	Deepskyblue: EV_COLOR is 
		once
			Result := color_for_name (Deepskyblue_name)
		end
	
	Dimgray: EV_COLOR is 
		once
			Result := color_for_name (Dimgray_name)
		end
	
	Dimgrey: EV_COLOR is 
		once
			Result := color_for_name (Dimgrey_name)
		end
	
	oncedgerblue: EV_COLOR is 
		once
			Result := color_for_name (Dodgerblue_name)
		end
	
	Firebrick: EV_COLOR is 
		once
			Result := color_for_name (Firebrick_name)
		end
	
	Floralwhite: EV_COLOR is 
		once
			Result := color_for_name (Floralwhite_name)
		end
	
	Forestgreen: EV_COLOR is 
		once
			Result := color_for_name (Forestgreen_name)
		end
	
	Fuchsia: EV_COLOR is 
		once
			Result := color_for_name (Fuchsia_name)
		end
	
	Gainsboro: EV_COLOR is 
		once
			Result := color_for_name (Gainsboro_name)
		end
	
	Ghostwhite: EV_COLOR is 
		once
			Result := color_for_name (Ghostwhite_name)
		end
	
	Gold: EV_COLOR is 
		once
			Result := color_for_name (Gold_name)
		end
	
	Goldenrod: EV_COLOR is 
		once
			Result := color_for_name (Goldenrod_name)
		end
	
	Gray: EV_COLOR is 
		once
			Result := color_for_name (Gray_name)
		end
	
	Grey: EV_COLOR is 
		once
			Result := color_for_name (Grey_name)
		end
	
	Green: EV_COLOR is 
		once
			Result := color_for_name (Green_name)
		end
	
	Greenyellow: EV_COLOR is 
		once
			Result := color_for_name (Greenyellow_name)
		end
	
	Honeydew: EV_COLOR is 
		once
			Result := color_for_name (Honeydew_name)
		end
	
	Hotpink: EV_COLOR is 
		once
			Result := color_for_name (Hotpink_name)
		end
	
	Indianred: EV_COLOR is 
		once
			Result := color_for_name (Indianred_name)
		end
	
	Indigo: EV_COLOR is 
		once
			Result := color_for_name (Indigo_name)
		end
	
	Ivory: EV_COLOR is 
		once
			Result := color_for_name (Ivory_name)
		end
	
	Khaki: EV_COLOR is 
		once
			Result := color_for_name (Khaki_name)
		end
	
	Lavender: EV_COLOR is 
		once
			Result := color_for_name (Lavender_name)
		end
	
	Lavenderblush: EV_COLOR is 
		once
			Result := color_for_name (Lavenderblush_name)
		end
	
	Lawngreen: EV_COLOR is 
		once
			Result := color_for_name (Lawngreen_name)
		end
	
	Lemonchiffon: EV_COLOR is 
		once
			Result := color_for_name (Lemonchiffon_name)
		end
	
	Lightblue: EV_COLOR is 
		once
			Result := color_for_name (Lightblue_name)
		end
	
	Lightcoral: EV_COLOR is 
		once
			Result := color_for_name (Lightcoral_name)
		end
	
	Lightcyan: EV_COLOR is 
		once
			Result := color_for_name (Lightcyan_name)
		end
	
	Lightgoldenrodyellow: EV_COLOR is 
		once
			Result := color_for_name (Lightgoldenrodyellow_name)
		end
	
	Lightgray: EV_COLOR is 
		once
			Result := color_for_name (Lightgray_name)
		end
	
	Lightgreen: EV_COLOR is 
		once
			Result := color_for_name (Lightgreen_name)
		end
	
	Lightgrey: EV_COLOR is 
		once
			Result := color_for_name (Lightgrey_name)
		end
	
	Lightpink: EV_COLOR is 
		once
			Result := color_for_name (Lightpink_name)
		end
	
	Lightsalmon: EV_COLOR is 
		once
			Result := color_for_name (Lightsalmon_name)
		end
	
	Lightseagreen: EV_COLOR is 
		once
			Result := color_for_name (Lightseagreen_name)
		end
	
	Lightskyblue: EV_COLOR is 
		once
			Result := color_for_name (Lightskyblue_name)
		end
	
	Lightslategray: EV_COLOR is 
		once
			Result := color_for_name (Lightslategray_name)
		end
	
	Lightslategrey: EV_COLOR is 
		once
			Result := color_for_name (Lightslategrey_name)
		end
	
	Lightsteelblue: EV_COLOR is 
		once
			Result := color_for_name (Lightsteelblue_name)
		end
	
	Lightyellow: EV_COLOR is 
		once
			Result := color_for_name (Lightyellow_name)
		end
	
	Lime: EV_COLOR is 
		once
			Result := color_for_name (Lime_name)
		end
	
	Limegreen: EV_COLOR is 
		once
			Result := color_for_name (Limegreen_name)
		end
	
	Linen: EV_COLOR is 
		once
			Result := color_for_name (Linen_name)
		end
	
	Magenta: EV_COLOR is 
		once
			Result := color_for_name (Magenta_name)
		end
	
	Maroon: EV_COLOR is 
		once
			Result := color_for_name (Maroon_name)
		end
	
	Mediumaquamarine: EV_COLOR is 
		once
			Result := color_for_name (Mediumaquamarine_name)
		end
	
	Mediumblue: EV_COLOR is 
		once
			Result := color_for_name (Mediumblue_name)
		end
	
	Mediumorchid: EV_COLOR is 
		once
			Result := color_for_name (Mediumorchid_name)
		end
	
	Mediumpurple: EV_COLOR is 
		once
			Result := color_for_name (Mediumpurple_name)
		end
	
	Mediumseagreen: EV_COLOR is 
		once
			Result := color_for_name (Mediumseagreen_name)
		end
	
	Mediumslateblue: EV_COLOR is 
		once
			Result := color_for_name (Mediumslateblue_name)
		end
	
	Mediumspringgreen: EV_COLOR is 
		once
			Result := color_for_name (Mediumspringgreen_name)
		end
	
	Mediumturquoise: EV_COLOR is 
		once
			Result := color_for_name (Mediumturquoise_name)
		end
	
	Mediumvioletred: EV_COLOR is 
		once
			Result := color_for_name (Mediumvioletred_name)
		end
	
	Midnightblue: EV_COLOR is 
		once
			Result := color_for_name (Midnightblue_name)
		end
	
	Mintcream: EV_COLOR is 
		once
			Result := color_for_name (Mintcream_name)
		end
	
	Mistyrose: EV_COLOR is 
		once
			Result := color_for_name (Mistyrose_name)
		end
	
	Moccasin: EV_COLOR is 
		once
			Result := color_for_name (Moccasin_name)
		end
	
	Navajowhite: EV_COLOR is 
		once
			Result := color_for_name (Navajowhite_name)
		end
	
	Navy: EV_COLOR is 
		once
			Result := color_for_name (Navy_name)
		end
	
	Oldlace: EV_COLOR is 
		once
			Result := color_for_name (Oldlace_name)
		end
	
	Olive: EV_COLOR is 
		once
			Result := color_for_name (Olive_name)
		end
	
	Olivedrab: EV_COLOR is 
		once
			Result := color_for_name (Olivedrab_name)
		end
	
	Orange: EV_COLOR is 
		once
			Result := color_for_name (Orange_name)
		end
	
	Orangered: EV_COLOR is 
		once
			Result := color_for_name (Orangered_name)
		end
	
	Orchid: EV_COLOR is 
		once
			Result := color_for_name (Orchid_name)
		end
	
	Palegoldenrod: EV_COLOR is 
		once
			Result := color_for_name (Palegoldenrod_name)
		end
	
	Palegreen: EV_COLOR is 
		once
			Result := color_for_name (Palegreen_name)
		end
	
	Paleturquoise: EV_COLOR is 
		once
			Result := color_for_name (Paleturquoise_name)
		end
	
	Palevioletred: EV_COLOR is 
		once
			Result := color_for_name (Palevioletred_name)
		end
	
	Papayawhip: EV_COLOR is 
		once
			Result := color_for_name (Papayawhip_name)
		end
	
	Peachpuff: EV_COLOR is 
		once
			Result := color_for_name (Peachpuff_name)
		end
	
	Peru: EV_COLOR is 
		once
			Result := color_for_name (Peru_name)
		end
	
	Pink: EV_COLOR is 
		once
			Result := color_for_name (Pink_name)
		end
	
	Plum: EV_COLOR is 
		once
			Result := color_for_name (Plum_name)
		end
	
	Powderblue: EV_COLOR is 
		once
			Result := color_for_name (Powderblue_name)
		end
	
	Purple: EV_COLOR is 
		once
			Result := color_for_name (Purple_name)
		end
	
	Red: EV_COLOR is 
		once
			Result := color_for_name (Red_name)
		end
	
	Rosybrown: EV_COLOR is 
		once
			Result := color_for_name (Rosybrown_name)
		end
	
	Royalblue: EV_COLOR is 
		once
			Result := color_for_name (Royalblue_name)
		end
	
	Saddlebrown: EV_COLOR is 
		once
			Result := color_for_name (Saddlebrown_name)
		end
	
	Salmon: EV_COLOR is 
		once
			Result := color_for_name (Salmon_name)
		end
	
	Sandybrown: EV_COLOR is 
		once
			Result := color_for_name (Sandybrown_name)
		end
	
	Seagreen: EV_COLOR is 
		once
			Result := color_for_name (Seagreen_name)
		end
	
	Seashell: EV_COLOR is 
		once
			Result := color_for_name (Seashell_name)
		end
	
	Sienna: EV_COLOR is 
		once
			Result := color_for_name (Sienna_name)
		end
	
	Silver: EV_COLOR is 
		once
			Result := color_for_name (Silver_name)
		end
	
	Skyblue: EV_COLOR is 
		once
			Result := color_for_name (Skyblue_name)
		end
	
	Slateblue: EV_COLOR is 
		once
			Result := color_for_name (Slateblue_name)
		end
	
	Slategray: EV_COLOR is 
		once
			Result := color_for_name (Slategray_name)
		end
	
	Slategrey: EV_COLOR is 
		once
			Result := color_for_name (Slategrey_name)
		end
	
	Snow: EV_COLOR is 
		once
			Result := color_for_name (Snow_name)
		end
	
	Springgreen: EV_COLOR is 
		once
			Result := color_for_name (Springgreen_name)
		end
	
	Steelblue: EV_COLOR is 
		once
			Result := color_for_name (Steelblue_name)
		end
	
	Tan: EV_COLOR is 
		once
			Result := color_for_name (Tan_name)
		end
	
	Teal: EV_COLOR is 
		once
			Result := color_for_name (Teal_name)
		end
	
	Thistle: EV_COLOR is 
		once
			Result := color_for_name (Thistle_name)
		end
	
	Tomato: EV_COLOR is 
		once
			Result := color_for_name (Tomato_name)
		end
	
	Turquoise: EV_COLOR is 
		once
			Result := color_for_name (Turquoise_name)
		end
	
	Violet: EV_COLOR is 
		once
			Result := color_for_name (Violet_name)
		end
	
	Wheat: EV_COLOR is 
		once
			Result := color_for_name (Wheat_name)
		end
	
	White: EV_COLOR is 
		once
			Result := color_for_name (White_name)
		end
	
	Whitesmoke: EV_COLOR is 
		once
			Result := color_for_name (Whitesmoke_name)
		end
	
	Yellow: EV_COLOR is 
		once
			Result := color_for_name (Yellow_name)
		end
	
	Yellowgreen: EV_COLOR is 
		once
			Result := color_for_name (Yellowgreen_name)
		end

feature {NONE} -- Implementation

	as_ev_color (a_color: DRW_COLOR): EV_COLOR is
		require
			a_color_not_void: a_color /= Void
		do
			create Result.make_with_rgb (a_color.Red, a_color.Green, a_color.Blue)
		ensure
			result_not_void: Result /= Void
		end

	colors: HASH_TABLE [EV_COLOR, STRING]

end

