class MOSIS_JOBQ_VALUES
	-- known attribute values with semantic meaning
	-- found primarily in JOBQ section tables
	-- They are collected here for ease of use.

feature	-- batch_job_queues

	bjque_is_dc:		STRING = "DESIGN_CHECK_BATCH"
	bjque_is_IBM_prep:	STRING = "IBM_PREP_BATCH"
	bjque_is_auto_DRC:	STRING = "AUTO_DRC_BATCH"

feature	-- batch job types

	bjtype_is_dc:		STRING = "DESIGN_CHECK"
	bjtype_is_fracture:	STRING = "FRACTURE"
	bjtype_is_merge:	STRING = "MERGE"
	bjtype_is_fill:		STRING = "FILL"
	bjtype_is_IBM_prep:	STRING = "IBM_PREP"
	bjtype_is_auto_DRC:	STRING = "AUTO_DRC"

feature	-- batch job states

	bjstate_is_waiting:	STRING = "WAITING"
	bjstate_is_assigned:	STRING = "ASSIGNED"
	bjstate_is_executing:	STRING = "EXECUTING"
	bjstate_is_aborted:	STRING = "ABORTED"
	bjstate_is_passed:	STRING = "PASSED"
	bjstate_is_failed:	STRING = "FAILED"
	bjstate_is_interr:	STRING = "INTERNAL_ERROR"
	bjstate_is_stop_requested: STRING = "STOP_REQUESTED"
	bjstate_is_stopped:	STRING = "STOPPED"
	bjstate_is_holding:	STRING = "HOLDING"

	bjstate_is_terminal(bjs: STRING): BOOLEAN
		-- is this a terminal batch_job state?
	do  Result :=	equal(bjs, bjstate_is_aborted) or
			equal(bjs, bjstate_is_passed) or
			equal(bjs, bjstate_is_failed) or
			equal(bjs, bjstate_is_interr) or
			equal(bjs, bjstate_is_stopped)
	end

feature	-- typical priority values

	bjpriority_is_normal:	INTEGER = 50

end
