
deferred class MOSIS_PRICE

inherit
	MOSIS_PRICE_CALCULATOR

	EFFECTIVE_ON_DATE

feature -- status

	price_identification_no: INTEGER is
	    -- quote or price identifying number
	    deferred
	    end

	line_no: INTEGER is
	    -- identifying qualifying number if needed
	    do
		-- May be redefined if needed
	    end

	pricing_schedule: STRING is
	    -- the price schedule
	    require
		appropriate: is_standard_price
	    do
		-- May be redefined if needed
	    end

	quantity_quoted: INTEGER is
	    -- the quoted quantity
	    require
		appropriate: is_quoted_price
	    do
		-- May be redefined if needed
	    end

	assumed_area: DOUBLE is
	    -- the quoted assumed area
	    require
		appropriate: is_quoted_price
	    do
		-- May be redefined if needed
	    end

	edu_units: INTEGER is
	    deferred
	    end

  --	date_effective: DB_DATE is	-- these thre are inherited from
  --	    deferred			-- EFFECTIVE_ON_DATE
  --	    end

  --	date_expires: DB_DATE is
  --	    deferred
  --	    end

  --	is_null_date_expires: BOOLEAN is
  --	    deferred
  --	    end

	m_part_no: INTEGER is
	    -- the part this price is for
	    deferred
	    end

	is_quoted_price: BOOLEAN is
	    -- true if represents a quoted price
	    deferred
	    ensure
		consistent: Result implies price_identification_no > 0
	    end

	is_standard_price: BOOLEAN is
	    -- true if represents a standard price
	    do
		Result := not is_quoted_price and
				(price_identification_no > 0)
	    ensure
		consistent: Result implies price_identification_no > 0
	    end

	descr: STRING is
	    -- description of source (quote id or pricing_schedule.descr)
	    deferred
	    end;

end -- MOSIS_PRICE


