
indexing
	
	description: "Action to take to move selected objects by the same %
		%relative amount"
	author: "David Hollenberg"
	date: "November 16, 2006"

class MOVE_RELATIVE_ACTION
inherit
	VIEW_ELEMENT_MOVE_ACTION

feature -- Properties

	requested_move_distance: CONST_POINT
			-- Distance by which elements are to be moved

feature -- Modification

	set_requested_move_distance (a_value: like requested_move_distance)
			-- Set `requested_move_distance' to `a_value'
		do
			requested_move_distance := a_value
		ensure
			requested_move_distance_set: requested_move_distance = a_value
		end

feature {NONE} -- Implementation

	compute_center (an_element: RETICLE_VIEW_ELEMENT)
			-- Compute `new_center' for `an_element'.
		do
			new_center.make_xy (an_element.center_x + requested_move_distance.x, an_element.center_y + requested_move_distance.y)
		end

	compute_move_distance (an_element: RETICLE_VIEW_ELEMENT)
			-- Compute `move_distance' for `an_element'
		do
			move_distance.make_xy (requested_move_distance.x, requested_move_distance.y)
		end

	do_additional_validation (an_element: RETICLE_VIEW_ELEMENT)
		do
			an_element.check_move_restrictions (move_distance)
		end

end
