
indexing
	
	description: "EV_MULTI_COLUMN_LIST_ROW with additional properties"
	author: "David Hollenberg";
	date: "November 18, 2003"

deferred class MULTI_COLUMN_LIST_ROW
inherit
	EV_MULTI_COLUMN_LIST_ROW
		undefine
			new_filled_list
		redefine
			initialize
		end
	

feature -- Properties

	is_visible: BOOLEAN
			-- Is row currently visible in multi-column list?

	unique_identifier: STRING is
			-- Value that uniquely identifies row
		deferred
		end

feature -- Modification

	enable_visible is
			-- Make row visible
		do
			is_visible := True
		ensure
			is_visible: is_visible
		end

	disable_visible is
			-- Make row invisible
		do
			is_visible := False
		ensure
			not_visible: not is_visible
		end

	set_visible (b: BOOLEAN) is
			-- Set `is_visible' to `b'
		do
			is_visible := b
		ensure
			visibility_set: is_visible = b
		end

feature {NONE} -- Implementation

	initialize is
		do
			precursor
			enable_visible
		end

end
