
indexing

	date: "Tue Apr 24 10:30:14 2007"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user DHOLLEN"
	database_tables: 
		"NAMED_COLORS (MOSIS.NAMED_COLORS)"
			-- Included columns
			-- 	BLUE_VALUE
			-- 	COLOR_NAME
			-- 	GREEN_VALUE
			-- 	IS_SVG_STANDARD
			-- 	RED_VALUE
			-- Excluded columns
			-- 	(none)

class NAMED_COLORS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_color_name: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_color_name_exists: the_color_name /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			color_name := the_color_name
			is_null_color_name := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 5

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  blue_value, color_name, green_value, is_svg_standard, red_value"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "named_colors nc"

	join_condition: STRING = ""

	table_name: STRING = "named_colors"

	key_where_clause: STRING = "color_name = :1"

feature -- Values

	blue_value: DOUBLE
			-- DB: NUMBER(*,*) not null

	color_name: STRING
			-- DB: VARCHAR2(30) not null

	green_value: DOUBLE
			-- DB: NUMBER(*,*) not null

	is_svg_standard: BOOLEAN
			-- DB: CHAR(1) not null

	red_value: DOUBLE
			-- DB: NUMBER(*,*) not null

feature -- Nullness for non-null columns

	is_null_blue_value: BOOLEAN
	is_null_color_name: BOOLEAN
	is_null_green_value: BOOLEAN
	is_null_is_svg_standard: BOOLEAN
	is_null_red_value: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (color_name, r.color_name)
			Result := Result
				and is_null_color_name = r.is_null_color_name
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and blue_value = r.blue_value
				and green_value = r.green_value
				and is_svg_standard = r.is_svg_standard
				and red_value = r.red_value
			Result := Result
				and is_null_blue_value = r.is_null_blue_value
				and is_null_green_value = r.is_null_green_value
				and is_null_is_svg_standard = r.is_null_is_svg_standard
				and is_null_red_value = r.is_null_red_value
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_double (1)
			q.select_string (2, 30)
			q.select_double (3)
			q.select_boolean (4)
			q.select_double (5)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			blue_value := q.double_value (1)
			green_value := q.double_value (3)
			is_svg_standard := q.boolean_value (4)
			red_value := q.double_value (5)
		end

	fill_in_references (q: SQL_QUERY)
		do
			color_name := q.string_value (2)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (2, color_name)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_blue_value := q.is_null (1)
			is_null_color_name := q.is_null (2)
			is_null_green_value := q.is_null (3)
			is_null_is_svg_standard := q.is_null (4)
			is_null_red_value := q.is_null (5)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_color_name := True
			create color_name.make (0)
		end

	set_null_nonkey
		do
			is_null_blue_value := True
			is_null_green_value := True
			is_null_is_svg_standard := True
			is_null_red_value := True
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, color_name, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and blue_value = q.double_value (1)
				and green_value = q.double_value (3)
				and is_svg_standard = q.boolean_value (4)
				and red_value = q.double_value (5)
			q.get_string_value (2, s)
			Result := Result and equal (color_name, s)
			Result := Result
				and is_null_blue_value = q.is_null (1)
				and is_null_color_name = q.is_null (2)
				and is_null_green_value = q.is_null (3)
				and is_null_is_svg_standard = q.is_null (4)
				and is_null_red_value = q.is_null (5)
		end

end
