class NFE_PROCESS_CREATION_ACTION

inherit
	ACTION_ITEM

	NFE_SUB_PROCESS_CACHE

	PROCESS_CREATION_ACTION
	rename make as new_make
	undefine log_child_status
	redefine do_it, descr
	end;

	NFE_PROCESSOR_MODE

	OS_ACCESS

	UNIX_OS_ACCESS

create
	make

feature -- items set up by make and used by do_it

--	proc_mode: STRING;

--	proc_args: ARRAY[STRING];

--	proc_lock: LOCK;

--	proc_in_action: UNIX_PROCESS;

feature	-- executor

	do_it is
	local taken: BOOLEAN
	do  -- see if the lock is available (or none required)
	    if proc_lock /= Void
	     then proc_lock.test_lock
		  taken := proc_lock.conflicting_lock_exists
	    end;
	    -- and start up the sucker
	    if not taken
	     then proc_in_action.set_arguments(proc_args)
		  proc_in_action.set_process_group_leader (True)
		  proc_in_action.spawn_nowait;
		  if proc_in_action.in_child
		   then os.die_without_handlers(1) end;	-- BIG OOPS
		  all_my_children.extend(proc_in_action);
		  generic_glo.log_pid_line("Spawned", proc_mode,
					proc_in_action.process_id);
	    elseif proc_lock /= Void
	     then glo.log_line_2("Lock already taken for", proc_mode)
	    end;
	    done := true;
	rescue
	    if proc_in_action.in_child
	     then	-- BIG OOPS; speak quickly and DIE (do not PUNT)
		os.die_without_handlers(2)
	    end;
	end;

	descr: STRING is
	do  Result := su.string_of_2("start ", proc_mode)
	end;

feature -- creation

	make(mode: STRING) is
		-- mode is a mode_is_xxxx value
	local foo, program_file, nfe_host, p_name: STRING; args: ARRAY[STRING];
	      i,offset: INTEGER; go_rem: BOOLEAN;
	do  -- create proc_mode
	    proc_mode := mode;
	    -- determine whether we are going to run remotely
	    nfe_host := vars.nfe_host_name;
	    go_rem := su.not_empty (nfe_host) and then
			not nfe_host.is_equal (os.local_host_name);
	    -- create proc_args as copy of mine plus one if nfe_host is empty
	    --   otherwise, prefix them with the host and program name
	    args := vars.original_args;
	    if go_rem
	     then create proc_args.make(1, args.upper+5);
		  proc_args.enter(nfe_host,1);
		  proc_args.enter("-l",2);
		  proc_args.enter(unix_os.user_name_for_id (unix_os.effective_user_id),3);
		  proc_args.enter(vars.nfe_remote_prog_remote,4);
		  offset := 4
	     else create proc_args.make(1, args.upper+1);
		  offset := 0
	    end;
	    from i := 1		-- copy my args
	    until i > args.upper
	    loop  proc_args.enter(args @ i, i + offset);
		  i := i + 1
	    end;
	    proc_args.enter(configuration_line(param_is_mode, mode),
			    i + offset);	-- add final mode
	    -- find the program name (file name for creation)
	    p_name := fe_proc_name(mode);	-- for set_process_name
	    if go_rem then
	    	program_file := vars.nfe_remote_prog_local;
		p_name := "rsh"
		    		-- Don't change this name.  If name under
				-- which rsh is invoked is not "rsh",
				-- it uses that name as the remote host name
	    elseif equal(mode, mode_is_sender) then
	    	program_file := vars.nfe_sender_file
	--  elseif equal(mode, mode_is_padx) then
	-- 	program_file := vars.nfe_pad_extractor_file
	--	JG: pad extractor eliminated, 20-Oct-2004
	    else
	    	program_file := vars.nfe_proc_file
	    end;
	    foo := vars.item(lock_file_key(mode));
	    new_make(program_file,p_name,foo);
	end;

end -- NFE_PROCESS_CREATION_ACTION