class NFE_STRINGS
		-- string constants whose values are known to NFE
		-- most are stored / fetched from the database, but
		-- some are used elsewhere (parameter names)
		-- NOTE: table and column names are not found here

inherit
	MOSIS_PROD_VALUES

	MOSIS_UMFE_VALUES

	MOSIS_CACT_VALUES

	MOSIS_MPRO_VALUES

	MOSIS_ADDR_VALUES

	MOSIS_TECH_VALUES

	MOSIS_JOBQ_VALUES

	DB_SIGNAL_NAMES

feature -- nfe signature

	i_am: STRING is "UFE"		-- for created_by
	application: STRING is "UFE97"	-- for application_parameters & _events

feature -- MESSAGE_IDs for UFE97_REQ

	application_is_ufe_response: STRING is "UFE97_REQ"

	response_is_ackitm:    STRING is "ACKITM"
	response_is_ambpar:    STRING is "AMBPAR"
	response_is_bigpar:    STRING is "BIGPAR"
	response_is_bigqot:    STRING is "BIGQOT"
	response_is_bonded:    STRING is "BONDED"
	response_is_bond_subj: STRING is "BOND_SUBJ"
	response_is_bdproc:    STRING is "BDPROC"
	response_is_canned:    STRING is "CANNED"
	response_is_chkpar:    STRING is "CHKPAR"
	response_is_cntqot:    STRING is "CNTQOT"
	response_is_comment:   STRING is "COMMENT"
	response_is_dblpar:    STRING is "DBLPAR"
	response_is_dcfail:    STRING is "DCFAIL"
	response_is_dcpass:    STRING is "DCPASS"
	response_is_dedrun:    STRING is "DEDRUN"
	response_is_drcfal:    STRING is "DRCFAL"
	response_is_drcrdy:    STRING is "DRCRDY"
	response_is_duppar:    STRING is "DUPPAR"
	response_is_emlqot:    STRING is "EMLQOT"
	response_is_expacc:    STRING is "EXPACC"
	response_is_fildup:    STRING is "FILDUP"
	response_is_fillng:    STRING is "FILLNG"
	response_is_filmis:    STRING is "FILMIS"
	response_is_filtyp:    STRING is "FILTYP"
	response_is_frgeom:    STRING is "FRGEOM"
	response_is_ftpexp:    STRING is "FTPEXP"
	response_is_ignval:    STRING is "IGNVAL"
	response_is_illpar:    STRING is "ILLPAR"
	response_is_illval:    STRING is "ILLVAL"
	response_is_inclin:    STRING is "INCLIN"
	response_is_incans:    STRING is "INCANS"
	response_is_incpar:    STRING is "INCPAR"
	response_is_insqot:    STRING is "INSQOT"
	response_is_intpar:    STRING is "INTPAR"
	response_is_invacc:    STRING is "INVACC"
	response_is_invdlm:    STRING is "INVDLM"
	response_is_invftp:    STRING is "INVFTP"
	response_is_invhrs:    STRING is "INVHRS"
	response_is_invstar:   STRING is "INVSTAR"
--	response_is_kconsu:    STRING is "KCONSU"
--	response_is_knotet:    STRING is "KNOTET"
	response_is_mepact:    STRING is "MEPACT";
	response_is_mispar:    STRING is "MISPAR"
	response_is_misreq:    STRING is "MISREQ"
	response_is_mustcan:   STRING is "MUSTCAN"
	response_is_mustwt:    STRING is "MUSTWT"
	response_is_noattn:    STRING is "NOATTN"
	response_is_nogeom:    STRING is "NOGEOM"
	response_is_noinfo:    STRING is "NOINFO"
	response_is_nonqot:    STRING is "NONQOT"
	response_is_nopar:     STRING is "NOPAR"
	response_is_notbtwn:   STRING is "NOTBTWN"
	response_is_notbtwne:  STRING is "NOTBTWNE"
	response_is_notbtwnw:  STRING is "NOTBTWNW"
	response_is_notopi:    STRING is "NOTOPI"
	response_is_obscif:    STRING is "OBSCIF"
	response_is_obsinf:    STRING is "OBSINF"
	response_is_obspar:    STRING is "OBSPAR"
	response_is_obsreq:    STRING is "OBSREQ"
	response_is_oneqot:    STRING is "ONEQOT"
	response_is_opstat:    STRING is "OPSTAT"
	response_is_opstat_subj:    STRING is "OPSTAT_SUBJ"
	response_is_pkgqot:    STRING is "PKGQOT"
	response_is_prmdat:    STRING is "PRMDAT"
	response_is_prsval:    STRING is "PRSVAL"
	response_is_prvhst:    STRING is "PRVHST"
	response_is_remadr:    STRING is "REMADR"
	response_is_remads:    STRING is "REMADS"
	response_is_replay:    STRING is "REPLAY"
	response_is_resqot:    STRING is "RESQOT"
	response_is_routlb:    STRING is "ROUTLB"
	response_is_rqnhdr:    STRING is "RQNHDR"
	response_is_sndftp:    STRING is "SNDFTP"
	response_is_shippd:    STRING is "SHIPPD"
	response_is_sillyv:    STRING is "SILLYV"
	response_is_skplin:    STRING is "SKPLIN"
	response_is_smlpar:    STRING is "SMLPAR"
	response_is_srvqot:    STRING is "SRVQOT"
	response_is_stdqot:    STRING is "STDQOT"
	response_is_tncqot:    STRING is "TNCQOT"
	response_is_tncqotres: STRING is "TNCQOTRES"
	response_is_tncqotx:   STRING is "TNCQOTX"
	response_is_tncqotz:   STRING is "TNCQOTZ"
	response_is_toobigw:   STRING is "TOOBIGW"
	response_is_toobige:   STRING is "TOOBIGE"
	response_is_toosmallw: STRING is "TOOSMALLW"
	response_is_toosmalle: STRING is "TOOSMALLE"
	response_is_trcpar:    STRING is "TRCPAR"
	response_is_unkpar:    STRING is "UNKPAR"
	response_is_unkreq:    STRING is "UNKREQ"
	response_is_unkval:    STRING is "UNKVAL"
	response_is_upgrade_shipping: STRING is "UPGRADE_SHIPPING"

feature -- MESSAGE_IDs for PROJECT_REPLY

	application_is_project_reply: STRING is "PROJECT_REPLY"

	result_is_ackchk:  STRING is "ACKCHK"
	result_is_ackftp:  STRING is "ACKFTP"
	result_is_ackitm:  STRING is "ACKITM"
	result_is_adjqan:  STRING is "ADJQAN"
	result_is_anonqot: STRING is "ANONQOT";
	result_is_bddhlp:  STRING is "BDDHLP"
	result_is_bddrqd:  STRING is "BDDRQD"
	result_is_bdscus:  STRING is "BDSCUS"
	result_is_bducus:  STRING is "BDUCUS"
	result_is_bdsmos:  STRING is "BDSMOS"
	result_is_bndrdy:  STRING is "BNDRDY"
	result_is_bndrdyc: STRING is "BNDRDYC"
	result_is_bndreq:  STRING is "BNDREQ"
	result_is_bndsbj:  STRING is "BNDSBJ"
	result_is_canned:  STRING is "CANNED"
	result_is_dcinfo:  STRING is "DCINFO"
	result_is_dedmep:  STRING is "DEDMEP"
	result_is_dedqot:  STRING is "DEDQOT"
	result_is_defqnt:  STRING is "DEFQNT"
	result_is_diesiz:  STRING is "DIESIZ"
	result_is_difexp:  STRING is "DIFEXP"
	result_is_diffmt:  STRING is "DIFFMT"
	result_is_diffrg:  STRING is "DIFFRG"
	result_is_drcnak:  STRING is "DRCNAK"
	result_is_drcofr:  STRING is "DRCOFR"
	result_is_drcsub:  STRING is "DRCSUB"
	result_is_drcusd:  STRING is "DRCUSD"
	result_is_dupfab:  STRING is "DUPFAB"
	result_is_dupfrg:  STRING is "DUPFRG"
	result_is_dupitm:  STRING is "DUPITM"
	result_is_dupxfm:  STRING is "DUPXFM"
	result_is_eccdrm:  STRING is "ECCDRM"
	result_is_eccdrq:  STRING is "ECCDRQ"
	result_is_eccpqr:  STRING is "ECCPQR"
	result_is_eccqlk:  STRING is "ECCQLK"
	result_is_eccqna:  STRING is "ECCQNA"
	result_is_eccqqna: STRING is "ECCQQNA"
	result_is_eccqok:  STRING is "ECCQOK"
	result_is_eccqrv:  STRING is "ECCQRV"
	result_is_ecmaxd:  STRING is "ECMAXD"
	result_is_expqot:  STRING is "EXPQOT"
	result_is_exterr:  STRING is "EXTERR"
	result_is_extwrn:  STRING is "EXTWRN"
	result_is_fiqnak:  STRING is "FIQNAK"
	result_is_fiqwrn:  STRING is "FIQWRN"
	result_is_fndrfl:  STRING is "FNDRFL"
	result_is_frozen:  STRING is "FROZEN"
	result_is_ftpenc:  STRING is "FTPENC"
	result_is_ftpfrm:  STRING is "FTPFRM"
	result_is_ftphdr:  STRING is "FTPHDR"
	result_is_ftpshd:  STRING is "FTPSHD"
	result_is_gdsnly:  STRING is "GDSNLY"
	result_is_IBMMDR:  STRING is "IBMMDR"
	result_is_igndat:  STRING is "IGNDAT"
	result_is_ignlam:  STRING is "IGNLAM"
	result_is_ignpo:   STRING is "IGN_PO"
	result_is_incopt:  STRING is "INCOPT"
	result_is_increp:  STRING is "INCREP";	-- error
	result_is_incrwp:  STRING is "INCRWP";	-- warning
	result_is_itarco:  STRING is "ITARCO";
	result_is_manqot:  STRING is "MANQOT";
	result_is_maxdie:  STRING is "MAXDIE"
	result_is_minqot:  STRING is "MINQOT";
	result_is_mischk:  STRING is "MISCHK";
	result_is_misrdr:  STRING is "MISRDR";
	result_is_misval:  STRING is "MISVAL";
	result_is_mrgfrg:  STRING is "MRGFRG"
	result_is_mstred:  STRING is "MSTRED"
	result_is_nakchk:  STRING is "NAKCHK"
	result_is_ncrypt:  STRING is "NCRYPT"
	result_is_nedqot:  STRING is "NEDQOT";
	result_is_nilfil:  STRING is "NILFIL"
	result_is_noacct:  STRING is "NOACCT"
	result_is_nocifs:  STRING is "NOCIFS"
	result_is_nofid:   STRING is "NO_FID"
	result_is_nofile:  STRING is "NOFILE"
	result_is_nofram:  STRING is "NOFRAM"
	result_is_nolamb:  STRING is "NOLAMB"
	result_is_nopack:  STRING is "NOPACK"
	result_is_nopass:  STRING is "NOPASS"
	result_is_notcan:  STRING is "NOTCAN"
	result_is_notfrg:  STRING is "NOTFRG"
	result_is_notque:  STRING is "NOTQUE"
	result_is_nottxt:  STRING is "NOTTXT"
	result_is_nounpk:  STRING is "NOUNPK"
	result_is_nowtfl:  STRING is "NOWTFL"
	result_is_nsains:  STRING is "NSAINS"
	result_is_opstat:  STRING is "OPSTAT"
	result_is_pckfrm:  STRING is "PCKFRM"
	result_is_pkgnav:  STRING is "PKGNAV"
	result_is_pkglim:  STRING is "PKGLIM"
	result_is_pckprv:  STRING is "PCKPRV"
	result_is_pkgqnl:  STRING is "PKGQNL"
	result_is_pkgqnt:  STRING is "PKGQNT"
	result_is_pkgrqd:  STRING is "PKGRQD"
	result_is_report:  STRING is "REPORT"
	result_is_reqqot:  STRING is "REQQOT";
	result_is_restek:  STRING is "RESTEK"
	result_is_rewnak:  STRING is "REWNAK"
	result_is_sndftp:  STRING is "SNDFTP"
	result_is_sndfrg:  STRING is "SNDFRG"
	result_is_stdfrm:  STRING is "STDFRM"
	result_is_swiqot:  STRING is "SWIQOT"
	result_is_tekqot:  STRING is "TEKQOT"
	result_is_tgtdie:  STRING is "TGTDIE"
	result_is_uchopt:  STRING is "UCHOPT"
	result_is_unkfab:  STRING is "UNKFAB"
	result_is_unkfid:  STRING is "UNKFID"
	result_is_unkfi2:  STRING is "UNKFI2"
	result_is_unkfmt:  STRING is "UNKFMT"
	result_is_unklam:  STRING is "UNKLAM"
	result_is_unkopt:  STRING is "UNKOPT"
	result_is_unkqot:  STRING is "UNKQOT"
	result_is_unktec:  STRING is "UNKTEC"
	result_is_unkxfm:  STRING is "UNKXFM"
	result_is_unpk2b:  STRING is "UNPK2B"
	result_is_updqot:  STRING is "UPDQOT"
	result_is_useqot:  STRING is "USEQOT"
	result_is_uudcod:  STRING is "UUDCOD"
	result_is_weesiz:  STRING is "WEESIZ"
	result_is_whrfrg:  STRING is "WHRFRG"

feature -- MESSAGE_IDs for adding to ic_fab_instance_messages (messag_is_xxx)
	--  (these are part of the reply_application)

	messag_is_addlyr: STRING =  "ADDLYR"
	messag_is_badsiz: STRING is "BADSIZ"
	messag_is_bigqot: STRING is "BIGQOT"
	messag_is_layxwt: STRING is "LAYXWT"
	messag_is_nofab:  STRING is "NO_FAB"
	messag_is_nolyrs: STRING is "NOLYRS"
	messag_is_nottny: STRING is "NOTTNY"
	messag_is_padinf: STRING is "PADINF"
	messag_is_padwrn: STRING is "PADWRN"
	messag_is_paderr: STRING is "PADERR"
	messag_is_padmet: STRING is "PADMET"
	messag_is_pkgnav: STRING is "PKGNAV"
	messag_is_resact: STRING is "RESACT"
	messag_is_rmvlyr: STRING =  "RMVLYR"
	messag_is_strnam: STRING is "STRNAM"
	messag_is_sizlrg: STRING is "SIZLRG"
	messag_is_unkcif: STRING is "UNKCIF"
	messag_is_unkgds: STRING is "UNKGDS"
	messag_is_wafmlx: STRING is "WAFMLX"

feature -- MESSAGE_IDs for project_status application (status_is_xxx)

	application_is_project_status: STRING is "PROJECT_STATUS"

	status_is_acctis:     STRING is "ACCTIS"
	status_is_acctpo:     STRING is "ACCTPO"
	status_is_andtax:     STRING is "ANDTAX"
	status_is_bddrqd:     STRING is "BDDRQD"
	status_is_bddwrn:     STRING is "BDDWRN"
	status_is_caterr:     STRING is "CATERR"
	status_is_catwrn:     STRING is "CATWRN"
	status_is_cbdrqd:     STRING is "CBDRQD"
	status_is_chgedu:     STRING is "CHGEDU"
	status_is_chkagr:     STRING is "CHKAGR"
	status_is_chkfnd:     STRING is "CHKFND"
	status_is_chkerr:     STRING is "CHKERR"
	status_is_chkwrn:     STRING is "CHKWRN"
	status_is_comppd:     STRING is "COMPPD"
	status_is_comppdi:    STRING is "COMPPDI"
	status_is_compsz:     STRING is "COMPSZ"
	status_is_dedshr:     STRING is "DEDSHR"
	status_is_dedsol:     STRING is "DEDSOL"
	status_is_defpkg:     STRING is "DEFPKG"
	status_is_dkvers:     STRING is "DKVERS"
	status_is_epiopt:     STRING is "EPIOPT"
	status_is_epiop2:     STRING is "EPIOP2"
	status_is_estlrg:     STRING is "ESTLRG"
	status_is_expoid:     STRING is "EXPOID"
	status_is_fabagr:     STRING is "FABAGR"
	status_is_fabbed:     STRING is "FABBED"
	status_is_fabfnd:     STRING is "FABFND"
	status_is_fabopt:     STRING is "FABOPT"
	status_is_fbdagr:     STRING is "FBDAGR"
	status_is_fbdfnd:     STRING is "FBDFND"
	status_is_fchrge:     STRING is "FCHRGE"
	status_is_fchrgs:     STRING is "FCHRGS"
	status_is_fidlst:     STRING is "FIDLST"
	status_is_fillok:     STRING is "FILLOK"
	status_is_format:     STRING is "FORMAT"
	status_is_foundry:    STRING is "FONDRY"
	status_is_ftpexp:     STRING is "FTPEXP"
	status_is_ftpinf:     STRING is "FTPINF"
	status_is_frginf:     STRING is "FRGINF"
	status_is_idispo:     STRING is "IDISPO"
	status_is_insfnd:     STRING is "INSFND"
	status_is_insres:     STRING is "INSRES"
	status_is_insedu:     STRING is "INSEDU"
	status_is_layers:     STRING is "LAYERS"
	status_is_lyrsdn:     STRING is "LYRSDN"
	status_is_lyrfat:     STRING is "LYRFAT"
	status_is_lyroky:     STRING is "LYROKY"
	status_is_lyrokn:     STRING is "LYROKN"
	status_is_lyrfxy:     STRING is "LYRFXY"
	status_is_lyrfxn:     STRING is "LYRFXN"
	status_is_lyrloy:     STRING is "LYRLOY"
	status_is_lyrlon:     STRING is "LYRLON"
	status_is_layout:     STRING is "LAYOUT"
	status_is_layxwt:     STRING is "LAYXWT"
	status_is_lowdns:     STRING is "LOWDNS"
	status_is_maxdsz:     STRING is "MAXDSZ"
	status_is_mchrge:     STRING is "MCHRGE"
	status_is_mchrgs:     STRING is "MCHRGS"
	result_is_mispkg,
	status_is_mispkg:     STRING is "MISPKG"
	status_is_netadd:     STRING is "NETADD"
	status_is_noagre:     STRING is "NOAGRE"
	status_is_noauth:     STRING is "NOAUTH"
	result_is_nodkvs,
	status_is_nodkvs:     STRING is "NODKVS"
	status_is_nonetadd:   STRING is "NONADD"
	status_is_nofab:      STRING is "NO_FAB"
	result_is_nopcnt,
	status_is_nopcnt:     STRING is "NOPCNT"
	status_is_nopoid:     STRING is "NOPOID"
	result_is_nosize,
	status_is_nosize:     STRING is "NOSIZE"
	result_is_notech,
	status_is_notech:     STRING is "NOTECH"
	status_is_notpkg:     STRING is "NOTPKG"
	status_is_noipkg:     STRING is "NOIPKG"
	status_is_nsains:     STRING is "NSAINS"
	status_is_oldfab:     STRING is "OLDFAB"
	status_is_phone :     STRING is "PHONE#"
	status_is_pidmis:     STRING is "PIDMIS"
	status_is_pidtek:     STRING is "PIDTEK"
	status_is_pidsiz:     STRING is "PIDSIZ"
	status_is_pkgrqd:     STRING is "PKGRQD"
	status_is_pmttrm:     STRING is "PMTTRM"
	status_is_pname :     STRING is "P_NAME"
	status_is_ponum :     STRING is "PO_NUM"
	status_is_prcqot:     STRING is "PRCQOT"
	status_is_prcqotmep:  STRING is "PRCQOTMEP"
	status_is_prcqottrf:  STRING is "PRCQOTTRF"
	status_is_prjoky:     STRING is "PRJOKY"
	status_is_prjokn:     STRING is "PRJOKN"
	status_is_prjfxy:     STRING is "PRJFXY"
	status_is_prjfxn:     STRING is "PRJFXN"
	status_is_prjloy:     STRING is "PRJLOY"
	status_is_prjlon:     STRING is "PRJLON"
	status_is_projid:     STRING is "PROJID"
	status_is_prpoid:     STRING is "PRPOID"
	status_is_qparts:     STRING is "QPARTS"
	status_is_qpkged:     STRING is "QPKGED"
	status_is_qbared:     STRING is "QBARED"
	status_is_queagr:     STRING is "QUEAGR"
	status_is_quefnd:     STRING is "QUEFND"
	status_is_quotid:     STRING is "QUOTID"
	status_is_reqval:     STRING is "REQVAL"
	status_is_restek:     STRING is "RESTEK"
	status_is_rundat:     STRING is "RUNDAT"
	status_is_rundat3:    STRING is "RUNDAT3"
	status_is_runhld:     STRING is "RUNHLD"
	status_is_runshp:     STRING is "RUNSHP"
	status_is_runsts:     STRING is "RUNSTS"
	status_is_routto:     STRING is "ROUTTO"
	status_is_shpgto:     STRING is "SHPGTO"
	status_is_skdcur:     STRING is "SKDCUR"
	status_is_skdlst:     STRING is "SKDLST"
	status_is_skdnon:     STRING is "SKDNON"
	status_is_skdnxt:     STRING is "SKDNXT"
	status_is_sphitm:     STRING is "SPHITM"
	status_is_tchrge:     STRING is "TCHRGE"
	status_is_tchrgs:     STRING is "TCHRGS"
	status_is_tgdiff:     STRING is "TGDIFF"
	status_is_tgnrms:     STRING is "TGNRMS"
	status_is_thkopt:     STRING is "THKOPT"
	status_is_tiny:       STRING is "ISTINY"
	status_is_topstr:     STRING is "TOPSTR"
	result_is_techn,
	status_is_techn:      STRING is "DESTEK"
	status_is_ukpoid:     STRING is "UKPOID"
	status_is_upndsz:     STRING is "UPNDSZ"
	status_is_wafmul:     STRING is "WAFMUL"
	status_is_waftek:     STRING is "WAFTEK"
	status_is_wtitar:     STRING is "WTITAR"
	status_is_xxpoid:     STRING is "XXPOID"
	status_is_xdocmis:    STRING is "XDOCMIS"
	status_is_xdocmisbxa: STRING is "XDOCMISBXA"
	status_is_xdocmisecc: STRING is "XDOCMISECC"
	status_is_xdocmisibm: STRING is "XDOCMISIBM"

end -- NFE_STRINGS
