
indexing
	
	description: "Object that can generate colors for an %
		%element of a reticle view according to whether the element %
		%is isolated and has a non default cut die size (cut die %
		%size determined by surrounding cuts is different from the %
		%cut die size determined by surrounding scribes)"
	author: "David Hollenberg"
	date: "December 8, 2006"

class NON_DEFAULT_CUT_DIE_SIZE_COLOR_GENERATOR
inherit
	RETICLE_VIEW_ELEMENT_COLOR_GENERATOR

create
	make

feature -- Access

	border_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Foreground color for border (usually a
			-- rectangle) of `an_element'
		do
			Result := standard_color (an_element)
		end
	
	label_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Foreground color for label
		do
			Result := standard_color (an_element)
		end
	
feature {NONE} -- Implementation

	standard_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Standard color for `an_element'
		do
			if not an_element.is_selectable then
				Result := palette.unselectable_color
			elseif an_element.has_non_default_cut_die_size then
				Result := palette.non_default_cut_die_size_color
			else
				Result := palette.no_validity_issues_color
			end
		end
	
end
