
indexing
	
	description: "A run closing step operation that notifies mask shop %
		%that files for a run have been transferred"
	author: "David Hollenberg"
	date: "May 26, 2004"

class NOTIFY_MASK_SHOP_OP
inherit
	RC_PRIMITIVE_STEP_OP
	RC_APPLICABLE_STEP
	NO_USER_INTERFACE
	NO_EXTERNAL_STATE

create
	make

feature -- Properties

	input_data_items: LIST [STRING]
			-- Data items required before step can be executed
		do
			Result := array_as_list (<<
					data_item.Mask_shop_transfer
				 >>)
		end

feature {NONE} -- Implementation

	do_step
			-- Execute step
		do
			if question ("Has the mask shop been notified that files have been sent or made available for retrieval?") then
			else
				abort
			end
			call_completion_actions
		end

	undo_step
			-- Undo execution of step
		do
			call_completion_actions
		end

	set_state
			-- Set `state'
		do
			state := Void
		end

end
