deferred class OBJECT_MODIFIER[G]
	-- generic "take an object
	--	and do something to it to fix it up if necessary""

feature
	modify(s: G): ?G is
		-- if modification is required, a NEW G is returned;
		--  otherwise, we return s itself
	require s /= Void
	do  if needs_modification(s)
	     then Result := make_modified_object(s)
	     else Result := s
	    end;
	ensure Result /= Void;
	end;

	needs_modification(s: G): BOOLEAN is
		-- determine whether or not s needs modification
	require s /= Void
	deferred
	end;

	make_modified_object(s: G): ?G is
		-- make a NEW G with the appropriate modifications
	require s /= Void
	deferred
	ensure Result /= Void; Result /= s
	end;

end -- OBJECT_MODIFIER
