
indexing
	
	author: "David Hollenberg"
	date:	"November 28, 1995"
	description: "Constants used by the Oracle Call Interface"
		
class OCI_CONSTANTS

feature -- Return codes in Logon Data Area or Cursor Data Area
	
	Oci_not_connected_code: INTEGER = 3114
	
	Oci_no_data_found_code: INTEGER = 1403
	
	Oci_fetched_col_null_code: INTEGER = 1405
	
	Oci_fetched_col_trunc_code: INTEGER = 1406
	
	Oci_invalid_rowid: INTEGER = 1410
	
	Oci_resource_busy_code: INTEGER = 54
	
	Oci_invalid_username_code: INTEGER = 1017
	
	Oci_no_default_username_code: INTEGER = 1004
	
	Oci_null_password_code: INTEGER = 1005
	
	Oci_invalid_select_item_code: INTEGER = 1007
	
	Oci_unique_constraint_code: INTEGER = 1
	
	Oci_no_hostdef_ext_code: INTEGER = 1041
			-- Code for "internal error. hostdef extension
			-- doesn't exist".  This is a bug in version 7.
			-- This code can be returned from a "close cursor"
			-- call if database connection has already been
			-- closed, but only in version 7.
	
feature -- Translation of OCI function codes
	
	name_for_oci_code (code: INTEGER): STRING
		do
			inspect code
			when Oexec_code then
				Result := "OEXEC or OEXN"
			when Odefin_code then
				Result := "ODEFIN"
			when Ofetch_code then
				Result := "OFETCH or OFEN"
			when Oopen_code then
				Result := "OOPEN"
			when Oclose_code then
				Result := "OCLOSE"
			when Obndrv_code then
				Result := "OBNDRV"
			when Obndrn_code then
				Result := "OBNDRN"
			when Oopt_code then
				Result := "OOPT"
			when Ocan_code then
				Result := "OCAN"
			when Oparse_code then
				Result := "OPARSE"
			when Oexfet_code then
				Result := "OEXFET"
			when Oflng_code then
				Result := "OFLNG"
			when Odescr_code then
				Result := "ODESCR"
			when Obndra_code then
				Result := "OBNDRA"
			when Obindps_code then
				Result := "OBINDPS"
			when Odefinps_code then
				Result := "ODEFINPS"
			when Ogetpi_code then
				Result := "OGETPI"
			when Osetpi_code then
				Result := "OSETPI"
			else
				Result := "unknown"
			end
		end
	
feature -- Translation of SQL function codes
	
	name_for_sql_code (code: INTEGER): STRING
		do
			inspect code
			when Unknown_operation_code then
				Result := "unknown"
			when Create_table_code then
				Result := "CREATE TABLE"
			when Set_role_code then
				Result := "SET ROLE"
			when Insert_code then
				Result := "INSERT"
			when Select_code then
				Result := "SELECT"
			when Update_code then
				Result := "UPDATE"
			when Drop_role_code then
				Result := "DROP ROLE"
			when Drop_view_code then
				Result := "DROP VIEW"
			when Drop_table_code then
				Result := "DROP TABLE"
			when Delete_code then
				Result := "DELETE"
			when Create_view_code then
				Result := "CREATE VIEW"
			when Drop_user_code then
				Result := "DROP USER"
			when Create_role_code then
				Result := "CREATE ROLE"
			when Create_sequence_code then
				Result := "CREATE SEQUENCE"
			when Alter_sequence_code then
				Result := "ALTER SEQUENCE"
			when Drop_sequence_code then
				Result := "DROP SEQUENCE"
			when Create_schema_code then
				Result := "CREATE SCHEMA"
			when Create_cluster_code then
				Result := "CREATE CLUSTER"
			when Create_user_code then
				Result := "CREATE USER"
			when Create_index_code then
				Result := "CREATE INDEX"
			when Drop_index_code then
				Result := "DROP INDEX"
			when Drop_cluster_code then
				Result := "DROP CLUSTER"
			when Validate_index_code then
				Result := "VALIDATE INDEX"
			when Create_procedure_code then
				Result := "CREATE PROCEDURE"
			when Alter_procedure_code then
				Result := "ALTER PROCEDURE"
			when Alter_table_code then
				Result := "ALTER TABLE"
			when Explain_code then
				Result := "EXPLAIN"
			when Grant_code then
				Result := "GRANT"
			when Revoke_code then
				Result := "REVOKE"
			when Create_synonym_code then
				Result := "CREATE SYNONYM"
			when Drop_synonym_code then
				Result := "DROP SYNONYM"
			when Alter_system_switch_log_code then
				Result := "ALTER SYSTEM SWITCH LOG"
			when Set_transaction_code then
				Result := "SET TRANSACTION"
			when Plsql_execute_code then
				Result := "PL/SQL EXECUTE"
			when Lock_table_code then
				Result := "LOCK TABLE"
			when Rename_code then
				Result := "RENAME"
			when Comment_code then
				Result := "COMMENT"
			when Audit_code then
				Result := "AUDIT"
			when Noaudit_code then
				Result := "NOAUDIT"
			when Alter_index_code then
				Result := "ALTER INDEX"
			when Create_database_link_code then
				Result := "CREATE DATABASE LINK"
			when Drop_database_link_code then
				Result := "DROP DATABASE LINK"
			when Create_database_code then
				Result := "CREATE DATABASE"
			when Alter_database_code then
				Result := "ALTER DATABASE"
			when Create_rollback_segment_code then
				Result := "CREATE ROLLBACK SEGMENT"
			when Alter_rollback_segment_code then
				Result := "ALTER ROLLBACK SEGMENT"
			when Drop_rollback_segment_code then
				Result := "DROP ROLLBACK SEGMENT"
			when Create_tablespace_code then
				Result := "CREATE TABLESPACE"
			when Alter_tablespace_code then
				Result := "ALTER TABLESPACE"
			when Drop_tablespace_code then
				Result := "DROP TABLESPACE"
			when Alter_session_code then
				Result := "ALTER SESSION"
			when Alter_user_code then
				Result := "ALTER USER"
			when Commit_code then
				Result := "COMMIT"
			when Rollback_code then
				Result := "ROLLBACK"
			when Savepoint_code then
				Result := "SAVEPOINT"
			when Create_control_file_code then
				Result := "CREATE CONTROL FILE"
			when Alter_tracing_code then
				Result := "ALTER TRACING"
			when Create_trigger_code then
				Result := "CREATE TRIGGER"
			when Alter_trigger_code then
				Result := "ALTER TRIGGER"
			when Drop_trigger_code then
				Result := "DROP TRIGGER"
			when Analyze_table_code then
				Result := "ANALYZE TABLE"
			when Analyze_index_code then
				Result := "ANALYZE INDEX"
			when Analyze_cluster_code then
				Result := "ANALYZE CLUSTER"
			when Create_profile_code then
				Result := "CREATE PROFILE"
			when Drop_profile_code then
				Result := "DROP PROFILE"
			when Alter_profile_code then
				Result := "ALTER PROFILE"
			when Drop_procedure_code then
				Result := "DROP PROCEDURE"
			when Alter_resource_cost_code then
				Result := "ALTER RESOURCE COST"
			when Create_snapshot_log_code then
				Result := "CREATE SNAPSHOT LOG"
			when Alter_snapshot_log_code then
				Result := "ALTER SNAPSHOT LOG"
			when Drop_snapshot_log_code then
				Result := "DROP SNAPSHOT LOG"
			when Create_snapshot_code then
				Result := "CREATE SNAPSHOT"
			when Alter_snapshot_code then
				Result := "ALTER SNAPSHOT"
			when Drop_snapshot_code then
				Result := "DROP SNAPSHOT"
			else
				Result := "unknown"
			end
		end
	
feature -- OCI function codes set in field of Cursor Data Area
	
	Oexec_code: INTEGER = 4
	
	Odefin_code: INTEGER = 8
	
	Ofetch_code: INTEGER = 12
	
	Oopen_code: INTEGER = 14
	
	Oclose_code: INTEGER = 16
	
	Obndrv_code: INTEGER = 28
	
	Obndrn_code: INTEGER = 30
	
	Oopt_code: INTEGER = 34
	
	Ocan_code: INTEGER = 52
	
	Oparse_code: INTEGER = 54
	
	Oexfet_code: INTEGER = 56
	
	Oflng_code: INTEGER = 58
	
	Odescr_code: INTEGER = 60
	
	Obndra_code: INTEGER = 62
	
	Obindps_code: INTEGER = 63
	
	Odefinps_code: INTEGER = 64
	
	Ogetpi_code: INTEGER = 65
	
	Osetpi_code: INTEGER = 66
	
feature -- OCI SQL function codes set in field of Cursor Data Area
	
	Unknown_operation_code: INTEGER = 0
	
	Create_table_code: INTEGER = 1
	
	Set_role_code: INTEGER = 2
	
	Insert_code: INTEGER = 3
	
	Select_code: INTEGER = 4
	
	Update_code: INTEGER = 5
	
	Drop_role_code: INTEGER = 6
	
	Drop_view_code: INTEGER = 7
	
	Drop_table_code: INTEGER = 8
	
	Delete_code: INTEGER = 9
	
	Create_view_code: INTEGER = 10
	
	Drop_user_code: INTEGER = 11
	
	Create_role_code: INTEGER = 12
	
	Create_sequence_code: INTEGER = 13
	
	Alter_sequence_code: INTEGER = 14
	
	Drop_sequence_code: INTEGER = 16
	
	Create_schema_code: INTEGER = 17
	
	Create_cluster_code: INTEGER = 18
	
	Create_user_code: INTEGER = 19
	
	Create_index_code: INTEGER = 20
	
	Drop_index_code: INTEGER = 21
	
	Drop_cluster_code: INTEGER = 22
	
	Validate_index_code: INTEGER = 23
	
	Create_procedure_code: INTEGER = 24
	
	Alter_procedure_code: INTEGER = 25
	
	Alter_table_code: INTEGER = 26
	
	Explain_code: INTEGER = 27
	
	Grant_code: INTEGER = 28
	
	Revoke_code: INTEGER = 29
	
	Create_synonym_code: INTEGER = 30
	
	Drop_synonym_code: INTEGER = 31
	
	Alter_system_switch_log_code: INTEGER = 32
	
	Set_transaction_code: INTEGER = 33
	
	Plsql_execute_code: INTEGER = 34
	
	Lock_table_code: INTEGER = 35
	
	Rename_code: INTEGER = 37
	
	Comment_code: INTEGER = 38
	
	Audit_code: INTEGER = 39
	
	Noaudit_code: INTEGER = 40
	
	Alter_index_code: INTEGER = 41
	
	Create_database_link_code: INTEGER = 42
	
	Drop_database_link_code: INTEGER = 43
	
	Create_database_code: INTEGER = 44
	
	Alter_database_code: INTEGER = 45
	
	Create_rollback_segment_code: INTEGER = 46
	
	Alter_rollback_segment_code: INTEGER = 47
	
	Drop_rollback_segment_code: INTEGER = 48
	
	Create_tablespace_code: INTEGER = 49
	
	Alter_tablespace_code: INTEGER = 50
	
	Drop_tablespace_code: INTEGER = 51
	
	Alter_session_code: INTEGER = 52
	
	Alter_user_code: INTEGER = 53
	
	Commit_code: INTEGER = 54
	
	Rollback_code: INTEGER = 55
	
	Savepoint_code: INTEGER = 56
	
	Create_control_file_code: INTEGER = 57
	
	Alter_tracing_code: INTEGER = 58
	
	Create_trigger_code: INTEGER = 59
	
	Alter_trigger_code: INTEGER = 60
	
	Drop_trigger_code: INTEGER = 61
	
	Analyze_table_code: INTEGER = 62
	
	Analyze_index_code: INTEGER = 63
	
	Analyze_cluster_code: INTEGER = 64
	
	Create_profile_code: INTEGER = 65
	
	Drop_profile_code: INTEGER = 66
	
	Alter_profile_code: INTEGER = 67
	
	Drop_procedure_code: INTEGER = 68
	
	Alter_resource_cost_code: INTEGER = 70
	
	Create_snapshot_log_code: INTEGER = 71
	
	Alter_snapshot_log_code: INTEGER = 72
	
	Drop_snapshot_log_code: INTEGER = 73
	
	Create_snapshot_code: INTEGER = 74
	
	Alter_snapshot_code: INTEGER = 75
	
	Drop_snapshot_code: INTEGER = 76
	
end
