
indexing
	
	author: "David Hollenberg"
	date:	"November 30, 1995"
	description: "Possible states of an Oracle cursor"

class ORACLE_CURSOR_STATES

feature -- States

	Cursor_closed: INTEGER = 1
			-- State indicating cursor is not open

	Cursor_open: INTEGER = 2
			-- State indicating cursor is open but not parsed

	Cursor_parsed: INTEGER = 3
			-- State indicating cursor is open and parsed

	Cursor_reserved: INTEGER = 4
			-- State indicating cursor is open, parsed and
			-- reserved by program (in use)

feature -- Validity checking

	is_valid_state (s: INTEGER): BOOLEAN
			-- Is `s' a valid state for an Oracle cursor?
		do
			Result := s >= Cursor_closed and s <= Cursor_reserved
		end

	text_for_state (s: INTEGER): STRING
			-- Text description of state `s'
		require
			valid_state: is_valid_state (s)
		do
			inspect s
			when Cursor_closed then
				Result := "closed"
			when Cursor_open then
				Result := "open"
			when Cursor_parsed then
				Result := "parsed"
			when Cursor_reserved then
				Result := "reserved"
			else
				Result := "unknown"
			end
		end

end
