
indexing
	
	author: "David Hollenberg"
	date:	"November 22, 1995"
	description: "An Oracle Host Data Area (HDA)"

class ORACLE_HDA

inherit
	ANY
	C_MEMORY_ALLOCATION
		export
			{NONE} all
		end

feature {NONE} -- Creation

	make
		do
			address := allocate_nongc_memory (length)
			set_nongc_memory (address, '%U', length)
				-- Clear memory since Oracle documents
				-- claim it must by zeroed initially,
				-- though it seems hard to believe since
				-- they could zero it themselves at login
		end
			
feature -- Properties

	address: POINTER
			-- Address of Host Data Area


feature {NONE} -- Implementation
	
	length: INTEGER
			-- Length of Host Data Area in bytes
		external
			"C macro use %"oracle.h%""
		alias
			"hda_length"
		end

invariant
	address_exists: address /= default_pointer

end
