
indexing
	
	author: "David Hollenberg"
	date:	"November 22, 1995"
	description: "An Oracle Logon Data Area (LDA)"

class ORACLE_LDA

inherit
	ANY
	C_MEMORY_ALLOCATION
		export
			{NONE} all
		end
	ORACLE_EXTERNALS
		export
			{NONE} all
		end

feature {NONE} -- Creation

	make
		do
			address := allocate_nongc_memory (length)
			set_nongc_memory (address, '%U', length)
				-- Clear memory to be sure
			add_oracle_lda (address)
		end
			
feature -- Properties

	address: POINTER
			-- Address of start of Logon Data Area

	return_code: INTEGER
			-- Return code from last operation
		do
			Result := lda_retcode (address)
		end
	
	os_error_code: INTEGER
			-- OS-dependent error code
		do
			Result := lda_osd_error_code (address)
		end
	

feature {NONE}	-- Externals

	length: INTEGER
			-- Length in bytes
		external
			"C macro use %"oracle.h%""
		alias
			"lda_length"
		end

	lda_retcode (lda_address: POINTER): INTEGER
			-- Return code for LDA at address `lda_address'
		external
			"C macro use %"oracle.h%""
		end

	lda_osd_error_code (lda_address: POINTER): INTEGER
			-- OS-dependent error code for LDA at address
			-- `lda_address'
		external
			"C macro use %"oracle.h%""
		end
	
invariant
	address_exists: address /= default_pointer

end
