
indexing
	
	author: "David Hollenberg"
	date:	"December 5, 1995"
	description: "An Oracle numeric placeholder (e.g., :1)"

class ORACLE_NUMERIC_PLACEHOLDER

inherit
	ORACLE_PLACEHOLDER
		export
			{ANY} is_valid_placeholder_number
		redefine
			length
		end

create
	set_address

feature -- Properties

	number: INTEGER
			-- Placeholder number (e.g., 3 for :3)
		do
			Result := ph_number (address)
		ensure
			valid_placeholder_number: is_valid_placeholder_number (Result)
		end
	
	display_name: STRING
			-- Name for display purposes
		do
			create Result.make (3)
			Result.append_character (':')
			Result.append_integer (number)
		end

	max_display_name_length: INTEGER = 4
			-- Maximum length of display name

feature -- Modification

	set_number (num: INTEGER)
			-- Set placeholder number to `num'
		require
			valid_placeholder_number: is_valid_placeholder_number (num)
		do
			ph_set_number (address, num)
		ensure
			correct_number: number = num
		end
	
	do_oci_bind (c: ORACLE_CURSOR): INTEGER
			-- Bind `Current' via the appropriate Oracle Call
			-- Interface routine using  `c' as the cursor.
			-- Return the return code from this routine.
		do
			c.enter_oci
			Result := ora_bind_placeholder_number (c.address,
				number, data_address, data_length,
				external_datatype, std_null_indicator_address)
			c.leave_oci
		end
	
feature {NONE}	-- Externals

	length: INTEGER
			-- Length in bytes
		external
			"C macro use %"oracle.h%""
		alias
			"phn_length"
		end

end
