
indexing
	
	author: "David Hollenberg"
	date:	"February 5, 1996"
	description: "Types of Oracle SQL statements"

class ORACLE_STATEMENT_TYPES

feature -- Statement types
	
	Unknown_statement: INTEGER = 0
			-- Code for unknown type of statement

	Query_statement: INTEGER = 1
			-- Code for query (select)
	Dml_statement: INTEGER = 2
			-- Code for Data Manipulation Language statement
			-- which is not a query

	Ddl_statement: INTEGER = 3
			-- Code for Data Definition Language statement

	Block_statement: INTEGER = 4
			-- Code for PL/SQL block

	Illegal_statement: INTEGER = 5
			-- Code for illegal type of statement

feature -- Validity
	
	valid_statement_type (type: INTEGER): BOOLEAN
			-- Is `type' a valid Oracle SQL statement type?
		do
			Result := type >= Unknown_statement and type <= Illegal_statement
		end
	
feature -- Translation
	
	statement_type_string (type: INTEGER): STRING
			-- `type' as a string
		require
			valid_statement_type: valid_statement_type (type)
		do
			inspect type
			when Query_statement then
				Result := "query"
			when Dml_statement then
				Result := "DML statement"
			when Ddl_statement then
				Result := "DDL statement"
			when Block_statement then
				Result := "PL/SQL block"
			when Illegal_statement then
				Result := "illegal statement"
			when Unknown_statement then
				Result := "unknown type"
			end
		end
	
end
