
indexing

	author: "David Hollenberg"
	date: "March 1, 2007"

class ORG_NAMEXORG_TYPES_ROW
inherit
	ORG_NAMEXORG_TYPES_RAW
	ROW_COUNT_CHECK_ACCESS
create
	make_template, make_null

feature -- Properties

	is_not_org_no (n: INTEGER): BOOLEAN is
			-- Does this organization not have org_no `n'?
		do
			Result := org_no /= n
		end

feature -- Collections

	rows_for_org_type (ot: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current] is
			-- All rows for org type `lt', ordered by short ID
		require
			ot_exists: ot /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_S
		do
			create b.make (ot)
			Result := all_rows_filtered_ordered (conn, "org_type = :1", b, "short_id")
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

end
