
indexing
	
	description: "Map that shows organizations and sponsors"
	author: "David Hollenberg"
	date: "January 21, 2005"

class ORGANIZATIONS_MAP
inherit
	FIELDS_OF_VIEW_MAP
		redefine
			primary_description
		end
create
	make

feature -- Properties

	title: STRING = "Sponsors and Organizations"
			-- Title to include on map
	
	wafer_techn_organization: ORGANIZATIONS_ROW
			-- Organization associated with wafer techn for run

feature -- Modification

	set_wafer_techn_organization (o: like wafer_techn_organization)
			-- Set `wafer_techn_organization' to `o'
		require
			org_not_void: o /= Void
		do
			wafer_techn_organization := o
		ensure
			org_set: wafer_techn_organization = o
		end

feature {NONE} -- Implementation

	primary_description (loc: DIE_LOCATIONS_EROW): STRING
			-- Primary description of `loc' to display on map
		do
			Result := loc.sponsor_for_map
		end

	secondary_description (loc: DIE_LOCATIONS_EROW): STRING
			-- Secondary description of `loc' to display on map
		do
			if loc.is_vendor_geometry or loc.is_vendor_ghost then
				Result := wafer_techn_organization.short_id
			else
				Result := loc.org_short_id_for_map
			end
		end

end
