
indexing

	author: "Generated"
	date: "Wed Jun 18 12:57:24 PDT 2003"

class ORGANIZATIONS_ROW
inherit
	ORGANIZATIONS_RAW
	ROW_COUNT_CHECK_ACCESS
create
	make_template, make_null, make_by_key

feature -- Properties

	rows_with_org_no (n: INTEGER conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current] is
			-- All rows with `org_no' as organization number
		require
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_I
		do
			create b.make (n)
			Result := all_rows_filtered (conn, "org_no = :1", b)
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

	rows_with_short_id (s: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current] is
			-- All rows with `s' as short id
		require
			short_id_exists: s /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_S
		do
			create b.make (s)
			Result := all_rows_filtered (conn, "short_id = :1", b)
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

	packaging_vendor_rows (conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current] is
			-- All rows for organizations that are package
			-- vendors (or bump vendors or test vendors),
			-- ordered by short_id
		require
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_SSS
			type: ORG_TYPE_VALUES
		do
			create b.make (type.Pkg_vendor, type.Bump_vendor, type.Test_vendor)
			Result := all_rows_filtered_ordered (conn, "org_no in (select org_no from org#org_types where org_type in (:1, :2, :3))", b, "short_id")
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

end
