
indexing
	
	description: "Object that can generate colors for an %
		%element of a reticle view according to its overhead style"
	author: "David Hollenberg"
	date: "April 16, 2009"

class OVERHEAD_STYLE_COLOR_GENERATOR
inherit
	RETICLE_VIEW_ELEMENT_COLOR_GENERATOR

create
	make

feature  -- Access

	border_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Foreground color for border (usually a
			-- rectangle) of `an_element'
		do
			Result := standard_color (an_element)
		end
	
	label_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Foreground color for label
		do
			Result := standard_color (an_element)
		end
	
feature {NONE} -- Implementation

	standard_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Standard color for `an_element', based on
			-- its overhead style
		local
			elem_style: STRING
			style: OVERHEAD_STYLE_VALUES
		do
			elem_style := an_element.effective_overhead_style
			if not an_element.is_selectable then
				Result := palette.unselectable_color
			elseif elem_style.is_equal (style.External_) then
				Result := palette.external_overhead_color
			elseif elem_style.is_equal (style.Internal) then
				Result := palette.internal_overhead_color
			elseif elem_style.is_equal (style.None) then
				Result := palette.none_overhead_color
			else
				Result := palette.no_overhead_color
			end
		end
	
end
