
indexing
	
	description: "Object that can generate colors for an %
		%element of a reticle view according to the type of packaging %
		%it requires"
	author: "David Hollenberg"
	date: "December 8, 2006"

class PACKAGING_COLOR_GENERATOR
inherit
	RETICLE_VIEW_ELEMENT_COLOR_GENERATOR

create
	make

feature -- Access

	border_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Foreground color for border (usually a
			-- rectangle) of `an_element'
		do
			Result := standard_color (an_element)
		end
	
	label_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Foreground color for label
		do
			Result := standard_color (an_element)
		end
	
feature {NONE} -- Implementation

	standard_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Standard color for `an_element', based on
			-- type of packaging it requires
		local
			has_ceramic, has_plastic: BOOLEAN
		do
			if not an_element.is_selectable then
				Result := palette.unselectable_color
			else
				has_ceramic := an_element.has_ceramic_packaging
				has_plastic := an_element.has_plastic_packaging
				if has_ceramic and has_plastic then
					Result := palette.ceramic_and_plastic_packaging_color
				elseif has_ceramic then
					Result := palette.ceramic_packaging_color
				elseif has_plastic then
					Result := palette.plastic_packaging_color
				else
					Result := palette.no_packaging_color
				end
			end
		end
	
end
