
indexing
	
	description: "Die location of packer box as used in ICL"
	author: "David Hollenberg"
	date: "January 26, 2006"

class PACKER_DIE_LOCATION

feature -- Properties

	field_name: STRING
			-- Name of field in which die is to be placed

	location: CONST_POINT
			-- Location of center of die relative to
			-- center of field

	mask_site_no: INTEGER
			-- Site number assigned to this die instance on the mask

	section_number: INTEGER
			-- Number of the section this copy of the die is in,
			-- if any, for a full wafer packing only

	is_new: BOOLEAN
			-- Is project new (no CATS command file/overhead
			-- file/CIF file if needed) yet?
			-- Used only if `label_individual_sites' is true

	chip_number: INTEGER
			-- Number to use in CHIP commands for mask
			-- levels for this location of die

feature -- Modification

	set_field_name (s: STRING)
			-- Set `field_name' to `s'
		require
			value_exists: s /= Void
		do
			field_name := s
		ensure
			value_set: field_name = s
		end

	set_location (p: CONST_POINT)
			-- Set `location' to `p'
		do
			location := p
		ensure
			value_set: location = p
		end

	set_mask_site_no (n: INTEGER)
			-- Set `mask_site_no' to `n'
		do
			mask_site_no := n
		ensure
			value_set: mask_site_no = n
		end

	set_section_number (n: INTEGER)
			-- Set `section_number' to `n'
		do
			section_number := n
		ensure
			value_set: section_number = n
		end

	set_is_new (b: BOOLEAN)
			-- Set `is_new' to `b'
		do
			is_new := b
		ensure
			value_set: is_new = b
		end

	set_chip_number (n: INTEGER)
			-- Set `chip_number' to `n'
		do
			chip_number := n
		ensure
			value_set: chip_number = n
		end

end

