
indexing
	
	description: "Utility routines related to packing"
	author: "David Hollenberg"
	date: "October 30, 2006"

class PACKER_UTILITIES
	
feature -- Utilities

	set_clipped_rectangle_from_values (a_rectangle: EV_RECTANGLE a_max_coordinate: INTEGER_64 a_x, a_y, a_width, a_height: INTEGER_64)
			-- Set X and Y coordinates of upper left of
			-- `a_rectangle' and its width and height from
			-- `a_x', `a_y', `a_width' and `a_height',
			-- after first intersecting the INTEGER_64 rectangle
			-- with rectangle whose corners are
			-- (-`a_max_coordinate', -`a_max_coordinate') to
			-- (`a_max_coordinate', `a_max_coordinate') to
		require
			a_rectangle_not_void: a_rectangle /= Void
			a_max_coordinate_positive: a_max_coordinate > 0
			a_max_coordinate_small_enough: 2 * a_max_coordinate <= {INTEGER}.Max_value
		local
			left_x, right_x, top_y, bottom_y: INTEGER_64
		do
			left_x := a_x
			right_x := a_x + a_width
			top_y := a_y
			bottom_y := a_y + a_height

			left_x := left_x.max (-a_max_coordinate).min (a_max_coordinate)
			right_x := right_x.max (-a_max_coordinate).min (a_max_coordinate)
			top_y := top_y.max (-a_max_coordinate).min (a_max_coordinate)
			bottom_y := bottom_y.max (-a_max_coordinate).min (a_max_coordinate)
			
			a_rectangle.move_and_resize (left_x.as_integer_32, top_y.as_integer_32, (right_x - left_x).max (1).as_integer_32, (bottom_y - top_y).max (1).as_integer_32)
		end

	Maximum_view_coordinate: INTEGER_64 = 1_000_000_000

	Infinity: DOUBLE = 1.0E100

end
