
indexing

	author: "David Hollenberg"

class PACKING_CUT_LOCATIONS_MROW
inherit
	PACKING_CUT_LOCATIONS_MRAW
		redefine
			detached_twin, copy_from_row
		end
	PACKING_CUT_LOCATIONS_ROW
		undefine
			initialize_new,
			initialize_new_by_key
		end
	DB_DETACHABLE_ROW
		export
			{PACKING_CUT_LOCATIONS_MROW} detach_actions_internal
		redefine
			detached_twin, copy_from_row
		end

create
	make_template, make_null, make_by_key, make_detached

feature -- Properties

	detached_twin: like Current is
			-- New object that is the same as `Current' but
			-- is detached from any database connection
		do
			Result := precursor {PACKING_CUT_LOCATIONS_MRAW}
			call_detach_actions (Result)
		end

	deep_detached_twin: like Current is
			-- Detached copy of `Current' with all
			-- dependent rows detached as well
		do
			Result := detached_twin
		end

	is_deep_unchanged: BOOLEAN is
			-- Are `Current' and all its dependent rows
			-- unchanged from their original versions?
			-- Returns False if no original version
		do
			Result := all_columns_equal_original
		end

feature -- Row copy

	copy_from_row (r: like original_row) is
			-- Initialize `Current' from `r'
		do
			precursor {PACKING_CUT_LOCATIONS_MRAW} (r)
			detach_actions_internal := r.detach_actions_internal
		end

feature -- Operations
	
	update_for_new_version (n: INTEGER) is
			-- Update `Current' with information for new
			-- version `n'
		do
			set_version_no (n)
		end

	register_deep is
			-- Register `Current' and all dependent rows
			-- on implicit connection
		do
			register_on_implicit_connection
		end

end
