
indexing

	date: "Wed Jun 27 14:03:22 2007"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user DHOLLEN"
	database_tables: 
		"PACKING_CUT_PATTERNS (MOSIS.PACKING_CUT_PATTERNS)"
			-- Included columns
			-- 	CUT_PATTERN_NO
			-- 	FIELD_NAME
			-- 	IS_COMPLETED
			-- 	PACKING_ID
			-- 	QUANTITY_WAFERS_NEEDED
			-- 	VERSION_NO
			-- 	WAFER_ETEST_NAME
			-- Excluded columns
			-- 	(none)

class PACKING_CUT_PATTERNS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_packing_id: STRING; the_version_no: INTEGER; the_cut_pattern_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_packing_id_exists: the_packing_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			packing_id := the_packing_id
			version_no := the_version_no
			cut_pattern_no := the_cut_pattern_no
			is_null_packing_id := False
			is_null_version_no := False
			is_null_cut_pattern_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 7

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  cut_pattern_no, field_name, is_completed, packing_id,%N  quantity_wafers_needed, version_no, wafer_etest_name"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "packing_cut_patterns pckcp"

	join_condition: STRING = ""

	table_name: STRING = "packing_cut_patterns"

	key_where_clause: STRING = "packing_id = :1 and version_no = :2 and cut_pattern_no = :3"

feature -- Values

	cut_pattern_no: INTEGER
			-- DB: NUMBER(2,0) not null

	field_name: STRING
			-- DB: VARCHAR2(20) not null

	is_completed: BOOLEAN
			-- DB: CHAR(1) not null

	packing_id: STRING
			-- DB: VARCHAR2(30) not null

	quantity_wafers_needed: INTEGER
			-- DB: NUMBER(6,0)

	version_no: INTEGER
			-- DB: NUMBER(4,0) not null

	wafer_etest_name: STRING
			-- DB: VARCHAR2(50)

feature -- Maximum database lengths for character columns

	maxlen_field_name: INTEGER = 20
	maxlen_packing_id: INTEGER = 30
	maxlen_wafer_etest_name: INTEGER = 50

feature -- Precisions for number columns

	precision_cut_pattern_no: INTEGER = 2
	precision_quantity_wafers_needed: INTEGER = 6
	precision_version_no: INTEGER = 4

feature -- Scales for number columns

	scale_cut_pattern_no: INTEGER = 0
	scale_quantity_wafers_needed: INTEGER = 0
	scale_version_no: INTEGER = 0

feature -- Nullness for null allowed columns

	is_null_quantity_wafers_needed: BOOLEAN
	is_null_wafer_etest_name: BOOLEAN

feature -- Nullness for non-null columns

	is_null_cut_pattern_no: BOOLEAN
	is_null_field_name: BOOLEAN
	is_null_is_completed: BOOLEAN
	is_null_packing_id: BOOLEAN
	is_null_version_no: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and cut_pattern_no = r.cut_pattern_no
				and version_no = r.version_no
			Result := Result
				and equal (packing_id, r.packing_id)
			Result := Result
				and is_null_cut_pattern_no = r.is_null_cut_pattern_no
				and is_null_packing_id = r.is_null_packing_id
				and is_null_version_no = r.is_null_version_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and is_completed = r.is_completed
				and quantity_wafers_needed = r.quantity_wafers_needed
			Result := Result
				and equal (field_name, r.field_name)
				and equal (wafer_etest_name, r.wafer_etest_name)
			Result := Result
				and is_null_field_name = r.is_null_field_name
				and is_null_is_completed = r.is_null_is_completed
				and is_null_quantity_wafers_needed = r.is_null_quantity_wafers_needed
				and is_null_wafer_etest_name = r.is_null_wafer_etest_name
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_integer (1)
			q.select_string (2, 20)
			q.select_boolean (3)
			q.select_string (4, 30)
			q.select_integer (5)
			q.select_integer (6)
			q.select_string (7, 50)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			cut_pattern_no := q.integer_value (1)
			is_completed := q.boolean_value (3)
			quantity_wafers_needed := q.integer_value (5)
			version_no := q.integer_value (6)
		end

	fill_in_references (q: SQL_QUERY)
		do
			field_name := q.string_value (2)
			packing_id := q.string_value (4)
			wafer_etest_name := q.string_value (7)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (2, field_name)
			q.get_string_value (4, packing_id)
			q.get_string_value (7, wafer_etest_name)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_cut_pattern_no := q.is_null (1)
			is_null_field_name := q.is_null (2)
			is_null_is_completed := q.is_null (3)
			is_null_packing_id := q.is_null (4)
			is_null_quantity_wafers_needed := q.is_null (5)
			is_null_version_no := q.is_null (6)
			is_null_wafer_etest_name := q.is_null (7)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_packing_id := True
			is_null_version_no := True
			is_null_cut_pattern_no := True
			create packing_id.make (0)
		end

	set_null_nonkey
		do
			is_null_field_name := True
			is_null_is_completed := True
			is_null_quantity_wafers_needed := True
			is_null_wafer_etest_name := True
			create field_name.make (0)
			create wafer_etest_name.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, packing_id, False)
			q.bind_num_to_integer (2, version_no, False)
			q.bind_num_to_integer (3, cut_pattern_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and cut_pattern_no = q.integer_value (1)
				and is_completed = q.boolean_value (3)
				and quantity_wafers_needed = q.integer_value (5)
				and version_no = q.integer_value (6)
			q.get_string_value (2, s)
			Result := Result and equal (field_name, s)
			q.get_string_value (4, s)
			Result := Result and equal (packing_id, s)
			q.get_string_value (7, s)
			Result := Result and equal (wafer_etest_name, s)
			Result := Result
				and is_null_cut_pattern_no = q.is_null (1)
				and is_null_field_name = q.is_null (2)
				and is_null_is_completed = q.is_null (3)
				and is_null_packing_id = q.is_null (4)
				and is_null_quantity_wafers_needed = q.is_null (5)
				and is_null_version_no = q.is_null (6)
				and is_null_wafer_etest_name = q.is_null (7)
		end

end
