
indexing

	author: "David Hollenberg"
	date: "October 18, 2006"

class PACKING_ETEST_COLORS_ROW

inherit
	PACKING_ETEST_COLORS_RAW
	PACKING_QUERIES
	ROW_COUNT_CHECK_ACCESS
		export
			{NONE} all
		end
	DB_OPTIONS_ACCESS
		export
			{NONE} all
		end

create
	make_template, make_null, make_by_key

feature -- Collections

	rows_for_packing_id (a_packing_id: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current] is
			-- All rows for `a_packing_id'
		require
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_S
		do
			create b.make (a_packing_id)
			Result := all_rows_filtered (conn, "packing_id = :1", b)
			check_row_count (Result, range)
		end

feature -- Properties

	to_ev_color: EV_COLOR is
		local
			row: NAMED_COLORS_ROW
		do
			if is_null_color_name then
				create Result.make_with_rgb (red_value, green_value, blue_value)
			else
				create row.make_by_key (any_connection, option.Old_row, color_name)
				create Result.make_with_rgb (row.red_value, row.green_value, row.blue_value)
			end
		end

	wafer_etest_id: STRING is
			-- Wafer etest ID for `wafer_etest_name'
		do  
			Result := etest_name.wafer_etest_id
		ensure
			result_not_void: Result /= Void
		end;

	etest_name: WAFER_ETEST_NAMES_ROW is
			-- Row for `wafer_etest_name'
		do  
			if not is_cached_etest_name then 
	     			create cached_etest_name.make_by_key (any_connection, option.Old_row, wafer_etest_name)
	    		end
	    		Result := cached_etest_name
		ensure
			result_not_void: Result /= Void
		end;

	uncache_etest_name is
			-- Uncache `etest_name' for `Current'
		do  
			cached_etest_name := Void
		ensure
			etest_name_not_cached: not is_cached_etest_name
		end;

	is_cached_etest_name: BOOLEAN is
			-- Is etest name cached?
		do  
			Result := cached_etest_name /= Void
		end;

feature {NONE} -- Implementation
	
	cached_etest_name: like etest_name
			-- Row for `wafer_etest_name', cached in memory

end
