
indexing
	
	description: "Multi-column list row that has additional information %
		%about the entity it represents that uniquely identifies %
		%the entity and associates it with packing"
	author: "David Hollenberg"
	date: "November 10, 2005"

class PACKING_MULTI_COLUMN_LIST_ROW
inherit	
	MULTI_COLUMN_LIST_ROW
		rename
			make as mcl_make
		end
	HAS_PACKING_ID
		undefine
			copy, is_equal, default_create
		end
	HAS_CREATOR
		undefine
			copy, is_equal, default_create
		end
	HAS_DATE_CREATED
		undefine
			copy, is_equal, default_create
		end
	HAS_RUN_TYPE
		undefine
			copy, is_equal, default_create
		end
	HAS_WAFER_TECHN
		undefine
			copy, is_equal, default_create
		end
	HAS_FIELD_SET
		undefine
			copy, is_equal, default_create
		end
	HAS_RUN_ID
		undefine
			copy, is_equal, default_create
		end
	DB_OPTIONS_ACCESS
		export
			{NONE} all
		undefine
			copy, is_equal, default_create
		end
	STRING_UTILITIES_ACCESS
		export
			{NONE} all
		undefine
			copy, is_equal, default_create
		end

create
	make

create {PACKING_MULTI_COLUMN_LIST_ROW}
	make_filled

feature {NONE} -- Creation

	make (p: PACKINGS_ROW)
		require
			p_not_void: p /= Void
		do
			default_create
			packing := p
			enable_visible
		ensure
			is_visible: is_visible
		end

feature -- Properties

	packing: PACKINGS_ROW
			-- Packing this row is for

	packing_id: STRING
			-- Packing id
		do
			Result := packing.packing_id
		end

	creator: STRING
			-- Creator
		do
			Result := packing.creator
		end

	date_created: DB_DATE
			-- Date packing created
		do
			Result := packing.date_created
		end

	run_type: STRING
			-- Run type
		do
			Result := packing.run_type
		end

	wafer_techn: STRING
			-- Wafer technology
		do
			Result := packing.wafer_techn
		end

	field_set: STRING
			-- Field set name
		do
			Result := packing.field_set_name
		end

	run_id: STRING
			-- Run ID
		do
			Result := packing.intended_run
		end

	unique_identifier: STRING
			-- Value that uniquely identifies row
		do
			Result := packing_id
		end

	has_packing_id: BOOLEAN = True
			-- Is there an associated packing ID?

	has_creator: BOOLEAN = True
			-- Is there an associated creator?

	has_date_created: BOOLEAN = True
			-- Is there an associated date created?

	has_run_type: BOOLEAN = True
			-- Is there an associated run type?

	has_wafer_techn: BOOLEAN = True
			-- Is there an associated wafer techn?

	has_field_set: BOOLEAN = True
			-- Is there an associated field set?

	has_run_id: BOOLEAN
			-- Is there an intended run set?
		do
			Result := not packing.is_null_intended_run
		end

feature {NONE} -- Implementation

	new_filled_list (n: INTEGER): like Current
			-- New list with `n' elements.
		do
			create Result.make_filled (n)
		end
		
end
