
indexing
	
	description: "Multi-column list row that has additional information %
		%about the entity it represents that uniquely identifies %
		%the entity and associates it with a packing project"
	author: "David Hollenberg"
	date: "November 10, 2005"

class PACKING_PROJ_MULTI_COLUMN_LIST_ROW
inherit	
	MULTI_COLUMN_LIST_ROW
		rename
			make as mcl_make
		end
	HAS_PACKING_ID
		undefine
			copy, is_equal, default_create
		end
	HAS_PROJECT_NUMBER
		rename
			has_project_number as has_project_no,
			project_number as project_no
		undefine
			copy, is_equal, default_create
		end
	HAS_VERSION_NUMBER
		rename
			has_version_number as has_version_no,
			version_number as version_no
		undefine
			copy, is_equal, default_create
		end
	HAS_FAB_INSTANCE_TYPE
		undefine
			copy, is_equal, default_create
		end
	HAS_DATE_SELECTED
		undefine
			copy, is_equal, default_create
		end
	HAS_DATE_SYNCHRONIZED
		undefine
			copy, is_equal, default_create
		end
	HAS_DESIGN_NUMBER
		rename
			has_design_number as has_design_no,
			design_number as design_no
		undefine
			copy, is_equal, default_create
		end
	HAS_RUN_ID
		rename
			has_run_id as has_assigned_run_id,
			run_id as assigned_run_id
		undefine
			copy, is_equal, default_create
		end
	HAS_RUN_TYPE
		rename
			has_run_type as has_run_type_requested,
			run_type as run_type_requested
		undefine
			copy, is_equal, default_create
		end
	HAS_EXPORT_CONTROL_TYPE
		undefine
			copy, is_equal, default_create
		end
	HAS_DATE_FAB_REQUESTED
		undefine
			copy, is_equal, default_create
		end
	HAS_RUN_DATE_REQUESTED
		undefine
			copy, is_equal, default_create
		end
	HAS_DESIGN_NAME
		undefine
			copy, is_equal, default_create
		end
	HAS_OVERHEAD_STYLE
		undefine
			copy, is_equal, default_create
		end
	HAS_SIZE_X
		rename
			size_x as design_size_x,
			size_x_string as design_size_x_string,
			has_size_x as has_design_size_x
		undefine
			copy, is_equal, default_create
		end
	HAS_SIZE_Y
		rename
			size_y as design_size_y,
			size_y_string as design_size_y_string,
			has_size_y as has_design_size_y
		undefine
			copy, is_equal, default_create
		end
	HAS_MAX_SIZE_X
		undefine
			copy, is_equal, default_create
		end
	HAS_MAX_SIZE_Y
		undefine
			copy, is_equal, default_create
		end
	HAS_ACCOUNT_NUMBER
		rename
			has_account_number as has_cust_acct_no,
			account_number as cust_acct_no
		undefine
			copy, is_equal, default_create
		end
	HAS_ACCOUNT_SPONSOR
		undefine
			copy, is_equal, default_create
		end
	HAS_ACCOUNT_TYPE
		undefine
			copy, is_equal, default_create
		end
	HAS_ORG_SHORT_ID
		rename
			has_org_short_id as has_organization_short_id,
			org_short_id as organization_short_id
		undefine
			copy, is_equal, default_create
		end
	HAS_NET_ADDRESS
		undefine
			copy, is_equal, default_create
		end
	HAS_TELEPHONE_NUMBER
		undefine
			copy, is_equal, default_create
		end
	HAS_ADMIN_LIAISON_NAME
		undefine
			copy, is_equal, default_create
		end
	HAS_ADMIN_LIAISON_NET_ADDRESS
		undefine
			copy, is_equal, default_create
		end
	HAS_REASON_UNSELECTABLE
		undefine
			copy, is_equal, default_create
		end
	HAS_IS_INCLUDED
		rename
			is_included as is_currently_included,
			has_is_included as has_is_currently_included
		undefine
			copy, is_equal, default_create
		end
	HAS_IS_LOCKED
		undefine
			copy, is_equal, default_create
		end
	HAS_IS_ASSIGNED
		undefine
			copy, is_equal, default_create
		end
	HAS_IS_LOT_ASSIGNED
		undefine
			copy, is_equal, default_create
		end
	HAS_LOT_COMPATIBILITY
		undefine
			copy, is_equal, default_create
		end
	MOSIS_UTILITIES
		export
			{NONE} all
		undefine
			copy, is_equal, default_create
		end
	NUMBER_UTILITIES_ACCESS
		export
			{NONE} all
		undefine
			copy, is_equal, default_create
		end

create
	make

create {PACKING_PROJ_MULTI_COLUMN_LIST_ROW}
	make_filled

feature {NONE} -- Creation

	make (pp: like project a_packing: like packing)
		require
			pp_not_void: pp /= Void
			a_packing_not_void: a_packing /= Void
		do
			default_create
			project := pp
			packing := a_packing
			enable_visible
		ensure
			is_visible: is_visible
		end

feature -- Modification

	set_run_id (s: STRING)
			-- Set `run_id' to `s'
		do
			run_id := s
		end

	set_die (a_die: like die)
			-- Set `die' to `a_die'
		require
			a_die_not_void: a_die /= Void
		do
			die := a_die
		end

	set_lot_compatibility_status (a_list: like lot_compatibility_status)
			-- Set `lot_compatibility_status' to `a_list'
		require
			a_list_not_void: a_list /= Void
		do
			lot_compatibility_status := a_list
		end

feature -- Properties

	packing: RC_PACKING
			-- Packing project is part of

	project: PACKING_PROJECTS_ROW
			-- Packing project this row is for

	die: PACKING_DIES_ROW
			-- Die this row is for, if not Void

	lot_compatibility_status: LIST [STRING]
			-- Compatibility of project with lot `n'

	run_id: STRING
			-- Associated run ID, if has run context

	reason_unselectable: STRING
			-- Reason `Current' cannot be selected
		do
			Result := project.reason_unselectable
		end

	packing_id: STRING
			-- Packing id
		do
			Result := project.packing_id
		end

	version_no: INTEGER
			-- Version number
		do
			Result := project.version_no
		end

	project_no: INTEGER
			-- Project number
		do
			Result := project.project_no
		end

	fab_instance_type: STRING
			-- Type of fab instance
		do
			Result := project.ic_fab_instance_type
		end

	is_customer_project: BOOLEAN
			-- Is `Current' a customer project
		local
			type: IC_FAB_INSTANCE_TYPE_VALUES
		do
			Result := fab_instance_type.is_equal (type.Customer_fab)
		end

	date_selected: DB_DATE
			-- Date project selected
		do
			Result := project.date_selected
		end

	date_synchronized: DB_DATE
			-- Date project synchronized
		do
			Result := project.date_synchronized
		end

	date_fab_requested: DB_DATE
			-- Date fab was requested
		do
			Result := project.date_fab_requested
		end

	run_date_requested: DB_DATE
			-- Requested run date
		do
			Result := project.run_date_requested
		end

	design_no: INTEGER
			-- Design number
		do
			Result := project.design_no
		end

	assigned_run_id: STRING
			-- Run ID to which project is assigned or empty
			-- string if not assigned to a run
		do
			if not project.is_null_m_fab_no then
				Result := project.assigned_run_id
			else
				Result := ""
			end
		end

	run_type_requested: STRING
			-- Type of run requested
		do
			Result := project.run_type_requested
		end

	design_name: STRING
			-- Name of design
		do
			Result := project.design_name
		end

	overhead_style: STRING
			-- Overhead style for design
		do
			Result := packing.packings_row.effective_overhead_style_description (project.overhead_style)
		end

	design_size_x: DOUBLE
			-- Size in X dimension
		do
			Result := project.design_size_x
		end

	design_size_y: DOUBLE
			-- Size in Y dimension
		do
			Result := project.design_size_y
		end

	design_size_x_string: STRING
			-- Size in X dimension as a string
		do
			Result := nu.std_formatted_number (design_size_x)
		end

	design_size_y_string: STRING
			-- Size in Y dimension as a string
		do
			Result := nu.std_formatted_number (design_size_y)
		end

	max_size_x: DOUBLE
			-- Maximum size in X dimension
		do
			Result := project.max_allowed_die_size_x
		end

	max_size_y: DOUBLE
			-- Maximum size in Y dimension
		do
			Result := project.max_allowed_die_size_y
		end

	max_size_x_string: STRING
			-- Maximum size in X dimension as a string
		do
			if has_max_size_x then
				Result := nu.std_formatted_number (project.max_allowed_die_size_x)
			else
				Result := ""
			end
		end

	max_size_y_string: STRING
			-- Maximum size in Y dimension as a string
		do
			if has_max_size_y then
				Result := nu.std_formatted_number (project.max_allowed_die_size_y)
			else
				Result := ""
			end
		end

	cust_acct_no: INTEGER
			-- Account number
		do
			Result := project.cust_acct_no
		end

	account_sponsor: STRING
			-- Account sponsor ID
		do
			Result := account.acct_sponsor_id
		end

	account_type: STRING
			-- Account type
		do
			if account.is_null_acct_sponsor_id then
				Result := account.acct_type
			else
				Result := account.acct_sponsor_id + "-" + account.acct_type
			end
		end

	organization_short_id: STRING
			-- Organization short ID
		do
			Result := account.organization.short_id
		end

	export_control_type: STRING
			-- Export control type
		do
			Result := project.export_control_type
		end

	net_address: STRING
			-- E-mail address
		do
			Result := project.net_address
		end

	telephone_number: STRING
			-- Phone number
		do
			Result := project.phone_number
		end

	admin_liaison_name: STRING
			-- Name of adminstrative liaison for design's account
		do
			Result := admin_liaison.full_name
		end

	admin_liaison_net_address: STRING
			-- Net address of adminstrative liaison for
			-- design's account
		do
			Result := admin_liaison.net_address
		end

	is_currently_included: BOOLEAN
			-- Is project currently included?
		do
			Result := project.is_selected
		end

	is_locked: BOOLEAN
			-- Is project currently locked against user updates?
		do
			Result := project.is_currently_locked
		end

	is_assigned: BOOLEAN
			-- Is project currently assigned to a run?
		do
			Result := run_id /= Void and then project.is_assigned_to_run (run_id)
		end

	is_lot_assigned: BOOLEAN
			-- Is project currently assigned to a specific lot?
		do
			Result := die /= Void and then not die.assigned_wafer_etest_id.is_empty
		end

	lot_compatibility (n: INTEGER): STRING
			-- Lot compatibility status for lot `n'
		do
			Result := lot_compatibility_status.i_th (n)
		end

	unique_identifier: STRING
			-- Value that uniquely identifies row
		do
			Result := project_no.out
		end

	has_packing_id: BOOLEAN = True
			-- Is there an associated packing ID?

	has_version_no: BOOLEAN = True
			-- Is there an associated version number?

	has_project_no: BOOLEAN = True
			-- Is there an associated project number?

	has_fab_instance_type: BOOLEAN = True
			-- Is there an associated fab instance type?

	has_date_selected: BOOLEAN = True
			-- Is there an associated date selected?

	has_date_synchronized: BOOLEAN = True
			-- Is there an associated date synchronized?

	has_run_type_requested: BOOLEAN = True
			-- Is there an associated run type requested?

	has_design_name: BOOLEAN = True
			-- Is there an associated design name?

	has_cust_acct_no: BOOLEAN = True
			-- Is there an associated account number?

	has_account_type: BOOLEAN = True
			-- Is there an associated account type?

	has_organization_short_id: BOOLEAN = True
			-- Is there an associated organization short ID?

	has_is_currently_included: BOOLEAN = True
			-- Is there an associated "is currently included"
			-- attribute?

	has_is_locked: BOOLEAN
			-- Is there an associated "is locked" attribute?
		do
			Result := is_customer_project
		end

	has_is_assigned: BOOLEAN
			-- Is there an associated "is assigned" attribute?
		do
			Result := is_customer_project
		end

	has_is_lot_assigned: BOOLEAN
			-- Is there an associated "is lot assigned" attribute?
		do
			Result := is_customer_project
		end

	has_lot_compatibility (n: INTEGER): BOOLEAN
			-- Is there an associated "lot compatibility status"
			-- attribute?
		do
			Result := is_customer_project
		end

	has_account_sponsor: BOOLEAN
			-- Is there an associated account sponsor?
		do
			Result := not account.is_null_acct_sponsor_id
		end

	has_design_no: BOOLEAN
			-- Is there an associated design number?
		do
			Result := not project.is_null_design_no
		end

	has_assigned_run_id: BOOLEAN
			-- Is there an associated assigned run ID?
		do
			Result := not project.is_null_m_fab_no
		end

	has_design_size_x: BOOLEAN
			-- Is there an associated design_size in X?
		do
			Result := not project.is_null_design_size_x
		end

	has_design_size_y: BOOLEAN
			-- Is there an associated design size in Y?
		do
			Result := not project.is_null_design_size_y
		end

	has_max_size_x: BOOLEAN
			-- Is there an associated maximum size in X?
		do
			Result := not project.is_null_max_allowed_die_size_x
		end

	has_max_size_y: BOOLEAN
			-- Is there an associated maximum size in Y?
		do
			Result := not project.is_null_max_allowed_die_size_y
		end

	has_date_fab_requested: BOOLEAN
			-- Is there an associated date fab requested?
		do
			Result := not project.is_null_date_fab_requested
		end

	has_run_date_requested: BOOLEAN
			-- Is there an associated requested run date?
		do
			Result := not project.is_null_run_date_requested
		end

	has_export_control_type: BOOLEAN
			-- Is there an associated export control type?
		do
			Result := not project.is_null_export_control_type
		end

	has_reason_unselectable: BOOLEAN
			-- Is there an associated reason `Current' is
			-- unselectable?
		do
			Result := project.reason_unselectable /= Void
		end

	has_admin_liaison_name: BOOLEAN
			-- Is there an associated administrative liaison name?
		do
			Result := not admin_liaison.name.is_empty
		end

	has_admin_liaison_net_address: BOOLEAN
			-- Is there an associated administrative liaison
			-- net address?
		do
			Result := not admin_liaison.is_null_net_address
		end

feature {NONE} -- Implementation

	account: like cached_account
			-- Cust account row for `Current'
		do
			if cached_account = Void then
				fetch_account
			end
			Result := cached_account
		end

	fetch_account
		do
			create cached_account.make_by_key (project.any_connection, option.Old_row, cust_acct_no)
		end

	cached_account: CUST_ACCTS_ROW
			-- Cached customer account row

	cust_ic_design: like cached_cust_ic_design
			-- Cust IC design row for `Current'
		do
			if cached_cust_ic_design = Void then
				fetch_cust_ic_design
			end
			Result := cached_cust_ic_design
		end

	fetch_cust_ic_design
		do
			create cached_cust_ic_design.make_by_key (project.any_connection, option.Old_row, design_no)
		end

	admin_liaison: CONTACTS_ROW
			-- Administrative liaison for design's cust account
		do
			Result := cust_ic_design.admin_liaison_contact
		end

	cached_cust_ic_design: CUST_IC_DESIGNS_ROW
			-- Cached cust IC design row

	new_filled_list (n: INTEGER): like Current
			-- New list with `n' elements.
		do
			create Result.make_filled (n)
		end
		
end
