
indexing
	
	description: "Data associated with one tab of notebook in window to %
		%manage projects"
	author: "David Hollenberg"
	date: "November 7, 2005"

class PACKING_PROJ_NOTEBOOK_TAB_DATA

feature -- Properties

	category: STRING
			-- Category of projects in tab (selectable, lockable,
			-- etc)

	refresh_agent: PROCEDURE [ANY, TUPLE]
			-- Agent to refresh lists displayed in tab

	selection_list: MULTI_COLUMN_LIST [PACKING_PROJ_MULTI_COLUMN_LIST_ROW]
			-- List within tab to which Select menu items apply
			-- (e.g., Select All)

feature -- Modification

	set_category (a_category: like category)
			-- Set `category' to `a_category'
		require
			a_category_not_void: a_category /= Void
		do
			category := a_category
		end

	set_refresh_agent (a: like refresh_agent)
			-- Set `refresh_agent' to `a'
		do
			refresh_agent := a
		end

	set_selection_list (list: like selection_list)
			-- Set `selection_list' to `list'
		do
			selection_list := list
		end

	add_list_formatter (fmt: STRING list: like selection_list col_selector:  FUNCTION [ANY, TUPLE, LIST [MULTI_COLUMN_LIST_COLUMN [PACKING_PROJ_MULTI_COLUMN_LIST_ROW]]])
			-- Add formatter for format name `fmt' that
			-- will format `list' by setting its visible
			-- columns to the ones returned by `col_selector'
		local
			formatter: MULTI_COLUMN_LIST_FORMATTER [PACKING_PROJ_MULTI_COLUMN_LIST_ROW]
			formatter_list: ARRAYED_LIST [MULTI_COLUMN_LIST_FORMATTER [PACKING_PROJ_MULTI_COLUMN_LIST_ROW]]
		do
			if table = Void then
				create table.make (3)
			end
			table.search (fmt)
			create formatter.make (list, col_selector)
			if table.found then
				table.found_item.extend (formatter)
			else
				create formatter_list.make (5)
				formatter_list.extend (formatter)
				table.put (formatter_list, fmt)
			end
		end

feature -- Operations

	set_format (fmt: STRING)
			-- Set format of multi-column lists in notebook
			-- tab to `fmt'
		do
			if table /= Void then
				table.search (fmt)
				if table.found then
					table.found_item.do_all (agent {MULTI_COLUMN_LIST_FORMATTER [PACKING_PROJ_MULTI_COLUMN_LIST_ROW]}.apply)
				end
			end
		end

feature {NONE} -- Implementation

	table: HASH_TABLE [LIST [MULTI_COLUMN_LIST_FORMATTER [PACKING_PROJ_MULTI_COLUMN_LIST_ROW]], STRING]

end

