
indexing
	
	description: "Object that can report packing status"
	author: "David Hollenberg"
	date: "December 4, 2006"

deferred class PACKING_STATUS_REPORTER

feature -- Operations

	report_start
			-- Report start of an operation
		deferred
		end

	report_end
			-- Report end of an operation
		deferred
		end

	report_status (a_message: STRING)
			-- Report transient status described by
			-- `a_message'.  Includes things like "started
			-- operation", "waiting for next key", etc
		require
			a_message_not_void: a_message /= Void
		deferred
		end

	report_progress (a_message: STRING)
			-- Report operation in progress described by
			-- `a_message'
		require
			a_message_not_void: a_message /= Void
		deferred
		end

	report_select (a_message: STRING)
			-- Report select operation described by `a_message'
		require
			a_message_not_void: a_message /= Void
		deferred
		end

	report_view (a_message: STRING)
			-- Report change of how objects are displayed
			-- described by `a_message'
		require
			a_message_not_void: a_message /= Void
		deferred
		end

	report_lock (a_message: STRING)
			-- Report locking of object property or properties
			-- described by `a_message'
		require
			a_message_not_void: a_message /= Void
		deferred
		end

	report_navigation (a_message: STRING)
			-- Report operation that affects what part of
			-- model is displayed, described by `a_message'
		require
			a_message_not_void: a_message /= Void
		deferred
		end

	report_change (a_message: STRING)
			-- Report operation that changes the packing,
			-- described by `a_message'.  Includes things
			-- like move, duplicate, add or remove
			-- projects, etc
		require
			a_message_not_void: a_message /= Void
		deferred
		end

	report_failure (a_message: STRING)
			-- Report operation failure described by
			-- `a_message'.  This is for the case where operation
			-- failed completely, not where some part of the
			-- operation could be done
		require
			a_message_not_void: a_message /= Void
		deferred
		end

	report_cancellation (a_message: STRING)
			-- Report operation cancellation described by
			-- `a_message'
		require
			a_message_not_void: a_message /= Void
		deferred
		end

	report_validity (a_message: STRING)
			-- Report validity check operation described by
			-- `a_message'
		require
			a_message_not_void: a_message /= Void
		deferred
		end

	report_exit (a_message: STRING)
			-- Report exit of packer described by
			-- `a_message'
		require
			a_message_not_void: a_message /= Void
		deferred
		end

	report_details (a_message: STRING)
			-- Report details of operation that succeeded or
			-- failed, described by `a_message'
		require
			a_message_not_void: a_message /= Void
		deferred
		end

	report_internal_error (a_message: STRING)
			-- Report internal error `a_message'
		require
			a_message_not_void: a_message /= Void
		deferred
		end

end
