
indexing
	
	description: "Multi-column list row that has additional information %
		%about the entity it represents that uniquely identifies %
		%the entity and associates it with a packing version"
	author: "David Hollenberg"
	date: "November 10, 2005"

class PACKING_VERSION_MULTI_COLUMN_LIST_ROW
inherit	
	MULTI_COLUMN_LIST_ROW
		rename
			make as mcl_make
		end
	HAS_PACKING_ID
		undefine
			copy, is_equal, default_create
		end
	HAS_VERSION_NUMBER
		rename
			has_version_number as has_version_no,
			version_number as version_no
		undefine
			copy, is_equal, default_create
		end
	HAS_PARENT_VERSION_NUMBER
		rename
			has_parent_version_number as has_parent_version_no,
			parent_version_number as parent_version_no
		undefine
			copy, is_equal, default_create
		end
	HAS_DATE_CREATED
		undefine
			copy, is_equal, default_create
		end
	HAS_CREATOR
		undefine
			copy, is_equal, default_create
		end
	HAS_VERSION_ID
		undefine
			copy, is_equal, default_create
		end

create
	make

create {PACKING_VERSION_MULTI_COLUMN_LIST_ROW}
	make_filled

feature {NONE} -- Creation

	make (pv: PACKING_VERSIONS_ROW)
		require
			pv_not_void: pv /= Void
		do
			default_create
			version := pv
			enable_visible
		ensure
			is_visible: is_visible
		end

feature -- Properties

	version: PACKING_VERSIONS_ROW
			-- Packing version this row is for

	packing_id: STRING
			-- Packing id
		do
			Result := version.packing_id
		end

	version_no: INTEGER
			-- Version number
		do
			Result := version.version_no
		end

	parent_version_no: INTEGER
			-- Parent version number
		do
			Result := version.parent_version_no
		end

	creator: STRING
			-- Creator
		do
			Result := version.creator
		end

	date_created: DB_DATE
			-- Date packing created
		do
			Result := version.date_created
		end

	version_id: STRING
			-- Version ID
		do
			Result := version.version_id
		end

	unique_identifier: STRING
			-- Value that uniquely identifies row
		do
			Result := version_no.out
		end

	has_packing_id: BOOLEAN = True
			-- Is there an associated packing ID?

	has_version_no: BOOLEAN = True
			-- Is there an associated version number?

	has_creator: BOOLEAN = True
			-- Is there an associated creator?

	has_date_created: BOOLEAN = True
			-- Is there an associated date created?

	has_version_id: BOOLEAN
			-- Is there an associated version ID?
		do
			Result := not version.is_null_version_id
		end

	has_parent_version_no: BOOLEAN
			-- Is there an associated parent version number?
		do
			Result := not version.is_null_parent_version_no
		end

feature {NONE} -- Implementation

	new_filled_list (n: INTEGER): like Current
			-- New list with `n' elements.
		do
			create Result.make_filled (n)
		end
		
end
