
indexing

	date: "Tue Apr 24 10:30:15 2007"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user DHOLLEN"
	database_tables: 
		"PACKING_VERSIONS (MOSIS.PACKING_VERSIONS)"
			-- Included columns
			-- 	CREATOR
			-- 	DATE_CREATED
			-- 	PACKING_ID
			-- 	PACKING_NAME
			-- 	PARENT_VERSION_NO
			-- 	VERSION_ID
			-- 	VERSION_NO
			-- Excluded columns
			-- 	(none)

class PACKING_VERSIONS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_packing_id: STRING; the_version_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_packing_id_exists: the_packing_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			packing_id := the_packing_id
			version_no := the_version_no
			is_null_packing_id := False
			is_null_version_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 7

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  creator, date_created, packing_id, packing_name, parent_version_no,%N  version_id, version_no"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "packing_versions pckv"

	join_condition: STRING = ""

	table_name: STRING = "packing_versions"

	key_where_clause: STRING = "packing_id = :1 and version_no = :2"

feature -- Values

	creator: STRING
			-- DB: VARCHAR2(30) not null

	date_created: DB_DATE
			-- DB: DATE not null

	packing_id: STRING
			-- DB: VARCHAR2(30) not null

	packing_name: STRING
			-- DB: VARCHAR2(30)

	parent_version_no: INTEGER
			-- DB: NUMBER(4,0)

	version_id: STRING
			-- DB: VARCHAR2(50)

	version_no: INTEGER
			-- DB: NUMBER(4,0) not null

feature -- Maximum database lengths for character columns

	maxlen_creator: INTEGER = 30
	maxlen_packing_id: INTEGER = 30
	maxlen_packing_name: INTEGER = 30
	maxlen_version_id: INTEGER = 50

feature -- Precisions for number columns

	precision_parent_version_no: INTEGER = 4
	precision_version_no: INTEGER = 4

feature -- Scales for number columns

	scale_parent_version_no: INTEGER = 0
	scale_version_no: INTEGER = 0

feature -- Nullness for null allowed columns

	is_null_packing_name: BOOLEAN
	is_null_parent_version_no: BOOLEAN
	is_null_version_id: BOOLEAN

feature -- Nullness for non-null columns

	is_null_creator: BOOLEAN
	is_null_date_created: BOOLEAN
	is_null_packing_id: BOOLEAN
	is_null_version_no: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and version_no = r.version_no
			Result := Result
				and equal (packing_id, r.packing_id)
			Result := Result
				and is_null_packing_id = r.is_null_packing_id
				and is_null_version_no = r.is_null_version_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and parent_version_no = r.parent_version_no
			Result := Result
				and equal (creator, r.creator)
				and equal (date_created, r.date_created)
				and equal (packing_name, r.packing_name)
				and equal (version_id, r.version_id)
			Result := Result
				and is_null_creator = r.is_null_creator
				and is_null_date_created = r.is_null_date_created
				and is_null_packing_name = r.is_null_packing_name
				and is_null_parent_version_no = r.is_null_parent_version_no
				and is_null_version_id = r.is_null_version_id
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 30)
			q.select_date (2)
			q.select_string (3, 30)
			q.select_string (4, 30)
			q.select_integer (5)
			q.select_string (6, 50)
			q.select_integer (7)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			parent_version_no := q.integer_value (5)
			version_no := q.integer_value (7)
		end

	fill_in_references (q: SQL_QUERY)
		do
			creator := q.string_value (1)
			date_created := q.date_value (2)
			packing_id := q.string_value (3)
			packing_name := q.string_value (4)
			version_id := q.string_value (6)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, creator)
			q.get_date_value (2, date_created)
			q.get_string_value (3, packing_id)
			q.get_string_value (4, packing_name)
			q.get_string_value (6, version_id)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_creator := q.is_null (1)
			is_null_date_created := q.is_null (2)
			is_null_packing_id := q.is_null (3)
			is_null_packing_name := q.is_null (4)
			is_null_parent_version_no := q.is_null (5)
			is_null_version_id := q.is_null (6)
			is_null_version_no := q.is_null (7)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_packing_id := True
			is_null_version_no := True
			create packing_id.make (0)
		end

	set_null_nonkey
		do
			is_null_creator := True
			is_null_date_created := True
			is_null_packing_name := True
			is_null_parent_version_no := True
			is_null_version_id := True
			create creator.make (0)
			create {ORACLE_DATE} date_created.set_null
			create packing_name.make (0)
			create version_id.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, packing_id, False)
			q.bind_num_to_integer (2, version_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
			d: DB_DATE
		do
			s := temp_string
			d := temp_date
			Result := True
			Result := Result
				and parent_version_no = q.integer_value (5)
				and version_no = q.integer_value (7)
			q.get_string_value (1, s)
			Result := Result and equal (creator, s)
			q.get_date_value (2, d)
			Result := Result and equal (date_created, d)
			q.get_string_value (3, s)
			Result := Result and equal (packing_id, s)
			q.get_string_value (4, s)
			Result := Result and equal (packing_name, s)
			q.get_string_value (6, s)
			Result := Result and equal (version_id, s)
			Result := Result
				and is_null_creator = q.is_null (1)
				and is_null_date_created = q.is_null (2)
				and is_null_packing_id = q.is_null (3)
				and is_null_packing_name = q.is_null (4)
				and is_null_parent_version_no = q.is_null (5)
				and is_null_version_id = q.is_null (6)
				and is_null_version_no = q.is_null (7)
		end

end
