
indexing
	
	description: "Set of four parameters"
	author: "David Hollenberg"
	date: "March 12, 2003"

class PARAMETERS_4 [A, B, C, D]
inherit
	PARAMETER_SET
		redefine
			is_valid
		end


feature -- Properties

	parameter_1: A

	parameter_2: B

	parameter_3: C

	parameter_4: D

feature -- Modification

	set_parameter_1 (p: A)
		require
			argument_valid: is_valid_parameter_1 (p)
		do
			parameter_1 := p
		ensure
			parameter_set: parameter_1 = p
		end

	set_parameter_2 (p: B)
		require
			argument_valid: is_valid_parameter_2 (p)
		do
			parameter_2 := p
		ensure
			parameter_set: parameter_2 = p
		end

	set_parameter_3 (p: C)
		require
			argument_valid: is_valid_parameter_3 (p)
		do
			parameter_3 := p
		ensure
			parameter_set: parameter_3 = p
		end

	set_parameter_4 (p: D)
		require
			argument_valid: is_valid_parameter_4 (p)
		do
			parameter_4 := p
		ensure
			parameter_set: parameter_4 = p
		end

feature -- Validity

	is_valid: BOOLEAN
			-- Are all parameters valid?
		do
			Result := is_valid_parameter_1 (parameter_1) and
				is_valid_parameter_2 (parameter_2) and
				is_valid_parameter_3 (parameter_3) and
				is_valid_parameter_4 (parameter_4)
		end

	is_valid_parameter_1 (p: A): BOOLEAN
		do
			Result := p /= Void
		end

	is_valid_parameter_2 (p: B): BOOLEAN
		do
			Result := p /= Void
		end

	is_valid_parameter_3 (p: C): BOOLEAN
		do
			Result := p /= Void
		end

	is_valid_parameter_4 (p: D): BOOLEAN
		do
			Result := p /= Void
		end

end
