
indexing

	date: "Wed Feb 18 12:05:35 2009"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user ALLMOSIS"
	database_tables: 
		"PATTERN_FILES (MOSIS.PATTERN_FILES)"
			-- Included columns
			-- 	ARRAY_RECTANGLE_COUNT
			-- 	ARRAY_TRAPEZOID_COUNT
			-- 	DENSITY
			-- 	DIE_ID
			-- 	FIELD_NAME
			-- 	GRAND_TOTAL_COUNT
			-- 	LEVEL_NO
			-- 	PATTERN_FILENAME
			-- 	PATTERN_TYPE
			-- 	RECTANGLE_COUNT
			-- 	RENAMED_PATTERN_FILENAME
			-- 	RUN_ID
			-- 	TRAPEZOID_COUNT
			-- Excluded columns
			-- 	(none)

class PATTERN_FILES_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_pattern_filename: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_pattern_filename_exists: the_pattern_filename /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			pattern_filename := the_pattern_filename
			is_null_pattern_filename := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 13

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  array_rectangle_count, array_trapezoid_count, density, die_id,%N  field_name, grand_total_count, level_no, pattern_filename, pattern_type,%N  rectangle_count, renamed_pattern_filename, run_id, trapezoid_count"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "pattern_files pf"

	join_condition: STRING = ""

	table_name: STRING = "pattern_files"

	key_where_clause: STRING = "pattern_filename = :1"

feature -- Values

	array_rectangle_count: DOUBLE
			-- DB: NUMBER(15,0)

	array_trapezoid_count: DOUBLE
			-- DB: NUMBER(15,0)

	density: DOUBLE
			-- DB: NUMBER(*,*)

	die_id: STRING
			-- DB: CHAR(2)

	field_name: STRING
			-- DB: VARCHAR2(20)

	grand_total_count: DOUBLE
			-- DB: NUMBER(15,0)

	level_no: INTEGER
			-- DB: NUMBER(3,0) not null

	pattern_filename: STRING
			-- DB: VARCHAR2(12) not null

	pattern_type: STRING
			-- DB: VARCHAR2(8) not null

	rectangle_count: DOUBLE
			-- DB: NUMBER(15,0)

	renamed_pattern_filename: STRING
			-- DB: VARCHAR2(12)

	run_id: STRING
			-- DB: CHAR(4) not null

	trapezoid_count: DOUBLE
			-- DB: NUMBER(15,0)

feature -- Nullness for null allowed columns

	is_null_array_rectangle_count: BOOLEAN
	is_null_array_trapezoid_count: BOOLEAN
	is_null_density: BOOLEAN
	is_null_die_id: BOOLEAN
	is_null_field_name: BOOLEAN
	is_null_grand_total_count: BOOLEAN
	is_null_rectangle_count: BOOLEAN
	is_null_renamed_pattern_filename: BOOLEAN
	is_null_trapezoid_count: BOOLEAN

feature -- Nullness for non-null columns

	is_null_level_no: BOOLEAN
	is_null_pattern_filename: BOOLEAN
	is_null_pattern_type: BOOLEAN
	is_null_run_id: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (pattern_filename, r.pattern_filename)
			Result := Result
				and is_null_pattern_filename = r.is_null_pattern_filename
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and array_rectangle_count = r.array_rectangle_count
				and array_trapezoid_count = r.array_trapezoid_count
				and density = r.density
				and grand_total_count = r.grand_total_count
				and level_no = r.level_no
				and rectangle_count = r.rectangle_count
				and trapezoid_count = r.trapezoid_count
			Result := Result
				and equal (die_id, r.die_id)
				and equal (field_name, r.field_name)
				and equal (pattern_type, r.pattern_type)
				and equal (renamed_pattern_filename, r.renamed_pattern_filename)
				and equal (run_id, r.run_id)
			Result := Result
				and is_null_array_rectangle_count = r.is_null_array_rectangle_count
				and is_null_array_trapezoid_count = r.is_null_array_trapezoid_count
				and is_null_density = r.is_null_density
				and is_null_die_id = r.is_null_die_id
				and is_null_field_name = r.is_null_field_name
				and is_null_grand_total_count = r.is_null_grand_total_count
				and is_null_level_no = r.is_null_level_no
				and is_null_pattern_type = r.is_null_pattern_type
				and is_null_rectangle_count = r.is_null_rectangle_count
				and is_null_renamed_pattern_filename = r.is_null_renamed_pattern_filename
				and is_null_run_id = r.is_null_run_id
				and is_null_trapezoid_count = r.is_null_trapezoid_count
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_double (1)
			q.select_double (2)
			q.select_double (3)
			q.select_string (4, 2)
			q.select_string (5, 20)
			q.select_double (6)
			q.select_integer (7)
			q.select_string (8, 12)
			q.select_string (9, 8)
			q.select_double (10)
			q.select_string (11, 12)
			q.select_string (12, 4)
			q.select_double (13)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			array_rectangle_count := q.double_value (1)
			array_trapezoid_count := q.double_value (2)
			density := q.double_value (3)
			grand_total_count := q.double_value (6)
			level_no := q.integer_value (7)
			rectangle_count := q.double_value (10)
			trapezoid_count := q.double_value (13)
		end

	fill_in_references (q: SQL_QUERY)
		do
			die_id := q.string_value (4)
			field_name := q.string_value (5)
			pattern_filename := q.string_value (8)
			pattern_type := q.string_value (9)
			renamed_pattern_filename := q.string_value (11)
			run_id := q.string_value (12)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (4, die_id)
			q.get_string_value (5, field_name)
			q.get_string_value (8, pattern_filename)
			q.get_string_value (9, pattern_type)
			q.get_string_value (11, renamed_pattern_filename)
			q.get_string_value (12, run_id)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_array_rectangle_count := q.is_null (1)
			is_null_array_trapezoid_count := q.is_null (2)
			is_null_density := q.is_null (3)
			is_null_die_id := q.is_null (4)
			is_null_field_name := q.is_null (5)
			is_null_grand_total_count := q.is_null (6)
			is_null_level_no := q.is_null (7)
			is_null_pattern_filename := q.is_null (8)
			is_null_pattern_type := q.is_null (9)
			is_null_rectangle_count := q.is_null (10)
			is_null_renamed_pattern_filename := q.is_null (11)
			is_null_run_id := q.is_null (12)
			is_null_trapezoid_count := q.is_null (13)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_pattern_filename := True
			create pattern_filename.make (0)
		end

	set_null_nonkey
		do
			is_null_array_rectangle_count := True
			is_null_array_trapezoid_count := True
			is_null_density := True
			is_null_die_id := True
			is_null_field_name := True
			is_null_grand_total_count := True
			is_null_level_no := True
			is_null_pattern_type := True
			is_null_rectangle_count := True
			is_null_renamed_pattern_filename := True
			is_null_run_id := True
			is_null_trapezoid_count := True
			create die_id.make (0)
			create field_name.make (0)
			create pattern_type.make (0)
			create renamed_pattern_filename.make (0)
			create run_id.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, pattern_filename, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and array_rectangle_count = q.double_value (1)
				and array_trapezoid_count = q.double_value (2)
				and density = q.double_value (3)
				and grand_total_count = q.double_value (6)
				and level_no = q.integer_value (7)
				and rectangle_count = q.double_value (10)
				and trapezoid_count = q.double_value (13)
			q.get_string_value (4, s)
			Result := Result and equal (die_id, s)
			q.get_string_value (5, s)
			Result := Result and equal (field_name, s)
			q.get_string_value (8, s)
			Result := Result and equal (pattern_filename, s)
			q.get_string_value (9, s)
			Result := Result and equal (pattern_type, s)
			q.get_string_value (11, s)
			Result := Result and equal (renamed_pattern_filename, s)
			q.get_string_value (12, s)
			Result := Result and equal (run_id, s)
			Result := Result
				and is_null_array_rectangle_count = q.is_null (1)
				and is_null_array_trapezoid_count = q.is_null (2)
				and is_null_density = q.is_null (3)
				and is_null_die_id = q.is_null (4)
				and is_null_field_name = q.is_null (5)
				and is_null_grand_total_count = q.is_null (6)
				and is_null_level_no = q.is_null (7)
				and is_null_pattern_filename = q.is_null (8)
				and is_null_pattern_type = q.is_null (9)
				and is_null_rectangle_count = q.is_null (10)
				and is_null_renamed_pattern_filename = q.is_null (11)
				and is_null_run_id = q.is_null (12)
				and is_null_trapezoid_count = q.is_null (13)
		end

end
