
indexing

	author: "Generated"
	date: "Thu Mar 11 15:52:47 PST 2004"

class PATTERN_FILES_ROW
inherit
	PATTERN_FILES_RAW
	ROW_COUNT_CHECK_ACCESS
	NULL_VALUE_CHECK_ACCESS
create
	make_template, make_null, make_by_key

feature -- Properties

	rows_for_run_and_type (a_run_id, a_type: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current] is
			-- All rows for `a_run_id' with  `a_type'
		require
			a_run_id_exists: a_run_id /= Void
			a_type_exists: a_type /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_SS
		do
			create b.make (a_run_id, a_type)
			Result := all_rows_filtered (conn, "run_id = :1 and pattern_type = :2", b)
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

	final_rows_for_run (a_run_id: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current] is
			-- All rows for `a_run_id' that are for final
			-- pattern files to be sent to mask shop (only
			-- merged or filled pattern files)
		require
			a_run_id_exists: a_run_id /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_SSS
			type: PATTERN_TYPE_VALUES
		do
			create b.make (a_run_id, type.Fill, type.Merge)
			Result := all_rows_filtered_ordered (conn, "run_id = :1 and (pattern_type = :2 or (pattern_type = :3 and not exists (select 1 from pattern_files where run_id = :1 and pattern_type = :2 and level_no = pf.level_no and field_name = pf.field_name)))", b, "level_no")
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

	rows_for_die_and_type (a_run_id, a_die_id, a_type: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current] is
			-- All rows for `a_run_id' and `a_die_id' with
			-- `a_type'
		require
			a_run_id_exists: a_run_id /= Void
			a_die_id_exists: a_die_id /= Void
			a_type_exists: a_type /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_SSS
		do
			create b.make (a_run_id, a_die_id, a_type)
			Result := all_rows_filtered (conn, "run_id = :1 and die_id = :2 and pattern_type = :3", b)
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

	rows_for_level_and_type (a_run_id: STRING a_level_no: INTEGER a_type: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current] is
			-- All rows for `a_run_id' and `a_level_no' with
			-- `a_type'
		require
			a_run_id_exists: a_run_id /= Void
			a_type_exists: a_type /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_SIS
		do
			create b.make (a_run_id, a_level_no, a_type)
			Result := all_rows_filtered (conn, "run_id = :1 and level_no = :2 and pattern_type = :3", b)
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

	non_null_density: like density is
			-- Value of `density', with error check for nullness
		do
			check_not_null ("density", is_null_density, Current)
			Result := density
		end

feature	-- extra property added by JG for the design_check_processor

	extent: CONST_RECTANGLE

end
