
indexing
	
	description: "One page of a PostScript file"
	author: "David Hollenberg"
	date: "April 7, 2005"

class POSTSCRIPT_PAGE

feature -- Properties

	number: INTEGER
			-- Ordinal position of page within document

	label: STRING
			-- Page label (alternative to page number)

	start_offset: INTEGER_64
			-- Offset of first character of page from
			-- beginning of its containing PostScript file

	end_offset: INTEGER_64
			-- Offset of first position after last character of
			-- page beginning of its containing PostScript file
	
	count: INTEGER_64 is
			-- Number of characters in page
		do
			Result := end_offset - start_offset
		end

feature -- Modification

	set_number (n: like number) is
			-- Set `number' to `n'
		do
			number := n
		ensure
			number_set: number = n
		end

	set_label (s: like label) is
			-- Set `label' to `s'
		do
			label := s
		ensure
			label_set: label = s
		end

	set_start_offset (n: like start_offset) is
			-- Set `start_offset' to `n'
		do
			start_offset := n
		ensure
			start_offset_set: start_offset = n
		end

	set_end_offset (n: like end_offset) is
			-- Set `end_offset' to `n'
		do
			end_offset := n
		ensure
			end_offset_set: end_offset = n
		end

end
