
indexing
	
	description: "Action to take before Abut operation"
	author: "David Hollenberg"
	date: "November 16, 2006"

class PRE_ABUT_ACTION
inherit
	VIEW_POINT_ACTION

feature -- Properties

	containing_elements: LIST [RETICLE_VIEW_ELEMENT]
			-- List of non-field elements that contain
			-- `selection_point'

	selected_elements: LIST [RETICLE_VIEW_ELEMENT]
			-- List of elements that are currently selected

	target_field: RETICLE_VIEW_ELEMENT
			-- Field that contains `selection_point' and is
			-- target of Abut or Void if none

feature -- Modification

	set_containing_elements (a_list: like containing_elements)
			-- Set `containing_elements' to `a_list'
		require
			a_list_not_void: a_list /= Void
		do
			containing_elements := a_list
		ensure
			containing_elements_set: containing_elements = a_list
		end

	set_selected_elements (a_list: like selected_elements)
			-- Set `selected_elements' to `a_list'
		require
			a_list_not_void: a_list /= Void
		do
			selected_elements := a_list
		ensure
			selected_elements_set: selected_elements = a_list
		end

	set_no_target_field
			-- Set `target_field' to Void
		do
			target_field := Void
		ensure
			target_field_void: target_field = Void
		end

feature -- Operations

	apply (an_element: RETICLE_VIEW_ELEMENT)
			-- Apply action to `an_element'
		do
			if an_element.is_selected then
				selected_elements.extend (an_element)
			end
			if an_element.bounding_box.has (selection_point) then
				if an_element.is_field then
					target_field := an_element
				elseif an_element.is_die then
					containing_elements.extend (an_element)
				end
			end
		end

end
