
indexing
	
	description: "Action to take before Align operation"
	author: "David Hollenberg"
	date: "November 16, 2006"

class PRE_ALIGN_ACTION
inherit
	VIEW_POINT_ACTION

feature -- Properties

	containing_elements: LIST [RETICLE_VIEW_ELEMENT]
			-- List of non-field elements that contain
			-- `selection_point'

feature -- Modification

	set_containing_elements (a_list: like containing_elements)
			-- Set `containing_elements' to `a_list'
		require
			a_list_not_void: a_list /= Void
		do
			containing_elements := a_list
		ensure
			containing_elements_set: containing_elements = a_list
		end

feature -- Operations

	apply (an_element: RETICLE_VIEW_ELEMENT)
			-- Apply action to `an_element'
		do
			if an_element.bounding_box.has (selection_point) and an_element.is_die then
				containing_elements.extend (an_element)
			end
		end

end
