
indexing
	
	description: "Window to show progress of application %
		%that includes a Cancel button to abort operation"
	author: "David Hollenberg"
	date: "May 8, 2003"

class PROGRESS_WINDOW

inherit
	PROGRESS_IFC
	WINDOW_INTERFACE
	MOSIS_GRAPHICAL_UTILITIES
		export
			{NONE} all
		undefine
			default_create
		end
		
create
	make

feature {NONE} -- Creation

	make (w: EV_TITLED_WINDOW)
			-- Create interface in window `w'
		require
			window_exists: w /= Void
			window_valid: not w.is_destroyed
		do
			make_interface
			make_proxy (w)
		end

feature -- Operations

	reset
			-- Reset interface
		do
			enable_active
		end

feature -- Modification

	set_label (s: STRING)
		do
			create label.make_with_text (s)
			label.set_background_color (background_color)
			label_box.wipe_out
			label_box.extend (label)
		end

feature {NONE} -- Implementation

	label: EV_LABEL
			-- Text to display in progress window

	label_box: EV_HORIZONTAL_BOX
			-- Box to display text

	cancel_button: EV_BUTTON
			-- Button to abort operation in progress

	build_interface
			-- Build interface in `window'
		local
			main_vbox: EV_VERTICAL_BOX
			box: EV_BOX
			buttons: HORIZONTAL_BUTTON_SET
		do
			create main_vbox
			main_vbox.set_padding (user_interface.padding)
			main_vbox.set_border_width (user_interface.border_width)
			create label_box
			create label.make_with_text ("")
			label_box.extend (label)
			main_vbox.extend (label_box)
			
			create buttons.make_with_text_and_actions (<< gui.ev_abort >>, << agent process_decline >>)
			cancel_button := buttons.i_th (1)
			box := buttons.column_set.box
			
			main_vbox.extend (box)
			main_vbox.disable_item_expand (box)

			gui.set_box_background_recursive (main_vbox, background_color)
			extend (main_vbox)
			gui.do_once_on_idle (agent post_display_actions)
		end
		
	post_display_actions
		do
			reset
		end

	process_decline
			-- Take actions needed when user declines
			-- current operation
		do
			if is_active then
				disable_active
				decline_actions.call ([])
			end
		end

end
