class R_ARRAYED_LIST[G]
	-- an ARRAYED_LIST with
	--	a reset function,
	--	rapid automatic growth, and
	--	a trim function to discard excess capacity

inherit
	ARRAYED_LIST[G]
	redefine
		additional_space
	end;

create
	make, make_filled

feature	-- additional_space (ignore growth_percentage; go big)

	additional_space: INTEGER
		-- go 4X at a time by using a 300% growth factor
	do
	    Result := (capacity * 3).max(minimal_increase)
	end;

feature	-- reset 

	reset
		-- like wipe-out, but preserve the area object
	do  count := 0;
	    index := 0
	    clear_all	-- rather than make_area(capacity)
	end

feature	-- trim

	trim(thold: INTEGER)
		-- trim area down to count IF area.count - count > thold
		-- i.e., if we will recover more than thold slots
		-- NOTE: in the ISE implementation, the capacity of the
		--  underlying ARRAY _may_ be less than the count of its
		--  area !!!
	require valid_thold: thold >= 0
	local acnt: INTEGER; oarea: SPECIAL[G]
	do  acnt := area.count
	    if acnt - count > thold then
		oarea := area;
		make_area(count)
		if count > 0 then
			area.copy_data(oarea, 0, 0, count)
		end
	    end
	end;

end -- R_ARRAYED_LIST
