
indexing
	
	description: "An abstract session for selecting and packing projects"
	author: "David Hollenberg"
	date: "November 7, 2005"

deferred class RC_ABSTRACT_PACKING_SESSION
inherit
	RC_SESSION

feature -- Properties

	packing_id: STRING
			-- Packing id we're working on
	
	run_id: STRING
			-- Run id
		deferred
		end
	
	has_run_context: BOOLEAN
			-- Is packing being done in context of
			-- a specific run?
		do
			Result := run_id /= Void
		end
	
	has_packing_context: BOOLEAN
			-- Has a specific packing been selected
			-- for editing?
		do
			Result := packing_id /= Void
		end
	
	title_with_run_and_packing_id (s: STRING): STRING
                        -- Title `s' with run ID and packing ID information
			-- added to it in standard way
                require
                        title_exists: s /= Void
                do
                        Result := s + " Packing"
			if packing_id /= Void then
                        	Result := Result + " " + packing_id
			end
			if run_id /= Void then
				if packing_id /= Void then
                        		Result := Result + " for Run " + run_id
				else
                        		Result := Result + " for " + run_id
				end
			end
                end

feature -- Modification

	set_packing_id (p: STRING)
		require
			p_not_void: p /= Void
		do
			packing_id := p
		end

	set_run_id (s: STRING)
		require
			s_not_void: s /= Void
		deferred
		ensure
			run_id_set: run_id.is_equal (s.as_upper)
		end

end
