
indexing
	
	description: "Interface to allow viewing of bonding diagrams for %
		%a specific run or for a design"
	author: "David Hollenberg"
	date: "February 23, 2005"

deferred class RC_BONDING_IFC

inherit
	ABSTRACT_INTERFACE
		
feature {NONE} -- Creation

	make_interface
			-- Create interface
		do
			create cancel_actions
		end

feature -- Modification

	set_session (sess: like session)
			-- Set `session' to `sess'
		require
			sess_exists: sess /= Void
		do
			session := sess
		ensure
			session_set: session = sess
		end

	set_run_id (s: like run_id)
			-- Set `run_id' to `s'
		do
			run_id := s
		ensure
			run_id_set: run_id = s
		end

	set_print_interface (ifc: like print_interface)
			-- Set `print_interface' to `ifc'
		require
			ifc_exists: ifc /= Void
		do
			print_interface := ifc
		ensure
			interface_set: print_interface = ifc
		end

feature -- Properties

	session: RC_BONDING_SESSION
			-- Session used to view diagrams

	run_id: STRING
			-- Run id (Void if not constrained to a particular run)

	print_interface: RC_MAP_PRINT_IFC
			-- Interface to print bonding diagrams

	cancel_actions: CLOSED_ACTION_SEQUENCE
			-- Actions to be executed when user clicks on Cancel
			-- button

end
