
indexing
	
	description: "Run closing interface elements"
	author: "David Hollenberg"
	date: "April 24, 2003"

deferred class RC_INTERFACE_FACTORY

feature -- Properties

	database_login_interface (user, conn_str: STRING): DATABASE_LOGIN_IFC
			-- Interface to get database login information,
			-- with initial userid `user' and connect string
			-- `conn_str'
		require
			user_exists: user /= Void
			connect_string_exists: conn_str /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	session_selection_interface (title: STRING): SINGLE_SELECTION_IFC
			-- Interface to select session type
		require
			title_exists: title /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	single_fixed_selection_interface (title: STRING): SINGLE_SELECTION_IFC
			-- Interface to select a single choice from
			-- a fixed short list
		require
			title_exists: title /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	single_free_value_interface (title: STRING): SINGLE_FREE_VALUE_IFC
			-- Interface to enter a single unconstrained value
		require
			title_exists: title /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	step_selection_interface (run_id, title: STRING): RC_STEP_SELECTION_IFC
			-- Interface with `title' to select run closing steps
			-- for run `run_id' and what actions to take on them
		require
			run_id_exists: run_id /= Void
			title_exists: title /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	single_constrained_value_interface (title: STRING): SINGLE_CONSTRAINED_VALUE_IFC
			-- Interface to select a single value from
			-- a possible long list
		require
			title_exists: title /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	progress_interface (run_id, title: STRING): PROGRESS_IFC
			-- Interface with `title' to display progress of
			-- application for `run_id', with Abort button
		require
			run_id_exists: run_id /= Void
			title_exists: title /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	field_set_interface (run_id, title: STRING): FIELD_SET_IFC
			-- Interface with `title' to allow user to
			-- select field set for `run_id'
		require
			run_id_exists: run_id /= Void
			title_exists: title /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	run_status_interface (run_id, title: STRING): RC_STATUS_IFC
			-- Interface with `title' to display status of
			-- run `run_id'
		require
			run_id_exists: run_id /= Void
			title_exists: title /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	merged_gds_field_control_interface (run_id, title: STRING): JOB_CONTROL_IFC
			-- Interface with `title' to allow user to submit,
			-- monitor and control jobs to create merged GDS
			-- files (one per field) for run `run_id'
		require
			run_id_exists: run_id /= Void
			title_exists: title /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	merged_gds_die_control_interface (run_id, title: STRING): JOB_CONTROL_IFC
			-- Interface with `title' to allow user to submit,
			-- monitor and control jobs to create merged GDS
			-- files (one per fdie) for run `run_id'
		require
			run_id_exists: run_id /= Void
			title_exists: title /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	die_fracture_control_interface (run_id, title: STRING): JOB_CONTROL_IFC
			-- Interface with `title' to allow user to submit,
			-- monitor and control jobs to fracture individual
			-- dies of run `run_id'
		require
			run_id_exists: run_id /= Void
			title_exists: title /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	level_merge_control_interface (run_id, title: STRING): JOB_CONTROL_IFC
			-- Interface with `title' to allow user to submit,
			-- monitor and control jobs to merge pattern files
			-- for each level of run `run_id'
		require
			run_id_exists: run_id /= Void
			title_exists: title /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	level_fill_control_interface (run_id, title: STRING): JOB_CONTROL_IFC
			-- Interface with `title' to allow user to submit,
			-- monitor and control jobs to fill pattern files
			-- for each level of run `run_id' that needs to be
			-- filled
		require
			run_id_exists: run_id /= Void
			title_exists: title /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	fill_selector_control_interface (run_id, title: STRING): JOB_CONTROL_IFC
			-- Interface with `title' to allow user to submit,
			-- monitor and control jobs to produce the fill
			-- selector file for run `run_id'
		require
			run_id_exists: run_id /= Void
			title_exists: title /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	edit_preferences_interface (run_id, title: STRING): EDIT_PREFERENCES_IFC
			-- Interface with `title' to allow user to edit
			-- preferences for session for `run_id'
		require
			run_id_exists: run_id /= Void
			title_exists: title /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	turnaround_dates_interface (run_id, title: STRING): TURNAROUND_DATES_IFC
			-- Interface with `title' to allow user to set
			-- tapeout date and estimated turnaround dates
			-- for `run_id'
		require
			run_id_exists: run_id /= Void
			title_exists: title /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	fab_run_order_interface (run_id, title: STRING): FAB_RUN_ORDER_IFC
			-- Interface with `title' to allow user to build
			-- order for fabrication of dedicated or trusted
			-- foundry run `run_id'
		require
			run_id_exists: run_id /= Void
			title_exists: title /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	die_overhead_parameters_interface (run_id, title: STRING): RC_DIE_OVERHEAD_PARAMETERS_IFC
			-- Interface with `title' to allow user to set
			-- die overhead parameters
		require
			run_id_exists: run_id /= Void
			title_exists: title /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	packing_creation_interface (title: STRING): RC_PACKING_IFC
			-- Interface with `title' to create new packings
		require
			title_exists: title /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	packing_selection_interface (title: STRING): RC_PACKING_IFC
			-- Interface with `title' to select existing packing
			-- to  edited
		require
			title_exists: title /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	packing_confirmation_interface (a_window: EV_TITLED_WINDOW run_id, packing_id, title: STRING): RC_PACKING_IFC
			-- Interface with `title' to do confirm
			-- selection of packing to edit for run
			-- `run_id' (or for packing identified by
			-- `packing_id').  Display interface in `a_window'
			-- if not Void, otherwise in current window
		require
			title_exists: title /= Void
			has_run_id_or_packing: run_id /= Void or packing_id /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	packing_interface (a_window: EV_TITLED_WINDOW run_id, packing_id, title: STRING): RC_PACKING_IFC
			-- Interface with `title' to do packing
			-- activities for run `run_id' (or for packing
			-- identified by `packing_id').  Display
			-- interface in `a_window' if not Void,
			-- otherwise in current window
		require
			title_exists: title /= Void
			has_run_id_or_packing: run_id /= Void or packing_id /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	packing_versions_interface (a_window: EV_TITLED_WINDOW run_id, packing_id, title: STRING): RC_PACKING_VERSIONS_IFC
			-- Interface with `title' to select version packing
			-- for run `run_id' (or for packing identified by
			-- `packing_id')
		require
			title_exists: title /= Void
			has_run_id_or_packing: run_id /= Void or packing_id /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	packing_projects_interface (a_window: EV_TITLED_WINDOW run_id, packing_id, title: STRING): RC_PACKING_PROJECTS_IFC
			-- Interface with `title' to manage projects
			-- while packing for run `run_id' (or for
			-- packing identified by `packing_id')
		require
			title_exists: title /= Void
			has_run_id_or_packing: run_id /= Void or packing_id /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	packing_payload_sizes_interface (a_window: EV_TITLED_WINDOW run_id, packing_id, title: STRING): RC_PACKING_PAYLOAD_SIZES_IFC
			-- Interface with `title' to view/set payload
			-- and field sizes while packing for run
			-- `run_id' (or for packing identified by
			-- `packing_id')
		require
			title_exists: title /= Void
			has_run_id_or_packing: run_id /= Void or packing_id /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	packing_scribes_interface (a_window: EV_TITLED_WINDOW run_id, packing_id, title: STRING): RC_PACKING_SCRIBES_IFC
			-- Interface with `title' to set properties of
			-- scribes while packing for run `run_id' (or for
			-- packing identified by `packing_id')
		require
			title_exists: title /= Void
			has_run_id_or_packing: run_id /= Void or packing_id /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	packing_filler_interface (a_window: EV_TITLED_WINDOW run_id, packing_id, title: STRING): RC_PACKING_FILLER_IFC
			-- Interface with `title' to set properties of
			-- a new filler while packing for run `run_id' (or for
			-- packing identified by `packing_id')
		require
			title_exists: title /= Void
			has_run_id_or_packing: run_id /= Void or packing_id /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	packing_delete_interface (a_window: EV_TITLED_WINDOW run_id, packing_id, title: STRING): RC_PACKING_DELETE_IFC
			-- Interface with `title' to allow user to control
			-- disposition of customer projects whose last copy
			-- is deleted while packing for run `run_id' (or for
			-- packing identified by `packing_id')
		require
			title_exists: title /= Void
			has_run_id_or_packing: run_id /= Void or packing_id /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	packing_move_absolute_interface (a_window: EV_TITLED_WINDOW run_id, packing_id, title: STRING): RC_PACKING_MOVE_ABS_IFC
			-- Interface with `title' to allow user to
			-- specify field and location for absolute
			-- move while packing for run `run_id' (or for
			-- packing identified by `packing_id')
		require
			title_exists: title /= Void
			has_run_id_or_packing: run_id /= Void or packing_id /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	packing_move_relative_interface (a_window: EV_TITLED_WINDOW run_id, packing_id, title: STRING): RC_PACKING_MOVE_REL_IFC
			-- Interface with `title' to allow user to
			-- specify distance for relative
			-- move while packing for run `run_id' (or for
			-- packing identified by `packing_id')
		require
			title_exists: title /= Void
			has_run_id_or_packing: run_id /= Void or packing_id /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	packing_output_interface (a_window: EV_TITLED_WINDOW run_id, packing_id, title: STRING): RC_PACKING_OUTPUT_IFC
			-- Interface with `title' to display output
			-- from packer operations while packing for
			-- run `run_id' (or for packing identified by
			-- `packing_id')
		require
			title_exists: title /= Void
			has_run_id_or_packing: run_id /= Void or packing_id /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	packing_info_interface (a_window: EV_TITLED_WINDOW run_id, packing_id, title: STRING): RC_PACKING_INFO_IFC
			-- Interface with `title' to display information
			-- about selected projects while packing for
			-- run `run_id' (or for packing identified by
			-- `packing_id')
		require
			title_exists: title /= Void
			has_run_id_or_packing: run_id /= Void or packing_id /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	packing_lot_split_colors_interface (a_window: EV_TITLED_WINDOW run_id, packing_id, title: STRING): RC_PACKING_SPLIT_COLORS_IFC
			-- Interface with `title' to allow user to view and
			-- set colors for lot splits for packing for
			-- run `run_id' (or for packing identified by
			-- `packing_id')
		require
			title_exists: title /= Void
			has_run_id_or_packing: run_id /= Void or packing_id /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	packing_application_colors_interface (a_window: EV_TITLED_WINDOW run_id, packing_id, title: STRING): RC_PACKING_APP_COLORS_IFC
			-- Interface with `title' to allow user to view and
			-- set application colors for packing for
			-- run `run_id' (or for packing identified by
			-- `packing_id')
		require
			title_exists: title /= Void
			has_run_id_or_packing: run_id /= Void or packing_id /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	packing_lot_assign_interface (a_window: EV_TITLED_WINDOW run_id, packing_id, title: STRING): RC_PACKING_LOT_ASSIGN_IFC
			-- Interface with `title' to allow user to assign
			-- a lot to projects for packing for
			-- run `run_id' (or for packing identified by
			-- `packing_id')
		require
			title_exists: title /= Void
			has_run_id_or_packing: run_id /= Void or packing_id /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	packing_lot_summary_interface (a_window: EV_TITLED_WINDOW run_id, packing_id, title: STRING): RC_PACKING_LOT_SUMMARY_IFC
			-- Interface with `title' to display summary of
			-- project lot compatibility for packing for
			-- run `run_id' (or for packing identified by
			-- `packing_id')
		require
			title_exists: title /= Void
			has_run_id_or_packing: run_id /= Void or packing_id /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	packing_search_interface (a_window: EV_TITLED_WINDOW run_id, packing_id, title: STRING): RC_PACKING_SEARCH_IFC
			-- Interface with `title' to allow searching
			-- for selected projects while packing for
			-- run `run_id' (or for packing identified by
			-- `packing_id')
		require
			title_exists: title /= Void
			has_run_id_or_packing: run_id /= Void or packing_id /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	packing_help_interface (a_window: EV_TITLED_WINDOW run_id, packing_id, title: STRING): RC_PACKING_HELP_IFC
			-- Interface with `title' to provide help for
			-- packer while packing for run `run_id' (or
			-- for packing identified by `packing_id')
		require
			title_exists: title /= Void
			has_run_id_or_packing: run_id /= Void or packing_id /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	cut_pattern_properties_interface (a_window: EV_TITLED_WINDOW run_id, packing_id, title: STRING): RC_CUT_PATTERN_PROPERTIES_IFC
			-- Interface with `title' to set properties of
			-- a cut pattern while packing for run
			-- `run_id' (or for packing identified by
			-- `packing_id')
		require
			title_exists: title /= Void
			has_run_id_or_packing: run_id /= Void or packing_id /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	wafer_lot_creation_interface (run_id, title: STRING): WAFER_LOT_CREATION_IFC
			-- Interface with `title' to allow user to create
			-- initial wafer lots for `run_id'
		require
			run_id_exists: run_id /= Void
			title_exists: title /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	packaging_lot_creation_interface (run_id, title: STRING): PACKAGING_LOT_CREATION_IFC
			-- Interface with `title' to allow user to create
			-- initial packaging lots for `run_id'
		require
			run_id_exists: run_id /= Void
			title_exists: title /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	package_info_interface (a_window: EV_TITLED_WINDOW run_id, title: STRING): PACKAGE_INFO_IFC
			-- Interface with `title' to display information
			-- about packaging for projects on
			-- run `run_id'
		require
			title_exists: title /= Void
			run_id_not_void: run_id /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	bonding_interface (run_id, title: STRING): RC_BONDING_IFC
			-- Interface with `title' to do bonding activies
			-- for run `run_id' (not constrained to a particular
			-- run if Void)
		require
			title_exists: title /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	wafer_map_print_interface (run_id, title: STRING): RC_MAP_PRINT_IFC
			-- Interface with `title' to print wafer maps
			-- for run `run_id'
		require
			run_id_exists: run_id /= Void
			title_exists: title /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	bond_diagram_print_interface (run_id, title: STRING): RC_MAP_PRINT_IFC
			-- Interface with `title' to print bonding diagrams
			-- for run `run_id'
		require
			run_id_exists: run_id /= Void
			title_exists: title /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	bond_diagram_list_print_interface (title: STRING): RC_MAP_PRINT_IFC
			-- Interface with `title' to print list of
			-- bonding diagrams (not necessarily for one run
			-- or even on a run)
		require
			title_exists: title /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	job_file_print_interface (run_id, title: STRING): RC_MAP_PRINT_IFC
			-- Interface with `title' to print job files
			-- for run `run_id'
		require
			run_id_exists: run_id /= Void
			title_exists: title /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	bond_diagram_prep_interface (run_id, title: STRING): INTERNAL_FE_REQUEST_IFC
			-- Interface with `title' to prepare final bonding
			-- diagrams for run `run_id' and make them available
			-- to customers
		require
			run_id_exists: run_id /= Void
			title_exists: title /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	posted_notification_interface (run_id, title: STRING): INTERNAL_FE_REQUEST_IFC
			-- Interface with `title' to notify customers
			-- for run `run_id' that their projects have been
			-- sent to foundry for review
		require
			run_id_exists: run_id /= Void
			title_exists: title /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
	rtm_notification_interface (run_id, title: STRING): INTERNAL_FE_REQUEST_IFC
			-- Interface with `title' to notify customers
			-- for run `run_id' that their projects have been
			-- released to manufacturing
		require
			run_id_exists: run_id /= Void
			title_exists: title /= Void
		deferred
		ensure
			result_exists: Result /= Void
		end
	
end
