
indexing
	
	description: "Interface to allow printing of wafer maps for %
		%a specific run"
	author: "David Hollenberg"
	date: "March 10, 2005"

deferred class RC_MAP_PRINT_IFC

inherit
	ABSTRACT_INTERFACE
		
feature {NONE} -- Creation

	make_interface
			-- Create interface
		do
			create cancel_actions
		end

feature -- Modification

	set_session (sess: like session)
			-- Set `session' to `sess'
		require
			sess_exists: sess /= Void
		do
			session := sess
		ensure
			session_set: session = sess
		end

feature -- Operations

	refresh
			-- Refresh list of files
		deferred
		end

feature -- Properties

	session: RC_SESSION
			-- Session used to print maps

	is_built: BOOLEAN
			-- Has interface been built?
		deferred
		end

	cancel_actions: CLOSED_ACTION_SEQUENCE
			-- Actions to be executed when user clicks on Cancel
			-- button

end
