
indexing
	
	description: "Interface to view and set application colors in packer"
	author: "David Hollenberg"
	date: "April 18, 2006"

deferred class RC_PACKING_APP_COLORS_IFC
inherit
	ABSTRACT_INTERFACE

feature {NONE} -- Creation

	make_interface
			-- Create interface
		do
			create accept_actions
			create apply_actions
			create cancel_actions
		end

feature -- Properties

	session: RC_ABSTRACT_PACKING_SESSION
			-- Session used to do packing

	application_colors: LIST [APPLICATION_COLORS_MROW]
			-- Existing colors for lot splits
	
	named_colors: LIST [NAMED_COLORS_ROW]
			-- List of supported named colors

	accept_actions: ACTION_SEQUENCE [TUPLE [LIST [APPLICATION_COLORS_ROW]]]
			-- Action to be invoked when user clicks on OK

	apply_actions: ACTION_SEQUENCE [TUPLE [LIST [APPLICATION_COLORS_ROW]]]
			-- Action to be invoked when user clicks on Apply

	cancel_actions: CLOSED_ACTION_SEQUENCE
			-- Action to be invoked when user clicks on Cancel

feature -- Modification

	set_session (sess: like session)
			-- Set `session' to `sess'
		require
			sess_exists: sess /= Void
		do
			session := sess
		ensure
			session_set: session = sess
		end

	set_application_colors (a_list: like application_colors)
			-- Set `application_colors' to `a_list'
		require
			a_list_exists: a_list /= Void
		do
			application_colors := a_list
		ensure
			application_colors_set: application_colors = a_list
		end

	set_named_colors (a_list: like named_colors)
			-- Set `named_colors' to `a_list'
		require
			a_list_exists: a_list /= Void
		do
			named_colors := a_list
		ensure
			named_colors_set: named_colors = a_list
		end

end
