
indexing
	
	description: "Window to allow user to confirm that correct packing %
		%was selected for editing"
	author: "David Hollenberg"
	date: "November 7, 2005"

class RC_PACKING_CONFIRMATION_WINDOW

inherit
	RC_PACKING_RECORD_WINDOW
		
create
	make

feature -- Modification

feature {NONE} -- Implementation

	enable_buttons_sensitive
			-- Make buttons sensitive
		do
			edit_button.enable_sensitive
			cancel_button.enable_sensitive
		end

	disable_buttons_sensitive
			-- Make buttons insensitive
		do
			edit_button.disable_sensitive
			cancel_button.disable_sensitive
		end

	populate_fields
			-- Populate some fields
		local
			p: PACKINGS_ROW
			sr: SCHEDULED_RUNS_ROW
			sr_date: STRING
			style: OVERHEAD_STYLE_VALUES
			l_other_border: STRING
		do
			create packings_row.make_by_key (connection, option.Old_row, packing_id)
			p := packings_row
			if not p.is_null_sched_run_no then
				create sr.make_by_key (connection, option.Old_row, p.sched_run_no)
				sr_date := sr.date_scheduled.to_date_string
			else
				sr_date := ""
			end
			packing_id_field.set_text (p.packing_id)
			creator_field.set_text (p.creator)
			run_type_field.set_text (p.run_type)
			if p.educational then
				educational_field.enable_select
			else
				educational_field.disable_select
			end
			if p.is_taxi then
				taxi_field.enable_select
			else
				taxi_field.disable_select
			end
			sched_run_field.set_text (sr_date)
			wafer_techn_field.set_text (p.wafer_techn)
			field_set_field.set_text (p.field_set_name)
			step_pattern_field.set_text (p.field_step_pattern)
			overhead_style_field.set_text (style.null_translated (p.overhead_style) + "   " + overhead_style_descriptions.item (p.overhead_style))
			l_other_border := nu.formatted_number_or_integer (p.other_border, border_scale)
			other_border_field.set_text (l_other_border)
			top_overhead_field.set_text (top_overhead_description (p.overhead_style, l_other_border))
			intended_run_field.set_text (p.intended_run)
			description_field.set_text (p.descr)
		end
		
	set_field_properties
			-- Set properties of fields
		do
			packing_id_field.disable_edit
			creator_field.disable_edit
			educational_field.disable_sensitive
			taxi_field.disable_sensitive
			run_type_field.disable_edit
			sched_run_field.disable_edit
			wafer_techn_field.disable_edit
			field_set_field.disable_edit
			step_pattern_field.disable_edit
			overhead_style_field.disable_edit
			other_border_field.disable_edit
			top_overhead_field.disable_edit
			intended_run_field.disable_edit
			description_field.disable_edit
		end
		
	add_buttons
			-- Add buttons to end of `main_vox'
		local
			box: EV_BOX
			buttons: HORIZONTAL_BUTTON_SET
		do
			create buttons.make_with_text_and_actions (<<
				"Edit", "Cancel" >>,
				<< agent process_edit, agent process_cancel >>)
			edit_button := buttons.i_th (1)
			cancel_button := buttons.i_th (2)
			
			box := buttons.column_set.box
			
			main_vbox.extend (box)
			main_vbox.disable_item_expand (box)
			close_request_actions.extend (agent process_cancel)
		end
		
	process_edit
		local
			operation: ANONYMOUS_OPERATION
		do
			if is_active then
				disable_active
				create operation.make (agent process_edit_request)
				operation.enable_abort_caught
				operation.execute
				if operation.aborted then
					enable_active
				else
					edit_actions.call ([])
				end
			end
		end

	process_edit_request
		local
			role_setter: ROLE_SET_OP
		do
			if role /= Void then
				create role_setter
				role_setter.set_role (connection, role, session.environment.db_access_control)
			end
			session.lock
			session.open_log
		end

	wafer_techns_row: WAFER_TECHNS_ROW
			-- Row for wafer techn
		do
			check
				packings_row_not_void: packings_row /= Void
			end
			Result := packings_row.wafer_techns_row
		end

	edit_button: EV_BUTTON
			-- Button to edit packing
	
	cancel_button: EV_BUTTON
			-- Button to end session
	
end
