
indexing
	
	description: "Interface to allow user to specify disposition of %
		%projects whose last copy is deleted during packing"
	author: "David Hollenberg"
	date: "November 29, 2006"

deferred class RC_PACKING_DELETE_IFC
inherit
	ABSTRACT_INTERFACE

feature {NONE} -- Creation

	make_interface
			-- Create interface
		do
			create accept_actions
			create cancel_actions
		end

feature -- Properties

	deleted_projects: LIST [PACKING_PROJECTS_ROW]
			-- List of projects to be deleted

	session: RC_ABSTRACT_PACKING_SESSION
			-- Session used to do packing

	accept_actions: ACTION_SEQUENCE [TUPLE [BOOLEAN, BOOLEAN]]
			-- Action to be invoked when user accepts
			-- current project(s) disposition

	cancel_actions: CLOSED_ACTION_SEQUENCE
			-- Action to be invoked when user clicks on Cancel

feature -- Modification

	set_session (sess: like session)
			-- Set `session' to `sess'
		require
			sess_exists: sess /= Void
		do
			session := sess
		ensure
			session_set: session = sess
		end

	set_deleted_projects (a_list: like deleted_projects)
			-- Set `deleted_projects' to `a_list'
		require
			a_list_not_void: a_list /= Void
		do
			deleted_projects := a_list
		ensure
			deleted_projects_set: deleted_projects = a_list
		end

end
