
indexing
	
	description: "Interface to display information about selected projects %
		%in packer"
	author: "David Hollenberg"
	date: "November 7, 2006"

deferred class RC_PACKING_INFO_IFC
inherit
	ABSTRACT_INTERFACE
	GRIDABLE

feature {NONE} -- Creation

	make_interface
			-- Create interface
		do
			create save_actions
			create cancel_actions
		end

feature -- Properties

	packing: RC_PACKING
			-- Packing

	session: RC_ABSTRACT_PACKING_SESSION
			-- Session used to do packing

	dies: LIST [RETICLE_DIE]
			-- Dies and locations for which information is
			-- to be displayed

	save_actions: ACTION_SEQUENCE [TUPLE [LIST [PACKING_DIE_MULTI_COLUMN_LIST_ROW], LIST [MULTI_COLUMN_LIST_COLUMN [PACKING_DIE_MULTI_COLUMN_LIST_ROW]]]]
			-- Action to be invoked when user clicks on Save

	cancel_actions: CLOSED_ACTION_SEQUENCE
			-- Action to be invoked when user clicks on Cancel

feature -- Modification

	set_session (sess: like session)
			-- Set `session' to `sess'
		require
			sess_exists: sess /= Void
		do
			session := sess
		ensure
			session_set: session = sess
		end

	set_packing (a_packing: like packing)
			-- Set `packing' to `a_packing'
		do
			packing := a_packing
		ensure
			packing_set: packing = a_packing
		end

	set_dies (a_list: like dies)
			-- Set `dies' to `a_list'
		require
			a_list_not_void: a_list /= Void
		do
			dies := a_list
		ensure
			dies_set: dies = a_list
		end

end
