
indexing
	
	description: "Interface to allow user to assign a lot to %
		%projects during packing"
	author: "David Hollenberg"
	date: "December 18, 2006"

deferred class RC_PACKING_LOT_ASSIGN_IFC
inherit
	ABSTRACT_INTERFACE

feature {NONE} -- Creation

	make_interface
			-- Create interface
		do
			create accept_actions
			create cancel_actions
		end

feature -- Properties

	projects: LIST [PACKING_DIES_MROW]
			-- List of projects for which lot is to be assigned

	session: RC_ABSTRACT_PACKING_SESSION
			-- Session used to do packing

	accept_actions: ACTION_SEQUENCE [TUPLE [WAFER_ETEST_NAMES_ROW]]
			-- Action to be invoked when user accepts lot for
			-- current project(s)

	cancel_actions: CLOSED_ACTION_SEQUENCE
			-- Action to be invoked when user clicks on Cancel

feature -- Modification

	set_session (sess: like session)
			-- Set `session' to `sess'
		require
			sess_exists: sess /= Void
		do
			session := sess
		ensure
			session_set: session = sess
		end

	set_projects (a_list: like projects)
			-- Set `projects' to `a_list'
		require
			a_list_not_void: a_list /= Void
		local
			sorter: LIST_BUBBLE_SORTER [PACKING_DIES_MROW]
			comparator: DESIGN_NO_COMPARATOR [PACKING_DIES_MROW]
		do
			create sorter
			create comparator
			projects := sorter.sorted (a_list, comparator)
		ensure
			projects_set: projects = a_list
		end

end
