
indexing
	
	description: "Interface to display summary of project/lot compatbility"
	author: "David Hollenberg"
	date: "December 10, 2006"

deferred class RC_PACKING_LOT_SUMMARY_IFC
inherit
	ABSTRACT_INTERFACE

feature {NONE} -- Creation

	make_interface
			-- Create interface
		do
			create send_actions
			create cancel_actions
		end

feature -- Properties

	packing: RC_PACKING
			-- Packing

	projects_agent: FUNCTION [ANY, TUPLE, LIST [PACKING_DIES_MROW]]
			-- Agent that returns list of distinct dies
			-- for current customer projects

	session: RC_ABSTRACT_PACKING_SESSION
			-- Session used to do packing

	send_actions: ACTION_SEQUENCE [TUPLE [STRING, STRING]]
			-- Actions to be invoked when user clicks on Send

	cancel_actions: CLOSED_ACTION_SEQUENCE
			-- Action to be invoked when user clicks on Cancel

feature -- Modification

	set_session (sess: like session)
			-- Set `session' to `sess'
		require
			sess_exists: sess /= Void
		do
			session := sess
		ensure
			session_set: session = sess
		end

	set_packing (a_packing: like packing)
			-- Set `packing' to `a_packing'
		do
			packing := a_packing
		ensure
			packing_set: packing = a_packing
		end

	set_projects_agent (an_agent: like projects_agent)
			-- Set `projects_agent' to `an_agent'
		require
			an_agent_not_void: an_agent /= Void
		do
			projects_agent := an_agent
		ensure
			projects_agent_set: projects_agent = an_agent
		end

feature -- Operations

	refresh
			-- Refresh contents of interface
		deferred
		end

end
