
indexing
	
	description: "Interface to allow specification of field and location %
		%for absolute move operation in packer"
	author: "David Hollenberg"
	date: "November 7, 2006"

deferred class RC_PACKING_MOVE_ABS_IFC
inherit
	ABSTRACT_INTERFACE
	GRIDABLE

feature {NONE} -- Creation

	make_interface
			-- Create interface
		do
			create accept_actions
			create cancel_actions
		end

feature -- Properties

	element: RETICLE_VIEW_ELEMENT
			-- Element to be moved

	fields: LIST [RETICLE_FIELD]
			-- Fields of view

	max_db_value: DOUBLE
			-- Maximum value that can fit in database

	accept_actions: ACTION_SEQUENCE [TUPLE [STRING, DOUBLE, DOUBLE]]
			-- Action to be invoked when user accepts
			-- current values

	cancel_actions: CLOSED_ACTION_SEQUENCE
			-- Action to be invoked when user clicks on Cancel

feature -- Modification

	set_element (an_element: like element)
			-- Set `element' to `an_element'
		require
			an_list_not_void: an_element /= Void
		do
			element := an_element
		ensure
			element_set: element = an_element
		end

	set_fields (a_list: like fields)
			-- Set `fields' to `a_list'
		require
			a_list_not_void: a_list /= Void
		do
			fields := a_list
		ensure
			fields_set: fields = a_list
		end

	set_max_db_value (a_value: like max_db_value)
			-- Set `max_db_value' to `a_value'
		do
			max_db_value := a_value
		ensure
			max_db_value_set: max_db_value = a_value
		end

end
