
indexing
	
	description: "Interface to display output from packer operations"
	author: "David Hollenberg"
	date: "November 7, 2006"

deferred class RC_PACKING_OUTPUT_IFC
inherit
	ABSTRACT_INTERFACE

feature {NONE} -- Creation

	make_interface
			-- Create interface
		do
			create cancel_actions
		end

feature -- Modification

	set_session (sess: like session)
			-- Set `session' to `sess'
		require
			sess_exists: sess /= Void
		do
			session := sess
		ensure
			session_set: session = sess
		end

feature -- Operations

	process_key_press (a_key: MODIFIED_KEY)
			-- Take actions needed when `a_key' is pressed
		require
			a_key_not_void: a_key /= Void
		deferred
		end

	process_info_added (a_text: STRING)
			-- Take actions needed when informational output
			-- `a_text' is generated
		require
			a_text_not_void: a_text /= Void
		deferred
		end

feature -- Properties

	session: RC_ABSTRACT_PACKING_SESSION
			-- Session used to do packing

	cancel_actions: CLOSED_ACTION_SEQUENCE
			-- Action to be invoked when user clicks on Cancel

end
