
indexing
	
	description: "Interface to allow management of projects while packing"
	author: "David Hollenberg"
	date: "November 7, 2005"

deferred class RC_PACKING_PROJECTS_IFC
inherit
	ABSTRACT_INTERFACE
	EVENT_SUBSCRIBER
		undefine
			default_create
		end

feature {NONE} -- Creation

	make_interface
			-- Create interface
		do
			create send_actions
			create cancel_actions
		end

feature -- Modification

	set_session (sess: like session)
			-- Set `session' to `sess'
		require
			sess_exists: sess /= Void
		do
			session := sess
		ensure
			session_set: session = sess
		end

	set_packing (a_packing: like packing)
			-- Set `packing' to `a_packing'
		require
			a_packing_not_void: a_packing /= Void
		do
			packing := a_packing
		ensure
			packing_set: packing = a_packing
		end

	set_packing_interface (ifc: like packing_interface)
			-- Set `packing_interface' to `ifc'
		require
			ifc_not_void: ifc /= Void
		do
			packing_interface := ifc
		ensure
			interface_set: packing_interface = ifc
		end

	set_is_read_only (b: like is_read_only)
			-- Set `is_read_only' to `b'
		do
			is_read_only := b
		ensure
			read_only_set: is_read_only = b
		end

feature -- Properties

	session: RC_ABSTRACT_PACKING_SESSION
			-- Session used to do packing

	packing: RC_PACKING
			-- Packing

	packing_interface: RC_PACKING_IFC
			-- Packing interface

	is_read_only: BOOLEAN
			-- Is packer in read-only mode?

	send_actions: ACTION_SEQUENCE [TUPLE [STRING, STRING]]
			-- Actions to be invoked when user clicks on Send

	cancel_actions: CLOSED_ACTION_SEQUENCE
			-- Actions to be invoked when user clicks on Cancel

end
