
indexing
	
	description: "Interface to allow searching for projects %
		%in packer"
	author: "David Hollenberg"
	date: "December 11, 2006"

deferred class RC_PACKING_SEARCH_IFC
inherit
	ABSTRACT_INTERFACE

feature {NONE} -- Creation

	make_interface
			-- Create interface
		do
			create search_actions
			create cancel_actions
		end

feature -- Properties

	session: RC_ABSTRACT_PACKING_SESSION
			-- Session used to do packing

	view_elements_agent: FUNCTION [ANY, TUPLE, LIST [RETICLE_VIEW_ELEMENT]]
			-- Agent that returns list of elements in reticle
			-- view

	search_actions: ACTION_SEQUENCE [TUPLE [LIST [INTEGER], BOOLEAN]]
			-- Actions to be invoked when user clicks on Search

	cancel_actions: CLOSED_ACTION_SEQUENCE
			-- Action to be invoked when user clicks on Cancel

feature -- Modification

	set_session (sess: like session)
			-- Set `session' to `sess'
		require
			sess_exists: sess /= Void
		do
			session := sess
		ensure
			session_set: session = sess
		end

	set_view_elements_agent (an_agent: like view_elements_agent)
			-- Set `view_elements_agent' to `an_agent'
		require
			an_agent_not_void: an_agent /= Void
		do
			view_elements_agent := an_agent
		ensure
			view_elements_agent_set: view_elements_agent = an_agent
		end

end
