
indexing
	
	description: "A session for selecting and packing projects"
	author: "David Hollenberg"
	date: "November 7, 2005"

class RC_PACKING_SESSION
inherit
	RC_ABSTRACT_PACKING_SESSION

create
	make_from_session

feature -- Properties

	type: STRING = "Packing"
			-- Type of session

	id_name: STRING = "Packing Id"
			-- Name of session-identifying value
	
	id_value: STRING
			-- Value that identifies session
		do
			Result := packing_id
		end

	has_steps: BOOLEAN = False
			-- Is session activity broken into separate steps?

	error_file_name: STRING
			-- Name of file for error messages
		do
			Result := environment.error_name_for_packing (packing_id)
		end

	log_file_name: STRING
			-- Name of log file for session
		do
			Result := environment.log_name_for_packing (packing_id)
		end

	shared_lock_name: STRING
			-- Name of shared lock file
		do
			Result := environment.shared_lock_name
		end

	exclusive_lock_name: STRING
			-- Name of exclusive lock file
		do
			Result := environment.lock_name_for_packing (packing_id)
		end

	run_id: STRING
			-- Run id, if not Void

feature -- Modification

	set_run_id (s: STRING)
		do
			run_id := s
		end

end

