
indexing
	
	description: "Interface to view and set lot split colors %
		%in packer"
	author: "David Hollenberg"
	date: "December 13, 2006"

deferred class RC_PACKING_SPLIT_COLORS_IFC
inherit
	ABSTRACT_INTERFACE

feature {NONE} -- Creation

	make_interface
			-- Create interface
		do
			create accept_actions
			create cancel_actions
		end

feature -- Properties

	session: RC_ABSTRACT_PACKING_SESSION
			-- Session used to do packing

	packing: PACKINGS_ROW
			-- Packing for which colors are to be set

	split_colors: LIST [PACKING_ETEST_COLORS_MROW]
			-- Existing colors for lot splits
	
	named_colors: LIST [NAMED_COLORS_ROW]
			-- List of supported named colors

	unassigned_color: EV_COLOR
			-- Color to use for lot splits that haven't been
			-- explicitly assigned a color yet

	wafer_etest_names: LIST [WAFER_ETEST_NAMES_ROW]
			-- List of wafer etest names rows (lot splits) for
			-- which colors can be set

	accept_actions: ACTION_SEQUENCE [TUPLE [LIST [PACKING_ETEST_COLORS_ROW], BOOLEAN]]
			-- Action to be invoked when user clicks on OK

	cancel_actions: CLOSED_ACTION_SEQUENCE
			-- Action to be invoked when user clicks on Cancel

feature -- Modification

	set_session (sess: like session)
			-- Set `session' to `sess'
		require
			sess_exists: sess /= Void
		do
			session := sess
		ensure
			session_set: session = sess
		end

	set_packing (a_packing: like packing)
			-- Set `packing' to `a_packing'
		require
			a_packing_exists: a_packing /= Void
		do
			packing := a_packing
		ensure
			packing_set: packing = a_packing
		end

	set_split_colors (a_list: like split_colors)
			-- Set `split_colors' to `a_list'
		require
			a_list_exists: a_list /= Void
		do
			split_colors := a_list
		ensure
			split_colors_set: split_colors = a_list
		end

	set_unassigned_color (a_value: like unassigned_color)
			-- Set `unassigned_color' to `a_value'
		require
			a_value_exists: a_value /= Void
		do
			unassigned_color := a_value
		ensure
			unassigned_color_set: unassigned_color = a_value
		end

	set_wafer_etest_names (a_list: like wafer_etest_names)
			-- Set `wafer_etest_names' to `a_list'
		require
			a_list_exists: a_list /= Void
		do
			wafer_etest_names := a_list
		ensure
			wafer_etest_names_set: wafer_etest_names = a_list
		end

	set_named_colors (a_list: like named_colors)
			-- Set `named_colors' to `a_list'
		require
			a_list_exists: a_list /= Void
		do
			named_colors := a_list
		ensure
			named_colors_set: named_colors = a_list
		end

end
