
indexing
	
	description: "Interface to allow selection of an existing packing version"
	author: "David Hollenberg"
	date: "November 7, 2005"

deferred class RC_PACKING_VERSIONS_IFC
inherit
	ABSTRACT_INTERFACE
	EVENT_SUBSCRIBER
		undefine
			default_create
		end

feature {NONE} -- Creation

	make_interface
			-- Create interface
		do
			create select_actions
			create send_actions
			create cancel_actions
		end

feature -- Modification

	set_session (sess: like session)
			-- Set `session' to `sess'
		require
			sess_exists: sess /= Void
		do
			session := sess
		ensure
			session_set: session = sess
		end

feature -- Properties

	session: RC_ABSTRACT_PACKING_SESSION
			-- Session used to do packing

	select_actions: ACTION_SEQUENCE [TUPLE [PACKING_VERSIONS_ROW]]
			-- Action to be invoked when user selects
			-- a packing version

	send_actions: ACTION_SEQUENCE [TUPLE [STRING, STRING]]
			-- Actions to be invoked when user clicks on Send

	cancel_actions: CLOSED_ACTION_SEQUENCE
			-- Action to be invoked when user clicks on Cancel

end
