
indexing
	
	description: "A run closing session for closing a real run"
	author: "David Hollenberg"
	date: "May 1, 2003"

class RC_REAL_RUN_SESSION
inherit
	RC_RUN_CLOSING_SESSION
		redefine
			primitive_step_implementation
		end

create
	make_run_session

feature -- Properties

	type: STRING = "Real run closing"
			-- Type of session

	is_trial_run: BOOLEAN = False
			-- Is this a session for closing a trial run?

	is_standard_run_id (s: STRING): BOOLEAN
			-- Is `s' a standard run id for this session?
		do
			Result := rc.is_standard_real_run_id (s)
		end

	run_reality_type: STRING = "Real"
			-- Text describing whether run is real

	run_directory: STRING
			-- Name of run directory
		do
			Result := environment.run_directory_for_real_run (run_id)
		end

	probing_run_directory: STRING
			-- Name of run directory for probing purposes
		do
			Result := environment.probing_directory_for_real_run (run_id)
		end

	primitive_step_implementation (step: RC_PRIMITIVE_STEP): RC_PRIMITIVE_STEP_OP
			-- New object which is implementation for
			-- primitive step `step'
		do
			Result := precursor (step)
			if Result = Void then
				create {UNIMPLEMENTED_STEP_OP} Result.make (step, Current)
			end
		ensure then
			result_exists: Result /= Void
		end
end
