
indexing
	
	description: "An object that can become associated with a run %
		%closing session."
	author: "David Hollenberg"
	date: "June 9, 2002"

deferred class RC_SESSIONABLE
inherit
	ANY
		undefine
			default_create
		end

feature -- Properties

	session: RC_RUN_CLOSING_SESSION
			-- Session used to close run

	connection: DB_CONNECTION
			-- Connection to use for database access
		do
			Result := session.connection
		ensure
			result_exists: Result /= Void
		end

	cache: RUN_CACHE
			-- Run-specific cache
		do
			Result := session.cache
		ensure
			result_exists: Result /= Void
		end

feature -- Modification

	set_session (sess: RC_RUN_CLOSING_SESSION)
			-- Set `session' to `sess'
		require
			sess_exists: sess /= Void
		do
			session := sess
		ensure
			session_set: session = sess
		end

end
