
indexing
	
	description: "Interface to present information about the status of %
		%a run"
	author: "David Hollenberg"
	date: "May 27, 2003"

deferred class RC_STATUS_IFC

inherit
	ABSTRACT_INTERFACE
	RC_SESSIONABLE
	EVENT_SUBSCRIBER
		undefine
			default_create
		end
		
feature {NONE} -- Creation

	make_interface
			-- Create interface
		do
			create decline_actions
		end

feature -- Modification

	destroy
			-- Destroy interface
		deferred
		end

	refresh
			-- Refresh information in interface so that
			-- it is up-to-date
		deferred
		end

feature -- Properties

	primitive_steps: LIST [RC_PRIMITIVE_STEP]
			-- Primitive run closing steps

	decline_actions: CLOSED_ACTION_SEQUENCE
			-- Actions to be performed when user declines to
			-- proceed

feature -- Modification

	set_primitive_steps (list: LIST [RC_PRIMITIVE_STEP])
			-- Set `primitive_steps' to `list'
		require
			list_exists: list /= Void
		do
			primitive_steps := list
		ensure
			value_set: primitive_steps = list
		end

end
