
indexing
	
	description: "An operation that does something with a regular %
		%expression, such as compile it"
	author: "David Hollenberg"
	date: "March 10, 2004"

class REGEXP_OP
inherit
	OPERATION
		rename
			try_operation as try_compile
		end

create
	default_create

feature -- Properties

feature -- Operations

	compile (r: RX_PCRE_REGULAR_EXPRESSION pat: STRING)
			-- Compile `pat' into `r'
		require
			regexp_exists: r /= Void
			pattern_exists: pat /= Void
		do
			regexp := r
			pattern := pat
			execute
		end

feature {NONE} -- Implementation

	try_compile
			-- Try to compile regular expression
		local
			error: REGEXP_COMPILE_ERROR
		do
			regexp.compile (pattern)
			if not regexp.is_compiled then
				create error
				error.set_hard_error
				error.disable_retry
				error.set_expression (regexp)
				error.set_pattern (pattern)
				error.handle
			end
		end

	regexp: RX_PCRE_REGULAR_EXPRESSION
			-- Regular expression

	pattern: STRING
			-- Pattern with which to compile regular expression

end
