class REGULAR_EXPRESSION_ELEMENTS
	-- a set of pre-defined regular expression elements,
	-- defined solely to improve readability

feature	-- the basic elements

	beginning_anchor: STRING = "^"

	ending_anchor: STRING = "$"

	zero_or_one: STRING = "?"

	mandatory_character: STRING = "."
			-- Excludes newline

	mandatory_characters: STRING = ".+"
			-- Excludes newline

	optional_characters: STRING = ".*"
			-- Excludes newline

	period: STRING = "\."

	optional_white_space: STRING = "[ \t]*"
	
	mandatory_white_space: STRING = "[ \t]+"

	mandatory_black_space: STRING = "[^ \t]+"

	mandatory_integer: STRING = "[0-9]+"

	mandatory_signed_integer: STRING = "-?[0-9]+"

	mandatory_pseudo_fixed: STRING = "[0-9\.]+"
		-- (accepts any number of decimal points)

	mandatory_signed_fixed: STRING = "-?[0-9\.]+"

	mandatory_signed_real: STRING = "-?[0-9\.]+(e-?[0-9]+)?"

feature	-- captured element

	captured(element: STRING): STRING
		-- "captures" the matching value for captured_substring
	do  create Result.make(element.count+2)
	    Result.extend('(')
	    Result.append(element)
	    Result.extend(')')
	end

	optional (element: STRING): STRING
			-- Matches zero or one occurrence of `element'
		do
			create Result.make (element.count + 3)
	    		Result.extend ('(')
	    		Result.append (element)
	    		Result.extend (')')
	    		Result.append (Zero_or_one)
		end

end
