
indexing
	
	description: "Action that resize scribe"
	author: "David Hollenberg"
	date: "October 31, 2006"

class RESIZE_SCRIBE_ACTION
inherit
	VIEW_ELEMENT_ACTION

feature -- Properties

	resize_amount: CONST_POINT
			-- Point that specifies how much to resize scribe

	is_left_or_bottom_resize: BOOLEAN
			-- Does resize of scribe move the left edge
			-- (for horizontal scribe) or bottom edge (for
			-- vertical scribe)?  If not, it moves right or
			-- top edge

feature -- Modification

	set_resize_amount (a_point: like resize_amount)
			-- Set `resize_amount' to `a_point'
		require
			a_point_not_void: a_point /= Void
		do
			resize_amount := a_point
		ensure
			resize_amount_set: resize_amount = a_point
		end

	set_is_left_or_bottom_resize (a_value: like is_left_or_bottom_resize)
			-- Set `is_left_or_bottom_resize' to `a_value'
		do
			is_left_or_bottom_resize := a_value
		ensure
			is_left_or_bottom_resize_set: is_left_or_bottom_resize = a_value
		end

feature -- Operations

	apply (an_element: RETICLE_VIEW_ELEMENT)
			-- Apply action to `an_element'
		do
			an_element.resize_by (resize_amount, is_left_or_bottom_resize)
			if an_element.is_selected then
				an_element.include_in_selection_bounding_box
			end
			an_element.add_old_and_new_to_changed_region
			an_element.add_change (create {SCRIBE_END_POSITION_CHANGE}.make (an_element, resize_amount.x, resize_amount.y, is_left_or_bottom_resize))
		end

end
