
indexing
	
	description: "Unix-specific constants related to resource limits"
	author: "David Hollenberg"
	date: "May 30, 2001"

class RESOURCE_LIMIT_CONSTANTS

feature -- Resource codes

	Rlimit_core: INTEGER
			-- Resource code for maximum size of core file that
			-- may be created by process in bytes
		external
			"C macro use <sys/resource.h>"
		alias
			"RLIMIT_CORE"
		end
	
	Rlimit_cpu: INTEGER
			-- Resource code for maximum amount of CPU time
			-- that may be used by process in seconds
		external
			"C macro use <sys/resource.h>"
		alias
			"RLIMIT_CPU"
		end
		
	Rlimit_data: INTEGER
			-- Resource code for maximum size of process heap
			-- in bytes
		external
			"C macro use <sys/resource.h>"
		alias
			"RLIMIT_DATA"
		end
		
	Rlimit_fsize: INTEGER
			-- Resource code for maximum size of size of file
			-- that may be created by process in bytes
		external
			"C macro use <sys/resource.h>"
		alias
			"RLIMIT_FSIZE"
		end
		
	Rlimit_nofile: INTEGER
			-- Resource code for one more than the maximum value
			-- system may assign to newly created file descriptor
		external
			"C macro use <sys/resource.h>"
		alias
			"RLIMIT_NOFILE"
		end
		
	Rlimit_stack: INTEGER
			-- Resource code for maximum size of process stack
			-- in bytes
		external
			"C macro use <sys/resource.h>"
		alias
			"RLIMIT_STACK"
		end
		
	Rlimit_vmem: INTEGER
			-- Resource code for maximum size of process
			-- mapped address space in bytes
		external
			"C macro use <sys/resource.h>"
		alias
			"RLIMIT_VMEM"
		end
		
feature -- Properties

	Rlim_infinity: INTEGER
			-- Value for "infinite" resource limit
		external
			"C macro use <sys/resource.h>"
		alias
			"RLIM_INFINITY"
		end
		
end
