class RESPONSE_COUNTER
		-- used for those (repeatable) responses for which we
		-- wish to cut off responses after a few and just
		-- summarize the total number of occurrences when there
		-- are a lot

inherit
	SEVERITY_LEVELS

create
	make

feature  -- attributes

	severity: INTEGER
		-- severity level (of this id) so summary can attain same
		-- level

	id: STRING
		-- short error id (usually the message_id)

	actual_occurrences: INTEGER
		-- number of times this response has arisen
		-- (only the first max_occurrences are posted; the rest
		--  are summarized)

	max_occurrences: INTEGER
		-- max number of times to post this response
		-- (usually 1)

	summary_template: STRING
		-- text for summary line
		-- summary is to be generated when actual > max

feature  -- creation (or reuse)

	make(nid: STRING; sev, maxo: INTEGER; summ: STRING) is
	require nid /= Void and summ /= Void;
		maxo > 0;
		is_severity_level(sev)
	do id := nid;
	   severity := sev;
	   actual_occurrences := 0;
	   max_occurrences := maxo;
	   summary_template := summ;
	end;

feature -- status

	maxxed_out: BOOLEAN is
	do  Result := actual_occurrences > max_occurrences
	end;

	additional_occurences: INTEGER is
	require maxxed_out
	do  Result := actual_occurrences - max_occurrences
	ensure Result > 0
	end;

feature -- counting

	bump is
	do  actual_occurrences := actual_occurrences + 1;
	end;

	reset is
	do  actual_occurrences := 0;
	end;

invariant

	id /= Void

end -- RESPONSE_COUNTER
