class RESPONSE_ITEM
		-- 

inherit
	SEVERITY_LEVELS

create
	make

feature  -- attributes

	severity: INTEGER
		-- is_severity_level

	id: STRING
		-- short error id (usually the message_id)

	text: STRING
		-- arbitrary long text, with values filled in

	is_retractable: BOOLEAN
		-- retract this item (on a rollback)

feature  -- status

	is_in_error: BOOLEAN is
		-- are we at error (or higher) severity?
	do  Result := severity >= severity_is_error
	end;

	is_null: BOOLEAN is
		-- is this the message_is_null message?
	do  Result := severity = severity_is_null
	end;

feature -- change of severity, retractability

	downgrade(lvl: INTEGER) is
		-- downgrade me to severity lvl
	require is_severity_level(lvl)
	do if severity > lvl then severity := lvl end;
	ensure  severity <= lvl
	end;

	upgrade(lvl: INTEGER) is
		-- upgrade me to severity lvl
	require is_severity_level(lvl)
	do if severity < lvl then severity := lvl end;
	ensure  severity >= lvl
	end;

	set_is_retractable(r: BOOLEAN) is
		-- set is_retractable to r
	do  is_retractable := r
	ensure is_retractable = r
	end;

feature -- creation (or reuse)

	make(lvl: INTEGER; nid, ntext: STRING) is
	require is_severity_level(lvl)
		nid /= Void and ntext /= Void
	do severity := lvl;
	   id := nid;
	   text := ntext;
	end;

invariant
	is_severity_level(severity)
	id /= Void
	text /= Void

end -- RESPONSE_ITEM
