
indexing

	date: "Tue Apr 24 10:30:15 2007"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application NFE, database user DHOLLEN"
	database_tables: 
		"RESPONSE_TEXT_TEMPLATES (MOSIS.RESPONSE_TEXT_TEMPLATES)"
			-- Included columns
			-- 	APPLICATION
			-- 	MAX_OCCURRENCES
			-- 	MESSAGE_ID
			-- 	MESSAGE_TEMPLATE
			-- 	SEVERITY
			-- 	SUMMARY_TEMPLATE
			-- Excluded columns
			-- 	(none)

class RESPONSE_TEXT_TEMPLATES_RAW

inherit

	DB_IDENTIFIED_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_application: STRING; the_message_id: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_application_exists: the_application /= Void
			the_message_id_exists: the_message_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			application := the_application
			message_id := the_message_id
			is_null_application := False
			is_null_message_id := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 6

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  application, max_occurrences, message_id, message_template, severity,%N  summary_template"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "response_text_templates rtt"

	join_condition: STRING = ""

	table_name: STRING = "response_text_templates"

	key_where_clause: STRING = "application = :1 and message_id = :2"

feature -- Values

	application: STRING
			-- DB: VARCHAR2(50) not null

	max_occurrences: INTEGER
			-- DB: NUMBER(3,0)

	message_id: STRING
			-- DB: VARCHAR2(20) not null

	message_template: STRING
			-- DB: VARCHAR2(2000) not null

	severity: CHARACTER
			-- DB: CHAR(1) not null
			-- Eiffel type specified explicitly

	summary_template: STRING
			-- DB: VARCHAR2(255)

feature -- Nullness for null allowed columns

	is_null_max_occurrences: BOOLEAN
	is_null_summary_template: BOOLEAN

feature -- Nullness for non-null columns

	is_null_application: BOOLEAN
	is_null_message_id: BOOLEAN
	is_null_message_template: BOOLEAN
	is_null_severity: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (application, r.application)
				and equal (message_id, r.message_id)
			Result := Result
				and is_null_application = r.is_null_application
				and is_null_message_id = r.is_null_message_id
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and max_occurrences = r.max_occurrences
				and severity = r.severity
			Result := Result
				and equal (message_template, r.message_template)
				and equal (summary_template, r.summary_template)
			Result := Result
				and is_null_max_occurrences = r.is_null_max_occurrences
				and is_null_message_template = r.is_null_message_template
				and is_null_severity = r.is_null_severity
				and is_null_summary_template = r.is_null_summary_template
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 50)
			q.select_integer (2)
			q.select_string (3, 20)
			q.select_string (4, 2000)
			q.select_character (5)
			q.select_string (6, 255)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			max_occurrences := q.integer_value (2)
			severity := q.character_value (5)
		end

	fill_in_references (q: SQL_QUERY)
		do
			application := q.string_value (1)
			message_id := q.string_value (3)
			message_template := q.string_value (4)
			summary_template := q.string_value (6)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, application)
			q.get_string_value (3, message_id)
			q.get_string_value (4, message_template)
			q.get_string_value (6, summary_template)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_application := q.is_null (1)
			is_null_max_occurrences := q.is_null (2)
			is_null_message_id := q.is_null (3)
			is_null_message_template := q.is_null (4)
			is_null_severity := q.is_null (5)
			is_null_summary_template := q.is_null (6)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_application := True
			is_null_message_id := True
			create application.make (0)
			create message_id.make (0)
		end

	set_null_nonkey
		do
			is_null_max_occurrences := True
			is_null_message_template := True
			is_null_severity := True
			is_null_summary_template := True
			create message_template.make (0)
			create summary_template.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, application, False)
			q.bind_num_to_string (2, message_id, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and max_occurrences = q.integer_value (2)
				and severity = q.character_value (5)
			q.get_string_value (1, s)
			Result := Result and equal (application, s)
			q.get_string_value (3, s)
			Result := Result and equal (message_id, s)
			q.get_string_value (4, s)
			Result := Result and equal (message_template, s)
			q.get_string_value (6, s)
			Result := Result and equal (summary_template, s)
			Result := Result
				and is_null_application = q.is_null (1)
				and is_null_max_occurrences = q.is_null (2)
				and is_null_message_id = q.is_null (3)
				and is_null_message_template = q.is_null (4)
				and is_null_severity = q.is_null (5)
				and is_null_summary_template = q.is_null (6)
		end

end
