
indexing
	
	description: "Customer die element of reticle model"
	author: "David Hollenberg"
	date: "July 28, 2006"

class RETICLE_CUST_DIE
inherit
	RETICLE_PROJECT
		redefine
			is_cust_project, wafer_etest_id, has_wafer_etest_id,
			compatible_wafer_etest_ids, compatible_wafer_etest_names,
			assigned_wafer_etest_id, unassigned_wafer_etest_ids,
			assigned_wafer_etest_name,
			wafer_etest_name, is_reworkable
		end
	STRING_UTILITIES_ACCESS
		export
			{NONE} all
		end

create
	make

feature -- Properties

	is_cust_project: BOOLEAN = True
			-- Is element a customer project?

	wafer_etest_id: STRING
			-- Wafer etest IDs for element
		do
			Result := su.joined_by (project.compatible_wafer_etest_ids, ", ")
		end

	wafer_etest_name: STRING
			-- Wafer etest name for element
		local
			name_row: WAFER_ETEST_NAMES_ROW
		do
			name_row := die.assigned_wafer_etest_name
			if name_row /= Void then
				Result := name_row.wafer_etest_name
			else
				Result := ""
			end
		end

	assigned_wafer_etest_id: STRING
			-- Wafer etest ID assigned to element or empty string
			-- if none assigned yet or if not applicable
		do
			Result := die.assigned_wafer_etest_id
		end

	assigned_wafer_etest_name: WAFER_ETEST_NAMES_ROW
			-- Wafer etest name assigned to element or Void
			-- if none assigned yet
		do
			Result := die.assigned_wafer_etest_name
		end

	unassigned_wafer_etest_ids: LIST [STRING]
			-- Wafer etest IDs not assigned to element or
			-- empty string if no unassigned etest IDs or
			-- if not applicable
		do
			Result := die.unassigned_wafer_etest_ids
		end

	compatible_wafer_etest_ids: LIST [STRING]
			-- Compatible wafer etest IDs for element
		do
			Result := project.compatible_wafer_etest_ids
		end

	compatible_wafer_etest_names: LIST [WAFER_ETEST_NAMES_ROW]
			-- Compatible wafer etest names rows for element
		do
			Result := project.compatible_wafer_etest_names
		end

	has_wafer_etest_id: BOOLEAN = True
			-- Does object have associated wafer etest ID(s)?

	is_reworkable: BOOLEAN
			-- Is element currently reworkable?
		do
			Result := project.is_reworkable
		end

feature -- Contract support

	is_valid_for_creation (a_die: like die): BOOLEAN
			-- Is `a_die' have a die type that is valid
			-- for creation of `Current'?
		do
			Result := a_die.is_cust_die
		end

end
