
indexing
	
	description: "Filler element of reticle model"
	author: "David Hollenberg"
	date: "July 28, 2006"

class RETICLE_FILLER
inherit
	RETICLE_DIE
		redefine
			is_filler, can_be_isolated
		end

create
	make

feature -- Properties

	identification: STRING
			-- Identifying name of element
		do
			Result := "FILLER_" + die.filler_name
		end

	is_filler: BOOLEAN = True
			-- Is element a filler?

	can_be_isolated: BOOLEAN = True
			-- Is `Current' allowed to be isolated, based on its
			-- type?

feature -- Contract support

	is_valid_for_creation (a_die: like die): BOOLEAN
			-- Is `a_die' have a die type that is valid
			-- for creation of `Current'?
		do
			Result := a_die.is_filler
		end

end
