
indexing
	
	description: "Named view, which determines how elements of view %
		%appear when drawn (colors, fill, transparency, label)"
	author: "David Hollenberg"
	date: "January 25, 2007"

class RETICLE_NAMED_VIEW

create
	make

feature {NONE} -- Creation
	
	make (a_name: STRING a_label_generator: RETICLE_VIEW_ELEMENT_LABEL_GENERATOR a_color_generator: RETICLE_VIEW_ELEMENT_COLOR_GENERATOR a_fill_generator: RETICLE_VIEW_ELEMENT_FILL_GENERATOR an_opacity_generator: RETICLE_VIEW_ELEMENT_OPACITY_GENERATOR)
			-- Create with `a_name', `a_label_generator',
			-- `a_color_generator', `a_fill_generator', and
			-- `an_opacity_generator'
		do
			name := a_name
			label_generator := a_label_generator
			color_generator:= a_color_generator
			fill_generator := a_fill_generator
			opacity_generator := an_opacity_generator
		end

feature -- Properties

	label_generator: RETICLE_VIEW_ELEMENT_LABEL_GENERATOR
			-- Generator for text to display to label elements

	color_generator: RETICLE_VIEW_ELEMENT_COLOR_GENERATOR
			-- Generator for colors to use to display elements

	fill_generator: RETICLE_VIEW_ELEMENT_FILL_GENERATOR
			-- Generator for "filled" indicator to use to
			-- display elements

	opacity_generator: RETICLE_VIEW_ELEMENT_OPACITY_GENERATOR
			-- Generator for opaqueness or transparency
			-- indicator to use to display elements

	name: STRING
			-- Name of named view

end
