
indexing
	
	description: "Comparator for object that is can be scanned horizontally in reticle packer"
	author: "David Hollenberg"
	date: "February 4, 2007"

class RETICLE_SCANNABLE_X_COMPARATOR [G -> RETICLE_SCANNABLE_X]
inherit
	KL_COMPARATOR [G]

feature -- Status report

	less_than (u, v: G): BOOLEAN
			-- Is `u' considered less than `v'?
		do
			if u.has_gridded_center_x and v.has_gridded_center_x then
				if u.has_fixed_in_x and v.has_fixed_in_x then
					if u.gridded_center_x < v.gridded_center_x then
						Result := True
					elseif u.gridded_center_x = v.gridded_center_x then
						if not u.is_fixed_in_x and not v.is_fixed_in_x then
							-- Both movable
							-- Decide based on Y
							if u.has_gridded_center_y and v.has_gridded_center_y then
								Result := u.gridded_center_y < v.gridded_center_y
							elseif v.has_gridded_center_y then
								Result := True
							else
								Result := False
							end
						elseif u.is_fixed_in_x and v.is_fixed_in_x then
							-- Both fixed
							if u.has_gridded_size_x and v.has_gridded_size_x then
								Result := u.gridded_size_x < v.gridded_size_x
							elseif v.has_gridded_size_x then
								Result := True
							else
								Result := False
							end
						else
							Result := u.is_fixed_in_x and not v.is_fixed_in_x
						end
					else
						Result := False
					end
				elseif v.has_fixed_in_x then
					Result := True
				else
					Result := False
				end
			elseif v.has_gridded_center_x then
				Result := True
			else
				Result := False
			end
		end

end
