
indexing
	
	description: "Comparator for object that is can be scanned vertically in reticle packer"
	author: "David Hollenberg"
	date: "November 18, 2003"

class RETICLE_SCANNABLE_Y_COMPARATOR [G -> RETICLE_SCANNABLE_Y]
inherit
	KL_COMPARATOR [G]

feature -- Status report

	less_than (u, v: G): BOOLEAN
			-- Is `u' considered less than `v'?
		do
			if u.has_gridded_center_y and v.has_gridded_center_y then
				if u.has_fixed_in_y and v.has_fixed_in_y then
					if u.gridded_center_y < v.gridded_center_y then
						Result := True
					elseif u.gridded_center_y = v.gridded_center_y then
						if not u.is_fixed_in_y and not v.is_fixed_in_y then
							-- Both movable
							-- Decide based on X
							if u.has_gridded_center_x and v.has_gridded_center_x then
								Result := u.gridded_center_x < v.gridded_center_x
							elseif v.has_gridded_center_x then
								Result := True
							else
								Result := False
							end
						elseif u.is_fixed_in_y and v.is_fixed_in_y then
							-- Both fixed
							if u.has_gridded_size_y and v.has_gridded_size_y then
								Result := u.gridded_size_y < v.gridded_size_y
							elseif v.has_gridded_size_y then
								Result := True
							else
								Result := False
							end
						else
							Result := u.is_fixed_in_y and not v.is_fixed_in_y
						end
					else
						Result := False
					end
				elseif v.has_fixed_in_y then
					Result := True
				else
					Result := False
				end
			elseif v.has_gridded_center_y then
				Result := True
			else
				Result := False
			end
		end

end
