
indexing
	
	description: "Colors for a reticle view"
	author: "David Hollenberg"
	date: "July 25, 2006"

class RETICLE_VIEW_COLORS
inherit
	VIEW_COLORS
	RC_POLICIES_ACCESS
		export
			{NONE} all
		undefine
			default_create
		end
	

feature -- Properties

	current_background_color: EV_COLOR
			-- Set current background color to use

	standard_background_color: EV_COLOR
			-- Standard background color

	fully_zoomed_in_background_color: EV_COLOR
			-- Background color to use when fully zoomed in
			-- and cannot zoom in any farther

	unselectable_color: EV_COLOR
			-- Foreground color to use for items that are not
			-- selectable

	default_border_color: EV_COLOR
			-- Default foreground color to use for border
			-- for items that are selectable

	default_label_color: EV_COLOR
			-- Default foreground color to use for label
			-- for items that are selectable

	default_fill_color: EV_COLOR
			-- Default fill color to use for for items
			-- that are selectable and are filled

	not_fixed_in_x_or_y_color: EV_COLOR
			-- Foreground color to use for selectable
			-- items that are not fixed in X or Y

	fixed_in_x_only_color: EV_COLOR
			-- Foreground color to use for selectable
			-- items that are fixed in X but not fixed in
			-- Y

	fixed_in_y_only_color: EV_COLOR
			-- Foreground color to use for selectable
			-- items that are fixed in Y but not fixed in
			-- X

	fixed_in_x_and_y_color: EV_COLOR
			-- Foreground color to use for selectable
			-- items that are fixed in both X and Y

	not_locked_in_x_or_y_color: EV_COLOR
			-- Foreground color to use for selectable
			-- items that not are locked in position in X or Y
			-- not in Y

	locked_in_x_only_color: EV_COLOR
			-- Foreground color to use for selectable
			-- items that are locked in position in X but
			-- not in Y

	locked_in_y_only_color: EV_COLOR
			-- Foreground color to use for selectable
			-- items that are locked in position in Y but
			-- not in X

	locked_in_x_and_y_color: EV_COLOR
			-- Foreground color to use for selectable
			-- items that are locked in position in both X
			-- and Y

	has_max_die_size_color: EV_COLOR
			-- Foreground color to use for selectable
			-- items that have a maximum die size and
			-- the maximum is not too close to the min die size

	tight_fit_color: EV_COLOR
			-- Foreground color to use for selectable
			-- items that have a maximum die size and
			-- the maximum is close to the min die size

	no_max_die_size_color: EV_COLOR
			-- Foreground color to use for selectable
			-- items that do not have a maximum die size

	no_packaging_color: EV_COLOR
			-- Foreground color to use for selectable
			-- items that do not have any packaging

	ceramic_packaging_color: EV_COLOR
			-- Foreground color to use for selectable
			-- items that have only ceramic packaging

	plastic_packaging_color: EV_COLOR
			-- Foreground color to use for selectable
			-- items that have only plastic packaging

	ceramic_and_plastic_packaging_color: EV_COLOR
			-- Foreground color to use for selectable
			-- items that have both ceramic and plastic packaging

	search_match_color: EV_COLOR
			-- Foreground color to use for items that matched
			-- search criteria for last search

	search_no_match_color: EV_COLOR
			-- Foreground color to use for items that did not
			-- match search criteria for last search

	search_match_fill_color: EV_COLOR
			-- Color to use to fill elements that matched search
			-- criteria for last search

	highlighted_selected_color: EV_COLOR
			-- Foreground color to use for items that are selected
			-- when selected items are highlighted

	highlighted_unselected_color: EV_COLOR
			-- Foreground color to use for items that are
			-- selectable but not currently selected when selected
			-- items are highlighted

	highlighted_selected_fill_color: EV_COLOR
			-- Color to use to fill elements that are selected
			-- when selected items are highlighted

	commercial_project_color: EV_COLOR
			-- Foreground color to use for commercial projects

	mep_project_color: EV_COLOR
			-- Foreground color to use for MEP projects

	other_project_color: EV_COLOR
			-- Foreground color to use for projects that are
			-- not commercial or MEP

	non_project_color: EV_COLOR
			-- Foreground color to use for elements that are
			-- not projects (e.g., scribes, fillers, etc)

	external_overhead_color: EV_COLOR
			-- Foreground color to use for elements that have
			-- external overhead

	internal_overhead_color: EV_COLOR
			-- Foreground color to use for elements that have
			-- internal overhead

	none_overhead_color: EV_COLOR
			-- Foreground color to use for elements that have
			-- no overhead (but for which overhead makes sense)

	no_overhead_color: EV_COLOR
			-- Foreground color to use for elements that
			-- have no overhead (and for which overhead
			-- does not make sense)

	cut_color: EV_COLOR
			-- Foreground color to use for elements that are cuts

	selected_fill_color: EV_COLOR
			-- Color to use to fill elements that are selected,
			-- when fill of selected elements is requested

	unselected_fill_color: EV_COLOR
			-- Color to use to fill elements that are not selected,
			-- when fill of unselected elements is requested

	locked_in_x_fill_color: EV_COLOR
			-- Color to use to fill elements that are locked in X,
			-- when fill of these elements is requested

	locked_in_y_fill_color: EV_COLOR
			-- Color to use to fill elements that are locked in Y,
			-- when fill of these elements is requested

	locked_in_x_and_y_fill_color: EV_COLOR
			-- Color to use to fill elements that are locked in X
			-- and Y, when fill of these elements is
			-- and Y, requested

	no_max_die_size_fill_color: EV_COLOR
			-- Color to use to fill elements that have no
			-- maximum die size, when fill of these
			-- elements is requested

	standard_rubber_box_color: EV_COLOR
			-- Standard foreground color to use when drawing
			-- rubber boxes

	too_small_rubber_box_color: EV_COLOR
			-- Foreground color to use when drawing rubber
			-- boxes that are smaller than allowed for the
			-- operation in progress

	horizontal_scribe_rubber_box_color: EV_COLOR
			-- Foreground color to use when drawing rubber
			-- boxes for creation of horizontal scribes

	vertical_scribe_rubber_box_color: EV_COLOR
			-- Foreground color to use when drawing rubber
			-- boxes for creation of vertical scribes

	standard_move_box_color: EV_COLOR
			-- Foreground color to use when drawing box
			-- that shows outline of bounding box for items
			-- to be moved

	standard_duplicate_box_color: EV_COLOR
			-- Foreground color to use when drawing box
			-- that shows outline of bounding box for items
			-- to be duplicated

	no_lot_color_assigned_color: EV_COLOR
			-- Foreground color to use in Lot Split view
			-- for projects whose lot has not yet had a color
			-- assigned by user

	no_lot_assigned_color: EV_COLOR
			-- Foreground color to use in Lot Split view
			-- for projects which have not yet been assigned
			-- a lot

	no_validity_issues_color: EV_COLOR
			-- Foreground color to use in Validity Check view
			-- for objects which have no validity issues

	multiple_validity_issues_color: EV_COLOR
			-- Foreground color to use in Validity Check view
			-- for objects which have multiple validity issues

	unlocked_or_unassigned_color: EV_COLOR
			-- Foreground color to use in Validity Check view
			-- for customer projects which are not locked against
			-- customer update or are not assigned to run
			-- being closed

	outside_all_fields_color: EV_COLOR
			-- Foreground color to use in Validity Check view
			-- for objects which are completely outside all
			-- fields of view

	overlaps_field_edge_color: EV_COLOR
			-- Foreground color to use in Validity Check view
			-- for objects which overlap a field of view edge

	overlaps_another_object_color: EV_COLOR
			-- Foreground color to use in Validity Check view
			-- for objects which overlap a field of view edge

	below_minimum_size_color: EV_COLOR
			-- Foreground color to use in Validity Check view
			-- for objects which are below the minimum size
			-- in either dimension

	needs_lot_assignment_color: EV_COLOR
			-- Foreground color to use in Validity Check view
			-- for projects which do not have a specific
			-- wafer etest ID assigned

	floating_scribe_color: EV_COLOR
			-- Foreground color to use in Validity Check
			-- view for floating scribes (either end does
			-- not abut field of view edge or scribe of
			-- opposite orientation)

	misaligned_scribe_color: EV_COLOR
			-- Foreground color to use in Validity Check
			-- view for misaligned scribes (not quite lined up)

	too_close_to_object_color: EV_COLOR
			-- Foreground color to use in Validity Check
			-- view for objects which are too close to
			-- another object

	too_close_to_edge_color: EV_COLOR
			-- Foreground color to use in Validity Check
			-- view for objects which are too close to
			-- field of view edge

	small_but_legal_color: EV_COLOR
			-- Foreground color to use in Validity Check
			-- view for objects which are above minimum size
			-- but are small and so might be errors

	cut_die_too_big_color: EV_COLOR
			-- Foreground color to use in Validity Check
			-- view for projects whose cut die size exceeds
			-- their maximum die size

	not_isolated_in_cut_die_color: EV_COLOR
			-- Foreground color to use in Validity Check
			-- view for projects which are not isolated in
			-- their cut die

	not_centered_in_cut_die_color: EV_COLOR
			-- Foreground color to use in Validity Check
			-- view for projects which are not centered in
			-- their cut die

	wafer_etest_name_color (a_wafer_etest_name: STRING): EV_COLOR
			-- Foreground color to use in Lot Split view
			-- for project whose assigned wafer etest name
			-- is `a_wafer_etest_name'
		require
			a_wafer_etest_name_not_void: a_wafer_etest_name /= Void
		do
			if a_wafer_etest_name.is_empty then
				-- No lot assigned yet
				Result := no_lot_assigned_color
			else
				split_colors_table.search (a_wafer_etest_name)
				if split_colors_table.found then
					Result := split_colors_table.found_item.to_ev_color
				else
					Result := no_lot_color_assigned_color
				end
			end
		end

	measurement_marker_color: EV_COLOR
			-- Foreground color to use for marking locations
			-- when measuring distances

	isolated_in_curr_pattern_fill_color: EV_COLOR
			-- Color to use to fill elements that are isolated
			-- in current cut pattern, when fill of these
			-- elements is requested

	isolated_in_other_pattern_fill_color: EV_COLOR
			-- Color to use to fill elements that are
			-- isolated in another cut pattern (not the
			-- current one), when fill of these elements
			-- is requested

	invalid_isolated_cut_die_color: EV_COLOR
			-- Foreground color to use in Validity Check
			-- view for projects that are isolated in a cut
			-- pattern but are not surrounded by cuts or have
			-- a cut through the printed die

	wrong_lot_color: EV_COLOR
			-- Foreground color to use in Validity Check view
			-- for projects that are isolated in a cut pattern
			-- but are on a different lot than the one for the
			-- cut pattern

	non_default_cut_die_size_color: EV_COLOR
			-- Foreground color to use in Validity Check view
			-- for projects whose cut die determined by cuts
			-- is different from the default cut die determined
			-- by surrounding scribes

	shared_cut_die_color: EV_COLOR
			-- Foreground color to use in Validity Check view
			-- for projects whose cut die determined by cuts
			-- is shared by other non-scribe dies

	extra_cut_color: EV_COLOR
			-- Foreground color to use in Validity Check
			-- view for extra cuts that are not an isolating cut
			-- for any isolated sites

feature -- Modification

	set_color_by_role (a_color_role: STRING a_color: EV_COLOR)
			-- Set color identified by `a_color_role'
			-- to `a_color'
		require
			a_color_role_not_void: a_color_role /= Void
			a_color_not_void: a_color /= Void
		do
			application_colors_table.search (a_color_role)
			if application_colors_table.found then
				application_colors_table.found_item.call ([a_color])
			end
		end

	set_current_background_color (a_color: EV_COLOR)
			-- Set `current_background_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			current_background_color := a_color
		ensure
			color_set: current_background_color = a_color
		end

	set_standard_background_color (a_color: EV_COLOR)
			-- Set `standard_background_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			standard_background_color := a_color
		ensure
			color_set: standard_background_color = a_color
		end

	set_fully_zoomed_in_background_color (a_color: EV_COLOR)
			-- Set `fully_zoomed_in_background_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			fully_zoomed_in_background_color := a_color
		ensure
			color_set: fully_zoomed_in_background_color = a_color
		end

	set_unselectable_color (a_color: EV_COLOR)
			-- Set `unselectable_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			unselectable_color := a_color
		ensure
			color_set: unselectable_color = a_color
		end

	set_default_border_color (a_color: EV_COLOR)
			-- Set `default_border_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			default_border_color := a_color
		ensure
			color_set: default_border_color = a_color
		end

	set_default_label_color (a_color: EV_COLOR)
			-- Set `default_label_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			default_label_color := a_color
		ensure
			color_set: default_label_color = a_color
		end

	set_default_fill_color (a_color: EV_COLOR)
			-- Set `default_fill_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			default_fill_color := a_color
		ensure
			color_set: default_fill_color = a_color
		end

	set_not_fixed_in_x_or_y_color (a_color: EV_COLOR)
			-- Set `not_fixed_in_x_or_y_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			not_fixed_in_x_or_y_color := a_color
		ensure
			color_set: not_fixed_in_x_or_y_color = a_color
		end

	set_fixed_in_x_only_color (a_color: EV_COLOR)
			-- Set `fixed_in_x_only_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			fixed_in_x_only_color := a_color
		ensure
			color_set: fixed_in_x_only_color = a_color
		end

	set_fixed_in_y_only_color (a_color: EV_COLOR)
			-- Set `fixed_in_y_only_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			fixed_in_y_only_color := a_color
		ensure
			color_set: fixed_in_y_only_color = a_color
		end

	set_fixed_in_x_and_y_color (a_color: EV_COLOR)
			-- Set `fixed_in_x_and_y_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			fixed_in_x_and_y_color := a_color
		ensure
			color_set: fixed_in_x_and_y_color = a_color
		end

	set_not_locked_in_x_or_y_color (a_color: EV_COLOR)
			-- Set `not_locked_in_x_or_y_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			not_locked_in_x_or_y_color := a_color
		ensure
			color_set: not_locked_in_x_or_y_color = a_color
		end

	set_locked_in_x_only_color (a_color: EV_COLOR)
			-- Set `locked_in_x_only_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			locked_in_x_only_color := a_color
		ensure
			color_set: locked_in_x_only_color = a_color
		end

	set_locked_in_y_only_color (a_color: EV_COLOR)
			-- Set `locked_in_y_only_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			locked_in_y_only_color := a_color
		ensure
			color_set: locked_in_y_only_color = a_color
		end

	set_locked_in_x_and_y_color (a_color: EV_COLOR)
			-- Set `locked_in_x_and_y_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			locked_in_x_and_y_color := a_color
		ensure
			color_set: locked_in_x_and_y_color = a_color
		end

	set_has_max_die_size_color (a_color: EV_COLOR)
			-- Set `has_max_die_size_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			has_max_die_size_color := a_color
		ensure
			color_set: has_max_die_size_color = a_color
		end

	set_tight_fit_color (a_color: EV_COLOR)
			-- Set `tight_fit_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			tight_fit_color := a_color
		ensure
			color_set: tight_fit_color = a_color
		end

	set_no_max_die_size_color (a_color: EV_COLOR)
			-- Set `no_max_die_size_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			no_max_die_size_color := a_color
		ensure
			color_set: no_max_die_size_color = a_color
		end

	set_no_packaging_color (a_color: EV_COLOR)
			-- Set `no_packaging_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			no_packaging_color := a_color
		ensure
			color_set: no_packaging_color = a_color
		end

	set_ceramic_packaging_color (a_color: EV_COLOR)
			-- Set `ceramic_packaging_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			ceramic_packaging_color := a_color
		ensure
			color_set: ceramic_packaging_color = a_color
		end

	set_plastic_packaging_color (a_color: EV_COLOR)
			-- Set `plastic_packaging_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			plastic_packaging_color := a_color
		ensure
			color_set: plastic_packaging_color = a_color
		end

	set_ceramic_and_plastic_packaging_color (a_color: EV_COLOR)
			-- Set `ceramic_and_plastic_packaging_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			ceramic_and_plastic_packaging_color := a_color
		ensure
			color_set: ceramic_and_plastic_packaging_color = a_color
		end

	set_search_match_color (a_color: EV_COLOR)
			-- Set `search_match_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			search_match_color := a_color
		ensure
			color_set: search_match_color = a_color
		end

	set_search_no_match_color (a_color: EV_COLOR)
			-- Set `search_no_match_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			search_no_match_color := a_color
		ensure
			color_set: search_no_match_color = a_color
		end

	set_search_match_fill_color (a_color: EV_COLOR)
			-- Set `search_match_fill_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			search_match_fill_color := a_color
		ensure
			color_set: search_match_fill_color = a_color
		end

	set_highlighted_selected_color (a_color: EV_COLOR)
			-- Set `highlighted_selected_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			highlighted_selected_color := a_color
		ensure
			color_set: highlighted_selected_color = a_color
		end

	set_highlighted_unselected_color (a_color: EV_COLOR)
			-- Set `highlighted_unselected_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			highlighted_unselected_color := a_color
		ensure
			color_set: highlighted_unselected_color = a_color
		end

	set_highlighted_selected_fill_color (a_color: EV_COLOR)
			-- Set `highlighted_selected_fill_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			highlighted_selected_fill_color := a_color
		ensure
			color_set: highlighted_selected_fill_color = a_color
		end

	set_commercial_project_color (a_color: EV_COLOR)
			-- Set `commercial_project_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			commercial_project_color := a_color
		ensure
			color_set: commercial_project_color = a_color
		end

	set_mep_project_color (a_color: EV_COLOR)
			-- Set `mep_project_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			mep_project_color := a_color
		ensure
			color_set: mep_project_color = a_color
		end

	set_other_project_color (a_color: EV_COLOR)
			-- Set `other_project_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			other_project_color := a_color
		ensure
			color_set: other_project_color = a_color
		end

	set_non_project_color (a_color: EV_COLOR)
			-- Set `non_project_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			non_project_color := a_color
		ensure
			color_set: non_project_color = a_color
		end

	set_external_overhead_color (a_color: EV_COLOR)
			-- Set `external_overhead_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			external_overhead_color := a_color
		ensure
			color_set: external_overhead_color = a_color
		end

	set_internal_overhead_color (a_color: EV_COLOR)
			-- Set `internal_overhead_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			internal_overhead_color := a_color
		ensure
			color_set: internal_overhead_color = a_color
		end

	set_none_overhead_color (a_color: EV_COLOR)
			-- Set `none_overhead_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			none_overhead_color := a_color
		ensure
			color_set: none_overhead_color = a_color
		end

	set_no_overhead_color (a_color: EV_COLOR)
			-- Set `no_overhead_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			no_overhead_color := a_color
		ensure
			color_set: no_overhead_color = a_color
		end

	set_cut_color (a_color: EV_COLOR)
			-- Set `cut_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			cut_color := a_color
		ensure
			color_set: cut_color = a_color
		end

	set_selected_fill_color (a_color: EV_COLOR)
			-- Set `selected_fill_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			selected_fill_color := a_color
		ensure
			color_set: selected_fill_color = a_color
		end

	set_unselected_fill_color (a_color: EV_COLOR)
			-- Set `unselected_fill_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			unselected_fill_color := a_color
		ensure
			color_set: unselected_fill_color = a_color
		end

	set_locked_in_x_fill_color (a_color: EV_COLOR)
			-- Set `locked_in_x_fill_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			locked_in_x_fill_color := a_color
		ensure
			color_set: locked_in_x_fill_color = a_color
		end

	set_locked_in_y_fill_color (a_color: EV_COLOR)
			-- Set `locked_in_y_fill_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			locked_in_y_fill_color := a_color
		ensure
			color_set: locked_in_y_fill_color = a_color
		end

	set_locked_in_x_and_y_fill_color (a_color: EV_COLOR)
			-- Set `locked_in_x_and_y_fill_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			locked_in_x_and_y_fill_color := a_color
		ensure
			color_set: locked_in_x_and_y_fill_color = a_color
		end

	set_no_max_die_size_fill_color (a_color: EV_COLOR)
			-- Set `no_max_die_size_fill_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			no_max_die_size_fill_color := a_color
		ensure
			color_set: no_max_die_size_fill_color = a_color
		end

	set_standard_rubber_box_color (a_color: EV_COLOR)
			-- Set `standard_rubber_box_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			standard_rubber_box_color := a_color
		ensure
			color_set: standard_rubber_box_color = a_color
		end

	set_too_small_rubber_box_color (a_color: EV_COLOR)
			-- Set `too_small_rubber_box_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			too_small_rubber_box_color := a_color
		ensure
			color_set: too_small_rubber_box_color = a_color
		end

	set_horizontal_scribe_rubber_box_color (a_color: EV_COLOR)
			-- Set `horizontal_scribe_rubber_box_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			horizontal_scribe_rubber_box_color := a_color
		ensure
			color_set: horizontal_scribe_rubber_box_color = a_color
		end

	set_vertical_scribe_rubber_box_color (a_color: EV_COLOR)
			-- Set `vertical_scribe_rubber_box_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			vertical_scribe_rubber_box_color := a_color
		ensure
			color_set: vertical_scribe_rubber_box_color = a_color
		end

	set_standard_move_box_color (a_color: EV_COLOR)
			-- Set `standard_move_box_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			standard_move_box_color := a_color
		ensure
			color_set: standard_move_box_color = a_color
		end

	set_standard_duplicate_box_color (a_color: EV_COLOR)
			-- Set `standard_duplicate_box_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			standard_duplicate_box_color := a_color
		ensure
			color_set: standard_duplicate_box_color = a_color
		end

	set_no_lot_color_assigned_color (a_color: EV_COLOR)
			-- Set `no_lot_color_assigned_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			no_lot_color_assigned_color := a_color
		ensure
			color_set: no_lot_color_assigned_color = a_color
		end

	set_no_lot_assigned_color (a_color: EV_COLOR)
			-- Set `no_lot_assigned_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			no_lot_assigned_color := a_color
		ensure
			color_set: no_lot_assigned_color = a_color
		end

	set_no_validity_issues_color (a_color: EV_COLOR)
			-- Set `no_validity_issues_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			no_validity_issues_color := a_color
		ensure
			color_set: no_validity_issues_color = a_color
		end

	set_multiple_validity_issues_color (a_color: EV_COLOR)
			-- Set `multiple_validity_issues_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			multiple_validity_issues_color := a_color
		ensure
			color_set: multiple_validity_issues_color = a_color
		end

	set_unlocked_or_unassigned_color (a_color: EV_COLOR)
			-- Set `unlocked_or_unassigned_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			unlocked_or_unassigned_color := a_color
		ensure
			color_set: unlocked_or_unassigned_color = a_color
		end

	set_outside_all_fields_color (a_color: EV_COLOR)
			-- Set `outside_all_fields_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			outside_all_fields_color := a_color
		ensure
			color_set: outside_all_fields_color = a_color
		end

	set_overlaps_field_edge_color (a_color: EV_COLOR)
			-- Set `overlaps_field_edge_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			overlaps_field_edge_color := a_color
		ensure
			color_set: overlaps_field_edge_color = a_color
		end

	set_overlaps_another_object_color (a_color: EV_COLOR)
			-- Set `overlaps_another_object_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			overlaps_another_object_color := a_color
		ensure
			color_set: overlaps_another_object_color = a_color
		end

	set_below_minimum_size_color (a_color: EV_COLOR)
			-- Set `below_minimum_size_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			below_minimum_size_color := a_color
		ensure
			color_set: below_minimum_size_color = a_color
		end

	set_needs_lot_assignment_color (a_color: EV_COLOR)
			-- Set `needs_lot_assignment_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			needs_lot_assignment_color := a_color
		ensure
			color_set: needs_lot_assignment_color = a_color
		end

	set_floating_scribe_color (a_color: EV_COLOR)
			-- Set `floating_scribe_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			floating_scribe_color := a_color
		ensure
			color_set: floating_scribe_color = a_color
		end

	set_misaligned_scribe_color (a_color: EV_COLOR)
			-- Set `misaligned_scribe_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			misaligned_scribe_color := a_color
		ensure
			color_set: misaligned_scribe_color = a_color
		end

	set_too_close_to_object_color (a_color: EV_COLOR)
			-- Set `too_close_to_object_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			too_close_to_object_color := a_color
		ensure
			color_set: too_close_to_object_color = a_color
		end

	set_too_close_to_edge_color (a_color: EV_COLOR)
			-- Set `too_close_to_edge_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			too_close_to_edge_color := a_color
		ensure
			color_set: too_close_to_edge_color = a_color
		end

	set_small_but_legal_color (a_color: EV_COLOR)
			-- Set `small_but_legal_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			small_but_legal_color := a_color
		ensure
			color_set: small_but_legal_color = a_color
		end

	set_cut_die_too_big_color (a_color: EV_COLOR)
			-- Set `cut_die_too_big_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			cut_die_too_big_color := a_color
		ensure
			color_set: cut_die_too_big_color = a_color
		end

	set_not_isolated_in_cut_die_color (a_color: EV_COLOR)
			-- Set `not_isolated_in_cut_die_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			not_isolated_in_cut_die_color := a_color
		ensure
			color_set: not_isolated_in_cut_die_color = a_color
		end

	set_not_centered_in_cut_die_color (a_color: EV_COLOR)
			-- Set `not_centered_in_cut_die_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			not_centered_in_cut_die_color := a_color
		ensure
			color_set: not_centered_in_cut_die_color = a_color
		end

	set_split_colors (a_list: like split_colors)
			-- Set lot split colors from `a_list'
		require
			a_list_not_void: a_list /= Void
		do
			split_colors := a_list
			build_split_colors_table
		ensure
			split_colors_set: split_colors = a_list
		end

	set_measurement_marker_color (a_color: EV_COLOR)
			-- Set `measurement_marker_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			measurement_marker_color := a_color
		ensure
			color_set: measurement_marker_color = a_color
		end

	set_isolated_in_curr_pattern_fill_color (a_color: EV_COLOR)
			-- Set `isolated_in_curr_pattern_fill_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			isolated_in_curr_pattern_fill_color := a_color
		ensure
			color_set: isolated_in_curr_pattern_fill_color = a_color
		end

	set_isolated_in_other_pattern_fill_color (a_color: EV_COLOR)
			-- Set `isolated_in_other_pattern_fill_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			isolated_in_other_pattern_fill_color := a_color
		ensure
			color_set: isolated_in_other_pattern_fill_color = a_color
		end

	set_invalid_isolated_cut_die_color (a_color: EV_COLOR)
			-- Set `invalid_isolated_cut_die_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			invalid_isolated_cut_die_color := a_color
		ensure
			color_set: invalid_isolated_cut_die_color = a_color
		end

	set_wrong_lot_color (a_color: EV_COLOR)
			-- Set `wrong_lot_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			wrong_lot_color := a_color
		ensure
			color_set: wrong_lot_color = a_color
		end

	set_non_default_cut_die_size_color (a_color: EV_COLOR)
			-- Set `non_default_cut_die_size_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			non_default_cut_die_size_color := a_color
		ensure
			color_set: non_default_cut_die_size_color = a_color
		end

	set_shared_cut_die_color (a_color: EV_COLOR)
			-- Set `shared_cut_die_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			shared_cut_die_color := a_color
		ensure
			color_set: shared_cut_die_color = a_color
		end

	set_extra_cut_color (a_color: EV_COLOR)
			-- Set `extra_cut_color' to `a_color'
		require
			a_color_not_void: a_color /= Void
		do
			extra_cut_color := a_color
		ensure
			color_set: extra_cut_color = a_color
		end

feature {NONE} -- Implementation

	build_split_colors_table
			-- Build table that maps wafer etest ID to the
			-- database row that assigns it a color
		do
			create split_colors_table.make (split_colors.count)
			split_colors.do_all (agent add_split_color)
		end

	add_split_color (row: PACKING_ETEST_COLORS_MROW)
			-- Add `row' to `split_colors_table'
		do
			split_colors_table.put (row, row.wafer_etest_name)
		end

	split_colors: LIST [PACKING_ETEST_COLORS_ROW]
			-- Colors to use for lot splits

	split_colors_table: HASH_TABLE [PACKING_ETEST_COLORS_MROW, STRING]
			-- Table of existing split color assignment
			-- rows indexed by wafer etest name
	
	application_colors_table: HASH_TABLE [PROCEDURE [ANY, TUPLE [EV_COLOR]], STRING]
			-- Table of "set color" procedures, indexed by 
			-- color role
		local
			table: like cached_application_colors_table
		do
			if cached_application_colors_table = Void then
				create table.make (100)
				table.put (agent set_standard_background_color, policies.standard_background_name)
				table.put (agent set_unselectable_color, policies.unselectable_name)
				table.put (agent set_default_border_color, policies.default_border_name)
				table.put (agent set_default_label_color, policies.default_label_name)
				table.put (agent set_default_fill_color, policies.default_fill_name)
				table.put (agent set_fully_zoomed_in_background_color, policies.fully_zoomed_background_name)
				table.put (agent set_not_fixed_in_x_or_y_color, policies.not_fixed_in_x_or_y_name)
				table.put (agent set_fixed_in_x_only_color, policies.fixed_in_x_only_name)
				table.put (agent set_fixed_in_y_only_color, policies.fixed_in_y_only_name)
				table.put (agent set_fixed_in_x_and_y_color, policies.fixed_in_x_and_y_name)
				table.put (agent set_not_locked_in_x_or_y_color, policies.not_locked_in_x_or_y_name)
				table.put (agent set_locked_in_x_only_color, policies.locked_in_x_only_name)
				table.put (agent set_locked_in_y_only_color, policies.locked_in_y_only_name)
				table.put (agent set_locked_in_x_and_y_color, policies.locked_in_x_and_y_name)
				table.put (agent set_has_max_die_size_color, policies.has_max_die_size_name)
				table.put (agent set_tight_fit_color, policies.tight_fit_name)
				table.put (agent set_no_max_die_size_color, policies.no_max_die_size_name)
				table.put (agent set_no_packaging_color, policies.no_packaging_name)
				table.put (agent set_ceramic_packaging_color, policies.ceramic_packaging_name)
				table.put (agent set_plastic_packaging_color, policies.plastic_packaging_name)
				table.put (agent set_ceramic_and_plastic_packaging_color, policies.ceramic_and_plastic_packaging_name)
				table.put (agent set_search_match_color, policies.search_match_name)
				table.put (agent set_search_no_match_color, policies.search_no_match_name)
				table.put (agent set_search_match_fill_color, policies.search_match_fill_name)
				table.put (agent set_highlighted_selected_color, policies.highlighted_selected_name)
				table.put (agent set_highlighted_unselected_color, policies.highlighted_unselected_name)
				table.put (agent set_highlighted_selected_fill_color, policies.highlighted_selected_fill_name)
				table.put (agent set_commercial_project_color, policies.commercial_project_name)
				table.put (agent set_mep_project_color, policies.mep_project_name)
				table.put (agent set_other_project_color, policies.other_project_name)
				table.put (agent set_non_project_color, policies.non_project_name)
				table.put (agent set_cut_color, policies.cut_name)
				table.put (agent set_selected_fill_color, policies.selected_fill_name)
				table.put (agent set_unselected_fill_color, policies.unselected_fill_name)
				table.put (agent set_locked_in_x_fill_color, policies.locked_in_x_fill_name)
				table.put (agent set_locked_in_y_fill_color, policies.locked_in_y_fill_name)
				table.put (agent set_locked_in_x_and_y_fill_color, policies.locked_in_x_and_y_fill_name)
				table.put (agent set_no_max_die_size_fill_color, policies.no_max_die_size_fill_name)
				table.put (agent set_standard_rubber_box_color, policies.standard_rubber_box_name)
				table.put (agent set_too_small_rubber_box_color, policies.too_small_rubber_box_name)
				table.put (agent set_horizontal_scribe_rubber_box_color, policies.horizontal_scribe_rubber_box_name)
				table.put (agent set_vertical_scribe_rubber_box_color, policies.vertical_scribe_rubber_box_name)
				table.put (agent set_standard_move_box_color, policies.standard_move_box_name)
				table.put (agent set_standard_duplicate_box_color, policies.standard_duplicate_box_name)
				table.put (agent set_no_lot_color_assigned_color, policies.no_lot_color_assigned_name)
				table.put (agent set_no_lot_assigned_color, policies.no_lot_assigned_name)
				table.put (agent set_no_validity_issues_color, policies.no_validity_issues_name)
				table.put (agent set_multiple_validity_issues_color, policies.multiple_validity_issues_name)
				table.put (agent set_unlocked_or_unassigned_color, policies.unlocked_or_unassigned_name)
				table.put (agent set_outside_all_fields_color, policies.outside_all_fields_name)
				table.put (agent set_overlaps_field_edge_color, policies.overlaps_field_edge_name)
				table.put (agent set_overlaps_another_object_color, policies.overlaps_another_object_name)
				table.put (agent set_below_minimum_size_color, policies.below_minimum_size_name)
				table.put (agent set_needs_lot_assignment_color, policies.needs_lot_assignment_name)
				table.put (agent set_floating_scribe_color, policies.floating_scribe_name)
				table.put (agent set_misaligned_scribe_color, policies.misaligned_scribe_name)
				table.put (agent set_too_close_to_object_color, policies.too_close_to_object_name)
				table.put (agent set_too_close_to_edge_color, policies.too_close_to_edge_name)
				table.put (agent set_small_but_legal_color, policies.small_but_legal_name)
				table.put (agent set_cut_die_too_big_color, policies.cut_die_too_big_name)
				table.put (agent set_not_isolated_in_cut_die_color, policies.not_isolated_in_cut_die_name)
				table.put (agent set_not_centered_in_cut_die_color, policies.not_centered_in_cut_die_name)
				table.put (agent set_measurement_marker_color, policies.measurement_marker_name)
				table.put (agent set_isolated_in_curr_pattern_fill_color, policies.isolated_in_curr_pattern_fill_name)
				table.put (agent set_isolated_in_other_pattern_fill_color, policies.isolated_in_other_pattern_fill_name)
				table.put (agent set_invalid_isolated_cut_die_color, policies.invalid_isolated_cut_die_name)
				table.put (agent set_wrong_lot_color, policies.wrong_lot_name)
				table.put (agent set_non_default_cut_die_size_color, policies.non_default_cut_die_size_name)
				table.put (agent set_shared_cut_die_color, policies.shared_cut_die_name)
				table.put (agent set_extra_cut_color, policies.extra_cut_name)
				cached_application_colors_table := table
			end
			Result := cached_application_colors_table
		end
	
	cached_application_colors_table: like application_colors_table
			-- Table of "set color" procedures, index by color role
	
end
