
indexing
	
	description: "Cut element of reticle view"
	author: "David Hollenberg"
	date: "July 28, 2006"

class RETICLE_VIEW_CUT
inherit
	RETICLE_VIEW_ELEMENT
		redefine
			make
		end

create
	make

feature {NONE} -- Creation
	
	make (a_model_element: like anchored_model_element a_view: like view)
		do
			precursor (a_model_element, a_view)
			create all_copies.make (1)
			all_copies.extend (Current)
			set_sub_elements
		end

feature {NONE} -- Implementation

	set_sub_elements
			-- Set `sub_elements'
		local
			list: LIST [RETICLE_MODEL_SUB_ELEMENT]
		do
			list := model_element.sub_elements
			create {ARRAYED_LIST [like anchored_view_sub_element]} sub_elements.make (list.count)
			from
				list.start
			until
				list.after
			loop
				sub_elements.extend  (new_view_sub_element (list.item))
				
				list.forth
			end
		end

	new_view_sub_element (a_model_sub_element: RETICLE_MODEL_SUB_ELEMENT): like anchored_view_sub_element
			-- New view sub-element for `a_model_sub_element'
		local
			elem: like a_model_sub_element
		do
			elem := a_model_sub_element
			if elem.is_cut_line then
				create {RETICLE_VIEW_CUT_LINE} Result.make (elem, Current, view)
			elseif elem.is_cut_handle then
				create {RETICLE_VIEW_CUT_HANDLE} Result.make (elem, Current, view)
			else
				handle_internal_error ("Unknown sub-element type for model sub-element - not a cut line or cut handle")
			end
		end


end
