
indexing
	
	description: "Object that can generate colors for an %
		%element of a reticle view"
	author: "David Hollenberg"
	date: "July 25, 2006"

deferred class RETICLE_VIEW_ELEMENT_COLOR_GENERATOR

feature  {NONE} -- Creation

	make (a_palette: like palette)
		require
			a_palette_not_void: a_palette /= Void
		do
			palette := a_palette
		ensure
			palette_set: palette = a_palette
		end

feature  -- Access

	palette: RETICLE_VIEW_COLORS
			-- Palette of colors to be used, depending on
			-- view element properties

	border_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Foreground color for border (usually a
			-- rectangle) of `an_element'
		require
			an_element_not_void: an_element /= Void
		deferred
		ensure
			result_not_void: Result /= Void
		end
	
	label_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Foreground color for label
		require
			an_element_not_void: an_element /= Void
		deferred
		ensure
			result_not_void: Result /= Void
		end
	
end
