
indexing
	
	description: "Object that can generate a %"filled%" indication for an %
		%element of a reticle view"
	author: "David Hollenberg"
	date: "October 3, 2006"

deferred class RETICLE_VIEW_ELEMENT_FILL_GENERATOR

feature  {NONE} -- Creation

	make (a_palette: like palette)
		require
			a_palette_not_void: a_palette /= Void
		do
			palette := a_palette
		ensure
			palette_set: palette = a_palette
		end

feature  -- Access

	palette: RETICLE_VIEW_COLORS
			-- Palette of colors to be used, depending on
			-- view element properties

	is_interior_filled (an_element: RETICLE_VIEW_ELEMENT): BOOLEAN
			-- Should interior of `an_element' be filled when
			-- it is displayed?
		require
			an_element_not_void: an_element /= Void
		deferred
		end
	
	interior_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Foreground color for interior of
			-- `an_element', if it is filled
		require
			an_element_not_void: an_element /= Void
			an_element_filled: is_interior_filled (an_element)
		deferred
		ensure
			result_not_void: Result /= Void
		end
	
end
