
indexing
	
	description: "Access to shared row busy checking services"
	author: "David Hollenberg"
	date: "February 21, 2004"

deferred class ROW_BUSY_CHECK_ACCESS

feature {NONE} -- Properties

	check_list_busy
			-- Check that the none of the rows were busy in last
			-- attempt to retrieve locked rows
		local
			error: ROW_LIST_BUSY_ERROR
		do
			if is_list_busy then
				create error
				error.set_hard_error
				error.disable_retry
				error.set_query_text (last_query_text)
				error.set_query_bindings (last_query_bindings)
				error.handle
			end
		end

	last_query_text: STRING
			-- Text of last query used
		deferred
		end

	last_query_bindings: STRING
			-- Description of bindings for last query used
		deferred
		end

	is_list_busy: BOOLEAN
			-- Did last call to one of the routines that
			-- returns a list of locked rows encounter
			-- a "row locked by another session" condition?
		deferred
		end

end
