
indexing
	
	description: "Object that can compose text for database row lock error"
	author: "David Hollenberg"
	date: "October 30, 2003"

class ROW_LOCK_ERROR_COMPOSER
inherit
	TEXT_COMPOSER [ROW_LOCK_ERROR]

feature -- Properties

	text (err: ROW_LOCK_ERROR): STRING
			-- Text composed for `err'
		local
			row: DB_LOCKABLE_ROW
			table: STRING
		do
			row := err.row
			table := row.table_name.as_upper
			Result := "Error locking row in table " + table + ", rowid " + row.connection.rowid_extended_format_text (row.rowid) + " (" + row.rowid.out + ")%N"
			if row.is_locked_but_changed then
				Result.append ("Lock succeeded, but row changed since fetch")
			elseif row.is_busy then
				Result.append ("Row locked by another session")
			elseif row.is_gone then
				Result.append ("Row no longer exists in database")
			end
		end

end
