
indexing
	
	description: "Window to allow sending of %"project released to manufacturing%" %
		%messages to customers on a specific run"
	author: "David Hollenberg"
	date: "June 7, 2005"

class RTM_MESSAGE_WINDOW

inherit
	FRONT_END_MESSAGE_WINDOW
		
create
	make

feature {NONE} -- Implementation

	internal_request_type: STRING
			-- Type of internal requests that can be submitted
			-- and monitored
		do
			Result := cache.wafer_techn_run_types_row.rtm_request_type
		end

	request_description: STRING = "customer RTM notification"
			-- Description of internal requests that can be
			-- submitted and monitored, suitable for inclusion
			-- in messages to operator

	progress_window_title: STRING = "Sending RTM Status Messages"
			-- Title for request progress window (without
			-- run id)
	
	confirm_before_submission (n: INTEGER)
			-- Tell operator we're about to submit `n' internal
			-- requests and get confirmation before proceeding
		do
			confirm ("E-mail messages will be sent to " + n.out + " " + su.number (n, "project", "projects") + " notifying customer%Nthat their project has been released to manufacturing.%N%NProceed")
		end

	warn_prev_processed_requests (n: INTEGER)
			-- Warn operator about `n' orders for which an
			-- internal request of this type has already been
			-- processed
		do
			warn ("RTM status messages have already been sent before for " + n.out + " " + su.number (n, "project", "projects") + ".%NThese customers will be notified again.%N%NProceed anyway?")
		end

end
