
indexing

	date: "Tue Apr 24 10:30:15 2007"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user DHOLLEN"
	database_tables: 
		"RUN_CLOSING_PRIMITIVE_STEPS (MOSIS.RUN_CLOSING_PRIMITIVE_STEPS)"
			-- Included columns
			-- 	DATABASE_ROLE
			-- 	DESCR
			-- 	EXECUTION_ORDER
			-- 	IS_MODIFIABLE
			-- 	PRESENTATION_TEXT
			-- 	PRIMITIVE_STEP_NAME
			-- 	READ_ONLY
			-- Excluded columns
			-- 	(none)

class RUN_CLOSING_PRIMITIVE_STEPS_RAW

inherit

	DB_IDENTIFIED_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_primitive_step_name: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_primitive_step_name_exists: the_primitive_step_name /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			primitive_step_name := the_primitive_step_name
			is_null_primitive_step_name := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 7

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  database_role, descr, execution_order, is_modifiable, presentation_text,%N  primitive_step_name, read_only"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "run_closing_primitive_steps rcps"

	join_condition: STRING = ""

	table_name: STRING = "run_closing_primitive_steps"

	key_where_clause: STRING = "primitive_step_name = :1"

feature -- Values

	database_role: STRING
			-- DB: VARCHAR2(30) not null

	descr: STRING
			-- DB: VARCHAR2(200)

	execution_order: DOUBLE
			-- DB: NUMBER(*,*) not null

	is_modifiable: BOOLEAN
			-- DB: CHAR(1) not null

	presentation_text: STRING
			-- DB: VARCHAR2(50) not null

	primitive_step_name: STRING
			-- DB: VARCHAR2(30) not null

	read_only: BOOLEAN
			-- DB: CHAR(1) not null

feature -- Nullness for null allowed columns

	is_null_descr: BOOLEAN

feature -- Nullness for non-null columns

	is_null_database_role: BOOLEAN
	is_null_execution_order: BOOLEAN
	is_null_is_modifiable: BOOLEAN
	is_null_presentation_text: BOOLEAN
	is_null_primitive_step_name: BOOLEAN
	is_null_read_only: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (primitive_step_name, r.primitive_step_name)
			Result := Result
				and is_null_primitive_step_name = r.is_null_primitive_step_name
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and execution_order = r.execution_order
				and is_modifiable = r.is_modifiable
				and read_only = r.read_only
			Result := Result
				and equal (database_role, r.database_role)
				and equal (descr, r.descr)
				and equal (presentation_text, r.presentation_text)
			Result := Result
				and is_null_database_role = r.is_null_database_role
				and is_null_descr = r.is_null_descr
				and is_null_execution_order = r.is_null_execution_order
				and is_null_is_modifiable = r.is_null_is_modifiable
				and is_null_presentation_text = r.is_null_presentation_text
				and is_null_read_only = r.is_null_read_only
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 30)
			q.select_string (2, 200)
			q.select_double (3)
			q.select_boolean (4)
			q.select_string (5, 50)
			q.select_string (6, 30)
			q.select_boolean (7)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			execution_order := q.double_value (3)
			is_modifiable := q.boolean_value (4)
			read_only := q.boolean_value (7)
		end

	fill_in_references (q: SQL_QUERY)
		do
			database_role := q.string_value (1)
			descr := q.string_value (2)
			presentation_text := q.string_value (5)
			primitive_step_name := q.string_value (6)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, database_role)
			q.get_string_value (2, descr)
			q.get_string_value (5, presentation_text)
			q.get_string_value (6, primitive_step_name)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_database_role := q.is_null (1)
			is_null_descr := q.is_null (2)
			is_null_execution_order := q.is_null (3)
			is_null_is_modifiable := q.is_null (4)
			is_null_presentation_text := q.is_null (5)
			is_null_primitive_step_name := q.is_null (6)
			is_null_read_only := q.is_null (7)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_primitive_step_name := True
			create primitive_step_name.make (0)
		end

	set_null_nonkey
		do
			is_null_database_role := True
			is_null_descr := True
			is_null_execution_order := True
			is_null_is_modifiable := True
			is_null_presentation_text := True
			is_null_read_only := True
			create database_role.make (0)
			create descr.make (0)
			create presentation_text.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, primitive_step_name, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and execution_order = q.double_value (3)
				and is_modifiable = q.boolean_value (4)
				and read_only = q.boolean_value (7)
			q.get_string_value (1, s)
			Result := Result and equal (database_role, s)
			q.get_string_value (2, s)
			Result := Result and equal (descr, s)
			q.get_string_value (5, s)
			Result := Result and equal (presentation_text, s)
			q.get_string_value (6, s)
			Result := Result and equal (primitive_step_name, s)
			Result := Result
				and is_null_database_role = q.is_null (1)
				and is_null_descr = q.is_null (2)
				and is_null_execution_order = q.is_null (3)
				and is_null_is_modifiable = q.is_null (4)
				and is_null_presentation_text = q.is_null (5)
				and is_null_primitive_step_name = q.is_null (6)
				and is_null_read_only = q.is_null (7)
		end

end
