
indexing

	date: "Tue Apr 24 10:30:16 2007"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user DHOLLEN"
	database_tables: 
		"RUN_CUT_PATTERNS (MOSIS.RUN_CUT_PATTERNS)"
			-- Included columns
			-- 	CUT_PATTERN_NO
			-- 	FIELD_NAME
			-- 	PACKAGING_LOT_NO
			-- 	QUANTITY_WAFERS_NEEDED
			-- 	QUANTITY_WAFERS_NEEDED_WO_DFC
			-- 	RUN_ID
			-- Excluded columns
			-- 	(none)

class RUN_CUT_PATTERNS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_run_id: STRING; the_cut_pattern_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_run_id_exists: the_run_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			run_id := the_run_id
			cut_pattern_no := the_cut_pattern_no
			is_null_run_id := False
			is_null_cut_pattern_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 6

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  cut_pattern_no, field_name, packaging_lot_no, quantity_wafers_needed,%N  quantity_wafers_needed_wo_dfc, run_id"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "run_cut_patterns rcp"

	join_condition: STRING = ""

	table_name: STRING = "run_cut_patterns"

	key_where_clause: STRING = "run_id = :1 and cut_pattern_no = :2"

feature -- Values

	cut_pattern_no: INTEGER
			-- DB: NUMBER(2,0) not null

	field_name: STRING
			-- DB: VARCHAR2(20) not null

	packaging_lot_no: INTEGER
			-- DB: NUMBER(3,0)

	quantity_wafers_needed: INTEGER
			-- DB: NUMBER(6,0) not null

	quantity_wafers_needed_wo_dfc: INTEGER
			-- DB: NUMBER(6,0)

	run_id: STRING
			-- DB: CHAR(4) not null

feature -- Nullness for null allowed columns

	is_null_packaging_lot_no: BOOLEAN
	is_null_quantity_wafers_needed_wo_dfc: BOOLEAN

feature -- Nullness for non-null columns

	is_null_cut_pattern_no: BOOLEAN
	is_null_field_name: BOOLEAN
	is_null_quantity_wafers_needed: BOOLEAN
	is_null_run_id: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and cut_pattern_no = r.cut_pattern_no
			Result := Result
				and equal (run_id, r.run_id)
			Result := Result
				and is_null_cut_pattern_no = r.is_null_cut_pattern_no
				and is_null_run_id = r.is_null_run_id
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and packaging_lot_no = r.packaging_lot_no
				and quantity_wafers_needed = r.quantity_wafers_needed
				and quantity_wafers_needed_wo_dfc = r.quantity_wafers_needed_wo_dfc
			Result := Result
				and equal (field_name, r.field_name)
			Result := Result
				and is_null_field_name = r.is_null_field_name
				and is_null_packaging_lot_no = r.is_null_packaging_lot_no
				and is_null_quantity_wafers_needed = r.is_null_quantity_wafers_needed
				and is_null_quantity_wafers_needed_wo_dfc = r.is_null_quantity_wafers_needed_wo_dfc
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_integer (1)
			q.select_string (2, 20)
			q.select_integer (3)
			q.select_integer (4)
			q.select_integer (5)
			q.select_string (6, 4)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			cut_pattern_no := q.integer_value (1)
			packaging_lot_no := q.integer_value (3)
			quantity_wafers_needed := q.integer_value (4)
			quantity_wafers_needed_wo_dfc := q.integer_value (5)
		end

	fill_in_references (q: SQL_QUERY)
		do
			field_name := q.string_value (2)
			run_id := q.string_value (6)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (2, field_name)
			q.get_string_value (6, run_id)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_cut_pattern_no := q.is_null (1)
			is_null_field_name := q.is_null (2)
			is_null_packaging_lot_no := q.is_null (3)
			is_null_quantity_wafers_needed := q.is_null (4)
			is_null_quantity_wafers_needed_wo_dfc := q.is_null (5)
			is_null_run_id := q.is_null (6)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_run_id := True
			is_null_cut_pattern_no := True
			create run_id.make (0)
		end

	set_null_nonkey
		do
			is_null_field_name := True
			is_null_packaging_lot_no := True
			is_null_quantity_wafers_needed := True
			is_null_quantity_wafers_needed_wo_dfc := True
			create field_name.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, run_id, False)
			q.bind_num_to_integer (2, cut_pattern_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and cut_pattern_no = q.integer_value (1)
				and packaging_lot_no = q.integer_value (3)
				and quantity_wafers_needed = q.integer_value (4)
				and quantity_wafers_needed_wo_dfc = q.integer_value (5)
			q.get_string_value (2, s)
			Result := Result and equal (field_name, s)
			q.get_string_value (6, s)
			Result := Result and equal (run_id, s)
			Result := Result
				and is_null_cut_pattern_no = q.is_null (1)
				and is_null_field_name = q.is_null (2)
				and is_null_packaging_lot_no = q.is_null (3)
				and is_null_quantity_wafers_needed = q.is_null (4)
				and is_null_quantity_wafers_needed_wo_dfc = q.is_null (5)
				and is_null_run_id = q.is_null (6)
		end

end
