
indexing

	date: "Mon Jun 23 14:03:26 2008"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user GOLDBERG"
	database_tables: 
		"RUN_GDS_FILE_LAYERS (MOSIS.RUN_GDS_FILE_LAYERS)"
			-- Included columns
			-- 	FILE_NO
			-- 	LAYER_NAME
			-- 	RUN_ID
			-- Excluded columns
			-- 	(none)

class RUN_GDS_FILE_LAYERS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_run_id: STRING; the_file_no: INTEGER; the_layer_name: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_run_id_exists: the_run_id /= Void
			the_layer_name_exists: the_layer_name /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			run_id := the_run_id
			file_no := the_file_no
			layer_name := the_layer_name
			is_null_run_id := False
			is_null_file_no := False
			is_null_layer_name := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 3

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  file_no, layer_name, run_id"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "run_gds_file_layers rgfl"

	join_condition: STRING = ""

	table_name: STRING = "run_gds_file_layers"

	key_where_clause: STRING = "run_id = :1 and file_no = :2 and layer_name = :3"

feature -- Values

	file_no: INTEGER
			-- DB: NUMBER(3,0) not null

	layer_name: STRING
			-- DB: VARCHAR2(255) not null

	run_id: STRING
			-- DB: CHAR(4) not null

feature -- Nullness for non-null columns

	is_null_file_no: BOOLEAN
	is_null_layer_name: BOOLEAN
	is_null_run_id: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and file_no = r.file_no
			Result := Result
				and equal (layer_name, r.layer_name)
				and equal (run_id, r.run_id)
			Result := Result
				and is_null_file_no = r.is_null_file_no
				and is_null_layer_name = r.is_null_layer_name
				and is_null_run_id = r.is_null_run_id
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_integer (1)
			q.select_string (2, 255)
			q.select_string (3, 4)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			file_no := q.integer_value (1)
		end

	fill_in_references (q: SQL_QUERY)
		do
			layer_name := q.string_value (2)
			run_id := q.string_value (3)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (2, layer_name)
			q.get_string_value (3, run_id)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_file_no := q.is_null (1)
			is_null_layer_name := q.is_null (2)
			is_null_run_id := q.is_null (3)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_run_id := True
			is_null_file_no := True
			is_null_layer_name := True
			create run_id.make (0)
			create layer_name.make (0)
		end

	set_null_nonkey
		do
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, run_id, False)
			q.bind_num_to_integer (2, file_no, False)
			q.bind_num_to_string (3, layer_name, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and file_no = q.integer_value (1)
			q.get_string_value (2, s)
			Result := Result and equal (layer_name, s)
			q.get_string_value (3, s)
			Result := Result and equal (run_id, s)
			Result := Result
				and is_null_file_no = q.is_null (1)
				and is_null_layer_name = q.is_null (2)
				and is_null_run_id = q.is_null (3)
		end

end
