class RUN_GDS_FILE_LAYERS_ROW

inherit

	RUN_GDS_FILE_LAYERS_RAW
	ROW_COUNT_CHECK_ACCESS

create

        make_template, make_null, make_detached, make_by_key

feature -- Collections

	rows_for_run (run: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): DYNAMIC_LIST [like Current] is
			-- All rows for run `run', ordered by file_no and 
			-- then layer name
		require
			run_exists: run /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_S
		do
			create b.make (run)
			Result := all_rows_filtered_ordered (conn, "run_id = :1", b, "file_no, layer_name")
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end
	
	rows_for_run_and_file (run: STRING n: INTEGER conn: DB_CONNECTION range: ITEM_COUNT_RANGE): DYNAMIC_LIST [like Current] is
			-- All rows for run `run' and file_no `n'
		require
			run_exists: run /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_SI
		do
			create b.make (run, n)
			Result := all_rows_filtered (conn, "run_id = :1 and file_no = :2", b)
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end


end -- RUN_GDS_FILE_LAYERS_ROW
