class RUN_GDS_FILES_MROW

inherit
	RUN_GDS_FILES_MRAW
		redefine
			set_date_job_started,
			set_date_job_ended,
			set_error_explanation
		end
	RUN_GDS_FILES_ROW
		undefine
			initialize_new, initialize_new_by_key
		redefine
			anchored_merge_result, anchored_merge_layer
		end
	BATCH_JOB_REQUESTOR
		undefine
			initialize_new,
			initialize_new_by_key
		redefine
			set_date_job_started,
			set_date_job_ended,
			set_error_explanation
		end

create

	make_template, make_null, make_detached, make_by_key,
	make_by_die_id, make_by_field_name

feature -- Modification

	set_date_job_started (d: DB_DATE) is
		do
			precursor {BATCH_JOB_REQUESTOR} (d)
			precursor {RUN_GDS_FILES_MRAW} (d)
		end

	set_date_job_ended (d: DB_DATE) is
		do
			precursor {BATCH_JOB_REQUESTOR} (d)
			precursor {RUN_GDS_FILES_MRAW} (d)
		end

	set_error_explanation (s: STRING) is
		do
			precursor {BATCH_JOB_REQUESTOR} (s)
			precursor {RUN_GDS_FILES_MRAW} (truncated_error)
		end

feature {NONE} -- Implementation

	anchored_merge_result: RUN_GDS_MERGE_RESULTS_MROW
			-- For anchoring only
		do
		end

	anchored_merge_layer: RUN_GDS_FILE_LAYERS_MROW
			-- For anchoring only
		do
		end

end -- RUN_GDS_FILES_MROW
