
indexing

	date: "Tue Oct  7 16:30:24 2008"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user ALLMOSIS"
	database_tables: 
		"RUN_GDS_FILES (MOSIS.RUN_GDS_FILES)"
			-- Included columns
			-- 	BATCH_JOB_NO
			-- 	CENTER_X
			-- 	CENTER_Y
			-- 	DATE_JOB_ENDED
			-- 	DATE_JOB_STARTED
			-- 	DIE_ID
			-- 	ERROR_EXPLANATION
			-- 	FIELD_NAME
			-- 	FILE_NO
			-- 	GDS_FILENAME
			-- 	JOB_STATUS
			-- 	LOG_FILENAME
			-- 	RUN_ID
			-- 	SIZE_X
			-- 	SIZE_Y
			-- 	TOP_STRUCTURE
			-- Excluded columns
			-- 	(none)

class RUN_GDS_FILES_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_run_id: STRING; the_file_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_run_id_exists: the_run_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			run_id := the_run_id
			file_no := the_file_no
			is_null_run_id := False
			is_null_file_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 16

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  batch_job_no, center_x, center_y, date_job_ended, date_job_started,%N  die_id, error_explanation, field_name, file_no, gds_filename, job_status,%N  log_filename, run_id, size_x, size_y, top_structure"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "run_gds_files rgf"

	join_condition: STRING = ""

	table_name: STRING = "run_gds_files"

	key_where_clause: STRING = "run_id = :1 and file_no = :2"

feature -- Values

	batch_job_no: INTEGER
			-- DB: NUMBER(9,0)

	center_x: DOUBLE
			-- DB: NUMBER(12,6)

	center_y: DOUBLE
			-- DB: NUMBER(12,6)

	date_job_ended: DB_DATE
			-- DB: DATE

	date_job_started: DB_DATE
			-- DB: DATE

	die_id: STRING
			-- DB: CHAR(2)

	error_explanation: STRING
			-- DB: VARCHAR2(4000)

	field_name: STRING
			-- DB: VARCHAR2(20)

	file_no: INTEGER
			-- DB: NUMBER(3,0) not null

	gds_filename: STRING
			-- DB: VARCHAR2(50)

	job_status: STRING
			-- DB: VARCHAR2(15) not null

	log_filename: STRING
			-- DB: VARCHAR2(50)

	run_id: STRING
			-- DB: CHAR(4) not null

	size_x: DOUBLE
			-- DB: NUMBER(12,6)

	size_y: DOUBLE
			-- DB: NUMBER(12,6)

	top_structure: STRING
			-- DB: VARCHAR2(255)

feature -- Maximum database lengths for character columns

	maxlen_die_id: INTEGER = 2
	maxlen_error_explanation: INTEGER = 4000
	maxlen_field_name: INTEGER = 20
	maxlen_gds_filename: INTEGER = 50
	maxlen_job_status: INTEGER = 15
	maxlen_log_filename: INTEGER = 50
	maxlen_run_id: INTEGER = 4
	maxlen_top_structure: INTEGER = 255

feature -- Precisions for number columns

	precision_batch_job_no: INTEGER = 9
	precision_center_x: INTEGER = 12
	precision_center_y: INTEGER = 12
	precision_file_no: INTEGER = 3
	precision_size_x: INTEGER = 12
	precision_size_y: INTEGER = 12

feature -- Scales for number columns

	scale_batch_job_no: INTEGER = 0
	scale_center_x: INTEGER = 6
	scale_center_y: INTEGER = 6
	scale_file_no: INTEGER = 0
	scale_size_x: INTEGER = 6
	scale_size_y: INTEGER = 6

feature -- Nullness for null allowed columns

	is_null_batch_job_no: BOOLEAN
	is_null_center_x: BOOLEAN
	is_null_center_y: BOOLEAN
	is_null_date_job_ended: BOOLEAN
	is_null_date_job_started: BOOLEAN
	is_null_die_id: BOOLEAN
	is_null_error_explanation: BOOLEAN
	is_null_field_name: BOOLEAN
	is_null_gds_filename: BOOLEAN
	is_null_log_filename: BOOLEAN
	is_null_size_x: BOOLEAN
	is_null_size_y: BOOLEAN
	is_null_top_structure: BOOLEAN

feature -- Nullness for non-null columns

	is_null_file_no: BOOLEAN
	is_null_job_status: BOOLEAN
	is_null_run_id: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and file_no = r.file_no
			Result := Result
				and equal (run_id, r.run_id)
			Result := Result
				and is_null_file_no = r.is_null_file_no
				and is_null_run_id = r.is_null_run_id
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and batch_job_no = r.batch_job_no
				and center_x = r.center_x
				and center_y = r.center_y
				and size_x = r.size_x
				and size_y = r.size_y
			Result := Result
				and equal (date_job_ended, r.date_job_ended)
				and equal (date_job_started, r.date_job_started)
				and equal (die_id, r.die_id)
				and equal (error_explanation, r.error_explanation)
				and equal (field_name, r.field_name)
				and equal (gds_filename, r.gds_filename)
				and equal (job_status, r.job_status)
				and equal (log_filename, r.log_filename)
				and equal (top_structure, r.top_structure)
			Result := Result
				and is_null_batch_job_no = r.is_null_batch_job_no
				and is_null_center_x = r.is_null_center_x
				and is_null_center_y = r.is_null_center_y
				and is_null_date_job_ended = r.is_null_date_job_ended
				and is_null_date_job_started = r.is_null_date_job_started
				and is_null_die_id = r.is_null_die_id
				and is_null_error_explanation = r.is_null_error_explanation
				and is_null_field_name = r.is_null_field_name
				and is_null_gds_filename = r.is_null_gds_filename
				and is_null_job_status = r.is_null_job_status
				and is_null_log_filename = r.is_null_log_filename
				and is_null_size_x = r.is_null_size_x
				and is_null_size_y = r.is_null_size_y
				and is_null_top_structure = r.is_null_top_structure
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_integer (1)
			q.select_double (2)
			q.select_double (3)
			q.select_date (4)
			q.select_date (5)
			q.select_string (6, 2)
			q.select_string (7, 4000)
			q.select_string (8, 20)
			q.select_integer (9)
			q.select_string (10, 50)
			q.select_string (11, 15)
			q.select_string (12, 50)
			q.select_string (13, 4)
			q.select_double (14)
			q.select_double (15)
			q.select_string (16, 255)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			batch_job_no := q.integer_value (1)
			center_x := q.double_value (2)
			center_y := q.double_value (3)
			file_no := q.integer_value (9)
			size_x := q.double_value (14)
			size_y := q.double_value (15)
		end

	fill_in_references (q: SQL_QUERY)
		do
			date_job_ended := q.date_value (4)
			date_job_started := q.date_value (5)
			die_id := q.string_value (6)
			error_explanation := q.string_value (7)
			field_name := q.string_value (8)
			gds_filename := q.string_value (10)
			job_status := q.string_value (11)
			log_filename := q.string_value (12)
			run_id := q.string_value (13)
			top_structure := q.string_value (16)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_date_value (4, date_job_ended)
			q.get_date_value (5, date_job_started)
			q.get_string_value (6, die_id)
			q.get_string_value (7, error_explanation)
			q.get_string_value (8, field_name)
			q.get_string_value (10, gds_filename)
			q.get_string_value (11, job_status)
			q.get_string_value (12, log_filename)
			q.get_string_value (13, run_id)
			q.get_string_value (16, top_structure)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_batch_job_no := q.is_null (1)
			is_null_center_x := q.is_null (2)
			is_null_center_y := q.is_null (3)
			is_null_date_job_ended := q.is_null (4)
			is_null_date_job_started := q.is_null (5)
			is_null_die_id := q.is_null (6)
			is_null_error_explanation := q.is_null (7)
			is_null_field_name := q.is_null (8)
			is_null_file_no := q.is_null (9)
			is_null_gds_filename := q.is_null (10)
			is_null_job_status := q.is_null (11)
			is_null_log_filename := q.is_null (12)
			is_null_run_id := q.is_null (13)
			is_null_size_x := q.is_null (14)
			is_null_size_y := q.is_null (15)
			is_null_top_structure := q.is_null (16)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_run_id := True
			is_null_file_no := True
			create run_id.make (0)
		end

	set_null_nonkey
		do
			is_null_batch_job_no := True
			is_null_center_x := True
			is_null_center_y := True
			is_null_date_job_ended := True
			is_null_date_job_started := True
			is_null_die_id := True
			is_null_error_explanation := True
			is_null_field_name := True
			is_null_gds_filename := True
			is_null_job_status := True
			is_null_log_filename := True
			is_null_size_x := True
			is_null_size_y := True
			is_null_top_structure := True
			create {ORACLE_DATE} date_job_ended.set_null
			create {ORACLE_DATE} date_job_started.set_null
			create die_id.make (0)
			create error_explanation.make (0)
			create field_name.make (0)
			create gds_filename.make (0)
			create job_status.make (0)
			create log_filename.make (0)
			create top_structure.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, run_id, False)
			q.bind_num_to_integer (2, file_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
			d: DB_DATE
		do
			s := temp_string
			d := temp_date
			Result := True
			Result := Result
				and batch_job_no = q.integer_value (1)
				and center_x = q.double_value (2)
				and center_y = q.double_value (3)
				and file_no = q.integer_value (9)
				and size_x = q.double_value (14)
				and size_y = q.double_value (15)
			q.get_date_value (4, d)
			Result := Result and equal (date_job_ended, d)
			q.get_date_value (5, d)
			Result := Result and equal (date_job_started, d)
			q.get_string_value (6, s)
			Result := Result and equal (die_id, s)
			q.get_string_value (7, s)
			Result := Result and equal (error_explanation, s)
			q.get_string_value (8, s)
			Result := Result and equal (field_name, s)
			q.get_string_value (10, s)
			Result := Result and equal (gds_filename, s)
			q.get_string_value (11, s)
			Result := Result and equal (job_status, s)
			q.get_string_value (12, s)
			Result := Result and equal (log_filename, s)
			q.get_string_value (13, s)
			Result := Result and equal (run_id, s)
			q.get_string_value (16, s)
			Result := Result and equal (top_structure, s)
			Result := Result
				and is_null_batch_job_no = q.is_null (1)
				and is_null_center_x = q.is_null (2)
				and is_null_center_y = q.is_null (3)
				and is_null_date_job_ended = q.is_null (4)
				and is_null_date_job_started = q.is_null (5)
				and is_null_die_id = q.is_null (6)
				and is_null_error_explanation = q.is_null (7)
				and is_null_field_name = q.is_null (8)
				and is_null_file_no = q.is_null (9)
				and is_null_gds_filename = q.is_null (10)
				and is_null_job_status = q.is_null (11)
				and is_null_log_filename = q.is_null (12)
				and is_null_run_id = q.is_null (13)
				and is_null_size_x = q.is_null (14)
				and is_null_size_y = q.is_null (15)
				and is_null_top_structure = q.is_null (16)
		end

end
