
indexing

	date: "Mon Nov  3 11:20:35 2008"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user ALLMOSIS"
	database_tables: 
		"RUN_GDS_MERGE_RESULTS (MOSIS.RUN_GDS_MERGE_RESULTS)"
			-- Included columns
			-- 	CENTER_X
			-- 	CENTER_Y
			-- 	FILE_NO
			-- 	RUN_ID
			-- 	SIZE_X
			-- 	SIZE_Y
			-- 	TOP_STRUCTURE
			-- Excluded columns
			-- 	(none)

class RUN_GDS_MERGE_RESULTS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_run_id: STRING; the_file_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_run_id_exists: the_run_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			run_id := the_run_id
			file_no := the_file_no
			is_null_run_id := False
			is_null_file_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 7

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  center_x, center_y, file_no, run_id, size_x, size_y, top_structure"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "run_gds_merge_results rgmr"

	join_condition: STRING = ""

	table_name: STRING = "run_gds_merge_results"

	key_where_clause: STRING = "run_id = :1 and file_no = :2"

feature -- Values

	center_x: DOUBLE
			-- DB: NUMBER(12,6)

	center_y: DOUBLE
			-- DB: NUMBER(12,6)

	file_no: INTEGER
			-- DB: NUMBER(3,0) not null

	run_id: STRING
			-- DB: CHAR(4) not null

	size_x: DOUBLE
			-- DB: NUMBER(12,6)

	size_y: DOUBLE
			-- DB: NUMBER(12,6)

	top_structure: STRING
			-- DB: VARCHAR2(255)

feature -- Maximum database lengths for character columns

	maxlen_run_id: INTEGER = 4
	maxlen_top_structure: INTEGER = 255

feature -- Precisions for number columns

	precision_center_x: INTEGER = 12
	precision_center_y: INTEGER = 12
	precision_file_no: INTEGER = 3
	precision_size_x: INTEGER = 12
	precision_size_y: INTEGER = 12

feature -- Scales for number columns

	scale_center_x: INTEGER = 6
	scale_center_y: INTEGER = 6
	scale_file_no: INTEGER = 0
	scale_size_x: INTEGER = 6
	scale_size_y: INTEGER = 6

feature -- Nullness for null allowed columns

	is_null_center_x: BOOLEAN
	is_null_center_y: BOOLEAN
	is_null_size_x: BOOLEAN
	is_null_size_y: BOOLEAN
	is_null_top_structure: BOOLEAN

feature -- Nullness for non-null columns

	is_null_file_no: BOOLEAN
	is_null_run_id: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and file_no = r.file_no
			Result := Result
				and equal (run_id, r.run_id)
			Result := Result
				and is_null_file_no = r.is_null_file_no
				and is_null_run_id = r.is_null_run_id
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and center_x = r.center_x
				and center_y = r.center_y
				and size_x = r.size_x
				and size_y = r.size_y
			Result := Result
				and equal (top_structure, r.top_structure)
			Result := Result
				and is_null_center_x = r.is_null_center_x
				and is_null_center_y = r.is_null_center_y
				and is_null_size_x = r.is_null_size_x
				and is_null_size_y = r.is_null_size_y
				and is_null_top_structure = r.is_null_top_structure
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_double (1)
			q.select_double (2)
			q.select_integer (3)
			q.select_string (4, 4)
			q.select_double (5)
			q.select_double (6)
			q.select_string (7, 255)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			center_x := q.double_value (1)
			center_y := q.double_value (2)
			file_no := q.integer_value (3)
			size_x := q.double_value (5)
			size_y := q.double_value (6)
		end

	fill_in_references (q: SQL_QUERY)
		do
			run_id := q.string_value (4)
			top_structure := q.string_value (7)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (4, run_id)
			q.get_string_value (7, top_structure)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_center_x := q.is_null (1)
			is_null_center_y := q.is_null (2)
			is_null_file_no := q.is_null (3)
			is_null_run_id := q.is_null (4)
			is_null_size_x := q.is_null (5)
			is_null_size_y := q.is_null (6)
			is_null_top_structure := q.is_null (7)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_run_id := True
			is_null_file_no := True
			create run_id.make (0)
		end

	set_null_nonkey
		do
			is_null_center_x := True
			is_null_center_y := True
			is_null_size_x := True
			is_null_size_y := True
			is_null_top_structure := True
			create top_structure.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, run_id, False)
			q.bind_num_to_integer (2, file_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and center_x = q.double_value (1)
				and center_y = q.double_value (2)
				and file_no = q.integer_value (3)
				and size_x = q.double_value (5)
				and size_y = q.double_value (6)
			q.get_string_value (4, s)
			Result := Result and equal (run_id, s)
			q.get_string_value (7, s)
			Result := Result and equal (top_structure, s)
			Result := Result
				and is_null_center_x = q.is_null (1)
				and is_null_center_y = q.is_null (2)
				and is_null_file_no = q.is_null (3)
				and is_null_run_id = q.is_null (4)
				and is_null_size_x = q.is_null (5)
				and is_null_size_y = q.is_null (6)
				and is_null_top_structure = q.is_null (7)
		end

end
