
indexing
	
	description: "An operation that checks a run id to ensure it is possible (it may still be nonstandard)"
	author: "David Hollenberg"
	date: "April 10, 2003"

class RUN_ID_CHECK_OP
inherit
	OPERATION
		rename
			try_operation as try_to_check_run_id
		end
	RC_UTILITIES_ACCESS
		export
			{NONE} all
		end

create
	default_create

feature -- Operations

	check_run_id (s: STRING trial: BOOLEAN)
			-- Check run id `s' to see if it is a possible run id.
			-- If `trial' check whether it is possible as
			-- a trial run id, otherwise check whether it is
			-- valid as a real run id
		require
			name_exists: s /= Void
		do
			run_id := s
			is_trial_run := trial
			execute
		end

feature {NONE} -- Implementation

	run_id: STRING
			-- Run id to be checked

	is_trial_run: BOOLEAN
			-- Is run id being checked for validity for a
			-- trial run instead of a real run?

	try_to_check_run_id
			-- Try to check run id
		local
			ok: BOOLEAN
			type: STRING
		do
			if is_trial_run then
				ok := rc.is_possible_trial_run_id (run_id)
				type := "trial"
			else
				ok := rc.is_possible_real_run_id (run_id)
				type := "real"
			end
			if not ok then
				handle_user_error ("Invalid " + type + " run id: " + run_id)
			end
		end

end
