
indexing
	
	description: "An operation that locks out all run closing by getting an exclusive lock on shared lock file"
	author: "David Hollenberg"
	date: "April 15, 2003"

class RUN_LOCK_OUT_OP
inherit
	OPERATION
		rename
			try_operation as try_to_lock_out
		end

create
	default_create

feature -- Operations

	lock_out (sess: RC_SESSION)
			-- Lock out all run closing, using `sess'
		require
			session_exists: sess /= Void
		do
			session := sess
			execute
		end

feature {NONE} -- Implementation

	session: RC_SESSION
			-- Session to use

	try_to_lock_out
			-- Try to lock out all run closing activity
		local
		do
			session.lock_shared_exclusively
			inform ("Unix run closing sessions locked out - click OK to end lockout")
			session.unlock
		end

	publish_lock_out_started_event
		local
			lock_out_event: LOCK_OUT_STARTED_EVENT
		do
			create lock_out_event
			lock_out_event.publish
		end

	publish_lock_out_event
		local
			lock_out_over_event: LOCK_OUT_ENDED_EVENT
		do
			create lock_out_over_event
			lock_out_over_event.publish
		end

end
