
indexing

	date: "Tue Apr 24 10:30:16 2007"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user DHOLLEN"
	database_tables: 
		"RUN_PRIMITIVE_STEPS (MOSIS.RUN_PRIMITIVE_STEPS)"
			-- Included columns
			-- 	DATE_COMPLETED
			-- 	DATE_STARTED
			-- 	DATE_UNDO_COMPLETED
			-- 	DATE_UNDO_STARTED
			-- 	IS_APPLICABLE
			-- 	IS_OFFICIAL
			-- 	PRIMITIVE_STEP_NAME
			-- 	RUN_ID
			-- 	SAVED_STATE_FILENAME
			-- 	SAVED_UNDO_COUNT
			-- 	USERNAME
			-- Excluded columns
			-- 	(none)

class RUN_PRIMITIVE_STEPS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_run_id: STRING; the_primitive_step_name: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_run_id_exists: the_run_id /= Void
			the_primitive_step_name_exists: the_primitive_step_name /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			run_id := the_run_id
			primitive_step_name := the_primitive_step_name
			is_null_run_id := False
			is_null_primitive_step_name := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 11

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  date_completed, date_started, date_undo_completed, date_undo_started,%N  is_applicable, is_official, primitive_step_name, run_id,%N  saved_state_filename, saved_undo_count, username"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "run_primitive_steps rps"

	join_condition: STRING = ""

	table_name: STRING = "run_primitive_steps"

	key_where_clause: STRING = "run_id = :1 and primitive_step_name = :2"

feature -- Values

	date_completed: DB_DATE
			-- DB: DATE

	date_started: DB_DATE
			-- DB: DATE not null

	date_undo_completed: DB_DATE
			-- DB: DATE

	date_undo_started: DB_DATE
			-- DB: DATE

	is_applicable: BOOLEAN
			-- DB: CHAR(1) not null

	is_official: BOOLEAN
			-- DB: CHAR(1) not null

	primitive_step_name: STRING
			-- DB: VARCHAR2(30) not null

	run_id: STRING
			-- DB: CHAR(4) not null

	saved_state_filename: STRING
			-- DB: VARCHAR2(200)

	saved_undo_count: INTEGER
			-- DB: NUMBER(5,0)

	username: STRING
			-- DB: VARCHAR2(30) not null

feature -- Nullness for null allowed columns

	is_null_date_completed: BOOLEAN
	is_null_date_undo_completed: BOOLEAN
	is_null_date_undo_started: BOOLEAN
	is_null_saved_state_filename: BOOLEAN
	is_null_saved_undo_count: BOOLEAN

feature -- Nullness for non-null columns

	is_null_date_started: BOOLEAN
	is_null_is_applicable: BOOLEAN
	is_null_is_official: BOOLEAN
	is_null_primitive_step_name: BOOLEAN
	is_null_run_id: BOOLEAN
	is_null_username: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (primitive_step_name, r.primitive_step_name)
				and equal (run_id, r.run_id)
			Result := Result
				and is_null_primitive_step_name = r.is_null_primitive_step_name
				and is_null_run_id = r.is_null_run_id
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and is_applicable = r.is_applicable
				and is_official = r.is_official
				and saved_undo_count = r.saved_undo_count
			Result := Result
				and equal (date_completed, r.date_completed)
				and equal (date_started, r.date_started)
				and equal (date_undo_completed, r.date_undo_completed)
				and equal (date_undo_started, r.date_undo_started)
				and equal (saved_state_filename, r.saved_state_filename)
				and equal (username, r.username)
			Result := Result
				and is_null_date_completed = r.is_null_date_completed
				and is_null_date_started = r.is_null_date_started
				and is_null_date_undo_completed = r.is_null_date_undo_completed
				and is_null_date_undo_started = r.is_null_date_undo_started
				and is_null_is_applicable = r.is_null_is_applicable
				and is_null_is_official = r.is_null_is_official
				and is_null_saved_state_filename = r.is_null_saved_state_filename
				and is_null_saved_undo_count = r.is_null_saved_undo_count
				and is_null_username = r.is_null_username
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_date (1)
			q.select_date (2)
			q.select_date (3)
			q.select_date (4)
			q.select_boolean (5)
			q.select_boolean (6)
			q.select_string (7, 30)
			q.select_string (8, 4)
			q.select_string (9, 200)
			q.select_integer (10)
			q.select_string (11, 30)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			is_applicable := q.boolean_value (5)
			is_official := q.boolean_value (6)
			saved_undo_count := q.integer_value (10)
		end

	fill_in_references (q: SQL_QUERY)
		do
			date_completed := q.date_value (1)
			date_started := q.date_value (2)
			date_undo_completed := q.date_value (3)
			date_undo_started := q.date_value (4)
			primitive_step_name := q.string_value (7)
			run_id := q.string_value (8)
			saved_state_filename := q.string_value (9)
			username := q.string_value (11)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_date_value (1, date_completed)
			q.get_date_value (2, date_started)
			q.get_date_value (3, date_undo_completed)
			q.get_date_value (4, date_undo_started)
			q.get_string_value (7, primitive_step_name)
			q.get_string_value (8, run_id)
			q.get_string_value (9, saved_state_filename)
			q.get_string_value (11, username)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_date_completed := q.is_null (1)
			is_null_date_started := q.is_null (2)
			is_null_date_undo_completed := q.is_null (3)
			is_null_date_undo_started := q.is_null (4)
			is_null_is_applicable := q.is_null (5)
			is_null_is_official := q.is_null (6)
			is_null_primitive_step_name := q.is_null (7)
			is_null_run_id := q.is_null (8)
			is_null_saved_state_filename := q.is_null (9)
			is_null_saved_undo_count := q.is_null (10)
			is_null_username := q.is_null (11)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_run_id := True
			is_null_primitive_step_name := True
			create run_id.make (0)
			create primitive_step_name.make (0)
		end

	set_null_nonkey
		do
			is_null_date_completed := True
			is_null_date_started := True
			is_null_date_undo_completed := True
			is_null_date_undo_started := True
			is_null_is_applicable := True
			is_null_is_official := True
			is_null_saved_state_filename := True
			is_null_saved_undo_count := True
			is_null_username := True
			create {ORACLE_DATE} date_completed.set_null
			create {ORACLE_DATE} date_started.set_null
			create {ORACLE_DATE} date_undo_completed.set_null
			create {ORACLE_DATE} date_undo_started.set_null
			create saved_state_filename.make (0)
			create username.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, run_id, False)
			q.bind_num_to_string (2, primitive_step_name, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
			d: DB_DATE
		do
			s := temp_string
			d := temp_date
			Result := True
			Result := Result
				and is_applicable = q.boolean_value (5)
				and is_official = q.boolean_value (6)
				and saved_undo_count = q.integer_value (10)
			q.get_date_value (1, d)
			Result := Result and equal (date_completed, d)
			q.get_date_value (2, d)
			Result := Result and equal (date_started, d)
			q.get_date_value (3, d)
			Result := Result and equal (date_undo_completed, d)
			q.get_date_value (4, d)
			Result := Result and equal (date_undo_started, d)
			q.get_string_value (7, s)
			Result := Result and equal (primitive_step_name, s)
			q.get_string_value (8, s)
			Result := Result and equal (run_id, s)
			q.get_string_value (9, s)
			Result := Result and equal (saved_state_filename, s)
			q.get_string_value (11, s)
			Result := Result and equal (username, s)
			Result := Result
				and is_null_date_completed = q.is_null (1)
				and is_null_date_started = q.is_null (2)
				and is_null_date_undo_completed = q.is_null (3)
				and is_null_date_undo_started = q.is_null (4)
				and is_null_is_applicable = q.is_null (5)
				and is_null_is_official = q.is_null (6)
				and is_null_primitive_step_name = q.is_null (7)
				and is_null_run_id = q.is_null (8)
				and is_null_saved_state_filename = q.is_null (9)
				and is_null_saved_undo_count = q.is_null (10)
				and is_null_username = q.is_null (11)
		end

end
