
indexing

	date: "Tue Apr 24 10:30:16 2007"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user DHOLLEN"
	database_tables: 
		"RUN_WAFER_LEVEL_JOBS (MOSIS.RUN_WAFER_LEVEL_JOBS)"
			-- Included columns
			-- 	BATCH_JOB_NO
			-- 	CATS_JOB_TYPE
			-- 	CATS_STATUS
			-- 	DATE_JOB_ENDED
			-- 	DATE_JOB_STARTED
			-- 	ERROR_EXPLANATION
			-- 	LEVEL_NO
			-- 	RUN_ID
			-- 	WAFER_TECHN_FAMILY
			-- Excluded columns
			-- 	(none)

class RUN_WAFER_LEVEL_JOBS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_run_id: STRING; the_wafer_techn_family: STRING; the_level_no: INTEGER; the_cats_job_type: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_run_id_exists: the_run_id /= Void
			the_wafer_techn_family_exists: the_wafer_techn_family /= Void
			the_cats_job_type_exists: the_cats_job_type /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			run_id := the_run_id
			wafer_techn_family := the_wafer_techn_family
			level_no := the_level_no
			cats_job_type := the_cats_job_type
			is_null_run_id := False
			is_null_wafer_techn_family := False
			is_null_level_no := False
			is_null_cats_job_type := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 9

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  batch_job_no, cats_job_type, cats_status, date_job_ended,%N  date_job_started, error_explanation, level_no, run_id, wafer_techn_family"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "run_wafer_level_jobs rwlj"

	join_condition: STRING = ""

	table_name: STRING = "run_wafer_level_jobs"

	key_where_clause: STRING = "run_id = :1 and wafer_techn_family = :2 and level_no = :3 and cats_job_type = :4"

feature -- Values

	batch_job_no: INTEGER
			-- DB: NUMBER(9,0)

	cats_job_type: STRING
			-- DB: VARCHAR2(15) not null

	cats_status: STRING
			-- DB: VARCHAR2(15) not null

	date_job_ended: DB_DATE
			-- DB: DATE

	date_job_started: DB_DATE
			-- DB: DATE

	error_explanation: STRING
			-- DB: VARCHAR2(4000)

	level_no: INTEGER
			-- DB: NUMBER(3,0) not null

	run_id: STRING
			-- DB: CHAR(4) not null

	wafer_techn_family: STRING
			-- DB: VARCHAR2(50) not null

feature -- Maximum database lengths for character columns

	maxlen_cats_job_type: INTEGER = 15
	maxlen_cats_status: INTEGER = 15
	maxlen_error_explanation: INTEGER = 4000
	maxlen_run_id: INTEGER = 4
	maxlen_wafer_techn_family: INTEGER = 50

feature -- Precisions for number columns

	precision_batch_job_no: INTEGER = 9
	precision_level_no: INTEGER = 3

feature -- Scales for number columns

	scale_batch_job_no: INTEGER = 0
	scale_level_no: INTEGER = 0

feature -- Nullness for null allowed columns

	is_null_batch_job_no: BOOLEAN
	is_null_date_job_ended: BOOLEAN
	is_null_date_job_started: BOOLEAN
	is_null_error_explanation: BOOLEAN

feature -- Nullness for non-null columns

	is_null_cats_job_type: BOOLEAN
	is_null_cats_status: BOOLEAN
	is_null_level_no: BOOLEAN
	is_null_run_id: BOOLEAN
	is_null_wafer_techn_family: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and level_no = r.level_no
			Result := Result
				and equal (cats_job_type, r.cats_job_type)
				and equal (run_id, r.run_id)
				and equal (wafer_techn_family, r.wafer_techn_family)
			Result := Result
				and is_null_cats_job_type = r.is_null_cats_job_type
				and is_null_level_no = r.is_null_level_no
				and is_null_run_id = r.is_null_run_id
				and is_null_wafer_techn_family = r.is_null_wafer_techn_family
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and batch_job_no = r.batch_job_no
			Result := Result
				and equal (cats_status, r.cats_status)
				and equal (date_job_ended, r.date_job_ended)
				and equal (date_job_started, r.date_job_started)
				and equal (error_explanation, r.error_explanation)
			Result := Result
				and is_null_batch_job_no = r.is_null_batch_job_no
				and is_null_cats_status = r.is_null_cats_status
				and is_null_date_job_ended = r.is_null_date_job_ended
				and is_null_date_job_started = r.is_null_date_job_started
				and is_null_error_explanation = r.is_null_error_explanation
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_integer (1)
			q.select_string (2, 15)
			q.select_string (3, 15)
			q.select_date (4)
			q.select_date (5)
			q.select_string (6, 4000)
			q.select_integer (7)
			q.select_string (8, 4)
			q.select_string (9, 50)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			batch_job_no := q.integer_value (1)
			level_no := q.integer_value (7)
		end

	fill_in_references (q: SQL_QUERY)
		do
			cats_job_type := q.string_value (2)
			cats_status := q.string_value (3)
			date_job_ended := q.date_value (4)
			date_job_started := q.date_value (5)
			error_explanation := q.string_value (6)
			run_id := q.string_value (8)
			wafer_techn_family := q.string_value (9)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (2, cats_job_type)
			q.get_string_value (3, cats_status)
			q.get_date_value (4, date_job_ended)
			q.get_date_value (5, date_job_started)
			q.get_string_value (6, error_explanation)
			q.get_string_value (8, run_id)
			q.get_string_value (9, wafer_techn_family)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_batch_job_no := q.is_null (1)
			is_null_cats_job_type := q.is_null (2)
			is_null_cats_status := q.is_null (3)
			is_null_date_job_ended := q.is_null (4)
			is_null_date_job_started := q.is_null (5)
			is_null_error_explanation := q.is_null (6)
			is_null_level_no := q.is_null (7)
			is_null_run_id := q.is_null (8)
			is_null_wafer_techn_family := q.is_null (9)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_run_id := True
			is_null_wafer_techn_family := True
			is_null_level_no := True
			is_null_cats_job_type := True
			create run_id.make (0)
			create wafer_techn_family.make (0)
			create cats_job_type.make (0)
		end

	set_null_nonkey
		do
			is_null_batch_job_no := True
			is_null_cats_status := True
			is_null_date_job_ended := True
			is_null_date_job_started := True
			is_null_error_explanation := True
			create cats_status.make (0)
			create {ORACLE_DATE} date_job_ended.set_null
			create {ORACLE_DATE} date_job_started.set_null
			create error_explanation.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, run_id, False)
			q.bind_num_to_string (2, wafer_techn_family, False)
			q.bind_num_to_integer (3, level_no, False)
			q.bind_num_to_string (4, cats_job_type, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
			d: DB_DATE
		do
			s := temp_string
			d := temp_date
			Result := True
			Result := Result
				and batch_job_no = q.integer_value (1)
				and level_no = q.integer_value (7)
			q.get_string_value (2, s)
			Result := Result and equal (cats_job_type, s)
			q.get_string_value (3, s)
			Result := Result and equal (cats_status, s)
			q.get_date_value (4, d)
			Result := Result and equal (date_job_ended, d)
			q.get_date_value (5, d)
			Result := Result and equal (date_job_started, d)
			q.get_string_value (6, s)
			Result := Result and equal (error_explanation, s)
			q.get_string_value (8, s)
			Result := Result and equal (run_id, s)
			q.get_string_value (9, s)
			Result := Result and equal (wafer_techn_family, s)
			Result := Result
				and is_null_batch_job_no = q.is_null (1)
				and is_null_cats_job_type = q.is_null (2)
				and is_null_cats_status = q.is_null (3)
				and is_null_date_job_ended = q.is_null (4)
				and is_null_date_job_started = q.is_null (5)
				and is_null_error_explanation = q.is_null (6)
				and is_null_level_no = q.is_null (7)
				and is_null_run_id = q.is_null (8)
				and is_null_wafer_techn_family = q.is_null (9)
		end

end
