
indexing
	
	description: "Slot into which objects can be placed for reticle packer %
		%horizontal or vertical scan"
	author: "David Hollenberg"
	date: "January 3, 2007"

class SCAN_SLOT
create
	make

feature {NONE} -- Creation

	make
		do
			create {ARRAYED_LIST [RETICLE_VIEW_ELEMENT]} elements.make (5)
		end

feature -- Properties

	lower_limit: DOUBLE
			-- Lower limit for determining whether movable object
			-- should be packed into this slot (center of starting
			-- obstacle)

	upper_limit: DOUBLE
			-- Upper limit for determining whether movable object
			-- should be packed into this slot (center of ending
			-- obstacle)

	lower_edge: DOUBLE
			-- Edge of starting obstacle which defines lower
			-- limit of available space for slot

	upper_edge: DOUBLE
			-- Edge of ending obstacle which defines upper
			-- limit of available space for slot

	width: DOUBLE
			-- Width of available space (distance between
			-- `lower_edge' and `upper_edge')
		do
			Result := upper_edge - lower_edge
		end

	elements: LIST [RETICLE_VIEW_ELEMENT]
			-- Elements which will be placed in this slot,
			-- if they all fit

feature -- Modification

	set_lower_limit (a_value: like lower_limit)
			-- Set `lower_limit' to `a_value'
		do
			lower_limit := a_value
		ensure
			lower_limit_set: lower_limit = a_value
		end

	set_upper_limit (a_value: like upper_limit)
			-- Set `upper_limit' to `a_value'
		do
			upper_limit := a_value
		ensure
			upper_limit_set: upper_limit = a_value
		end

	set_lower_edge (a_value: like lower_edge)
			-- Set `lower_edge' to `a_value'
		do
			lower_edge := a_value
		ensure
			lower_edge_set: lower_edge = a_value
		end

	set_upper_edge (a_value: like upper_edge)
			-- Set `upper_edge' to `a_value'
		do
			upper_edge := a_value
		ensure
			upper_edge_set: upper_edge = a_value
		end

end
