
indexing

	author: "Generated"
	date: "Thu Jun 12 13:50:27 PDT 2003"

class SCHEDULED_RUNS_EROW
inherit
	SCHEDULED_RUNS_ERAW
	ROW_COUNT_CHECK_ACCESS
create
	make_template, make_null

feature -- Properties

	possible_scheduled_runs_ordered (wt: STRING is_edu: BOOLEAN days_past, days_future: INTEGER conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current] is
			-- All rows for scheduled runs compatible with
			-- wafer techn `wt' and `is_edu', whose scheduled
			-- date is within the range indicated by
			-- `days_past' and `days_future'
		require
			wafer_techn_exists: wt /= Void
			days_past_nonnegative: days_past >= 0
			days_future_nonnegative: days_future >= 0
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_SSII
			pricing_grp: PRICING_GROUP_VALUES
		do
			create b.make (wt, pricing_grp.Educational, -days_past, days_future)
			Result := all_rows_filtered_ordered (conn, sched_runs_filter (is_edu, days_past, days_future), b, "abs(date_scheduled - sysdate)")
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end


feature {NONE} -- Implementation

	sched_runs_filter (is_edu: BOOLEAN days_past, days_future: INTEGER): STRING is
			-- Filter for possible scheduled runs for this run,
			-- where `is_edu' indicates whether it is an
			-- educational run
		do
			Result := "wafer_techn = :1 and date_canceled is null%N"
			Result.append ("and date_scheduled - sysdate between :3 and :4%N")
			Result.append ("and pricing_group ")
			if is_edu then
				Result.extend ('=')
			else
				Result.append ("<>")
			end
			Result.append (" :2")
			if is_edu then
				Result.extend ('%N')
				Result.append ("and not exists%N  (select 1 from scheduled_run#pricing_groups srpg2%N   where srpg.sched_run_no = srpg2.sched_run_no and pricing_group <> :2)")
			end
		ensure
			result_exists: Result /= Void
		end

end
