
indexing

	author: "Generated"
	date: "Thu Jun 12 13:50:27 PDT 2003"

class SCHEDULED_RUNS_ROW
inherit
	SCHEDULED_RUNS_RAW

	STRING_UTILITIES_ACCESS

create
	make_template, make_null, make_by_key

feature	-- printable handles on the scheduled run

	foundry: STRING is
	local b: DB_BIND_S;
	do  create b.make(wafer_techn);
	    Result := connection.selected_string(
				"short_id", "organizations",
				org_no_of_wt, b);
	end;

	feature_size: STRING is
	local b: DB_BIND_S;
	do  create b.make(wafer_techn);
	    Result := connection.selected_string(
				"feature_size_um_ss", "run_techns",
				run_techn_of_wt, b);
	    if (Result @ 1) = '.'
	     then Result.precede('0')
	    end
	end;

	terse_handle: STRING is
	do  Result := su.string_of_5(
				date_scheduled.to_date_string,
				su.colon_space,
				foundry, su.space, feature_size)
	end;

	verbose_handle: STRING is
	do  Result := su.string_of_5(
				foundry, su.space, feature_size,
				" run scheduled on ",
				date_scheduled.to_date_string)
	end;

feature	-- info on the associated run(s)

	run_count: INTEGER is
		-- number of runs closed on me
	local b: DB_BIND_I;
	do  create b.make(sched_run_no);
	    Result := connection.selected_count("runs", by_sched_run, b)
	end;

	run_ids: LIST[STRING] is
		-- the names (run_id) of those runs
	local b: DB_BIND_I;
	do  create b.make(sched_run_no);
	    Result := connection.selected_strings("run_id", "runs",
					by_sched_run, Void, false, b)
	end;

	run_event_count(evnt: STRING): INTEGER is
		-- number of my runs that show (at least) one run_event
		--  with event_name = evnt
	local b: DB_BIND_SI;
	do  create b.make(evnt, sched_run_no);
	    Result := connection.selected_integer(
					"count(distinct run_id)",
					"run_events",
					event_filter, b)
	end;

feature	-- info on the pricing groups

	pricing_groups: LIST[STRING] is
	local b: DB_BIND_I;
	do  create b.make(sched_run_no);
	    Result := connection.selected_strings
				("pricing_group",
				 "scheduled_run#pricing_groups",
				 by_sched_run, "pricing_group", false, b);
	    Result.compare_objects
	end;

feature {NONE} -- details

	by_sched_run: STRING is "sched_run_no = :1"

	org_no_of_wt: STRING is
	"org_no = (select org_no from wafer_techns %
			%where wafer_techn = :1)"

	run_techn_of_wt: STRING is
	"run_techn = (select run_techn from wafer_techns_ %
			%where wafer_techn = :1)"

	event_filter: STRING is
	"event_name = :1 and %
	%run_id in (select run_id from runs where sched_run_no = :2)"

end
