
indexing
	
	description: "Action to set matched  indication if project's design %
		%number is included in a list"
	author: "David Hollenberg"
	date: "November 30, 2006"

class SEARCH_DESIGN_NUMBER_ACTION
inherit
	VIEW_ELEMENT_ACTION
	VIEW_ELEMENT_ACTIONS
		export
			{NONE} all
		end

feature -- Properties

	design_number_list: LIST [INTEGER]
			-- List of design numbers to search for

	select_matching_elements: BOOLEAN
			-- Should elements that have one of the design
			-- numbers in `design_number_list' be selected?

feature -- Modification

	set_design_number_list (a_list: like design_number_list)
			-- Set `design_number_list' to `a_list'
		require
			a_list_not_void: a_list /= Void
		do
			design_number_list := a_list
			design_number_list.compare_objects
		ensure
			design_number_list_set: design_number_list = a_list
		end

	set_select_matching_elements (a_value: like select_matching_elements)
			-- Set `select_matching_elements' to `a_value'
		do
			select_matching_elements := a_value
		ensure
			select_matching_elements_set: select_matching_elements = a_value
		end

feature -- Operations

	apply (an_element: RETICLE_VIEW_ELEMENT)
			-- Apply action to `an_element'
		local
			n: INTEGER
			matched: BOOLEAN
		do
			if an_element.is_project then
				n := an_element.design_number
				matched := design_number_list.has (n)
				an_element.set_matched_last_search (matched)
				if an_element.matched_last_search_changed then
					an_element.add_to_changed_region
				end
				if matched then
					an_element.view.found_elements.extend (an_element)
				end
			else
				matched := False
			end
			if select_matching_elements then
				an_element.set_selected (matched, True)
			end
			set_view_action.apply (an_element)
		end

end
