
indexing
	
	description: "Object that can generate colors for an %
		%element of a reticle view according to whether it was matched %
		%the search criteria for the last Search operation"
	author: "David Hollenberg"
	date: "December 8, 2006"

class SEARCH_RESULTS_COLOR_GENERATOR
inherit
	RETICLE_VIEW_ELEMENT_COLOR_GENERATOR

create
	make

feature -- Access

	border_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Foreground color for border (usually a
			-- rectangle) of `an_element'
		do
			Result := standard_color (an_element)
		end
	
	label_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Foreground color for label
		do
			Result := standard_color (an_element)
		end
	
feature {NONE} -- Implementation

	standard_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Standard color for `an_element', based on
			-- whether it matched criteria for last search
		do
			if not an_element.is_selectable then
				Result := palette.unselectable_color
			elseif an_element.matched_last_search then
				Result := palette.search_match_color
			else
				Result := palette.search_no_match_color
			end
		end
	
end
