
indexing
	
	description: "Action that sets view element color generator"
	author: "David Hollenberg"
	date: "October 1, 2006"

class SET_COLOR_GENERATOR_ACTION
inherit
	VIEW_ELEMENT_ACTION

feature -- Properties

	color_generator: RETICLE_VIEW_ELEMENT_COLOR_GENERATOR
			-- Generator for colors to display this element

feature -- Modification

	set_color_generator (a_generator: like color_generator)
			-- Set `color_generator' to `a_generator'
		require
			a_generator_not_void: a_generator /= Void
		do
			color_generator := a_generator
		ensure
			color_generator_set: color_generator = a_generator
		end

feature -- Operations

	apply (an_element: RETICLE_VIEW_ELEMENT)
			-- Apply action to `an_element'
		do
			an_element.set_color_generator (color_generator)
			if an_element.is_color_generator_changed then
				an_element.add_to_changed_region
			end
		end

invariant
	color_generator_not_void: color_generator /= Void
end
