
indexing
	
	description: "Action that sets view element fill generator"
	author: "David Hollenberg"
	date: "October 1, 2006"

class SET_FILL_GENERATOR_ACTION
inherit
	VIEW_ELEMENT_ACTION

feature -- Properties

	fill_generator: RETICLE_VIEW_ELEMENT_FILL_GENERATOR
			-- Generator for interior fill to display this element

feature -- Modification

	set_fill_generator (a_generator: like fill_generator)
			-- Set `fill_generator' to `a_generator'
		require
			a_generator_not_void: a_generator /= Void
		do
			fill_generator := a_generator
		ensure
			fill_generator_set: fill_generator = a_generator
		end

feature -- Operations

	apply (an_element: RETICLE_VIEW_ELEMENT)
			-- Apply action to `an_element'
		do
			an_element.set_fill_generator (fill_generator)
			if an_element.is_fill_generator_changed then
				an_element.add_to_changed_region
			end
		end

invariant
	fill_generator_not_void: fill_generator /= Void
end
