
indexing
	
	description: "Action that sets view element label generator"
	author: "David Hollenberg"
	date: "October 1, 2006"

class SET_LABEL_GENERATOR_ACTION
inherit
	VIEW_ELEMENT_ACTION
		redefine
			default_create
		end
	SHARED_RETICLE_LABEL_GENERATORS
		export
			{NONE} all
		redefine
			default_create
		end

feature {NONE} -- Creation

	default_create
		do
			label_generator := design_number_label_generator
		end

feature -- Properties

	label_generator: RETICLE_VIEW_ELEMENT_LABEL_GENERATOR
			-- Generator for text to display to label this element

feature -- Modification

	set_label_generator (a_generator: like label_generator)
			-- Set `label_generator' to `a_generator'
		require
			a_generator_not_void: a_generator /= Void
		do
			label_generator := a_generator
		ensure
			label_generator_set: label_generator = a_generator
		end

feature -- Operations

	apply (an_element: RETICLE_VIEW_ELEMENT)
			-- Apply action to `an_element'
		do
			an_element.set_label_generator (label_generator)
			if an_element.is_label_generator_changed then
				an_element.add_to_changed_region
			end
		end

invariant
	label_generator_not_void: label_generator /= Void
end
