
indexing
	
	description: "Action that sets view element opacity generator"
	author: "David Hollenberg"
	date: "October 1, 2006"

class SET_OPACITY_GENERATOR_ACTION
inherit
	VIEW_ELEMENT_ACTION

feature -- Properties

	opacity_generator: RETICLE_VIEW_ELEMENT_OPACITY_GENERATOR
			-- Generator for opaque/transparent indicator
			-- to display this element

feature -- Modification

	set_opacity_generator (a_generator: like opacity_generator)
			-- Set `opacity_generator' to `a_generator'
		require
			a_generator_not_void: a_generator /= Void
		do
			opacity_generator := a_generator
		ensure
			opacity_generator_set: opacity_generator = a_generator
		end

feature -- Operations

	apply (an_element: RETICLE_VIEW_ELEMENT)
			-- Apply action to `an_element'
		do
			an_element.set_opacity_generator (opacity_generator)
			if an_element.is_opacity_generator_changed then
				an_element.add_to_changed_region
			end
		end

invariant
	opacity_generator_not_void: opacity_generator /= Void
end
