
indexing
	
	description: "Interface to obtain a single unconstrained value from the user"
	author: "David Hollenberg"
	date: "April 3, 2003"

deferred class SINGLE_FREE_VALUE_IFC

inherit
	SINGLE_VALUE_IFC
		
feature -- Modification

	set_default_value (s: STRING)
			-- Set default value to `s'
		require
			string_exists: s /= Void
		do
			default_value := s
		ensure
			default_value_set: default_value = s
		end

	set_minimum_width_in_chars (n: INTEGER)
			-- Set `minimum_width_in_chars' to `n'
		do
			minimum_width_in_chars := n
		ensure
			minimum_width_set: minimum_width_in_chars = n
		end

feature -- Properties

	default_value: STRING
			-- Default value if not Void

	minimum_width_in_chars: INTEGER
			-- Minimum width of text field in characters

end
