
indexing
	
	description: "Interface to obtain a single value from the user"
	author: "David Hollenberg"
	date: "April 3, 2003"

deferred class SINGLE_VALUE_IFC

inherit
	ABSTRACT_INTERFACE
	CASE_SETTABLE
		undefine
			default_create
		end
		
feature {NONE} -- Creation

	make_interface
			-- Create interface
		do
			create accept_actions
			create decline_actions
			label := ""
		end

feature -- Modification

	set_label (s: STRING)
			-- Set `label' to `s'
		require
			string_exists: s /= Void
		do
			label := s
		ensure
			label_set: label = s
		end

feature -- Properties

	accept_actions: CLOSED_ACTION_SEQUENCE
			-- Actions to be performed when user accepts current
			-- operation

	decline_actions: CLOSED_ACTION_SEQUENCE
			-- Actions to be performed when user declines to
			-- proceed with current operation

	label: STRING
			-- Descriptive label that explains what
			-- kind of value user is being asked for
	
	entered_value: STRING
			-- Value entered by user

feature -- Operations
	
	execute_action (action: PROCEDURE [ANY, TUPLE [STRING]])
			-- Execute `action' and pass it the user's value
		require
			action_exists: action /= Void
		do
			action.call ([entered_value])
		end

invariant
	accept_actions_exist: accept_actions /= Void
	decline_actions_exist: decline_actions /= Void
end
