
indexing
	
	description: "Action to spread elements horizontally or vertically"
	author: "David Hollenberg"
	date: "November 16, 2006"

deferred class SPREAD_ACTION
inherit
	VIEW_ELEMENT_MOVE_ACTION

feature -- Properties

	next_point: POINT
			-- Point that defines where next element is to
			-- be placed

	spacing: DOUBLE
			-- Spacing between adjacent elements

	largest_dimension: DOUBLE
			-- Largest width (or height) of elements to be
			-- spread, depending on whether this is a horizontal
			-- or vertical spread

feature -- Modification

	set_spacing (a_spacing: like spacing)
			-- Set `spacing to `a_spacing'
		do
			spacing := a_spacing
		ensure
			spacing_set: spacing = a_spacing
		end

	set_largest_dimension (a_dimension: like largest_dimension)
			-- Set `largest_dimension to `a_dimension'
		do
			largest_dimension := a_dimension
		ensure
			largest_dimension_set: largest_dimension = a_dimension
		end

	set_next_point (a_point: like next_point)
			-- Set `next_point' to `a_point'
		require
			a_point_not_void: a_point /= Void
		do
			next_point := a_point
		ensure
			next_point_set: next_point = a_point
		end

feature -- Operations

feature {NONE} -- Implementation

	compute_move_distance (an_element: RETICLE_VIEW_ELEMENT)
			-- Compute `move_distance' for `an_element'
		do
			move_distance.make_xy (grid.rounded_edge (new_center.x - an_element.model_element.center_x), grid.rounded_edge (new_center.y - an_element.model_element.center_y))
		end

	do_additional_validation (an_element: RETICLE_VIEW_ELEMENT)
			-- Do any additional validation needed
		do
		end

end
