
indexing
	
	description: "Unix-specific constants related to stat and umask calls"
	author: "David Hollenberg"
	date: "May 30, 2001"

class STAT_CONSTANTS

feature -- Properties

	S_irwxu: INTEGER
			-- Read, write, execute: owner
		external
			"C macro use <sys/stat.h>"
		alias
			"S_IRWXU"
		end
	
	S_irusr: INTEGER
			-- Read permission: owner
		external
			"C macro use <sys/stat.h>"
		alias
			"S_IRUSR"
		end
	
	S_iwusr: INTEGER
			-- Write permission: owner
		external
			"C macro use <sys/stat.h>"
		alias
			"S_IWUSR"
		end
	
	S_ixusr: INTEGER
			-- Execute permission: owner
		external
			"C macro use <sys/stat.h>"
		alias
			"S_IXUSR"
		end
	
	S_irwxg: INTEGER
			-- Read, write, execute: group
		external
			"C macro use <sys/stat.h>"
		alias
			"S_IRWXG"
		end
	
	S_irgrp: INTEGER
			-- Read permission: group
		external
			"C macro use <sys/stat.h>"
		alias
			"S_IRGRP"
		end
	
	S_iwgrp: INTEGER
			-- Write permission: group
		external
			"C macro use <sys/stat.h>"
		alias
			"S_IWGRP"
		end
	
	S_ixgrp: INTEGER
			-- Execute permission: group
		external
			"C macro use <sys/stat.h>"
		alias
			"S_IXGRP"
		end
	
	S_irwxo: INTEGER
			-- Read, write, execute: other
		external
			"C macro use <sys/stat.h>"
		alias
			"S_IRWXO"
		end
	
	S_iroth: INTEGER
			-- Read permission: other
		external
			"C macro use <sys/stat.h>"
		alias
			"S_IROTH"
		end
	
	S_iwoth: INTEGER
			-- Write permission: other
		external
			"C macro use <sys/stat.h>"
		alias
			"S_IWOTH"
		end
	
	S_ixoth: INTEGER
			-- Execute permission: other
		external
			"C macro use <sys/stat.h>"
		alias
			"S_IXOTH"
		end
	
end
