class SUB_PROCESS_CACHE

inherit

	ANY

	UNIX_OS_ACCESS export {NONE} all end;

	EXECUTION_ENVIRONMENT_ACCESS export {NONE} all end;

	STRING_UTILITIES_ACCESS export {NONE} all end;

feature {NONE} -- child maintenance for cleanup purposes

	all_my_children: ARRAYED_LIST[UNIX_PROCESS] is
		-- cache of all child processes that are still chugging
	once  create Result.make(4)
	end;

	check_the_children is
		-- check each one to see if still running;
		-- log and delete from cache if not
	local lst: like all_my_children; it: UNIX_PROCESS;
	do  from  lst := all_my_children;
		  lst.start
	    until lst.after
	    loop  it := lst.item;
		  if is_still_chugging(it)
		   then lst.forth
--		   else glo.log_line_2("Process",
--				su.string_of_3(it.process_id.out, su.space,
--				    unix_os.status_description (it.status)))
		   else log_child_status(it.process_id.out,
				   unix_os.status_description(it.status));
			lst.remove
		  end;
	    end;
	end;

	is_still_chugging(it: UNIX_PROCESS): BOOLEAN is
	local gone: BOOLEAN
	do  if not gone
	     then if it.is_executing then it.get_status_noblock end;
		  Result := it.is_executing
	    end
	rescue
	    gone := true; retry
	end;

feature {NONE} -- logging

	log_child_status(proc_id, proc_status: STRING) is
	do
	end;

end -- SUB_PROCESS_CACHE
