
indexing
	
	description: "Action that switches view element color generator to %
		%a new color generator if it is currently equal to the old %
		%color generator"
	author: "David Hollenberg"
	date: "October 5, 2006"

class SWITCH_COLOR_GENERATOR_ACTION
inherit
	VIEW_ELEMENT_ACTION

feature -- Properties

	old_color_generator: RETICLE_VIEW_ELEMENT_COLOR_GENERATOR
			-- Old generator for colors

	new_color_generator: RETICLE_VIEW_ELEMENT_COLOR_GENERATOR
			-- New generator for colors

feature -- Modification

	set_old_color_generator (a_generator: like old_color_generator)
			-- Set `old_color_generator' to `a_generator'
		require
			a_generator_not_void: a_generator /= Void
		do
			old_color_generator := a_generator
		ensure
			old_color_generator_set: old_color_generator = a_generator
		end

	set_new_color_generator (a_generator: like new_color_generator)
			-- Set `new_color_generator' to `a_generator'
		require
			a_generator_not_void: a_generator /= Void
		do
			new_color_generator := a_generator
		ensure
			new_color_generator_set: new_color_generator = a_generator
		end

feature -- Operations

	apply (an_element: RETICLE_VIEW_ELEMENT)
			-- Apply action to `an_element'
		do
			if an_element.color_generator = old_color_generator then
				an_element.set_color_generator (new_color_generator)
				an_element.add_to_changed_region
			end
		end

end
