
indexing
	
	description: "Action that switches view element fill generator to %
		%a new fill generator if it is currently equal to the old %
		%fill generator"
	author: "David Hollenberg"
	date: "October 5, 2006"

class SWITCH_FILL_GENERATOR_ACTION
inherit
	VIEW_ELEMENT_ACTION

feature -- Properties

	old_fill_generator: RETICLE_VIEW_ELEMENT_FILL_GENERATOR
			-- Old generator for fill

	new_fill_generator: RETICLE_VIEW_ELEMENT_FILL_GENERATOR
			-- New generator for fill

feature -- Modification

	set_old_fill_generator (a_generator: like old_fill_generator)
			-- Set `old_fill_generator' to `a_generator'
		require
			a_generator_not_void: a_generator /= Void
		do
			old_fill_generator := a_generator
		ensure
			old_fill_generator_set: old_fill_generator = a_generator
		end

	set_new_fill_generator (a_generator: like new_fill_generator)
			-- Set `new_fill_generator' to `a_generator'
		require
			a_generator_not_void: a_generator /= Void
		do
			new_fill_generator := a_generator
		ensure
			new_fill_generator_set: new_fill_generator = a_generator
		end

feature -- Operations

	apply (an_element: RETICLE_VIEW_ELEMENT)
			-- Apply action to `an_element'
		do
			if an_element.fill_generator = old_fill_generator then
				an_element.set_fill_generator (new_fill_generator)
				an_element.add_to_changed_region
			end
		end

end
