class TECHN_GROUP_FAMILIES_ROW

inherit

	TECHN_GROUP_FAMILIES_RAW

create

	make_template, make_null, make_by_key, make_by_menu_text

feature {NONE} -- alternate creation

	make_by_menu_text(conn: DB_CONNECTION; opt: DB_QUERY_OPTION;
			  a_menu_text: STRING) is
	require have_text: a_menu_text /= Void and then
			   not a_menu_text.is_empty
	local b: DB_BIND_S
	do  create b.make(a_menu_text);
	    make_by_alternate_key(conn, opt, "menu_text = :1", b)
	end;

feature	-- my techn_groups

	techn_groups: LIST[TECHN_GROUPS_ROW] is
		-- all the techn_groups in this family
	local r: TECHN_GROUPS_ROW; b: DB_BIND_S;
	do  if cached_groups = Void
	     then create r.make_template;
		  create b.make(techn_group_family);
		  cached_groups := r.all_rows_filtered_ordered
					(connection,
					 "techn_group_family = :1", b,
					 "tg_family_tier_no")
	    end;
	    Result := cached_groups
	end;

	techn_group_by_size(x, y: DOUBLE): TECHN_GROUPS_ROW is
		-- the (first) techn_group that can contain an item
		-- of dimension X x Y
	local tgs: like techn_groups; tg: TECHN_GROUPS_ROW
	do  tgs := techn_groups
	    from  tgs.start
	    until tgs.after or Result /= Void
	    loop  tg := tgs.item
		  if tg.can_contain(x, y) then Result := tg end;
		  tgs.forth
	    end
	end;

feature {NONE} -- cached data

	cached_groups: LIST[TECHN_GROUPS_ROW]

end -- TECHN_GROUP_FAMILIES_ROW
