
indexing

	date: "Tue Apr 24 10:30:16 2007"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application NFE, database user DHOLLEN"
	database_tables: 
		"TECHN_GROUPS (MOSIS.TECHN_GROUPS)"
			-- Included columns
			-- 	MAX_AREA_SQMM_SSS
			-- 	MAX_DESIGN_SIZE_X
			-- 	MAX_DESIGN_SIZE_Y
			-- 	QUOTED_PRICE_ONLY
			-- 	TECHN_GROUP_FAMILY
			-- 	TG_FAMILY_TIER_NO
			-- Excluded columns
			-- 	(none)

class TECHN_GROUPS_RAW

inherit

	DB_IDENTIFIED_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_techn_group_family: STRING; the_tg_family_tier_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_techn_group_family_exists: the_techn_group_family /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			techn_group_family := the_techn_group_family
			tg_family_tier_no := the_tg_family_tier_no
			is_null_techn_group_family := False
			is_null_tg_family_tier_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 6

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  max_area_sqmm_sss, max_design_size_x, max_design_size_y,%N  quoted_price_only, techn_group_family, tg_family_tier_no"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "techn_groups tg"

	join_condition: STRING = ""

	table_name: STRING = "techn_groups"

	key_where_clause: STRING = "techn_group_family = :1 and tg_family_tier_no = :2"

feature -- Values

	max_area_sqmm_sss: DOUBLE
			-- DB: NUMBER(10,3) not null

	max_design_size_x: INTEGER
			-- DB: NUMBER(6,0) not null

	max_design_size_y: INTEGER
			-- DB: NUMBER(6,0) not null

	quoted_price_only: BOOLEAN
			-- DB: CHAR(1) not null

	techn_group_family: STRING
			-- DB: VARCHAR2(20) not null

	tg_family_tier_no: INTEGER
			-- DB: NUMBER(2,0) not null

feature -- Nullness for non-null columns

	is_null_max_area_sqmm_sss: BOOLEAN
	is_null_max_design_size_x: BOOLEAN
	is_null_max_design_size_y: BOOLEAN
	is_null_quoted_price_only: BOOLEAN
	is_null_techn_group_family: BOOLEAN
	is_null_tg_family_tier_no: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and tg_family_tier_no = r.tg_family_tier_no
			Result := Result
				and equal (techn_group_family, r.techn_group_family)
			Result := Result
				and is_null_techn_group_family = r.is_null_techn_group_family
				and is_null_tg_family_tier_no = r.is_null_tg_family_tier_no
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and max_area_sqmm_sss = r.max_area_sqmm_sss
				and max_design_size_x = r.max_design_size_x
				and max_design_size_y = r.max_design_size_y
				and quoted_price_only = r.quoted_price_only
			Result := Result
				and is_null_max_area_sqmm_sss = r.is_null_max_area_sqmm_sss
				and is_null_max_design_size_x = r.is_null_max_design_size_x
				and is_null_max_design_size_y = r.is_null_max_design_size_y
				and is_null_quoted_price_only = r.is_null_quoted_price_only
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_double (1)
			q.select_integer (2)
			q.select_integer (3)
			q.select_boolean (4)
			q.select_string (5, 20)
			q.select_integer (6)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			max_area_sqmm_sss := q.double_value (1)
			max_design_size_x := q.integer_value (2)
			max_design_size_y := q.integer_value (3)
			quoted_price_only := q.boolean_value (4)
			tg_family_tier_no := q.integer_value (6)
		end

	fill_in_references (q: SQL_QUERY)
		do
			techn_group_family := q.string_value (5)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (5, techn_group_family)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_max_area_sqmm_sss := q.is_null (1)
			is_null_max_design_size_x := q.is_null (2)
			is_null_max_design_size_y := q.is_null (3)
			is_null_quoted_price_only := q.is_null (4)
			is_null_techn_group_family := q.is_null (5)
			is_null_tg_family_tier_no := q.is_null (6)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_techn_group_family := True
			is_null_tg_family_tier_no := True
			create techn_group_family.make (0)
		end

	set_null_nonkey
		do
			is_null_max_area_sqmm_sss := True
			is_null_max_design_size_x := True
			is_null_max_design_size_y := True
			is_null_quoted_price_only := True
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, techn_group_family, False)
			q.bind_num_to_integer (2, tg_family_tier_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and max_area_sqmm_sss = q.double_value (1)
				and max_design_size_x = q.integer_value (2)
				and max_design_size_y = q.integer_value (3)
				and quoted_price_only = q.boolean_value (4)
				and tg_family_tier_no = q.integer_value (6)
			q.get_string_value (5, s)
			Result := Result and equal (techn_group_family, s)
			Result := Result
				and is_null_max_area_sqmm_sss = q.is_null (1)
				and is_null_max_design_size_x = q.is_null (2)
				and is_null_max_design_size_y = q.is_null (3)
				and is_null_quoted_price_only = q.is_null (4)
				and is_null_techn_group_family = q.is_null (5)
				and is_null_tg_family_tier_no = q.is_null (6)
		end

end
