
indexing
	
	description: "Object with text whose case can be set"
	author: "David Hollenberg"
	date: "December 15, 2004"

deferred class TEXT_CASE_SETTABLE
inherit
	CASE_SETTABLE
	STRING_UTILITIES_ACCESS
		export
			{NONE} all
		end

feature -- Properties

	text: STRING_GENERAL is
		deferred
		ensure
			result_exists: Result /= Void
		end

	caret_position: INTEGER
		deferred
		end

feature -- Modification
	
	set_text (s: STRING_GENERAL) is
		require
			text_exists: s /= Void
		deferred
		ensure
			value_set: text.as_string_32.is_equal (s.as_string_32)
		end

	set_caret_position (n: INTEGER)
		deferred
		end

feature {NONE} -- Implementation

	set_text_to_desired_case is
			-- Set `text' to desired case
		local
			s: STRING_8
			l_caret_position: INTEGER
		do
			s := text.as_string_8
			if is_uppercase_only then
				if not su.is_upper_case (s) then
					l_caret_position := caret_position
					set_text (s.as_upper)
					set_caret_position (l_caret_position)
				end
			elseif is_lowercase_only then
				if not su.is_lower_case (s) then
					l_caret_position := caret_position
					set_text (s.as_lower)
					set_caret_position (l_caret_position)
				end
			end
		end

end
