deferred class THREE_CHECKSUMS
	-- deal with sources of the three current checksum forms

feature	-- the three possible CHECKSUM_PAIRs
	-- note that some may be Void if not available

	cif_sum: CHECKSUM_PAIR is
	deferred
	end;

	binary_crc_sum: CHECKSUM_PAIR is
	deferred
	end;

	text_crc_sum: CHECKSUM_PAIR is
	deferred
	end;

feature	-- checksum names, for those wishing to print them or 
	-- select them by name

	cif_sum_name:	     STRING is "Old-style CIF checksum"
	binary_crc_sum_name: STRING is "Binary CRC checksum"
	text_crc_sum_name:   STRING is "Text CRC checksum"

	valid_sum_name(n: STRING): BOOLEAN is
		-- NOTE use these very string tokens!!
		-- (no clones)
	do  Result := n = cif_sum_name or n = binary_crc_sum_name
				or n = text_crc_sum_name
	end;

	named_sum(n: STRING): CHECKSUM_PAIR is
	require valid_name: valid_sum_name(n)
	do  if n = cif_sum_name
	     then Result := cif_sum
	    elseif n = binary_crc_sum_name
	     then Result := binary_crc_sum
	     else Result := text_crc_sum
	    end
	end;

end -- THREE_CHECKSUMS
