
indexing
	
	description: "Action that toggles isolation status of a project"
	author: "David Hollenberg"
	date: "December 18, 2006"

class TOGGLE_ISOLATION_ACTION
inherit
	VIEW_ELEMENT_ACTION

feature -- Operations

	apply (an_element: RETICLE_VIEW_ELEMENT)
			-- Apply action to `an_element'
		local
			new_isolated: BOOLEAN
		do
			new_isolated := not an_element.is_isolated_in_current_cut_pattern
			if an_element.cut_cut_die /= Void or not new_isolated then
				-- Always allow unisolate, even if 
				-- `cut_cut_die' is Void
				an_element.add_to_changed_region
				-- Make sure element is isolated when
				-- change is added
				if new_isolated then
					an_element.isolate
					an_element.add_change (create {ISOLATION_CHANGE}.make (an_element))
				else
					an_element.add_change (create {UNISOLATION_CHANGE}.make (an_element))
					an_element.unisolate
				end
			else
				an_element.report_isolation_failure
			end
		end

end
