
indexing
	
	description: "An operation for an unimplemented run closing step"
	author: "David Hollenberg"
	date: "April 24, 2003"

class UNIMPLEMENTED_STEP_OP
inherit
	RC_PRIMITIVE_STEP_OP
		redefine
			make
		end
	RC_APPLICABLE_STEP
	HAS_USER_INTERFACE
	NO_EXTERNAL_STATE

create
	make

feature {NONE} -- Creation

	make (s: like step sess: RC_RUN_CLOSING_SESSION)
			-- Create operation to execute step `s' in context
			-- of `session'
		do
			precursor (s, sess)
		end

feature -- Properties

	input_data_items: LIST [STRING]
			-- Data items required before step can be executed
		do
			Result := array_as_list (<< >>)
		end


feature {NONE} -- Implementation

	do_step
		do
			handle_hard_error ("Step not implemented: " + step.step_name)
		end

	undo_step
			-- Undo execution of step
		do
			handle_hard_error ("Step undo not implemented: " + step.step_name)
		end

	set_state
			-- Set `state'
		do
			handle_hard_error ("Step undo and save not implemented: " + step.step_name)
		end

end
