
indexing
	
	author: "David Hollenberg"
	date:	"April 25, 2001"
	description: "A Unix environment in form required for execve call"

class UNIX_ENVIRONMENT
inherit
	C_MEMORY_CHUNK
		rename
			make as c_memory_make
		export
			{NONE} c_memory_make, make_pointer
		redefine
			dispose
		end

create
	make

feature {NONE} -- Creation

	make (n: INTEGER)
			-- Create environment which can hold
			-- `n' environment strings (each of form NAME=VALUE)
			-- and also has space for terminating null pointer
		do
			make_pointer (n + 1)
			clear
		end

feature -- Modification

	dispose
			-- Free allocated memory
		local
			var, null_ptr: POINTER
			k: INTEGER
		do
			from
				k := 0
				var := nth_pointer (address, k)
			until
				var = null_ptr
			loop
				free_nongc_memory (var)
				k := k + 1
				var := nth_pointer (address, k)
			end
			precursor
		end

			
end
