
indexing
	
	description: "Unix-specific operating system error code constants"
	author: "David Hollenberg"
	date: "August 17, 1998"

class UNIX_ERROR_CONSTANTS

feature -- Error numbers

	Eperm: INTEGER
			-- Code for "Not owner"
		external
			"C macro use <errno.h>"
		alias
			"EPERM"
		end

	Enoent: INTEGER
			-- Code for "No such file or directory"
		external
			"C macro use <errno.h>"
		alias
			"ENOENT"
		end

	Esrch: INTEGER
			-- Code for "No such process"
		external
			"C macro use <errno.h>"
		alias
			"ESRCH"
		end

	Eintr: INTEGER
			-- Code for "Interrupted system call"
		external
			"C macro use <errno.h>"
		alias
			"EINTR"
		end

	Eio: INTEGER
			-- Code for "I/O error"
		external
			"C macro use <errno.h>"
		alias
			"EIO"
		end

	Enxio: INTEGER
			-- Code for "No such device or address"
		external
			"C macro use <errno.h>"
		alias
			"ENXIO"
		end

	E2big: INTEGER
			-- Code for "Arg list too long"
		external
			"C macro use <errno.h>"
		alias
			"E2BIG"
		end

	Enoexec: INTEGER
			-- Code for "Exec format error"
		external
			"C macro use <errno.h>"
		alias
			"ENOEXEC"
		end

	Ebadf: INTEGER
			-- Code for "Bad file number"
		external
			"C macro use <errno.h>"
		alias
			"EBADF"
		end

	Echild: INTEGER
			-- Code for "No child processes"
		external
			"C macro use <errno.h>"
		alias
			"ECHILD"
		end

	Eagain: INTEGER
			-- Code for "Resource temporarily unavailable"
		external
			"C macro use <errno.h>"
		alias
			"EAGAIN"
		end

	Enomem: INTEGER
			-- Code for "Not enough space"
		external
			"C macro use <errno.h>"
		alias
			"ENOMEM"
		end

	Eacces: INTEGER
			-- Code for "Permission denied"
		external
			"C macro use <errno.h>"
		alias
			"EACCES"
		end

	Efault: INTEGER
			-- Code for "Bad address"
		external
			"C macro use <errno.h>"
		alias
			"EFAULT"
		end

	Enotblk: INTEGER
			-- Code for "Block device required"
		external
			"C macro use <errno.h>"
		alias
			"ENOTBLK"
		end

	Ebusy: INTEGER
			-- Code for "Device busy"
		external
			"C macro use <errno.h>"
		alias
			"EBUSY"
		end

	Eexist: INTEGER
			-- Code for "File exists"
		external
			"C macro use <errno.h>"
		alias
			"EEXIST"
		end

	Exdev: INTEGER
			-- Code for "Cross-device link"
		external
			"C macro use <errno.h>"
		alias
			"EXDEV"
		end

	Enodev: INTEGER
			-- Code for "No such device"
		external
			"C macro use <errno.h>"
		alias
			"ENODEV"
		end

	Enotdir: INTEGER
			-- Code for "Not a directory"
		external
			"C macro use <errno.h>"
		alias
			"ENOTDIR"
		end

	Eisdir: INTEGER
			-- Code for "Is a directory"
		external
			"C macro use <errno.h>"
		alias
			"EISDIR"
		end

	Einval: INTEGER
			-- Code for "Invalid argument"
		external
			"C macro use <errno.h>"
		alias
			"EINVAL"
		end

	Enfile: INTEGER
			-- Code for "File table overflow"
		external
			"C macro use <errno.h>"
		alias
			"ENFILE"
		end

	Emfile: INTEGER
			-- Code for "Too many open files"
		external
			"C macro use <errno.h>"
		alias
			"EMFILE"
		end

	Enotty: INTEGER
			-- Code for "Inappropriate ioctl for device"
		external
			"C macro use <errno.h>"
		alias
			"ENOTTY"
		end

	Etxtbsy: INTEGER
			-- Code for "Text file busy"
		external
			"C macro use <errno.h>"
		alias
			"ETXTBSY"
		end

	Efbig: INTEGER
			-- Code for "File too large"
		external
			"C macro use <errno.h>"
		alias
			"EFBIG"
		end

	Enospc: INTEGER
			-- Code for "No space left on device"
		external
			"C macro use <errno.h>"
		alias
			"ENOSPC"
		end

	Espipe: INTEGER
			-- Code for "Illegal seek"
		external
			"C macro use <errno.h>"
		alias
			"ESPIPE"
		end

	Erofs: INTEGER
			-- Code for "Read-only file system"
		external
			"C macro use <errno.h>"
		alias
			"EROFS"
		end

	Emlink: INTEGER
			-- Code for "Too many links"
		external
			"C macro use <errno.h>"
		alias
			"EMLINK"
		end

	Epipe: INTEGER
			-- Code for "Broken pipe"
		external
			"C macro use <errno.h>"
		alias
			"EPIPE"
		end

	Edom: INTEGER
			-- Code for "Argument out of domain"
		external
			"C macro use <errno.h>"
		alias
			"EDOM"
		end

	Erange: INTEGER
			-- Code for "Result too large"
		external
			"C macro use <errno.h>"
		alias
			"ERANGE"
		end

	Enomsg: INTEGER
			-- Code for "No message of desired type"
		external
			"C macro use <errno.h>"
		alias
			"ENOMSG"
		end

	Eidrm: INTEGER
			-- Code for "Identifier removed"
		external
			"C macro use <errno.h>"
		alias
			"EIDRM"
		end

	Echrng: INTEGER
			-- Code for "Channel number out of range"
		external
			"C macro use <errno.h>"
		alias
			"ECHRNG"
		end

	El2nsync: INTEGER
			-- Code for "Level 2 not synchronized"
		external
			"C macro use <errno.h>"
		alias
			"EL2NSYNC"
		end

	El3hlt: INTEGER
			-- Code for "Level 3 halted"
		external
			"C macro use <errno.h>"
		alias
			"EL3HLT"
		end

	El3rst: INTEGER
			-- Code for "Level 3 reset"
		external
			"C macro use <errno.h>"
		alias
			"EL3RST"
		end

	Elnrng: INTEGER
			-- Code for "Link number out of range"
		external
			"C macro use <errno.h>"
		alias
			"ELNRNG"
		end

	Eunatch: INTEGER
			-- Code for "Protocol driver not attached"
		external
			"C macro use <errno.h>"
		alias
			"EUNATCH"
		end

	Enocsi: INTEGER
			-- Code for "No CSI structure available"
		external
			"C macro use <errno.h>"
		alias
			"ENOCSI"
		end

	El2hlt: INTEGER
			-- Code for "Level 2 halted"
		external
			"C macro use <errno.h>"
		alias
			"EL2HLT"
		end

	Edeadlk: INTEGER
			-- Code for "Deadlock situation detected/avoided"
		external
			"C macro use <errno.h>"
		alias
			"EDEADLK"
		end

	Enolck: INTEGER
			-- Code for "No record locks available"
		external
			"C macro use <errno.h>"
		alias
			"ENOLCK"
		end

	Ecanceled: INTEGER
			-- Code for "Operation canceled"
		external
			"C macro use <errno.h>"
		alias
			"ECANCELED"
		end

	Enotsup: INTEGER
			-- Code for "Operation not supported"
		external
			"C macro use <errno.h>"
		alias
			"ENOTSUP"
		end

	Edquot: INTEGER
			-- Code for "Disc quota exceeded"
		external
			"C macro use <errno.h>"
		alias
			"EDQUOT"
		end

	Ebade: INTEGER
			-- Code for "Bad exchange descriptor"
		external
			"C macro use <errno.h>"
		alias
			"EBADE"
		end

	Ebadr: INTEGER
			-- Code for "Bad request descriptor"
		external
			"C macro use <errno.h>"
		alias
			"EBADR"
		end

	Exfull: INTEGER
			-- Code for "Message tables full"
		external
			"C macro use <errno.h>"
		alias
			"EXFULL"
		end

	Enoano: INTEGER
			-- Code for "Anode table overflow"
		external
			"C macro use <errno.h>"
		alias
			"ENOANO"
		end

	Ebadrqc: INTEGER
			-- Code for "Bad request code"
		external
			"C macro use <errno.h>"
		alias
			"EBADRQC"
		end

	Ebadslt: INTEGER
			-- Code for "Invalid slot"
		external
			"C macro use <errno.h>"
		alias
			"EBADSLT"
		end

	Edeadlock: INTEGER
			-- Code for "File locking deadlock"
		external
			"C macro use <errno.h>"
		alias
			"EDEADLOCK"
		end

	Ebfont: INTEGER
			-- Code for "Bad font file format"
		external
			"C macro use <errno.h>"
		alias
			"EBFONT"
		end

	Eownerdead: INTEGER
			-- Code for "Owner of the lock died"
		external
			"C macro use <errno.h>"
		alias
			"EOWNERDEAD"
		end

	Enotrecoverable: INTEGER
			-- Code for "Lock is not recoverable"
		external
			"C macro use <errno.h>"
		alias
			"ENOTRECOVERABLE"
		end

	Enostr: INTEGER
			-- Code for "Not a stream device"
		external
			"C macro use <errno.h>"
		alias
			"ENOSTR"
		end

	Enodata: INTEGER
			-- Code for "No data available"
		external
			"C macro use <errno.h>"
		alias
			"ENODATA"
		end

	Etime: INTEGER
			-- Code for "Timer expired"
		external
			"C macro use <errno.h>"
		alias
			"ETIME"
		end

	Enosr: INTEGER
			-- Code for "Out of stream resources"
		external
			"C macro use <errno.h>"
		alias
			"ENOSR"
		end

	Enonet: INTEGER
			-- Code for "Machine is not on the network"
		external
			"C macro use <errno.h>"
		alias
			"ENONET"
		end

	Enopkg: INTEGER
			-- Code for "Package not installed"
		external
			"C macro use <errno.h>"
		alias
			"ENOPKG"
		end

	Eremote: INTEGER
			-- Code for "Object is remote"
		external
			"C macro use <errno.h>"
		alias
			"EREMOTE"
		end

	Enolink: INTEGER
			-- Code for "Link has been severed"
		external
			"C macro use <errno.h>"
		alias
			"ENOLINK"
		end

	Eadv: INTEGER
			-- Code for "Advertise error"
		external
			"C macro use <errno.h>"
		alias
			"EADV"
		end

	Esrmnt: INTEGER
			-- Code for "Srmount error"
		external
			"C macro use <errno.h>"
		alias
			"ESRMNT"
		end

	Ecomm: INTEGER
			-- Code for "Communication error on send"
		external
			"C macro use <errno.h>"
		alias
			"ECOMM"
		end

	Eproto: INTEGER
			-- Code for "Protocol error"
		external
			"C macro use <errno.h>"
		alias
			"EPROTO"
		end

	Elockunmapped: INTEGER
			-- Code for "Locked lock was unmapped"
		external
			"C macro use <errno.h>"
		alias
			"ELOCKUNMAPPED"
		end

	-- FIXME: defined only in Solaris 8, not in Solaris 7
	-- Enotactive: INTEGER
	-- 		-- Code for "Facility is not active"
	-- 	external
	-- 		"C macro use <errno.h>"
	-- 	alias
	-- 		"ENOTACTIVE"
	-- 	end

	Emultihop: INTEGER
			-- Code for "Multihop attempted"
		external
			"C macro use <errno.h>"
		alias
			"EMULTIHOP"
		end

	Ebadmsg: INTEGER
			-- Code for "Not a data message"
		external
			"C macro use <errno.h>"
		alias
			"EBADMSG"
		end

	Enametoolong: INTEGER
			-- Code for "File name too long"
		external
			"C macro use <errno.h>"
		alias
			"ENAMETOOLONG"
		end

	Eoverflow: INTEGER
			-- Code for "Value too large for defined data type"
		external
			"C macro use <errno.h>"
		alias
			"EOVERFLOW"
		end

	Enotuniq: INTEGER
			-- Code for "Name not unique on network"
		external
			"C macro use <errno.h>"
		alias
			"ENOTUNIQ"
		end

	Ebadfd: INTEGER
			-- Code for "File descriptor in bad state"
		external
			"C macro use <errno.h>"
		alias
			"EBADFD"
		end

	Eremchg: INTEGER
			-- Code for "Remote address changed"
		external
			"C macro use <errno.h>"
		alias
			"EREMCHG"
		end

	Elibacc: INTEGER
			-- Code for "Can not access a needed shared library"
		external
			"C macro use <errno.h>"
		alias
			"ELIBACC"
		end

	Elibbad: INTEGER
			-- Code for "Accessing a corrupted shared library"
		external
			"C macro use <errno.h>"
		alias
			"ELIBBAD"
		end

	Elibscn: INTEGER
			-- Code for ".lib section in a.out corrupted"
		external
			"C macro use <errno.h>"
		alias
			"ELIBSCN"
		end

	Elibmax: INTEGER
			-- Code for "Attempting to link in more shared
			-- libraries than system limit"
		external
			"C macro use <errno.h>"
		alias
			"ELIBMAX"
		end

	Elibexec: INTEGER
			-- Code for "Can not exec a shared library directly"
		external
			"C macro use <errno.h>"
		alias
			"ELIBEXEC"
		end

	Eilseq: INTEGER
			-- Code for "Illegal byte sequence"
		external
			"C macro use <errno.h>"
		alias
			"EILSEQ"
		end

	Enosys: INTEGER
			-- Code for "Operation not applicable"
		external
			"C macro use <errno.h>"
		alias
			"ENOSYS"
		end

	Eloop: INTEGER
			-- Code for "Number of symbolic links encountered
			-- during path name traversal exceeds MAXSYMLINKS"
		external
			"C macro use <errno.h>"
		alias
			"ELOOP"
		end

	Erestart: INTEGER
			-- Code for "Restartable system call"
		external
			"C macro use <errno.h>"
		alias
			"ERESTART"
		end

	Estrpipe: INTEGER
			-- Code for "If pipe/FIFO, don't sleep in stream head"
			-- (not externally visible)
		external
			"C macro use <errno.h>"
		alias
			"ESTRPIPE"
		end

	Enotempty: INTEGER
			-- Code for "Directory not empty"
		external
			"C macro use <errno.h>"
		alias
			"ENOTEMPTY"
		end

	Eusers: INTEGER
			-- Code for "Too many users"
		external
			"C macro use <errno.h>"
		alias
			"EUSERS"
		end

	Enotsock: INTEGER
			-- Code for "Socket operation on non-socket"
		external
			"C macro use <errno.h>"
		alias
			"ENOTSOCK"
		end

	Edestaddrreq: INTEGER
			-- Code for "Destination address required"
		external
			"C macro use <errno.h>"
		alias
			"EDESTADDRREQ"
		end

	Emsgsize: INTEGER
			-- Code for "Message too long"
		external
			"C macro use <errno.h>"
		alias
			"EMSGSIZE"
		end

	Eprototype: INTEGER
			-- Code for "Protocol wrong type for socket"
		external
			"C macro use <errno.h>"
		alias
			"EPROTOTYPE"
		end

	Enoprotoopt: INTEGER
			-- Code for "Option not supported by protocol"
		external
			"C macro use <errno.h>"
		alias
			"ENOPROTOOPT"
		end

	Eprotonosupport: INTEGER
			-- Code for "Protocol not supported"
		external
			"C macro use <errno.h>"
		alias
			"EPROTONOSUPPORT"
		end

	Esocktnosupport: INTEGER
			-- Code for "Socket type not supported"
		external
			"C macro use <errno.h>"
		alias
			"ESOCKTNOSUPPORT"
		end

	Eopnotsupp: INTEGER
			-- Code for "Operation not supported on transport
			-- endpoint"
		external
			"C macro use <errno.h>"
		alias
			"EOPNOTSUPP"
		end

	Epfnosupport: INTEGER
			-- Code for "Protocol family not supported"
		external
			"C macro use <errno.h>"
		alias
			"EPFNOSUPPORT"
		end

	Eafnosupport: INTEGER
			-- Code for "Address family not supported by protocol
			-- family"
		external
			"C macro use <errno.h>"
		alias
			"EAFNOSUPPORT"
		end

	Eaddrinuse: INTEGER
			-- Code for "Address already in use"
		external
			"C macro use <errno.h>"
		alias
			"EADDRINUSE"
		end

	Eaddrnotavail: INTEGER
			-- Code for "Cannot assign requested address"
		external
			"C macro use <errno.h>"
		alias
			"EADDRNOTAVAIL"
		end

	Enetdown: INTEGER
			-- Code for "Network is down"
		external
			"C macro use <errno.h>"
		alias
			"ENETDOWN"
		end

	Enetunreach: INTEGER
			-- Code for "Network is unreachable"
		external
			"C macro use <errno.h>"
		alias
			"ENETUNREACH"
		end

	Enetreset: INTEGER
			-- Code for "Network dropped connection because of
			-- reset"
		external
			"C macro use <errno.h>"
		alias
			"ENETRESET"
		end

	Econnaborted: INTEGER
			-- Code for "Software caused connection abort"
		external
			"C macro use <errno.h>"
		alias
			"ECONNABORTED"
		end

	Econnreset: INTEGER
			-- Code for "Connection reset by peer"
		external
			"C macro use <errno.h>"
		alias
			"ECONNRESET"
		end

	Enobufs: INTEGER
			-- Code for "No buffer space available"
		external
			"C macro use <errno.h>"
		alias
			"ENOBUFS"
		end

	Eisconn: INTEGER
			-- Code for "Transport endpoint is already connected"
		external
			"C macro use <errno.h>"
		alias
			"EISCONN"
		end

	Enotconn: INTEGER
			-- Code for "Transport endpoint is not connected"
		external
			"C macro use <errno.h>"
		alias
			"ENOTCONN"
		end

	Eshutdown: INTEGER
			-- Code for "Cannot send after socket shutdown"
		external
			"C macro use <errno.h>"
		alias
			"ESHUTDOWN"
		end

	Etoomanyrefs: INTEGER
			-- Code for "Too many references: cannot splice"
		external
			"C macro use <errno.h>"
		alias
			"ETOOMANYREFS"
		end

	Etimedout: INTEGER
			-- Code for "Connection timed out"
		external
			"C macro use <errno.h>"
		alias
			"ETIMEDOUT"
		end

	Econnrefused: INTEGER
			-- Code for "Connection refused"
		external
			"C macro use <errno.h>"
		alias
			"ECONNREFUSED"
		end

	Ehostdown: INTEGER
			-- Code for "Host is down"
		external
			"C macro use <errno.h>"
		alias
			"EHOSTDOWN"
		end

	Ehostunreach: INTEGER
			-- Code for "No route to host"
		external
			"C macro use <errno.h>"
		alias
			"EHOSTUNREACH"
		end

	Ewouldblock: INTEGER
			-- Code for "Resource temporarily unavailable"
		external
			"C macro use <errno.h>"
		alias
			"EWOULDBLOCK"
		end

	Ealready: INTEGER
			-- Code for "Operation already in progress"
		external
			"C macro use <errno.h>"
		alias
			"EALREADY"
		end

	Einprogress: INTEGER
			-- Code for "Operation now in progress"
		external
			"C macro use <errno.h>"
		alias
			"EINPROGRESS"
		end

	Estale: INTEGER
			-- Code for "Stale NFS file handle"
		external
			"C macro use <errno.h>"
		alias
			"ESTALE"
		end

end
