
indexing
	
	description: "Change that unlocked an object completely"
	author: "David Hollenberg"
	date: "January 25, 2007"

class UNLOCK_COMPLETELY_CHANGE
inherit
	RETICLE_SIMPLE_CHANGE
		rename
			make as simple_make
		export
			{NONE} simple_make
		end

create
	make

feature {NONE} -- Creation

	make (an_element: RETICLE_VIEW_ELEMENT a_locked_x_changed, a_locked_y_changed, a_rotatable_changed, a_duplicatable_changed, a_deletable_changed: BOOLEAN)
		do
			simple_make (an_element)
			locked_in_x_changed := a_locked_x_changed
			locked_in_y_changed := a_locked_y_changed
			rotatable_changed := a_rotatable_changed
			duplicatable_changed := a_duplicatable_changed
			deletable_changed := a_deletable_changed
		end

feature -- Properties

	locked_in_x_changed: BOOLEAN
			-- Did locked in X change?

	locked_in_y_changed: BOOLEAN
			-- Did locked in Y change?

	rotatable_changed: BOOLEAN
			-- Did rotatability change?

	duplicatable_changed: BOOLEAN
			-- Did duplicatability change?

	deletable_changed: BOOLEAN
			-- Did deletability change?

feature -- Operations

	undo
			-- Undo change
		do
			if deletable_changed then
				element.lock_deletion
			end
			if duplicatable_changed then
				element.lock_duplication
			end
			if rotatable_changed then
				element.lock_orientation
			end
			if locked_in_x_changed then
				element.lock_in_x
			end
			if locked_in_y_changed then
				element.lock_in_y
			end
		end

	redo
			-- Redo change
		do
			if locked_in_x_changed then
				element.unlock_in_x
			end
			if locked_in_y_changed then
				element.unlock_in_y
			end
			if rotatable_changed then
				element.unlock_orientation
			end
			if duplicatable_changed then
				element.unlock_duplication
			end
			if deletable_changed then
				element.unlock_deletion
			end
		end

end
