
indexing
	
	description: "Change that unlocked an object in X and Y dimensions"
	author: "David Hollenberg"
	date: "January 25, 2007"

class UNLOCK_IN_X_AND_Y_CHANGE
inherit
	RETICLE_SIMPLE_CHANGE
		rename
			make as simple_make
		export
			{NONE} simple_make
		end

create
	make

feature {NONE} -- Creation

	make (an_element: RETICLE_VIEW_ELEMENT a_locked_x_changed, a_locked_y_changed: BOOLEAN)
		do
			simple_make (an_element)
			locked_in_x_changed := a_locked_x_changed
			locked_in_y_changed := a_locked_y_changed
		end

feature -- Properties

	locked_in_x_changed: BOOLEAN
			-- Did locked in X change?

	locked_in_y_changed: BOOLEAN
			-- Did locked in Y change?

feature -- Operations

	undo
			-- Undo change
		do
			if locked_in_x_changed then
				element.lock_in_x
			end
			if locked_in_y_changed then
				element.lock_in_y
			end
		end

	redo
			-- Redo change
		do
			if locked_in_x_changed then
				element.unlock_in_x
			end
			if locked_in_y_changed then
				element.unlock_in_y
			end
		end

end
