
indexing
	
	description: "An operation that unlocks a lock"
	author: "David Hollenberg"
	date: "March 12, 2003"

class UNLOCK_OP
inherit
	OPERATION
		rename
			try_operation as try_unlock
		end

create
	default_create

feature -- Operations

	unlock (l: LOCK)
		require
			lock_exists: l /= Void
			lock_locked: l.is_locked_by_me
		do
			lock := l
			execute
		end

feature {NONE} -- Implementation

	try_unlock
			-- Try file unlock
		local
			ok_event: UNLOCK_OK_EVENT
		do
			lock.unlock
			create ok_event
			ok_event.set_lock (lock)
			ok_event.publish
		end

	lock: LOCK
			-- Lock to unlock

end
