
indexing
	
	description: "Target which indicates that run will deliver unpacked die only "
	author: "David Hollenberg"
	date: "August 28, 2008"

class UNPACKED_DIE_PACKING_TARGET
inherit
	PACKING_TARGET
		redefine
			field_set_field
		end

create
	make

feature -- Properties

	is_custom: BOOLEAN = False
			-- Is target a custom target?

	has_enough_data_to_build_interface: BOOLEAN
			-- Is there enough data from related
			-- field sets to build the interface for `Current'?
		do
			Result := not field_sets.is_empty
		end

	selected_field_set_name: STRING
			-- Name of currently selected field set
		do
			Result ?= field_set_field.selected_item.data
		end

	field_set_field: EV_COMBO_BOX
			-- Field for selecting field set

feature -- Modification

	create_text_fields
			-- Create text fields for `Current'
		do
			field_set_field := new_std_field_set_field
			renaming_style_field := new_read_only_text_field ("", Renaming_style_width)
			fab_location_field := new_read_only_text_field ("", Fab_location_width)
		end

feature -- Operations

	validate_input
			-- Validate user input.  Leave any validation
			-- errors in `validation_errors' and set `is_input_valid'
			-- to indicate whether input is valid
		do
			clear_validation_errors
		end

	update_database
			-- Do any needed database inserts or updates
			-- prior to setting field set to one user
			-- has selected
		do
		end

end
