
indexing
	
	description: "A user interface"
	author: "David Hollenberg"
	date: "October 27, 2003"

class USER_INTERFACE
inherit
	ANY
		redefine
			default_create
		end

create
	default_create

feature {NONE} -- Creation

	default_create
		local
			stock_colors: EV_STOCK_COLORS
		do
			create stock_colors
			background_color := stock_colors.Default_background_color
			border_width := 20
			padding := 10
			minimum_button_width := 80
		end

feature -- Properties

	background_color: EV_COLOR
			-- Default background color used for application 
			-- windows

	border_width: INTEGER
			-- Standard border width

	padding: INTEGER
			-- Standard padding amount

	minimum_button_width: INTEGER
			-- Standard minimum width of button

feature -- Modification

	set_background_color (c: EV_COLOR)
			-- Set `background_color' to `c'
		do
			background_color := c
		ensure
			color_set: background_color = c
		end

	set_border_width (n: INTEGER)
			-- Set `border_width' to `n'
		do
			border_width := n
		ensure
			border_width_set: border_width = n
		end

	set_padding (n: INTEGER)
			-- Set `padding' to `n'
		do
			padding := n
		ensure
			padding_set: padding = n
		end

	set_minimum_button_width (n: INTEGER)
			-- Set `minimum_button_width' to `n'
		do
			minimum_button_width := n
		ensure
			minimum_button_width_set: minimum_button_width = n
		end

end
