
indexing
	
	description: "Object that can generate colors for an %
		%element of a reticle view according to the validity errors %
		%and warnings found for it"
	author: "David Hollenberg"
	date: "December 8, 2006"

class VALIDITY_CHECK_COLOR_GENERATOR
inherit
	RETICLE_VIEW_ELEMENT_COLOR_GENERATOR

create
	make

feature -- Properties

	current_generator: RETICLE_VIEW_ELEMENT_COLOR_GENERATOR
			-- Current generator to use for Validity Check
			-- view colors

feature -- Modification

	set_current_generator (a_generator: like current_generator)
		require
			a_generator_not_void: a_generator /= Void
		do
			current_generator := a_generator
		end

feature -- Access

	border_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Foreground color for border (usually a
			-- rectangle) of `an_element'
		do
			Result := current_generator.border_color (an_element)
		end
	
	label_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Foreground color for label
		do
			Result := current_generator.label_color (an_element)
		end
	
end
