
indexing
	
	description: "Queries related to vendor part ids"
	author: "David Hollenberg"
	date: "June 10, 2003"

deferred class VENDOR_PART_ID_QUERIES
inherit
	ANY
		undefine
			default_create
		end
	ITEM_COUNT_RANGES_ACCESS
		export
			{NONE} all
		undefine
			default_create
		end

feature -- Properties

	all_part_id_usages (seq: STRING conn: DB_CONNECTION): LIST [PART_ID_USAGE]
			-- All uses of parts in sequence `seq' by runs
		require
			sequence_exists: seq /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
		local
			prods_row: PRODUCTIONS_ROW
			dies_row: DIES_ROW
			dl_row: DIE_LOCATIONS_ROW
			list1, list2, list3: LIST [PART_ID_USAGE]
		do
			create prods_row.make_template
			create dies_row.make_template
			create dl_row.make_template
			list1 := prods_row.production_part_id_usages (seq, conn, Expected_count.at_least_zero)
			list2 := dies_row.die_part_id_usages (seq, conn, Expected_count.at_least_zero)
			list3 := dl_row.site_part_id_usages (seq, conn, Expected_count.at_least_zero)
			create {ARRAYED_LIST [PART_ID_USAGE]} Result.make (list1.count + list2.count + list3.count)
			Result.append (list1)
			Result.append (list2)
			Result.append (list3)
		ensure
			result_exists: Result /= Void
		end

end
