
indexing

	date: "Tue Apr 24 10:30:16 2007"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user DHOLLEN"
	database_tables: 
		"VENDOR_PART_IDS (MOSIS.VENDOR_PART_IDS)"
			-- Included columns
			-- 	ASSIGNED
			-- 	ROW_NO
			-- 	VENDOR_PART_ID_SOURCE
			-- 	VENDOR_PART_SEQUENCE_ID
			-- Excluded columns
			-- 	(none)

class VENDOR_PART_IDS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_vendor_part_sequence_id: STRING; the_row_no: INTEGER)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_vendor_part_sequence_id_exists: the_vendor_part_sequence_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			vendor_part_sequence_id := the_vendor_part_sequence_id
			row_no := the_row_no
			is_null_vendor_part_sequence_id := False
			is_null_row_no := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 4

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  assigned, row_no, vendor_part_id_source, vendor_part_sequence_id"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "vendor_part_ids vpi"

	join_condition: STRING = ""

	table_name: STRING = "vendor_part_ids"

	key_where_clause: STRING = "vendor_part_sequence_id = :1 and row_no = :2"

feature -- Values

	assigned: BOOLEAN
			-- DB: CHAR(1) not null

	row_no: INTEGER
			-- DB: NUMBER(6,0) not null

	vendor_part_id_source: STRING
			-- DB: VARCHAR2(50) not null

	vendor_part_sequence_id: STRING
			-- DB: VARCHAR2(30) not null

feature -- Maximum database lengths for character columns

	maxlen_vendor_part_id_source: INTEGER = 50
	maxlen_vendor_part_sequence_id: INTEGER = 30

feature -- Precisions for number columns

	precision_row_no: INTEGER = 6

feature -- Scales for number columns

	scale_row_no: INTEGER = 0

feature -- Nullness for non-null columns

	is_null_assigned: BOOLEAN
	is_null_row_no: BOOLEAN
	is_null_vendor_part_id_source: BOOLEAN
	is_null_vendor_part_sequence_id: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and row_no = r.row_no
			Result := Result
				and equal (vendor_part_sequence_id, r.vendor_part_sequence_id)
			Result := Result
				and is_null_row_no = r.is_null_row_no
				and is_null_vendor_part_sequence_id = r.is_null_vendor_part_sequence_id
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and assigned = r.assigned
			Result := Result
				and equal (vendor_part_id_source, r.vendor_part_id_source)
			Result := Result
				and is_null_assigned = r.is_null_assigned
				and is_null_vendor_part_id_source = r.is_null_vendor_part_id_source
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_boolean (1)
			q.select_integer (2)
			q.select_string (3, 50)
			q.select_string (4, 30)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			assigned := q.boolean_value (1)
			row_no := q.integer_value (2)
		end

	fill_in_references (q: SQL_QUERY)
		do
			vendor_part_id_source := q.string_value (3)
			vendor_part_sequence_id := q.string_value (4)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (3, vendor_part_id_source)
			q.get_string_value (4, vendor_part_sequence_id)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_assigned := q.is_null (1)
			is_null_row_no := q.is_null (2)
			is_null_vendor_part_id_source := q.is_null (3)
			is_null_vendor_part_sequence_id := q.is_null (4)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_vendor_part_sequence_id := True
			is_null_row_no := True
			create vendor_part_sequence_id.make (0)
		end

	set_null_nonkey
		do
			is_null_assigned := True
			is_null_vendor_part_id_source := True
			create vendor_part_id_source.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, vendor_part_sequence_id, False)
			q.bind_num_to_integer (2, row_no, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and assigned = q.boolean_value (1)
				and row_no = q.integer_value (2)
			q.get_string_value (3, s)
			Result := Result and equal (vendor_part_id_source, s)
			q.get_string_value (4, s)
			Result := Result and equal (vendor_part_sequence_id, s)
			Result := Result
				and is_null_assigned = q.is_null (1)
				and is_null_row_no = q.is_null (2)
				and is_null_vendor_part_id_source = q.is_null (3)
				and is_null_vendor_part_sequence_id = q.is_null (4)
		end

end
