
indexing

	date: "Tue Apr 24 10:30:16 2007"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application DELTA, database user DHOLLEN"
	database_tables: 
		"VENDOR_PART_SEQUENCE_IDS (MOSIS.VENDOR_PART_SEQUENCE_IDS)"
			-- Included columns
			-- 	DESCR
			-- 	PART_ACQUISITION_METHOD
			-- 	VENDOR_PART_SEQUENCE_ID
			-- 	VENDOR_SEQUENCE_TYPE
			-- 	WARNING_THRESHOLD
			-- Excluded columns
			-- 	(none)

class VENDOR_PART_SEQUENCE_IDS_RAW

inherit

	DB_LOCKABLE_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_vendor_part_sequence_id: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_vendor_part_sequence_id_exists: the_vendor_part_sequence_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			vendor_part_sequence_id := the_vendor_part_sequence_id
			is_null_vendor_part_sequence_id := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 5

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  descr, part_acquisition_method, vendor_part_sequence_id,%N  vendor_sequence_type, warning_threshold"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "vendor_part_sequence_ids vpi"

	join_condition: STRING = ""

	table_name: STRING = "vendor_part_sequence_ids"

	key_where_clause: STRING = "vendor_part_sequence_id = :1"

feature -- Values

	descr: STRING
			-- DB: VARCHAR2(200)

	part_acquisition_method: STRING
			-- DB: VARCHAR2(15) not null

	vendor_part_sequence_id: STRING
			-- DB: VARCHAR2(30) not null

	vendor_sequence_type: STRING
			-- DB: VARCHAR2(15) not null

	warning_threshold: INTEGER
			-- DB: NUMBER(3,0)

feature -- Nullness for null allowed columns

	is_null_descr: BOOLEAN
	is_null_warning_threshold: BOOLEAN

feature -- Nullness for non-null columns

	is_null_part_acquisition_method: BOOLEAN
	is_null_vendor_part_sequence_id: BOOLEAN
	is_null_vendor_sequence_type: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (vendor_part_sequence_id, r.vendor_part_sequence_id)
			Result := Result
				and is_null_vendor_part_sequence_id = r.is_null_vendor_part_sequence_id
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and warning_threshold = r.warning_threshold
			Result := Result
				and equal (descr, r.descr)
				and equal (part_acquisition_method, r.part_acquisition_method)
				and equal (vendor_sequence_type, r.vendor_sequence_type)
			Result := Result
				and is_null_descr = r.is_null_descr
				and is_null_part_acquisition_method = r.is_null_part_acquisition_method
				and is_null_vendor_sequence_type = r.is_null_vendor_sequence_type
				and is_null_warning_threshold = r.is_null_warning_threshold
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_string (1, 200)
			q.select_string (2, 15)
			q.select_string (3, 30)
			q.select_string (4, 15)
			q.select_integer (5)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			warning_threshold := q.integer_value (5)
		end

	fill_in_references (q: SQL_QUERY)
		do
			descr := q.string_value (1)
			part_acquisition_method := q.string_value (2)
			vendor_part_sequence_id := q.string_value (3)
			vendor_sequence_type := q.string_value (4)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (1, descr)
			q.get_string_value (2, part_acquisition_method)
			q.get_string_value (3, vendor_part_sequence_id)
			q.get_string_value (4, vendor_sequence_type)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_descr := q.is_null (1)
			is_null_part_acquisition_method := q.is_null (2)
			is_null_vendor_part_sequence_id := q.is_null (3)
			is_null_vendor_sequence_type := q.is_null (4)
			is_null_warning_threshold := q.is_null (5)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_vendor_part_sequence_id := True
			create vendor_part_sequence_id.make (0)
		end

	set_null_nonkey
		do
			is_null_descr := True
			is_null_part_acquisition_method := True
			is_null_vendor_sequence_type := True
			is_null_warning_threshold := True
			create descr.make (0)
			create part_acquisition_method.make (0)
			create vendor_sequence_type.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, vendor_part_sequence_id, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and warning_threshold = q.integer_value (5)
			q.get_string_value (1, s)
			Result := Result and equal (descr, s)
			q.get_string_value (2, s)
			Result := Result and equal (part_acquisition_method, s)
			q.get_string_value (3, s)
			Result := Result and equal (vendor_part_sequence_id, s)
			q.get_string_value (4, s)
			Result := Result and equal (vendor_sequence_type, s)
			Result := Result
				and is_null_descr = q.is_null (1)
				and is_null_part_acquisition_method = q.is_null (2)
				and is_null_vendor_part_sequence_id = q.is_null (3)
				and is_null_vendor_sequence_type = q.is_null (4)
				and is_null_warning_threshold = q.is_null (5)
		end

end
