
indexing

	author: "Generated"
	date: "Fri Jun 13 12:00:08 PDT 2003"

class VENDOR_PART_SEQUENCE_IDS_ROW
inherit
	VENDOR_PART_SEQUENCE_IDS_RAW
	ROW_COUNT_CHECK_ACCESS
	ITEM_COUNT_RANGES_ACCESS
		export
			{NONE} all
		end
create
	make_template, make_null, make_by_key

feature -- Properties

	vendor_part_sequence_ids_rows (seq: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): LIST [like Current] is
			-- Rows for vendor part sequence id `seq'
		require
			sequence_exists: seq /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_S
		do
			create b.make (seq)
			Result := all_rows_filtered (conn, "vendor_part_sequence_id = :1", b)
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

	number_of_parts_left (seq: STRING conn: DB_CONNECTION): INTEGER is
			-- Number of parts left in `seq' if number is below
			-- warning threshold, -1 otherwise
		require
			sequence_exists: seq /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
		local
			threshold, remaining: INTEGER
			row: VENDOR_PART_SEQUENCE_IDS_ROW
			acq_method: STRING
			method: PART_ACQUISITION_METHOD_VALUES
		do
			row := vendor_part_sequence_ids_rows (seq, conn, Expected_count.exactly_one).first
			threshold := row.warning_threshold
			remaining := unassigned_part_id_count (seq, conn)
			acq_method := row.part_acquisition_method
			if not equal (acq_method, method.Manual) and remaining <= threshold then
				Result := remaining
			else
				Result := -1
			end
		ensure
			valid_result: Result >= 0 or Result = -1
		end

feature {NONE} -- Implementation

	unassigned_part_id_count (seq: STRING conn: DB_CONNECTION): INTEGER is
			-- Number of unassigned part ids in `seq'
		require
			sequence_exists: seq /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
		local
			b: DB_BIND_SB
		do
			create b.make (seq, False)
			Result := conn.selected_count ("vendor_part_ids", "vendor_part_sequence_id = :1 and assigned = :2", b)
		ensure
			result_nonnegative: Result >= 0
		end

end
