
indexing
	
	description: "A run closing step operation that ensures sales %
		%orders have been verified to match PO"
	author: "David Hollenberg"
	date: "May 26, 2004"

class VERIFY_SALES_ORDERS_OP
inherit
	RC_PRIMITIVE_STEP_OP
	NO_USER_INTERFACE
	NO_EXTERNAL_STATE

create
	make

feature -- Properties

	input_data_items: LIST [STRING]
			-- Data items required before step can be executed
		do
			Result := array_as_list (<<
					data_item.Production_job
				 >>)
		end

	is_applicable: BOOLEAN
			-- Is step applicable to run for session?
		do
			Result := not cache.db_commercial_cust_wo_rows.is_empty
		end

feature {NONE} -- Implementation

	do_step
			-- Execute step
		local
			proj_count: INTEGER
			fa_count: INTEGER
		do
			proj_count := cache.commercial_project_count
			fa_count := cache.distinct_commercial_funding_allocs.count
			if question ("This run has " + proj_count.out + " commercial " + su.number(proj_count, "project", "projects") + " on " + fa_count.out + " distinct payment " + su.number(fa_count, "scheme", "schemes") + ".%NA payment scheme is usually a single PO or an internal requisition.%N%NHave you verified that all sales orders match POs and resolved any discrepancies?") then
			else
				abort
			end
			call_completion_actions
		end

	undo_step
			-- Undo execution of step
		do
			call_completion_actions
		end

	set_state
			-- Set `state'
		do
			state := Void
		end

end
