
indexing
	
	description: "Version number column in a multi column list"
	author: "David Hollenberg"
	date: "November 18, 2003"

class VERSION_NO_COLUMN [G -> HAS_VERSION_NUMBER]
inherit
	MULTI_COLUMN_LIST_COLUMN [G]

create
	default_create

feature -- Properties

	title: STRING = "Version No"
			-- Title for column

	alignment: EV_TEXT_ALIGNMENT
			-- Alignment for values in column
		do
			create Result.make_with_right_alignment
		end

	value (r: G): STRING
			-- Value in column for `r'
		do
			if r.has_version_number then
				Result := r.version_number.out
			else
				Result := ""
			end
		end

	comparator: VERSION_NO_COMPARATOR [G]
		do
			create Result
		end

end
