
indexing
	
	description: "Action to build slots for vertical scan"
	author: "David Hollenberg"
	date: "January 3, 2007"

class VERTICAL_SCAN_ACTION
inherit
	SCAN_ACTION

feature -- Modification

	set_field_limits (f: RETICLE_FIELD)
			-- Set `field_lower_limit' and `field_upper_limit'
			-- from `f'
		do
			field_lower_limit := grid.rounded_edge (f.bottom_y)
			field_upper_limit := grid.rounded_edge (f.top_y)
		end

feature {NONE} -- Implementation

	is_obstacle (an_element: RETICLE_VIEW_ELEMENT): BOOLEAN
			-- Is `an_element' an obstacle (won't be moved by
			-- scan)?
		do
			Result := an_element.is_fixed_in_y
		end

	gridded_center (an_element: RETICLE_VIEW_ELEMENT): DOUBLE
			-- Location of element center, placed on grid
		do
			Result := an_element.gridded_center_y
		end

	gridded_lower_limit (an_element: RETICLE_VIEW_ELEMENT): DOUBLE
			-- Left or bottom edge of element, placed on grid
		do
			Result := grid.rounded_edge (an_element.bottom_y)
		end

	gridded_upper_limit (an_element: RETICLE_VIEW_ELEMENT): DOUBLE
			-- Right or top edge of element, placed on grid
		do
			Result := grid.rounded_edge (an_element.top_y)
		end

	gridded_width (an_element: RETICLE_VIEW_ELEMENT): DOUBLE
			-- Wdith of element, rounded to grid
		do
			Result := an_element.gridded_size_y
		end

	set_move_distance (an_element: RETICLE_VIEW_ELEMENT a_lower_edge: DOUBLE)
			-- Set `move_distance' for `an_element' to move its
			-- lower edge to `a_lower_edge'
		do
			move_distance.make_xy (0, a_lower_edge - an_element.bottom_y)
		end

	lower_edge_name: STRING = "bottom"
			-- Name of lower edge of field of view

	upper_edge_name: STRING = "top"
			-- Name of upper edge of field of view

	dimension_name: STRING = "height"
			-- Name of dimension of objects that matters for scan

end
