
indexing
	
	description: "Action to be spread elements vertically"
	author: "David Hollenberg"
	date: "November 16, 2006"

class VERTICAL_SPREAD_ACTION
inherit
	SPREAD_ACTION

feature {NONE} -- Implementation

	compute_center (an_element: RETICLE_VIEW_ELEMENT)
			-- Compute `new_center' for `an_element'
		local
			n: INTEGER_64
			size_y, diff, diff_x: DOUBLE
		do
			size_y := an_element.model_element.size_y
			diff := largest_dimension - size_y
			diff_x := largest_dimension / 2.0
			n := grid.rounded_edge_units (diff)
			if n \\ 2 /= 0 then
				diff_x := diff_x - grid.edge_resolution / 2
			end
			new_center.make_xy (next_point.x + diff_x, next_point.y + size_y / 2)
			next_point.make_xy (next_point.x, grid.rounded_edge (next_point.y + (size_y + spacing)))
		end

end
