
indexing
	
	description: "Filter that selects reticle elements based on their %
		%relationship with a view area (rectangle)"
	author: "David Hollenberg"
	date: "December 18, 2006"

deferred class VIEW_AREA_FILTER
inherit
	VIEW_ELEMENT_FILTER

feature -- Properties

	rectangle: EV_RECTANGLE
			-- Rectangle that defines area

feature -- Modification

	set_rectangle (a_rectangle: like rectangle)
			-- Set `rectangle' to `a_rectangle'
		require
			a_rectangle_not_void: a_rectangle /= Void
		do
			rectangle := a_rectangle
		ensure
			rectangle_set: rectangle = a_rectangle
		end

feature {NONE} -- Implementation

	rectangle_contained_in (r1, r2: EV_RECTANGLE): BOOLEAN
			-- Is `r1' contained in `r2' (i.e., is intersection
			-- of `r1' and `r2' equal to `r1')?
		require
			rectangle_1_not_void: r1 /= Void
			rectangle_2_not_void: r2 /= Void
		do
			Result := r2.has_x_y (r1.left, r1.top) and then
				r2.has_x_y (r1.left, r1.bottom) and then
				r2.has_x_y (r1.right, r1.top) and then
				r2.has_x_y (r1.right, r1.bottom)
		end


end
