
indexing
	
	description: "Actions for view elements"
	author: "David Hollenberg"
	date: "October 1, 2006"

class VIEW_ELEMENT_ACTIONS

feature -- Properties

	clear_in_changed_region_action: VIEW_ELEMENT_ACTION
			-- Action to clear the "in changed region" indicator
			-- for an element
		once
			create {CLEAR_IN_CHANGED_REGION_ACTION} Result
		end
	
	add_to_changed_region_action: VIEW_ELEMENT_ACTION
			-- Action to add element to changed region
		once
			create {ADD_TO_CHANGED_REGION_ACTION} Result
		end
	
	create_cut_action: VIEW_ELEMENT_ACTION
			-- Action to create a cut
		once
			create {CREATE_CUT_ACTION} Result
		end
	
	pre_rotate_action: VIEW_ELEMENT_ACTION
			-- Action to take before attempting to change
			-- rotation of selected elements
		once
			create {PRE_ROTATE_ACTION} Result
		end
	
	pre_horizontal_spread_action: VIEW_ELEMENT_ACTION
			-- Action to take before attempting to spread
			-- selected elements horizontally
		once
			create {PRE_HORIZONTAL_SPREAD_ACTION} Result
		end
	
	pre_vertical_spread_action: VIEW_ELEMENT_ACTION
			-- Action to take before attempting to spread
			-- selected elements vertically
		once
			create {PRE_VERTICAL_SPREAD_ACTION} Result
		end
	
	horizontal_spread_action: SPREAD_ACTION
			-- Action to spread selected elements horizontally
		once
			create {HORIZONTAL_SPREAD_ACTION} Result
		end
	
	vertical_spread_action: SPREAD_ACTION
			-- Action to spread selected elements vertically
		once
			create {VERTICAL_SPREAD_ACTION} Result
		end
	
	pre_abut_action: PRE_ABUT_ACTION
			-- Action to take before an Abut operation
		once
			create Result
		end
	
	pre_align_action: PRE_ALIGN_ACTION
			-- Action to take before an Align operation
		once
			create Result
		end
	
	compute_fields_action: COMPUTE_FIELDS_ACTION
			-- Action to compute list of fields
		once
			create Result
		end
	
	align_left_action: ALIGN_ACTION
			-- Action to take to align selected objects to left
			-- side of align target
		once
			create {ALIGN_LEFT_ACTION} Result
		end
	
	align_right_action: ALIGN_ACTION
			-- Action to take to align selected objects to right
			-- side of align target
		once
			create {ALIGN_RIGHT_ACTION} Result
		end
	
	align_top_action: ALIGN_ACTION
			-- Action to take to align selected objects to top
			-- side of align target
		once
			create {ALIGN_TOP_ACTION} Result
		end
	
	align_bottom_action: ALIGN_ACTION
			-- Action to take to align selected objects to bottom
			-- side of align target
		once
			create {ALIGN_BOTTOM_ACTION} Result
		end
	
	align_center_x_action: ALIGN_ACTION
			-- Action to take to align selected objects to center
			-- of align target in X
		once
			create {ALIGN_CENTER_X_ACTION} Result
		end
	
	align_center_y_action: ALIGN_ACTION
			-- Action to take to align selected objects to center
			-- of align target in Y
		once
			create {ALIGN_CENTER_Y_ACTION} Result
		end
	
	all_copies_by_point_action: VIEW_ELEMENT_ACTION
			-- Action to take before setting selection to,
			-- adding to selection or removing from selection
			-- all copies of elements any of whose copies contain
			-- a point
		once
			create {ALL_COPIES_BY_POINT_ACTION} Result
		end
	
	selection_changed_action: VIEW_ELEMENT_ACTION
			-- Action to take when set of selected items
			-- may have changed
		once
			create {SELECTION_CHANGED_ACTION} Result
		end
	
	select_action: VIEW_ELEMENT_ACTION
			-- Action to select an element
		once
			create {SELECT_ACTION} Result
		end
	
	unselect_action: VIEW_ELEMENT_ACTION
			-- Action to unselect an element
		once
			create {UNSELECT_ACTION} Result
		end
	
	unchanged_selection_action: VIEW_ELEMENT_ACTION
			-- Action to leave selection status of an element
			-- unchanged
		once
			create {UNCHANGED_SELECTION_ACTION} Result
		end
	
	set_selection_to_element_action: VIEW_ONE_ELEMENT_ACTION
			-- Action to select only one specified element and
			-- unselect all others
		once
			create {SET_SELECTION_TO_ELEMENT_ACTION} Result
		end
	
	set_selection_action: VIEW_ELEMENT_FILTERED_ACTION
			-- Action to select only elements that match a filter
		once
			create {SET_SELECTION_ACTION} Result
		end
	
	add_to_selection_action: VIEW_ELEMENT_FILTERED_ACTION
			-- Action to add to selection elements that match
			-- a filter
		once
			create {ADD_TO_SELECTION_ACTION} Result
		end
	
	remove_from_selection_action: VIEW_ELEMENT_FILTERED_ACTION
			-- Action to revemo from selection elements that match
			-- a filter
		once
			create {REMOVE_FROM_SELECTION_ACTION} Result
		end
	
	fix_in_x_action: VIEW_ELEMENT_ACTION
			-- Action to fix an element in X
		once
			create {FIX_IN_X_ACTION} Result
		end
	
	fix_in_y_action: VIEW_ELEMENT_ACTION
			-- Action to fix an element in Y
		once
			create {FIX_IN_Y_ACTION} Result
		end
	
	fix_in_x_and_y_action: VIEW_ELEMENT_ACTION
			-- Action to fix an element in both X and Y
		once
			create {FIX_IN_X_AND_Y_ACTION} Result
		end
	
	unfix_in_x_action: VIEW_ELEMENT_ACTION
			-- Action to unfix an element in X
		once
			create {UNFIX_IN_X_ACTION} Result
		end
	
	unfix_in_y_action: VIEW_ELEMENT_ACTION
			-- Action to unfix an element in Y
		once
			create {UNFIX_IN_Y_ACTION} Result
		end
	
	unfix_in_x_and_y_action: VIEW_ELEMENT_ACTION
			-- Action to unfix an element in both X and Y
		once
			create {UNFIX_IN_X_AND_Y_ACTION} Result
		end
	
	lock_in_x_action: VIEW_ELEMENT_ACTION
			-- Action to lock an element in position in X
		once
			create {LOCK_IN_X_ACTION} Result
		end
	
	lock_in_y_action: VIEW_ELEMENT_ACTION
			-- Action to lock an element in position in Y
		once
			create {LOCK_IN_Y_ACTION} Result
		end
	
	lock_in_x_and_y_action: VIEW_ELEMENT_ACTION
			-- Action to lock an element in position in X and Y
		once
			create {LOCK_IN_X_AND_Y_ACTION} Result
		end
	
	lock_orientation_action: VIEW_ELEMENT_ACTION
			-- Action to lock orientation of an element
		once
			create {LOCK_ORIENTATION_ACTION} Result
		end
	
	lock_duplication_action: VIEW_ELEMENT_ACTION
			-- Action to lock an element to prevent it from
			-- being duplicated
		once
			create {LOCK_DUPLICATION_ACTION} Result
		end
	
	lock_deletion_action: VIEW_ELEMENT_ACTION
			-- Action to lock an element to prevent it from
			-- being deleted
		once
			create {LOCK_DELETION_ACTION} Result
		end
	
	lock_almost_completely_action: VIEW_ELEMENT_ACTION
			-- Action to lock an element almost completely
			-- (everything except duplication)
		once
			create {LOCK_ALMOST_COMPLETELY_ACTION} Result
		end
	
	lock_completely_action: VIEW_ELEMENT_ACTION
			-- Action to lock an element completely
			-- (position, orientation, duplication, deletion)
		once
			create {LOCK_COMPLETELY_ACTION} Result
		end
	
	unlock_in_x_action: VIEW_ELEMENT_ACTION
			-- Action to unlock an element in position in X
		once
			create {UNLOCK_IN_X_ACTION} Result
		end
	
	unlock_in_y_action: VIEW_ELEMENT_ACTION
			-- Action to unlock an element in position in Y
		once
			create {UNLOCK_IN_Y_ACTION} Result
		end
	
	unlock_in_x_and_y_action: VIEW_ELEMENT_ACTION
			-- Action to unlock an element in position in X and Y
		once
			create {UNLOCK_IN_X_AND_Y_ACTION} Result
		end
	
	unlock_orientation_action: VIEW_ELEMENT_ACTION
			-- Action to unlock orientation of an element
		once
			create {UNLOCK_ORIENTATION_ACTION} Result
		end
	
	unlock_duplication_action: VIEW_ELEMENT_ACTION
			-- Action to unlock an element to allow it to
			-- be duplicated
		once
			create {UNLOCK_DUPLICATION_ACTION} Result
		end
	
	unlock_deletion_action: VIEW_ELEMENT_ACTION
			-- Action to unlock an element to allow it to
			-- be deleted
		once
			create {UNLOCK_DELETION_ACTION} Result
		end
	
	unlock_completely_action: VIEW_ELEMENT_ACTION
			-- Action to unlock an element completely
			-- (position, orientation, duplication, deletion)
		once
			create {UNLOCK_COMPLETELY_ACTION} Result
		end
	
	unlock_almost_completely_action: VIEW_ELEMENT_ACTION
			-- Action to unlock an element almost completely
			-- (everything except duplication)
		once
			create {UNLOCK_ALMOST_COMPLETELY_ACTION} Result
		end
	
	convert_fixed_to_locked_action: VIEW_ELEMENT_ACTION
			-- Action to convert an element that is fixed in X
			-- or Y to be locked in that dimension instead
		once
			create {CONVERT_FIXED_TO_LOCKED_ACTION} Result
		end
	
	convert_locked_to_fixed_action: VIEW_ELEMENT_ACTION
			-- Action to convert an element that is locked in X
			-- or Y to be fixed in that dimension instead,
			-- if not stationary in that dimension
		once
			create {CONVERT_LOCKED_TO_FIXED_ACTION} Result
		end
	
	set_view_action: SET_VIEW_ACTION
			-- Action to set view for element
			-- (combination of label, color, fill, opacity)
		once
			create Result
		end
	
	set_label_generator_action: SET_LABEL_GENERATOR_ACTION
			-- Action to set label generator for element
		once
			create Result
		end
	
	set_color_generator_action: SET_COLOR_GENERATOR_ACTION
			-- Action to set color generator for element
		once
			create Result
		end
	
	set_fill_generator_action: SET_FILL_GENERATOR_ACTION
			-- Action to set fill generator for element
		once
			create Result
		end
	
	set_opacity_generator_action: SET_OPACITY_GENERATOR_ACTION
			-- Action to set opacity generator for element
		once
			create Result
		end
	
	switch_color_generator_action: SWITCH_COLOR_GENERATOR_ACTION
			-- Action to switch color generator for element
			-- that has a particular generator to a new one
		once
			create Result
		end
	
	switch_fill_generator_action: SWITCH_FILL_GENERATOR_ACTION
			-- Action to switch fill generator for element
			-- that has a particular generator to a new one
		once
			create Result
		end
	
	toggle_rotation_action: VIEW_ELEMENT_ACTION
			-- Action to toggle of all selected elements
			-- that are rotatable
		once
			create {TOGGLE_ROTATION_ACTION} Result
		end
	
	rotate_clockwise_action: VIEW_ELEMENT_ACTION
			-- Action to rotate all selected elements
			-- that are rotatable 90 degrees clockwise
		once
			create {ROTATE_CLOCKWISE_ACTION} Result
		end
	
	move_action: MOVE_ACTION
			-- Action to move all selected elements
		once
			create Result
		end
	
	duplicate_action: DUPLICATE_ACTION
			-- Action to duplicate all selected elements
		once
			create Result
		end
	
	move_relative_action: MOVE_RELATIVE_ACTION
			-- Action to move all selected elements by relative
			-- amount specified by user
		once
			create Result
		end
	
	center_in_cut_die_action: CENTER_IN_CUT_DIE_ACTION
			-- Action to center elements that are projects in
			-- their cut die, ignoring projects that are not
			-- isolated in their cut die
		once
			create Result
		end
	
	compute_move_limits_action: VIEW_ELEMENT_ACTION
			-- Action to compute limits for Move operation
		once
			create {COMPUTE_MOVE_LIMITS_ACTION} Result
		end
	
	compute_duplicate_limits_action: VIEW_ELEMENT_ACTION
			-- Action to compute limits for Duplicate operation
		once
			create {COMPUTE_DUPLICATE_LIMITS_ACTION} Result
		end
	
	resize_scribe_action: RESIZE_SCRIBE_ACTION
			-- Action to resize all selected scribes
		once
			create Result
		end
	
	compute_fixed_and_locked_action: COMPUTE_FIXED_AND_LOCKED_ACTION
			-- Action to compute whether there are any elements
			-- that are fixed or locked in X and/or Y
		once
			create Result
		end
	
	find_selected_element_action: FIND_SELECTED_ELEMENT_ACTION
			-- Action to find the only selected element
		once
			create Result
		end
	
	delete_dies_action: DELETE_DIES_ACTION
			-- Action to delete all dies in a list
		once
			create Result
		end
	
	update_dies_action: UPDATE_DIES_ACTION
			-- Action to add to changed dies which have been
			-- updated
		once
			create Result
		end
	
	delete_action: DELETE_ACTION
			-- Action to delete all selected elements
		once
			create Result
		end
	
	delete_selected_cut_action: VIEW_ELEMENT_ACTION
			-- Action to delete all selected elements that are cuts
		once
			create {DELETE_SELECTED_CUT_ACTION} Result
		end
	
	delete_intersecting_cut_action: DELETE_INTERSECTING_CUT_ACTION
			-- Action to delete all cuts that intersect the
			-- cut die of any selected project
		once
			create Result
		end
	
	compute_default_isolation_action: VIEW_ELEMENT_ACTION
			-- Action to compute default set of isolated
			-- projects
		once
			create {COMPUTE_DEFAULT_ISOLATION_ACTION} Result
		end
	
	toggle_isolation_action: VIEW_ELEMENT_ACTION
			-- Action to toggle the isolation status of a project
		once
			create {TOGGLE_ISOLATION_ACTION} Result
		end
	
	set_isolated_site_cut_die_action: VIEW_ELEMENT_ACTION
			-- Action to set cut die size and center to ensure
			-- they are accurate just prior to completing a
			-- cut pattern
		once
			create {SET_ISOLATED_SITE_CUT_DIE_ACTION} Result
		end
	
	add_cut_die_action: ADD_CUT_DIE_ACTION
			-- Action to add the cut die to a list, if not Void
		once
			create Result
		end
	
	pre_add_cuts_action: PRE_ADD_CUTS_ACTION
			-- Action to perform before adding cuts through
			-- scribes containing mouse pointer
		once
			create Result
		end
	
	check_scribe_action: VIEW_ELEMENT_ACTION
			-- Action that checks whether a scribe intersects
			-- iat least one field of view and is movable in
			-- its length direction
		once
			create {CHECK_SCRIBE_ACTION} Result
		end
	
	trim_scribe_action: TRIM_SCRIBE_ACTION
			-- Action that trims a scribe that intersects at least
			-- one field of view and that has an end that is
			-- not in any field of view by "trimming" that
			-- end back to the field of view edge
		once
			create Result
		end
	
	separate_scribe_action: SEPARATE_SCRIBE_ACTION
			-- Action that replaces a scribe that
			-- intersects more than one field of view with
			-- a set of scribes that represents the
			-- intersection of the scribe with each field
		once
			create Result
		end
	
	build_edge_list_action: BUILD_EDGE_LIST_ACTION
			-- Action to build list of edges of
			-- model elements and their properties, in either
			-- horizontal or vertical dimension
		once
			create Result
		end
	
	extend_scribe_action: EXTEND_SCRIBE_ACTION
			-- Action that extends both ends of a scribe
			-- to the first meetable edge if not already
			-- at a meetable edge, but without extending
			-- past an unmeetable edge
		once
			create Result
		end
	
	unoverlap_scribe_action: UNOVERLAP_SCRIBE_ACTION
			-- Action that unoverlaps scribe with all or selected
			-- scribes of opposite orientation that intersect it
		once
			create Result
		end
	
	check_join_validity_action: VIEW_ELEMENT_ACTION
			-- Action that checks scribe to see if it is valid
			-- to participate in a Join Scribes operation
		once
			create {CHECK_JOIN_VALIDITY_ACTION} Result
		end
	
	remove_marked_with_select_action: VIEW_ELEMENT_ACTION
			-- Action that removes all elements that are marked
			-- and sets "selected" status of elements that
			-- are not marked (for rebuilding selection lists)
		once
			create {REMOVE_MARKED_WITH_SELECT_ACTION} Result
		end
	
	unmark_action: VIEW_ELEMENT_ACTION
			-- Action that unmarks element
		once
			create {UNMARK_ACTION} Result
		end
	
	unmark_and_clear_invalid_action: VIEW_ELEMENT_ACTION
			-- Action that unmarks element and clears its
			-- list of invalid elements (ones with which
			-- it has some kind of validity problem, such
			-- as overlap)
		once
			create {UNMARK_AND_CLEAR_INVALID_ACTION} Result
		end
	
	extend_list_action: EXTEND_LIST_ACTION
			-- Action to add element to a list
		once
			create Result
		end
	
	add_project_action: ADD_PROJECT_ACTION
			-- Action to add project to a list if not already
			-- in list
		once
			create Result
		end
	
	compute_delete_lists_action: COMPUTE_DELETE_LISTS_ACTION
			-- Action to compute list of projects which have
			-- all copies selected and list of dies for
			-- non-projects that have all copies selected
		once
			create Result
		end
	
	count_action: COUNT_ACTION
			-- Action to count elements
		once
			create Result
		end
	
	add_die_action: ADD_DIE_ACTION
			-- Action to add reticle die to a list
		once
			create Result
		end
	
	add_unique_die_action: ADD_UNIQUE_DIE_ACTION
			-- Action to add reticle die to a list if it
			-- is not already in the list
		once
			create Result
		end
	
	add_action: ADD_ACTION
			-- Action to add element to a list
		once
			create Result
		end
	
	assign_lot_action: ASSIGN_LOT_ACTION
			-- Action to assign lot (wafer etest ID) to project
		once
			create Result
		end
	
	search_design_number_action: SEARCH_DESIGN_NUMBER_ACTION
			-- Action to set "matched" indication for projects
			-- whose design number is included in a list
		once
			create Result
		end
	
	compute_wafer_etest_ids_action: COMPUTE_ETEST_IDS_ACTION
			-- Action to compute list of distinct wafer etest
			-- IDs that are compatible with at least one element
		once
			create {COMPUTE_WAFER_ETEST_IDS_ACTION} Result
		end
	
	compute_assigned_etest_ids_action: COMPUTE_ETEST_IDS_ACTION
			-- Action to compute list of distinct wafer etest
			-- IDs that are assigned to at least one element
		once
			create {COMPUTE_ASSIGNED_ETEST_IDS_ACTION} Result
		end
	
	compute_cut_die_action: COMPUTE_CUT_DIE_ACTION
			-- Action to compute cut die for a project
		once
			create Result
		end
	
	pre_horizontal_scan_action: PRE_HORIZONTAL_SCAN_ACTION
			-- Action to take before horizontal scan
		once
			create Result
		end
	
	pre_vertical_scan_action: PRE_VERTICAL_SCAN_ACTION
			-- Action to take before vertical scan
		once
			create Result
		end
	
	horizontal_scan_action: HORIZONTAL_SCAN_ACTION
			-- Action to do horizontal scan
		once
			create Result
		end
	
	vertical_scan_action: VERTICAL_SCAN_ACTION
			-- Action to do vertical scan
		once
			create Result
		end
	
	check_outside_fields_action: VIEW_ELEMENT_ACTION
			-- Action to check whether element is completely
			-- outside any field of view
		once
			create {CHECK_OUTSIDE_FIELDS_ACTION} Result
		end
	
	check_overlapping_field_action: SCRIBES_INCLUDABLE_ACTION
			-- Action to check whether element overlaps
			-- field of view edge
		once
			create {CHECK_OVERLAPPING_FIELD_ACTION} Result
		end
	
	check_overlapping_object_action: SCRIBES_INCLUDABLE_ACTION
			-- Action to check whether element overlaps
			-- another object
		once
			create {CHECK_OVERLAPPING_OBJECT_ACTION} Result
		end
	
	check_below_min_size_action: VIEW_ELEMENT_ACTION
			-- Action to check whether element is below the
			-- minimum size in either dimension
		once
			create {CHECK_BELOW_MIN_SIZE_ACTION} Result
		end
	
	check_no_lot_assigned_action: VIEW_ELEMENT_ACTION
			-- Action to check whether element is a project
			-- with no lot assigned
		once
			create {CHECK_NO_LOT_ASSIGNED_ACTION} Result
		end
	
	check_unlocked_or_unassigned_action: VIEW_ELEMENT_ACTION
			-- Action to check whether element is a project
			-- that is not locked against customer update or is
			-- not assigned to current run
		once
			create {CHECK_UNLOCKED_OR_UNASSIGNED_ACTION} Result
		end
	
	check_too_close_to_edge_action: SCRIBES_INCLUDABLE_ACTION
			-- Action to check whether element is too close to
			-- a field of view edge
		once
			create {CHECK_TOO_CLOSE_TO_EDGE_ACTION} Result
		end
	
	check_too_close_to_object_action: SCRIBES_INCLUDABLE_ACTION
			-- Action to check whether element is too close to
			-- another object
		once
			create {CHECK_TOO_CLOSE_TO_OBJECT_ACTION} Result
		end
	
	check_misaligned_scribe_action: VIEW_ELEMENT_ACTION
			-- Action to check whether element is a scribe
			-- misaligned with another scribe of same orientation
		once
			create {CHECK_MISALIGNED_SCRIBE_ACTION} Result
		end
	
	check_scribe_cut_die_too_big_action: VIEW_ELEMENT_ACTION
			-- Action to check whether element has a cut die size
			-- determined by surrounding scribes that exceeds 
			-- its maximum die size
		once
			create {CHECK_SCRIBE_CUT_DIE_TOO_BIG_ACTION} Result
		end
	
	check_uncentered_in_cut_die_action: VIEW_ELEMENT_ACTION
			-- Action to check whether element is not centered in
			-- its cut die
		once
			create {CHECK_UNCENTERED_IN_CUT_DIE_ACTION} Result
		end
	
	check_unisolated_in_scribe_cut_die_action: VIEW_ELEMENT_ACTION
			-- Action to check whether element is not isolated in
			-- its cut die determined by surrounding scribes
		once
			create {CHECK_UNISOLATED_IN_SCRIBE_CUT_DIE_ACTION} Result
		end
	
	check_invalid_cut_die_action: VIEW_ELEMENT_ACTION
			-- Action to check wheter element that is isolated
			-- has an invalid cut die
		once
			create {CHECK_INVALID_CUT_DIE_ACTION} Result
		end
	
	check_cut_cut_die_too_big_action: VIEW_ELEMENT_ACTION
			-- Action to check whether element has a cut die size
			-- determined by surrounding cuts that exceeds 
			-- its maximum die size
		once
			create {CHECK_CUT_CUT_DIE_TOO_BIG_ACTION} Result
		end
	
	check_wrong_lot_action: VIEW_ELEMENT_ACTION
			-- Action to check whether element that is isolated
			-- has the wrong lot (different from the one for the
			-- cut pattern)
		once
			create {CHECK_WRONG_LOT_ACTION} Result
		end
	
	check_non_default_cut_die_size_action: VIEW_ELEMENT_ACTION
			-- Action to check whether element that is isolated
			-- has an cut die size determined by surrounding cuts
			-- that is different from its default cut die size
			-- determined by surrounding scribes
		once
			create {CHECK_NON_DEFAULT_CUT_DIE_SIZE_ACTION} Result
		end
	
	check_shared_cut_die_action: VIEW_ELEMENT_ACTION
			-- Action to check whether element that is
			-- isolated shares its cut die partially or
			-- fully with one or more other non-scribe die
			-- elements
		once
			create {CHECK_SHARED_CUT_DIE_ACTION} Result
		end
	
	check_extra_cut_action: VIEW_ELEMENT_ACTION
			-- Action to check whether element is an extra
			-- cut that does not help isolate any isolated sites
		once
			create {CHECK_EXTRA_CUT_ACTION} Result
		end
	
	clear_unisolated_in_scribe_cut_die_action: VIEW_ELEMENT_ACTION
			-- Action to clear element "unisolated in cut die"
			-- indicator
		once
			create {CLEAR_UNISOLATED_IN_SCRIBE_CUT_DIE_ACTION} Result
		end
	
	clear_unisolated_in_cut_cut_die_action: VIEW_ELEMENT_ACTION
			-- Action to clear element "unisolated in cut die"
			-- indicator
		once
			create {CLEAR_UNISOLATED_IN_CUT_CUT_DIE_ACTION} Result
		end
	
	clear_isolating_cut_action: VIEW_ELEMENT_ACTION
			-- Action to clear element "isolating cut"
			-- indicator
		once
			create {CLEAR_ISOLATING_CUT_ACTION} Result
		end
	
	clear_overlapping_object_action: VIEW_ELEMENT_ACTION
			-- Action to clear element "overlaps another object"
			-- indicator
		once
			create {CLEAR_OVERLAPPING_OBJECT_ACTION} Result
		end
	
	clear_close_to_object_action: VIEW_ELEMENT_ACTION
			-- Action to clear element "close to another object"
			-- indicator
		once
			create {CLEAR_CLOSE_TO_OBJECT_ACTION} Result
		end
	
	clear_floating_scribe_action: VIEW_ELEMENT_ACTION
			-- Action to clear element "floating scribe" indicator
		once
			create {CLEAR_FLOATING_SCRIBE_ACTION} Result
		end
	
	set_floating_scribe_action: VIEW_ELEMENT_ACTION
			-- Action to set element to be a floating
			-- scribe
		once
			create {SET_FLOATING_SCRIBE_ACTION} Result
		end
	
	clear_misaligned_scribe_action: VIEW_ELEMENT_ACTION
			-- Action to clear element "misaligned scribe" indicator
		once
			create {CLEAR_MISALIGNED_SCRIBE_ACTION} Result
		end
	
	set_misaligned_scribe_action: VIEW_ELEMENT_ACTION
			-- Action to set element to be a misaligned
			-- scribe
		once
			create {SET_MISALIGNED_SCRIBE_ACTION} Result
		end
	
	small_but_legal_action: SCRIBES_INCLUDABLE_ACTION
			-- Action to take for element that is small but
			-- legal size during validity checking
		once
			create {SMALL_BUT_LEGAL_ACTION} Result
		end
	
	check_test_vehicle_action: CHECK_TEST_VEHICLE_ACTION
			-- Action to take for element that is test vehicle
			-- during validity checking
		once
			create Result
		end
	
	check_scribe_width_action: CHECK_SCRIBE_WIDTH_ACTION
			-- Action to take for element that is scribe
			-- during validity checking
		once
			create Result
		end
	
	clear_processed_action: VIEW_ELEMENT_ACTION
			-- Action to clear the "processed" indicator for
			-- an element, which indicates whether at least one
			-- copy has been processed
		once
			create {CLEAR_PROCESSED_ACTION} Result
		end
	
	clear_intersecting_mbb_areas_action: CLEAR_INTERSECTING_MBB_AREAS_ACTION
			-- Action to clear the list of intersecting model areas
			-- for an element's bounding box
		once
			create Result
		end
	
	populate_intersecting_mbb_areas_action: VIEW_ELEMENT_ACTION
			-- Action to populate the list of intersecting
			-- model areas for an element's bounding box
			-- and the list of intersecting elements for a
			-- model area
		once
			create {POPULATE_INTERSECTING_MBB_AREAS_ACTION} Result
		end
	
	clear_intersecting_scribe_cut_die_areas_action: CLEAR_INTERSECTING_SCRIBE_CUT_DIE_AREAS_ACTION
			-- Action to clear the list of intersecting model areas
			-- for an element's cut die, as determined by
			-- surrounding scribes
		once
			create Result
		end
	
	populate_intersecting_scribe_cut_die_areas_action: VIEW_ELEMENT_ACTION
			-- Action to populate the list of intersecting
			-- model areas for an element's cut die
			-- determined by surrounding scribes and the
			-- list of intersecting elements for a model
			-- area
		once
			create {POPULATE_INTERSECTING_SCRIBE_CUT_DIE_AREAS_ACTION} Result
		end
	
	clear_intersecting_cut_cut_die_areas_action: CLEAR_INTERSECTING_CUT_CUT_DIE_AREAS_ACTION
			-- Action to clear the list of intersecting model areas
			-- for an element's cut die, as determined by
			-- surrounding cuts
		once
			create Result
		end
	
	populate_intersecting_cut_cut_die_areas_action: VIEW_ELEMENT_ACTION
			-- Action to populate the list of intersecting
			-- model areas for an element's cut die
			-- determined by surrounding cuts and the
			-- list of intersecting elements for a model
			-- area
		once
			create {POPULATE_INTERSECTING_CUT_CUT_DIE_AREAS_ACTION} Result
		end
	
	clear_intersecting_hscribe_areas_action: CLEAR_INTERSECTING_HSCRIBE_AREAS_ACTION
			-- Action to clear the list of intersecting
			-- model areas for a horizontal scribe's bounding box
		once
			create Result
		end
	
	populate_intersecting_hscribe_areas_action: VIEW_ELEMENT_ACTION
			-- Action to populate the list of intersecting
			-- model areas for a horizontal scribe's bounding box
			-- and the list of intersecting elements for a
			-- model area
		once
			create {POPULATE_INTERSECTING_HSCRIBE_AREAS_ACTION} Result
		end
	
	clear_intersecting_vscribe_areas_action: CLEAR_INTERSECTING_VSCRIBE_AREAS_ACTION
			-- Action to clear the list of intersecting
			-- model areas for a vertical scribe's bounding box
		once
			create Result
		end
	
	populate_intersecting_vscribe_areas_action: VIEW_ELEMENT_ACTION
			-- Action to populate the list of intersecting
			-- model areas for a vertical scribe's bounding box
			-- and the list of intersecting elements for a
			-- model area
		once
			create {POPULATE_INTERSECTING_VSCRIBE_AREAS_ACTION} Result
		end
	
	measure_sum_action: MEASURE_SUM_ACTION
			-- Action to measure sum of selected object widths
			-- and heights
		once
			create Result
		end
	
	compute_measure_point_action: COMPUTE_MEASURE_POINT_ACTION
			-- Action to compute point to be used for a
			-- Measure Distance operation
		once
			create Result
		end
	
	compute_unisolated_in_scribe_cut_die_action: VIEW_ELEMENT_ACTION
			-- Action to compute whether element is not isolated in
			-- its cut die determined by surrounding scribes
		once
			create {COMPUTE_UNISOLATED_IN_SCRIBE_CUT_DIE_ACTION} Result
		end
	
end
