
indexing
	
	description: "Filters for view elements"
	author: "David Hollenberg"
	date: "October 1, 2006"

class VIEW_ELEMENT_FILTERS

feature -- Properties

	all_filter: VIEW_ELEMENT_FILTER
			-- Filter to select all view elements
		once
			create {ELEM_ALL_FILTER} Result
		end
	
	none_filter: VIEW_ELEMENT_FILTER
			-- Filter to select no view elements
		once
			create {ELEM_NONE_FILTER} Result
		end
	
	selected_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are currently selected
		once
			create {ELEM_SELECTED_FILTER} Result
		end
	
	unselected_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are currently unselected
		once
			create {ELEM_UNSELECTED_FILTER} Result
		end
	
	selectable_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are selectable
		once
			create {ELEM_SELECTABLE_FILTER} Result
		end
	
	die_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are dies
		once
			create {ELEM_DIE_FILTER} Result
		end
	
	die_or_cut_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are dies or cuts
		once
			create {ELEM_DIE_OR_CUT_FILTER} Result
		end
	
	project_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are projects
		once
			create {ELEM_PROJECT_FILTER} Result
		end
	
	cust_project_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are customer projects
		once
			create {ELEM_CUST_PROJECT_FILTER} Result
		end
	
	test_vehicle_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are test vehicles
		once
			create {ELEM_TEST_VEHICLE_FILTER} Result
		end
	
	vendor_geometry_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are vendor geometries
		once
			create {ELEM_VENDOR_GEOMETRY_FILTER} Result
		end
	
	cut_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are cuts
		once
			create {ELEM_CUT_FILTER} Result
		end
	
	selected_cut_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are cuts that are currently selected
		once
			create {ELEM_SELECTED_CUT_FILTER} Result
		end
	
	horizontal_cut_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are horizontal cuts
		once
			create {ELEM_HORIZONTAL_CUT_FILTER} Result
		end
	
	vertical_cut_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are vertical cuts
		once
			create {ELEM_VERTICAL_CUT_FILTER} Result
		end
	
	selected_project_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are projects that are currently selected
		once
			create {ELEM_SELECTED_PROJECT_FILTER} Result
		end
	
	isolatable_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are isolatable
		once
			create {ELEM_ISOLATABLE_FILTER} Result
		end
	
	selected_isolatable_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are isolatable and that are currently selected
		once
			create {ELEM_SELECTED_ISOLATABLE_FILTER} Result
		end
	
	cut_label_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are cut labels
		once
			create {ELEM_CUT_LABEL_FILTER} Result
		end
	
	filler_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are fillers
		once
			create {ELEM_FILLER_FILTER} Result
		end
	
	scribe_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are scribes
		once
			create {ELEM_SCRIBE_FILTER} Result
		end
	
	horizontal_scribe_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are horizontal scribes
		once
			create {ELEM_HORIZONTAL_SCRIBE_FILTER} Result
		end
	
	vertical_scribe_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are vertical scribes
		once
			create {ELEM_VERTICAL_SCRIBE_FILTER} Result
		end
	
	floating_scribe_filter: ELEM_FLOATING_SCRIBE_FILTER
			-- Filter to select only view elements that
			-- are floating scribes
		once
			create Result
		end
	
	floating_scribe_alt_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are floating scribes.  Alternate version
			-- that uses previously computed value
		once
			create {ELEM_FLOATING_SCRIBE_ALT_FILTER} Result
		end
	
	misaligned_scribe_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are misaligned scribes
		once
			create {ELEM_MISALIGNED_SCRIBE_FILTER} Result
		end
	
	misaligned_scribe_alt_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are misaligned scribes.  Alternate version
			-- that uses previously computed value
		once
			create {ELEM_MISALIGNED_SCRIBE_ALT_FILTER} Result
		end
	
	default_width_scribe_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are scribes that have the default width
		once
			create {ELEM_DEFAULT_WIDTH_SCRIBE_FILTER} Result
		end
	
	custom_width_scribe_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are scribes that have a non-default width
		once
			create {ELEM_CUSTOM_WIDTH_SCRIBE_FILTER} Result
		end
	
	non_scribe_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are dies but are not scribes
		once
			create {ELEM_NON_SCRIBE_FILTER} Result
		end
	
	selected_horizontal_scribe_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are horizontal scribes which are selected
		once
			create {SELECTED_HORIZONTAL_SCRIBE_FILTER} Result
		end
	
	selected_vertical_scribe_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are vertical scribes which are selected
		once
			create {SELECTED_VERTICAL_SCRIBE_FILTER} Result
		end
	
	int_horizontal_scribe_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are horizontal scribes that intersect at
			-- least one field of view
		once
			create {INT_HORIZONTAL_SCRIBE_FILTER} Result
		end
	
	int_vertical_scribe_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are vertical scribes that intersect at
			-- least one field of view
		once
			create {INT_VERTICAL_SCRIBE_FILTER} Result
		end
	
	selected_int_horizontal_scribe_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are horizontal scribes that are selected and
			-- that intersect at least one field of view
		once
			create {SELECTED_INT_HORIZONTAL_SCRIBE_FILTER} Result
		end
	
	selected_int_vertical_scribe_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are vertical scribes that are selected and
			-- that intersect at least one field of view
		once
			create {SELECTED_INT_VERTICAL_SCRIBE_FILTER} Result
		end
	
	commercial_project_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are commercial projects
		once
			create {ELEM_COMMERCIAL_PROJECT_FILTER} Result
		end
	
	mep_project_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are MEP projects
		once
			create {ELEM_MEP_PROJECT_FILTER} Result
		end
	
	other_project_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are "other" projects (not commercial or MEP)
		once
			create {ELEM_OTHER_PROJECT_FILTER} Result
		end
	
	cust_project_etest_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are customer projects and that have more than
			-- one compatible wafer etest ID
		once
			create {ELEM_CUST_PROJECT_ETEST_FILTER} Result
		end
	
	selected_cust_project_etest_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are selected, are customer projects and
			-- that have more than one compatible wafer
			-- etest ID
		once
			create {SELECTED_CUST_PROJECT_ETEST_FILTER} Result
		end
	
	partially_selected_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are partially selected (some but not all copies
			-- selected)
		once
			create {ELEM_PARTIALLY_SELECTED_FILTER} Result
		end
	
	outside_fields_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are completely outside all fields of view
			-- (do not intersect them)
		once
			create {ELEM_OUTSIDE_FIELDS_FILTER} Result
		end
	
	partially_outside_fields_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- intersect at least one field of view but
			-- are not completely enclosed by any field
		once
			create {ELEM_PARTIALLY_OUTSIDE_FIELDS_FILTER} Result
		end
	
	partially_outside_fields_alt_filter: ELEM_PARTIALLY_OUTSIDE_FIELDS_ALT_FILTER
			-- Alternate filter to select only view elements that
			-- intersect at least one field of view but
			-- are not completely enclosed by any field,
			-- with option to include or exclude scribes
		once
			create Result
		end
	
	too_close_to_edge_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- intersect at least one field of view and
			-- have at least one edge which is too close
			-- to field of view edge
		once
			create {ELEM_TOO_CLOSE_TO_EDGE_FILTER} Result
		end
	
	too_close_to_edge_alt_filter: ELEM_TOO_CLOSE_TO_EDGE_ALT_FILTER
			-- Filter to select only view elements that
			-- intersect at least one field of view and
			-- have at least one edge which is too close
			-- to field of view edge.  Alternate version
			-- which provides option to include or exclude
			-- scribes
		once
			create Result
		end
	
	too_close_to_object_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- intersect at least one field of view and
			-- that are too close to another object that also
			-- intersects at least one field
		once
			create {ELEM_TOO_CLOSE_TO_OBJECT_FILTER} Result
		end
	
	too_close_to_object_alt_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- intersect at least one field of view and
			-- that are too close to another object that also
			-- intersects at least one field.  Alternate
			-- version that uses previously computed value
		once
			create {ELEM_TOO_CLOSE_TO_OBJECT_ALT_FILTER} Result
		end
	
	scribe_cut_die_too_big_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are projects whose cut die size determined
			-- by surrounding scribes exceeds their
			-- maximum die size
		once
			create {ELEM_SCRIBE_CUT_DIE_TOO_BIG_FILTER} Result
		end
	
	cut_cut_die_too_big_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are projects whose cut die size determined
			-- by surrounding cuts exceeds their
			-- maximum die size
		once
			create {ELEM_CUT_CUT_DIE_TOO_BIG_FILTER} Result
		end
	
	cut_cut_die_invalid_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are projects whose cut die determined
			-- by surrounding cuts is invalid (not surrounded
			-- by cuts on all sides or has cut through
			-- printed die)
		once
			create {ELEM_CUT_CUT_DIE_INVALID_FILTER} Result
		end
	
	wrong_lot_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are projects that have the wrong lot (different
			-- than the one for the cut pattern)
		once
			create {ELEM_WRONG_LOT_FILTER} Result
		end
	
	shares_cut_die_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only isolated elements
			-- that have a cut die determined by
			-- surrounding cuts that is shared by
			-- partially or fully by one or more other
			-- non-scribe die elements than the one for
			-- the cut pattern)
		once
			create {ELEM_SHARES_CUT_DIE_FILTER} Result
		end
	
	non_default_cut_size_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only isolated elements
			-- that have a die size determined by
			-- surrounding cuts that is different than the
			-- die size determined by surrounding scribes
		once
			create {ELEM_NON_DEFAULT_CUT_SIZE_FILTER} Result
		end
	
	extra_cut_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only elements that are
			-- cuts that are not an isolating cut for any
			-- isolated site
		once
			create {ELEM_EXTRA_CUT_FILTER} Result
		end
	
	uncentered_in_cut_die_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are projects which are not centered in their
			-- cut die
		once
			create {ELEM_UNCENTERED_IN_CUT_DIE_FILTER} Result
		end
	
	unisolated_in_cut_die_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are projects which are not isolated in their
			-- cut die
		once
			create {ELEM_UNISOLATED_IN_CUT_DIE_FILTER} Result
		end
	
	unisolated_in_cut_die_alt_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are projects which are not isolated in their
			-- cut die.  Alternate version that uses
			-- previously computed value
		once
			create {ELEM_UNISOLATED_IN_CUT_DIE_ALT_FILTER} Result
		end
	
	overlaps_other_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- overlap another element that is a die
		once
			create {ELEM_OVERLAPS_OTHER_FILTER} Result
		end
	
	overlaps_other_alt_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- overlap another element that is a die,
			-- using previously computed "overlapping"
		once
			create {ELEM_OVERLAPS_OTHER_ALT_FILTER} Result
		end
	
	inside_view_area_filter: VIEW_AREA_FILTER
			-- Filter to select only view elements that
			-- are completely inside an area (rectangle) of view
		once
			create {ELEM_INSIDE_VIEW_AREA_FILTER} Result
		end
	
	intersects_view_area_filter: VIEW_AREA_FILTER
			-- Filter to select only view elements that
			-- intersect an area (rectangle) of view
		once
			create {ELEM_INTERSECTS_VIEW_AREA_FILTER} Result
		end
	
	contains_view_point_filter: VIEW_POINT_FILTER
			-- Filter to select only view elements that
			-- contain a view point
		once
			create {ELEM_CONTAINS_VIEW_POINT_FILTER} Result
		end
	
	any_copy_contains_view_point_filter: VIEW_POINT_FILTER
			-- Filter to select only view elements which have at
			-- least one copy that contains a view point
		once
			create {ELEM_ANY_COPY_CONTAINS_POINT_FILTER} Result
		end
	
	project_all_copies_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are projects that have all copies selected
		once
			create {ELEM_PROJECT_ALL_COPIES_FILTER} Result
		end
	
	all_copies_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- have all copies selected
		once
			create {ELEM_ALL_COPIES_FILTER} Result
		end

	unmarked_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are not marked
		once
			create {UNMARKED_FILTER} Result
		end
	
	size_too_small_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are dies that have a size below the minimum
			-- allowed in either dimension
		once
			create {ELEM_SIZE_TOO_SMALL_FILTER} Result
		end
	
	small_scribe_and_filler_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are scribes or fillers whose size is below
			-- the small object threshold in either
			-- dimension (just length for scribes)
		once
			create {ELEM_SMALL_SCRIBE_FILLER_FILTER} Result
		end
	
	small_scribe_and_filler_alt_filter: ELEM_SMALL_SCRIBE_FILLER_ALT_FILTER
			-- Filter to select only view elements that
			-- are scribes or fillers whose size is below
			-- the small object threshold in either
			-- dimension (just length for scribes).
			-- Alternate version that provides option to
			-- include or exclude scribes
		once
			create Result
		end
	
	wafer_etest_id_unassigned_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- have associated wafer etest ID(s) but have not
			-- been assigned a specific one
		once
			create {ELEM_WAFER_ETEST_ID_UNASSIGNED_FILTER} Result
		end
	
	unlocked_or_unassigned_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are customer projects that have not been locked
			-- against customer update or that have not been
			-- assigned to the run being closed
		once
			create {ELEM_UNLOCKED_OR_UNASSIGNED_FILTER} Result
		end
	
	non_field_label_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are not field labels
		once
			create {ELEM_NON_FIELD_LABEL_FILTER} Result
		end
	
	uncentered_projects_filter: VIEW_ELEMENT_FILTER
			-- Filter to select all view elements that
			-- are projects that are isolated in their
			-- cut die but not centered in cut die
		once
			create {ELEM_UNCENTERED_PROJECT_FILTER} Result
		end
	
	selected_uncentered_project_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only selected view elements that
			-- are projects that are isolated in their
			-- cut die but not centered in cut die
		once
			create {ELEM_SELECTED_UNCENTERED_PROJECT_FILTER} Result
		end
	
	rotated_180_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are rotated 180 degrees clockwise
			-- cut die but not centered in cut die
		once
			create {ELEM_ROTATED_180_FILTER} Result
		end
	
	rotated_270_filter: VIEW_ELEMENT_FILTER
			-- Filter to select only view elements that
			-- are rotated 270 degrees clockwise
			-- cut die but not centered in cut die
		once
			create {ELEM_ROTATED_270_FILTER} Result
		end
	
end
