
indexing
	
	description: "Object that can generate colors for an %
		%element of a reticle view according to the whether it has %
		%an assigned wafer etest ID and if so, which one"
	author: "David Hollenberg"
	date: "December 15, 2006"

class WAFER_ETEST_ID_COLOR_GENERATOR
inherit
	RETICLE_VIEW_ELEMENT_COLOR_GENERATOR

create
	make

feature -- Access

	border_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Foreground color for border (usually a
			-- rectangle) of `an_element'
		do
			Result := standard_color (an_element)
		end
	
	label_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Foreground color for label
		do
			Result := standard_color (an_element)
		end
	
feature {NONE} -- Implementation

	standard_color (an_element: RETICLE_VIEW_ELEMENT): EV_COLOR
			-- Standard color for `an_element', based on
			-- its assigned wafer etest name
		do
			if not an_element.is_selectable then
				Result := palette.unselectable_color
			elseif an_element.has_wafer_etest_id then
				Result := palette.wafer_etest_name_color (an_element.wafer_etest_name)
			elseif an_element.is_cut then
				Result := palette.cut_color
			else
				Result := palette.default_label_color
			end
		end
	
end
