
indexing
	
	description: "Object that can generate a wafer etest ID for an %
		%element of a reticle view"
	author: "David Hollenberg"
	date: "July 25, 2006"

class WAFER_ETEST_ID_LABEL_GENERATOR
inherit
	RETICLE_VIEW_ELEMENT_LABEL_GENERATOR
	STRING_UTILITIES_ACCESS
		export
			{NONE} all
		end

feature  -- Access

	label (an_element: RETICLE_VIEW_ELEMENT): STRING
			-- Label for `an_element'
		local
			assigned, unassigned: STRING
			unassigned_list: LIST [STRING]
		do
			if an_element.has_wafer_etest_id then
				assigned := an_element.assigned_wafer_etest_id
				unassigned_list := an_element.unassigned_wafer_etest_ids
				unassigned := "(" + su.joined_by (unassigned_list, ", ") + ")"
				if not assigned.is_empty then
					if unassigned_list.is_empty then
						Result := assigned
					else
						Result := assigned + "%N" + unassigned
					end
				else
					Result := unassigned
				end
			else
				Result := an_element.identification
			end
		end
	
end
