
indexing

	author: "Generated"
	date: "Thu Jun 12 13:50:27 PDT 2003"

class WAFER_LITHO_SIZE_PART_SEQ_IDS_ROW
inherit
	WAFER_LITHO_SIZE_PART_SEQ_IDS_RAW
	ROW_COUNT_CHECK_ACCESS
		export
			{NONE} all
		end
	ITEM_COUNT_RANGES_ACCESS
		export
			{NONE} all
		end
create
	make_template, make_null, make_by_key

feature -- Collections

	rows_for_wt_and_entity (wt, entity: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): DYNAMIC_LIST [like Current]
			-- All rows for wafer techn `wt' and labeled
			-- entity `entity', ordered by vendor part sequence
			-- ID
		require
			wt_not_void: wt /= Void
			entity_not_void: entity /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_SS
		do
			create b.make (wt, entity)
			Result := all_rows_filtered_ordered (conn, "wafer_techn = :1 and labelled_entity = :2",
				b, "vendor_part_sequence_id")
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

	rows_for_custom_litho_sizes_for_run (run: STRING conn: DB_CONNECTION range: ITEM_COUNT_RANGE): DYNAMIC_LIST [like Current]
			-- All rows which are for litho sizes which 
			-- are custom ones for `run'
		require
			run_not_void: run /= Void
			connection_exists: conn /= Void
			connection_open: conn.is_open
			range_exists: range /= Void
		local
			b: DB_BIND_S
		do
			create b.make (run)
			Result := all_rows_filtered (conn, "litho_size_id in (select litho_size_id from litho_sizes where run_id = :1)", b)
			check_row_count (Result, range)
		ensure
			result_exists: Result /= Void
		end

end
