
indexing

	date: "Tue Apr 24 10:30:17 2007"
	author: "Generated automatically by the Eiffel class generator"
	description: "Application NFE, database user DHOLLEN"
	database_tables: 
		"WAFER_PROBERS (MOSIS.WAFER_PROBERS)"
			-- Included columns
			-- 	CHUCK_DIAMETER
			-- 	CHUCK_TRAVEL_CENTER_X
			-- 	CHUCK_TRAVEL_CENTER_Y
			-- 	CHUCK_TRAVEL_SIZE_X
			-- 	CHUCK_TRAVEL_SIZE_Y
			-- 	DESCR
			-- 	OBSTACLE_DISTANCE
			-- 	SAFETY_MARGIN_X
			-- 	SAFETY_MARGIN_Y
			-- 	SHORT_ID
			-- 	WAFER_PROBER_ID
			-- Excluded columns
			-- 	(none)

class WAFER_PROBERS_RAW

inherit

	DB_IDENTIFIED_ROW

create

	make_template, make_null, make_detached, make_by_key

feature -- Creation

	make_by_key (c: DB_CONNECTION; o: DB_QUERY_OPTION; the_wafer_prober_id: STRING)
		require
			connection_exists: c /= Void
			option_exists: o /= Void
			the_wafer_prober_id_exists: the_wafer_prober_id /= Void
		do
			if is_registered then
				handle_reuse_error
			end
			wafer_prober_id := the_wafer_prober_id
			is_null_wafer_prober_id := False
			std_make_by_key (c, o)
		end

feature -- Properties

	real_column_count: INTEGER = 11

	pseudo_column_count: INTEGER = 0

	real_column_names: STRING = "  chuck_diameter, chuck_travel_center_x, chuck_travel_center_y,%N  chuck_travel_size_x, chuck_travel_size_y, descr, obstacle_distance,%N  safety_margin_x, safety_margin_y, short_id, wafer_prober_id"

	pseudo_column_names: STRING = ""

	select_list: STRING
		once
			Result := new_select_list
		end

	table_and_alias_names: STRING = "wafer_probers wp"

	join_condition: STRING = ""

	table_name: STRING = "wafer_probers"

	key_where_clause: STRING = "wafer_prober_id = :1"

feature -- Values

	chuck_diameter: INTEGER
			-- DB: NUMBER(6,0) not null

	chuck_travel_center_x: INTEGER
			-- DB: NUMBER(6,0) not null

	chuck_travel_center_y: INTEGER
			-- DB: NUMBER(6,0) not null

	chuck_travel_size_x: INTEGER
			-- DB: NUMBER(6,0) not null

	chuck_travel_size_y: INTEGER
			-- DB: NUMBER(6,0) not null

	descr: STRING
			-- DB: VARCHAR2(50)

	obstacle_distance: INTEGER
			-- DB: NUMBER(6,0) not null

	safety_margin_x: INTEGER
			-- DB: NUMBER(6,0) not null

	safety_margin_y: INTEGER
			-- DB: NUMBER(6,0) not null

	short_id: STRING
			-- DB: VARCHAR2(10) not null

	wafer_prober_id: STRING
			-- DB: VARCHAR2(30) not null

feature -- Nullness for null allowed columns

	is_null_descr: BOOLEAN

feature -- Nullness for non-null columns

	is_null_chuck_diameter: BOOLEAN
	is_null_chuck_travel_center_x: BOOLEAN
	is_null_chuck_travel_center_y: BOOLEAN
	is_null_chuck_travel_size_x: BOOLEAN
	is_null_chuck_travel_size_y: BOOLEAN
	is_null_obstacle_distance: BOOLEAN
	is_null_safety_margin_x: BOOLEAN
	is_null_safety_margin_y: BOOLEAN
	is_null_short_id: BOOLEAN
	is_null_wafer_prober_id: BOOLEAN

feature -- Comparison

	key_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and equal (wafer_prober_id, r.wafer_prober_id)
			Result := Result
				and is_null_wafer_prober_id = r.is_null_wafer_prober_id
		end

	nonkey_columns_equal (r: like Current): BOOLEAN
		do
			Result := True
			Result := Result
				and chuck_diameter = r.chuck_diameter
				and chuck_travel_center_x = r.chuck_travel_center_x
				and chuck_travel_center_y = r.chuck_travel_center_y
				and chuck_travel_size_x = r.chuck_travel_size_x
				and chuck_travel_size_y = r.chuck_travel_size_y
				and obstacle_distance = r.obstacle_distance
				and safety_margin_x = r.safety_margin_x
				and safety_margin_y = r.safety_margin_y
			Result := Result
				and equal (descr, r.descr)
				and equal (short_id, r.short_id)
			Result := Result
				and is_null_chuck_diameter = r.is_null_chuck_diameter
				and is_null_chuck_travel_center_x = r.is_null_chuck_travel_center_x
				and is_null_chuck_travel_center_y = r.is_null_chuck_travel_center_y
				and is_null_chuck_travel_size_x = r.is_null_chuck_travel_size_x
				and is_null_chuck_travel_size_y = r.is_null_chuck_travel_size_y
				and is_null_descr = r.is_null_descr
				and is_null_obstacle_distance = r.is_null_obstacle_distance
				and is_null_safety_margin_x = r.is_null_safety_margin_x
				and is_null_safety_margin_y = r.is_null_safety_margin_y
				and is_null_short_id = r.is_null_short_id
		end

feature {NONE} -- Select item definition

	define_real_select_items (q: SQL_QUERY)
		do
			q.select_integer (1)
			q.select_integer (2)
			q.select_integer (3)
			q.select_integer (4)
			q.select_integer (5)
			q.select_string (6, 50)
			q.select_integer (7)
			q.select_integer (8)
			q.select_integer (9)
			q.select_string (10, 10)
			q.select_string (11, 30)
		end

	define_pseudo_select_items (q: SQL_QUERY)
		do
		end

feature {NONE} -- Row fill in

	fill_in_basics (q: SQL_QUERY)
		do
			chuck_diameter := q.integer_value (1)
			chuck_travel_center_x := q.integer_value (2)
			chuck_travel_center_y := q.integer_value (3)
			chuck_travel_size_x := q.integer_value (4)
			chuck_travel_size_y := q.integer_value (5)
			obstacle_distance := q.integer_value (7)
			safety_margin_x := q.integer_value (8)
			safety_margin_y := q.integer_value (9)
		end

	fill_in_references (q: SQL_QUERY)
		do
			descr := q.string_value (6)
			short_id := q.string_value (10)
			wafer_prober_id := q.string_value (11)
		end

	fill_in_references_reused (q: SQL_QUERY)
		do
			q.get_string_value (6, descr)
			q.get_string_value (10, short_id)
			q.get_string_value (11, wafer_prober_id)
		end

	fill_in_nulls (q: SQL_QUERY)
		do
			is_null_chuck_diameter := q.is_null (1)
			is_null_chuck_travel_center_x := q.is_null (2)
			is_null_chuck_travel_center_y := q.is_null (3)
			is_null_chuck_travel_size_x := q.is_null (4)
			is_null_chuck_travel_size_y := q.is_null (5)
			is_null_descr := q.is_null (6)
			is_null_obstacle_distance := q.is_null (7)
			is_null_safety_margin_x := q.is_null (8)
			is_null_safety_margin_y := q.is_null (9)
			is_null_short_id := q.is_null (10)
			is_null_wafer_prober_id := q.is_null (11)
		end

feature {NONE} -- Initialization

	set_null_key
		do
			is_null_wafer_prober_id := True
			create wafer_prober_id.make (0)
		end

	set_null_nonkey
		do
			is_null_chuck_diameter := True
			is_null_chuck_travel_center_x := True
			is_null_chuck_travel_center_y := True
			is_null_chuck_travel_size_x := True
			is_null_chuck_travel_size_y := True
			is_null_descr := True
			is_null_obstacle_distance := True
			is_null_safety_margin_x := True
			is_null_safety_margin_y := True
			is_null_short_id := True
			create descr.make (0)
			create short_id.make (0)
		end

feature {NONE} -- Binding

	bind_key (q: SQL_QUERY)
		do
			q.bind_num_to_string (1, wafer_prober_id, False)
		end

feature {NONE} -- Comparison

	same_values (q: SQL_QUERY): BOOLEAN
		local
			s: STRING
		do
			s := temp_string
			Result := True
			Result := Result
				and chuck_diameter = q.integer_value (1)
				and chuck_travel_center_x = q.integer_value (2)
				and chuck_travel_center_y = q.integer_value (3)
				and chuck_travel_size_x = q.integer_value (4)
				and chuck_travel_size_y = q.integer_value (5)
				and obstacle_distance = q.integer_value (7)
				and safety_margin_x = q.integer_value (8)
				and safety_margin_y = q.integer_value (9)
			q.get_string_value (6, s)
			Result := Result and equal (descr, s)
			q.get_string_value (10, s)
			Result := Result and equal (short_id, s)
			q.get_string_value (11, s)
			Result := Result and equal (wafer_prober_id, s)
			Result := Result
				and is_null_chuck_diameter = q.is_null (1)
				and is_null_chuck_travel_center_x = q.is_null (2)
				and is_null_chuck_travel_center_y = q.is_null (3)
				and is_null_chuck_travel_size_x = q.is_null (4)
				and is_null_chuck_travel_size_y = q.is_null (5)
				and is_null_descr = q.is_null (6)
				and is_null_obstacle_distance = q.is_null (7)
				and is_null_safety_margin_x = q.is_null (8)
				and is_null_safety_margin_y = q.is_null (9)
				and is_null_short_id = q.is_null (10)
				and is_null_wafer_prober_id = q.is_null (11)
		end

end
