
indexing
	
	description: "Access to all known wafer techn families"
	author: "David Hollenberg"
	date: "June 18, 2003"

deferred class WAFER_TECHN_FAMILY_ACCESS

feature	-- need a run_cache so we can look up answers

	cache: RUN_CACHE
	deferred
	end

feature -- Properties

	wafer_techn_family_for_wtf(a_wtf: STRING): WAFER_TECHN_FAMILY
		-- retrieve WAFER_TECHN_FAMILY for wtf;
		-- give it access to the cache
		require have_wtf: a_wtf /= Void
		do
			if cached_wafer_techn_families = Void then
				cache_all_wafer_techn_families
			end
			Result := cached_wafer_techn_families.item(a_wtf)
		end

feature {NONE} -- cache stuff

	cached_wafer_techn_families: HASH_TABLE [WAFER_TECHN_FAMILY, STRING]

	cache_all_wafer_techn_families
			-- All known wafer techn families indexed by name
		do	
			create cached_wafer_techn_families.make (73)
			add_family (create {AMI_ABN})
			add_family (create {AMI_C3})
			add_family (create {AMI_C4})
			add_family (create {AMI_C5})
			add_family (create {AMI_I2T100})
			add_family (create {AMI_I3T80})
			add_family (create {AMS_BYR})
			add_family (create {AMS_CXZ})
			add_family (create {AMS_S35})
			add_family (create {AMS_C35})
			add_family (create {HP_AMOS14TB})
			add_family (create {HP_GMOS10})
			add_family (create {IBM_5HP})
			add_family (create {IBM_5HPE})
			add_family (create {IBM_6HP})
			add_family (create {IBM_6RF})
			add_family (create {IBM_6SF})
			add_family (create {IBM_6WL})
			add_family (create {IBM_7HP})
			add_family (create {IBM_7HV})
			add_family (create {IBM_7RF})
			add_family (create {IBM_7RFSOI})
			add_family (create {IBM_7SF})
			add_family (create {IBM_7WL})
			add_family (create {IBM_8RF})
			add_family (create {IBM_8HP})
			add_family (create {IBM_8SF})
			add_family (create {IBM_8WL})
			add_family (create {IBM_9SF})
			add_family (create {IBM_9LPRF})
			add_family (create {IBM_10SF})
			add_family (create {IBM_10LPRFE})
			add_family (create {IBM_32LP})
			add_family (create {MF_EFAB})
			add_family (create {OMMIC_GAAS})
			add_family (create {PEREGRINE_FA})
			add_family (create {PEREGRINE_FC})
			add_family (create {TSMC_0065})
			add_family (create {TSMC_013})
			add_family (create {TSMC_018})
			add_family (create {TSMC_025})
			add_family (create {TSMC_035})
			add_family (create {VSE_VIP_1})
			add_family (create {ZARLINK_C08})
		end

	add_family (f: WAFER_TECHN_FAMILY)
			-- Add `f' to cached_wafer_techn_families
		require
			family_exists: f /= Void
		do
			f.set_cache(cache)
			cached_wafer_techn_families.put (f, f.name)
		end
end
