
indexing
	
	description: "Facilities for aligning widgets"
	author: "David Hollenberg";
	date: "November 5, 2003"

deferred class WIDGET_ALIGNMENT
inherit
	ANY
	EV_TEXT_ALIGNMENT_CONSTANTS
		export
			{NONE} all
		end

feature -- Properties

	aligned_widget (widget: EV_WIDGET): EV_WIDGET is
			-- `widget' aligned as specified by `alignment'
		local
			is_label: BOOLEAN
			label: EV_LABEL
			hbox, left_box, right_box: EV_HORIZONTAL_BOX
		do
			label ?= widget
			is_label := label /= Void
			Result := widget
			inspect alignment
			when No_alignment then
			when Ev_text_alignment_left then
				if is_label then
					label.align_text_left
				else
					create right_box
					create hbox
					hbox.extend (widget)
					hbox.extend (right_box)
					hbox.disable_item_expand (widget)
					Result := hbox
				end
			when Ev_text_alignment_center then
				if is_label then
					label.align_text_center
				else
					create left_box
					create right_box
					create hbox
					hbox.extend (left_box)
					hbox.extend (widget)
					hbox.extend (right_box)
					hbox.disable_item_expand (widget)
					Result := hbox
				end
			when Ev_text_alignment_right then
				if is_label then
					label.align_text_right
				else
					create left_box
					create hbox
					hbox.extend (left_box)
					hbox.extend (widget)
					hbox.disable_item_expand (widget)
					Result := hbox
				end
			end
		end

feature {NONE} -- Implementation

	alignment: INTEGER
			-- Alignment of item

	No_alignment: INTEGER is 0
			-- Value indicating item should not be aligned

end
