
indexing
	
	description: "Interface that can be displayed in a graphical window"
	author: "David Hollenberg"
	date: "November 3, 2003"

deferred class WINDOW_INTERFACE
inherit
	ABSTRACT_INTERFACE
	TITLED_WINDOW_PROXY
		rename
			make as make_proxy
		export
			{NONE} make_proxy
		end

feature -- Properties

	is_buildable: BOOLEAN
			-- Can interface be built?
		do
			Result := window /= Void and then not window.is_destroyed
		end

	is_active: BOOLEAN

feature -- Modification

	enable_active
			-- Make interface active
		do
			is_active := True
		end

	disable_active
			-- Make interface inactive
			-- (can look but cannot initiate most actions)
		do
			is_active := False
		end

feature -- Operations

	build
			-- Build interface in `window', replacing
			-- any previous interface
		do
			is_resize_to_minimum_requested := True
			build_interface
			if is_resize_to_minimum_requested then
				-- Descendant did not override
				(create {EV_ENVIRONMENT}).application.do_once_on_idle (agent set_size_to_minimum)
			end
		end

feature {NONE} -- Implementation

	build_interface
			-- Build interface in `window'
		deferred
		end
	
	is_resize_to_minimum_requested: BOOLEAN
			
end
