class ZACHS_FONT
	-- the simple proportional-width polygonal font that Zach and Glenn use
	-- each (UC alpha and digit) character fits in the box
	--   (0, 0) to (width ,32), where 15 <= width <= 25
	-- minimum line width is 5
	-- all edges are Manhattan or 45 degrees

inherit
	TEXT_AS_LAYOUT

create
	make	-- (in LAYOUT_TEXT)

feature

	char_layout(c: CHARACTER): LAYOUT is
		-- the creator
	local p: LAYOUT_POLYGON
	do  create p.make(30);
	    Result := p;	-- (unless an instance changes this)
	    inspect c
	    when '0' then
		p.extend_xy( 22.000, 28.000 );
		p.extend_xy( 18.000, 32.000 );
		p.extend_xy( 17.000, 32.000 );
		p.extend_xy( 17.000, 11.000 );
		p.extend_xy( 11.000,  5.000 );
		p.extend_xy(  5.000, 11.000 );
		p.extend_xy(  5.000, 21.000 );
		p.extend_xy( 11.000, 27.000 );
		p.extend_xy( 17.000, 21.000 );
		p.extend_xy( 17.000, 32.000 );
		p.extend_xy(  4.000, 32.000 );
		p.extend_xy(  0.000, 28.000 );
		p.extend_xy(  0.000,  4.000 );
		p.extend_xy(  4.000,  0.000 );
		p.extend_xy( 18.000,  0.000 );
		p.extend_xy( 22.000,  4.000 );
	    when '9' then
		p.extend_xy(  0.000, 20.800 );
		p.extend_xy(  5.000, 15.800 );
		p.extend_xy(  5.000, 23.000 );
		p.extend_xy(  9.000, 27.000 );
		p.extend_xy( 13.000, 27.000 );
		p.extend_xy( 17.000, 23.000 );
		p.extend_xy( 13.000, 19.000 );
		p.extend_xy(  9.000, 19.000 );
		p.extend_xy(  5.000, 23.000 );
		p.extend_xy(  5.000, 15.800 );
		p.extend_xy(  6.800, 14.000 );
		p.extend_xy( 17.000, 14.000 );
		p.extend_xy( 17.000,  0.000 );
		p.extend_xy( 22.000,  0.000 );
		p.extend_xy( 22.000, 25.200 );
		p.extend_xy( 15.200, 32.000 );
		p.extend_xy(  6.800, 32.000 );
		p.extend_xy(  0.000, 25.200 );
	    when '8' then
		p.extend_xy( 22.000, 32.000 );
		p.extend_xy( 17.000, 32.000 );
		p.extend_xy( 17.000,  5.000 );
		p.extend_xy(  5.000,  5.000 );
		p.extend_xy(  5.000, 13.500 );
		p.extend_xy( 17.000, 13.500 );
		p.extend_xy( 17.000, 18.500 );
		p.extend_xy(  5.000, 18.500 );
		p.extend_xy(  5.000, 27.000 );
		p.extend_xy( 17.000, 27.000 );
		p.extend_xy( 17.000, 32.000 );
		p.extend_xy(  0.000, 32.000 );
		p.extend_xy(  0.000,  0.000 );
		p.extend_xy( 22.000,  0.000 );
	    when '7' then
		p.extend_xy(  0.000, 22.000 );
		p.extend_xy(  5.000, 22.000 );
		p.extend_xy(  5.000, 27.000 );
		p.extend_xy( 17.000, 27.000 );
		p.extend_xy( 17.000,  0.000 );
		p.extend_xy( 22.000,  0.000 );
		p.extend_xy( 22.000, 32.000 );
		p.extend_xy(  0.000, 32.000 );
	    when '6' then
		p.extend_xy( 22.000, 11.200 );
		p.extend_xy( 17.000, 16.200 );
		p.extend_xy( 17.000,  9.000 );
		p.extend_xy( 13.000,  5.000 );
		p.extend_xy(  9.000,  5.000 );
		p.extend_xy(  5.000,  9.000 );
		p.extend_xy(  9.000, 13.000 );
		p.extend_xy( 13.000, 13.000 );
		p.extend_xy( 17.000,  9.000 );
		p.extend_xy( 17.000, 16.200 );
		p.extend_xy( 15.200, 18.000 );
		p.extend_xy(  5.000, 18.000 );
		p.extend_xy(  5.000, 27.000 );
		p.extend_xy( 12.800, 27.000 );
		p.extend_xy( 12.800, 32.000 );
		p.extend_xy(  0.000, 32.000 );
		p.extend_xy(  0.000,  6.800 );
		p.extend_xy(  6.800,  0.000 );
		p.extend_xy( 15.200,  0.000 );
		p.extend_xy( 22.000,  6.800 );
	--	p.extend_xy( 22.000, 11.200 );
	    when '5' then
		p.extend_xy( 22.000, 27.000 );
		p.extend_xy( 22.000, 32.000 );
		p.extend_xy(  0.000, 32.000 );
		p.extend_xy(  0.000, 19.200 );
		p.extend_xy(  5.000, 14.200 );
		p.extend_xy( 14.200, 14.200 );
		p.extend_xy( 17.000, 11.400 );
		p.extend_xy( 17.000,  7.200 );
		p.extend_xy( 14.800,  5.000 );
		p.extend_xy(  5.000,  5.000 );
		p.extend_xy(  5.000,  8.000 );
		p.extend_xy(  0.000,  8.000 );
		p.extend_xy(  0.000,  4.000 );
		p.extend_xy(  4.000,  0.000 );
		p.extend_xy( 17.000,  0.000 );
		p.extend_xy( 22.000,  5.000 );
		p.extend_xy( 22.000, 13.400 );
		p.extend_xy( 16.200, 19.200 );
		p.extend_xy(  7.000, 19.200 );
		p.extend_xy(  5.000, 21.200 );
		p.extend_xy(  5.000, 27.000 );
	--	p.extend_xy( 22.000, 27.000 );
	    when '4' then
		p.extend_xy(  0.000, 32.000 );
		p.extend_xy(  0.000, 13.000 );
		p.extend_xy( 14.000, 13.000 );
		p.extend_xy( 14.000,  0.000 );
		p.extend_xy( 19.000,  0.000 );
		p.extend_xy( 19.000, 13.000 );
		p.extend_xy( 22.000, 13.000 );
		p.extend_xy( 22.000, 18.000 );
		p.extend_xy( 19.000, 18.000 );
		p.extend_xy( 19.000, 32.000 );
		p.extend_xy( 14.000, 32.000 );
		p.extend_xy( 14.000, 18.000 );
		p.extend_xy(  5.000, 18.000 );
		p.extend_xy(  5.000, 32.000 );
	--	p.extend_xy(  0.000, 32.000 );
	    when '3' then
		p.extend_xy(  0.000, 27.000 );
		p.extend_xy( 17.000, 27.000 );
		p.extend_xy( 17.000, 18.500 );
		p.extend_xy(  0.000, 18.500 );
		p.extend_xy(  0.000, 13.500 );
		p.extend_xy( 17.000, 13.500 );
		p.extend_xy( 17.000,  5.000 );
		p.extend_xy(  0.000,  5.000 );
		p.extend_xy(  0.000,  0.000 );
		p.extend_xy( 22.000,  0.000 );
		p.extend_xy( 22.000, 32.000 );
		p.extend_xy(  0.000, 32.000 );
	--	p.extend_xy(  0.000, 27.000 );
	    when '2' then
		p.extend_xy( 22.000,  5.000 );
		p.extend_xy( 22.000,  0.000 );
		p.extend_xy(  0.000,  0.000 );
		p.extend_xy(  0.000, 12.800 );
		p.extend_xy(  5.000, 17.800 );
		p.extend_xy( 14.200, 17.800 );
		p.extend_xy( 17.000, 20.600 );
		p.extend_xy( 17.000, 24.800 );
		p.extend_xy( 14.800, 27.000 );
		p.extend_xy(  5.000, 27.000 );
		p.extend_xy(  5.000, 24.000 );
		p.extend_xy(  0.000, 24.000 );
		p.extend_xy(  0.000, 28.000 );
		p.extend_xy(  4.000, 32.000 );
		p.extend_xy( 17.000, 32.000 );
		p.extend_xy( 22.000, 27.000 );
		p.extend_xy( 22.000, 18.600 );
		p.extend_xy( 16.200, 12.800 );
		p.extend_xy(  7.000, 12.800 );
		p.extend_xy(  5.000, 10.800 );
		p.extend_xy(  5.000,  5.000 );
	--	p.extend_xy( 22.000,  5.000 );
	    when '1' then
		p.extend_xy(  0.000,  0.000 );
		p.extend_xy(  5.000,  0.000 );
		p.extend_xy(  5.000, 32.000 );
		p.extend_xy(  0.000, 32.000 );
	--	p.extend_xy(  0.000,  0.000 );
	    when 'Z' then
		p.extend_xy(  0.000, 32.000 );
		p.extend_xy( 22.000, 32.000 );
		p.extend_xy( 22.000, 23.500 );
		p.extend_xy(  8.500, 10.000 );
		p.extend_xy(  8.500,  5.000 );
		p.extend_xy( 22.000,  5.000 );
		p.extend_xy( 22.000,  0.000 );
		p.extend_xy(  0.000,  0.000 );
		p.extend_xy(  0.000,  9.000 );
		p.extend_xy( 13.000, 22.000 );
		p.extend_xy( 13.000, 27.000 );
		p.extend_xy(  0.000, 27.000 );
	--	p.extend_xy(  0.000, 32.000 );
	    when 'Y' then
		p.extend_xy( 22.000, 32.000 );
		p.extend_xy( 17.700, 32.000 );
		p.extend_xy( 17.700, 25.300 );
		p.extend_xy( 11.000, 18.600 );
		p.extend_xy(  4.300, 25.300 );
		p.extend_xy(  4.300, 32.000 );
		p.extend_xy(  0.000, 32.000 );
		p.extend_xy(  0.000, 23.600 );
		p.extend_xy(  8.500, 15.100 );
		p.extend_xy(  8.500,  0.000 );
		p.extend_xy( 13.500,  0.000 );
		p.extend_xy( 13.500, 15.000 );
		p.extend_xy( 22.000, 23.500 );
	--	p.extend_xy( 22.000, 32.000 );
	    when 'X' then
		p.extend_xy( 22.000,  0.000 );
		p.extend_xy( 22.000,  6.700 );
		p.extend_xy( 13.500, 15.200 );
		p.extend_xy( 13.500, 16.700 );
		p.extend_xy( 22.000, 25.200 );
		p.extend_xy( 22.000, 32.000 );
		p.extend_xy( 17.700, 32.000 );
		p.extend_xy( 17.700, 27.000 );
		p.extend_xy( 11.000, 20.300 );
		p.extend_xy(  4.300, 27.000 );
		p.extend_xy(  4.300, 32.000 );
		p.extend_xy(  0.000, 32.000 );
		p.extend_xy(  0.000, 25.300 );
		p.extend_xy(  8.500, 16.800 );
		p.extend_xy(  8.500, 15.300 );
		p.extend_xy(  0.000,  6.800 );
		p.extend_xy(  0.000,  0.000 );
		p.extend_xy(  4.300,  0.000 );
		p.extend_xy(  4.300,  5.000 );
		p.extend_xy( 11.000, 11.700 );
		p.extend_xy( 17.700,  5.000 );
		p.extend_xy( 17.700,  0.000 );
	--	p.extend_xy( 22.000,  0.000 );
	    when 'W' then
		p.extend_xy( 20.000, 32.000 );
		p.extend_xy( 20.000, 12.200 );
		p.extend_xy( 15.000, 12.200 );
		p.extend_xy( 15.000, 20.000 );
		p.extend_xy( 10.000, 20.000 );
		p.extend_xy( 10.000, 12.200 );
		p.extend_xy(  5.000, 12.200 );
		p.extend_xy(  5.000, 32.000 );
		p.extend_xy(  0.000, 32.000 );
		p.extend_xy(  0.000,  0.000 );
		p.extend_xy(  5.000,  0.000 );
		p.extend_xy( 11.900,  6.900 );
		p.extend_xy( 13.100,  6.900 );
		p.extend_xy( 20.000,  0.000 );
		p.extend_xy( 25.000,  0.000 );
		p.extend_xy( 25.000, 32.000 );
	--	p.extend_xy( 20.000, 32.000 );
	    when 'V' then
		p.extend_xy(  8.000,  5.300 );
		p.extend_xy(  8.000,  0.000 );
		p.extend_xy( 13.300,  0.000 );
		p.extend_xy( 13.300,  5.300 );
		p.extend_xy( 18.600,  5.300 );
		p.extend_xy( 18.600, 16.000 );
		p.extend_xy( 21.300, 16.000 );
		p.extend_xy( 21.300, 31.900 );
		p.extend_xy( 16.000, 31.900 );
		p.extend_xy( 16.000, 21.300 );
		p.extend_xy( 13.300, 21.300 );
		p.extend_xy( 13.300, 10.600 );
		p.extend_xy(  8.000, 10.600 );
		p.extend_xy(  8.000, 21.300 );
		p.extend_xy(  5.300, 21.300 );
		p.extend_xy(  5.300, 31.900 );
		p.extend_xy(  0.000, 31.900 );
		p.extend_xy(  0.000, 16.000 );
		p.extend_xy(  2.700, 16.000 );
		p.extend_xy(  2.700,  5.300 );
	--	p.extend_xy(  8.000,  5.300 );
	    when 'U' then
		p.extend_xy(  0.000, 32.000 );
		p.extend_xy(  0.000,  0.000 );
		p.extend_xy( 22.000,  0.000 );
		p.extend_xy( 22.000, 32.000 );
		p.extend_xy( 17.000, 32.000 );
		p.extend_xy( 17.000,  5.000 );
		p.extend_xy(  5.000,  5.000 );
		p.extend_xy(  5.000, 32.000 );
	--	p.extend_xy(  0.000, 32.000 );
	    when 'T' then
		p.extend_xy(  0.000, 32.000 );
		p.extend_xy( 22.000, 32.000 );
		p.extend_xy( 22.000, 27.000 );
		p.extend_xy( 13.500, 27.000 );
		p.extend_xy( 13.500,  0.000 );
		p.extend_xy(  8.500,  0.000 );
		p.extend_xy(  8.500, 27.000 );
		p.extend_xy(  0.000, 27.000 );
	--	p.extend_xy(  0.000, 32.000 );
	    when 'S' then
		p.extend_xy(  0.000,  8.500 );
		p.extend_xy(  0.000,  3.500 );
		p.extend_xy(  3.500,  0.000 );
		p.extend_xy( 17.000,  0.000 );
		p.extend_xy( 22.000,  5.000 );
		p.extend_xy( 22.000, 13.500 );
		p.extend_xy( 17.000, 18.500 );
		p.extend_xy(  7.800, 18.500 );
		p.extend_xy(  5.000, 21.300 );
		p.extend_xy(  5.000, 24.800 );
		p.extend_xy(  7.200, 27.000 );
		p.extend_xy( 17.000, 27.000 );
		p.extend_xy( 17.000, 24.000 );
		p.extend_xy( 22.000, 24.000 );
		p.extend_xy( 22.000, 28.000 );
		p.extend_xy( 18.000, 32.000 );
		p.extend_xy(  5.000, 32.000 );
		p.extend_xy(  0.000, 27.000 );
		p.extend_xy(  0.000, 19.300 );
		p.extend_xy(  5.800, 13.500 );
		p.extend_xy( 15.000, 13.500 );
		p.extend_xy( 17.000, 11.500 );
		p.extend_xy( 17.000,  7.000 );
		p.extend_xy( 15.000,  5.000 );
		p.extend_xy(  6.000,  5.000 );
		p.extend_xy(  5.000,  6.000 );
		p.extend_xy(  5.000,  8.500 );
	--	p.extend_xy(  0.000,  8.500 );
	    when 'R' then
		p.extend_xy( 22.000,  7.200 );
		p.extend_xy( 15.200, 14.000 );
		p.extend_xy( 22.000, 20.800 );
		p.extend_xy( 22.000, 25.200 );
		p.extend_xy( 17.000, 30.200 );
		p.extend_xy( 17.000, 23.000 );
		p.extend_xy( 13.000, 19.000 );
		p.extend_xy(  9.000, 19.000 );
		p.extend_xy(  5.000, 23.000 );
		p.extend_xy(  9.000, 27.000 );
		p.extend_xy( 13.000, 27.000 );
		p.extend_xy( 17.000, 23.000 );
		p.extend_xy( 17.000, 30.200 );
		p.extend_xy( 15.200, 32.000 );
		p.extend_xy(  0.000, 32.000 );
		p.extend_xy(  0.000,  0.000 );
		p.extend_xy(  5.000,  0.000 );
		p.extend_xy(  5.000, 14.000 );
		p.extend_xy( 10.200, 14.000 );
		p.extend_xy( 10.200, 11.800 );
		p.extend_xy( 17.000,  5.000 );
		p.extend_xy( 17.000,  0.000 );
		p.extend_xy( 22.000,  0.000 );
	--	p.extend_xy( 22.000,  7.200 );
	    when 'Q' then
		p.extend_xy( 23.900,  3.300 );
		p.extend_xy( 20.200,  7.000 );
		p.extend_xy( 22.000,  8.800 );
		p.extend_xy( 22.000, 23.200 );
		p.extend_xy( 17.000, 28.200 );
		p.extend_xy( 17.000, 11.000 );
		p.extend_xy( 11.000,  5.000 );
		p.extend_xy(  5.000, 11.000 );
		p.extend_xy(  5.000, 21.000 );
		p.extend_xy( 11.000, 27.000 );
		p.extend_xy( 17.000, 21.000 );
		p.extend_xy( 17.000, 28.200 );
		p.extend_xy( 13.200, 32.000 );
		p.extend_xy(  8.800, 32.000 );
		p.extend_xy(  0.000, 23.200 );
		p.extend_xy(  0.000,  8.800 );
		p.extend_xy(  8.800,  0.000 );
		p.extend_xy( 13.200,  0.000 );
		p.extend_xy( 16.900,  3.700 );
		p.extend_xy( 20.600,  0.000 );
	--	p.extend_xy( 23.900,  3.300 );
	    when 'P' then
		p.extend_xy( 22.000, 25.200 );
		p.extend_xy( 17.000, 30.200 );
		p.extend_xy( 17.000, 23.000 );
		p.extend_xy( 13.000, 19.000 );
		p.extend_xy(  9.000, 19.000 );
		p.extend_xy(  5.000, 23.000 );
		p.extend_xy(  9.000, 27.000 );
		p.extend_xy( 13.000, 27.000 );
		p.extend_xy( 17.000, 23.000 );
		p.extend_xy( 17.000, 30.200 );
		p.extend_xy( 15.200, 32.000 );
		p.extend_xy(  0.000, 32.000 );
		p.extend_xy(  0.000,  0.000 );
		p.extend_xy(  5.000,  0.000 );
		p.extend_xy(  5.000, 14.000 );
		p.extend_xy( 15.200, 14.000 );
		p.extend_xy( 22.000, 20.800 );
	--	p.extend_xy( 22.000, 25.200 );
	    when 'O' then
		p.extend_xy( 22.000, 23.200 );
		p.extend_xy( 17.000, 28.200 );
		p.extend_xy( 17.000, 11.000 );
		p.extend_xy( 14.000,  8.000 );
		p.extend_xy(  8.000,  8.000 );
		p.extend_xy(  5.000, 11.000 );
		p.extend_xy(  5.000, 21.000 );
		p.extend_xy(  8.000, 24.000 );
		p.extend_xy( 14.000, 24.000 );
		p.extend_xy( 17.000, 21.000 );
		p.extend_xy( 17.000, 28.200 );
		p.extend_xy( 13.200, 32.000 );
		p.extend_xy(  8.800, 32.000 );
		p.extend_xy(  0.000, 23.200 );
		p.extend_xy(  0.000,  8.800 );
		p.extend_xy(  8.800,  0.000 );
		p.extend_xy( 13.200,  0.000 );
		p.extend_xy( 22.000,  8.800 );
	--	p.extend_xy( 22.000, 23.200 );
	    when 'N' then
		p.extend_xy( 22.000,  0.000 );
		p.extend_xy( 22.000, 32.000 );
		p.extend_xy( 17.000, 32.000 );
		p.extend_xy( 17.000, 19.000 );
		p.extend_xy( 12.000, 19.000 );
		p.extend_xy( 12.000, 22.000 );
		p.extend_xy(  9.000, 22.000 );
		p.extend_xy(  9.000, 26.000 );
		p.extend_xy(  5.000, 26.000 );
		p.extend_xy(  5.000, 32.000 );
		p.extend_xy(  0.000, 32.000 );
		p.extend_xy(  0.000,  0.000 );
		p.extend_xy(  5.000,  0.000 );
		p.extend_xy(  5.000, 13.000 );
		p.extend_xy( 10.000, 13.000 );
		p.extend_xy( 10.000, 10.000 );
		p.extend_xy( 13.000, 10.000 );
		p.extend_xy( 13.000,  6.000 );
		p.extend_xy( 17.000,  6.000 );
		p.extend_xy( 17.000,  0.000 );
	--	p.extend_xy( 22.000,  0.000 );
	    when 'M' then
		p.extend_xy(  5.000,  0.000 );
		p.extend_xy(  5.000, 19.800 );
		p.extend_xy( 10.000, 19.800 );
		p.extend_xy( 10.000,  0.000 );
		p.extend_xy( 15.000,  0.000 );
		p.extend_xy( 15.000, 19.800 );
		p.extend_xy( 20.000, 19.800 );
		p.extend_xy( 20.000,  0.000 );
		p.extend_xy( 25.000,  0.000 );
		p.extend_xy( 25.000, 32.000 );
		p.extend_xy( 20.000, 32.000 );
		p.extend_xy( 13.100, 25.100 );
		p.extend_xy( 11.900, 25.100 );
		p.extend_xy(  5.000, 32.000 );
		p.extend_xy(  0.000, 32.000 );
		p.extend_xy(  0.000,  0.000 );
	--	p.extend_xy(  5.000,  0.000 );
	    when 'L' then
		p.extend_xy( 22.000, 10.000 );
		p.extend_xy( 17.000, 10.000 );
		p.extend_xy( 17.000,  5.000 );
		p.extend_xy(  5.000,  5.000 );
		p.extend_xy(  5.000, 32.000 );
		p.extend_xy(  0.000, 32.000 );
		p.extend_xy(  0.000,  0.000 );
		p.extend_xy( 22.000,  0.000 );
	--	p.extend_xy( 22.000, 10.000 );
	    when 'K' then
		p.extend_xy( 15.000, 13.500 );
		p.extend_xy( 15.000, 18.500 );
		p.extend_xy( 17.000, 18.500 );
		p.extend_xy( 17.000, 27.000 );
		p.extend_xy( 22.000, 27.000 );
		p.extend_xy( 22.000, 32.000 );
		p.extend_xy( 12.000, 32.000 );
		p.extend_xy( 12.000, 25.000 );
		p.extend_xy( 10.000, 25.000 );
		p.extend_xy( 10.000, 18.500 );
		p.extend_xy(  5.000, 18.500 );
		p.extend_xy(  5.000, 32.000 );
		p.extend_xy(  0.000, 32.000 );
		p.extend_xy(  0.000,  0.000 );
		p.extend_xy(  5.000,  0.000 );
		p.extend_xy(  5.000, 13.500 );
		p.extend_xy( 10.000, 13.500 );
		p.extend_xy( 10.000,  7.000 );
		p.extend_xy( 12.000,  7.000 );
		p.extend_xy( 12.000,  0.000 );
		p.extend_xy( 22.000,  0.000 );
		p.extend_xy( 22.000,  5.000 );
		p.extend_xy( 17.000,  5.000 );
		p.extend_xy( 17.000, 13.500 );
	--	p.extend_xy( 15.000, 13.500 );
	    when 'J' then
		p.extend_xy(  5.000, 10.000 );
		p.extend_xy(  0.000, 10.000 );
		p.extend_xy(  0.000,  0.000 );
		p.extend_xy( 17.000,  0.000 );
		p.extend_xy( 17.000, 27.000 );
		p.extend_xy( 22.000, 27.000 );
		p.extend_xy( 22.000, 32.000 );
		p.extend_xy(  5.000, 32.000 );
		p.extend_xy(  5.000, 27.000 );
		p.extend_xy( 12.000, 27.000 );
		p.extend_xy( 12.000,  5.000 );
		p.extend_xy(  5.000,  5.000 );
	--	p.extend_xy(  5.000, 10.000 );
	    when 'I' then
		p.extend_xy( 15.000, 32.000 );
		p.extend_xy(  0.000, 32.000 );
		p.extend_xy(  0.000, 27.000 );
		p.extend_xy(  5.000, 27.000 );
		p.extend_xy(  5.000,  5.000 );
		p.extend_xy(  0.000,  5.000 );
		p.extend_xy(  0.000,  0.000 );
		p.extend_xy( 15.000,  0.000 );
		p.extend_xy( 15.000,  5.000 );
		p.extend_xy( 10.000,  5.000 );
		p.extend_xy( 10.000, 27.000 );
		p.extend_xy( 15.000, 27.000 );
	--	p.extend_xy( 15.000, 32.000 );
	    when 'H' then
		p.extend_xy(  5.000,  0.000 );
		p.extend_xy(  0.000,  0.000 );
		p.extend_xy(  0.000, 32.000 );
		p.extend_xy(  5.000, 32.000 );
		p.extend_xy(  5.000, 18.500 );
		p.extend_xy( 17.000, 18.500 );
		p.extend_xy( 17.000, 32.000 );
		p.extend_xy( 22.000, 32.000 );
		p.extend_xy( 22.000,  0.000 );
		p.extend_xy( 17.000,  0.000 );
		p.extend_xy( 17.000, 13.500 );
		p.extend_xy(  5.000, 13.500 );
	--	p.extend_xy(  5.000,  0.000 );
	    when 'G' then
		p.extend_xy(  0.000,  0.000 );
		p.extend_xy(  0.000, 32.000 );
		p.extend_xy( 22.000, 32.000 );
		p.extend_xy( 22.000, 27.000 );
		p.extend_xy(  5.000, 27.000 );
		p.extend_xy(  5.000,  5.000 );
		p.extend_xy( 17.000,  5.000 );
		p.extend_xy( 17.000, 12.000 );
		p.extend_xy( 12.000, 12.000 );
		p.extend_xy( 12.000, 17.000 );
		p.extend_xy( 22.000, 17.000 );
		p.extend_xy( 22.000,  0.000 );
	--	p.extend_xy(  0.000,  0.000 );
	    when 'F' then
		p.extend_xy(  0.000,  0.000 );
		p.extend_xy(  0.000, 32.000 );
		p.extend_xy( 22.000, 32.000 );
		p.extend_xy( 22.000, 27.000 );
		p.extend_xy(  5.000, 27.000 );
		p.extend_xy(  5.000, 18.900 );
		p.extend_xy( 18.000, 18.900 );
		p.extend_xy( 18.000, 13.900 );
		p.extend_xy(  5.000, 13.900 );
		p.extend_xy(  5.000,  0.000 );
	--	p.extend_xy(  0.000,  0.000 );
	    when 'E' then
		p.extend_xy( 22.000, 24.000 );
		p.extend_xy( 22.000, 32.000 );
		p.extend_xy(  0.000, 32.000 );
		p.extend_xy(  0.000,  0.000 );
		p.extend_xy( 22.000,  0.000 );
		p.extend_xy( 22.000,  8.000 );
		p.extend_xy( 17.000,  8.000 );
		p.extend_xy( 17.000,  5.000 );
		p.extend_xy(  5.000,  5.000 );
		p.extend_xy(  5.000, 13.500 );
		p.extend_xy( 13.600, 13.500 );
		p.extend_xy( 13.600, 18.500 );
		p.extend_xy(  5.000, 18.500 );
		p.extend_xy(  5.000, 27.000 );
		p.extend_xy( 17.000, 27.000 );
		p.extend_xy( 17.000, 24.000 );
	--	p.extend_xy( 22.000, 24.000 );
	    when 'D' then
		p.extend_xy( 22.000, 32.000 );
		p.extend_xy( 17.000, 32.000 );
		p.extend_xy( 17.000,  5.000 );
		p.extend_xy(  8.000,  5.000 );
		p.extend_xy(  8.000, 27.000 );
		p.extend_xy( 17.000, 27.000 );
		p.extend_xy( 17.000, 32.000 );
		p.extend_xy(  0.000, 32.000 );
		p.extend_xy(  0.000, 27.000 );
		p.extend_xy(  3.000, 27.000 );
		p.extend_xy(  3.000,  5.000 );
		p.extend_xy(  0.000,  5.000 );
		p.extend_xy(  0.000,  0.000 );
		p.extend_xy( 22.000,  0.000 );
	--	p.extend_xy( 22.000, 32.000 );
	    when 'C' then
		p.extend_xy( 22.000,  9.000 );
		p.extend_xy( 17.000,  9.000 );
		p.extend_xy( 17.000,  5.000 );
		p.extend_xy(  5.000,  5.000 );
		p.extend_xy(  5.000, 27.000 );
		p.extend_xy( 17.000, 27.000 );
		p.extend_xy( 17.000, 23.000 );
		p.extend_xy( 22.000, 23.000 );
		p.extend_xy( 22.000, 32.000 );
		p.extend_xy(  0.000, 32.000 );
		p.extend_xy(  0.000,  0.000 );
		p.extend_xy( 22.000,  0.000 );
	--	p.extend_xy( 22.000,  9.000 );
	    when 'B' then
		p.extend_xy( 22.000, 32.000 );
		p.extend_xy( 17.000, 32.000 );
		p.extend_xy( 17.000,  5.000 );
		p.extend_xy(  8.000,  5.000 );
		p.extend_xy(  8.000, 13.500 );
		p.extend_xy( 17.000, 13.500 );
		p.extend_xy( 17.000, 18.500 );
		p.extend_xy(  8.000, 18.500 );
		p.extend_xy(  8.000, 27.000 );
		p.extend_xy( 17.000, 27.000 );
		p.extend_xy( 17.000, 32.000 );
		p.extend_xy(  0.000, 32.000 );
		p.extend_xy(  0.000, 27.000 );
		p.extend_xy(  3.000, 27.000 );
		p.extend_xy(  3.000,  5.000 );
		p.extend_xy(  0.000,  5.000 );
		p.extend_xy(  0.000,  0.000 );
		p.extend_xy( 22.000,  0.000 );
	--	p.extend_xy( 22.000, 32.000 );
	    when 'A' then
		p.extend_xy( 17.000,  0.000 );
		p.extend_xy( 17.000, 14.000 );
		p.extend_xy(  8.000, 14.000 );
		p.extend_xy(  8.000, 19.000 );
		p.extend_xy( 14.000, 19.000 );
		p.extend_xy( 14.000, 25.000 );
		p.extend_xy(  8.000, 25.000 );
		p.extend_xy(  8.000, 14.000 );
		p.extend_xy(  5.000, 14.000 );
		p.extend_xy(  5.000,  0.000 );
		p.extend_xy(  0.000,  0.000 );
		p.extend_xy(  0.000, 25.000 );
		p.extend_xy(  7.000, 32.000 );
		p.extend_xy( 15.000, 32.000 );
		p.extend_xy( 22.000, 25.000 );
		p.extend_xy( 22.000,  0.000 );
	--	p.extend_xy( 17.000,  0.000 );
	    -- that is the end of Zach's stuff; rest is new
	    when '!' then
		Result := u2(box( 0, 0, 6, 6 ),
			     box( 0,12, 6,32 ))
	    when '-' then
		Result := box( 0,13,14,19 )
	    when '_' then
		Result := box( 0,-4,22, 2 )
	    when '.' then
		Result := box( 0, 0, 6, 6 )
	    when ',' then
		p.extend_xy(  0,  0 );
		p.extend_xy(  0,  6 );
		p.extend_xy(  6,  6 );
		p.extend_xy(  6, -4 );
		p.extend_xy(  3, -4 );
		p.extend_xy(  3,  0 )
	    when ':' then 
		Result := u2(box( 0, 0, 6, 6 ),
			     box( 0,12, 6,18 ))
	    when '/' then
		p.extend_xy(  0,  0 );
		p.extend_xy(  6,  0 );
		p.extend_xy( 24, 32 );
		p.extend_xy( 18, 32 )
	    when '\' then
		p.extend_xy( 18,  0 );
		p.extend_xy( 24,  0 );
		p.extend_xy(  6, 32 );
		p.extend_xy(  0, 32 )
	    when '(' then
		p.extend_xy(  6,  0 );
		p.extend_xy( 13,  0 );
		p.extend_xy( 13,  5 );
		p.extend_xy(  9,  5 );
		p.extend_xy(  5,  9 );
		p.extend_xy(  5, 23 );
		p.extend_xy(  9, 27 );
		p.extend_xy( 13, 27 );
		p.extend_xy( 13, 32 );
		p.extend_xy(  6, 32 );
		p.extend_xy(  0, 26 );
		p.extend_xy(  0,  6 );
	    when ')' then
		p.extend_xy(  7,  0 );
		p.extend_xy(  0,  0 );
		p.extend_xy(  0,  5 );
		p.extend_xy(  4,  5 );
		p.extend_xy(  8,  9 );
		p.extend_xy(  8, 23 );
		p.extend_xy(  4, 27 );
		p.extend_xy(  0, 27 );
		p.extend_xy(  0, 32 );
		p.extend_xy(  7, 32 );
		p.extend_xy( 13, 26 );
		p.extend_xy( 13,  6 );
	    when '[' then
		p.extend_xy(  0,  0 );
		p.extend_xy( 10,  0 );
		p.extend_xy( 10,  5 );
		p.extend_xy(  5,  5 );
		p.extend_xy(  5, 27 );
		p.extend_xy( 10, 27 );
		p.extend_xy( 10, 32 );
		p.extend_xy(  0, 32 );
	    when ']' then
		p.extend_xy(  0,  0 );
		p.extend_xy( 10,  0 );
		p.extend_xy( 10, 32 );
		p.extend_xy(  0, 32 );
		p.extend_xy(  0, 27 );
		p.extend_xy(  5, 27 );
		p.extend_xy(  5,  5 );
		p.extend_xy(  0,  5 );
	    when 'a' .. 'z' then	-- miniaturize
		Result := move(char_layout(c.as_upper), lc_scale)
	    else	-- biggish solid block
		Result := box( 0, 0, 16, 12 );
	    end;
	end;

feature {NONE} -- scale factor for lower case as miniaturized upper case

	lc_scale: MATRIX is
	once  create Result.make_magnification(0.75)
	end;

end -- ZACHS_FONT
