
indexing
	
	description: "A map for a specific run which shows the payload area"
	author: "David Hollenberg"
	date: "January 24, 2005"

deferred class PAYLOAD_MAP
inherit
	RUN_MAP

feature -- Properties

	payload_box: CONST_RECTANGLE
			-- Rectangle that defines extent of payload in
			-- microns relative to center of field, in
			-- wafer coordinates

feature -- Modification

	set_payload_box (b: like payload_box)
			-- Set `payload_box' to `b'
		require
			box_not_void: b /= Void
		do
			payload_box := b
		ensure
			box_set: payload_box = b
		end

feature {NONE} -- Implementation

	approximate_drawing_width: DOUBLE
			-- Approximate width of drawing, in unspecified units.
			-- Used only to determine initial stroke width
			-- for various line thicknesses, so that stroke
			-- width will be a small fraction of drawing width
		do
			Result := payload_box.size_x.max (payload_box.size_y)
		end


end
